$(function() {

    //if(!pgIsMagic()) return;

    $('body').one('pinegrow-ready', function(e, pinegrow) {


       // pinegrow.addEventHandler('on_dm_register_skills', function(page) {

        new PgDmSkill('text', 'Text', function () {
            this.description = 'Display a line under headings';

            var bm = new PgToggleButtonMaker();

            this.addControl('font',
                {
                    name: 'Font',
                    type: 'select',
                    toggle_buttons: true,
                    show_empty: true,
                    recreate_on_show: true,
                    options: function() {
                        var list = [];
                        pgDmStore.design.getFontTypes().forEach(function(font) {
                            list.push({key: font, name: font, html: bm.makeText(font, {})});
                        })
                        return list;
                    }
                }
            )

            this.addControl('fontsize',
                {
                    name: 'Size',
                    type: 'slider',
                    slider_def_unit: '',
                    slider_min: pgDmStore.design.options.font_sizes.min,
                    slider_max: pgDmStore.design.options.font_sizes.max,
                    options: function() {
                        var r = [];
                        var o = pgDmStore.design.options.font_sizes;
                        var f = 1.2;
                        for(var i = o.min; i <= o.max; i++) {
                            var s = 13.0 * Math.pow(f,i);
                            r.push({
                                key: i,
                                name: i,
                                html: `<span style="font-size:${s}px;">Text Size ${i}</span>`
                            })
                        }
                        return r;
                    }
                }
            )

            this.addControl('line-height',
                {
                    name: 'Line height',
                    type: 'slider',
                    slider_def_unit: ''
                }
            )

            this.addControl('color',
                {
                    name: 'Color',
                    type: 'color'
                }
            )

            this.addControl('spacing',
                {
                    name: 'Spacing',
                    type: 'slider',
                    slider_def_unit: 'px'
                }
            )

            var align_to_icon = {
                left: 'left',
                right: 'right',
                center: 'center',
                justify: 'full'
            }

            this.addControl('align',
                {
                    name: 'Align',
                    type: 'select',
                    toggle_buttons : true,
                    show_empty: true,
                    options : [
                        {
                            key : 'left',
                            name : 'Left',
                            html : bm.makeIcon('align-left', { attributes: { 'title': 'Left' } })
                        },
                        {
                            key : 'center',
                            name : 'Center',
                            html : bm.makeIcon('align-center', { attributes: { 'title': 'Center' } })
                        },
                        {
                            key : 'right',
                            name : 'Right',
                            html : bm.makeIcon('align-right', { attributes: { 'title': 'Right' } })
                        },
                        {
                            key : 'justify',
                            name : 'Justify',
                            html : bm.makeIcon('align-full', { attributes: { 'title': 'Justify' } })
                        }
                    ]
                }
            )

            this.addControl('font-options-container',
                {
                    name: 'Options',
                    type: 'displayhtmlwithlabel',
                    html: ''
                }
            )

            this.addControl('italic',
                {
                    name: 'Italic',
                    type: 'select',
                    toggle_buttons: true,
                    append_to: '.crsa-field-text-font-options-container',
                    without_text: true,
                    show_empty: true,
                    options : [
                        {
                            key : 'italic',
                            name : 'Italic',
                            html : bm.makeIcon('style_italic', { attributes: { 'title': 'Italic' } })
                        }
                    ]
                }
            )

            this.addControl('smallcaps',
                {
                    name: 'Small caps',
                    type: 'select',
                    toggle_buttons: true,
                    append_to: '.crsa-field-text-font-options-container',
                    without_text: true,
                    show_empty: true,
                    options : [
                        {
                            key : 'small-caps',
                            name : 'Small caps',
                            html : bm.makeText('Abc', {
                                styles: {'font-family': 'serif', 'font-size': '15px', 'font-variant': 'small-caps'},
                                attributes: {'title': 'Small caps'}
                            })
                        }
                    ]
                }
            )

            this.addControl('uppercase',
                {
                    name: 'Uppercase',
                    type: 'select',
                    toggle_buttons: true,
                    append_to: '.crsa-field-text-font-options-container',
                    without_text: true,
                    show_empty: true,
                    options: [
                        {
                            key : 'uppercase',
                            name : 'Uppercase',
                            html : bm.makeIcon('Transform-uppercase', { attributes: { 'title': 'Uppercase' } })
                        }
                    ]
                }
            )

            this.addControl('truncate',
                {
                    name: 'Truncate',
                    type: 'select',
                    toggle_buttons: true,
                    append_to: '.crsa-field-text-font-options-container',
                    without_text: true,
                    show_empty: true,
                    options : [
                        {
                            key : 'truncate',
                            name : '...',
                            html : bm.makeText('...', {})
                        }
                    ]
                }
            )

            this.addControl('indent',
                {
                    name: 'Indent',
                    type: 'slider',
                    slider_def_unit: ''
                }
            )

            this.populateDefaultParams = function () {
                this.setParam('width', '50px');
                this.setParam('height', '0.05em');
            }

            this.onGetCSS = function(params, style) {
                var css = '';
                if(params['font']) {
                    css += pgDmStore.design.getFontDeclarationForCSS(params['font']);
                    //css += f.getRuleCSS();
                    /*
                    $.each(f.css, function(prop, val) {
                        css += `${prop}: ${val};\n`;
                    })*/
                }
                if(params['fontsize']) {
                    css += `font-size: ${pgDmStore.design.getFontSizeForCSS(params['fontsize'])};\n`;
                }
                if(params['line-height']) {
                    css += `line-height: ${params['line-height']};\n`;
                }
                if(params['color']) {
                    css += `color: ${pgDmStore.design.getColorForCSS(params['color'])};\n`;
                }
                if(params['spacing']) {
                    css += `letter-spacing: ${params['spacing']};\n`;
                }
                if(params['align']) {
                    css += `text-align: ${params['align']};\n`;
                }
                if(params['italic']) {
                    css += `font-style: italic;\n`;
                }
                if(params['uppercase']) {
                    css += `text-transform: uppercase;\n`;
                } else if(params['smallcaps']) {
                    css += `font-variant: small-caps;\n`;
                }

                if(params['truncate']) {
                    css += `overflow: hidden;\n`;
                    css += `white-space: nowrap;\n`;
                    css += `text-overflow: ellipsis;\n`;
                }
                if(params['indent']) {
                    css += `text-indent: ${pgDmStore.design.getFontSizeForCSS(params['indent'])};\n`;
                }
                return css;
            }

            this.getHTMLForStyleDisplay = function(params) {
                var html = '';

                var attrs = {};
                var text = 'A';
                var has = false;

                var extra_html = '';

                if(params['font']) {
                    text = params['font'];
                    has = true;
                }
                if(params['align']) {
                    extra_html += `<div><i class="icon icon-align-${align_to_icon[params['align']]}"></i></div>`;
                }
                if(has) {
                    var s = '';
                    $.each(attrs, function(prop, val) {
                        s += prop + ':' + val + ';';
                    })
                    html = `<div style="${s}">${text}</div>`;
                }
                return html + extra_html;
            }
        });

        new PgDmSkill('container', 'Container', function () {
            this.description = 'Container settings';

            var _this = this;

            var bm = new PgToggleButtonMaker();

            this.addControl('mode',
                {
                    name: 'Mode',
                    type: 'select',
                    toggle_buttons: true,
                    show_empty: true,
                    options: [
                        { key : 'absolute', name : 'Absolute', html : bm.makeText('Abs', { attributes: { 'title': 'Absolute' } })},
                        { key : 'columns', name : 'Columns', html : bm.makeText('Cols', { attributes: { 'title': 'Columns' } })},
                        { key : 'rows', name : 'Rows', html : bm.makeText('Rows', { attributes: { 'title': 'Rows' } })},
                        { key : 'grid', name : 'Grid', html : bm.makeText('Grid', { attributes: { 'title': 'Grid' } })}
                    ]
                }
            )

            //Flex
            var flex_if = 'container.mode==columns||rows';

            this.addControl('flex.wrap.columns',
                {
                    name: 'Wrap',
                    type : 'select',
                    show_empty: true,
                    toggle_buttons : true,
                    options:[
                        {
                            'key' : 'wrap',
                            'name' : 'Wrap',
                            html: bm.makeIcon('204', { attributes: { 'title': 'Wrap' } })
                        },
                        {
                            'key' : 'nowrap',
                            'name' : 'No wrap',
                            html: bm.makeIcon('203', { attributes: { 'title': 'No wrap' } })
                        },
                        {
                            'key' : 'wrap-reverse',
                            'name' : 'Wrap reverse',
                            html: bm.makeIcon('202', { attributes: { 'title': 'Wrap reverse' } })
                        }
                    ],
                    show_if: 'container.mode==columns'
                }
            )

            this.addControl('flex.wrap.rows',
                {
                    name: 'Wrap',
                    type : 'select',
                    show_empty: true,
                    toggle_buttons : true,
                    options:[
                        {
                            'key' : 'wrap',
                            'name' : 'Wrap',
                            html: bm.makeIcon('204 flip-icon', { attributes: { 'title': 'Wrap' } })
                        },
                        {
                            'key' : 'nowrap',
                            'name' : 'No wrap',
                            html: bm.makeIcon('203 flip-icon', { attributes: { 'title': 'No wrap' } })
                        },
                        {
                            'key' : 'wrap-reverse',
                            'name' : 'Wrap reverse',
                            html: bm.makeIcon('202 flip-icon', { attributes: { 'title': 'Wrap reverse' } })
                        }
                    ],
                    show_if: 'container.mode==rows'
                }
            )

            this.addControl('flex.align.items.columns',
                {
                    name: 'Align items',
                    type : 'select',
                    show_empty: true,
                    toggle_buttons : true,
                    options:[
                        {
                            'key' : 'flex-start',
                            'name' : 'Start',
                            'html': bm.makeIcon('223', { attributes: { 'title': 'Start' } })
                        },
                        {
                            'key' : 'center',
                            'name' : 'Center',
                            'html': bm.makeIcon('221', { attributes: { 'title': 'Center' } })
                        },
                        {
                            'key' : 'flex-end',
                            'name' : 'End',
                            'html': bm.makeIcon('220', { attributes: { 'title': 'End' } })
                        },
                        {
                            'key' : 'stretch',
                            'name' : 'Stretch',
                            'html': bm.makeIcon('214', { attributes: { 'title': 'Stretch' } })
                        },
                        {
                            'key' : 'baseline',
                            'name' : 'Baseline',
                            'html': bm.makeIcon('212', { attributes: { 'title': 'Baseline' } })
                        }
                    ],
                    show_if: 'container.mode==columns'
                }
            )

            this.addControl('flex.align.items.rows',
                {
                    name: 'Align items',
                    type : 'select',
                    show_empty: true,
                    toggle_buttons : true,
                    options:[
                        {
                            'key' : 'flex-start',
                            'name' : 'Start',
                            'html': bm.makeIcon('223 flip-icon', { attributes: { 'title': 'Start' } })
                        },
                        {
                            'key' : 'center',
                            'name' : 'Center',
                            'html': bm.makeIcon('221 flip-icon', { attributes: { 'title': 'Center' } })
                        },
                        {
                            'key' : 'flex-end',
                            'name' : 'End',
                            'html': bm.makeIcon('220 flip-icon', { attributes: { 'title': 'End' } })
                        },
                        {
                            'key' : 'stretch',
                            'name' : 'Stretch',
                            'html': bm.makeIcon('214 flip-icon', { attributes: { 'title': 'Stretch' } })
                        },
                        {
                            'key' : 'baseline',
                            'name' : 'Baseline',
                            'html': bm.makeIcon('212 flip-icon', { attributes: { 'title': 'Baseline' } })
                        }
                    ],
                    show_if: 'container.mode==rows'
                }
            )

            this.addControl('flex.justify.columns',
                {
                    name: 'Justify',
                    type : 'select',
                    show_empty: true,
                    toggle_buttons : true,
                    options:[
                        {
                            'key' : 'flex-start',
                            'name' : 'Start',
                            'html': bm.makeIcon('223', { attributes: { 'title': 'Start' } })
                        },
                        {
                            'key' : 'center',
                            'name' : 'Center',
                            'html': bm.makeIcon('219', { attributes: { 'title': 'Center' } })
                        },
                        {
                            'key' : 'flex-end',
                            'name' : 'End',
                            'html': bm.makeIcon('218', { attributes: { 'title': 'End' } })
                        },
                        {
                            'key' : 'space-between',
                            'name' : 'Space between',
                            'html': bm.makeIcon('206', { attributes: { 'title': 'Space between' } })
                        },
                        {
                            'key' : 'space-around',
                            'name' : 'Space around',
                            'html': bm.makeIcon('205', { attributes: { 'title': 'Space around' } })
                        }
                    ],
                    show_if: 'container.mode==columns'
                }
            )

            this.addControl('flex.justify.rows',
                {
                    name: 'Justify',
                    type : 'select',
                    show_empty: true,
                    toggle_buttons : true,
                    options:[
                        {
                            'key' : 'flex-start',
                            'name' : 'Start',
                            'html': bm.makeIcon('223 flip-icon', { attributes: { 'title': 'Start' } })
                        },
                        {
                            'key' : 'center',
                            'name' : 'Center',
                            'html': bm.makeIcon('219 flip-icon', { attributes: { 'title': 'Center' } })
                        },
                        {
                            'key' : 'flex-end',
                            'name' : 'End',
                            'html': bm.makeIcon('218 flip-icon', { attributes: { 'title': 'End' } })
                        },
                        {
                            'key' : 'space-between',
                            'name' : 'Space between',
                            'html': bm.makeIcon('206 flip-icon', { attributes: { 'title': 'Space between' } })
                        },
                        {
                            'key' : 'space-around',
                            'name' : 'Space around',
                            'html': bm.makeIcon('205 flip-icon', { attributes: { 'title': 'Space around' } })
                        }
                    ],
                    show_if: 'container.mode==rows'
                }
            )

            this.addControl('flex.align.content.columns',
                {
                    name: 'Align content',
                    type : 'select',
                    show_empty: true,
                    toggle_buttons : true,
                    options:[
                        {
                            'key' : 'flex-start',
                            'name' : 'Start',
                            html: bm.makeIcon('217', { attributes: { 'title': 'Start' } })
                        },
                        {
                            'key' : 'center',
                            'name' : 'Center',
                            html: bm.makeIcon('215', { attributes: { 'title': 'Center' } })
                        },
                        {
                            'key' : 'flex-end',
                            'name' : 'End',
                            html: bm.makeIcon('216', { attributes: { 'title': 'End' } })
                        },
                        {
                            'key' : 'stretch',
                            'name' : 'Stretch',
                            html: bm.makeIcon('214', { attributes: { 'title': 'Stretch' } })
                        },
                        {
                            'key' : 'space-between',
                            'name' : 'Space between',
                            html: bm.makeIcon('210', { attributes: { 'title': 'Space between' } })
                        },
                        {
                            'key' : 'space-around',
                            'name' : 'Space around',
                            html: bm.makeIcon('209', { attributes: { 'title': 'Space around' } })
                        }
                    ],
                    show_if: 'container.mode==columns'
                }
            )

            this.addControl('flex.align.content.rows',
                {
                    name: 'Align content',
                    type : 'select',
                    show_empty: true,
                    toggle_buttons : true,
                    options:[
                        {
                            'key' : 'flex-start',
                            'name' : 'Start',
                            html: bm.makeIcon('217 flip-icon', { attributes: { 'title': 'Start' } })
                        },
                        {
                            'key' : 'center',
                            'name' : 'Center',
                            html: bm.makeIcon('215 flip-icon', { attributes: { 'title': 'Center' } })
                        },
                        {
                            'key' : 'flex-end',
                            'name' : 'End',
                            html: bm.makeIcon('216 flip-icon', { attributes: { 'title': 'End' } })
                        },
                        {
                            'key' : 'stretch',
                            'name' : 'Stretch',
                            html: bm.makeIcon('214 flip-icon', { attributes: { 'title': 'Stretch' } })
                        },
                        {
                            'key' : 'space-between',
                            'name' : 'Space between',
                            html: bm.makeIcon('210 flip-icon', { attributes: { 'title': 'Space between' } })
                        },
                        {
                            'key' : 'space-around',
                            'name' : 'Space around',
                            html: bm.makeIcon('209 flip-icon', { attributes: { 'title': 'Space around' } })
                        }
                    ],
                    show_if: 'container.mode==rows'
                }
            )

            //End flex

            //Grid

            var grid_presets = {};

            var PgCSSGridPreset = function(key, name, params, desc) {

                var _this = this;

                this.key = key;
                this.name = name;
                this.description = desc;
                this.params = params;
                this.controls = [];

                this.addControl = function(key, def) {
                    def.subkey = key;
                    this.controls.push(def);
                }

                this.getCSS = function(params) {
                    var css = '';
                    $.each(this.params, function(p, val) {
                        _this.controls.forEach(function(c) {
                            var pv = params[c.subkey] || null;
                            val = val.replace(new RegExp('\\$' + c.grid_param, 'g'), pv);
                        })
                        if(p.startsWith('_subrule')) {
                            css += `${val};\n`;
                        } else {
                            css += `${p}: ${val};\n`;
                        }
                    })
                    return css;
                }
            }

            var gpGallery = new PgCSSGridPreset('gallery', 'Gallery', {
                'grid-template-columns': 'repeat(auto-fit, minmax($min, 1fr))',
                'grid-auto-rows': '$rowsize',
                '_subrule1' : '> img, > a > img { @include m-grid-image; }'
            }, 'Bla bla...');

            gpGallery.addControl('min', {
                name: 'Min. col. size',
                type: 'slider',
                default_value: '200px',
                slider_def_unit: 'px'
            })

            gpGallery.addControl('rowsize', {
                name: 'Row size',
                type: 'slider',
                value: '100px',
                slider_def_unit: 'px'
            })

            grid_presets[gpGallery.key] = gpGallery;

            this.addControl('grid.preset',
                {
                    name: 'Preset',
                    type: 'select',
                    show_empty: true,
                    options: function() {
                        var r = [];
                        $.each(grid_presets, function(key, gp) {
                            r.push({key: gp.key, name: gp.name});
                        })
                        return r;
                    },
                    show_if: 'container.mode==grid'
                }
            )

            $.each(grid_presets, function(key, gp) {
                gp.controls.forEach(function(gpc) {
                    var def = gpc;
                    def.show_if = 'container.grid.preset==' + gp.key;
                    def.grid_param = gpc.subkey;
                    _this.addControl('grid.' + gp.key + '.' + gpc.subkey, def);
                })
            })

            this.addControl('grid.gap', {
                name: 'Gap',
                type: 'slider',
                slider_def_unit: 'px',
                show_if: 'container.mode==grid'
            })

            this.addControl('editor',
                {
                    name: 'Open Grid Editor',
                    type: 'button',
                    func: function(pgel, $button) {
                        pinegrow.showCSSGridControl(pgel, $button);
                    },
                    show_if: 'container.mode==grid'
                }
            )
            // End Grid

            this.onGetCSS = function(params, style) {
                var css = '';
                switch(params['mode']) {
                    case 'absolute':
                        css += `position: relative;\n`;
                        break;
                    case 'columns':
                    case 'rows':
                        var d = params['mode'];
                        css += `display: flex;\n`;
                        css += `flex-direction: ${params['mode'] == 'columns' ? 'row' : 'column' };\n`;
                        if(params['flex.wrap.' + d]) {
                            css += `flex-wrap: ${params['flex.wrap']};\n`;
                        }
                        var ai = 'flex.align.items.' + d;
                        if(params[ai]) {
                            css += `align-items: ${params[ai]};\n`;
                        }
                        if(params['flex.justify.' + d]) {
                            css += `justify-content: ${params['flex.justify.' + d]};\n`;
                        }
                        if(params['flex.align.content.' + d]) {
                            css += `align-items: ${params['flex.align.content.' + d]};\n`;
                        }
                        break;
                    case 'grid':
                        css += `display: grid;\n`;
                        if(params['grid.preset']) {
                            var gp = grid_presets[params['grid.preset']] || null;
                            if(gp) {
                                css += gp.getCSS(params);
                            }
                        }
                        if(params['grid.gap'] !== null) {
                            css += `grid-gap: ${params['grid.gap']};\n`;
                        }
                        break;
                }
                return css;
            }
        });

        new PgDmSkill('heading.line', 'Heading Line', function () {
                this.description = 'Display a line under headings';

                this.addControl('color',
                    {
                        type: 'color',
                        name: 'Color',
                        help: 'Line color.'
                    }
                )

                this.addControl('width',
                    {
                        name: 'Width',
                        type: 'slider',
                        default_value: '40px',
                        slider_min: 0
                    }
                )

                this.addControl('height',
                    {
                        name: 'Height',
                        type: 'slider',
                        slider_min: 0
                    }
                )

                this.addControl('opacity',
                    {
                        name: 'Opacity',
                        type: 'range',
                        range_min: 0,
                        range_max: 1.0,
                        range_step: 0.05
                    }
                )

                this.populateDefaultParams = function () {
                    this.setParam('width', '50px');
                    this.setParam('height', '0.05em');
                }

                this.onGetCSS = function(params, style) {
                    var color = this.getParam('color', params);
                    var width = this.getParam('width', params);
                    var height = this.getParam('height', params);
                    var opacity = this.getParam('opacity', params);

                    var extras = [];
                    if (opacity !== null) {
                        extras.push(`opacity: ${opacity};`)
                    }
                    return `
    &:after {
        border-top: ${height} solid ${color ? (' ' + pgDmStore.design.getColorForCSS(color)) : ''};
        display: block;
        width: ${width};
        height: 1px;
        margin-top: 1rem;
        content: "";
        ${extras.join("\n")}
    }
    `;
                }
            });

        new PgDmSkill('margin.padding', 'Margin &amp; Padding', function () {

            var _this = this;

            this.description = 'Display a line under headings';

            var control_def = {
                type: 'custom',
                name: 'margin_padding',
                action: 'none'
            }

            control_def.control = PgControlMarginPadding({
                setCssValueForShorthandable: function(pgel, f, sf, v, updateAllDirections, base_on_equal) {
                    //console.log(f, sf, v, updateAllDirections, base_on_equal);
                    _this.controlSetValue(pgel, v, null, null, 'input', {
                        subkey: f + '-' + sf
                    });
                    return v;
                },
                getCssValueForShorthandable: function(pgel, values, f, sf, base_on_equal) {
                    //console.log(values, f, sf, base_on_equal);
                    return _this.controlGetValue(pgel, f, values, {
                        subkey: f + '-' + sf
                    });
                },
                on_subfield_changed: function(obj, prop, value, oldValue, fdef, $field) {
                    if(control_def.on_changed) {
                        control_def.on_changed(obj, prop, value, oldValue, fdef, $field);
                    }
                }
            })

            this.addControl('control', control_def);

            var getProps = function(p, params) {
                var t = (p + '-top') in params ? params[p + '-top'] : null;
                var r = (p + '-right') in params ? params[p + '-right'] : null;
                var b = (p + '-bottom') in params ? params[p + '-bottom'] : null;
                var l = (p + '-left') in params ? params[p + '-left'] : null;

                if(t === r && r === b && b === l) {
                    if(t !== null) {
                        return [`${p}: ${t};`]
                    } else {
                        return null;
                    }
                }

                if(t !== null && r !== null && b !== null && l !== null) {
                    if(t === b && r === l) {
                        return [`${p}: ${t} ${l};`]
                    }
                    if(l === r) {
                        return [`${p}: ${t} ${l} ${b};`]
                    }
                    return [`${p}: ${t} ${l} ${b};`]
                }
                var list = [];
                if(t !== null) {
                    list.push(`${p}-top: ${t};`);
                }
                if(r !== null) {
                    list.push(`${p}-right: ${r};`);
                }
                if(b !== null) {
                    list.push(`${p}-bottom: ${b};`);
                }
                if(l !== null) {
                    list.push(`${p}-left: ${l};`);
                }
                return list;
            }

            this.onGetCSS = function(params, style) {
                var list = [];
                var m = getProps('margin', params);
                if(m) list = m;
                var p = getProps('padding', params);
                if(p) list = list.concat(p);

                if(list.length) {
                    return list.join("\n");
                }
                return '';
            }

            //Override
            /*
             this.isSet = function(params) {

             }*/
        });

        new PgDmSkill('grid', 'CSS Grid', function () {
            var _this = this;

            this.description = 'CSS Grid Control';

            this.addControl('editor',
                {
                    name: 'Open Editor',
                    type: 'button',
                    func: function(pgel, $button) {
                        pinegrow.showCSSGridControl(pgel, $button);
                    }
                }
            )

            var props = ['display', 'grid-template-columns', 'grid-template-rows', 'grid-template-areas', 'grid-gap', 'grid-auto-columns', 'grid-auto-rows'];

            props.forEach(function(prop) {
                _this.addControl(prop, { name: prop, type: 'text', show: false})
            })

            this.onGetCSS = function(params, style) {
                var css = '';
                $.each(params, function(key, val) {
                    if(val !== null) {
                        css += `${key}: ${val};\n`;
                    }
                })
                return css;
            }
        });

        new PgDmSkill('grid.item', 'CSS Grid Item', function () {
            var _this = this;

            this.description = 'CSS Grid Item Control';

            ['grid-area'].forEach(function(prop) {
                _this.addControl(prop, { name: prop, type: 'text'})
            })

            this.onGetCSS = function(params, style) {
                var css = '';
                if(params['grid-area']) {
                    css = `grid-area: ${params['grid-area']};\n`;
                }
                return css;
            }
        });

        new PgDmSkill('test', 'Test control', function () {
            this.description = 'Display a line under headings';

            this.addControl('x',
                {
                    name: 'X',
                    type: 'slider',
                    slider_def_unit: 'deg'
                }
            )

            this.addControl('y',
                {
                    name: 'Y',
                    type: 'slider',
                    slider_def_unit: 'deg'
                }
            )

            this.addControl('z',
                {
                    name: 'Z',
                    type: 'slider',
                    slider_def_unit: 'deg'
                }
            )

            this.populateDefaultParams = function () {
                this.setParam('width', '50px');
                this.setParam('height', '0.05em');
            }

            this.onGetCSS = function(params, style) {
                //return `width: ${this.getParam('x', params) || 0};`;
                return `transform: rotateX(${this.getParam('x', params) || 0}) rotateY(${this.getParam('y', params) || 0}) rotateZ(${this.getParam('z', params) || 0});`
            }
        });


     //   }

    })
});
