var PgDmView = function() {
    var $element = $('<div class="pg-dm-view"></div>');
    var view = new PgUIView($element, 'pgdm');

    view.tabIcon = 'icon-color';

    var p = window.pgDmProject = new PgDmProject();

    var unsplash = pgDmStore.unsplash = new PgUnsplashImageProvider();

    pgDmStore.designPanel = this;

    var notice = new PgPanelNotice();
    notice.$element.appendTo($element);

    var show_props = new PgShowProperties($element);

    var force_defs = [{
        sections: pgDmStore.getDesignSections()
    }]

    show_props.onlySections = false;
    show_props.forceDefinitions = force_defs;
    show_props.showName = false;

    show_props.view.get$Element().appendTo($element);

    var show_props_pgel = pgCreate('<div></div>');

    var bm = new PgToggleButtonMaker();

    var $controls = $('<div class="pg-dm-design-controls"></div>').appendTo($element);

    var $c = $controls;

    //view.tabIcon = 'icon-undo';

    this.view = view;
    var _this = this;

    var colors = p.colors;

    var field_defs = [

    ]

    this.dmAddOns = [];

    //pinegrow.dispatchEvent('on_dm_register_addons', null, this.dmAddOns);

    var fields = {}

    var locked = {}

    this.updatePanelDisplay = function() {
        updateFieldValues();
    }

    var updateFieldValues = function() {
        pgKeepScrollPosition(show_props.view.get$Element().find('.pg-grid'), function() {
            show_props.updateShow();
        })
    }


    var $palette = $('<div class="pg-dm-pallete"></div>').appendTo($c);

    var showOrUpdateColorPallete = function($c) {
        $palette.empty();
        var tb = new PgToggleButtons($palette, {input_type: 'none'});
        tb.options = colors.map(function(c) {
            var col =  p.getVarValue(c);
            return {
                key: c,
                name: c,
                html: bm.makeColor(col, '', {
                    'color': col,
                    'attributes': {title: c}
                })
            }
        })
        tb.show();
    }

    var makeDesignFromPhoto = function(src) {
        pgDmStore.makeDesignFromPhoto(src, true);
    }

    var $keeplist = null;

    var getDesignThumbHTML = function(node) {
        var dp = pgDmStore.getActiveDesignProvider();

        var html = '<div class="pg-dm-design-thumb">';

        var htmls = {
            bck: '',
            colors: '',
            fonts: ''
        }

        var bck_node = node.findOne('dmdesignskill[skill="background"]');
        if(bck_node) {
            var bck_color = bck_node.getAttribute('color');
            var bck_image = bck_node.getAttribute('image_sm') || bck_node.getAttribute('image');
            if(bck_color || bck_image) {
                if(bck_image && !crsaIsRemoteUrl(bck_image)) {
                    bck_image = pinegrow.getCurrentProject().getAbsoluteUrl(bck_image);
                }
                htmls.bck += `<div class="pg-dm-design-thumb-bck" style="background-color:${bck_color};background-image:url(${bck_image});"></div>`;
            }
        }

        htmls.colors += `<div class="pg-dm-design-thumb-colors">`;

        node.find('dmcolor').forEach(function(c) {
            htmls.colors += `<div style="background-color: ${c.getAttribute('color')}"></div>`;
        })
        htmls.colors += '</div>';

        var fonts = node.findOne('dmdesignskill[skill="fonts"]');
        if(fonts) {
            var headings_font = null;
            var list = ['headings', 'h1', 'h2', 'h3'];
            list.forEach(function(a) {
                var f = fonts.getAttribute(`${a}_family`);
                if(f && !headings_font) {
                    headings_font = f;
                }
            })
            var text_font = fonts.getAttribute(`text_family`);

            if(headings_font) {
                htmls.fonts += `<h1 style="font-family: ${headings_font}">Heading</h1>`;
            }

            if(text_font) {
                htmls.fonts += `<p style="font-family: ${text_font}">Text</p>`;
            }
        }

        if(dp && dp.onGetDesignThumbHTML) {
            dp.onGetDesignThumbHTML(node, htmls);
        }
        html += (htmls.bck + htmls.colors + htmls.fonts);

        html += '</div>';
        return html;
    }

    this.updateKeepList = function() {
        var i = 0;

        if($keeplist) {
            $keeplist.empty();

            if(pgDmStore.designs_node) {
                pgDmStore.designs_node.find('dmdesign').forEach(function (node) {
                    i++;
                    var $li = $(`<li>${getDesignThumbHTML(node)}</li>`).prependTo($keeplist);
                    $li.data('design-node', node);
                    if(node.hasAttribute('active')) $li.addClass('active');
                })
            }

            var $add = $(`<li class="add-new"><i class="icon icon-plus"></i></li>`).prependTo($keeplist);

            addTooltip($add, 'Add a new design');
            addTooltip($keeplist.find('li:not(.add-new)'), 'Click to activate.<br>Right-click for options.');

            keeplist_grid.updateLayout();
        }
    }

    this.updateActiveDesignInKeepList = function() {
        if(pgDmStore.designs_node && $keeplist) {
            var an = pgDmStore.designs_node.findOne('dmdesign[active]');

            if(an) {
                var $li = $keeplist.find('li.active');
                if($li.length) {
                    $li.html(getDesignThumbHTML(an));
                }
            }
        }
    }

    var keeplist_grid;

    var keeplist_section_data = {

    }

    notice.$element.on('click', '.activate', function(e) {
        e.preventDefault();
        var provider = pgDmStore.getActiveDesignProvider();

        if(provider) {
            pgDmStore.load(true /* force creating db and dmdesigns */);

            provider.firstActivateInProject(function() {
                provider.getEngine(function(engine) {
                    var pages = pinegrow.getAllPages().slice(0);

                    var activate = function() {
                        if(pages.length) {
                            var page = pages.shift();
                            engine.activateOnPage(page, activate);
                        } else {
                            pgDmStore.update();
                        }
                    }

                    activate();
                })
            })


        }
    })

    //var active_design_provider = null;

    var current_design_provider = null;

    this.show = function() {

        view.whenVisible(function() {

            if(!pgDmStore.isDesignEnabled()) {
                var html = '';
                var page = pinegrow.getSelectedPage();

                if(!pinegrow.getCurrentProject()) {
                    if(page && page.isNew()) {
                        html = `<p>Design panel works with projects. Save the page and open it as a project.</p>`;
                    } else {
                        html = `<p>Design panel works with projects. Open a project first.</p>`;
                    }
                } else {
                    if (!page) {
                        html = `<p>Open a page, then activate the design panel.</p>`;
                    } else {
                        var design_providers = [];
                        pinegrow.dispatchEvent('on_dm_detect_design_providers', page, design_providers);
                        if (design_providers.length === 0) {
                            //active_design_provider = null;
                            html = `<p>Sorry, design panel is not supported in this project.</p><p>At the moment, design panel is supported for Bootstrap 4 &amp; 5, Tailwind CSS and Plain HTML projects. Make sure the appropriate framework is enabled on this page.</p>`;
                        } else {

                            //active_design_provider = design_providers[0];
                            if(design_providers.length > 1) {
                                design_providers = design_providers.filter(function(dpkey) {
                                    return dpkey !== 'plainhtml';
                                })
                            }
                            pgDmStore.activateDesignProvider(design_providers[0]);
                            if(pgDmStore.isDesignEnabled()) {
                                //the design already exist in pg db
                                pgDmStore.setActiveDesign( pgDmStore.getActiveDesignNode() );
                                _this.show();
                                return;
                                html = '<p>Loading designs...</p>';
                            } else {
                                html = `<p>Activate the design panel to create a design theme for your project.</p>`;
                                html += `<p><button class="pg-button activate">Activate</button>`;
                            }

                        }
                    }
                }
                pg$Hide(show_props.view.get$Element());
                pg$Hide($controls);
                notice.show(html)

                keeplist_grid && pg$Hide(keeplist_grid.$element);
                return;
            }

            var dp = pgDmStore.getActiveDesignProvider();
            if(dp !== current_design_provider) {
                current_design_provider = dp;
                show_props.forgetFields();
            }

            notice.show();

            keeplist_grid && pg$Show(keeplist_grid.$element, 'flex');

            pg$Show(show_props.view.get$Element(), 'flex');
            pg$Show($controls);

            force_defs[0].sections = pgDmStore.getDesignSections();


            show_props.show(show_props_pgel, null, true);

            $c.empty();

            var $surprise = $('<button class="pg-button">Surprise me!</button>').appendTo($c);

            addTooltip($surprise, 'Create a surprise design. Use locks to prevent colors and other properties from being changed. Right-click for options.');

            var surprise_auto_play = 0;

            var surprise_busy_since = null;
            var auto_surprise = false;
            var auto_surprise_timer = null;

            var doSurprise = function(animate) {
                animate = animate_transitions;

                var stop = function() {
                    var doStop = function() {
                        setTimeout(function () {
                            surprise_busy_since = 0;
                            
                            gsap.killTweensOf(button);

                            gsap.to(button, {
                                backgroundImage: `none`,
                                backgroundColor: 'transparent',
                                duration: 0.25
                            })

                            $surprise.removeClass('surprising');

                            animate && $.fn.crsapages('showOverlays', true, 'white', true);

                            if(surprise_auto_play) {
                                auto_surprise_timer = setTimeout(function() {
                                    doSurprise()
                                }, surprise_auto_play * 1000)
                            }
                        }, animate ? 1000 : 0)
                    }

                    var wait = false;

                    if(animate) {
                        var page = pinegrow.getSelectedPage();
                        if (page) {
                            var bck_url = page.activeView.get$Html().find('body').css('backgroundImage');
                            if (bck_url && bck_url.startsWith('url(')) {
                                bck_url = bck_url.replace(/url\(['"](.*)['"]\)/, '$1');

                                var img = new Image();
                                img.onload = function () {
                                    doStop();
                                }
                                img.onerror = function () {
                                    doStop();
                                }
                                img.src = bck_url;
                                wait = true;
                            }
                        } else {
                            doStop();
                        }
                    }

                    if(!wait) {
                        doStop();
                    }

                }

                var button = $surprise.get(0);

                gsap.killTweensOf(button);

                gsap.set(button, {
                    backgroundImage: `linear-gradient(to right bottom, rgba(255, 255, 255, 0.2) 25%, rgba(0, 0, 0, 0) 25%, rgba(0, 0, 0, 0) 50%, rgba(255, 255, 255, 0.2) 50%, rgba(255, 255, 255, 0.2) 75%, rgba(0, 0, 0, 0) 75%, rgba(0, 0, 0, 0))`,
                    backgroundColor: '#33add6',
                    backgroundSize: '50%',
                    backgroundPosition: '0 0',
                })

                gsap.to(button, {
                    backgroundPosition: '100% 0',
                    duration: 2,
                    repeat: -1,
                    ease: 'none'
                })

                $surprise.addClass('surprising');

                animate && $.fn.crsapages('showOverlays', false, 'white', true);

                var demo = false;

                if(pgIsDev() && demo) {
                    setTimeout(function () {
                        var dnode = pgDmStore.getActiveDesignNode().next();
                        if(dnode) {
                            pgDmStore.setActiveDesign(dnode);
                        }
                        stop();
                    }, 500)
                } else {

                    setTimeout(function () {
                        p.magic(locked, null, function () {
                            stop();
                            updateFieldValues();
                        });
                    }, animate ? 250 : 0)
                }
                /*
                var page = pinegrow.getSelectedPage();
                if(page) {
                    page.getPageViews().forEach(function(pv) {
                        pv.get$Html().removeClass('pg-dm-surprise-ended').addClass('pg-dm-surprise');
                    })
                }

                 */



                /*
                if(e.metaKey || e.ctrlKey) {
                    var q = new PgQuickImageBrowser($(this));

                    q.imageBrowser.onImageClicked = function(url) {
                        makeDesignFromPhoto(url);
                        stop();
                    }
                } else if(e.shiftKey) {

                    unsplash.getRandomPhoto({
                        //featured: true
                        query: pinegrow.getPhotoBrowserSearchTerm() || 'background'
                    }, function(unp) {
                        var src = unsplash.getImageUrl(unp);
                        makeDesignFromPhoto(src);
                        stop();
                    })
                } else {

                }
*/

            }

            $surprise.on('click', function(e) {
                e.preventDefault();

                if(auto_surprise_timer) {
                    clearTimeout(auto_surprise_timer);
                    auto_surprise_timer = null;
                }

                var t = (new Date()).getTime();

                if(surprise_busy_since === 0 || t - surprise_busy_since > 5000) {
                    surprise_busy_since = (new Date()).getTime();

                    if(surprise_auto_play > 0) {
                        if(auto_surprise) {
                            surprise_auto_play = 0;
                            pinegrow.showMode('Auto surprise', false)
                            auto_surprise = false;
                            $surprise.html('Surprise me!');
                        } else {
                            doSurprise(animate_transitions)
                        }
                    } else {
                        doSurprise(animate_transitions)
                    }
                }
            })

            var animate_transitions = pinegrow.getSetting('dm-animate-transitions', '0') === '1';

            $surprise.on('contextmenu', function(e) {
                var setAutoPlay = function() {
                    surprise_auto_play = this.data;
                    if(surprise_auto_play > 0) {
                        pinegrow.showQuickMessage(`Auto surprise ON. Will surprise you every ${this.data} seconds.`)
                        auto_surprise = true;
                        doSurprise(animate_transitions)
                        $surprise.html('Stop auto surprise')
                    } else {
                        pinegrow.showMode('Auto surprise', false);
                    }
                }
                var submenu = [
                    {
                        label: 'Off',
                        data: 0,
                        action: setAutoPlay
                    },
                    {
                        type: 'divider'
                    },
                    {
                        type: 'header',
                        label: 'Surprise me every:'
                    }
                ];

                [5, 10, 20, 30, 60].forEach(function(s) {
                    submenu.push({
                        label: s + 's',
                        data: s,
                        action: setAutoPlay
                    })
                });

                var a = [
                    {
                        label: 'Animate transitions',
                        check: animate_transitions,
                        action: function() {
                            animate_transitions = !animate_transitions;
                            pinegrow.showMode('Animate transitions', animate_transitions);
                            pinegrow.setSetting('dm-animate-transitions', animate_transitions ? "1" : "0")
                        }
                    },
                    {
                        type: 'divider'
                    },
                    {
                        label: 'Autoplay',
                        submenu: submenu
                    }
                ]
                var m = new CrsaContextMenu(a, $surprise);
                m.showForElement($surprise);
                return false;
            })


            var $floating = $('<button class="pg-button pg-button-svg-icon" style="margin-left:4px;"><i class="icon icon-down" style="position: relative;top:2px;"></button>');

            $floating.appendTo($c);

            $floating.on('click', function(e) {
                e.preventDefault();

                var m = new CrsaContextMenu([
                    {
                        label: 'Show floating tools',
                        helptext: 'Show floating paint tools that let you easily "paint" text color, background and other properties.',
                        action: function() {
                            pinegrow.floatingToolsManager.showAtMousePosition();
                        }
                    },
                    {
                        type: 'divider'
                    },
                    {
                        label: 'Deactivate the Design panel...',
                        action: function() {
                            if(!isApp() && pinegrow.getCurrentProject().loaded_revision_info) {
                                pinegrow.showAlert(`<p>The Design panel can not be deactivated on a project revision. Restore the revision first, or deactivate it on the current version of the project.</p>`, 'This is a project revision');
                                return;
                            }
                            pinegrow.showAlert(`<p>Do you want to deactivate the Design panel on this project and delete all its designs?</p><p>This action can not be undone. The project will be reloaded.</p><p>Note, the generated CSS stylesheet will remain in the project.</p>`, 'Deactivate the Design panel', 'Cancel', 'Yes, deactivate &amp; delete designs', null, function() {

                                try {
                                    var pi = pinegrow.getCurrentProjectInfo();
                                    pi.setSetting('active-design-provider', '');
                                    pi.save();

                                    var project = pinegrow.getCurrentProject();
                                    var db = project.db;
                                    db.getProjectNode().find('dmdesigns,dmlocked').forEach(function (pgel) {
                                        pgel.removeWithoutEvents();
                                    })
                                    db.save();

                                    if(isApp()) {
                                        var pdir = project.getDir();
                                        pinegrow.closeCurrentProject(false, function () {
                                            pinegrow.openProject(pdir);
                                        })
                                    } else {
                                        pinegrow.kidsTutorial.reopenProject();
                                    }
                                } catch(err) {
                                    pinegrow.showAlert('Unable to deactivate the Design panel. ' + err);
                                }
                            })
                        },
                        helptext: 'Deactivate the Design panel for this project and delete all its designs.'
                    }
                ], $floating);
                m.showForElement($floating);
                return false;
            })

            addTooltip($floating, 'Design panel options...');

/*

            var $save = $('<button class="pg-button">Save</button>').appendTo($c);

            addTooltip($save, 'Use ' + pgShowKbd('SHIFT') + ' + Click for Save as')

            $save.on('click', function(e) {
                e.preventDefault();
                p.saveCss(e.shiftKey);
            })

 */

            /*
            var $keep = $('<button class="pg-button">New design</button>').appendTo($c);

            addTooltip($save, 'Remember this design.')

            $keep.on('click', function(e) {
                e.preventDefault();

                pgDmStore.addNewDesign();
                _this.updateKeepList();
            })

             */

            var keeplist = [];
            var keeplist_id = 1;

            keeplist_grid && keeplist_grid.destroy();

            keeplist_grid = new PgUISectionGrid();
            $element.append(keeplist_grid.$element.addClass('pg-dm-keep-list-uigrid'));

            var keeplist_section = new PgUISection('Saved designs', null, keeplist_section_data);
            keeplist_grid.addSection(keeplist_section);

            $keeplist = $('<ul class="pg-dm-keep-list" style="color:white;"></ul>').appendTo(keeplist_section.$content);
            $keeplist.on('click', 'li', function(e) {
                e.preventDefault();
                var $li = $(this);
                if($li.hasClass('add-new')) {
                    pgDmStore.addNewDesign();
                    _this.updateKeepList();
                } else {
                    $keeplist.find('li.active').removeClass('active');
                    $li.addClass('active');
                    pgDmStore.setActiveDesign($li.data('design-node'));
                }
            })

            $keeplist.on('contextmenu', 'li', function(e) {
                e.preventDefault();
                var $li = $(this);
                if($li.hasClass('add-new')) {
                } else {
                    var a = [
                        {
                            label: 'Activate',
                            check: $li.hasClass('active'),
                            action: function() {
                                $keeplist.find('li.active').removeClass('active');
                                $li.addClass('active');
                                pgDmStore.setActiveDesign($li.data('design-node'));
                            }
                        },
                        {
                            type: 'divider'
                        },
                        {
                            label: 'Duplicate',
                            action: function() {
                                pgDmStore.addNewDesign($li.data('design-node'));
                                _this.updateKeepList();
                            }
                        },
                        {
                            label: 'Delete',
                            action: function() {
                                pgDmStore.deleteDesign($li.data('design-node'));
                                _this.updateKeepList();
                            }
                        }
                    ]
                    var m = new CrsaContextMenu(a, $li);
                    m.showForElement($li);
                }
                return false;
            })

            _this.updateKeepList();
        })
    }

    //pinegrow.addEventHandler('on_page_selected', onPageSelected);

    var onGetCSS = function(pagenull, part, o) {
        p.onGetCSS(part, o);
    }

    var onColorChanged = function(pagenull, name, col) {
        swatches.setColor(name, col);
    }

    var onImageSelected = function(pagenull, url, picinfo) {
        makeDesignFromPhoto(url)
    }

    var onProjectDBChanged = function(pagenull, col, info) {
        if(info.source) {
            switch (info.source) {
                case 'design_panel':
                    _this.updateActiveDesignInKeepList();
                    break;
                case 'undo':
                    var ad = pgDmStore.getActiveDesignNode();
                    if(ad) {
                        pgDmStore.setActiveDesign(ad);
                        pgDmStore.update();
                    }
                    pgDmStore.designPanel.updatePanelDisplay();
                    pgDmStore.designPanel.updateKeepList();
                    break;
            }
        }
    }

    view.onResize = function() {
        show_props && show_props.updateLayout();
    }

    view.on('crsa-frameworks-changed', function() {
        _this.show();
    })

    var onPageLoaded = function(page) {
        if(!pgDmStore.isDesignEnabled()) {
            _this.show(); //update the panel in case it is not active yet
        }
    }

    pinegrow.addEventHandler('on_dm_get_css', onGetCSS);
    pinegrow.addEventHandler('on_dm_color_changed', onColorChanged);
    pinegrow.addEventHandler('on_projectdb_changed', onProjectDBChanged);
    pinegrow.addEventHandler('on_page_loaded', onPageLoaded);

    //need to listen here as well because the page might already be open when the project is loaded
    pinegrow.addEventHandler('on_project_loaded', onPageLoaded);

    //pinegrow.addEventHandler('on_image_browser_image_selected', onImageSelected);

    view.onDestroy = function() {
        pinegrow.removeEventHandler('on_dm_get_css', onGetCSS);
        pinegrow.removeEventHandler('on_dm_color_changed', onColorChanged);
        pinegrow.removeEventHandler('on_projectdb_changed', onProjectDBChanged);
        pinegrow.removeEventHandler('on_page_loaded', onPageLoaded);
        pinegrow.removeEventHandler('on_project_loaded', onPageLoaded);
        //pinegrow.removeEventHandler('on_image_browser_image_selected', onImageSelected);
    }

    this.show(p);
}

var PgQuicDmView = function() {

    var uv = new PgDmView();

    var win = new PgQuickWindow('Magic', uv, 'quickDesignMagic', 300, 520);

    win.showFor$El($('body'));
    uv.show(p);

    win.onDestroy = function() {
    }


}