var PgDmStyleView = function() {

    //View implementation is responsible for creating DOM and adding it to document.

    var $element = $('<div class="crsa-panel crsa-properties"></div>');

    if(only_sections) $element.addClass('crsa-properties-compact');

    var view = new PgUIView($element, 'dmprop');

    this.view = view;

    this.just_obj = false;

    view.tabIcon = 'icon-Pin15';

    var _this = this;
    var current_pgel = null;

    var show_props = new PgShowProperties($element);

    var only_sections = false;
    var in_quick_win = false;

    var control = new PgDmStylesControl();
    var sizes_control = new PgDmDeviceSizesControl();
    var states_control = new PgDmStatesControl();

    var force_defs = [{
        sections: pgDmStore.getPropSections()
    }]

    show_props.onlySections = only_sections;
    show_props.forceDefinitions = force_defs;

    //show_props.show(null);

    show_props.view.get$Element().appendTo($element);

    if(in_quick_win) {
        show_props.showName = false;
        if(show_general) show_general.showName = false;
    }

    this.show = function(pgel, just_update_control) {
        view.whenVisible(function() {

            if(!just_update_control) {
                if (pgel) {
                    pinegrow.dispatchEvent('on_before_dm_properties_shown', pgel.getPage());
                }
                show_props.show(pgel);
            }

            show_props.view.get$Element().prepend(sizes_control.$element);
            if(pgel) {
                sizes_control.show(pgel);
            }

            show_props.view.get$Element().prepend(states_control.$element);
            if(pgel) {
                states_control.show(pgel);
            }

            show_props.view.get$Element().prepend(control.$element);
            if(pgel) {
                control.show(pgel);
            }


        })
        current_pgel = pgel;

        if(this.quickWin && this.setQuickWinTitle) {
            if(pgel) {
                var page = pgel.getPage();
                var def = page ? page.getMainType(null, pgel) : null;
                this.quickWin.setTitle('Properties for ' + pinegrow.selectedElements.getName({short: true, def: def, num_classes: -1}));
            } else {
                this.quickWin.setTitle('Element properties');
            }
        }
    }

    if(!in_quick_win) {
        this.show(null);
    }

    var onFrameworksChanged = function() {
        if(pinegrow.getSelectedPage()) {
            _this.show(current_pgel);
        }
    }

    var onElementSelected = function(page) {
        var pgel = pinegrow.selectedElements.getLastSelected();
        _this.show(pgel);
    }


    var onCurrentStyleChanged = function(pagenull, style, just_in_time, on_el_selected) {
        if(!on_el_selected) {
            _this.show(current_pgel, just_in_time);
        }
    }

    var onDesignStructureChanged = function(pagenull, what) {
        onElementSelected();
    }

    view.onAddedToLayout = function(c) {
    }

    view.onResize = function() {
        show_props.updateLayout();
    }

    $('body')
        .on('crsa-frameworks-changed', onFrameworksChanged);

    pinegrow.addEventHandler('on_selected_elements_changed', onElementSelected);
    pinegrow.addEventHandler('on_dm_current_style_changed', onCurrentStyleChanged);
    pinegrow.addEventHandler('on_dm_design_structure_changed', onDesignStructureChanged);

    var onClassesChanged = function(page, col, info) {
        //onElementSelected();
    }

    pinegrow.addEventHandler('on_element_classes_changed', onClassesChanged);

    view.onDestroy = function() {
        show_props.show(null);

        pinegrow.removeEventHandler('on_selected_elements_changed', onElementSelected);
        //pinegrow.removeEventHandler('on_prop_field_changed', onPropFieldChanged);
        pinegrow.removeEventHandler('on_element_classes_changed', onClassesChanged);
        pinegrow.removeEventHandler('on_dm_current_style_changed', onCurrentStyleChanged);
        pinegrow.removeEventHandler('on_dm_design_structure_changed', onDesignStructureChanged);

        $('body')
            .off('crsa-frameworks-changed', onFrameworksChanged);
    }
}

var PgQuickDmProperties = function() {

    //test
    var page = pinegrow.getSelectedPage();
    pgDmStore.setSASSEngine(new PgDmSASSEngine(page));
    ///

    var h = Math.floor($('body').height() * 0.75);

    var view = new PgDmStyleView();

    var win = this.win = new PgQuickWindow('Quick Magic Properties', view, 'quickDmProperties', 400, h, false);

    win.noRightEdge();

    win.showFor$El($('body'));

    view.quickWin = win;

    view.show(pinegrow.selectedElements.getLastSelected());

    win.onDestroy = function() {
    }
}

var PgDmStylesControl = function() {
    this.$element = $('<div class="pg-dm-style-control"></div>');

    var $pills = $('<div class="pg-dm-style-control-pills"></div>').appendTo(this.$element);

    var pills = [];

    $pills.on('click', '.pg-dm-style-pill', function(e) {
        e.preventDefault();
        var $pill = $(this);
        var style = pgDmStore.findStyleByName($pill.attr('data-id'));
        pgDmStore.setCurrentStyle(style);
        pgDmStore.rememberSelectedStyleForSelectedElements(style);
    })

    $pills.on('click', '.pg-dm-style-control-new', function(e) {
        e.preventDefault();
        var $b = $(this).find('span');
        if($b.attr('contentEditable') == 'true') return false;

        $b.attr('contentEditable', 'true');
        $b.focus();
        var $ok = $(this).find('button');

        $ok.on('click', function(e) {
            $b.attr('contentEditable', '');
            var name = $b.text();
            if(name) {
                setTimeout(function() {
                    var style = new PgDmStyle(name);
                    pgDmStore.addStyle(style);
                    pgDmStore.assignStyleToSelectedElements(style);
                    pgDmStore.setCurrentStyle(style);
                    pgDmStore.rememberSelectedStyleForSelectedElements(style);
                }, 1)
            }
        })
    })

    this.show = function(pgel) {
        pills = [];
        $pills.empty();

        var cs = pgDmStore.getCurrentStyle();

        var styles = pgDmStore.getStylesForPgel(pgel);
        styles.forEach(function(style) {
            var pill = new PgDmStylePill(style);
            pills.push(pill);
            $pills.append(pill.$element);
            if(style === cs) {
                pill.setActive(true);
            }
        })

        var $add = $('<div class="pg-dm-style-control-new"><span>New name</span><button class="pg-button">Ok</button></div>').appendTo($pills);

    }
}


var PgDmStatesControl = function() {
    this.$element = $('<div class="pg-dm-states-control"></div>');

    var states = [
        {name: 'None', key: 'none'},
        {name: 'Hover', key: 'hover'},
        {name: 'Active', key: 'active'},
        {name: 'Focus', key: 'focus'}
    ];

    var selector = states.map(function(state) {
        return '.pg-state-' + state.key;
    }).join(',');

    var $states = $('<ul></ul>').appendTo(this.$element);

    $states.on('click', 'li', function(e) {
        e.preventDefault();
        var $state = $(this);
        var state = $state.attr('data-state');
        pgDmStore.setCurrentState(state);
        pgDmStore.stateManager.setState(state);
    })



    this.show = function(pgel) {
        $states.empty();

        var cs = pgDmStore.getCurrentState();

        var style = pgDmStore.getCurrentStyle();
        var style_states = style ? style.getStates() : {};

        states.forEach(function(state) {
            var $state = $(`<li data-state="${state.key}">${state.name}</li>`);
            $states.append($state);
            if(cs === state.key) {
                $state.addClass('active');
            }
            if(style_states[state.key]) {
                $state.append('<i class="icon icon-check"></i>');
            }
        })
    }
}


var PgDmDeviceSizesControl = function() {

    var _this = this;

    this.$element = $('<div class="pg-dm-sizes-control"></div>');

    this.show = function() {
        var page = pinegrow.getSelectedPage();
        var all_device_sizes = pgDmStore.design.getDeviceSizes();

        var pv = page.activeView;

        var style = pgDmStore.getCurrentStyle();
        var current_size = pgDmStore.getCurrentSize();
        var current_size_def = pgDmStore.design.getDeviceSizeDef(current_size);

        this.$element.empty();

        var $d = this.$element;

        var tabsToolbar = new PgButtonToolbar();
        $d.prepend(tabsToolbar.$element.addClass('pg-tabs-toolbar'));

        var deviceTabs = new PgToolbarTabButtons(tabsToolbar, 'tabs');

        for(var i = 0; i < all_device_sizes.length; i++) {
            var def = all_device_sizes[i];
            var has = false;

            if(style) {
                var items = style.getItemsForSize(def.size);
                for(var j = 0; j < items.length; j++) {
                    if(items[j].isSet()) {
                        has = true;
                        break;
                    }
                }
            }

            var current = current_size === def.size;//pv.isDeviceSize(def);

            var tab = deviceTabs.addTab(/*`<i class="icon ${def.icon}"></i> ` +*/ def.name_short, null, def, current).setClosable(false);

            if(has) {
                tab.$element.append('<i class="icon icon-check"></i>')
            }
        }

        deviceTabs.onTabSelected = function(tab) {
            var def = tab.data;

            pgDmStore.setCurrentSize(def.size);

            var page = pinegrow.getSelectedPage();
            if(page) {
                //page.view.setActiveViewSizeWithDef(def);
            }
            if(_this.onDeviceSizeChanged) {
                _this.onDeviceSizeChanged(page, def);
            }
        }

        if(!pv.isDeviceSizeVisible(current_size_def)) {
            this.$element.append(`<div class="pg-dm-sizes-control-notice">${current_size_def.name_short} is not visible on the active page view.</div>`);
        }
    }
}

var PgDmColorPicker = function($input, palette, steps) {

    var $element;
    var position;

    var $field = $('<div class="pg-dm-color-picker-field"></div>').insertAfter($input);

    var view = new PgUIView($field);

    var current_value = null;

    var show = function() {
        $element = $('<div class="pg-dm-color-picker"></div>').appendTo($('body'));
        var $grid = $('<div class="pg-dm-color-picker-grid"></div>').appendTo($element);

        var step = 0.25;
        var steps = 2;

        var desc = {
            '-2': 'darker',
            '-1': 'dark',
            '0': 'base',
            '1': 'light',
            '2': 'lighter'
        }

        var html = '';

        var pal = typeof palette == 'function' ? palette() : palette;

        pgDmStore.design.getColors().forEach(function (c) {
            //html += '<div class="pg-dm-color-picker-row">';

            for (var i = -steps; i <= steps; i++) {
                var bck = pgDmStore.design.getColorShade(c.color, i).css();
                //var val = '$' + c.name + '-' + desc[i.toString()];

                var val = `m-color(${c.name}, ${desc[i.toString()]})`;

                val = `${c.name}-${desc[i.toString()]}`;

                if (i < 0) {
                } else if(i > 0) {
                } else {
                    //val = '$' + c.name;
                }
                html += `<div class="pg-dm-color-picker-c" data-base="${c.name}" data-val="${val}" data-color="${bck}" data-shade="${i}"><div style="background-color:${bck};"></div></div>`;
            }

            //html += '</div>';
        })

        html += '<button class="pg-button">No color</button>';

        $grid.html(html);

        $grid.on('click', 'button', function(e) {
            current_value = null;
            setValue('');
            $input.val('');
            close();
            $input.trigger('change');
        })

        $grid.on('click', '.pg-dm-color-picker-c', function(e) {
            var $c = $(this);
            $input.val($c.attr('data-val'));
            close();
            $input.trigger('change');

            current_value = {
                base: $c.attr('data-base'),
                variable: $c.attr('data-val'),
                color: $c.attr('data-color'),
                shade: $c.attr('data-shade')
            }

            setValue($c.attr('data-color'));
        })
    }

    var setValue = function(color) {
        $field.css('background-color', color);
    }

    var close = function() {
        if($element) {
            position.destroy();
            $element.remove();
            $element = null;
        }
    }

    $field.on('click', function(e) {
        if($element) {
            close();
        } else {
            show();
            position = new PgPositionNextTo$El($element, $input, null, 0, 'down');
        }
    })

    var onColorChanged = function(pagenull, name, color) {
        if(current_value) {
            if(current_value.base == name) {
                setValue(pgDmStore.design.getColorShade(chroma(color), current_value.shade).css());
            }
        }
    }

    pinegrow.addEventHandler('on_dm_color_changed', onColorChanged);

    var onMouseDown = function(e) {
        if($element) {
            if($(e.target).closest($element).length) return;
            //debugger;
            close();
        }
    }

    document.addEventListener('mousedown', onMouseDown, true);

    view.onDestroy = function() {
        document.removeEventListener('mousedown', onMouseDown);
        pinegrow.removeEventHandler('on_dm_color_changed', onColorChanged);
    }
}