var PgTutorialVideo = function(vid, srt) {
    var $v = $(`<div class="pg-tutorial-video-overlay black" style="opacity:0;"><div class="pg-tutorial-video-wrapper">
<div class="pg-tutorial-video-iframe-box">
    <iframe src="https://player.vimeo.com/video/${vid}?autoplay=1" frameborder="0" allow="autoplay; fullscreen" allowfullscreen></iframe>
    </div>
    <div class="pg-video-text">
        <div class="pg-video-commands">
            <i class="close-video icon icon-close" title="Close the video."></i>
            <i class="show-text icon icon-align-left" title="Show / hide the video text."></i>
            <i class="make-thumb icon icon-window" title="Pause and make smaller."></i>
        </div>
        <div class="pg-video-text-title"><h2>Video text</h2><p>Click on the text to play or pause that part.</p></div>
        <div class="pg-video-text-content"></div>
        </div>
    </div>
<div class="pg-tutorial-video-thumb-overlay"></div>
</div>`);

    addTooltip($v.find('.pg-video-commands i'), '', {placement: 'left'});

    var $text = $v.find('.pg-video-text-content');

    var text_html = '';

    var srt_items = srt.split("\n\n");
    srt_items.forEach(function(i) {
        if(i.length) {
            var a = i.split("\n");
            var m = a[1].match(/(\d\d):(\d\d):([0-9,]+)/);
            var t = parseInt(m[1]) * 3600 + parseInt(m[2]) * 60 + parseFloat(m[3]);

            a.shift();
            a.shift();

            text_html += `<p data-time="${t}">${a.join(" ")}</p>`;
        }
    })

    $text.html(text_html);

    $v.appendTo($('body'));

    gsap.to($v.get(0), {
        opacity: 1,
        duration: 0.5
    })

    var $wrap = $v.find(".pg-tutorial-video-wrapper");

    if(pinegrow.getSetting('video-player-text', '1') === '1') {
        $wrap.addClass('expanded');
    }

    $v.find('.close-video').on('click', function(e) {
        e.preventDefault();
        destroy();
    })

    $v.find('.show-text').on('click', function(e) {
        e.preventDefault();
        $wrap.toggleClass('expanded');
        pinegrow.setSetting('video-player-text', $wrap.hasClass('expanded') ? '1' : '0');
    })

    $v.find('.make-thumb, .pg-tutorial-video-thumb-overlay').on('click', function(e) {
        e.preventDefault();
        $v.toggleClass('thumb');
    })

    var time_el_map = [];

    $text.find('[data-time]').each(function(i, el) {
        var t = parseFloat(el.getAttribute('data-time'));
        time_el_map.push({
            start: t,
            end: 0,
            el: el
        })

        if(i > 0) {
            time_el_map[i-1].end = t;
        }
    })
    if(time_el_map.length > 0) {
        time_el_map[time_el_map.length-1].end = 9999999;
    }

    $text.on('click', '[data-time]', function(e) {
        e.preventDefault();
        if(this.classList.contains('current')) {
            //toggle playback
            player.getPaused().then(function(paused) {
                paused ? player.play() : player.pause();
                //pinegrow.showQuickMessage(paused ? '')
            });
        } else {
            var t = parseFloat(this.getAttribute('data-time'));
            player.setCurrentTime(t).then(function() {
                player.play();
            });
        }
    })

    var player = new Vimeo.Player($v.find('iframe').get(0));

    var current_d = null;

    var destroy = function(delay) {
        player.off('timeupdate');
        player.off('ended');
        gsap.to($v.get(0), {
            opacity: 0,
            duration: 0.5,
            delay: delay || 0,
            onComplete: function() {
                $v.find('iframe').attr('src', 'about:blank');
                $v.remove();
                player = null;
            }
        })

        time_el_map = null;
        //$v.remove();
    }

    var is_interactive = false;

    player.on('ended', function(data) {
        !is_interactive && destroy(1);
    });

    player.on('timeupdate', function(data) {
        var ct = parseFloat(data.seconds);
        var d = null;
        for(var i = 0; i < time_el_map.length; i++) {
            if(time_el_map[i].start <= ct && time_el_map[i].end > ct) {
                d = time_el_map[i];
                break;
            }
        }
        if(current_d !== d) {
            if(current_d) {
                current_d.el.classList.remove('current');
            }
            if(d) {
                d.el.classList.add('current')
                var $del = $(d.el);
                pgScrollToItemInContainer($del, $del.parent(), false, 750, null, 0);
            }
            current_d = d;
        }
    });
}