//Simple plugin for Webflow projects
$(function() {


    $('body').one('pinegrow-ready', function(e, pinegrow) {
        var f = new PgFramework('pg.webflow', 'Webflow');
        f.type = "pg.webflow";
        f.allow_single_type = true;

        f.description = 'Highlight Webflow in the tree and provide support for WordPress theme builder.';
        f.author = 'Pinegrow';
        f.author_link = 'http://pinegrow.com';

        f.has_actions = false;
        f.show_in_manager = true;

        f.setScriptFileByScriptTagId('plugin-webflow');
        pinegrow.addFramework(f);

        f.detect = function(page) {
            if(page.sourceNode.findOne('meta[content="Webflow"]')) {
                return true;
            } else {
                return false;
            }
        }

        //Highlight tree items

        var elements = {
            '.w-nav': 'Navbar',
            '.w-nav-menu': 'Menu',
            '.w-dyn-list': 'List',
            '.w-dyn-items': 'Items',
            '.w-dyn-item': 'Item',
            '.w-dyn-empty': 'Empty list',
            '.w-richtext': 'Rich content',
            '.w-dropdown': 'Dropdown',
            '.w-dropdown-toggle': 'Dropdown toggle',
            '.w-dropdown-list': 'Dropdown list',
            '.w-form': 'Form',
            '.w-form-done': 'Form done',
            '.w-form-fail': 'Form fail',
            '.w-container': 'Container',
            '.w-row': 'Row',
            '.w-col': 'Column',
            '.w-grid': 'Grid'
        }

        $.each(elements, function(sel, name) {
            var c = new PgComponentType(`wf.${sel.replace('.', '')}`, name, {
                selector : sel,
                namedef_class: 'wf'
            });
            f.addComponentType(c);
        })
    })

});