/**
 * Created by Matjaz on 12/9/13.
 */



var CrsaProjectBrowser = function(opts) {

    var _this = this;
    var activeIndex = 0;



    this.options = null;
    this.crsaProjects = null;
    this.onFileSelected = null;
    this.title = null;
    this.intro = null;
    this.selectedProject = null;

    var def = {
        modal: true
    }

    this.opts = $.extend( {}, def, opts );

    this.setProjects = function(cp) {
        this.crsaProjects = cp;
    }

    var tag_tips = {
        'bootstrap 4': 'Based on Bootstrap 4.',
        'bootstrap 5': 'Based on Bootstrap 5.',
        'tailwind 2': 'Based on Tailwind CSS 2.x.',
        'multi-page': 'Includes multiple templates for different types of sub-pages.',
        'design panel': 'Design can be customized with the Design panel.',
        'pg 6.1': 'Requires Pinegrow 6.1 or higher.',
    }


    this.show = function(justSelected) {
        justSelected = justSelected || false;

        var selectedItem = null;//this.getSelectedItem();
        var selectedLi = null;

        var $div = $('<div/>', {class: 'project-browser'}).html('<div class="container-fluid">' +
                '<div class="row">' +
                    '<div class="col-md-4 col-lg-3 col-xl-2 pills"></div>' +
                    '<div class="col-md-8 col-lg-9 col-xl-10 tabs"></div>' +
                '</div>' +
            '</div>');
        var $pills = $('<ul class="nav nav-pills nav-stacked"></ul>').appendTo($div.find('.pills'));
        var $tabs = $('<div class="tab-content"></div>').appendTo($div.find('.tabs'));

        var first = true;

        var showProject = function (i, project) {
            if (!project.framework) return;
            if (project.show_only_master_pages && $.isEmptyObject(project.framework.master_pages)) return;

            var id = 'project-browser-tab-' + i;
            var $pill = $('<li><a href="#' + id + '" data-toggle="pill">' + project.name + (project.info_badge ? ' <span class="info-badge">' + project.info_badge + '</span>' : '') + '</a></li>').appendTo($pills);

            var $b = $('<div class="tab-pane aafade" id="' + id + '"><div class="project-info"></div><ul></ul></div>').appendTo($tabs);
            var $ul = $b.find('ul');

            var children = [];
            if (project.show_only_master_pages) {
                if(!_this.selectedProject) {
                    _this.selectedProject = project;
                }
                var master_pages = project.framework.master_pages;
                for (var name in master_pages) {
                    var master_page = jQuery.extend(true, {}, master_pages[name]);
                    master_page.tag = "master_page";
                    children.push(master_page);
                }
            }
            else {
                for(var n = 0; n < project.root.children.length; n++) {
                    if(project.root.children[n].order === undefined) {
                        project.root.children[n].order = n;
                    }
                }
                children = project.root.children.sort(function (a, b) {
                    if (a.order > b.order) return 1;
                    if (a.order < b.order) return -1;
                    if (b.order === undefined) return -1;
                    if (a.order === undefined) return 1;
                });
            }

            for(var n = 0; n < children.length; n++) {
                var cf = children[n];
                var $li = null;
                if (cf.tag == "master_page") {
                    var node = cf;
                    var src = node.image + "?v=" + pinegrow.cache_breaker;
                    cf = cf.file;

                    if (cf) {
                        $li = $('<li/>', {'class': 'item'}).html('<h3>' + (cf.desc_name || cf.name) + '</h3>').data('file', cf).data('project', project).appendTo($ul);
                        $('<img/>', {src: cf.image_direct || src }).prependTo($li);
                    }
                    else {
                        $li = $('<li/>', {'class': 'item reload-master-page'}).html('<h3>Master Page</h3><p>Reload & update components first</p>').data('file', '').data('project', project).appendTo($ul);
                    }
                }
                else if(cf.isFile && cf.tag == 'page') {
                    $li = $('<li/>', {'class': 'item'}).html('<h3>' + (cf.desc_name || cf.name) + '</h3>').data('file', cf).data('project', project).appendTo($ul);

                    if(!cf.subpages || true) {
                        if (cf.video && false) {
                            var $video = $(`<video poster="${cf.image_direct}" muted="false" loop="true" src="${cf.video}">`).appendTo($li);

                            (function ($video) {
                                $li.on('mouseenter', function (e) {
                                    var v = $video.get(0);
                                    v && v.play && v.play();
                                })

                                $li.on('mouseleave', function (e) {
                                    var v = $video.get(0);
                                    if (v && v.pause) {
                                        v.currentTime = 0;
                                        v.pause();
                                    }
                                })
                            })($video);
                        } else {
                            if (cf.image_direct || cf.image) {
                                var $img = $('<img/>', {
                                    src: cf.image_direct || cf.image,
                                    class: 'thumb'
                                }).prependTo($li);
                                if (cf.image_class) {
                                    $img.addClass(cf.image_class);
                                }
                            }
                        }
                    }

                    if(cf.description) {
                        var $desc = $('<div class="description">' + cf.description + '</div>').appendTo($li);
                        $li.addClass('with-description');

                        var $buttons = $(`<div class="buttons"></div>`).appendTo($desc);

                        $button = null;
                        if(!cf.subpages) {
                            var $button = $(`<button class="pg-button pg-button-primary">Open</button>`).appendTo($buttons);
                            addTooltip($button, 'Open the template in Pinegrow.');
                        } else {
                            var $button = $(`<button class="pg-button pg-button-primary">Select a page</button>`).appendTo($buttons);
                            addTooltip($button, 'This template has multiple pages. Click to show all and then select one.');
                        }

                        $ul.addClass('grid');
                        if(cf.template_data && cf.template_data.description_tags && cf.template_data.description_tags.length) {
                            var $tags = $(`<ul class="tags"></ul>`);
                            $desc.prepend($tags);
                            cf.template_data.description_tags.forEach(function(tag) {
                                var tip = tag_tips[tag.toLowerCase()] || null;
                                var $li = $(`<li>${tag}</li>`).appendTo($tags);
                                if(tip) {
                                    addTooltip($li, tip);
                                }
                            })
                        }

                        if(crsaIsRemoteUrl(cf.url)) {
                            addTooltip($(`<a href="${cf.url}" class="external preview-link pg-button">Preview</a>`).appendTo($buttons), 'Preview the template in the browser.');
                        }

                        if(cf.template_data && cf.template_data.helplink) {
                            var $help = $(`<a href="${cf.template_data.helplink}" class="external help-link pg-button">Guide</a>`);
                            if($button) {
                                $help.insertAfter($button)
                            } else {
                                $buttons.append($help);
                            }
                            addTooltip($help, 'Learn how to use and customize this template.');
                        }

                        if(cf.subpages ) {
                            $li.addClass('with-subpages');

                            var $subpages = $(`<div class="subpages" style="overflow:hidden;"></div>`).appendTo($desc);
                            if(!cf.subpages_open) {
                                $subpages.css({
                                    //height: 0
                                })
                            } else {
                                $subpages.addClass('open');
                            }
                            cf.subpages.forEach(function(sp) {
                                var $subitem = $(`<div data-url="${sp.url}" data-name="${sp.name}"><img src="${sp.image_direct}"><p>${sp.name}</p></div>`).appendTo($subpages);

                                $subitem.data('file', sp);

                                addTooltip($subitem.find('.preview-icon'), 'Preview the template in the browser.')
                            })
                        } else {

                        }

                    }
                    if(selectedItem == cf) {
                        $li.addClass('selected');
                        selectedLi = $li;
                    }
                }
                if($li) crsaHandleExternalLinks($li);
            }

            var info = '';
            if(project.description) {
                info += project.description;
            }
            if(project.author) {
                info += (info.length ? ' | ' : '') + 'By <a href="' + project.author_link + '">' + project.author + '</a>';
            }
            if(info.length) {
                var $info = $b.find('.project-info');
                $info.html('<p>' + info + '</p>');
                $info.find('a').addClass('external');
                crsaHandleExternalLinks($info);
            }
            if(_this.selectedProject ? _this.selectedProject == project : first) {
                $pill.addClass('active');
                $b.addClass('active in');
            }
            $pill.tab();

            first = false;
        }

        if (justSelected) {
            showProject(0, this.selectedProject)
        }
        else {
            this.crsaProjects.sort(function(a, b) {
                var ai = a.templateBrowserIndex === undefined ? 10 : a.templateBrowserIndex;
                var bi = b.templateBrowserIndex === undefined ? 10 : b.templateBrowserIndex;
                return ai - bi;
            })
            $.each(this.crsaProjects, function(i, project) {
                showProject(i, project);
            })
        }

        if(this.intro) {
            var $i = $(this.intro).prependTo($div);
            if(isApp()) {
                $i.find('a').on('click', function(e) {
                    e.preventDefault();
                    var gui = require('nw.gui');
                    var url = $(e.delegateTarget).attr('href');
                    gui.Shell.openExternal(url);
                });
            }
        }

        var $d = makeModalDialog(this.title ? this.title : "Select item", "Close", null, $div, function() {
            //cancel
        }, function() {
            //ok
        }, function($d) {
            /*
            $d.find('.modal-dialog').css({
                width: '890px',
                'margin-top': 0,
                height: '100vh',
                'margin-bottom': 0
            });
            */
            $d.addClass('project-browser-modal');
        });

        /*
        $d.find('.modal-header').append(`<section class="intro-band">
                <p class="lead">Create a fancy new page.<br></p>
            </section>`);
*/

        $tabs.find('li.item').not('.reload-master-page').not('.with-subpages').on('click', function(e) {
            var $li = $(e.delegateTarget);
            var cf = $li.data('file');

            if(selectedLi) {
                selectedLi.removeClass('selected');
                selectedLi = null;
            }
            if(selectedItem == cf) {
                selectedItem = null;
            } else {
                selectedItem = cf;
                selectedLi = $li;
                $li.addClass('selected');
            }
            if(_this.onFileSelected) _this.onFileSelected(cf, $li.data('project'));
            $d.modal('hide');
            e.preventDefault();
        });

        var showSubpages = function($subpages, cf) {
            $subpages.addClass('open');
            cf.subpages_open = true;
            //var pages = $subpages.get(0).querySelector('div');

            //gsap.set(pages, { autoAlpha: 0 });
            /*
            gsap.to($subpages.get(0), {
                height: 'auto',
                duration: 0
            })
*/
            /*
            gsap.to(pages, {
                autoAlpha: 1,
                duration: 0.3,
                stagger: 0.15
            })*/

            pinegrow.showQuickMessage('Select a page template from the list.');
        }

        $tabs.find('li.item.with-subpages').on('click', function(e) {
            var $li = $(this);
            var cf = $li.data('file');
            var $subpages = $li.find('.subpages', cf);

            if(!$subpages.hasClass('open')) {
                showSubpages($subpages, cf);

            } else {
                $subpages.removeClass('open');
                cf.subpages_open = false;
                /*
                gsap.to($subpages.get(0), {
                    height: 0,
                    duration: 0
                })*/
            }
            e.preventDefault();
        });

        $tabs.find('li.item .subpages > div').on('click', function(e) {
            e.preventDefault();
            e.stopPropagation();

            var $div = $(this);
            var url = $div.attr('data-url');
            var name = $div.attr('data-name');

            var $subpages = $div.closest('.subpages');
            if(!$subpages.hasClass('open')) {
                showSubpages($subpages, $div.closest('.item').data('file'));
                return;
            }

            var sp = $div.data('file');

            var cf = new CrsaFile();
            cf.isFile = true;
            cf.name = name;
            cf.url = url;

            if(sp.remove_components) cf.remove_components = true;
            if(sp.remove_local_links) cf.remove_local_links = true;

            if(_this.onFileSelected) _this.onFileSelected(cf, $div.closest('li.item').data('project'));
            $d.modal('hide');
        })

    }

}


var CrsaMultiChooser = function (list) {
    var _this = this;
    list = list || [];
    var resultList = [];


    this.addItem = function (question, key, choices) {
        list.push({
            question: question,
            key: key,
            choices: choices
        });
    }

    var addToChosenList = function (chosen, key) {
        resultList[key] = chosen;
    }

    var removeFromChosenList = function (chosen, key) {
        if (resultList[key]) {
            delete resultList[key];
            return true;
        }
        return false;
    }

    this.show = function (message, done) {
        if(list.length) {
            message = message || "Please choose files";
            var $b = $("<div><p>" + message + "</p></div>");
            var $table = $('<table class="file-writer table table-striped table-condensed table-hover"><tbody></tbody></table>').appendTo($b);
            var $tbody = $table.find('tbody');

            for (var i = 0; i < list.length; i++) {
                var choices = list[i].choices;
                var $title_tr = $('<tr><td><b>&nbsp;' + list[i].question + '</b></td></tr>').appendTo($tbody);
                for (var j = 0; j < choices.length; j++) {
                    var url = crsaGetSummaryStr(choices[j], 100);
                    var $tr = $('<tr data-index="' + i + '" data-chosen-item="' + j + '"><td><label title="' + choices[j] + '"><input type="radio" value="1" name="file-' + i + '" />&nbsp;' + url + '</label></td></tr>').appendTo($tbody);
                }
            }

            var $modal = makeModalDialog('Choose Files', 'Cancel', 'Ok', $b, function() {
                //cancel
                if(done) done();

            }, function() {
                //save selected
                $checks.each(function(i, ch) {
                    var $ch = $(ch);
                    var $tr = $ch.closest('tr');
                    var listIndex = parseInt($tr.attr('data-index'));
                    var choosenItemIndex = parseInt($tr.attr('data-chosen-item'));
                    var chosen = list[listIndex].choices[choosenItemIndex];
                    if($ch.is(':checked')) {
                        addToChosenList(chosen, list[listIndex].key);
                    }
                    // else {
                    //     removeFromChosenList(chosen, list[listIndex].key);
                    // }
                });

                if(done) done(resultList);
            });

            var $checks = $tbody.find('input[type="radio"]');
        }
        else {
            if (done) done();
        }
    }
}


var pgRecentFiles = function() {

    this.list = [];
    var _this = this;

    var max_show = 100;

    //projects have files, files have urls!!!
    this.add = function(file_or_url, project) {
        if(typeof project == 'undefined') project = false;

        if(file_or_url.startsWith('internal:')) return;

        //if file added and project exists just move the project up front
        if(!project) {
            var file = crsaMakeFileFromUrl(file_or_url);
            for (var i = 0; i < this.list.length; i++) {
                if (this.list[i].project && file.startsWith(this.list[i].file)) {
                    var p = this.list[i];
                    this.list.splice(i, 1);
                    this.list.unshift(p);
                    this.remove(file_or_url, true);
                    update();
                    save();
                    return;
                }
            }
        }

        var existing = this.remove(file_or_url, true);
        this.list.unshift({file: file_or_url, project: project, sticky: existing ? (existing.sticky || false) : false});
        //if project added, remove files
        if(project) {
            var project_url = crsaMakeUrlFromFile(file_or_url);
            for (var i = 1; i < this.list.length; i++) {
                if (!this.list[i].project && this.list[i].file.startsWith(project_url)) {
                    this.list.splice(i, 1);
                }
            }
        }
        if(this.list.length > max_show) {
            //this.list.splice(max_show, this.list.length - max_show);
            var r = [];
            var count_nonsticky = 0;
            for(var i = 0; i < this.list.length; i++) {
                if(!this.list[i].sticky) {
                    if(count_nonsticky < max_show) {
                        r.push(this.list[i]);
                        count_nonsticky++;
                    }
                } else {
                    r.push(this.list[i]);
                }
            }
            this.list = r;
        }
        update();
        save();
    }

    this.isEmpty = function() {
        return this.list.length === 0;
    }

    var findByFile = function(file) {
        for(var i = 0; i < _this.list.length; i++) {
            if(_this.list[i].file == file) return i;
        }
        return -1;
    }

    this.remove = function(file_or_url, skip_update) {
        var item = null;
        var idx = findByFile(file_or_url);
        if(idx < 0) {
            idx = findByFile(crsaMakeFileFromUrl(file_or_url));
        }
        if(idx >= 0) {
            item = this.list[idx];
            this.list.splice(idx, 1);
        }
        if(!skip_update) {
            save();
            update();
        }
        return item;
    }

    this.removeAll = function() {
        var r = [];
        for(var i = 0; i < this.list.length; i++) {
            if(this.list[i].sticky) {
                r.push(this.list[i]);
            }
        }
        this.list = r;
        save();
        update();
    }

    var save = function() {
        var str = JSON.stringify(_this.list);
        localStorage.pgRecentFiles = str;
    }

    var openRecentFileMenu = function (event) {

        var $parent = $(event.target).parent();
        if ($parent.hasClass('menu-file-recent')) {
            var $menu = $('.submenu-file-recent');
            if ($menu.is(':visible')) {
                $menu.css('display', 'none');
            }
            else {
                $menu.css('display', 'block');
                $menu.css('height', 'auto');
                $menu.css({
                    'display': 'block',
                    'height': 'auto',
                    'top': $parent.offset().top - 3,
                    'left': $parent.width()
                });

                var menuTopPos = $menu.offset().top;
                var menuPos = $menu.height() + menuTopPos;
                var winHeight = $(window).height();

                if (menuPos > winHeight) {
                    var overlayHeight = winHeight - menuPos;
                    var newTop = menuTopPos + overlayHeight - 10;
                    if (newTop > 0) {
                        $menu.css({
                            'top': newTop
                        });
                    }
                    else {
                        $menu.css({
                            'top': 0,
                            'height': winHeight
                        });
                    }

                }
            }
        }

        event.preventDefault();
    }

    var onclick = function(event) {
        var $a = $(event.delegateTarget);
        var file = $a.attr('href') || $a.attr('data-file');
        var project = $a.attr('data-project') ? true : false;
        var addtolist = true;

        if(project) {
            if(canOpenProject()) {
                // file is path
                if (!isApp() || crsaIsFileOrDir(file) == "dir") {

                    $('body').trigger('crsa-recent-files-item-clicked');

                    var p = new CrsaProject();

                    if(!isApp()) {
                        p.fromServer(file, function(p) {
                            pinegrow.setCurrentProject(p);
                            //crsaQuickMessage('Project was loaded.');
                            //pinegrow.showTab('project');
                        })
                    } else {
                        p.fromFolder(file, function (p) {
                            pinegrow.setCurrentProject(p);
                            crsaQuickMessage('Project was loaded.');
                            pinegrow.showTab('project');
                        }, true /* show pg files */);
                    }

                    pinegrow.stats.using('app.openproject');
                }
                else {
                    pinegrow.showAlert('Project folder may be deleted or moved to another directory.', 'Project folder not found');
                }
            }
        } else {
            // file is url
            if(file.startsWith('internal:')) {
                var url = file.replace('internal:', '');
                pinegrow.openExample(url);
                addtolist = false;
            } else {
                if (!crsaIsFileUrl(file) || crsaIsFileOrDir(crsaMakeFileFromUrl(file)) == "file") {
                    $('body').trigger('crsa-recent-files-item-clicked');

                    if(!crsaIsFileUrl(file) && (pinegrow.isPRO() || pinegrow.isProTrialActive()) && !pinegrow.getCurrentProject()) {
                        pinegrow.showOpenUrlDialogAndOpenPage(null, file);
                    } else {
                        pinegrow.openOrShowPage(file);
                    }
                    pinegrow.stats.using('app.openfile');
                }
                else {
                    pinegrow.showAlert('File may be deleted or moved to another directory.', 'File not found');
                }
            }
        }

        if(addtolist) {
            setTimeout(function () {
                _this.add(file, project);
            }, 100);
        }
        event.preventDefault();
    }

    var update = function() {
        var $recent_link = $('.menu-file-recent');
        var $menu = $('.submenu-file-recent').html('');
        var $canvas = $('.recent-files');
        var $canvas_ul = $('.recent-files ul').html('');

        var use_thumbnails = pinegrow.thumbnailMaker.enabled && (pinegrow.hasInternalServer() || !pgf.use_server);

        $menu.css('display', 'none');

        closeAllTooltips();

        var names = _this.list.map(function(item) {
            return item.project ? crsaMakeUrlFromFile(item.file) : item.file;
        })

        var short_names = pgGetUniqueShortNamesForUrls(names);

        var has_thumbs = false;

        for(var i = 0; i < _this.list.length; i++) {
            var str = pgUrlToDisplayString(_this.list[i].file);
            if(str.length > 50) {
                str = '&hellip;' + str.substr(str.length - 50);
            }
            if(_this.list[i].project) {
                str += '<small>prj</small>';
            }

            var li_menu = '<li><a href="' + _this.list[i].file + '"' + (_this.list[i].project ? ' data-project="true"' : '') + ' class="menu-file-recent-item">' + str + '</a></li>';

            $menu.append(li_menu);

            continue;

            var short = pgUrlToDisplayString(short_names[i]);
            if(short.length > 50) {
                short = '&hellip;' + short.substr(short.length - 50);
            }
            if(_this.list[i].project) {
                //short += '<small>project</small>';
            }

            var $li = $('<li class="recent-item" data-file="' + _this.list[i].file + '"' + (_this.list[i].project ? ' data-project="true"' : '') + '><div class="thumbnail-placeholder"></div><span>' + short + '</span><i class="kindicon icon icon-project"></i><i class="kindicon icon icon-279"></i><i class="icon icon-close"></i></li>').data('item', _this.list[i]);

            if(_this.list[i].project) {
                $li.addClass('project');
            }

            var remote = _this.list[i].file.startsWith('http');

            var tooltip = _this.list[i].file;

            if(use_thumbnails) {
                var thumb_url = null;

                if(_this.list[i].thumb) {
                    thumb_url = pgMakeFileUrl(crsaGetBaseForUrl(window.location.href) + _this.list[i].thumb);
                } else {
                    thumb_url = pinegrow.thumbnailMaker.getStoredThumbnailUrl(_this.list[i].file);
                }
                if (thumb_url) {
                    $li.addClass('with-thumbnail');
                    var $img = $('<img src="' + thumb_url + '">').appendTo($li);
                    has_thumbs = true;
                }
            }

            if(remote) {
                $('<div class="recent-files-label"><i class="icon icon-279"></i></div>').appendTo($li);
            }
            if(_this.list[i].project) {
                $('<div class="recent-files-label"><i class="icon icon-project"></i></div>').appendTo($li);
            }

            if(_this.list[i].tooltip) {
                tooltip = _this.list[i].tooltip;
            } else if(remote) {
                $li.addClass('remote');
                tooltip = 'URL ' + tooltip;
            } else if(_this.list[i].project) {
                tooltip = 'PROJECT ' + tooltip;
            }




            $canvas_ul.append($li);

            addTooltip($li, tooltip);

            /*
            var $sticky = $li.find('.sticky-control');
            if(_this.list[i].sticky) {
                $sticky.addClass('sticky');
            }
            $sticky.on('click', function(e) {
                e.preventDefault();
                var $i = $(e.delegateTarget);
                var item = $i.closest('li').data('item');
                item.sticky = !(item.sticky || false);
                if(item.sticky) {
                    $i.addClass('sticky');
                } else {
                    $i.removeClass('sticky');
                }
                save();
            })

             */
            //addTooltip($sticky, 'Make the item sticky to keep it on the list.');
        }

        if(has_thumbs) {
            $canvas_ul.addClass('with-thumbnails');
        } else {
            $canvas_ul.removeClass('with-thumbnails');
        }

        $recent_link.find('> a')
            .off('click', openRecentFileMenu)
            .on('click', openRecentFileMenu);

        var closeRecentMenu = function() {
            var $menu = $('.submenu-file-recent');
            $menu.css('display', 'none');
        }

        $('.menu-file').off('hidden.bs.dropdown', closeRecentMenu)
        $('.menu-file').on('hidden.bs.dropdown', closeRecentMenu)

        $menu.find('li > a').on('click', onclick);
        $canvas_ul.find('li.recent-item').on('click', onclick);

        /*
        $canvas_ul.find('li.recent-item .icon-close').on('click', function(e) {
            e.preventDefault();
            var $a = $(this).closest('li');
            var file = $a.attr('data-file');
            _this.remove(file);
        });
*/

        if(false && isApp()) { //moved to start screen
            var li = $('<li class="clear-recent">Options</li>');
            $canvas_ul.append(li);
            li.on('click', function (e) {
                e.preventDefault();

                var actions = [
                    {
                        label: 'Clear the recent list',
                        action: function () {
                            _this.removeAll();
                        }
                    },
                    {
                        label: 'Show thumbnails',
                        check: function () {
                            return pinegrow.thumbnailMaker.enabled;
                        },
                        action: function () {
                            pinegrow.thumbnailMaker.setEnabled(!pinegrow.thumbnailMaker.enabled);
                            pinegrow.showMode('Show and save thumbnails', pinegrow.thumbnailMaker.enabled);
                            update();
                        }
                    }/*,
                     {
                     label: 'Regenerate thumbnails',
                     action: function() {
                     pinegrow.showQuickMessage('Regenerating thumbnails... Can\'t do it for projects. This will take a while.');
                     pinegrow.thumbnailMaker.setEnabled(true);
                     update();

                     for(var i = 0; i < _this.list.length; i++) {
                     if(_this.list[i].project) continue;
                     pinegrow.thumbnailMaker.makeThumbnail(_this.list[i].file, null, true);
                     }
                     }
                     }*/
                ]

                var menu = new CrsaContextMenu(actions);
                menu.showForElement($(this), $('#pg-start-screen-container'));
                return false;
            })
        }

/*
        if(_this.list.length) {
            $canvas.show().removeClass('hide');
        } else {
            $canvas.hide().addClass('hide');
        }

 */

        $('.menu-file-parent').on('hide.bs.dropdown', function () {
            $('.submenu-file-recent').css('display', 'none');
        });

        isApp() && pinegrow.updateStartScreen();
    }

    if(!isApp()) {

    } else {

        if (localStorage.pgRecentFiles) {
            this.list = JSON.parse(localStorage.pgRecentFiles);

            //update from old format
            var r = [];
            for (var i = 0; i < this.list.length; i++) {
                if (typeof this.list[i] == 'string') {
                    r.push({file: this.list[i], project: false});
                } else {
                    r.push(this.list[i]);
                }
            }
            this.list = r;
            //end update
        }

        /*
        if (!localStorage.pgRecentFiles) {
            //add quick starts
            if (pgf.edit_html) {
                this.list.push({
                    file: 'internal:/help/examples/pinepoems/pinepoems.html',
                    thumb: '/help/examples/pinepoems/thumbnail.png',
                    tooltip: 'Sample page - Pine Tree Poems'
                })
                save();
            }
        }

         */
    }

    this.update = update;

    this.populate = function () {
        pinegrow.dispatchEvent('on_recent_list_populate', null, this.list);
        this.update();
    }

    this.populate();

    //update();


    var delayedTasks = new PgDelayedTasks();

    pinegrow.addEventHandler('on_server_created', function () {
        update();
    })

    pinegrow.addEventHandler('on_thumbnail_generated', function () {
        delayedTasks.run('updateOnThumbnailGenerated', update, 1000);
    })

}
