(function( $ ){

    var cssProps = ['width','height','color','color-alpha', 'background-color','background-color-alpha','min-height','max-height','text-align', 'font-size', 'font-style', 'font-weight', 'line-height', 'text-decoration', 'list-style-type', 'list-style-position', 'font-family','text-transform', 'background-attachment', 'background-repeat', 'background-position',  'display', 'position', 'left', 'right', 'top', 'bottom', 'border-left', 'border-right', 'border-top', 'border-bottom','z-index','clear','vertical-align','min-width','max-width','overflow','margin-top','margin-bottom','margin-left','margin-right','padding','padding-left','padding-right','padding-top','padding-bottom','font-variant','border-bottom-left-radius','border-top-left-radius','border-bottom-right-radius','border-top-right-radius','text-indent','column-count','column-gap'];
    
    var nonstandard = ['column-count','column-gap'];
    
    var ca_preset_positions = [
    'capp_strip_left_t',
    'capp_strip_center_t', 
    'capp_strip_right_t',
    'capp_box_lt',
    'capp_box_lb',
    'capp_box_rt',
    'capp_box_rb',
    'capp_box_center_t',
    'capp_box_center_middle',
    'capp_box_center_b',
    'capp_strip_center_b',
    'capp_column_l',
    'capp_column_r',
    'capp_corner_tl', 'capp_corner_bl', 'capp_corner_tr','capp_corner_br'    
    ];
    
    var ca_preset_sizes = ['caps_narrow', 'caps_medium', 'caps_wide','caps_huge'];
    
    var ca_preset_fontsizes = ['cafs_small','cafs_normal','cafs_large','cafs_huge'];
    
    var ca_preset_fonteffects = ['cafe_none', 'cafe_shadow', 'cafe_press', 'cafe_cloud','cafe_3d'];
    
    var ca_preset_fonts = {
        'caf_test' : [],
        'caf_georgia' : [],
        'caf_palatino' : [],
        'caf_museo' : ['Museo300','LeagueGothicRegular'],
        'caf_opensans' : ['OpenSansLight','OpenSansExtraBold'],
        'caf_pacifico' : ['PacificoRegular','ComfortaaRegular'],
        'caf_bebas' : ['BebasNeueRegular'],
        'caf_tondu' : ['TonduBeta','CallunaSansRegular']
    };
    
    var ca_preset_colorschemes = ['cacs_light','cacs_dark'];
    
    var ca_preset_boxstyles = ['cab_trans','cab_simple','cab_banner','cab_round'];
    
    var menu_positions = ['mp_top','mp_top_c','mp_top_r','mp_bottom','mp_bottom_c','mp_bottom_r'];
    
    var menu_styles = ['ms_el_dark','ms_el_light','ms_sim_dark','ms_sim_light'];
    
    var settings = {
      'fonts'         : {},
      'inline' : false
    }; 
        
    var fontLoaded = {};
    
    var main_el;
    var body;
    
    var methods = {
       init : function( options ) {
           return this.each(function(i,e){
                if ( options ) { 
                    $.extend( settings, options );
                }               
                e = $(e);
                main_el = e;
                e.bind('changed.crsa', methods.onChanged);    
                body = $('body');       
           });
       },
       onChanged : function(event, eventdata) {
           var $el = eventdata.e;
           var value = eventdata.value;
           var oldvalue = eventdata.oldvalue;
           var origfid = eventdata.fieldid;
           var fieldid = eventdata.fieldid.replace('Meta_','');
           var crsa = $el.data('crsa');
           var data = crsa.data;

           if(typeof value == 'string') {
            main_el.crsatoolbox('updateValuesUsedIn', $el[0].id, origfid, value);
            value = main_el.crsatoolbox('evaluateValue', value);
           }
           
           console.log('onChanged ' + fieldid + ' = ' + value + ' ' + crsa.type);
           
           switch(crsa.type) {
               case 'MsbValue.numeric':
               case 'MsbValue.expression':
               case 'MsbValue.color':
                   console.log('MsbValue ' + crsa.name + ' changed to ' + value);
                   main_el.crsatoolbox('setValue', crsa.name, value);
                   break;
               default:
                   var sel;
                   var isMsbElement = crsa.type.indexOf('MsbElement') == 0;
                   var prefix = '';
                   if(isMsbElement) {
                       sel = '#' + $el[0].id
                   } else if(crsa.type == 'MsbDef') {
                       sel = data.MsbDef_custom_selector ? data.MsbDef_custom_selector : data.MsbDef_selector;
                       if(sel != 'html' && sel != 'body' && sel.indexOf('#msb') < 0 ) sel = '#msb ' + sel;
                   }
                   
                   if(fieldid.indexOf('port-') == 0) {
                       fieldid = fieldid.replace('port-','');
                       if(isMsbElement) {
                            sel = 'body.portrait ' + sel;
                       } else {
                            sel = 'body.portrait ' + sel;
                       }
                       prefix = 'port-';
                   }
                   
                   if(fieldid.indexOf('inner-') == 0) {
                       fieldid = fieldid.replace('inner-','');
                       if(isMsbElement) {
                        sel = sel + '_inner';
                       } else {
                            sel = sel + ' .crsa-inner';
                       }
                       prefix = prefix + 'inner-';
                   } else if(fieldid.indexOf('h1-') == 0) {
                       fieldid = fieldid.replace('h1-','');
                       if(isMsbElement) {
                        sel = sel + ' h1';
                       } else {
                            sel = sel + ' h1';
                       }
                       prefix = 'h1-';
                   } else if(fieldid.indexOf('p-') == 0) {
                       fieldid = fieldid.replace('p-','');
                       if(isMsbElement) {
                        sel = sel + ' p';
                       } else {
                            sel = sel + ' p';
                       }
                       prefix = 'p-';
                   } else if(fieldid.indexOf('a-') == 0) {
                       fieldid = fieldid.replace('a-','');
                       if(isMsbElement) {
                        sel = sel + ' a';
                       } else {
                            sel = sel + ' a';
                       }
                       prefix = 'a-';
                   } else if(fieldid.indexOf('menu-item-') == 0) {
                       fieldid = fieldid.replace('menu-item-','');
                       if(isMsbElement) {
                        sel = sel + ' li';
                       } else {
                            sel = sel + ' li';
                       }
                       prefix = 'menu-item-';
                   } else if(fieldid.indexOf('menu-sel-') == 0) {
                       fieldid = fieldid.replace('menu-sel-','');
                       if(isMsbElement) {
                        sel = sel + ' li.selected';
                       } else {
                            sel = sel + ' li.selected';
                       }
                       prefix = 'menu-sel-';
                   } else if(fieldid.indexOf('menu-sel-a-') == 0) {
                       fieldid = fieldid.replace('menu-sel-a-','');
                       if(isMsbElement) {
                        sel = sel + ' li.selected a';
                       } else {
                            sel = sel + ' li.selected a';
                       }
                       prefix = 'menu-sel-a-';
                   } 
                   
                   if(cssProps.indexOf(fieldid) >= 0) {
                       methods.cssRuleChanged(sel, fieldid, value, data, prefix);
                   } else if(fieldid == 'align') {
                       methods.align(sel, fieldid, value, data, $el);
                   } else if(fieldid.match(/^shadow/gi)) {
                       methods.shadowChanged(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid.match(/^text_shadow/gi)) {
                       methods.textShadowChanged(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'background-images') {
                       methods.updateBckImages(sel, fieldid, value, data);
                   } else if(fieldid == 'background-strategy') {
                       methods.updateBckStrategy(sel, fieldid, value, data, $el);
                   } else if(fieldid.indexOf('hide_in_') == 0) {
                       methods.hideIn(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'MsbElement_name') {
                       crsa.name = value;
                       $el.data('crsa', crsa);
                   } else if(fieldid == 'background-position-v' || fieldid == 'background-position-h' || fieldid == 'show_whole_bck') {
                       methods.bckPosition(sel, fieldid, value, data, $el);
                   } else if(fieldid == 'align-h' || fieldid == 'align-v' || fieldid == 'distance-v' || fieldid == 'distance-h') {
                       methods.alignAbs(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'font') {
                       methods.setFont(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'scale_fonts') {
                       methods.setScaleFonts(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'ca_preset_position') {
                       methods.setCAPresetPosition(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'ca_preset_size') {
                       methods.setCAPresetSize(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'ca_preset_fontsize') {
                       methods.setCAPresetFontSize(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'ca_preset_fonteffect') {
                       methods.setCAPresetFontEffect(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'ca_preset_fonts') {
                       methods.setCAPresetFonts(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'ca_preset_color_scheme') {
                       methods.setCAPresetColorScheme(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'ca_preset_box_style') {
                       methods.setCAPresetBoxStyle(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'menu_position') {
                       methods.setMenuPosition(sel, fieldid, value, data, $el, prefix);
                   } else if(fieldid == 'menu_style') {
                       methods.setMenuStyle(sel, fieldid, value, data, $el, prefix);
                   }                    
                   break;
           }
       },
       cssRuleChanged : function(eid, prop, value, data, prefix) {
           if(typeof prefix == 'undefined') prefix = '';
           if(prop.match(/color/gi)) {
               if(prop.match(/\-alpha/) != null) {
                    prop = prop.replace('-alpha', '');
                    value = getValue(prefix + prop, data, 'transparent');
                    value = main_el.crsatoolbox('evaluateValue', value);
               }
               var caf = prop + '-alpha';
               value = value != "" ? value : 'transparent';
               var str = value + "";
               if(str.match(/\#/) == null && str.match(/rgb/) == null && value != "" && value != 'transparent') {
                   //so it must be 10 base int
                   value = parseInt(str, 10);
                   if(value > 0xFFFFFF) value = 0xFFFFFF;
                   if(value < 0) value = 0;
                   str = value.toString(16);
                   while(str.length < 6) str = "0" + str;
                   value = '#' + str;
               }
               if(value != "" && value != 'transparent') {
                var ca = getValue(prefix + caf, data, '100');
                value = hex2rgb(value, parseFloat(ca) / 100.0);
               }
           }
           /*
           if(prop.indexOf('shadow_') == 0) {
               var sx = 'shadow_x' in data ? data['shadow_x'] : '0px';
               var sy = 'shadow_y' in data ? data['shadow_y'] : '0px';
               var ssize = 'shadow_size' in data ? data['shadow_size'] : '0px';
               var sblur = 'shadow_blur' in data ? data['shadow_blur'] : '0px';
               var scolor = getColorValue('shadow_color', data);
               prop = 'box-shadow';
               value = sx + ' ' + sy + ' ' + ssize + ' ' + sblur + ' ' + scolor;
           }
           */
           $rule = $.rule(eid);
           if($rule.length == 0) {
               $rule = $.rule(eid + '{}').appendTo('style');
           }
           $rule.css(prop,value);
           if(nonstandard.indexOf(prop) >= 0) {
               $rule.css('-moz-' + prop,value);
            //   $rule.css('-webkit-' + prop,value);
           }
//           $.rule(eid,'style').css(prop,value);
           console.log('css update ' + prop + ' = ' + value);
       },
       hasLayers : function(data) {
           return getValue('stretch_bck', data, '0') != '0';// || getValue('layers', data, '0') != '0';
       },
       setScaleFonts : function(sel, fieldid, value, data, $el) {
           if(value && value != '0') {
               $el.addClass('crsa-scale-fonts');
           } else {
               $el.removeClass('crsa-scale-fonts');
           }
           methods.scaleFonts($el);
       },
       scaleFonts : function($el) {
           var s = [0, 1100, 1401, 1801];
           var w = $el.innerWidth();
           var on = $el.hasClass('crsa-scale-fonts');
           for(var n = s.length - 1; n >= 0; n--) {
               var cls = 'crsa-scale-fonts-' + (n+1);
               if(w >= s[n] && on) {
                   $el.addClass(cls);
               } else {
                   $el.removeClass(cls);
               }
           }
       },
       bckPosition : function(sel, fieldid, value, data, $el) {
           var layers = methods.hasLayers(data);
           if(!layers) {
               getRule(sel).css('background-position', getValue('background-position-h', data, 'left') + ' ' + getValue('background-position-v', data, 'top'));
           } else {
               var opt = {};
               opt.hpos = getValue('background-position-h', data, 'left');
               opt.vpos = getValue('background-position-v', data, 'top');
               opt.show_whole = getValue('show_whole_bck', data, 0);
               main_el.crsaruntime('fsStretchImages', $el, opt);               
           }
       },
       updateBckStrategy : function(sel, fieldid, value, data, $el) {
           var stretch = 0;
           var fit = 0;
           switch(value) {
               case 'normal':
                    break;
               case 'fill':
                    stretch = 1;
                    break;
               case 'fit':
                    stretch = 1;
                    fit = 1;
                    break;
           }
           main_el.crsaui('onValueChangedDirect', {name: 'Meta_show_whole_bck', id: null, el : $el}, fit);
           main_el.crsaui('onValueChangedDirect', {name: 'Meta_stretch_bck', id: null, el: $el, server_side: !settings.inline}, stretch);
       },
       setFont : function(sel, fieldid, value, data, $el, prefix, setrule) {
           if(typeof setrule == 'undefined' || setrule == null) setrule = true;
           var fd = value in settings.fonts ? settings.fonts[value] : {std:1, family:value};
           if(fd.std && fd.std == 1) {
               var ff = fd.family;
           } else {
               if(!(value in fontLoaded)) {
                  $("head").append($("<link rel='stylesheet' href='/css/fonts/" + value + "/stylesheet.css' type='text/css' media='screen' />"));
                  fontLoaded[value] = true;    
               }
               var ff = fd.family;        
           }
           if(setrule) {
            getRule(sel).css('font-family',ff);
           }
       },
       align : function(sel, fieldid, value, data, $el) {
           var prop = 'float';
           switch(value) {
               case 'center':
                getRule(sel).css('margin-left','auto').css('margin-right','auto').css('float','none');
                break;
               default:
                getRule(sel).css('margin-left','auto').css('margin-right','auto').css('float',value);
                break;
           }
       },
       hideIn : function(sel, fieldid, value, data, $el, prefix) {
           var where = fieldid.replace('hide_in_','');
           var c = fieldid;
           if(value == '1') {
               $el.addClass(c);
           } else {
               $el.removeClass(c);
           }
       },
       alignAbs : function(sel, fieldid, value, data, $el, prefix) {
           var dh = getValue(prefix + 'distance-h', data, '0px', false);
           var dv = getValue(prefix + 'distance-v', data, '0px', false);
           
           var opref = prefix;
           var subv = false;//prefix.indexOf('port-') == 0;    FOR PORTRAIT VARIANT, disabled
           if(subv) {
                var opref = prefix.replace('port-','');
           }
                       
           if(opref == 'inner-') {
               $ie = $el.find('> div.crsa-content-wrap > .crsa-inner');
           } else {
               $ie = $el;
           }
           $ie.css('top','').css('bottom','').css('left','').css('right','');
           getRule(sel).css('top','auto').css('bottom','auto').css('left','auto').css('right','auto');
           
           var h = 'left';
           if(subv) h = getValue(opref + 'align-h', data, h, false);
           var h = getValue(prefix + 'align-h', data, h, false);
           
           var w = 'auto';
           if(subv) w = getValue(opref + 'width', data, w, false);
           var w = getValue(prefix + 'width', data, w, false);
           
           if(h == '') h = 'left';
           if(h == 'center') {
               getRule(sel).css('width',w);
               main_el.crsaruntime('centerH', $ie, sel);
           } else {
               if(h == 'left') {
                  getRule(sel).css('position','absolute').css('margin-left','auto').css('margin-right','auto').css('left',dh).css('right','auto').css('width',w);
               } else if(h == 'right') {
                  getRule(sel).css('position','absolute').css('margin-left','auto').css('margin-right','auto').css('right',dh).css('left','auto').css('width',w);
               } else if(h == 'abs') {
                   
                  var right = '0px'; 
                  if(subv) right = getValue(opref + 'right', data, right, false);
                  var right = getValue(prefix + 'right', data, right, false);
                  
                  var dh = '0px';
                  if(subv) dh = getValue(opref + 'left', data, dh, false);
                  var dh = getValue(prefix + 'left', data, dh, false);
                  
                  getRule(sel).css('position','absolute').css('margin-left','auto').css('margin-right','auto').css('left',dh).css('right',right).css('width','auto');
                }
           }
           var v = 'top';
           if(subv) v = getValue(opref + 'align-v', data, v, false);
           var v = getValue(prefix + 'align-v', data, v, false);
           
           if(v == '') v = 'top';
           if(v == 'center') {
               main_el.crsaruntime('centerV', $ie, sel);
           } else {
               if(v == 'top') {
                   getRule(sel).css('top',dv).css('bottom','auto');
               } else if(v == 'bottom') {
                   getRule(sel).css('top','auto').css('bottom',dv);
               } else if( v == 'abs') {
                   var bottom = '0px';
                   if(subv) bottom = getValue(opref + 'bottom', data, bottom, false);
                   var bottom = getValue(prefix + 'bottom', data, bottom, false);
                   
                   var dv = '0px';
                   if(subv) dv = getValue(opref + 'left', data, dv, false);
                   var dv = getValue(prefix + 'left', data, dv, false);
                   
                   getRule(sel).css('top',dv).css('bottom',bottom).css('height','auto');
               }
           }
       },
       shadowChanged : function(sel, fieldid, value, data, $el, prefix) {
           $el.removeClass('crsa-active-element');
           //var x = 'Meta_shadow_x' in data && data['Meta_shadow_x'] != '' ? data['Meta_shadow_x'] : '0px';
           var x = getValue(prefix + 'shadow_x', data, '0px');
           //var y = 'Meta_shadow_y' in data && data['Meta_shadow_y'] != ''  ? data['Meta_shadow_y'] : '0px';
           var y = getValue(prefix + 'shadow_y', data, '0px');
           //var blur = 'Meta_shadow_blur' in data  && data['Meta_shadow_blur'] != '' ? data['Meta_shadow_blur'] : '0px';
           var blur = getValue(prefix + 'shadow_blur', data, '0px');
           //var size = 'Meta_shadow_size' in data  && data['Meta_shadow_size'] != '' ? data['Meta_shadow_size'] : '0px';
           var size = getValue(prefix + 'shadow_size', data, '0px');
           //var c = 'Meta_shadow_color' in data  && data['Meta_shadow_color'] != '' ? data['Meta_shadow_color'] : 'transparent';
           var c = getValue(prefix + 'shadow_color', data, 'transparent');
           //var ca = 'Meta_shadow_color-alpha' in data  && data['Meta_shadow_color-alpha'] != ''  ? data['Meta_shadow_color-alpha'] : '100';
           var ca = getValue(prefix + 'shadow_color-alpha', data, '100');
           if(c != 'transparent' && c != '')  {
               c = hex2rgb(c, parseFloat(ca) / 100.0);
               var s = x + ' ' + y + ' ' + blur + ' ' + size + ' ' + c;
               getRule(sel).css('box-shadow',s).css('-moz-box-shadow',s).css('-webkit-box-shadow',s);
           }
           //methods.updateBckImages(sel, fieldid, value, data);
           console.log('Shadow ' + s);
       },
       textShadowChanged : function(sel, fieldid, value, data, $el, prefix) {
           var x = getValue(prefix + 'text_shadow_x', data, '0px'); 
           var y = getValue(prefix + 'text_shadow_y', data, '0px');
           var size = getValue(prefix + 'text_shadow_size', data, '0px');
           var c = getValue(prefix + 'text_shadow_color', data, 'transparent');
           var ca = getValue(prefix + 'text_shadow_color-alpha', data, '100');
           if(c != 'transparent' && c != '')  {
               c = hex2rgb(c, parseFloat(ca) / 100.0);
               var s = x + ' ' + y + ' ' + size + ' ' + c;
               getRule(sel).css('text-shadow',s).css('-moz-text-shadow',s).css('-webkit-text-shadow',s);
           }
           //methods.updateBckImages(sel, fieldid, value, data);
           console.log('Text Shadow ' + s);
       },
       updateBckImages : function(sel, fieldid, value, data) {
           var images = data['Meta_background-images'];
           var layers = methods.hasLayers(data);
           
           if(!layers) {
               if(images.length > 0) {
                   $.each(images, function(i, img) {
                       $.rule(sel).css('background-image','url(' + img.image + ')');
                       return false;
                   });
               }
               else 
               {
                   $.rule(sel).css('background-image','none');
               }
           } else {
           }
       },
       setCAPresetPosition : function(sel, fieldid, value, data, $el, prefix) {
           $.each(ca_preset_positions, function(i,e) {
               if($el.hasClass(e)) $el.removeClass(e);
           });    
           $el.removeClass('crsa-h-center').removeClass('crsa-v-center')
           if(value != '') {
               $el.addClass(value);
               $i = $el.find('div.crsa-inner');
               $i.css('top','').css('bottom','').css('left','').css('right','');
               if(value.indexOf('_center') > 0) {
                   $el.addClass('crsa-h-center');
                   main_el.crsaruntime('centerH', $i);
               }
               if(value.indexOf('_middle') > 0) {
                   $el.addClass('crsa-v-center');
                   main_el.crsaruntime('centerV', $i);
               }
           }
       },
       setCAPresetSize : function(sel, fieldid, value, data, $el, prefix) {
           $.each(ca_preset_sizes, function(i,e) {
               if($el.hasClass(e)) $el.removeClass(e);
           });    
           if(value != '') {
               $el.addClass(value);
           }
       },       
       setCAPresetFontSize : function(sel, fieldid, value, data, $el, prefix) {
           $.each(ca_preset_fontsizes, function(i,e) {
               if($el.hasClass(e)) $el.removeClass(e);
           });    
           if(value != '') {
               $el.addClass(value);
           }
       },
       setCAPresetFontEffect : function(sel, fieldid, value, data, $el, prefix) {
           $.each(ca_preset_fonteffects, function(i,e) {
               if($el.hasClass(e)) $el.removeClass(e);
           });    
           if(value != '') {
               $el.addClass(value);
           }
       },
       setCAPresetFonts : function(sel, fieldid, value, data, $el, prefix) {
           $.each(ca_preset_fonts, function(i,e) {
               if($el.hasClass(i)) $el.removeClass(i);
           });    
           if(value != '') {
               $el.addClass(value);
               if(value in ca_preset_fonts) {
                   $.each(ca_preset_fonts[value], function(i,e) {
                       methods.setFont(sel, fieldid, e, data, $el, prefix, false);
                   });
               }
           }
       },      
       setCAPresetBoxStyle : function(sel, fieldid, value, data, $el, prefix) {
           $.each(ca_preset_boxstyles, function(i,e) {
               if($el.hasClass(e)) $el.removeClass(e);
           });    
           if(value != '') {
               $el.addClass(value);
           }
       },
       setCAPresetColorScheme : function(sel, fieldid, value, data, $el, prefix) {
           $.each(ca_preset_colorschemes, function(i,e) {
               if($el.hasClass(e)) $el.removeClass(e);
           });    
           if(value != '') {
               $el.addClass(value);
           }
       },
       setMenuPosition : function(sel, fieldid, value, data, $el, prefix) {
           $.each(menu_positions, function(i,e) {
               if($el.hasClass(e)) $el.removeClass(e);
               var bc = 'bc_' + e;
               if(body.hasClass(bc)) body.removeClass(bc);
           });    
           if(value != '') {
               bc = 'bc_' + value;
               $el.addClass(value);
               body.addClass(bc);
           }
       },
       setMenuStyle : function(sel, fieldid, value, data, $el, prefix) {
           $.each(menu_styles, function(i,e) {
               if($el.hasClass(e)) $el.removeClass(e);
           });    
           if(value != '') {
               $el.addClass(value);
           }
       },
       setMenuVisible : function(sel, fieldid, value, data, $el, prefix) {
           if(value) {
               $el.removeClass('hidden');
           } else {
               $el.addClass('hidden');
           }
       },
       updatePageAnchor : function($p, title) {
           var $a = $p.find('a.msb_element_anchor');
           if($a.length == 0) {
               $p.prepend('<a name="' + $p.attr('id') + '" class="msb_element_anchor" title="' + title + '"/a>');
           } else {
               $a.attr('title', title);
           }
       },
       getColorValue : function(prop, data) {
           var value = prop in data ? data[prop] : 'transparent';
           value = main_el.crsatoolbox('evaluateValue', value);
           var caf = prop + '-alpha';
           var str = value + "";
           if(str.match(/\#/) == null && str.match(/rgb/) == null && value != "" && value != 'transparent') {
               //so it must be 10 base int
               value = parseInt(str, 10);
               if(value > 0xFFFFFF) value = 0xFFFFFF;
               if(value < 0) value = 0;
               str = value.toString(16);
               while(str.length < 6) str = "0" + str;
               value = '#' + str;
           }
           if(value != "" && value != 'transparent') {
            var ca = caf in data ? data[caf] : '100';
            value = hex2rgb(value, parseFloat(ca) / 100.0);
           }
           return value;
       },
       getValue : function(key, data, def) {
           return getValue(key, data, def);
       }
    };
    getValue = function(key, data, def, empty) {
        if(typeof empty == 'undefined') empty = true;
        if(key.indexOf('Meta_') != 0) key = 'Meta_' + key;
        if(empty) {
            if(key in data ) return data[key];
        } else {
            if(key in data && data[key] != '') return data[key];
        }
        return def;
    };
    hex2rgb = function(hex, opacity) {
        var rgb = hex.replace('#', '').match(/(.{2})/g);

        var i = 3;
        while (i--) {
        rgb[i] = parseInt(rgb[i], 16);
        }

        if (typeof opacity == 'undefined' || opacity == 1) {
        return 'rgb(' + rgb.join(', ') + ')';
        }

        return 'rgba(' + rgb.join(', ') + ', ' + opacity + ')';
    };
    getRule = function(sel) {
       var $rule = $.rule(sel);
       if($rule.length == 0) {
           $rule = $.rule(sel + '{}').appendTo('style');
       }    
       return $rule;
    }
    
    $.fn.crsalive = function( method ) {

    if ( methods[method] ) {
      return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
    } else if ( typeof method === 'object' || ! method ) {
      return methods.init.apply( this, arguments );
    } else {
      $.error( 'Method ' +  method + ' does not exist on jQuery.crsa' );
    }    

    };

})( jQuery );