(function( $ ){

    var data = {};

    var msb = null;
    
    var id_count = 0;

    var settings = {
      'get_data' : '/cob/callSmarty/Skill.notes/externalGetUserNotes/',
      'save_data' : '/cob/callSmarty/MsbElement/externalSaveEditableArea/',
      'delete_site' : '/cob/callSmarty/MsbElement/externalDeleteSite/',
      'save_data_bck' : '/cob/callSmarty/MsbElement/externalSaveEditableBck/',
      'url_base' : ''
    };   
               
    var demo_products = [
        {
            id: '1',
            name: 'Shirt A',
            price: 100,
            currency: 'EUR',
            description: 'Sexy sheep wool shirt for all ages.',
            description_short: 'Sexy sheep wool shirt.',
            thumb: '/files/2292064768_e6d2b196d4_b_icon.jpg',
            images: [
                {
                    id: 1,
                    small: {
                        url: '/files/2292064768_e6d2b196d4_b_icon.jpg',
                        width: 100,
                        height: 100
                    },
                    medium: {
                        url: '',
                        width: 800,
                        height: 500
                    },
                    large : {
                        url: '',
                        width: 1200,
                        height: 1000
                    }
                },
                {
                    id: 2,
                    small: {
                        url: '/files/2805725527_bd0dc1d100_b_icon.jpg',
                        width: 100,
                        height: 100
                    },
                    medium: {
                        url: '',
                        width: 800,
                        height: 500
                    },
                    large : {
                        url: '',
                        width: 1200,
                        height: 1000
                    }
                },
                {
                    id: 3,
                    small: {
                        url: '/files/img_0688_icon.jpg',
                        width: 100,
                        height: 100
                    },
                    medium: {
                        url: '',
                        width: 800,
                        height: 500
                    },
                    large : {
                        url: '',
                        width: 1200,
                        height: 1000
                    }
                }
            ],
            category: 'Fashion/Woman',
            collection: 'Armani Summer 2012',
            url: '',
            available: 100,
            options: [
                {
                    id: '1',
                    name: 'Size',
                    values: [
                        {id: '1', label: 'Small'},
                        {id: '2', label: 'Medium'},
                        {id: '3', label: 'Large'}
                    ]
                },
                {
                    id: '2',
                    name: 'Color',
                    values: [
                        {id: '1', label: 'Blue'},
                        {id: '2', label: 'White'},
                        {id: '3', label: 'Orange'}
                    ]
                }
            ]
        },
        {
            id: '2',
            name: 'Shirt B',
            price: 120,
            currency: 'EUR',
            description: 'Another great shirt.',
            description_short: 'Wow! This is an amazing shirt.',
            thumb: '/files/img_0688_icon.jpg',
            images: [
                {
                    id: 1,
                    small: {
                        url: '/files/2292064768_e6d2b196d4_b_icon.jpg',
                        width: 100,
                        height: 100
                    },
                    medium: {
                        url: '',
                        width: 800,
                        height: 500
                    },
                    large : {
                        url: '',
                        width: 1200,
                        height: 1000
                    }
                },
                {
                    id: 2,
                    small: {
                        url: '/files/2805725527_bd0dc1d100_b_icon.jpg',
                        width: 100,
                        height: 100
                    },
                    medium: {
                        url: '',
                        width: 800,
                        height: 500
                    },
                    large : {
                        url: '',
                        width: 1200,
                        height: 1000
                    }
                },
                {
                    id: 3,
                    small: {
                        url: '/files/img_0688_icon.jpg',
                        width: 100,
                        height: 100
                    },
                    medium: {
                        url: '',
                        width: 800,
                        height: 500
                    },
                    large : {
                        url: '',
                        width: 1200,
                        height: 1000
                    }
                }
            ],
            category: 'Fashion/Woman',
            collection: 'Armani Summer 2012',
            url: '',
            available: 100,
            options: [
                {
                    id: '1',
                    name: 'Size',
                    values: [
                        {id: '1', label: 'Small'},
                        {id: '2', label: 'Medium'},
                        {id: '3', label: 'Large'}
                    ]
                },
                {
                    id: '2',
                    name: 'Color',
                    values: [
                        {id: '1', label: 'Blue'},
                        {id: '2', label: 'White'},
                        {id: '3', label: 'Orange'}
                    ]
                }
            ]
        }            

    ];
     
    var id2product = {};
    var products = [];
    var list = [];
    
    var methods = {
       init : function( options ) {
           if ( options ) { 
               $.extend( settings, options );
           }
           this.each(function(i,e){
               var $e = $(e);
           });
           methods.loadProducts(demo_products);
       },
       loadProducts : function(list) {
           id2products = {};
           products = list;
           $.each(list, function(i,e) {
               var key = 'pid_' + e.id;
               id2products[key] = e;
           });
       },
       getId : function() {
           id_count++;
           return "crsa-shop-id-" + id_count;
       },
       getProduct : function(id) {
           var key = 'pid_' + id; 
           return key in id2products ? id2products[key] : null;
       },
       getPrice : function(p) {
           return p.price + ' ' + p.currency;
       },
       getShortDescription : function(p) {
           return p.description_short ? p.description_short : methods.getDescription(p);
       },
       getDescription : function(p) {
           return p.description ? p.description : null;
       },
       showList : function() {
           var id = 'crsa-shop-list';
           var $list = $('#' + id);
           if($list.length == 0) {
               var b = '<div id="' + id + '"><div class="crsa-shop-list-h">My list</div><div class="crsa-shop-list-items"></div></div>';
               $('#msb_mask').after(b);
               var $list = $('#' + id);
           } 
           var c = '';
           $.each(list, function(i,p) {
               c += methods.showListItem(p);
           });
           var $items = $list.find('.crsa-shop-list-items');
           $items.html(c);
       },
       isInList : function(id) {
           var is = false;
           $.each(list, function(i,p) {
               if(p.id == id) {
                   is = true;
                   return false;
               }
           });
           return is;
       },
       addProduct : function(p) {
           if(!methods.isInList(p.id)) {
              list.push(p);
           }
           methods.showList();
       },
       showListItem : function(p, opt) {
           if(typeof opt == 'undefined' || opt == null) opt = {};
           
           var id = methods.getId();
           var b = '<div class="crsa-shop-li" id="' + id + '"><h1>' + p.name + '</h1>\
           <p>' + methods.getShortDescription(p) + '</p>\
           <span class="crsa-shop-ib-price">' + methods.getPrice(p) + '</span>';
           
           if(p.thumb) {
               b += '<img src="' + p.thumb + '" />';
           }
           b += '</div>';
           return b;
       },
       showInfoBox : function(p, $dest, opt) {
           if(typeof opt == 'undefined' || opt == null) opt = {};
           
           var id = methods.getId();
           var b = '<div class="crsa-shop-ib" id="' + id + '"><h1>' + p.name + '</h1>\
           <p>' + methods.getShortDescription(p) + '</p>\
           <span class="crsa-shop-ib-price">' + methods.getPrice(p) + '</span><div class="crsa-shop-ib-images">';
           
           if(p.images) {
               $.each(p.images, function(i,e) {
                   b += '<img src="' + e.small.url + '" />';
               });
           }
           b += '</div><div class="crsa-shop-ib-actions"><a class="crsa-shop-a-add" href="#">+ Add to list</a></div>';
           
           b += '</div>';
           
           $dest.append(b);
           
           var $sb = $('#' + id);
           
           if(opt.position) $sb.css('position', opt.position);
           if(opt.left) $sb.css('left', opt.left);
           if(opt.top) $sb.css('top', opt.top);
           if(opt.class) $sb.addClass(opt.class);
           
           $sb.click(function() {
               methods.showProductStrip(p, 0);
               return false;
           });
           $sb.find('a.crsa-shop-a-add').click(function() {
               methods.addProduct(p);
               $sb.remove();
               return false;
           });
           if(opt.autoclose) {
               var timeout = null;
               $sb.bind('mouseleave', function() {
                   timeout = setTimeout(function() {
                       methods.closeInfoBox($sb);
                       timeout = null;
                   }, 500);
               }).bind('mouseenter', function() {
                   if(timeout) {
                       clearTimeout(timeout);
                       timeout = null;
                   }
               });
           }           
           return $sb;
       },
       showProductStrip : function(p, jump) {
           var b = '<div class="crsa-shop-strip">';
           b += '<div><h1>' + p.name + '</h1>\
           <p>' + methods.getDescription(p) + '</p>\
           <span class="crsa-shop-ib-price">' + methods.getPrice(p) + '</span><div class="crsa-shop-ib-images">\
           </div>';
           
           if(p.images) {
               $.each(p.images, function(i,e) {
                   b += '<div class="crsa-photo"><img src="' + e.small.url + '" /></div>';
               });
           }
           b += '</div>';
            
           var $dest = $('body');
           $('#cms').after(b);
            
           var $s = $dest.find('div.crsa-shop-strip');
            
            //methods.resizeStripPhotos($s, data);
            
/*            main_el.bind('crsaAfterResize.strip', function() {
                methods.resizeStripPhotos($s, data);
            });
  */          
           $('#msb').crsaruntime('wireStrip', $s, jump);
       },       
       closeInfoBox : function($e) {
           $e.hide();
           $e.remove();
       }
    };


         
    $.fn.crsashop = function( method ) {

    if ( methods[method] ) {
      return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
    } else if ( typeof method === 'object' || ! method ) {
      return methods.init.apply( this, arguments );
    } else {
      $.error( 'Method ' +  method + ' does not exist on jQuery.crsa' );
    }    

    };

})( jQuery );