(function( $ ){

    var tree = null;
    
    var settings = {
      'dialogs'         : {},
      'element'         : 'crsa-ui-forms',
      'elementTools'    : 'crsa-ui-tools',
      'inline' : false
    };  
    
    var changed = {};
    var save = false;
    var edit_source = null;
    var current_el = null;
    var main_el = null;
    var save_b_e = null;
        
    var select_images = {};
    var bck_positions = {};
    var with_show = {};
    var sel_widgets = {};
    
    var methods = {
       init : function( options ) {
           return this.each(function(i,e){
                if ( options ) { 
                    $.extend( settings, options );
                }
                e = $(e);
                main_el = e;
                e.bind('edit.crsa', methods.onEdit);
                e.bind('changesSaved.crsa', methods.saveDone);
                
                var b = '<a id="crsa-save-button" href="#" class="crsa-input-button-link-small">&nbsp;&nbsp;&nbsp;Save changes&nbsp;&nbsp;&nbsp;</a>';
                $t = $('#' + settings.elementTools);
                $t.html(b);
                $t.find('a').click(function() {methods.save(); return false;});
                
                save_b_e = $("#crsa-save-button");
                
                 $(window).bind('beforeunload', function() {
                     if(save) {
                         return "You have unsaved changes.";
                     }
                 });
           });

     },
     hlSelected : function($e) {
        methods.unhlSelected();
        $e.addClass('crsa-active-element');    
     },
     unhlSelected : function() {
        if(current_el != null) current_el.removeClass('crsa-active-element');
     },
     onEdit : function(event, eid, dest, source, showAtElement, reposition) {
         if(typeof dest == 'undefined' || dest == null) dest = settings.element;
         if(typeof source == 'undefined' || source == null) source = 'action';
         if(typeof reposition == 'undefined') reposition = true;
         edit_source = source;
         
         var e = $('#' + eid);
         if(!settings.inline) {
            methods.hlSelected(e);
         }
         
         current_el = e;
         var data = e.data('crsa');
         var values = data.data ? data.data : {};
         var type = data.type;

         var uc = $('#crsa-ui');
     /*    if(uc.length == 0) {
             $('#cms').append('<div id="crsa-ui">');
             var uc = $('#crsa-ui');
         }*/
         
         if(typeof dest == "string") {
            var uiel = $('#' + dest);
         } else {
             uiel = dest;
         }
         uiel.accordion( "destroy" );
         uiel.html('');
         
         var dialog = settings.dialogs[type];
         if(typeof dialog == 'undefined') {
             uc.hide();
             return;
         }
         uc.show();
         uc.draggable({handle: '.crsa-window-title'});
         uc.find('a.crsa-window-close').click(function() { uc.hide(); });
         
         uc.find('.crsa-window-title').html(data.name + ' properties');

         var atElement = e;
         if(typeof showAtElement != 'undefined' && showAtElement != null) atElement = showAtElement;
         var ep = atElement.offset();

         var ux = ep.left - uc.width() - 10;
         var uy = ep.top + 20;
         if(uy < 50) uy = 50;
         if(ux < 0) {
             //if(ep.left + e.width() + uiel.width()) < 
             ux = 0;
         }
         if(reposition) {
            uc.css('left', ux + 'px').css('top', uy + 'px');
         }
         
         var b = '';
         var colors = {};
         var sliders = {};
         var images = {};
         var all = {};
         select_images = {};
         bck_positions = {};
         sel_widgets = {};
         with_show = {};
         
         $.each(dialog, function(sid, s) {
             b += '<h2>' + s.name + '</h2><div>';
             b += generateFields(s, values, colors, sliders, images, all);
             b += '</div>';
         });
         uiel.html(b);
         wireFields(uiel, colors, sliders, images, all);
         uiel.accordion({autoHeight: false});
         showHideFields();
     },
     paintDialog : function(eid, dest, reposition) {
         methods.onEdit(null, eid, dest, null, null, reposition);
     },
     repaintElementIfActive : function(eid) {
         if(current_el != null && current_el.length > 0 && current_el[0].id == eid) {
             methods.paintDialog(eid, null, false);
         }
     },
     save : function() {
         var d = methods.getChanges();
         main_el.trigger('save.crsa', d);
         return d;
     },
     getChanges : function($el) {
         var d = {elements: {}};
         $.each(changed, function(eid, v) {
             if(v == null) return true;
             if((typeof $el != 'undefined' || $el != null) && $el[0].id != eid) return true;
             var data = $('#' + eid).data('crsa');
             if(data == null || !data.data) return true;
             d.elements['id_' + data.id] = data.data;
         });
         d.values = main_el.crsatoolbox('getChangedValues');
         d.rules = main_el.crsatoolbox('getChangedRules');
         return d;
     },
     saveDone : function(event, data, $el) {
         if(typeof $el != 'undefined' && $el != null) {
             var eid = $el[0].id;
             if(eid in changed) changed[eid] = null;
         } else {
            changed = {};
            main_el.trigger('clean.crsa');
            save = false;
            if(save_b_e) {
                save_b_e.removeClass('hlButton');
            }
         }
     },
     onValueChangedDirect : function(target, val) {
         onValueChangedDirect(target, val);
     },
     showFileUpload : function(popt, dest, event) {
         var opt = {
            'max_size' : '10mb',
            'allowed' : null,
            'resize_width' : 1600,
            'resize_height' : 1600,
            'resize_quality' : 80,
            'class' : 'cms_multi_upload',
            'title' : 'File upload',
            'auto_start' : true,
            'type' : null,
            'image_type' : 'Attachment.gallery',
            'doc_type' : 'Attachment.document',
            'position' : null,
            'connect_to' : null,
            'did' : null,
            'parent_id' : null,
            'next' : 'show',
            'image_next' : null,
            'doc_next' : null,
            'auto_show' : false,
            'auto_show_button' : true,
            'objects_element' : null,
            'draggable' : true,
            'insertion' : 'top',
            'compact' : false,
            'raw' : false,
            'notify_element' : null,
            'auto_close' : true
         };
         if ( popt ) { 
            $.extend( opt, popt );
         }
        if(opt.compact) {
            opt['class'] = 'cms_multi_upload_compact';
            opt['draggable'] = false;
        }
        
        var filters = !opt.allowed ? [] : [ {title : "Allowed files", extensions : opt['allowed']}];
        
        var resize = null;
        if(opt.resize_width) {
            resize = {width : opt['resize_width'], height : opt['resize_height'], quality : opt['resize_quality']};
        }
        var url = main_el.crsaruntime('getUrlBase') + '/cob/saveMultiple/upload=1/next=' + opt['next'] + '/';
        if(opt.image_type) url += "image_type=" + opt['image_type'] + "/";
        if(opt.doc_type) url += "doc_type=" + opt['doc_type'] + "/";
        if(opt.type) url += "type=" + opt['type'] + "/";
        if(opt.position) url += "position=" + opt['position'] + "/";
        if(opt.connect_to) url += "connect_to=" + opt['connect_to'] + "/";
        if(opt.did) url += "did=" + opt['did'] + "/";
        if(opt.parent_id) url += "parent_id=" + opt['parent_id'] + "/";
        if(opt.image_next) url += "image_next=" + opt['image_next'] + "/";
        if(opt.doc_next) url += "doc_next=" + opt['doc_next'] + "/";
        if(opt.raw) $url += "raw=" + opt['raw'] + "/";
        
        var id = main_el.crsa('getNewId');
        
        var obj_el = opt.objects_element ? id + "objects" : opt['objects_element'];
        
        var drop_id = opt.drop_element ? id + "container" : opt['drop_element'];
        
        var append = opt['insertion'] == 'top' ? 'prepend' : 'append';
        var uploader = 'upl'.$id;
        
        opt['container'] = id + "container";
        opt['uploader_instance'] = uploader;
        
        uploader = null;
            
        var b = '';

        b += '<div id=\"' + id + 'container\" class=\"' + opt['class'] + '\" > \
                <p class=\"cms_multi_upload_title\">' + opt['title'] + '</p> \
                <div id=\"' + id + 'filelist\" class=\"cms_multi_upload_list\">Upload is not supported in your browser. \
                Use new versions of Firefox or Chrome.</div>  \
                <div id=\"' + id + 'drop\" class=\"cms_multi_upload_drop\"></div> ';
                
        if(!opt.compact) {
            b += '<br /> \
            <a id=\"' + id + 'pickfiles\" href=\"#\" class=\"cms_multi_upload_button_select crsa-button\">Select files...</a>&nbsp;&nbsp \
            <a class="crsa-close close">Close</a>';
        } else {
            b += '<a id=\"' + id + 'pickfiles\" href=\"#\" class=\"cms_multi_upload_button_select crsa-button\">Select files...</a>';
        }
        b += "</div>";
        if(obj_el == id + "objects") {
            b += '<div id=\"' + id + 'objects\" class=\"cms_multi_upload_objects\"></div>';
        }       
        
        if(typeof dest == 'undefined' || dest == null) dest = $('#cms');
        dest.append(b);  

        if(typeof(event) != 'undefined' && event != null)  dvPositionMenu('cms', id + 'container', event);
        if(opt.draggable) dvDraggable(id + "container", {});
        jQuery('#' + id + 'filelist').removeClass('cms_multi_upload_list_has_files');
        jQuery('#' + id + 'container').fadeIn();
        
        jQuery('#' + id + 'container').find('.close').click(function() {
            jQuery('#' + id + 'container').fadeOut();
        });
        
         var uploader = new plupload.Uploader({
            runtimes : 'html5,html4',
            browse_button : id + 'pickfiles',
            container : id + 'container',
            drop_element : drop_id, 
            max_file_size : opt['max_size'],
            filters : filters,
            resize : resize,
            flash_swf_url : '/js/plupload/js/plupload.flash.swf',
            url : url
        });

        uploader.bind('Init', function(up, params) {
            jQuery('#' + id + 'filelist').html('');
        });

        uploader.init();

        uploader.bind('FilesAdded', function(up, files) {
            jQuery.each(files, function(i, file) {
                jQuery('#' + id + 'filelist').append(
                    '<div id="' + file.id + '" class="cms_multi_upload_file"><div class="cms_multi_upload_file_pr" style="width:0;"></div><p>' +
                    file.name + ' (' + plupload.formatSize(file.size) + ') ' + '</p>' + 
                '</div>');
            });
            jQuery('#' + id + 'filelist').addClass('cms_multi_upload_list_has_files');
            if(!jQuery('#' + id + 'container').is(':visible')) jQuery('#' + id + 'container').fadeIn(200);
            if(!jQuery('#' + id + 'close').is(':visible')) jQuery('#' + id + 'close').show();

            if(opt.auto_start) {
                $('#msb').crsaruntime('waitStart');
                uploader.start();
                uploader.refresh(); // Reposition Flash/Silverlight
                jQuery('#' + drop_id).trigger('dvUploadStarted');
            }

        });
            
        uploader.bind('UploadProgress', function(up, file) {
            jQuery('#' + file.id + ' .cms_multi_upload_file_pr').width(file.percent + "%");
        });

        uploader.bind('Error', function(up, err) {
            jQuery('#' + id + 'filelist').append("<div>Error: " + err.code +
                ", Message: " + err.message +
                (err.file ? ", File: " + err.file.name : "") +
                "</div>"
            );
            $('#msb').crsaruntime('waitDone');
            uploader.refresh(); // Reposition Flash/Silverlight
        });

        uploader.bind('FileUploaded', function(up, file, response) {
            response = eval("(" + response.response + ")");
            jQuery('#' + file.id + " .cms_multi_upload_file_pr").width("100%");
            
            if(response.error) {
                alert(response.error);
            } else {
                if(opt['insertion'] == 'top') {
                    jQuery('#' + obj_el).prepend(response.result);
                } else {
                    jQuery('#' + obj_el).append(response.result);
                }
                if(opt['notify_element']) {
                    jQuery('#' + opt['notify_element']).trigger('FileUploaded', [file, response]);
                }
                if(opt['auto_close']) {
                    jQuery('#' + id + 'container').fadeOut();
                }
            }
            $('#msb').crsaruntime('waitDone');
        });
        uploader.refresh();

        return uploader;
     },
     showRemoveFromFbPage : function($dest, data, func) {
         var b = '\
         <p>Site is added to Facebook page <strong>' + data.fb_page_name + '</strong></p>\
         <a class="sne_remove_from_fb_page action" href="#">Remove it from the Facebook page</a>\
         ';
         
         $dest.html(b);
         
         var removed = function() {
             data.fb_page_id = null;
             data.fb_page_app_id = null;
             data.fb_page_name = '';
             
             main_el.crsaruntime('waitStart');
            $.ajax({
                  type: 'POST',
                  url: main_el.crsaruntime('getUrlBase') + '/cob/callSmarty/MsbElement/externalAddedToFbPage',
                  data: {fb: JSON.stringify(data)},
                  success: function(ret) {
                      main_el.crsaruntime('waitDone');
                      if(typeof func == 'function') func(data);
                      methods.showAddToFbPage($dest, data, func);
                  },
                  error: function(a,b,c) {
                      main_el.crsaruntime('waitDone');
                      alert(a.responseText);
                  },
                  beforeSend:function(request) { 
                      request.setRequestHeader('X-Update', 'dummy');
                  },               
                  dataType: 'json'
                });               
         };
         
         var msg = "Problem deleting from the page. Tab is disabled, but needs to be removed manually from the Facebook page.";
         
         $dest.find('a.sne_remove_from_fb_page').click(function() {
             if(!confirm("Are you sure that you want to remove this pllop from a Facebook page?")) return false;
             main_el.crsaruntime('waitStart');
             FB.login(function(response) {
                 main_el.crsaruntime('waitDone');
               if (response.authResponse) {
                   
                    main_el.crsaruntime('waitStart');
                    FB.api('/' + data.fb_page_id + '/tabs/' + data.fb_page_app_id, {}, function(response) {
                        main_el.crsaruntime('waitDone');
                        
                        if(response.data.length > 0) {
                            var tab_id = response.data[0].id;

                            main_el.crsaruntime('waitStart');
                            FB.api('/' + data.fb_page_id, { fields: 'access_token' }, function(response) {
                                main_el.crsaruntime('waitDone');
                                
                                if(response.access_token) {
                                    var at = response.access_token;
                                 //   FB.api('/' + data.fb_page_id + '/tabs/' + tab_id, 'delete', { access_token: at}, function(response) {
                                    main_el.crsaruntime('waitStart');
                                    FB.api('/' + tab_id, 'delete', { access_token: at}, function(response) {
                                        main_el.crsaruntime('waitDone');
                                        removed();
                                        if(response !== true) {
                                            alert(msg + " Reason: " + response.error.message);
                                        } 
                                    });
                                } else {
                                    removed();
                                    alert(msg);
                                }
                            });
                        } else {
                            removed();
                            alert(msg);
                        }                
                    });
               } else {
                 alert('User cancelled login or did not fully authorize.');
               }
             }, {scope: 'manage_pages'});
             return false;
         });
     },
     showAddToFbPage : function($dest, data, func) {
        var b = '\
                <p><a class="sne_add_to_fb_page action" href="#">Add this pllop to Facebook Page</a></p>\
                <p  style="display:none;">Select a Facebook page: <select class="sne_fb_page_id"/></p>\
                <input class="sne_fb_page_name" style="display:none;" />\
                <input class="sne_fb_page_id_done" style="display:none;" />\
                <input class="sne_fb_page_app_id_done" style="display:none;" />\
                <p  style="display:none;">Name of the tab: <input class="sne_fb_tab_name" type="input" /></p>\
                <p  style="display:none;"><input class="sne_fb_landing" type="checkbox" /> Make this pllop the landing tab for users who did not yet like the page</p>\
                <a class="sne_add_to_fb_page_do button" style="display:none;" href="#">Add it!</a>\
                ';
        
        $dest.html(b);
         
        var $action = $dest.find('a.sne_add_to_fb_page');
        var $fb_add_do = $dest.find('a.sne_add_to_fb_page_do');
        var $fb_sel = $dest.find('select.sne_fb_page_id');
        var $fb_name = $dest.find('input.sne_fb_page_name');
        var $fb_page_id_done = $dest.find('input.sne_fb_page_id_done');
        var $fb_page_app_id_done = $dest.find('input.sne_fb_page_app_id_done');

        var $tab_name = $dest.find('input.sne_fb_tab_name');
        var $landing = $dest.find('input.sne_fb_landing');
        
        if(data.tab_name) {
            $tab_name.val(data.tab_name);
        }
        
        var app_id = $('#msb').crsaruntime('getFbAppId');
        
        $fb_add_do.click(function(e) {
            var pid = $fb_sel.val();
            main_el.crsaruntime('waitStart');
            
            FB.api('/' + pid + '/tabs', 'post', { app_id: app_id, access_token: page_id_to_token['id' + pid]}, function(response) {   
                main_el.crsaruntime('waitDone');
                if(response === true) { 

                    main_el.crsaruntime('waitStart');
                    FB.api('/' + pid + '/tabs/' + app_id, {}, function(response) {
                        main_el.crsaruntime('waitDone');
                        
                        if(response.data.length > 0) {
                            var tab_id = response.data[0].id;
                            
                            main_el.crsaruntime('waitStart');

                            var ud = { access_token: page_id_to_token['id' + pid]};
                            var name = $tab_name.val();
                            if(name) ud.custom_name = name;
                            
                            if($landing.is(':checked')) ud.is_non_connection_landing_tab = true;
                            
                            FB.api('/' + tab_id, 'post', ud, function(response) {
                                main_el.crsaruntime('waitDone');
                            });                            
                            
                        } else {
                            alert('Site was added to the Facebook page, but could not set the name and landing page status');
                        }
                    });
                    
                    
                    $fb_page_id_done.val(pid);   
                    $fb_page_app_id_done.val( app_id); 
                    data.fb_page_id = pid;
                    data.fb_page_name = page_id_to_name['id' + pid];
                    data.fb_page_app_id = app_id;
                    
                    main_el.crsaruntime('waitStart');
                    $.ajax({
                          type: 'POST',
                          url: main_el.crsaruntime('getUrlBase') + '/cob/callSmarty/MsbElement/externalAddedToFbPage',
                          data: {fb: JSON.stringify(data)},
                          success: function(ret) {
                              main_el.crsaruntime('waitDone');
                              if(typeof func == 'function') func(data);
                              methods.showRemoveFromFbPage($dest, data, func);
                          },
                          error: function(a,b,c) {
                              main_el.crsaruntime('waitDone');
                              alert(a.responseText);
                          },
                          beforeSend:function(request) { 
                              request.setRequestHeader('X-Update', 'dummy');
                          },               
                          dataType: 'json'
                        });               
                } else {
                    alert("Pllop was not added to the page: " + response.error.message);
                }
            });
            return false;
        });  
                    
        $fb_sel.change(function() {
            var pid = $fb_sel.val();
            if(pid > 0) {
                $fb_name.val(page_id_to_name['id' + pid]);
                $fb_add_do.show();
                $tab_name.parent().show();
                $landing.parent().show();
            } else {
                $fb_name.val('');
                $fb_add_do.hide();
                $tab_name.parent().hide();
                $landing.parent().hide();
            }
        });
        
        var page_id_to_name = {};
        var page_id_to_token = {};
        
        $dest.find('a.sne_add_to_fb_page').click(function(e) {
            main_el.crsaruntime('waitStart');
            FB.login(function(response) {
                main_el.crsaruntime('waitDone');
               if (response.authResponse) {
                    main_el.crsaruntime('waitStart');
                    FB.api('/me/accounts', { limit: 100 }, function(response) {
                        main_el.crsaruntime('waitDone');
                        $fb_sel.html('<option value="0"></option>');
                        for (var i=0, l=response.data.length; i<l; i++) {
                            var acc = response.data[i];
                            console.log(acc.name);
                            var n = acc.name + ' (' + acc.id + ')';
                            $fb_sel.append('<option value="' + acc.id + '">' + n + '</option>');
                            page_id_to_name['id' + acc.id] = n;
                            page_id_to_token['id' + acc.id] = acc.access_token;
                        }
                        $fb_sel.parent().show();
                        $action.parent().hide();
                    });
               } else {
                 alert('User cancelled login or did not fully authorize.');
               }
             }, {scope: 'manage_pages'});                
            return false;
        });
     },     
     destroy : function( ) {

       return this.each(function(i,e){
         $(e).unbind('.crsa');
       })
     }


    };
    generateFields = function(s, values, colors, sliders, images, all) {
     var b = '';   
     $.each(s.fields, function(fid, f) {
         var cl = f.cls ? f.cls : '';
         b += '<div class="crsaui-field-c ' + cl + '">';
         b += '<label>' + f.name + '</label>';
         var value = (f.id in values) ? values[f.id] : ('default' in f ? f['default'] : "");
         var id = current_el[0].id + '__' + f.id;
         
         switch(f.type) {
             case 'checkbox':
                var sel = (value && value == "1") ? ' checked ' : '';
                b += '<input type="checkbox" value="1" id="' + id + '" name="' + f.id + '" class="crsaui-field crsaui-field-' + f.type + '"' + sel +'/>';
                break;
             case 'select':
                
                b += '<select id="' + id + '" name="' + f.id + '" class="crsaui-field crsaui-field-' + f.type + '">';
                if(f.empty) {
                    b += '<option value="0"></option>';
                }
                var has_img = false;
                $.each(f.options, function(op, opv) {
                    op = f.options[op];
                    var sel = op.id == value ? ' selected ' : '';
                    var style = '';
                    if(op.image && op.image != '' && false) {
                        //style = ' title="' + op.image + '"';
                        style = ' style="background-image:url(' + op.image + ');"';
                        has_img = true;
                    }
                    b += '<option value="' + op.id + '" ' + sel + style + '>' + op.label + '</option>';   
                });
                b += '</select>';
                if(has_img) select_images[id] = true;
                break;
             case 'images':
                var id_link = id + '_edit_link';
                b += '<div class="crsaui-field crsaui-field-' + f.type + '">';
                if(value) {
                    $.each(value, function(vi, img) {
                        b += '<img src="' + img.thumb + '" />';
                    });
                }
                b += '<a id="' + id_link + '" href="#">edit images</a>';
                b += '</div>';
                images[id_link] = f;
                break;
             case 'bck_position':
                b += paintPositionWidget(id, f);
                bck_positions[id] = f;
                break;
             case 'sel_widget':
                b += paintSelectionWidget(id, f, f.widget_class, f.options);
                sel_widgets[id] = f;
                break;
             case 'input':
             case 'color':
             case 'slider':
             default:
                var vu = splitValueUnit(value);
                var uu = f.units ? ' crsaui-field-with-unit' : '';
                b += '<input type="text" id="' + id + '" value="' + vu.value + '" name="' + f.id + '" class="crsaui-field crsaui-field-' + f.type + uu + '" />';
                if(f.units) b += makeUnitSelector(id, f.id, vu.unit);
                break;
         }
         if(f.type == 'color') {
             b += '<a href="#" title="Transparent" class="crsaui-field-color-trans" onclick="$(\'#' + id + '\').val(\'transparent\').trigger(\'input\'); return false;">Trans.</a>';
             b += '<div id="' + id + '_colorpicker" class="crsaui-colorpicker" style="display:none;"></div>';
             colors[id] = id + '_colorpicker';
         }
         if(f.type == 'slider') {
             b += '<div id="' + id + '_slider"></div>';
             sliders[id] = { pid: id + '_slider', def: f};
         }
         all[id] = f;
         
         if(f.show) {
             with_show[id] = f;
         }
         b += '</div>';
     });
     return b;
    };
    
    wireFields = function(uiel, colors, sliders, images, all) {
         //var uiel = $('#' + settings.element);
         uiel.find('.crsaui-field').bind('input', onValueChanged);
         uiel.find('.crsaui-field-checkbox').bind('change', onValueChanged);
         uiel.find('.crsaui-field-select').bind('change', onValueChanged);
         uiel.find('.crsaui-field-unit').bind('change', onValueChanged);
         
         $.each(colors, function(cid, cidv) {
             $('#' + colors[cid]).farbtastic('#' + cid);
             $('#' + cid).focus(function(event) { 
                 var cid = event.target.id + '_colorpicker';
                 $('.crsaui-colorpicker').fadeOut();
                 var $e = $(event.currentTarget);
                 var o = $e.offset();
                 event.pageX = o.left + $e.width();
                 event.pageY = o.top;
                 dvPositionMenu('cms', cid, event, 0, 0);
                 $('#' + cid).fadeIn(); 
             });
             //$('#' + colors[cid]).mouseleave(function() { $('#' + colors[cid]).fadeOut(); });
             $('#' + cid).blur(function(event) { $('#' + event.target.id + '_colorpicker').fadeOut(); });
             $('#' + cid).bind('input', function(event) {$.farbtastic('#' + event.target.id + '_colorpicker').setColor($(event.target).val());});
         });
         $.each(sliders, function(sid, sidv) {
            $( "#" + sliders[sid].pid ).slider({
                min: sliders[sid].def.min,
                max: sliders[sid].def.max,
                value: $('#' + sid).val(),
                slide: function( event, ui ) {
                    var fid = event.target.id.replace('_slider','');
                    $( "#" + fid ).val( ui.value ).trigger('input');
                }
            });
         });
         $.each(images, function(iid, iidv) {
             $('#' + iid).bind('click', images[iid], onEditImages);
         });
         $.each(all, function(id, idv) {
            $('#' + id).data('crsafield', all[id]);
         });
         $.each(select_images, function(id, vv) {
         //    $('#' + id).msDropDown();
         });
         $.each(bck_positions, function(id, vv) {
            wirePositionWidget($('#' + id), current_el);    
         });
         $.each(sel_widgets, function(id, vv) {
            wireSelectionWidget($('#' + id), current_el);    
         });
    };
    
    onEditImages = function(event) {
        var f = event.data;
        main_el.trigger('editPosition.crsa', {position: f.position, id: current_el.data('crsa').id});
        return false;
    };
    
    onValueChangedDirect = function(target, val) {
        var fieldid = target.name.replace('__unit','');
        var id = target.id != null ? target.id.replace('__unit','') : null;
        var server_side = false;
        if(id != null) {
            var $t = $('#' + id);
            var fdef = $t.data('crsafield');
            var m = id.split('__');
            var eid = m[0];
            var fid = m[1];
            if(fdef.server_side) server_side = true;
        } else {
            eid = target.el[0].id;
            if(target.server_side) server_side = true;
        }
        var value = null;
        if(typeof val == 'undefined') {
            if($t.hasClass('crsaui-field-checkbox')) {
                value = $('#' + id + ':checked').val() !== undefined ? "1" : "0";
            } else {
                value = $('#' + id).val();
                if(value != '' && $('#' + id + '__unit').length > 0) value += $('#' + id + '__unit').val();
            }
        } else {
            value = val;
        }
        if(edit_source == 'tree') {
            var active_elements = main_el.crsa('getActiveElements');
        } else {
            active_elements = [$('#' + eid)];
        }
        
        $.each(active_elements, function(i, $el) {
            var eid = $el[0].id;
            console.log(eid + ' - ' + fid + ' = ' + value);
            var data = $('#' + eid).data('crsa');
            if(!data.data) data.data = {};
            var oldvalue = (fieldid in data.data) ? data.data[fieldid] : null;
            data.data[fieldid] = value;
            //$el = $('#' + eid);
            $el.data('crsa', data);
            eventData = {'e': $el, 'fieldid': fieldid, 'value': value, 'oldvalue': oldvalue};
            if(server_side) {
              //  console.log('ss');
                main_el.crsa('onServerSideValueChanged', eid);
            } else {
                main_el.trigger('changed.crsa', eventData);
            }
            changed[eid] = true;
        });
        
        if(!save) {
            main_el.trigger('dirty.crsa');
            save_b_e.addClass('hlButton');
        }
        save = true;
    };
    
    showHideFields = function() {
        var data = current_el.data('crsa').data;
        $.each(with_show, function(id,e) {
            if(e.show(data)) {
                $('#' + id).parent().show();
            } else {
                $('#' + id).parent().hide();
            }
        });
    };
    
    onValueChanged = function(event) {
        onValueChangedDirect(event.target);
        showHideFields();
    }
    
    makeUnitSelector = function(id, name, value) {
        var units = ['px','%','em','er'];
        var b = '<select name="' + name + '__unit" id="' + id + '__unit" class="crsaui-field-unit" >';
        $.each(units, function(ui, u) {
            var sel = value == u ? ' selected' : '';
            b += '<option value="' + u + '"' + sel + '>' + u + '</option>';
        });
        b += '</select>';
        return b;
    }
    
    splitValueUnit = function(str) {
        var a = str.match(/^(\d+(?:\.\d+)?)(.*)$/);
        if(a == null) return {value: str, unit:""};
        return {value: a[1], unit: a[2]};
    }
    
    paintPositionWidget = function(id, f) {
        var data = current_el.data('crsa');        
        var values = {'top-left':[0,0], 'top-center':[0,0],'top-right':[0,0],'center-left':[0,0],'center-center':[0,0],'center-right':[0,0],'bottom-left':[0,0],'bottom-center':[0,0],'bottom-right':[0,0]};
        var vh = main_el.crsalive('getValue', 'Meta_background-position-h', data.data, 'center');
        var vv = main_el.crsalive('getValue', 'Meta_background-position-v', data.data, 'center');
        var value = vv + '-' + vh;
        var b = '<div id="' + id + '_widget" class="crsa-ui-widget crsa-ui-bck-position">';
        b += '<input type="hidden" id="' + id + '" value="' + value + '" name="' + f.id + '" />';

        $.each(values, function(f, v) {
            var cls = '';
            if(f == value) cls = ' class="selected" ';
            b += '<a href="#" ' + cls + '>' + f + '</a>';
        });
        b += '</div>';
        return b;
    }
    wirePositionWidget = function($w, $e) {
        $w.parent().find('> a').click(function(e) {
            var v = $(e.currentTarget).html();
            var a = v.match(/^([a-z]*)\-([a-z]*)$/);
            $w.parent().find('> a').removeClass('selected');
            $(e.currentTarget).addClass('selected');
            $w.val(v);
            onValueChangedDirect({name: 'Meta_background-position-v', id: $w[0].id}, a[1]);
            onValueChangedDirect({name: 'Meta_background-position-h', id: $w[0].id}, a[2]);
            return false;
        });
    }
    paintSelectionWidget = function(id, f, wcls, values) {
        var data = current_el.data('crsa');        
        var value = main_el.crsalive('getValue', f.id, data.data, '');

        var b = '<div id="' + id + '_widget" class="crsa-ui-widget crsa-ui-sel ' + wcls + '">';
        b += '<input type="hidden" id="' + id + '" value="' + value + '" name="' + f.id + '" />';

        var bpx = 0;
        var bpd = 60;
        
        $.each(values, function(f, v) {
            var cls = '';
            if(v.id == value) cls = ' class="selected" ';
            b += '<a href="#" ' + cls + ' style="background-position: ' + bpx + 'px 0;">' + v.id + '</a>';
            bpx = bpx - bpd;
        });
        b += '</div>';
        return b;
    }    
    wireSelectionWidget = function($w, $e) {
        $w.parent().find('> a').click(function(e) {
            var v = $(e.currentTarget).html();
            $w.parent().find('> a').removeClass('selected');
            $(e.currentTarget).addClass('selected');
            $w.val(v);
            //console.log($w.attr('name'));
            onValueChangedDirect({name: $w.attr('name'), id: $w[0].id}, v);
            return false;
        });
    }
        
    $.fn.crsaui = function( method ) {

    if ( methods[method] ) {
      return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
    } else if ( typeof method === 'object' || ! method ) {
      return methods.init.apply( this, arguments );
    } else {
      $.error( 'Method ' +  method + ' does not exist on jQuery.crsaui' );
    }    

    };

})( jQuery );