(function( $ ){
    var item_w = 0;
    var max_items = 0;
    var current_item=0;
    var speed=500;
    var first_item = null;
    var $e;
    var init_done = false;
    var items;
    var freeze = false;
        
    var swipeOptions=
    {
        triggerOnTouchEnd : true,    
        allowPageScroll:"none",
        threshold:100,
        onSeek : null,
        onNextRange : null,
        onPrevRange : null
    }
    
    var methods = {
       init : function( options ) {
           if ( options ) { 
               $.extend( swipeOptions, options );
           }           
           this.each(function(i,e){
               $e = $(e);
               init_done = $e.data('crsaSwipeInitDone') === true;
               if(init_done) {
                   methods.update();
                   return false;
               }
               swipeOptions.swipeStatus = methods.swipeStatus;
               $e.swipe( swipeOptions );
               init_done = true;
               $e.data('crsaSwipeInitDone', true);
               methods.update();
           });
           if(init_done) return;
           $(window).resize(function() {
                console.log('onresize in swipepage');
                methods.update();
                methods.seekTo(current_item, 100);
           });           
           if(document.location != 'http://dev.pllop.com/11025') {
              // methods.seekTo(1, 100);
           }
       },
       freeze : function() {
           freeze = true;
       },
       update : function() {
           console.log('update');
           items = $e.find('> div').filter(":visible");
           $e.css('-webkit-transform', 'translate3d(0px,0px,0px)'); 
           $e.css('-webkit-transition-property', '-webkit-transform');
           items.css('-webkit-transform', 'translate3d(0px,0px,0px)'); 
           max_items = items.length;
           items.each(function(i,e) {
                item_w = $(e).innerWidth();
                first_item = $(e);
                return false;    
           });
           if(current_item >= max_items) {
               methods.seekTo(max_items - 1, 100);
           }
       },
       swipeStatus : function (event, phase, direction, distance)
       {
           if(freeze) return;
           
           item_w = first_item.innerWidth();
           
         //  console.log(phase + ' ' + direction + ' dis ' + distance);
           
            //If we are moving before swipe, and we are going Lor R in X mode, or U or D in Y mode then drag.
            if( phase=="move" && (direction=="left" || direction=="right") )
            {
                var duration=0;
                
                if (direction == "left") {
                    methods.scrollImages((item_w * current_item) + distance, duration);
                    if(current_item == max_items - 1 && swipeOptions.onNextRange && distance > 50) swipeOptions.onNextRange();
                } else if (direction == "right") {
                    methods.scrollImages((item_w * current_item) - distance, duration);
                    if(current_item == 0 && swipeOptions.onPrevRange && distance > 50) swipeOptions.onPrevRange();
                }
            }
            
            else if ( phase == "cancel")
            {
                methods.scrollImages(item_w * current_item, speed, true);
            }
            
            else if ( phase =="end" )
            {
                if (direction == "right")
                    methods.previousImage()
                else if (direction == "left")            
                    methods.nextImage()
            }
        },
        previousImage : function()
        {
            item_w = first_item.innerWidth();
            current_item = Math.max(current_item-1, 0);
            methods.scrollImages( item_w * current_item, speed);
        },
        nextImage : function()
        {
            item_w = first_item.innerWidth();
            current_item = Math.min(current_item+1, max_items-1);
            methods.scrollImages( item_w * current_item, speed);
        },
        seekTo : function(i, pspeed) {
            item_w = first_item.innerWidth();
            if(pspeed == null) pspeed = speed;
            current_item = Math.min(max_items - 1, i);
            if(current_item < 0) current_item = 0;
            methods.scrollImages(item_w * current_item, pspeed);
        },        
        getTransformX : function($el) {
            var results = $el.css('-webkit-transform').replace(/px/g, '').match(/[a-z3]*\(([^,]*)/)

            if(!results) return '0';
            return results[1];
        },
        scrollImages : function(distance, duration, cancel)
        {
            if(typeof cancel == 'undefined' || cancel == null) cancel = false;
           // if(distance == 0) return;
            var l = $e.css('left');
            var value = (distance<0 ? "" : "-") + Math.abs(distance).toString();
          // console.log('left = ' + l + ', value = ' + value + ' dur ' + duration + ' dis ' + distance);
            if(value + "px" == l) return;
            var done = false;
            if(value + 'px' == l) return;
            var sim = true;
            if(l != "0px" && sim) {
                $e.unbind('webkitTransitionEnd.sp');
                //$e.css('-webkit-transition-property', '');
                $e.css("-webkit-transition-duration", "0s");
                //$e.css('-webkit-transition-property', null);
                //$e.css("-webkit-transition-duration", null);
                if(duration == 0) {
                    l = value + "px";
                    done = true;
                    $e.css('-webkit-transition-delay','0');
                    $e.css('-webkit-transition-property', ''); 
//                    $e.css('-webkit-transition-property', '-webkit-transform'); 
                    $e.css('left',"0px");
                    $e.css("-webkit-transform", "translate3d("+ l +",0px,0px)");  
                } else {
                    $e.css('-webkit-transition-delay','0');
                    //$e.css('-webkit-transition-property', '-webkit-transform,left'); 
                    $e.css('-webkit-transition-property', ''); 
                    $e.css("-webkit-transform", "translate3d("+ l +",0px,0px)");  
                    $e.css('left',"0px");
                    
                    
                    setTimeout(function() {
                        $e.css('-webkit-transition-delay','0');
                        $e.css('-webkit-transition-property', '-webkit-transform');
                        $e.css("-webkit-transition-duration", (duration/1000).toFixed(1) + "s");
                        $e.css("-webkit-transform", "translate3d("+value +"px,0px,0px)");
                    }, 10);
                    done = true;
                    
                }
            }
            if(!done) {
                setTimeout(function() {
                    $e.css('-webkit-transition-delay','0');
                    $e.css('-webkit-transition-property', '-webkit-transform');
                    $e.css("-webkit-transition-duration", (duration/1000).toFixed(1) + "s");
                    $e.css("-webkit-transform", "translate3d("+value +"px,0px,0px)");
                }, 10);
            }
            if(duration > 0) {
                $e.unbind('webkitTransitionEnd.sp');
                $e.bind('webkitTransitionEnd.sp', function(event){
                    $e.unbind('webkitTransitionEnd.sp');
                   // console.log(event.originalEvent.propertyName);
                    if(event.originalEvent.propertyName == '-webkit-transform' && sim) {
                        var tx = methods.getTransformX($e);
                        //$e.css('-webkit-transition-property', '-webkit-transform'); 
                        $e.css('-webkit-transition-property', ''); 
                        $e.css('left',tx + 'px');
                  //      console.log(event.originalEvent.propertyName + ' value = ' + value + ' tx ' + tx + ' ' + $e.css('-webkit-transform'));
                        
                        $e.css('-webkit-transition-delay','0');
                        $e.css("-webkit-transition-duration", "0s");
                        $e.css("-webkit-transform", "translate3d(0px,0px,0px)");
                    }
                    if(swipeOptions.onSeek && !cancel) {
                        swipeOptions.onSeek(current_item, $(items.get(current_item)));
                    }
                });
            } else {
                if(swipeOptions.onSeek) {
                 //   swipeOptions.onSeek(current_item, $(items.get(current_item)));
                }
            }
        }       
    };

    $.fn.swipepage = function( method ) {

    if ( methods[method] ) {
      return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
    } else if ( typeof method === 'object' || ! method ) {
      return methods.init.apply( this, arguments );
    } else {
      $.error( 'Method ' +  method + ' does not exist on jQuery.crsa' );
    }    

    };

})( jQuery );