var PgPanelInputControl = function ($container, fn, title) {
    var $panelGroup = $('<div class="panel-group crsa-panel-group" role="tablist" id="' + fn + '-accordion" aria-multiselectable="true"></div>').appendTo($container);
    var $content = $('<div class="' + fn + '"></div>').appendTo($container);

    var _this = this;

    $panelGroup.data('last-id', 0);

    this.$container = $container;

    this.clear = function () {
        $panelGroup.html('').data('last-id', 0);
    }

    this.getPanelGroup = function () {
        return $panelGroup;
    }

    //BS Collapse doesn't work with multiple windows, have to implement the feature manually, using same BS classes

    this.addPanel = function (shadowIndex, titleIndex, skipCallingOnAdd) {
        var $panel = $('<div class="panel panel-default ' + fn + '-panel"></div>').appendTo($panelGroup);
        $panel.data('index', shadowIndex);

        //disable bs default collapse, keeping attr in for clarity sake, doesn't do anything
        var $header = $('<div class="panel-heading"> <h4 class="panel-title"> <a href="#collapse-' + fn + '-' + shadowIndex + '" data-toggle-disable="collapse" data-parent="#' + fn + '-accordion" class="pg-collapse collapsed">' + title + ' <span class="title-number">' + titleIndex + '</span> <i class="icon-right closed"></i> <i class="icon-down opened"></i> </a> </h4> </div>').appendTo($panel);

        var $collapse = $header.find('a.pg-collapse');

        var $delete = $('<a href="#"><i class="icon-bin"></i></a>').appendTo($header.find('> h4'));
        var $content = $('<div class="panel-collapse collapse" id="collapse-' + fn + '-' + shadowIndex + '"></div>').appendTo($panel);
        var $body = $('<div class="panel-body"></div>').appendTo($content);

        //$content.collapse();

        if (typeof this.onAdd === "function" && !skipCallingOnAdd) {
            this.onAdd($body, shadowIndex);
        }

        $collapse.on('click', function(e) {
            e.preventDefault();
            var just_hidden = false;
            var $my_panel = $container.find(this.getAttribute('href'));

            //close all other panels
            var collapse_in = $container.find('.collapse.in');
            collapse_in.each(function (i, p) {
                var $p = $(p);
                $p.collapse('hide');
                collapseToggled($p, false);
                if (p == $my_panel.get(0)) {
                    just_hidden = true;
                }
            });
            if (!just_hidden) {
                $my_panel.collapse('show');
                collapseToggled($my_panel, true);
            }
        })

        $delete.on('click', function (e) {
            e.preventDefault();
            var $shadowPanel = $(this).closest('.' + fn + '-panel');
            var obj = $shadowPanel.closest('.panel-group').data('obj');
            var index = $shadowPanel.data('index');
            if (typeof _this.onDelete === "function") {
                _this.onDelete(index);
            }
            var $shadowPanelCon = $shadowPanel.parent();
            $shadowPanel.remove();

            $shadowPanelCon.children().each(function (i, el) {
                var $el = $(el);
                var $titleLink = $el.find('> .panel-heading > .panel-title > a');
                $titleLink.find('> .title-number').html(i + 1);
            });
        });

        return {
            $panel: $panel,
            $header: $header,
            $body: $body,
            $collapse_link: $collapse
        };
    }

    var collapseToggled = function ($panel, show) {
        var $panelHeading = $panel.siblings('.panel-heading');
        var $pgCollapse = $panelHeading.find('.pg-collapse');
        if (show) {
            $pgCollapse.addClass('in');
        }
        else {
            $pgCollapse.removeClass('in');
        }
    }
}