var PgCSSActiveRulesCombinedView = function () {

    var _this = this;

    pinegrow.activeCSSView = this;

    var $element = $('<div class="pg-css-active-rules-view"></div>');

    //3 modes for rules:
    //- Active rules
    //- CSS stylesheet rules
    //- CSS stylesheet code

    var activeCs = null; //if set then mode 2 and 3

    var css_api = new PgCSSApi();

    //Search
    var search = new PgSearchBox({
        placeholder: 'search',
        placeholder_active: null,
        toolbar_on: true,
        delay: true
    });
    /*
        search.addIcon({
            icon: '<i class="icon icon-Prepend"><span class="path1"></span><span class="path2"></span></i>',
            label: 'Append to the selected element(s).',
            position: 'append',
            func: function(item) {
                var qs = PgQuickStylesheets(item.$element, _this);
            }
        })
    */

    if(!pgf.kids) {
        search.$element.appendTo($element);
    }

    search.onSearch = function(f) {
        if(activeCs && stylesheetView) {
            stylesheetView.search(f);
        } else {
            pinegrow.showQuickMessage('Search is not available in ACTIVE tab.', 4000, true);
            //showCssActiveRules(current_pgel, selectedRule, f);
        }
        current_search_term = f;
    }

    var spacer = new PgSearchBoxSpacer();
    spacer.$element.appendTo($element);

    var tabsToolbar = new PgButtonToolbar();

    if(!pgf.kids) {
        $element.append(tabsToolbar.$element.addClass('pg-tabs-toolbar'));
    }

    var sheetTabs = new PgToolbarTabButtons(tabsToolbar, 'tabs');

    var activeRulesTab = sheetTabs.addTab('Active', 'Active rules for the selected element', null, true);

    activeRulesTab.$element.addClass('pg-selected-top-border without-close');

    var tabsInfo = new WeakMap();

    sheetTabs.onTabSelected = function(tab) {
        activeCs = tab.data;
        if(activeCs) {
            _this.showStylesheet(activeCs);
        } else {
            destroyStylesheetView();

            showCssActiveRules(current_pgel, selectedRule, current_search_term);
        }
    }

    sheetTabs.onTabClosed = function(tab) {
        var cs = tab.data;
        if(cs && csViews.has(cs)) {
            var v = csViews.get(cs);
            v.view.destroy();
            if(stylesheetView == v) stylesheetView = null;
            csViews.delete(cs);
            csTabs.delete(cs);
        }
    }

    tabsToolbar.addSection('icons');

    pg$Hide(search.$element);
    pg$Hide(spacer.$element);

    var sheets = new PgButtonToolbarItem('<span>Stylesheets</span><i class="icon icon-Pin10"></i><i class="icon icon-down"></i>', 'Show stylesheets...');


    var sheetsWithDropdown = new PgButtonToolbarItemWithDropdownView('<span>Stylesheets</span><!-- <i class="icon icon-Pin10"></i> --><i class="icon icon-down"></i>', 'Show and manage the list of available stylesheets...');


    sheetsWithDropdown.toolbarItem.$element.addClass('stylesheets');

    //tabsToolbar.addItem('icons', sheets);

    if(!pgf.kids) {
        tabsToolbar.addItem('icons', sheetsWithDropdown.toolbarItem);
    }

    sheetsWithDropdown.onGetView = function() {
        var sv = new PgStylesheetsView();
        sv.parentView = _this;
        return sv;
    }

    sheets.onClick = function() {
        var qs = PgQuickStylesheets(this.$element, _this);
    }

    var searchIcon = new PgButtonToolbarItem('icon-search', 'Show / hide search');

    if(!pgf.kids) {
        tabsToolbar.addItem('icons', searchIcon);
    }

    searchIcon.onClick = function() {
        var show = !this.getActive();
        this.setActive(show);
        if(show) {
            pg$Show(search.$element);
            pg$Show(spacer.$element);
            search.focus();
            $main.addClass('has-search');
        } else {
            pg$Hide(search.$element);
            pg$Hide(spacer.$element);
            $main.removeClass('has-search');
        }
        box.update();
    }


    this.show = function(pgel, term) {
        if(pgel) current_pgel = pgel;
        if(activeCs) {
            current_search_term = term;
            this.setActiveCs(null);
        } else {
            search.setValue(term);
        }
    }

    ///End search

    //Stylesheets dropdown
    /*
    var sheetsButton = new PgBoxWithButton('icon-duplicate', 'Stylesheets', function() {
        var view = new PgStylesheetsView();
        view.parentView = _this;
        view.show();
        return view.view;
    }, 'Show stylesheets');

    search.getToolbar().addItem('icons', sheetsButton.getButton());
    */
    //end

    var $main = $('<div class="pg-css-active-rules-combined"></div>').appendTo($element);

    if(pgf.kids) {
        $main.css('top', '-5px');
    }

    var $rules = $('<div class="pg-rules-container"></div>').appendTo($main);

    var rulesNotice = new PgPanelNotice();
    rulesNotice.$element.appendTo($rules);

    var $gui_container = $('<div class="pg-css-gui-container"><h1><span class="text">Visual Editor</span><span class="handle"><i class="icon icon225 icon-drag-vert-x225"></i></span><i class="icon icon-ddown hide-gui"></i><i class="icon icon-dup show-gui"></i></h1></div>').appendTo($main);

    var $gui = $('<div class="crsa-stylesheets crsa-css-gui"></div>').appendTo($gui_container);

    var $resizer = $gui_container.find('> h1');

    if(pgf.kids) {
        $resizer.find('.hide-gui,.show-gui').detach();
    }

    $resizer.find('.hide-gui').on('click', function(e) {
        e.preventDefault();
        hideGui();
        return false;
    })

    var view = new PgUIView($element, 'style', 'Style');

    view.tabIcon = 'icon-Pin15';

    var box = new PgComboDividerBox($resizer, view);

    var stylesheetView = null;

    var destroyStylesheetView = function() {
        if (stylesheetView) {
            stylesheetView.quitCodeMode();
            stylesheetView.view.get$Element().detach();
        }

        //$cmRules.detach();
        $rules.find('> *').not('.alert').remove();

        if (pgCSSActiveRulesEditor && pgCSSActiveRulesEditor.ready) {
            pgCSSActiveRulesEditor.remove();
            pgCSSActiveRulesEditor = null;
        }

        if(checkIfRulesChangedTimer) {
            clearTimeout(checkIfRulesChangedTimer);
            checkIfRulesChangedTimer = null;
        }
    }


    var csViews = new Map();
    var csTabs = new Map();

    var onStylesheetClosed = function(pagenull, cs) {
        if(csTabs.has(cs)) {
            sheetTabs.removeTab(csTabs.get(cs)); //will call onTabClosed
            csTabs.delete(cs);
        }
    }

    this.setActiveCs = function(cs) {
        if(cs) {
            if(!csTabs.has(cs)) {
                csTabs.set(cs, sheetTabs.addTab(cs.name, 'Edit stylesheet ' + cs.name, cs, true));
            } else {
                sheetTabs.selectTab(csTabs.get(cs));
            }
            rulesNotice.show(null);
        } else {
            sheetTabs.select(activeRulesTab);
        }
    }

    this.showCreateCssRule = function(selector) {
        if(activeCs) {
            this.setActiveCs(null);
        }
        if(pgCSSActiveRulesEditor) {
            pgCSSActiveRulesEditor.showCreateCssRule(selector);
        } else {
            this.showCreateCssRuleOnVisible = selector || true;
        }
    }

    this.updateRulesDisplayOnElementSelect = function(force_inline) {
        if(activeCs) {

        } else {
            var pgel_selected_css_rule = null;
            if(current_pgel) {
                var nodeid = current_pgel.getData('selectedCssRule');
                if(nodeid !== 'none') {
                    if (nodeid && !force_inline) {
                        if (!nodeid.csurl) {
                            pgel_selected_css_rule = 'inline';
                        } else {
                            pgel_selected_css_rule = pgcssh.getNodeFromGlobalId(nodeid);
                        }
                    }
                } else {
                    pgel_selected_css_rule = 'none';
                }
            }
            if(force_inline) {
                selectedRule = null;
            }
            showCssActiveRules(current_pgel, selectedRule, current_search_term, pgel_selected_css_rule);
        }
    }

    this.showStylesheet = function(cs) {

        // $rules.empty();
        destroyStylesheetView();
        /* if(stylesheetView) {
             stylesheetView.view.get$Element().detach();
         }*/

        if(!csViews.has(cs)) {
            stylesheetView = new PgCSSRulesView(cs);
            stylesheetView.view.alwaysVisible = true;
            stylesheetView.view.updateVisibility();

            stylesheetView.parentView = this;

            stylesheetView.show(current_search_term);
            csViews.set(cs, stylesheetView);
        } else {
            stylesheetView = csViews.get(cs);
            stylesheetView.researchIfNeeded(current_search_term);
        }
        stylesheetView.view.get$Element().appendTo($rules);
        stylesheetView.onRulesShow(); // update the view after inserting container
    }

    //Do Active rules
    var pgCSSActiveRulesEditor = null;

    this.view = view;

    var current_pgel = null;
    var current_search_term = null;

    var prev_selected_pgel = null;

    var showCssActiveRules = function (selectedElement, sel_rule, search_term, pgel_selected_css_rule, force_active_refresh) {
        if(checkIfRulesChangedTimer) {
            clearTimeout(checkIfRulesChangedTimer);
            checkIfRulesChangedTimer = null;
        }

        selectedElement = selectedElement || pinegrow.getSelectedElement();

        var scrollTop = 0;

        if(prev_selected_pgel === selectedElement) {
            var $list = $rules.find('.rules-list');
            scrollTop = $list.scrollTop();
        }
        prev_selected_pgel = selectedElement;
        current_pgel = selectedElement;
        current_search_term = search_term;



        var create_new = true;
        if (pgCSSActiveRulesEditor && pgCSSActiveRulesEditor.ready) {
            if (pgCSSActiveRulesEditor.getSelectedElement() == selectedElement) {
                create_new = false;
            }
        }

        if (create_new && pgCSSActiveRulesEditor) pgCSSActiveRulesEditor.remove();

        if(!activeCs) {
            var rules_list = null;
            if (false && search_term && current_pgel) {//disable aearch in active
                var p = new CrsaProfile();
                rules_list = current_pgel.getPage().activeView.findCSSRules(search_term);
                p.show('SEARCH CSS RULES');

                var max = 20;

                if (rules_list.length > max) {
                    pinegrow.showQuickMessage('Only the first ' + max + ' matches out of ' + rules_list.length + ' shown.');
                    rules_list.splice(max, rules_list.length - max);
                }
                /*
                 var list = [];
                 for(var idx = 0; idx < rules_list.length; idx++) {
                 var rule = rules_list[idx];
                 var sel = rule.selectorText.replace(/,\s\.pg-node-id-[0-9]+/, '');
                 var sa = SPECIFICITY.calculate(sel);
                 var max = [0,0,0,0];
                 for(var i = 0; i < sa.length; i++) {
                 if(SPECIFICITY.compare(sa[i].specificityArray, max) > 0) {
                 max = sa[i].specificityArray;
                 }
                 }
                 list.push({s: max, rule: rule, idx: idx});
                 }

                 list.sort(function(a, b) {
                 var c = SPECIFICITY.compare(a.s, b.s);
                 if(c == 0) {
                 return a.idx - b.idx;
                 } else {
                 return c;
                 }
                 })

                 rules_list = list.map(function(d) {
                 return d.rule;
                 })*/
            }

            $rules.find('> .crsa-cm-rules').remove();

            if(selectedElement && pinegrow.getSelectedPage()) {
                rulesNotice.show();

                var $cmRules = $('<div class="crsa-cm-rules"></div>').appendTo($rules);

                if (pgCSSActiveRulesEditor) pgCSSActiveRulesEditor.remove();
                pgCSSActiveRulesEditor = new PgCSSActiveRulesEditor(selectedElement, $cmRules);
                pgCSSActiveRulesEditor.parentView = _this;
                if (pgCSSActiveRulesEditor.ready) {
                    force_active_refresh && pgCSSActiveRulesEditor.setActiveOutDated();
                    pgCSSActiveRulesEditor.show(sel_rule, rules_list /* always null */, pgel_selected_css_rule);
                    if(_this.showCreateCssRuleOnVisible) {
                        pgCSSActiveRulesEditor.showCreateCssRule(_this.showCreateCssRuleOnVisible === true ? '' : _this.showCreateCssRuleOnVisible);
                        _this.showCreateCssRuleOnVisible = null;
                    }
                }

                var $list = $rules.find('.rules-list');
                if(scrollTop !== 0) {
                    $list.scrollTop(scrollTop);
                } else {
                    var $sel = $rules.find('.pg-selected-rule > div');
                    if($sel.length) {
                        pgScrollToItemInContainer($sel, $list, false, false);
                        //$sel.get(0).scrollIntoViewIfNeeded(); this function doesn't exist
                    }
                }


            } else {
                rulesNotice.show('Element is not selected.');

                if (pgCSSActiveRulesEditor && pgCSSActiveRulesEditor.ready) {
                    pgCSSActiveRulesEditor.remove();
                    pgCSSActiveRulesEditor = null;
                }
            }
        } else {
            _this.showStylesheet(activeCs);
        }
    }

    this.openCreateNewRuleDialog = function(selector, media, stylesheet, select_class) {
        this.view.whenVisible(function() {
            if(!pgCSSActiveRulesEditor) {
                pinegrow.showQuickMessage('Element is not selected.');
            } else {
                pgCSSActiveRulesEditor.openCreateNewRuleDialog(selector, media, stylesheet, select_class);
            }
        }, 'showNewRuleDialog', 1)
    }

    //Do GUI

    var pgGUICSSEditor = null;
    var selectedRule = null;

    var showCssGui = function (rule, options) {
        var obj = {
            indices: pinegrow.getSelectedRuleIndices(),
            pgStylesheet: pinegrow.getSelectedRuleStylesheet()
        }

        if (!pgGUICSSEditor) {
            pgGUICSSEditor = new PgCSSEditorNEW($gui);
        }
        pgGUICSSEditor.editRule(obj, options);
        pgGUICSSEditor.hideNoRuleNotice();
    }

    var selectSameRule = function () {
        var selectedRule = pinegrow.getSelectedRule();
        $('body').trigger('crsa-rule-selected', { rule: selectedRule });
    }

    view.on('crsa-rule-selected', function(event, obj) {
        view.whenVisible(function() {
            if (obj) {
                showCssGui(obj.rule, obj.options);
                selectedRule = obj.rule;
            }
            else {
                selectSameRule();
            }
        })
    });

    var undo_update_timer = null;

    var onNodeAddedOrUpdated = function (obj, deleted) {
        view.whenVisible(function () {
            if (obj.edited_by != 'gui') {

                var node = obj.node;
                var selectedRule = pinegrow.getSelectedRule();

                if (undo_update_timer) {
                    clearTimeout(undo_update_timer);
                    undo_update_timer = null;
                }

                if (selectedRule && pinegrow.pgPostCSSHelper.isNodeEqualOrChildOf(selectedRule, node)) {

                    var show = function () {
                        undo_update_timer = null;
                        var node = obj.node;
                        if (node.type == "rule" && !deleted) {

                            var rule = pinegrow.pgPostCSSHelper.getRuleForNode(node);
                            showCssGui(rule);
                        }
                        else {
                            if (pinegrow.isSelectedRule(node.parent)) {
                                selectSameRule();
                            }
                        }
                    }

                    if (obj.edited_by == 'undo') {
                        //lets delay a bit, maybe another undo event happens soon
                        undo_update_timer = setTimeout(show, 100);
                    } else {
                        show();
                    }
                }
            }
        })
    }

    var onDeviceSizeChanged = function(page, def) {
        /*
                1. find the current rule, take the selector
                2. get the mq for the rule
                3. look for the rule in that mq
                4. if found, select the rule
                5. if not found?
                 */
        var prev_rule = pinegrow.getSelectedRule();
        if(prev_rule) {
            var cs = pgcssh.getStylesheetForNode(prev_rule);

            var selector = prev_rule.selector;

            var getRule = function(create) {
                var pgel = pinegrow.selectedElements.getLastSelected();

                cs && css_api.getRuleForMediaSize(cs, selector, def.w_range[0] === 0 ? null : (def.w_range[0]), function(rule) {
                    if(rule) {
                        if(page.activeView.deviceWidth < def.w_range[0]) {
                            //this size is not displayed on this size
                            var size_name = def.name_short || def.name;

                            pgel && pgel.setData('selectedCssRule', 'none');
                            pgGUICSSEditor.showNoRuleNotice(selector, size_name, function() {
                                pgel && pgel.setData('selectedCssRule', null);

                                var pv = page.view.setActiveViewSizeWithDef(def);
                                page.view.setActiveView(pv);
                                pinegrow.selectRule(rule);

                            }, 'rule_not_visible')
                        } else {
                            pinegrow.selectRule(rule);
                        }
                    } else {
                        //does not exist yet
                        if(pgGUICSSEditor) {
                            var size_name = def.name_short || def.name;
                            if(def.w_range) {
                                size_name += ` - ${def.w_range[0]}px and above`;
                            }
                            pgel && pgel.setData('selectedCssRule', 'none');
                            pgGUICSSEditor.showNoRuleNotice(selector, size_name, function() {
                                pgel && pgel.setData('selectedCssRule', null);
                                getRule(true);
                            })
                        }
                    }
                }, create);
            }

            getRule();
        }
    }

    pinegrow.addEventHandler('on_current_device_size_changed', onDeviceSizeChanged)


    pinegrow.addEventHandler('on_css_rule_selected_in_active', function (page, node, $li) {
        if(current_pgel && node) {
            //remember last node selected for this pgel
            current_pgel.setData('selectedCssRule', pgcssh.getGlobalNodeId(node));
        }
    });

    pinegrow.addEventHandler('on_css_node_deleted', function (page, obj) {
        onNodeAddedOrUpdated(obj, true);
    });

    pinegrow.addEventHandler('on_css_node_updated', function (page, obj) {
        onNodeAddedOrUpdated(obj);
    });

    pinegrow.addEventHandler('on_css_node_added', function (page, obj) {
        onNodeAddedOrUpdated(obj);
    });

    //Common

    var resizeTaskKey = 'cssActiveComboResize';

    view.onResize = function() {
        //showCssGui(null);

        var task = view.getFastdomTasks().createDummy(resizeTaskKey);

        task.measure(function() {
            var w = $element.width();
            var h = $element.height();
            var rules_h = $rules.height();

            var css_w, css_h;

            task.mutate(function() {

                if (w > 500) {
                    var rw = 200;
                    var cw = 300;//320;
                    var cols = Math.max(1, Math.floor((w - rw) / cw));

                    var rsw = w - (cols * cw);


                    css_w = w - rsw;
                    css_h = h;

                    $main.addClass('horizontal');
                    if (!gui_open) {
                        //css_w = w;
                        //rsw = w;
                        $main.removeClass('gui-hidden');
                        pg$Show($gui);
                    }
                    $rules.css({
                        'min-width': rsw,
                        'max-width': rsw
                    })
                    //box.hide();
                } else {
                    $rules.css({
                        'min-width': '',
                        'max-width': ''
                    })
                    $main.removeClass('horizontal');
                    if (!gui_open) {
                        $main.addClass('gui-hidden');
                        pg$Hide($gui);
                    }

                    css_w = w;
                    css_h = h - rules_h;

                    box.show();
                }

                if (pgCSSActiveRulesEditor && pgCSSActiveRulesEditor.ready) {
                    pgCSSActiveRulesEditor.updateLayout();
                }

                if (pgGUICSSEditor) {
                    pgGUICSSEditor.updateLayout(css_w, css_h);
                }

                box.update(true);
            })
        })
    }

    var onSelectedElementsChanged = function(page, info) {
        view.whenVisible(function() {
            current_pgel = pinegrow.selectedElements.getLastSelected();
            _this.updateRulesDisplayOnElementSelect();
            if (!pinegrow.getSelectedRule() || !current_pgel) showCssGui();
        })
    }

    var onHideGUIOnNoElementSelected = function() {
        view.whenVisible(function() {
            //we need this to catch the unselecting element in order to disable gui editor
            var pgel = pinegrow.selectedElements.getLastSelected();
            if(!pgel) showCssGui();
        })
    }

    this.refreshCurrentDisplay = function(cs) {
        view.whenVisible(function() {
            _this.updateRulesDisplayOnElementSelect();
            if (!pinegrow.getSelectedRule()) showCssGui();
            if(cs) {
                var stylesheetView = csViews.get(cs);
                if (stylesheetView) {
                    stylesheetView.refresh();
                }
            }
        })

    }

    var checkIfRulesChangedTimer = null;

    // NOT USED
    var onPageChanged = function(page, pgel, info) {
        if(pgel == current_pgel && view.isVisible() && activeCs == null && pgCSSActiveRulesEditor && pgCSSActiveRulesEditor.ready) {

            if(checkIfRulesChangedTimer) {
                clearTimeout(checkIfRulesChangedTimer);
                checkIfRulesChangedTimer = true;
            }

            if(info && info.source && info.source == 'elementStyle') return;

            checkIfRulesChangedTimer = setTimeout(function() {
                checkIfRulesChangedTimer = null;
                try {
                    if (pgCSSActiveRulesEditor.didMatchedRulesChange()) {
                        showCssActiveRules(current_pgel, selectedRule, current_search_term);
                    }
                } catch(err) {}
            }, 200)
        }
    }

    var onElementClassesChanged = function(page, col, info) {
        view.whenVisible(function() {
            _this.updateRulesDisplayOnElementSelect();
            //if (!pinegrow.getSelectedRule() || !current_pgel) showCssGui();
        })
        return;

        if(view.isVisible() && activeCs == null && pgCSSActiveRulesEditor && pgCSSActiveRulesEditor.ready) {

            showCssActiveRules(current_pgel, selectedRule, current_search_term, null, true /* force active refresh */);
        }
    }

    var onStylesheetLockedChanged = function () {
        if(view.isVisible() && activeCs == null && pgCSSActiveRulesEditor && pgCSSActiveRulesEditor.ready) {
            showCssActiveRules(current_pgel, selectedRule, current_search_term, null, false /* force active refresh */);
        }
    }



    pinegrow.addEventHandler('on_undo_redo', onElementClassesChanged);
    //pinegrow.addEventHandler('on_element_classes_changed', onElementClassesChanged);
    pinegrow.addEventHandler('on_css_stylesheet_locked_changed', onStylesheetLockedChanged);


    // $('body').on('crsa-stylesheets-changed', onSelectedElementsChanged);
    //pinegrow.addEventHandler('on_selected_elements_changed', onHideGUIOnNoElementSelected);
    pinegrow.addEventHandler('on_css_active_rule_changed', onSelectedElementsChanged);

    //Adding this handler because the grid menu point for inline doesn't get cought here
    pinegrow.addEventHandler('on_css_attribute_style_changed', onSelectedElementsChanged);
    //Repaint the panel to bind input events to correct window
    pinegrow.addEventHandler('on_panel_moved_in_another_window', onSelectedElementsChanged);


    // pinegrow.addEventHandler('on_page_changed', onPageChanged); // NO dispatch for this event

    //force first show
    view.whenVisible(function() {
        onSelectedElementsChanged();
    })

    //will be auto-offed on destroy

    // pinegrow.addEventHandler('on_css_source_changed', function (p, obj) {
    //     view.whenVisible(function() {
    //         // TODO enhance this
    //         _this.updateRulesDisplayOnElementSelect();
    //         //showCssActiveRules();
    //     })
    // });

    // view.on('crsa-page-closed', function (event, obj) {
    //     view.whenVisible(function () {
    //         current_pgel = pinegrow.selectedElements.getLastSelected();
    //         _this.updateRulesDisplayOnElementSelect();
    //     })
    // })

    var onActivePageViewChanged = function(page, pv) {
        if(current_pgel && current_pgel.getPage() == page && page.activeView == pv) {
            view.whenVisible(function () {
                _this.updateRulesDisplayOnElementSelect();
            })
        }
    }

    // pinegrow.addEventHandler('on_active_page_view_changed', onActivePageViewChanged);
    // pinegrow.addEventHandler('on_page_view_resized', onActivePageViewChanged);
    pinegrow.addEventHandler('on_stylesheet_closed', onStylesheetClosed);
    pinegrow.addEventHandler('on_stylesheet_unloaded', onStylesheetClosed);
    pinegrow.addEventHandler('on_stylesheet_suspended', onStylesheetClosed);

    view.onDestroy = function() {
        //pinegrow.removeEventHandler('on_selected_elements_changed', onHideGUIOnNoElementSelected);
        pinegrow.removeEventHandler('on_css_active_rule_changed', onSelectedElementsChanged);
        pinegrow.removeEventHandler('on_css_attribute_style_changed', onSelectedElementsChanged);
        pinegrow.removeEventHandler('on_panel_moved_in_another_window', onSelectedElementsChanged);

        // pinegrow.removeEventHandler('on_page_changed', onPageChanged); // NO dispatch for this event
        // pinegrow.removeEventHandler('on_active_page_view_changed', onActivePageViewChanged);
        // pinegrow.removeEventHandler('on_page_view_resized', onActivePageViewChanged);
        pinegrow.removeEventHandler('on_stylesheet_closed', onStylesheetClosed);
        pinegrow.removeEventHandler('on_stylesheet_unloaded', onStylesheetClosed);
        pinegrow.removeEventHandler('on_stylesheet_suspended', onStylesheetClosed);

        pinegrow.removeEventHandler('on_undo_redo', onElementClassesChanged);
        //pinegrow.removeEventHandler('on_element_classes_changed', onElementClassesChanged);
        pinegrow.removeEventHandler('on_css_stylesheet_locked_changed', onStylesheetLockedChanged);

        pinegrow.removeEventHandler('on_current_device_size_changed', onDeviceSizeChanged)

        search.destroy();
        if(pinegrow.activeCSSView == this) pinegrow.activeCSSView = null;

        if(undo_update_timer) {
            clearTimeout(undo_update_timer);
            undo_update_timer = null;
        }

        pgFastdom.stopAll(resizeTaskKey);
    }

    ///Resizer

    var gui_open = pinegrow.getSetting('acss-gui-open', "1") === "1";

    var hideGui = function() {
        $main.addClass('gui-hidden');
        pg$Hide($gui);
        pinegrow.setSetting('acss-gui-open', "0");
        gui_open = false;
        box.update();
    }

    var showGui = function() {
        $main.removeClass('gui-hidden');
        pg$Show($gui, 'flex');
        view.onResize();
        pinegrow.setSetting('acss-gui-open', "1");
        gui_open = true;
        box.update();
    }

    var percent = parseFloat(pinegrow.getSetting('css-gui-size-2', "37"));

    var setGuiSize = function(p) {
        if(p > 90) p = 90;
        $rules.css({
            'min-height': p + '%',
            'max-height': p + '%'
        })
        box.update();
    }

    setGuiSize(percent);

    if(!gui_open) {
        hideGui();
    }

    $resizer.on('click', function(e) {
        e.preventDefault();
        if(in_resize || pgf.kids) return;
        gui_open = !gui_open;
        if(gui_open) {
            showGui();
        } else {
            hideGui();
        }
        view.onResize();
    })

    var drag_resize = new GoldenLayout.__lm.utils.DragListener($resizer.find('.handle'), 0, false);

    var resize_original_y = 0;
    var in_resize = false;
    var parent_h = 0;

    drag_resize.on( 'dragStart', function(x, y) {
        resize_original_y = $rules.outerHeight();
        parent_h = $rules.parent().height();
        in_resize = true;

        $.fn.crsapages('showOverlays');
    }, this );

    drag_resize.on( 'drag', function(x, y, event) {

        var h = Math.max(0, resize_original_y + y);
        percent = (h / parent_h) * 100;
        setGuiSize(percent);

    }, this );

    drag_resize.on( 'dragStop', function(x, y) {
        $.fn.crsapages('showOverlays', true);
        setTimeout(function() {
            in_resize = false;
        }, 100)

        pinegrow.setSetting('css-gui-size-2', percent);
    }, this );
}
