var PgCssGuiView = function() {
    var $element = $('<div id="crsa-css-gui" class="aacrsa-panel crsa-stylesheets crsa-css-gui"></div>');
    var pgGUICSSEditor = null;

    var view = new PgUIView($element);
    var selectedRule = null;

    this.view = view;

    var showCssGui = function (rule_obj, options) {
        rule_obj = rule_obj || pinegrow.getSelectedRule();

        if(!pgGUICSSEditor) {
            pgGUICSSEditor = new PgCSSEditorNEW($element);
        }
        pgGUICSSEditor.editRule(rule_obj, options);
    }

    var selectSameRule = function () {
        var selectedRule = pinegrow.getSelectedRule();
        if (!selectedRule) return;

        var pgStylesheet = pinegrow.pgPostCSSHelper.getRootNodeFor(selectedRule.data).pgStylesheet;
        var nodeIndices = pinegrow.pgPostCSSHelper.getNodeIndices(selectedRule.data);
        var newRule = pinegrow.pgPostCSSHelper.getNodeByIndices(pgStylesheet.getRootNode(), nodeIndices);
        var rule_obj = getObjectFromRule(newRule);
        $('body').trigger('crsa-rule-selected', { rule_obj: rule_obj });     ///Wrong param???
    }

    view.on('crsa-rule-selected', function(event, obj) {
        view.whenVisible(function() {
            if (obj) {
                showCssGui(obj.rule_obj, {clickedProp: obj.clickedProp || null});
                selectedRule = obj.rule_obj;
            }
            else {
                selectSameRule();
            }
        })
    });

    view.onResize = function() {
        if(pgGUICSSEditor) {
            pgGUICSSEditor.updateLayout();
        }
    }


    pinegrow.addEventHandler('on_css_node_updated', function (page, obj) {
        view.whenVisible(function () {
            if (obj.edited_by != 'gui') {
                var node = obj.node;
                if (node.type == "rule") {
                    var rule = pinegrow.pgPostCSSHelper.getRuleForNode(node);
                    var rule_obj = getObjectFromRule(rule);
                    showCssGui(rule_obj);
                }
                else if (node.type == "atrule" && node.name == "media") {
                    selectSameRule();
                }
            }
        })
    });
}