
var PgMediaQueryHelperView = function($input, page, in_control, keep_open) {

    var $el = $input;

    $input.attr('placeholder', 'Select or enter a media query');

    var _this = this;

    this.keep_list_open = keep_open === undefined ? false : keep_open;
    this.breakpoints = page.breakpoints;

    var getPage = function() {
        page = pinegrow.getSelectedPage();
        return page;
    }

    var getBreakpoints = function() {
        page = getPage();
        return page ? page.breakpoints : [];
    }

    var original = $.trim($el.val());

    var original_just_rule = '';
    var has_only = localStorage.mediaToolOnly ? true : false;
    var type = localStorage.mediaToolType ? localStorage.mediaToolType : null;
    var strange = true;

    this.getMediaQuery = function() {
        return $input.val();
    }

    var getQueryInfo = function(original) {
        var i = {
            type: null,
            only: false,
            strange: true,
            query: original,
            rule: '',
            button: null
        }
        if(original == 'noquery') {
            i.button = getQueryButtonForMediaQuery(original);
        } else {
            var idx = original.indexOf('(');
            if (idx >= 0) {
                var original_just_rule = original.substr(idx);
                if (original.indexOf('only ') >= 0) {
                    i.only = true;
                    original_just_rule = original_just_rule.replace('only ', '');
                }
                $.each(['screen', 'print'], function (ii, t) {
                    if (original.indexOf(t) >= 0) {
                        i.type = t;
                        original_just_rule = original_just_rule.replace(t, '');
                    }
                });
                // i.rule = original_just_rule.replace(/\s\s+/g, ' ');
                i.rule = original_just_rule.replace(/\s/g, '');
                i.strange = false;
                i.button = getQueryButtonForMediaQuery(i.rule);
            } else {
                i.rule = original;
            }
        }
        return i;
    }


    var done = false;

    var s = '';

    var triggerTimeout = null;

    var triggerChange = function($el) {
        if(triggerTimeout) {
            clearTimeout(triggerTimeout);
        }
        triggerTimeout = setTimeout(function() {
            //$el.focus();
            $el.trigger('change');
            triggerTimeout = null;
        }, 50);
    }

    var form = '<form role="form" class="form-inline">\
            <div class="form-group" style="margin-right:10px;">\
            <label class="control-label sr-only" for="formInput1">Field label</label>\
            <select class="form-control input-sm">\
            <option></option>\
            <option>screen</option>\
            <option>print</option>\
        </select>\
        </div>\
            <div class="checkbox">\
                <label class="control-label">\
                    <input type="checkbox" class="ignore"> Ignore in old browsers</label>\
                </div>\
            </form>';

    var $c = $('<div class="media-tool"><ul class="media-list">' + s + '</ul><div class="media-tool-footer"><div class="checkbox">\
                <label class="control-label">\
                    <input type="checkbox" class="ignore"> ' + (in_control ? 'Ignore in old' : 'Ignore in old browsers') + '</label>\
                </div><a href="#" class="manage">' + (in_control ? 'Manage&hellip;' : 'Manage breakpoints&hellip;') + '</a></div></div>');

    var $element = $c;

    var element_display = 'block';

    var $only = $element.find('input.ignore');

    var $selected = $('<div class="media-tool-selected crsa-field">' + (in_control ? '' : '<label>Media query</label>') + '<ul class="media-list"></ul><i class="icon icon-close"></i></div>').insertAfter($input.closest('.crsa-field'));

    var $inputContainer = $input.closest('.crsa-field');

    var input_container_display = $inputContainer.get(0).style.display || 'flex';

    var $footer = $element.find('.media-tool-footer');

    var type_input = new PgInputField('querytype', {
        type: 'select',
        show_empty: true,
        name: 'Type',
        without_text: true,
        default_value: localStorage.mediaToolType || null,
        options: [
            {key: 'screen', name: 'screen'},
            {key: 'print', name: 'print'}
        ]
    });

    type_input.prependTo($footer);

    type_input.on('input', function(e) {

    })


    var $select = type_input.$input;



    var $ul = $element.find('ul');

    if(in_control) {
        $ul.addClass('narrow');
    }

    var query_to_button = {};

    var getQueryKey = function(q) {
        return q.replace(/[\s\"]/g, '');
    }

    var getQueryButtonForMediaQuery = function(mq) {
        return query_to_button[getQueryKey(mq)] || null;
    }

    var createQueryButtons = function() {
        query_to_button = {};

        var s = '';

        var makeNoQueryButton = function() {
            b = '<li class="pg-button media-query submedia-last" data-media="noquery" title="No media query - show on all sizes."><i class="icon icon-see"></i><span class="including">' + (in_control ? 'None' : 'No media query') + '</span></li>';
            query_to_button['noquery'] = b;
            return b;
        }

        if(getBreakpoints().length) {
            _this.breakpoints = getBreakpoints();

            for(var i = 0; i < _this.breakpoints.length; i++) {

                var cv = crsaSplitCSSValue(_this.breakpoints[i]);
                var x = cv.value;
                var cvdown = crsaOneUpCSSValue(cv, -1); //one down

                var mq = '(max-width:' + (cvdown.value) + cv.unit + ')';
                var tip = 'smaller than ' + x + ' ' + cv.unit;
                var key = getQueryKey(mq);
                var b = '<li data-key="' + key + '" class="pg-button media-query" data-media="' + mq + '" title="' + tip + '"><i class="icon icon-see"></i><span class="line"></span><span class="excluding">' + x + '</span></li>';
                query_to_button[key] = b;
                s += b;

                mq = '(min-width:' + (x) + cv.unit + ')';
                key = getQueryKey(mq);
                tip = x + ' ' + cv.unit + ' and up';
                b = '<li data-key="' + key + '" class="pg-button media-query" data-media="' + mq + '" title="' + tip + '"><i class="icon icon-see"></i><span class="including">' + x + '</span><span class="line"></span></li>';
                query_to_button[key] = b;
                s += b;

                if(i < _this.breakpoints.length -1) {

                    var ncv = crsaSplitCSSValue(_this.breakpoints[i+1]);
                    var nx = ncv.value;
                    var ncvdown = crsaOneUpCSSValue(ncv, -1); //one down

                    mq = '(min-width:' + (x) + cv.unit + ') and (max-width:' + (ncvdown.value) + cv.unit + ')';
                    key = getQueryKey(mq);
                    tip = 'from ' + x + ' ' + cv.unit + ' to ' + (ncv.value) + ' ' + cv.unit;
                    b = '<li data-key="' + key + '" class="pg-button media-query submedia-last" data-media="' + mq + '" title="' + tip + '"><i class="icon icon-see"></i><span class="including">' + x + '</span><span class="line"></span><span class="excluding">' + (nx) + '</span></li>';
                    query_to_button[key] = b;
                    s += b;
                } else {

                    s += makeNoQueryButton();
                }
            }
        } else {
            s += makeNoQueryButton();
            s += '<li class="no-breakpoints">No breakpoints are defined. Use &quot;<a href="#" class="manage">Manage breakpoints</a>&quot; to define them.</li>';
        }
        $ul.html(s);
        addTooltip($ul.find('li'));
    }

    createQueryButtons();

    var selected_query_info = null;

    var constructFullQuery = function(q) {
        var s = $select.val();
        var has_and = false;
        if(s) {
            if(q.length) {
                q = s + ' and ' + q;
                has_and = true;
            } else {
                q = s;
            }
        }
        if($only.is(':checked')) {
            q = 'only ' + (!s ? 'screen and ' : '') + (!has_and ? '' : '') + q;
        }
        return q;
    }

    var selectQuery = function($li) {
        $ul.find('li.media-current').removeClass('media-current');
        if($li) {
            var q = $li.attr('data-media');
            if (q) {
                $li.addClass('media-current');
            }
        }
        else {
            selectNoQuery();
        }
    }

    var setSelected = function(button, mq) {
        var $ul = $selected.find('ul');
        $ul.empty();
        if(button) {
            var $b = $(button).addClass('media-current');
            var $tip = $('<li class="tip">' + (mq != 'noquery' ? $b.attr('title') : 'Click to select') + '</li>');
            $b.removeAttr('title');

            if(mq == 'noquery') {
                $b.removeClass('media-current');
                if(in_control) {
                    $b.text('Media query...');
                }
                pg$Hide($selected.find('i.icon-close'));//.hide();
            } else {
                pg$Show($selected.find('i.icon-close'), 'inline');//.show();
            }
            $ul.append($b);
            if(!_this.keep_list_open) {
                pg$Show($selected, 'flex');
                pg$Hide($inputContainer);
            }
            if(!in_control) {
                $ul.append($tip);
            }

        } else {
            pg$Hide($selected);//.hide();
            pg$Show($inputContainer, input_container_display);
        }
    }

    var onSourceChanged = function(original, input_event) {
        selected_query_info = null;

        var info = getQueryInfo(original);
        original_just_rule = info.rule;
        has_only = info.only;
        type = info.type;
        strange = info.strange;

        if (info.button) {
            var $li = $ul.find('li[data-key="' + getQueryKey(info.rule) + '"]');
            selectQuery($li);
            selected_query_info = info;
            if(!input_event) {
                setSelected(info.button);
            }
        } else if (!input_event) {
            selectQuery(null);
        }

        $only.prop('checked', info.only ? "checked" : false);
        $select.val(info.type);

    }

    //original = 'only screen and (min-width:768px)'; //test

    var selectNoQuery = function() {
        selectQuery($ul.find('li[data-media="noquery"]'));
        selected_query_info = getQueryInfo('noquery');
        setSelected(selected_query_info.button, 'noquery');
        pg$Hide($element);
    }

    if(original) {
        onSourceChanged(original);
        pg$Hide($element);
    } else {
        strange = false;
        selectNoQuery();
    }

    this.showFieldAndSelectors = function() {
        pg$Hide($selected);
        pg$Show($inputContainer, input_container_display);
        $input.get(0).focus();
        pg$Show($element, element_display);
    }

    $selected.on('click', 'li', function(e) {
        e.preventDefault();
        _this.showFieldAndSelectors();
    })

    $selected.on('click', 'i.icon-close', function(e) {
        e.preventDefault();
        selectNoQuery();
        $input.val('');
        triggerChange($input);
    })



    var cancel_blur = false;

    $input
        .on('blur', function(e) {
            return;
            setTimeout(function() {
                if(!cancel_blur) {
                    if(selected_query_info) {
                        pg$Show($selected, 'flex');
                        pg$hide($inputContainer);
                        pg$Hide($element);
                    }
                } else {
                    cancel_blur = false;
                }
            },250);
        })
        .on('focus', function(e) {
            //$element.show();
        })
        .on('input', function(e) {
            onSourceChanged($input.val(), true);
        })
        .on('changeaaa', function(e) {
            onSourceChanged($input.val());
        })



    if(strange) {
        $select.attr('disabled', 'disabled');
        $only.attr('disabled', 'disabled');
    } else {
        $select.val(type);
        if(has_only) {
            $only.attr('checked', 'checked');
        }
        $select.on('change', function(e) {
            $input.val(constructFullQuery(original_just_rule));
            localStorage.mediaToolType = $select.val();
        });
        $only.on('change', function(e) {
            $input.val(constructFullQuery(original_just_rule));
            localStorage.mediaToolOnly = $only.is(':checked') ? '1' : '0';
        });
    }



    var current = original_just_rule.replace(/\s/g, '');

    var updateVisibility = function() {
        var win = getPage().getWindow();
        $ul.find('li').each(function(i,e) {
            var $li = $(e);
            var q = $li.attr('data-media');
            if(q) {
                /*if(q.replace(/\s/g,'') == current) {
                    $li.addClass('media-current');
                } else {

                }*/
                if(win && (q.length == 0 || win.matchMedia(q).matches)) {
                    $li.addClass('media-match');
                } else {
                    $li.removeClass('media-match');
                }
            }
        });
        $ul.find('i.icon-see').tooltip('destroy');

        addTooltip($ul.find('i.icon-see:visible'), 'Matches current window size (' + getPage().activeView.deviceWidth + 'px).')
    }

    updateVisibility();

    $ul
       /* .on('mouseover', function(e) {
            if(!done) {
                var $e = $(e.delegateTarget);
                var q = $e.attr('data-media');
                if(q) {
                    apply(q);
                }
            }
        })
        .on('mouseout', function(e) {
            if(!done) {
                var q = $(e.delegateTarget).attr('data-media');
                if(q) {
                    if(strange) {
                        $el.val(original);
                        triggerChange($el);
                    } else {
                        apply(original_just_rule);
                    }
                }
            }
        })*/
        .on('click', 'li.media-query', function(e) {
            done = true;
            e.preventDefault();
            var $e = $(this);
            selectQuery($e);

            var mq = $e.attr('data-media');
            if(mq != 'noquery') {
                var q = constructFullQuery(mq);
                $input.val(q);
                selected_query_info = getQueryInfo(q);

                //var button = getQueryButtonForMediaQuery(q);
                setSelected(selected_query_info.button, mq);
            } else {
                selected_query_info = getQueryInfo(mq);
                setSelected(selected_query_info.button, mq);
                $input.val('');
            }
            if(!_this.keep_list_open) {
                pg$Hide($element);
            }
            triggerChange($input);

            cancel_blur = true;

            setTimeout(function() {
                cancel_blur = false;
            }, 100)
        });


    $element.find('.manage').on('click', function(e) {
        done = true;
        // TODO why we have to set value here
        // $el.val(original);
        // triggerChange($el);
        e.preventDefault();
        //ensureRemove($d);
        getPage().showManageBreakpoints();
    });

    var view = new PgUIView($element);

    this.view = view;

    if(this.keep_list_open) {
        this.showFieldAndSelectors();
    }

    var onActivePageViewChanged = function(apage, pv) {
        //update visible queries
        if(apage == page && page.activeView == pv) {
            updateVisibility();
        }
    }

    var onBreakpointsChanged = function () {
        createQueryButtons();
    }


    this.updateMediaValue = function (value) {
        onSourceChanged(value);
    }

    view.on('crsa-breakpoints-changed', onBreakpointsChanged);

    pinegrow.addEventHandler('on_selected_elements_changed', onBreakpointsChanged);
    pinegrow.addEventHandler('on_active_page_view_changed', onActivePageViewChanged);
    pinegrow.addEventHandler('on_page_view_resized', onActivePageViewChanged);

    view.onDestroy = function() {
        pinegrow.removeEventHandler('on_selected_elements_changed', onBreakpointsChanged);
        pinegrow.removeEventHandler('on_active_page_view_changed', onActivePageViewChanged);
        pinegrow.removeEventHandler('on_page_view_resized', onActivePageViewChanged);

    }
}