
var PgQuickStylesheets = function($target, parentView) {

    var _this = this;

    var sv = new PgStylesheetsView();
    sv.parentView = parentView;

    var win = new PgQuickWindow('Page Stylesheets', sv, 'quickStylesheets', 400, 500);

    var pos = $target.get(0).getBoundingClientRect();
    win.showAtPosition(pos.left, pos.top, 400);

    sv.show();

    sv.onStylesheetSelected = function() {
        if(!win.wasMoved && !win.wasResized) {
            win.destroy();
        }
    }

    win.onDestroy = function() {
    }
}

var PgStylesheetsView = function() {

    //Display list of stylesheets, like we had before on top of the CSS panel. But here we decouple stylesheets view from the rules view

    var $element = $('<div class="aacrsa-panel crsa-stylesheets"></div>');

    var view = new PgUIView($element);

    this.view = view;

    this.parentView = null;

    var _this = this;

    var selectedCrsaPage = null;
    var selectedPage = null;
    var iframe = null;
/*
    var $allButton = $('<button class="pg-button">Show all active rules</button>').appendTo($element);

    $allButton.on('click', function(e) {
        e.preventDefault();
        _this.parentView.setActiveCs(null);
        if(_this.onStylesheetSelected) _this.onStylesheetSelected(null);
    })
*/
    //var $p = $('<p>Click on the stylesheet name to open it:</p>').appendTo($element);


    var $stylesheet_manage_link = $('<button/>', {class: 'pg-button', href:"#"}).html('Add &amp; Manage');

    isApp() && $stylesheet_manage_link.appendTo($element);

    addTooltip($stylesheet_manage_link, 'Create and manage stylesheets.');

    var $stylesheet_refresh_link = $('<button/>', {class: 'pg-button', href:"#", style:'margin-left:10px;'}).html('Refresh').appendTo($element).on('click', function(e) {
        e.preventDefault();
        var page = pinegrow.getSelectedPage();
        if(page) {
            page.updateStylesheetsList();
        }
        pinegrow.showQuickMessage('Refreshing the stylesheet list...');
    });

    addTooltip($stylesheet_refresh_link, 'Refresh the list of all stylesheets that are used on the selected page.');

    var $psul = $('<ul/>', {class: 'cm-sslist'}).appendTo($element);

    /*
    var setSSHidden = function(cs, $li, hidden) {
        if(hidden) {
            //cs.unload();
            pinegrow.dispatchEvent('on_stylesheet_unloaded', null, cs)
        }
        cs.ignore = hidden;
        if(!hidden) {
            var idx = filter_cs_list.indexOf(cs);
            if(idx >= 0) filter_cs_list.splice(idx, 1);
        } else {
            var idx = filter_cs_list.indexOf(cs);
            if(idx < 0) filter_cs_list.push(cs);
        }
    }
    */

/*
    var showSSHidden = function(cs, $li) {
        var $i = $li.find('i.filter');
        if(!cs.ignore) {
            $li.addClass('loaded');
            $i.addClass('icon-check').removeClass('icon-minus');
        } else {
            $li.removeClass('loaded');
            $i.addClass('icon-minus').removeClass('icon-check');
        }
    }*/

    var showSSDefault = function(cs, $li, val) {
        var $i = $li.find('i.filter');
        if(val) {
            $i.addClass('icon-check').removeClass('icon-minus');
        } else {
            $i.addClass('icon-minus').removeClass('icon-check');
        }
    }

    var showSSLoaded = function(cs, $li) {
        if(cs.loaded) {
            $li.addClass('loaded');
        } else {
            $li.removeClass('loaded');
        }
    }

    var updateStylesheetList = function() {
        $psul.find('li').data('crsa-cs', null);

        selectedCrsaPage = pinegrow.getSelectedPage();

        $psul.html('');
        if (!selectedCrsaPage) {
            $psul.sortable('refresh');
            return;
        }

        selectedPage = selectedCrsaPage.$iframe;
        iframe = selectedPage.get(0);

        var ps = getCrsaPageStylesForPage(selectedPage);
        if (!ps) return;

        var allSheets = ps.getAllCrsaStylesheets();

        var project = pinegrow.getCurrentProject();

        var getRelativePathForCs = function (cs) {
            var nakedUrl = cs.url;
            var rel_url = crsaMakeLinkRelativeTo(nakedUrl, project ? project.getUrl() : selectedCrsaPage.url);
            return crsaRemoveUrlParameters(rel_url);
        }

        var default_cs = pinegrow.getDefaultStylesheet(null, function() {}, false, true);

        var addStyleSheetItem  = function (cs, $parent, imported, is_default) {
//            console.log(cs)
            var loaded = cs.loaded && !cs.ignore;

            var $li = $('<li/>').appendTo($parent).data('crsa-cs', cs);
            if(loaded) {
                $li.addClass('loaded');
            }
            var $locked = $('<i/>', {class: 'icon glyphicon glyphicon-lock', style: `font-size: 12px;
            opacity: 0.85;
            float: left;
            width: 11px;
            margin: 5px 3px 0px;`}).appendTo($li);
            if(!cs.locked) {
                $locked.css({
                    visibility: 'hidden'
                })
            } else {
                addTooltip($locked, 'The stylesheet is locked. Rigth-click to unlock.');
            }

            // var $fil = $('<i/>', {class: 'filter icon'}).appendTo($li).addClass(is_default ? 'icon-check' : 'icon-minus');

            if(cs.locked) {
                // pg$Hide($fil);
            } else {
                pg$Hide($locked);
            }

            if (!imported) var $vis = $('<i/>', {class: 'ss-enable'}).appendTo($li).addClass(cs.isEnabledForPage(selectedCrsaPage) ? 'icon-see' : 'icon-hide');

            var $name = $('<a/>', {href: '#'}).html('<span>' + cs.name + '</span>').appendTo($li);

            var tip_txt = (cs.url ? (getRelativePathForCs(cs) + '<br>') : '') + 'Click to open in a separate tab. Right-click for options.';

            if(cs === default_cs) {
                $name.addClass('pg-default-cs');
                tip_txt = `<b>Default stylesheet</b><br>` + tip_txt;
            }

            addTooltip($name, tip_txt)

            if(cs.url) {
                var $code = $('<i/>', {class: 'code icon icon-KODA'}).appendTo($li);
                $code.on('click', function(e) {
                    e.preventDefault();
                    pinegrow.stylesheets.editCode(cs);
                })

                addTooltip($code, 'Edit stylesheet code.')
            }

            if (!imported) {
                var $menu = $('<i/>', {class: 'menu icon icon-down'}).appendTo($li);
                var $move = $('<i/>', {class: 'move icon icon-Pin6'}).appendTo($li);
            }

            // addTooltip($fil, is_default ? 'This is a default stylesheet for new CSS rules. Right-click on any stylesheet to set it as default.' : 'Right-click to set as default stylesheet for new CSS rules.', {placement: 'top'})
            if (!imported) {
                addTooltip($vis, 'Hide / show in the page view (note, this will not remove the stylesheet from the page).', {placement: 'top'})
                addTooltip($menu, 'More actions...');
            }

            //showSSHidden(cs, $li);

            if(cs.getError()) $name.addClass('has-css-error');

            var createFileFromCssWithNewExt = function (cssUrl, ext) {
                var sourceUrl = cssUrl;
                var destUrl = cssUrl.replace(/\.css$/i, '.' + ext);
                crsaCopyFileSync(require('fs'), crsaMakeFileFromUrl(cssUrl), crsaMakeFileFromUrl(destUrl));
                return destUrl;
            }

            var clickOnName = function(cs, skipIgnoreChanging) {
                var p = new CrsaProfile(true);

                var doneLoading = function (pgStylesheet) {
                    if(_this.parentView) {
                        _this.parentView.setActiveCs(cs);

                        if(_this.onStylesheetSelected) _this.onStylesheetSelected(cs);

                        if(view.quickWin) {
                            view.quickWin.close();
                        }
                    }
                }

                cs.loadAndShowInActive(function() {
                    window.requestAnimationFrame(function() {
                        updateStylesheetList();
                        doneLoading(cs);
                    });
                })
            }

            var cannotConvertFileAlert = function (fileType) {
                pinegrow.showAlert('<p>After creating a new page, you have to <b>save the page</b> first, before using ' + fileType + '. After the page is saved on disk, you can use ' + fileType + ' without saving the page.</p>', 'Page needs a home first');
            }

            var loadStylesheet = function(cs) {
                cs.loadAndShowInActive();
            }

            var unloadStylesheet = function(cs) {
                cs.ignoreInActive();
                /*
                cs.ignore = true;
                var cStylesheet = null;
                if (cs.compiledStylesheet) {
                    cStylesheet = cs.compiledStylesheet;
                    cStylesheet.ignore = cs.ignore;
                }
                else {
                    cStylesheet = cs;
                }
                $('body').trigger('crsa-stylesheets-changed');
                */
            }

            var setAsDefault = function(cs) {
                if(cs.url) {
                    pinegrow.setDefaultStylesheet(selectedCrsaPage, cs);
                    pinegrow.showQuickMessage(`${cs.name} will be used as default destination for new CSS rules.`);
                } else {
                    pinegrow.showQuickError('Inline stylesheets can not be used as the default stylesheet.');
                }
                $('body').trigger('crsa-stylesheets-changed');
            }

            /*
            var clickOnFilterSS = function($li, cs) {
                setSSHidden(cs, $li, !cs.ignore);
                showSSHidden(cs, $li);

                $(".tooltip").hide();

                loadStylesheet(cs);
            }
*/

            var clickOnEnableSS = function(cs, $li) {
                var $i = $li.find('i.ss-enable');
                var enabled = cs.isEnabledForPage(selectedCrsaPage);
                cs.setEnabledForPage(selectedCrsaPage, !enabled);
                if(!enabled) {
                    $i.addClass('icon-see').removeClass('icon-hide');
                } else {
                    $i.addClass('icon-hide').removeClass('icon-see');
                }
            }

            var showContextMenu = function(cs, e, $target) {
                var menu = new CrsaContextMenu(null, $target);

                var locked = !cs.canEdit(true);

                /*
                menu.add("Show only these CSS rules", null, function() {
                    clickOnName(cs);
                });*/

                var default_cs = pinegrow.getDefaultStylesheet(null, function() {}, false, true);

                if(cs.url) {
                    var lock_submenu = null;

                    if (cs.importedFiles && cs.importedFiles.length > 0) {
                        var setLockForChildren = function (lock) {
                            cs.getAllImportedFiles(function (childCs) {
                                childCs.setLocked(lock, '');
                            });
                        }

                        lock_submenu = [];
                        /*
                        lock_submenu.add({
                            label: 'Locked',
                            check: locked,
                            action: function () {
                                if(!locked) {
                                    cs.setLocked(true, '');
                                    pinegrow.selectedElements.reselect();
                                    pinegrow.showQuickMessage('Stylesheet is locked.');
                                } else {
                                    cs.unlockWithAsk();
                                }
                            }
                        });*/

                        lock_submenu.push({
                            label: 'Lock all children',
                            //check: false,
                            action: function () {
                                setLockForChildren(true);
                                pinegrow.selectedElements.reselect();
                                updateStylesheetList();
                            }
                        });

                        lock_submenu.push({
                            label: 'Unlock all children',
                            //check: false,
                            action: function () {
                                setLockForChildren(false);
                                pinegrow.selectedElements.reselect();
                                updateStylesheetList();
                            }
                        });
                    }

                    menu.add({
                        label: 'Locked',
                        check: locked,
                        action: function() {
                            if(!locked) {
                                cs.setLocked(true, '');
                                pinegrow.selectedElements.reselect();
                                pinegrow.showQuickMessage('Stylesheet is locked.');
                                updateStylesheetList();
                            } else {
                                cs.unlockWithAsk(function() {
                                    updateStylesheetList();
                                });
                            }
                        },
                        submenu: lock_submenu
                    });
                }
                if (cs.url && !locked) {
                    menu.add({
                        label: "Set as default for new rules",
                        action: function () {
                            setAsDefault(cs);
                        },
                        check: default_cs === cs
                    });
                }

                var csInfo = pinegrow.stylesheets.getStylesheetInfo(cs, selectedCrsaPage);
                if (isApp() && !cs.isImportedFor(selectedCrsaPage) && !(csInfo && csInfo.compiledStylesheet) && !locked) {
                    menu.add("Convert to SCSS", null, function() {
                        if(isApp()) {
                            if(cs.changed) {
                                pinegrow.showAlert('Please save the stylesheet first.', 'Notice');
                            } else if(!cs.localFile) {
                                pinegrow.showAlert('<p>This is a remote stylesheet. The stylesheet needs to be local in order to convert it.</p>', 'Remote stylesheets are not supported.');
                            } else {
                                var crsaPage = pinegrow.getSelectedPage();
                                if (crsaPage.localFile) {
                                    var destUrl = createFileFromCssWithNewExt(crsaMakeUrlFromFile(cs.localFile), 'scss');
                                    var scs = PgSCSSStylesheet();

                                    pinegrow.stylesheets.stylsheetUsed({
                                        url: destUrl,
                                        pgStylesheet: scs
                                    }, 'source', cs);

                                    cs.compiledFile = true;
                                    cs.sourceStylesheet = scs;
                                    scs.load(destUrl, function () {
                                        cs.setSourceStylesheet(scs);
                                        $('body').trigger('crsa-stylesheets-changed');
                                    }, false, false, cs);

                                    pinegrow.refreshCurrentProjectDelayed(true);
                                }
                                else {
                                    cannotConvertFileAlert('SCSS');
                                }
                            }
                        }
                    });

                    menu.add("Convert to LESS", null, function() {
                        if(isApp()) {
                            if(cs.changed) {
                                pinegrow.showAlert('Please save the stylesheet first.', 'Notice');
                            } else if(!cs.localFile) {
                                pinegrow.showAlert('<p>This is a remote stylesheet. The stylesheet needs to be local in order to convert it.</p>', 'Remote stylesheets are not supported.');
                            } else {
                                var crsaPage = pinegrow.getSelectedPage();
                                if (crsaPage.localFile) {
                                    var destUrl = createFileFromCssWithNewExt(crsaMakeUrlFromFile(cs.localFile), 'less');
                                    var lcs = PgLESSStylesheet();

                                    pinegrow.stylesheets.stylsheetUsed({
                                        url: destUrl,
                                        pgStylesheet: lcs
                                    }, 'source', cs);

                                    cs.compiledFile = true;
                                    cs.sourceStylesheet = lcs;
                                    lcs.load(destUrl, function () {
                                        cs.setSourceStylesheet(lcs);
                                        $('body').trigger('crsa-stylesheets-changed');
                                    }, false, false, cs);

                                    pinegrow.refreshCurrentProjectDelayed(true);
                                }
                                else {
                                    cannotConvertFileAlert('LESS');
                                }
                            }
                        }
                    });
                }

                menu.add("Format file", null, function () {
                    if (isApp()) {
                        cs.formatCode(function () {
                            pinegrow.dispatchEvent('on_css_source_changed', null, {list: [cs]});
                            if (cs.inline) {
                                pinegrow.dispatchEvent('on_css_stylesheet_changed', null, cs);
                            }
                        });
                    }
                })

                if (isApp() && csInfo && csInfo.compiledStylesheet) {
                    menu.add("Recompile file", null, function() {
                        if(isApp()) {
                            cs.regenerateAndSetCssSource(function () {
                                $('body').trigger('crsa-stylesheets-changed');
                                pinegrow.showQuickMessage('File compiled!');
                            })
                        }
                    });
                    menu.add("Compile &amp; save", null, function() {
                        if(isApp()) {
                            cs.regenerateAndSetCssSource(function () {

                                var path = crsaMakeFileFromUrl(cs.url);
                                cs.save(path, function(err) {
                                    if (err) {
                                        showAlert('Error: ' + err, 'Can\'t save this file');
                                    }
                                    else {
                                        pinegrow.refreshPageChangedStatusForAllPages(true);
                                        pinegrow.showQuickMessage('File compiled and saved!');
                                    }
                                });
                                $('body').trigger('crsa-stylesheets-changed');
                            })
                        }
                    });
                }

                if(cs.ignore || !cs.loaded) {
                    menu.add("Load &amp; Show in Active", null, function() {
                        //clickOnFilterSS($li, cs);
                        loadStylesheet(cs);
                    });
                } else {
                    menu.add("Ignore in Active", null, function() {
                        unloadStylesheet(cs);
                        //clickOnFilterSS($li, cs);
                    });
                }

                if (isApp() && !cs.isImportedFor(selectedCrsaPage)) {
                    if (cs.isEnabledForPage(selectedCrsaPage)) {
                        menu.add("Hide in page view", null, function() {
                            clickOnEnableSS(cs, $li);
                        });
                    } else {
                        menu.add("Show in page view", null, function() {
                            clickOnEnableSS(cs, $li);
                        });
                    }
                }

                if (!cs.inline) {
                    menu.add("Reload", null, function() {
                        _this.reloadStylesheet(cs);
                    });
                }

                menu.add('Edit', null, function() {
                    clickOnName(cs, true);
                })

                if(e) {
                    menu.showAt(e.pageX, e.pageY);
                } else {
                    menu.showForElement($target);
                }
            }

            $name
                .on('click', function(e) {
                    var $li = $(e.delegateTarget).closest('li');
                    var cs = $li.data('crsa-cs');

                    var p = new CrsaProfile(true);
                    clickOnName(cs, true);

                    e.preventDefault();
                })
                .on('contextmenu', function(e) {
                    e.preventDefault();

                    var $li = $(e.delegateTarget).closest('li');
                    var cs = $li.data('crsa-cs');
                    showContextMenu(cs, e, $li);
                    return false;
                })

            if($menu) {
                $menu.on('click', function (e) {
                    e.preventDefault();

                    var $li = $(e.delegateTarget).closest('li');
                    var cs = $li.data('crsa-cs');
                    showContextMenu(cs, null, $menu);
                    return false;
                })
            }

            /*
            $fil.on('click', function(e) {
                var $li = $(e.delegateTarget).closest('li');
                var cs = $li.data('crsa-cs');

                clickOnFilterSS($li, cs);
                pinegrow.reselectElement();
                e.preventDefault();
            });*/

            if (!imported) {
                $vis.on('click', function(e) {
                    var $li = $(e.delegateTarget).closest('li');
                    var cs = $li.data('crsa-cs');

                    clickOnEnableSS(cs, $li);
                    pinegrow.reselectElement();
                    e.preventDefault();
                });
            }

            return $li;
        }

        var displayAllStylesheet = function (stylesheets, $ul,  showVisibilityIcon) {
            pinegrow.getDefaultStylesheet(pinegrow.getSelectedPage(), function(default_cs) {
                $.each(stylesheets, function (i, cs) {
                    if (cs.sourceStylesheet) cs = cs.sourceStylesheet;

                    var $li = addStyleSheetItem(cs, $ul, showVisibilityIcon, default_cs == cs);
                    var list = cs.importedFiles;
                    if (list.length > 0) {
                        var $newUl = $('<ul class="nested"></ul>').appendTo($li);
                        displayAllStylesheet(list, $newUl, true);
                    }
                });
            }, false, true /* skip load */)
        }

        displayAllStylesheet(allSheets, $psul, false)
        $psul.sortable('refresh');

        $(window).trigger('resize');

        if(view.quickWin) {
            view.quickWin.autoResize(300);
        }
    }

    this.show = this.refresh = function() {
        onPageSelected(null, pinegrow.getSelectedPage());
    }

    this.reloadStylesheet = function(cs, done) {
        var onDone = function() {
            if (done) done();
            crsaQuickMessage(cs.name + " reloaded.");
            $('body').trigger('crsa-stylesheets-changed');
        }

        if (cs.changed) {
            showAlert(cs.name + " has unsaved changes. Do you want to reload the stylesheet and loose these changes?", "Unsaved changes", "Cancel", "Reload", null, function() {
                cs.reload(onDone);
            });
        } else {
            cs.reload(onDone);
        }
    }

    $stylesheet_manage_link
        .on('click', function(e) {
            e.preventDefault();

            if (isApp()) {
                var crsaPage = pinegrow.getSelectedPage();
                if (crsaPage == null) {
                    pinegrow.showAlert('<p>Please open a page to use stylesheet manager</p>', 'No page is open');
                }
                else {
                    if(crsaPage.localFile || crsaPage.isRemote()) {
                        $.fn.crsacss('showStylesheetsManager');
                    }
                    else {
                        pinegrow.showAlert('<p>After creating a new page, you have to <b>save the page</b> first, before using stylesheet manager. After the page is saved on disk, you can use stylesheet manager without saving the page.</p>', 'Page needs a home first');
                    }
                }
            }
        });

    $psul.sortable({handle: 'i.icon-Pin6', axis: "y", scroll: false })
        .on("sortupdate", function(event, ui) {
            var list = [];
            $psul.find('> li').each(function(i, li) {
                var cs = $(li).data('crsa-cs');
                if (cs) list.push(cs);
            });

            //getCrsaPageForIframe($.fn.crsa('getSelectedPage')).undoStack.add("Reorder stylesheets");
            getCrsaPageStylesForPage(selectedPage).reorder(list, function() {
                // updateRules();
                // closeAllPropertiyForms();

                var page = pinegrow.getSelectedPage();
                // var doc = pinegrow.getSelectedPage().getDocument();
                // pinegrow.updateTree($(doc).find('> html > head'));
                page.callFrameworkHandler('on_page_changes_done', { action: "Move elements" });
            });
        });

    view.whenVisible(function() {
        updateStylesheetList();
    })

    var onPageSelected = function(event, page) {
        selectedCrsaPage = page;
        selectedPage = page ? page.$iframe : null;
        iframe = selectedPage ? selectedPage.get(0) : null;

        view.whenVisible(function() {
            updateStylesheetList();
        })
    }

    var onStylesheetsLoaded = function(page) {
        if(page == selectedCrsaPage) {
            view.whenVisible(function() {
                updateStylesheetList();
            })
        }
    }

    var onPageChanged = function (page) {
        view.whenVisible(function () {
            page.updateStylesheetsList();
        });
    }

    $('body').on('crsa-page-selected', onPageSelected);
    $('body').on('crsa-stylesheets-changed', updateStylesheetList);

    pinegrow.addEventHandler('on_page_changes_done', onPageChanged);
    pinegrow.addEventHandler('on_page_stylesheets_loaded', onStylesheetsLoaded);

    view.onDestroy = function() {
        $('body')
            .off('crsa-page-selected', onPageSelected)
            .off('crsa-stylesheets-changed', updateStylesheetList);

        pinegrow.removeEventHandler('on_page_changes_done', onPageChanged);
        pinegrow.removeEventHandler('on_page_stylesheets_loaded', onStylesheetsLoaded);
    }
}
