$(function () {

    if(!pgf.edit_html) return;

    $('body').one('pinegrow-ready', function (e, pinegrow) {//Wait for Pinegrow to start-up
        var f = new PgFramework('pg.asset.manager', 'Asset manager');
        pinegrow.addFramework(f);

        f.default = true;
        f.show_in_manager = false;

        var PgAssetManager = function () {
            var DIALOG_TITLE = "Manage Google Fonts";

            var assetsList = [];
            var removedAssets = [];

            var uniqueBy = function (arr, fn) {
              var unique = {};
              var distinct = [];
              arr.forEach(function (x) {
                var key = fn(x);
                if (!unique[key]) {
                  distinct.push(x);
                  unique[key] = true;
                }
              });
              return distinct;
            }

            var removeFromAssets = function (index) {
                if (index > -1 && index < assetsList.length) {
                    removedAssets.push(assetsList[index]);
                    assetsList.splice(index, 1);
                    return true;
                }
                return false;
            }

            var mergeGoogleFontWithAssetsList = function (entered_gooogle_font) {
                var google_fonts = entered_gooogle_font.map(function (font) {
                    return {
                        url: font.url,
                        type: 'CSS',
                        from: 'Google font',
                        info: font.name,
                        action: font.action
                    };
                });

                var newList = [];
                for (var i = 0; i < assetsList.length; i++) {
                    var found = false;
                    var foundFont;
                    for (var j = 0; j < google_fonts.length; j++) {
                        if (assetsList[i].info == google_fonts[j].info) {
                            found = true;
                            foundFont = google_fonts[j];
                            google_fonts.splice(j, 1);
                            break;
                        }
                    }
                    if (!found) {
                        newList.push(assetsList[i]);
                    }
                    else {
                        removedAssets.push(assetsList[i]);
                        newList.push(foundFont);
                    }
                }

                assetsList = $.merge(newList, google_fonts);
            }

            var updateAssetsUrl = function (oldUrl, newUrl) {
                for (var i = 0; i < assetsList.length; i++) {
                    if (assetsList[i].type == 'CSS') {
                        if (assetsList[i].url == oldUrl) {
                            assetsList[i].url = newUrl;
                        }
                    }
                }
            }

            var updateHrefFor = function (oldUrl, newUrl) {
                var selectedPage = pinegrow.getSelectedPage();
                if (!selectedPage) {
                    pinegrow.showAlert('Please open a page first.');
                    return;
                }
                var head = selectedPage.sourceNode.findOne('head');

                if (head) {
                    var col = new PgCollection();

                    head.findWithAttrValue('href', oldUrl).forEach(function (pgel) {
                        pgel.setAttr('href', newUrl);
                        col.add(pgel);
                    });

                    if(col.getLength()) {
                        pinegrow.changeManager.didChange(col, 'Update Google Font', null, selectedPage);
                    }
                }
            }

            var saveChangesToThePage = function () {
                var selectedPage = pinegrow.getSelectedPage();
                if (!selectedPage) {
                    pinegrow.showAlert('Please open a page first.');
                    return;
                }
                var head = selectedPage.sourceNode.findOne('head');

                if(head) {
                    var changeDone = false;
                    // Remove assets
                    for (var i = 0; i < removedAssets.length; i++) {
                        if (removedAssets[i].type == 'CSS') {
                            head.findWithAttrValue('href', removedAssets[i].url).forEach(function (pgel) {
                                var url = pgel.getAttr('href');
                                var newURL = getNewFontsUrl(url, removedAssets[i].info, 'remove');
                                if (newURL) {
                                    updateAssetsUrl(url, newURL);
                                    pgel.setAttr('href', newURL);
                                }
                                else {
                                    pgel.remove();
                                }

                                changeDone = true;
                            })
                        }
                    }

                    // Add assets
                    for (var i = 0; i < assetsList.length; i++) {
                        if (assetsList[i].type == 'CSS') {
                            if (selectedPage.addStylesheet(assetsList[i].url)) {
                                changeDone = true;
                            }
                        }
                    }

                    if (changeDone) {
                        pinegrow.changeManager.didChange(head, 'Update Google Fonts', null, selectedPage);
                    }
                }
            }

            this.show = function () {
                var $b = $("<div></div>");
                var $table = $('<table class="assets-manager file-chooser table table-striped table-condensed table-hover"><thead><tr><td style="width:60%;"><label>Asset name</label></td><td><label>Type</label></td><td style="width:100px;"><label>Family name</label></td><td style="width:30px;"></td><td style="width:30px;"></td></tr></thead><tbody></tbody></table>').appendTo($b);
                var $tbody = $table.find('tbody');

                var updateAssetsList = function (skip_save, choosed_fonts) {

                    var saveChanges = function () {
                        // Save changes
                        if (!skip_save) {
                            saveChangesToThePage();
                        }
                    }

                    var getUrlLabel = function (fontUrl) {
                        var url = crsaGetSummaryStr(fontUrl, 60);
                        return $('<label>' + url + '</label>')
                    }

                    // Update assets
                    if (choosed_fonts) {
                        mergeGoogleFontWithAssetsList(choosed_fonts);
                        saveChanges();
                    }
                    else {
                        saveChanges();
                        assetsList = [];
                        choosed_fonts = getDefaultPageAssets();
                        mergeGoogleFontWithAssetsList(choosed_fonts);
                    }

                    $tbody.html('');
                    for (var i = 0; i < assetsList.length; i++) {
                        var $tr = $('<tr data-index="' + i + '"></tr>').appendTo($tbody);

                        if (assetsList[i].from == 'Google font') {
                            $tr.data('fontUrl', assetsList[i].url);
                        }

                        var $td = $('<td class="elm-url"></td>').appendTo($tr);

                        var $urlLabel = getUrlLabel(assetsList[i].url);
                        $urlLabel.appendTo($td);

                        $td = $('<td class="elm-type">' + assetsList[i].type + (assetsList[i].from ? '/' + assetsList[i].from : '') + '</td>').appendTo($tr);
                        $td = $('<td class="more-info">' + assetsList[i].info + '</td>').appendTo($tr);

                        $td = $('<td class="elm-settings" style="vertical-align: middle;"><i class="glyphicon glyphicon-cog" style="position:relative;top:2px;"></i></td>').appendTo($tr);
                        var $g_font_settings_icon = $td.find('> .glyphicon');
                        $g_font_settings_icon.click(function (e) {
                            e.preventDefault();
                            var $tr = $(this).closest('tr');
                            var fontUrl = $tr.data('fontUrl');
                            var google_font = pinegrow.pgGoogleFontManager.getFont(fontUrl);
                            var included_font = getFontNameAndOptions(fontUrl)[0];

                            pinegrow.pgGoogleFontManager.openSettingsFor(google_font, included_font,
                                function () {

                                }, function (new_google_font, fontObj) {
                                    var newUrl = fontObj.url;
                                    $tr.data('fontUrl', newUrl);

                                    var $tdUrl = $tr.find('.elm-url');
                                    $tdUrl.html('');

                                    var $urlLabel = getUrlLabel(newUrl);
                                    $urlLabel.appendTo($tdUrl);

                                    updateHrefFor(fontUrl, newUrl);
                                    // updateAssetsList(false, [fontObj]);
                                });
                        });

                        addTooltip($td.find('i'), 'Font settings...')

                        $td = $('<td class="elm-action" style="vertical-align: middle;"></td>').appendTo($tr);
                        if (assetsList[i].action) {
                            assetsList[i].action(assetsList[i], $td);
                            addTooltip($td.find('i'), 'Copy family name to clipboard.')
                        }



                        $td = $('<td class="elm-delete" style="vertical-align: middle;"><i class="glyphicon glyphicon-trash"></i></td>').appendTo($tr);

                        addTooltip($td.find('i'), 'Remove font from the selected page.')

                        var $delete_icon = $td.find('> .glyphicon');
                        $delete_icon.click(function (e) {
                            e.preventDefault();
                            $tr = $(this).closest('tr');

                            if (removeFromAssets(parseInt($tr.attr('data-index')))) {
                                updateAssetsList(false);
                            }
                        });
                    }
                }

                var $notes = $('<p class="assets-notes"></p>').appendTo($b);
                var $form = $('<form class="form-inline load-files-folders" role="form"></form>').appendTo($b);
                var $add_google_font = $('<button type="submit" class="btn btn-primary add-google-font">Add Google font</button>').appendTo($form);

                pinegrow.pgGoogleFontManager.loadFonts(function (err) {
                    if (!err) {
                        $table.addClass('fonts-loaded');
                    }
                })

                if (pinegrow.pgGoogleFontManager.addNotes) {
                    pinegrow.pgGoogleFontManager.addNotes($notes)
                }

                $add_google_font.click(function (e) {
                    e.preventDefault();
                    pinegrow.pgGoogleFontManager.show(function (choosed_fonts) {
                        updateAssetsList(false, choosed_fonts);
                    });
                });

                var getDefaultPageAssets = function () {
                    var selectedPage = pinegrow.getSelectedPage();
                    if (selectedPage) {
                        return pinegrow.pgGoogleFontManager.checkForLinks(selectedPage);
                    }
                    return [];
                }

                var onPageRefreshed = function () {
                    assetsList = [];
                    var existedFonts = getDefaultPageAssets();
                    updateAssetsList(true, existedFonts);
                }

                onPageRefreshed();
                f.on_page_refreshed = onPageRefreshed;

                makeAndShowDialog(DIALOG_TITLE, "Close", null, $b, function () {
                    // do nothing
                }, null, null, true);
            }
        }

        pinegrow.assetManager = new PgAssetManager();

        if(!pinegrow.isContributorMode()) {
            f.on_page_menu = function(page, items) {
                items.push({
                    label: 'Manage Google Fonts...',
                    kbd: null,
                    action: function() {
                        pinegrow.assetManager.show();
                    }
                })
            };
        }
    });
});