/*
Humane technologies d.o.o.
 */

var PgPowerBar = function($container) {

    var $p = $('<div class="power-bar"></div>').appendTo($container);

    var $input = $('<input type="text" class="power-bar-input"/>').appendTo($p);

    var $b = $('<button class="btn btn-primary">Go</button>').appendTo($p);

    var $list = $('<div class="power-bar-list"></div>').appendTo($p);

    var api = new PgApi();
    var preview_ref = 'pg-preview-1';
    /*
    Modes for input
    - Code
    - Search element
    - Element
    - Component
     */

    var getHtmlForVal = function(val) {

        var p = new pgParser();
        p.assignIds = false;
        p.parse(val);

        if(p.validate().length) return null;

        //p.text

        return val;
    }

    $input.on('input', function(e) {
        var val = $input.val();

        var code = getHtmlForVal(val);

        if(code) {
            api.previewCodeInPage(preview_ref, code, 'append', null);
        }
    })

    $input.on('blur', function(e) {
        api.clearPreviewCodeInPage(preview_ref);
    })

    $b.on('click', function(e) {
        var val = $input.val();

        var code = getHtmlForVal(val);

        if(code) {
            api.append(code, null /* to selected element */);
        }
    })
}


var PgClipboardItem = function(code, source, type, data) {

    type = type || 'code';

    this.name = null;
    this.valid = false;
    this.code = code;
    this.source = source || 'pg';
    this.sticky = false;
    this.type = type;
    this.only_text = true;
    this.data = data;

    if(type == 'code') {
        var p = new pgParser();
        p.assignIds = false;
        p.parse(code);

        if(p.validate().length == 0) {

            var names = [];
            for (var i = 0; i < p.rootNode.children.length; i++) {
                if(p.rootNode.children[i].textNode) {
                    var t = $.trim(p.rootNode.children[i].content);
                    if(t.length) {
                        names.push( '<nametext>"' + crsaGetSummaryStr(escapeHtmlCode(t), 30, true) + '"</nametext>');
                    }
                } else {
                    names.push(p.rootNode.children[i].getName());
                    var count = 0;
                    for (i = i + 1; i < p.rootNode.children.length; i++) {
                        if(p.rootNode.children[i].isElementOrScript) {
                            count++;
                        }
                    }
                    if(count > 0) {
                        names.push('<small> + ' + count + ' more</small>');
                    }
                    this.only_text = false;
                    break;
                }
            }
            this.name = names.join(' ');
            this.valid = true;
        } else {
            this.name = '<nametext>"' + crsaGetSummaryStr(escapeHtmlCode(code), 30, true) + '"</nametext>';
        }
    }
    else if (type == 'css' || type == 'attributes') {
        this.name = '<nametext>"' + crsaGetSummaryStr(escapeHtmlCode(code), 30, true) + '"</nametext>';
        this.valid = true;
    }
    else if(type == 'actions') {
        this.name = `<action>${data[0].def.name}</action>`;
        if(data.length > 1) {
            this.name += ` <small>+ ${data.length - 1} more</small>`
        }
    }
    else if(type == 'pgia.timeline') {
        this.name = `<action>Timeline</action>`;
    }
    else if(type == 'pgia.transform') {
        this.name = `<action>Timeline tween</action>`;
    }

    this.formatText = function() {
        var html = '';
        this.code.split(/\n+/).forEach(function(line) {
            line = $.trim(line);
            if(line.length) {
                html += `<p>${line}</p>`;
            }
        })
        return html;
    }
}

var PgClipboard = function() {

    var _this = this;

    var list = [];

    var current = 0;

    var placement = 'insertAfter';

    var hiddenText = 'pinegrowisthebesteditorintheuniverse';

    this.getPlacement = function() {
        return placement;
    }

    this.setPlacement = function(p) {
        placement = p;
    }

    var find = function(code) {
        for(var i = 0; i < list.length; i++) {
            if(list[i].code == code) return i;
        }
        return -1;
    }

    var reorderListAfterAddingItem = function() {

        var r = [];
        var sticky = [];

        for(var i = 0; i < list.length; i++) {
            if(list[i].sticky) {
                sticky.push(list[i]);
                list[i].position = i > 1 ? Math.max(i - 1, 0) : i;
            } else {
                if(r.length < 100) {
                    r.push(list[i]);
                }
            }
        }

        for(var i = 0; i < sticky.length; i++) {
            r.splice(Math.min(sticky[i].position, r.length), 0, sticky[i]);
        }
        list = r;
    }

    this.add = function(code, source, type) {
        var item = null;

        if(code instanceof PgClipboardItem) {
            item = code;
        } else {
            if (!code || !$.trim(code).length) return;

            var idx = find(code);
            if (idx >= 0) {
                type = type || list[idx].type;
                list.splice(idx, 1);
            }

            item = new PgClipboardItem(code, source, type);
        }
        list.unshift(item);

        current = 0

        reorderListAfterAddingItem();

        if(typeof pinegrow != 'undefined') pinegrow.callGlobalFrameworkHandler('on_clipboard_changed', item);
    }

    this.select = function(idx) {
        if(idx < list.length) {
            current = idx;
            setClipboardContent(list[current].code);
        }
        if(typeof pinegrow != 'undefined') pinegrow.callGlobalFrameworkHandler('on_clipboard_item_selected', current);
    }

    this.getCurrentItem = function() {
        if(current < list.length) return list[current];
        return null;
    }

    this.getCurrentIndex = function() {
        return current;
    }

    this.getAll = function() {
        return list;
    }

    this.onPageMouseUp = function(event) {
        focusHiddenArea(event.currentTarget);
        event.stopPropagation();
    }

    this.onPagePaste = function(event) {
        if(!shouldHandlePaste()) return;
        handlePaste();
    }

    var getClipboardContent = function() {
        var gui = require('nw.gui');
        var clipboard = gui.Clipboard.get();
        return clipboard.get('text');
    }

    var setClipboardContent = function(c) {
        if(!isApp()) return false;
        setTimeout(function() {
            var gui = require('nw.gui');
            var clipboard = gui.Clipboard.get();
            clipboard.set(c, 'text');
        }, 100);
    }

    var removeHiddenTextFromClipboard = function() {
        if(!isApp()) return false;
        setTimeout(function() {
            var gui = require('nw.gui');
            var clipboard = gui.Clipboard.get();
            if(clipboard.get('text') === hiddenText) {
                clipboard.clear();
            }
        }, 10);
    }

    var addFromClipboard = function(source) {
        try {
            var text = getClipboardContent();
            if (text && text !== hiddenText) {
                _this.add(text, source);
            } else {
                removeHiddenTextFromClipboard();
            }
        } catch(err) {}
    }

    this.addFromClipboard = function(source) {
        addFromClipboard(source);
    }

    addFromClipboard();

    if(!isApp()) {
        setTimeout(function() {
            pinegrow.addEventHandler('on_key_pressed', function (page, e, status) {
                if(!status.input && !status.edit && status.ctrl) {
                    if(status.key === 'c') {
                        //if text is selected, ignore
                        var selection = window.getSelection();
                        if(selection && selection.toString().length) {
                            //is in focused element?
                            if(document.activeElement && document.activeElement.contains(selection.baseNode)) {
                                return;
                            }
                        }
                        handleCopy();
                        status.done = true;
                    } else if(status.key === 'x') {
                        handleCut();
                        status.done = true;
                    } else if(status.key === 'v') {
                        handlePaste();
                        status.done = true;
                    }
                }
            })
        }, 0)
    }

    document.addEventListener('copy', function(e) {
        handleCopy();
    })

    var handleCut = function() {
        if(isInInput()) {
            setTimeout(addFromClipboard, 100);
        } else if(hasSelection()) {
            setTimeout(addFromClipboard, 100);
        } else if(areCssRulesSelected()) {
            var c = getRulesToCopy(true);
            _this.add(c, 'pg', 'css');
            setClipboardContent(c);
        } else {
            var api = new PgApi();

            var code = [];
            pinegrow.selectedElements.forEachElement(function(pgel) {
                code.push(pgel.toStringOriginal(true, pinegrow.getFormatHtmlOptions()));
            })
            if(code.length) {
                var c = code.join('');
                _this.add(c);
                setClipboardContent(c);
            } else {
                removeHiddenTextFromClipboard();
            }
            api.removeElements(); //delete selected elements
        }
        if(typeof pinegrow != 'undefined') pinegrow.callGlobalFrameworkHandler('on_clipboard_cut');
    }

    document.addEventListener('cut', function(e) {
        handleCut()
    })

    var handleCopy = function(col, type, data) {
        if(type) {
            //handle special types
            switch(type) {

                case 'actions':
                case 'pgia.timeline':
                case 'pgia.transform':
                    var item = new PgClipboardItem(type, 'pg', type, data)
                    _this.add(item)
                    break;
                case 'attributes':
                    var item = new PgClipboardItem(data, 'pg', type)
                    _this.add(item)
                    break;
            }

        } else {
            var pgia_t = null;

            var pgia = pinegrow.findFrameworkByKey('pg.ia');
            if(pgia && pgia.timelineView) {
                pgia_t = pgia.timelineView.getSelectedTransform();
            }
            if (isInInput()) {
                setTimeout(addFromClipboard, 100);

            } else if(pgia_t) {
                pinegrow.clipboard.copySpecial('pgia.transform', pgia_t.toData());
                pinegrow.showQuickMessage('Tween was copied to clipboard.');

            } else if (hasSelection()) {
                setTimeout(addFromClipboard, 100);
            } else if (areAttributesSelected()) {
                // TODO @attribute_panel change it after changing attribute place
                var c = getAttributesToCopy();
                _this.add(c, 'pg', 'attributes');
                setClipboardContent(c);
            } else if (areCssRulesSelected()) {
                var c = getRulesToCopy();
                _this.add(c, 'pg', 'css');
                setClipboardContent(c);
            }
            else {
                if(pgf.copy_actions) {
                    var pgel = pinegrow.selectedElements.getLastSelected();
                    if(!pgel) {
                        pinegrow.showQuickError('Please select an element first.');
                    } else {
                        var r = []
                        pgel.getPage().getAllActionTypes(pgel).forEach(function(def) {
                            r.push({
                                def: def,
                                values: def.getActionValuesForPgel(pgel)
                            })
                        })
                        if(r.length) {
                            pinegrow.clipboard.copySpecial('actions', r);
                            pinegrow.showQuickMessage(`${r.length} action${r.length > 1 ? 's' : ''} copied to clipboard.`)
                        } else {
                            pinegrow.showQuickError('The selected element has no actions to copy.')
                        }
                    }
                    return;

                } else {
                    col = col || pinegrow.selectedElements.getCollection();
                    var code = [];
                    col.forEachElement(function (pgel) {
                        code.push(pgel.toStringOriginal(true, pinegrow.getFormatHtmlOptions()));
                    })
                    if (code.length) {
                        var c = code.join('');
                        _this.add(c);
                        setClipboardContent(c);
                    } else {
                        removeHiddenTextFromClipboard();
                    }
                }
            }
        }
        if(typeof pinegrow != 'undefined') pinegrow.callGlobalFrameworkHandler('on_clipboard_copy');
    }

    var handlePaste = function(item, col) {
        item = item || _this.getCurrentItem();
        col = col || pinegrow.selectedElements.getCollection();
        if(item) {
            if(item.type === 'actions') {
                var api = new PgApi();
                item.data.forEach(function (a) {
                    api.addAction(col, a.def, null, a.values);
                })
                focusHiddenArea();

            } else if(item.type === 'pgia.timeline' || item.type === 'pgia.transform') {
                var pgia = pinegrow.findFrameworkByKey('pg.ia');
                if(pgia) {
                    pgia.timelineView.handlePaste(item.type, item.data);
                }
            } else if (item.type == "attributes") {

                if(!pgf.edit_html) return;

                var api = new PgApi();
                if (col.getLength() > 0) {
                    api.pasteAttributes(col, item.code);
                } else {
                    pinegrow.showQuickMessage('Please select the destination element first.');
                }
            }
            else {

                if(!pgf.edit_html) return;

                if (!item.valid) {
                    pinegrow.showNotice('<p>The code has syntax errors (like unclosed tags) and so it can\'t be pasted to the page.</p><p>If you really want to add it to the page go to Edit code and paste it there.</p>', 'Can\'t insert invalid HTML', 'paste-invalid', function (shown) {
                        if (!shown) {
                            pinegrow.showQuickMessage('Can\'t insert invalid HTML!', 3000, false, 'error');
                        }
                    })
                    return;
                }
                var doPaste = function (code) {

                    var api = new PgApi();

                    api.insertElements(code, col, placement, {
                        repeater: true,
                        fix_placement: true,
                        before_body_scripts: true
                    });

                }

                if (col.getLength() === 0) {
                    pinegrow.showQuickMessage('Please select the destination element first.');
                } else {
                    if (item.only_text) {
                        var has_p = false;
                        col.forEachElement(function (pgel) {
                            var check = pgel;
                            if(placement == 'insertBefore' || placement == 'insertAfter') {
                                check = pgel.parent;
                            }
                            if (check && check.closest('p')) {
                                has_p = true;
                            }
                        })
                        if (!has_p) {
                            pinegrow.showAlert(`<p>Would you like to format the text into &lt;p&gt; paragraphs before pasting?</p>`, 'Format text?', 'Cancel', 'Yes, format', null, function () {
                                doPaste(item.formatText());

                            }, 'No thanks', function () {
                                doPaste(item.code);
                            })
                        } else {
                            doPaste(item.code);
                        }
                    } else {
                        doPaste(item.code);
                    }
                }
            }
        }

    }

    this.copySpecial = function(type, data) {
        handleCopy(null, type, data)
    }

    this.copy = function(col) {
        handleCopy(col);
    }

    this.paste = function(item, col) {
        handlePaste(item, col);
    }

    document.addEventListener('paste', function(e) {
        //debugger;
        if(!shouldHandlePaste()) return;
        e.preventDefault();
        handlePaste();
        return false;
    }, true);

    var isInInput = function() {
        if(crsaIsInEdit()) return true;
        try {
            var $a = $(document.activeElement);
            if (document.activeElement && document.activeElement.contentDocument) {
                $a = $(document.activeElement.contentDocument.activeElement);
            }
            return $a.is('input,select,textarea,[contenteditable="true"]') && !$a.is('#crsa-dummy-field');
        } catch(err) {

        }
        return false;
    }

    var shouldHandlePaste = function() {
        return !isInInput();
        /*
        if(crsaIsInEdit()) return false;
        var $a = $(document.activeElement);
        return !($a.is('input,textarea,[contenteditable="true"]') && !$a.is('#crsa-dummy-field'));
        */
    }

    var hiddenInput = $('#crsa-dummy-field');

    var hasSelection = function() {
        if(!isApp()) return false;
        var s = window.getSelection();
        var sel = s.toString();
        if(sel == hiddenText) return false;
        return sel.length;
    }

    var getRulesToCopy = function (deleteNodes) {
        var stylesheets = pinegrow.stylesheets.getAllCrsaStylesheets();
        var rulesString = "";

        var forAllStylesheet = function (stylesheets) {
            for (var i = 0; i < stylesheets.length; i++) {
                var cs = stylesheets[i];
                if (cs.sourceStylesheet) cs = cs.sourceStylesheet;

                if (cs.loaded) {
                    if (cs.stylePane) {
                        var lengthStr = rulesString.length;

                        // getCrsaPageForIframe($.fn.crsa('getSelectedPage')).undoStack.add("Edit CSS rule", false, cs);
                        rulesString += cs.stylePane.getStringOfSelectedItems(deleteNodes);

                        if (rulesString.length == lengthStr) {
                            // getCrsaPageForIframe($.fn.crsa('getSelectedPage')).undoStack.remove();
                        }

                        if (cs.importedFiles.length > 0) {
                            forAllStylesheet(cs.importedFiles);
                        }
                    }
                }
            }
        }

        forAllStylesheet(stylesheets);
        return rulesString;
    }

    var areCssRulesSelected = function () {
        var stylesheets = pinegrow.stylesheets.getAllCrsaStylesheets();

        var forAllStylesheet = function (stylesheets) {
            for (var i = 0; i < stylesheets.length; i++) {
                var cs = stylesheets[i];
                if (cs.sourceStylesheet) cs = cs.sourceStylesheet;

                if (cs.loaded) {
                    if (cs.stylePane && cs.stylePane.hasSelectedRules()) return true;

                    if (cs.importedFiles.length > 0) {
                        if (forAllStylesheet(cs.importedFiles)) return true;
                    }
                }
            }
            return false;
        }

        return forAllStylesheet(stylesheets);
    }

    // ==================
    //  @attribute_panel
    // ==================
    var getAttributesToCopy = function () {
        var $attributePanel = $('.attributes-panel');
        var pgFastEditor = $attributePanel.data('pg-fast-editor');
        // getCrsaPageForIframe($.fn.crsa('getSelectedPage')).undoStack.add("Add new attributes");
        return pgFastEditor.getStringOfSelectedItems('', '="', '" ');
    }

    var areAttributesSelected = function () {
        var $attributePanel = $('.attributes-panel');
        var $selectedItems = $attributePanel.find('.selected-item');
        return $selectedItems.length > 0;
    }
    // ======================
    //  END @attribute_panel
    // ======================

    var focusHiddenArea = function() {

        if(!isApp()) return; //dont use this online

        if(isInInput()) {
            return;
        }
        if(hasSelection()) {
            return;
        }
        //console.log(document.activeElement);
        hiddenInput.val(hiddenText);
        hiddenInput.get(0).focus();
        hiddenInput.get(0).select();
    };

    $(document).mouseup(focusHiddenArea);

    var clip_on_blur = null;

    this.onWindowBlur = function() {
        clip_on_blur = getClipboardContent();
    }

    this.onWindowFocus = function() {
        var c = getClipboardContent();
        if(clip_on_blur != c) {
            addFromClipboard('system');
            clip_on_blur = c;
        }
    }

    /*
    setTimeout(function() {
        var gui = require('nw.gui');

        gui.Window.get().on('blur', function() {

        })
        gui.Window.get().on('focus', function() {

        })
    }, 2000)

*/

/*
    ['cut', 'copy', 'paste'].forEach(function(event) {
        document.addEventListener(event, function(e) {
            console.log(event);
            //focusHiddenArea();
            e.preventDefault();
        });
    });
    */
}

var PgClipboardView = function() {

    var clipboard = pinegrow.getClipboard();

    var $c = $('<div class="clipboard-view"></div>');

    var $element = $c;

    var view = new PgUIView($element);
    this.view = view;
    var _this = this;

    var placement_field = new PgInputField('clipboard-placement', {
        type: 'select',
        show_empty: false,
        name: 'On paste',
        //system_field: true,
        options: [
            {key: 'append', name: 'append'},
            {key: 'prepend', name: 'prepend'},
            {key: 'insertBefore', name: 'insert before'},
            {key: 'insertAfter', name: 'insert after'}
        ]
    });

    placement_field.setValue(clipboard.getPlacement());

    placement_field.on('change', function(e) {
        clipboard.setPlacement( placement_field.getValue());
    })

    placement_field.appendTo($c);

    var $list = $('<ul class="clipboard-list"></ul>').appendTo($c);

    var onClipboardChanged = function(page, item) {
        paint();
    }

    var onClipboardItemSelected = function(page, current) {
        highlightCurrent(current);
    }

    pinegrow.addEventHandler('on_clipboard_changed', onClipboardChanged);
    pinegrow.addEventHandler('on_clipboard_item_selected', onClipboardItemSelected);

    var highlightCurrent = function(idx) {
        $list.find('li.current').removeClass('current');
        var $items = $list.children();
        if($items.length > idx) {
            $($items.get(idx)).addClass('current');
        }
    }

    var paint = function() {
        var list = clipboard.getAll();
        var current = clipboard.getCurrentIndex();

        $list.html('');

        var getItem = function(e) {
            var $item = $(e.delegateTarget).closest('li');
            var idx = $item.data('item-index');
            if(idx >= 0 && idx < list.length) {
                return {$item: $item, item: list[idx], idx: idx};
            }
            return null;
        }

        for(var i = 0; i < list.length; i++) {
            var $item = $('<li><div class="selector"></div>' + list[i].name + '</li>').data('item-index', i).appendTo($list);

            var $paste = $('<i class="control paste-control icon icon-right-arrow"></i>')
                .appendTo($item)
                .on('click', function(e) {
                    e.preventDefault();
                    e.stopPropagation();
                    e.stopImmediatePropagation();
                    var d = getItem(e);
                    if(d) {
                        clipboard.paste(d.item);
                    }
                });

            addTooltip($paste, 'Paste the item');

            var $sticky = $('<i class="control sticky-control icon icon-Pin"></i>')
                .appendTo($item)
                .on('click', function(e) {
                    e.preventDefault();
                    e.stopPropagation();
                    e.stopImmediatePropagation();
                    var d = getItem(e);
                    if(d) {
                        d.item.sticky = !d.item.sticky;
                        if(d.item.sticky) {
                            d.$item.addClass('sticky');
                        } else {
                            d.$item.removeClass('sticky');
                        }
                    }
                });

            addTooltip($sticky, 'Keep the clipboard item in the same position.');

            if(list[i].sticky) {
                $item.addClass('sticky');
            }


            if(i == current) $item.addClass('current');

            $item.on('click', function(e) {
                e.preventDefault();
                var d = getItem(e);
                if(d) {
                    $list.find('li.current').removeClass('current');
                    d.$item.addClass('current');
                    clipboard.select(d.idx);
                }
            })
        }
    }
    this.show = function() {
        paint();
    }

    view.onDestroy = function() {
        pinegrow.removeEventHandler('on_clipboard_changed', onClipboardChanged);
        pinegrow.removeEventHandler('on_clipboard_item_selected', onClipboardItemSelected);
    }
}

var PgQuickClipboard = function() {

    var v = new PgClipboardView();

    var win = new PgQuickWindow('Clipboard', v, 'quickClipboard', 320, 320);

    win.showAtPosition(200, 200);

    v.show();

    win.onDestroy = function() {
        pinegrow.showNotice('<p>Use <b>Edit -&gt; Show clipboard</b> to show the Clipboard again.</p>', 'Show clipboard', 'show-clipboard-3', null, true);
    }

}


var PgInputField = function(key, def) {

    var _this = this;

    this.$field = $.fn.crsa('addInputField', null, null, key, def, {}, true);
    this.$input = this.$field.find('input.crsa-input,textarea.crsa-input');

    if(def.type === 'selector' || def.type === 'menu') {
        this.$input = this.$field.find('input');
    }

    if(this.$input.length === 0) {
        this.$input = this.$field.find('.crsa-input');
    }

    if(!this.$input.length) {
        this.$input = this.$field.find('input');
    }

    this.on = function(event, func) {
        this.$input.on(event, func);
    }

    this.on('input', function() {
        validate();
        resizeInputField();
    })

    this.show = function() {
        pg$Show(this.$field, 'flex');
    }

    this.hide = function() {
        pg$Hide(this.$field);
    }

    this.setValue = function(value) {
        this.$input.attr('type') === 'checkbox' ? this.$input.prop('checked', (value == def.value) ? true : false) : this.$input.val(value);
        this.$input.trigger('crsa-field-value-updated');
        validate();
        resizeInputField();
    }

    this.getValue = function() {
        //return this.$input.val();
        return this.$input.is('[type="checkbox"]') ? (this.$input.prop('checked') ? def.value : ('neg_value' in def ? def.neg_value : null)) : this.$input.val();
    }

    this.appendTo = function($c) {
        this.$field.appendTo($c);
    }

    this.prependTo = function($c) {
        this.$field.prependTo($c);
    }
    /* Use CSS instead for PgInput */

    this.setWidth = function(w) {
        this.$input.find('.selector-container').css('width', w + 'px');
    }

    this.focus = function(at_end) {
        var input = this.$input.get(0);
        at_end && input.setSelectionRange(input.value.length, input.value.length);
        input.focus();
    }

    this.blur = function() {
        this.$input.get(0).blur();
    }

    var $error = null;
    var error_shown = false;

    this.setError = function(err) {
        if(err) {
            if(!$error) $error = $(`<p class="error-message"></p>`).appendTo(this.$field);
            $error.html(err);
            if(!error_shown) {
                pg$Show($error);
                this.$field.addClass('error');
                error_shown = true;
            }
        } else {
            if($error && error_shown) {
                pg$Hide($error);
                this.$field.removeClass('error');
                error_shown = false;
            }
        }
    }

    var validate = function() {
        if(def.validate) {
            if(!$error) $error = $(`<p class="error-message"></p>`).appendTo(_this.$field).hide();
            var val = _this.getValue();
            pinegrow.validateField({}, key, val, def, _this.$field, {key: val});
        }
    }

    var resizeInputField = function() {
        if(!def.auto_resize) return;

        var $field = _this.$input;
        var maxw = $field.data('start-width');
        if(!maxw) {
            maxw = $field.width();
            $field.data('start-width', maxw);
        }

        var text = $field.val();
        var inputWidth = parseInt(maxw);

        var w = pgMeasureTextWidth(text);

        if(w > inputWidth || true) {
            var fw = 20;
            if (text === "") {
                _this.$field.css('width', fw + 'px');
            }
            else {
                fw = (w + 30);
                _this.$field.css('width', fw + 'px');
            }
        } else {
            _this.$field.css('width', '');
        }
    }
}

var PgLastActivePage = function() {
    var page = null;
    var onChanged = null;

    this.setPage = function(p, on_changed) {
        //console.log('last active page is ' + (p ? p.name : 'NULL'))
        if(page !== p && onChanged) {
            onChanged();
        }
        page = p;
        onChanged = on_changed;
    }

    this.getPage = function() {
        return page || pinegrow.getSelectedPage();
    }

    this.closePage = function(p) {
        if(page === p) {
            page = null;
            onChanged = null;
        }
    }
}