$(function() {

    if(!pgf.edit_css) return;

    $('body').one('pinegrow-ready', function (e, pinegrow) {

        var f = new PgFramework('pg.image.overlay', 'Image overlay');
        pinegrow.addFramework(f);

        //f.setScriptFileByScriptTagId('plugin-pg-image-overlay', 'lib/crsa/tools/pg.image.overlay.js');

        f.default = true;
        f.show_in_manager = false;
        f.not_main_types = true;

        var attr = 'data-pg-overlay';

        var withOverlay = function(body, func) {
            if(body) {
                body.get$DOMElements().forEach(function ($b) {
                    var $o = $b.find('> .pg-image-overlay');
                    func($b, $o.length > 0 ? $o : null);
                })
            }
        }

        var setup = function() {
            f.requireSelectedPage(function(page) {
                var pgel = page.sourceNode.findOne('body');
                if(!pgel) {
                    pinegrow.showQuickMessage('BODY element is required.');
                } else {
                    var q = PgQuickProperties([def.sections['pg.image.overlay']], pgel, null, 'Setup image overlay', 500, true, 120, [def]);
                }
            })
        }

        var hasOverlay = function() {
            var page = pinegrow.getSelectedPage();
            var body = page.sourceNode.findOne('body');
            return body && body.hasAttribute(attr);
        }

        var helper = new PgPageViewHelper('Image overlay <extracmd class="pg-image-overlay-setup"><i class="icon icon-settings"></i></extracmd>', 'pg-image-overlay', 'pg-internal-page-view-image-overlay', null, null, '0', f);

        helper.onChange = function(v) {
            if(!hasOverlay()) {
                setup();
            }
        }

        helper.onExtraCmd = function() {
            setup();
        }

        var update = function(pgel) {
            var body, page;
            if(!pgel) return;
            page = pgel.getPage();
            if(pgel.tagName != 'body') {
                body = page.sourceNode.findOne('body');
            } else {
                body = pgel;
            }

            if(!body) return;

            var src = body.getAttribute(attr);
            var append = true || body.getAttribute(attr + '-append');
            var tint = 'rgba(255,30,30,0.5)';
            var bw = false;
            var opacity = body.getAttribute(attr + '-opacity') || '0.5';
            var x = body.getAttribute(attr + '-x') || '0';
            var y = body.getAttribute(attr + '-y') || '0';
            var gray = parseInt(body.getAttribute(attr + '-gray') || '0');

            if(src) {
                withOverlay(body, function($b, $o) {
                    if(!$o) {
                        $o = $('<div class="pg-image-overlay pinegrow-ui-helper"><div class="pg-image-overlay-tint"></div></div>');
                        $o.appendTo($b);
                    }
                    var $tint = $o.find('> .pg-image-overlay-tint');

                    if($o.next().length > 0) {
                        if (append) {
                            $o.appendTo($b);
                        } else {
                            $o.prependTo($b);
                        }
                    }
                    var o = $o.get(0);
                    var bck = 'url(\'' + pinegrow.getProxyUrl(src) + '\')';

                    var style = 'background-image:' + bck + ';';

                    if(o.style.backgroundImage != bck) {
                        o.style.backgroundImage = bck;
                    }
                    if(o.style.opacity != opacity) {
                        o.style.opacity = opacity;
                    }
                    style += 'opacity:' + opacity + ';';

                    var pos = x + ' ' + y;
                    if(o.style.backgroundPosition != pos) {
                       o.style.backgroundPosition = pos;
                    }

                    var filter = gray > 0 ? 'grayscale(' + gray + '%)' : '';
                    if(o.style.filter != filter) {
                        o.style.filter = filter;
                    }
                    style += 'background-position:' + pos + ';';

                    //$o.attr('style', style);
                    $b.addClass('pghelper-image-overlay-body');

                   // $tint.attr('style', 'background-color:' + tint + ';');

                })
            } else {
                withOverlay(body, function($b, $o) {
                    if($o) $o.remove();
                    $b.removeClass('pghelper-image-overlay-body');
                })
            }
        }

        var def = new PgComponentType('pg.overlay', 'Body overlay', {
            selector : null,
            not_main_type: true,
            sections : {
                'pg.image.overlay': {
                    name: 'Image overlay',

                    fields: {
                        'pg.image.overlay.src' : {
                            name: 'Image',
                            type: 'image',
                            file_picker: true,
                            file_picker_no_proxy: true,
                            action: 'element_attribute',
                            attribute: attr,
                            on_changed: update
                        },
                        'pg.image.overlay.opacity': {
                            name: 'Opacity',
                            type: 'slider',
                            action: 'element_attribute',
                            slider_def_unit: '',
                            slider_step: 0.1,
                            slider_min: 0,
                            slider_max: 1.0,
                            attribute: attr + '-opacity',
                            on_changed: update
                        },
                        'pg.image.overlay.gray': {
                            name: 'Grayscale',
                            type: 'slider',
                            action: 'element_attribute',
                            slider_def_unit: '%',
                            //slider_step: 10,
                            slider_min: 0,
                            slider_max: 100,
                            attribute: attr + '-gray',
                            placeholder: '0%',
                            on_changed: update
                        },
                        'pg.image.overlay.x': {
                            name: 'X',
                            type: 'slider',
                            action: 'element_attribute',
                            slider_def_unit: 'px',
                            attribute: attr + '-x',
                            on_changed: update
                        },
                        'pg.image.overlay.y': {
                            name: 'Y',
                            type: 'slider',
                            action: 'element_attribute',
                            slider_def_unit: 'px',
                            attribute: attr + '-y',
                            on_changed: update
                        },
                        'pg.image.overlay.remove' : {
                            'type' : 'button',
                            'action': 'button',
                            'name' : 'Remove overlay',
                            'func' : function(pgel, $button) {
                                pinegrow.makeChanges(pgel, 'Remove image overlay', function() {
                                    pgel.removeAttrIfStartsWith(attr, true);

                                    /*
                                    pgel.getAttrList().slice().forEach(function(i) {
                                        if(i.name.startsWith(attr)) {
                                            pgel.removeAttribute(i.name);
                                        }
                                    })*/

                                })
                                $button.trigger('crsa-field-value-changed');
                                $button.trigger('crsa-refresh-properties');

                                update(pgel);
                            }
                        }
                    }
                }
            }
        });
        f.addComponentType(def);

        f.on_plugin_activated = f.on_page_shown_in_live_view = function(page) {
            update(page.sourceNode);
        }

        f.on_set_inline_style = function(page, o) {
            o.css += '\
            .pg-image-overlay {\
            position: absolute;\
            top: 0;\
            left: 0;\
            right:0;\
            bottom:0;\
            opacity: 0.5;\
            background-repeat:no-repeat;\
            background-attachment:left top;\
            pointer-events:none;\
            display:none;\
            }\
            .pg-image-overlay-tint {\
                position:absolute;\
                top: 0;\
                left: 0;\
                right:0;\
                bottom:0;\
            }\
            .pghelper-image-overlay-body {\
            position: relative;\
            }\
            .pg-internal-page-view-image-overlay .pg-image-overlay{\
                display:block;\
            }\
            ';
        }
    })
})


