/*
Not used anymore. Golden Layout instead.
 */
var PgPanelManager = function() {

    var _this = this;

    var last_x = 0;
    var last_y = 0;
    var next_offset_x = 60;
    var next_offset_y = 60;

    var $win = $(window);

    var top_z_index = 100;

    var panels = [];

    var groups = [];

    this.findGroupForPanel = function(panel) {
        for(var i = 0; i < groups.length; i++) {
            if(groups[i].indexOf(panel) >= 0) return groups[i];
        }
        return null;
    }

    var areGroupsEqual = function(a, b) {
        if(a.length != b.length) return false;
        for(var i = 0; i < a.length; i++) {
            if(b.indexOf(a[i]) < 0) return false;
        }
        return true;
    }

    var findGroup = function(group) {
        for(var i = 0; i < groups.length; i++) {
            if(areGroupsEqual(group, groups[i])) return groups[i];
        }
        return null;
    }

    var removePanelFromGroup = function(group, panel) {
        var idx = group.indexOf(panel);
        if(ids >= 0) {
            group.splice(idx, 1);
        }
    }

    var arePanelsInSameGroup = function(list) {
        var group = _this.findGroupForPanel(list[0]);
        if(!group) return null;
        for(var i = 1; i < list.length; i++) {
            if(group.indexOf(list[i]) < 0) return null;
        }
        return group;
    }

    var combineGroups = function(a, b) {
        var c = a.concat(b);
        var idx = groups.indexOf(a);
        if(idx >= 0) groups.splice(idx, 1);
        idx = groups.indexOf(b);
        if(idx >= 0) groups.splice(idx, 1);
        groups.push(c);
    }

    this.updateGroups = function(moved_panel) {
        var original_group = moved_panel && this.findGroupForPanel(moved_panel);

        groups = [];
        panels.forEach(function(panel) {
            var group = _this.findGroupForPanel(panel);
            findPanelsSnappedToPanel(panel).forEach(function(snap_info) {
                if(!group) {
                    group = [];
                    groups.push(group);
                }
                if(group.indexOf(snap_info.panel) < 0) {
                    group.push(snap_info.panel);
                }
            })
        })
        groups.forEach(function(group) {
            group.sort(function(a,b) {
                var a_pos = a.getPosition();
                var b_pos = b.getPosition();
                if(Math.abs(a_pos.top - b_pos.top) < 2) {
                    if(a_pos.z < b_pos.z) {
                        return 1;
                    } else if(a_pos.z > b_pos.z){
                        return -1;
                    } else return 0;
                } else if(a_pos.top < b_pos.top) {
                    return -1;
                } else if(a_pos.top > b_pos.top) {
                    return 1;
                } else {
                    return 0;
                }
            })
        })

        if(original_group && original_group.length > 2) {
            if(!findGroup(original_group)) {
                //original group was disbanded. All panels from the
            }
        }
    }

    this.updateGroupLayout = function(group) {
        var top = null;
        var left = null;
        group.forEach(function(panel) {
            var p = panel.getPosition();
            if(top === null) {
                top = p.top;
                left = p.left;
            } else {
                if(p.top != top || p.left != left) {
                    panel.setPosition({top: top, left: left});
                }
            }
            top += panel.getSize().height + 1;
        })
    }

    this.updateLayoutForAllGroups = function() {
        groups.forEach(function(group) {
            _this.updateGroupLayout(group);
        })
    }

    this.addPanel = function(panel) {
        panels.push(panel);
    }

    this.getPositionForNewPanel = function(panel) {
        var panel_size = panel.getSize();
        var win_w = $win.width();
        var win_h = $win.height();

        last_x += next_offset_x;
        last_y += next_offset_y;

        if(last_x + panel_size.width > win_w) {
            last_x = 100;
        }
        if(last_y + panel_size.height > win_h) {
            last_y = 100;
        }
        return {left: last_x, top: last_y};
    }

    this.getTopZIndex = function() {
        return top_z_index++;
    }

    this.panelStartedMoving = function(panel) {
        var group = this.findGroupForPanel(panel) || [panel];

        group.forEach(function(p) {
            p.putOnTop();
        });
    }

    this.panelMoved = function(panel) {
        var group = this.findGroupForPanel(panel) || [panel];

        group.forEach(function(p) {
            var snaps = findPanelsSnappedToPanel(p, group);
            if(snaps.length) {
                var list = snaps.map(function(i) { return i.snap });
                p.showSnaps(list);
            } else {
                p.showSnaps(null);
            }
        })

        if(group) {
            var idx = group.indexOf(panel);
            var moved = [];
            for(var i = idx; i < group.length; i++) {
                moved.push(group[i]);
            }
            this.updateGroupLayout(moved);
        }
    }

    this.panelMoveEnded = function(panel) {
        this.panelMoved(panel);
        this.updateGroups();
        this.updateLayoutForAllGroups();
    }

    this.panelSizeChanged = function(panel) {
        var group = this.findGroupForPanel(panel);
        if(group) {
            this.updateGroupLayout(group);
        }
    }

    var findPanelsSnappedToPanel = function(panel, ignore_panels) {
        var r = [];

        var panel_pos = panel.getPosition();
        var panel_size = panel.getSize();

        var precision = 4;

        panels.forEach(function(p) {
            if(p != panel && (!ignore_panels || ignore_panels.indexOf(p) < 0)) {
                var p_pos = p.getPosition();
                var p_size = p.getSize();

                var snaps = [];

                var vert_overlap = false;

                if(p_pos.left >= panel_pos.left && p_pos.left <= panel_pos.left + panel_size.width) {
                    vert_overlap = p_pos.left
                }

                vert_overlap = Math.abs(p_pos.left - panel_pos.left) <= precision || Math.abs(p_pos.left + p_size.width - panel_pos.left - panel_size.width) <= precision;

                if(vert_overlap) {
                    //top?
                    if(Math.abs(p_pos.top + p_size.height - panel_pos.top) <= precision) {
                        snaps.push('top');
                    }
                    //bottom?
                    if(Math.abs(p_pos.top - (panel_pos.top + panel_size.height)) <= precision) {
                        snaps.push('bottom');
                    }
    /*
                    //left?
                    if(Math.abs(p_pos.left + p_size.width - panel_pos.left) <= precision) {
                        snaps.push('left');
                    }

                    //right?
                    if(Math.abs(p_pos.left - (panel_pos.left + panel_size.width)) <= precision) {
                        snaps.push('right');
                    }
                    */
                }

                if(snaps.length) {
                    r.push({panel: p, snap: snaps[0]});
                }
            }
        })
        return r;
    }

    var highlightSnaps = function(panels) {
        panels.forEach(function(p) {

        })
    }
}





var PgPanel = function(title, manager) {

    this.title = title;
    this.visible = false;

    var _this = this;

    var html = '<div class="panel">\
        <div class="panel-head"><i class="fa fa-bars"></i><span>' + title + '</span></div>\
        <div class="panel-content"></div>\
        <!--<div class="panel-subpanels"></div>-->\
    </div>';

    var $panel = $(html).appendTo($('body'));
    var $head = $panel.find('> .panel-head');
    var $content = $panel.find('> .panel-content');

    $panel.on('click', function(event) {
        _this.putOnTop();
    })

    this.isCollapsed = function() {
        return $panel.hasClass('panel-collapsed');
    }

    $head.on('dblclick', function(e) {
        if(!_this.isCollapsed()) {
            $panel.addClass('panel-collapsed');
        } else {
            $panel.removeClass('panel-collapsed');
        }
        manager.panelSizeChanged(_this);
    })

    $panel.draggable({
        handle: '.panel-head',
        scroll: false,
        //snap: '.panel',
        //connectToSortable: '.panel-subpanels'
    })
        .on('dragstart', function(e, ui) {
            if(ui) {
                $.fn.crsapages('showOverlays');
            }
            manager.panelStartedMoving(_this);
        })
        .on('drag', function(e, ui) {
            if(ui) {
                //_this.autoSize(ui.offset);
            }
            manager.panelMoved(_this);
        })
        .on('dragstop', function(e, ui) {
            if(ui) {
                $.fn.crsapages('showOverlays', true);
            }
            _this.showSnaps(null);
            manager.panelMoveEnded(_this);
        });

    $panel.find('.panel-subpanels').sortable();

    manager.addPanel(this);

    this.setTitle = function(title) {
        this.title = title;
        $head.find('span').html(title);
    }

    this.setContent = function($el) {
        $content.empty().append($el);
    }

    this.addSubpanel = function(panel) {

    }

    this.getSize = function() {
        return {width: $panel.width(), height: $panel.height()};
    }

    this.getPosition = function() {
        var r = $panel.offset();
        r.z = $panel.css('z-index');
        return r;
    }

    this.setPosition = function(pos) {
        $panel.css(pos);
    }

    this.showSnaps = function(snaps) {
        $panel.removeClass('panel-snap-top panel-snap-bottom');
        if(snaps) {
            snaps.forEach(function(snap) {
                $panel.addClass('panel-snap-' + snap);
            })
        }
    }

    var first_show = true;

    this.show = function() {
        if(first_show) {
            first_show = false;
            this.setPosition( manager.getPositionForNewPanel(this));
        }
        $panel.show();
        this.putOnTop();
        this.visible = true;
    }

    this.putOnTop = function() {
        $panel.css('z-index', manager.getTopZIndex());
    }

}

var PgDraggable = function($panel) {

    $panel.attr('draggable', 'true');
}

var testGoldenLayout = function() {
    //test golden layout
    var config = {
      settings: {
          showPopoutIcon: false,
          showMaximiseIcon: false,
          showCloseIcon: false
      },
      content: [{
        type: 'row',
        content: [
            {
                type: 'stack', // Stack
                width: 15,
                isClosable: false,
                content: [
                    {
                    type:'component',
                    componentName: 'lib_panel',
                    componentState: { text: 'Component 1' },
                    title: 'LIB',
                    isClosable: false
                    },
                    {
                    type:'component',
                    componentName: 'css_panel',
                    componentState: { text: 'Component 1' },
                    title: 'CSS',
                    isClosable: false
                    },
                    {
                    type:'component',
                    componentName: 'act_panel',
                    componentState: { text: 'Component 1' },
                    title: 'ACT',
                    isClosable: false
                    },
                    {
                    type:'component',
                    componentName: 'cms_panel',
                    componentState: { text: 'Component 1' },
                    title: 'WP',
                    isClosable: false
                    },
                    {
                    type:'component',
                    componentName: 'project_panel',
                    componentState: { text: 'Component 1' },
                    title: 'PRJ',
                    isClosable: false
                    },
                ]
            },
            {
            type:'component',
            componentName: 'canvas',
            componentState: { text: 'Component 1' },
            title: 'PAGES'
            },
          {
                type:'component',
                componentName: 'tree',
                componentState: { text: 'Component 3' },
                title: 'TREE',
                width: 15
            },
            {
                type: 'stack', // Stack
                width: 17,
                isClosable: false,
                isFloating: true,
                content: [
                    {
                        type: 'component',
                        componentName: 'prop_panel',
                        componentState: {text: 'Component 1'},
                        title: 'PROP',
                        isClosable: false
                    },
                    {
                        type: 'component',
                        componentName: 'attr_panel',
                        componentState: {text: 'Component 1'},
                        title: 'ATTR',
                        isClosable: false
                    }
                ]
            }
        ]
      }]
    };

    var myLayout = new GoldenLayout( config );

    var ensureFloatingPanelIsVisible = function(element) {
        var win_w = window.innerWidth;
        var win_h = window.innerHeight;
        var el_pos = element.offset();
        var el_w = element.width();
        var el_h = element.height();

        var $gl = element.closest('.lm_goldenlayout');
        var gl_pos = $gl.offset();

        el_pos.top -= gl_pos.top;

        var changed = false;

        if(el_pos.top < -gl_pos.top) {
            el_pos.top = -gl_pos.top;
            changed = true;
        }

        var atleast_y = 40;
        if(win_h - el_pos.top  - gl_pos.top < atleast_y) {
            el_pos.top = win_h - atleast_y - gl_pos.top;
            changed = true;
        }

        var atleast_x = 40;
        if(el_pos.left + el_w< atleast_x) {
            el_pos.left = -el_w + atleast_x;
            changed = true;
        }

        if(el_pos.left > win_w - atleast_x) {
            el_pos.left = win_w - atleast_x;
            changed = true;
        }

        if(changed) {
            element.addClass('lm_floating_animate');
            element.css({
                left: el_pos.left + 'px',
                top: el_pos.top + 'px'
            })
            setTimeout(function() {
                element.removeClass('lm_floating_animate');
            }, 500)
        }
    }

    myLayout.on( 'stackCreated', function( stack ){
        /*
         * Re-use the label
         */
        var label = stack.layoutManager.config.labels.popout;

        /*
         * Callback when the user clicks the popout button
         */
        stack.popout = function() {
            /*
             * The currently selected item - that's the one you'd want to pop out
             */
            var item = stack.header.activeContentItem;

            item = stack;

            /**
             * Remove the item as a child from the stack. true indicates that we DON'T
             * want the item to be destroyed
             */
            //stack.removeChild( item, true );

            //$('body').append(item.element);

            var new_column = myLayout._$normalizeContentItem({
                title: 'KOLI',
                type: 'column',
                componentName: 'kolicol',
                componentState: { text: 'Ha' }
            });

/*
            var new_stack = myLayout._$normalizeContentItem({
                title: 'KOLI',
                type: 'stack',
                componentName: 'koli',
                componentState: { text: 'Ha' }
            });
            */
            new_column.isFloating = true;
            myLayout.root.contentItems[ 0 ].addChild( new_column );
            stack.parent.removeChild( stack, true );

            new_column.element.css({
                position: 'absolute',
                left: '100px',
                top: '100px',
                border: '1px solid orange',
                height: '500px'
            })

            var drag_header = $('<div class="lm_header"></div>');

            new_column.element.prepend(drag_header);

            new_column.element.addClass('lm_floating');

            var drag = new GoldenLayout.__lm.utils.DragListener(drag_header);

            var original_x = 0;
            var page_offset_y = 0;
            var el_offset_x = 0;
            var el_offset_y = 0;

            drag.on( 'dragStart', function(x, y) {
                var $gl = new_column.element.closest('.lm_goldenlayout');
                var gl_pos = $gl.offset();
                page_offset_y = gl_pos.top;

                var el_pos = new_column.element.offset();
                el_offset_x = x - el_pos.left;
                el_offset_y = y - el_pos.top;

                $.fn.crsapages('showOverlays');
            }, this );

            drag.on( 'drag', function(x, y, event) {
                x = event.pageX;
			    y = event.pageY;

                new_column.element.css({
                    left: (x - el_offset_x) + 'px',
                    top: (y - page_offset_y - el_offset_y) + 'px'
                })
            }, this );

            drag.on( 'dragStop', function(x, y) {
                $.fn.crsapages('showOverlays', true);
                ensureFloatingPanelIsVisible(new_column.element);
            }, this );

            new_column.addChild(stack);
            //new_stack.addChild(item);
        };

        new GoldenLayout.__lm.controls.HeaderButton( stack.header, label, 'lm_popout', stack.popout );

        if(stack.config.isFloating) {
           // setTimeout(function() {
                stack.popout();
           // }, 100);
        }
    });

    myLayout.registerComponent( 'example', function( container, state ){
      var el = container.getElement().append($('#crsa-left-plane'));
    });

    myLayout.registerComponent( 'canvas', function( container, state ){
      var el = container.getElement().append($('.canvas'));
    });

    myLayout.registerComponent( 'tree', function( container, state ){
      var el = container.getElement().append($('#crsa-tree'));
    });

    myLayout.registerComponent( 'lib_panel', function( container, state ){
      var el = container.getElement().append($('#crsa-elements'));
    });

    myLayout.registerComponent( 'prop_panel', function( container, state ){
      var el = container.getElement().append($('#crsa-properties'));
    });

    myLayout.registerComponent( 'attr_panel', function( container, state ){
        var el = container.getElement().append($('.attributes-panel'));
    });

    myLayout.registerComponent( 'css_panel', function( container, state ){
      var el = container.getElement().append($('#crsa-rules'));
    });

    myLayout.registerComponent( 'act_panel', function( container, state ){
      var el = container.getElement().append($('#crsa-actions'));
    });

    myLayout.registerComponent( 'cms_panel', function( container, state ){
      var el = container.getElement().append($('#crsa-cms'));
    });

    myLayout.registerComponent( 'project_panel', function( container, state ){
      var el = container.getElement().append($('#crsa-project'));
    });


    myLayout.init();

    $('#crsa-left-plane').detach();
}
/*
$(function() {
    var pgPanelManagerInstance = new PgPanelManager();

    for(var i = 0; i < 4; i++) {
        var testPanel = new PgPanel('My cute panel ' + (i + 1), pgPanelManagerInstance);
        testPanel.setContent($('<p>The 7 day trial of PRO features (projects, master pages and components) started! The trial of PRO features just ended. Please upgrade to the PRO edition to continue using projects, master pages and components.</p>'));
        testPanel.show();
    }


})
*/

var PgToggleButtonMaker = function() {

    var getStyles = function(options) {
        if(!options) return '';
        var s = '';
        $.each(options, function(f, k) {
            s += f + ':' + k + ';';
        })
        return s;
    }

    var getElement = function(styles, text, classes, tag) {
        text = text || '';
        tag = tag || 'div';
        return '<' + tag + ' class="pg-tb-button' + (classes ? (' ' + classes) : '') + '" style="' + getStyles(styles) + '">' + text + '</' + tag + '>';
    }

    this.makeColor = function(color, text, options) {
        var def = {
            'border-radius': '8px',
            'width': '16px',
            'height': '16px',
            'background-color': color || 'transparent'
        }
        return getElement($.extend({}, def, options), text, 'pg-tb-button-color');
    }

    this.makeColorText = function(color, text, options) {
        var opts = {
            color: color
        }
        return this.makeColor(null, text, $.extend({}, opts, options));
    }

    this.makeText = function(text, options) {
        return getElement(options, text, 'pg-tb-button-text');
    }

    this.makeIcon = function(icon, options) {
        return getElement(options, '', 'pb-tb-button-icon fa fa-' + icon, 'i');
    }


}


var PgToggleButtons = function($cont, options) {

    var def = {
        input_type: 'hidden',
        compact: true
    }

    var settings = $.extend({}, def, options);

    var $list = $(`<div class="pg-tb${setting.compact ? ' pg-tb-compact' : ''}"></div>`).appendTo($cont);
    var $input = $('<input type="hidden">').appendTo($cont);

    var get$input = function() {
        if(!$input) {
            switch(settings.input_type) {
                case 'hidden':
                    $input = $('<input type="hidden">').appendTo($cont);
                    break;
                case 'checkbox':
                    $input = $('<input type="checkbox" value="' + settings.checkbox_value + '" style="display:none;">').appendTo($cont);
                    break;
            }
        }
    }

    var getInputValue = function() {
        switch(settings.input_type) {
            case 'hidden':
                return $input.val();
                break;
            case 'checkbox':
                return $input.is(':checked') ? settings.checkbox_value : null;
                break;
        }
    }

    var setInputValue = function(v) {
        switch(settings.input_type) {
            case 'hidden':
                $input.val(v);
                break;
            case 'checkbox':
                $input.prop("checked", v == settings.checkbox_value);
                break;
        }
    }


    this.options = [];

    var options = [];

    this.show_empty = false;

    var value = null;

    var _this = this;

    this.get$input = function() {
        return $input;
    }

    var shown = false;

    this.show = function() {
        if(typeof this.options == 'function') {
            options = this.options();
        } else {
            options = this.options;
        }
        get$input();
        addHandlers();
        update();
        shown = true;

        $input.on('crsa-field-value-updated', function(e) {
            _this.setValue($input.val());
        })
    }

    var current_node = null;
    var current_inherited = null;

    this.setValue = function(val) {
        value = val;
        if(shown) {
            current_node.classList.remove('active');
            if(val !== null) {
                current_node = $list.get(0).querySelector(`[data-item-key="${val}"]`);
                if(current_node) {
                    current_node.classList.add('active');
                }
            }
            //update();
        }
    }

    var update = function() {
        //$list.empty();
        var s = '';

        current_node = null;
        current_inherited = null;

        for(var i = 0; i < options.length; i++) {
            var html;
            if(options[i].html) {
                html = options[i].html;
            } else if(options[i].icon) {
                html = '<i class="fa fa-' + options[i].icon + '"></i>';
            } else {
                html = options[i].name;
            }
            s += '<div ' + (value == options[i].key ? 'class="active" ' : '') + 'data-item-id="' + i + '" data-item-key="' + options[i].key + '">' + html + '</div>';
        }

        $list.get(0).innerHTML = s;
    }

    var findItemIndexByKey = function(key) {
        for(var i = 0; i < options.length; i++) {
            if(options[i].key === key) return i;
        }
        return -1;
    }

    this.setInheritedValue = function(val, resp_label) {
        if(shown) {
            if (current_inherited) {
                current_inherited.classList.remove('inherited');
            }

            if (val) {
                current_inherited = $list.get(0).querySelector(`[data-item-key="${val}"]`);
                if(current_inherited) {
                    current_inherited.classList.add('inherited');
                    var label = current_inherited.querySelector('span.responsive-label');
                    if(!label) {
                        label = document.createElement("span");
                        label.classList.add('responsive-label');
                        inherited_value.append(label);
                    }
                    label.innerText = resp_label;
                }
            } else {

            }
        }
    }

    var addHandlers = function() {

        var $target;

        var getItem = function(event) {
            $target = $(event.target).closest('[data-item-id]');
            if($target.length) {
                var id = parseInt($target.attr('data-item-id'));
                return id < options.length ? options[id] : null;
            }
            return null;
        }

        $list.get(0).addEventListener('click', function(e) {
            var item = getItem(e);
            if(item) {
                if(_this.show_empty && $target.hasClass('active')) {
                    $target.removeClass('active');
                    setInputValue(null);
                } else {
                    $list.find('>div').removeClass('active');
                    $target.addClass('active');
                    setInputValue(item.key);
                }
                $input.trigger('change');
            }
        }, true);

    }
}

var PgCheckbox = function($cont, label, value) {

    var pm = new PgToggleButtonMaker();

    PgToggleButtons.call(this, $cont, {
        input_type: 'checkbox',
        checkbox_value: value
    });

    this.show_empty = true;

    this.options = [{
        key: value,
        name: label,
        html: pm.makeText(label)
    }]
}

PgCheckbox.prototype = Object.create(PgToggleButtons.prototype);
PgCheckbox.prototype.constructor = PgCheckbox;




window.pgCreateMediaQueryControl = function (standalone) {
    var $container = null, mediaQuery = null;
    var c = new PgCustomPropertyControl('css-media-query');
    var mediaDef = {
        type : 'media-query',
        name : '',
        action : 'rule_media',
        live_update : true,
        skip_handle_events : false
    };

    if(standalone) {
        mediaDef.skip_handle_events = true;
    }

    var mediaQueryBtn = ['icon-Xs', 'icon-Md', 'icon-Lg'];

    var getMediaParamsArr = function (params) {
        params = params || "";
        var mediaArr = params.split(' and ');
        mediaArr = mediaArr.filter(function (x) {
            if (x) return x;
        });

        if (mediaArr.length > 0) {
            if (mediaArr[0].indexOf("only") > -1 || mediaArr[0].indexOf("screen") > -1 || mediaArr[0].indexOf("print") > -1) {
                mediaArr[0] = mediaArr[0].split(' ');
                mediaArr = [].concat.apply([], mediaArr);
            }
        }

        return mediaArr;
    }

    var updateMediaView = function (params) {
        if (!$container) return;
        var mediaArr = getMediaParamsArr(params);

        var $browserCheckbox = $container.find('.browsers-input');
        var $typeSelect = $container.find('.type-input');

        var i = 0;
        if (mediaArr[i] == "only") {
            $browserCheckbox.prop('checked', true);
            i++;
        }
        else {
            $browserCheckbox.prop('checked', false);
        }

        if (mediaArr[i] == "screen" || mediaArr[i] == "print") {
            $typeSelect.val(mediaArr[i]);
            i++
        }
        else {
            $typeSelect.val("");
        }

        var $table = $container.find('.query-selector-container');
        $table.find('.btn').removeClass('active');
        var dirAndNum = mediaArr.splice(i, mediaArr.length);
        if (dirAndNum.length > 2) {
            return;
        }
        else {
            if (dirAndNum.length == 1) {
                var withoutBrackets = dirAndNum[0].replace(/[\(\)]/g, '');
                var arr = withoutBrackets.split(':');

                var direction = '';
                var number = parseInt(arr[1], 10);
                if (arr[0] == "max-width") {
                    direction = "smaller";
                    number++;
                }
                else if (arr[0] == "min-width") {
                    direction = "larger";
                }

                $table.find('[data-direction="' + direction + '"][data-number="' + number + '"]').addClass('active');
            }
            else if (dirAndNum.length == 2) {
                var withoutBrackets1 = dirAndNum[0].replace(/[\(\)]/g, '');
                var withoutBrackets2 = dirAndNum[1].replace(/[\(\)]/g, '');
                var arr1 = withoutBrackets1.split(':');
                var arr2 = withoutBrackets2.split(':');

                var direction = 'between', number = -1;
                var number1 = parseInt(arr1[1], 10);
                var number2 = parseInt(arr2[1], 10);
                if (arr1[0] == "min-width" && arr2[0] == "max-width") {
                    number = parseInt(arr1[1], 10) + ',' + (parseInt(arr2[1], 10) + 1);
                }
                else if (arr2[0] == "min-width" && arr1[0] == "max-width") {
                    number = parseInt(arr2[1], 10) + ',' + (parseInt(arr1[1], 10) + 1);
                }

                $table.find('[data-direction="' + direction + '"][data-number="' + number + '"]').addClass('active');
            }
        }
    }

    var buildMediaParam = function (params, type, frValue, sdValue) {
        var mediaArr = getMediaParamsArr(params);

        if (type == "browsers") {
            if (frValue) {
                if (mediaArr[0] != "only") mediaArr.splice(0, 0, "only");
            }
            else {
                if (mediaArr[0] == "only") mediaArr.splice(0, 1);
            }
        }
        else if (type == "type") {
            var i = 0;
            if (mediaArr[i] == "only") i++;

            if (mediaArr[i] == "screen" || mediaArr[i] == "print") {
                if (frValue) mediaArr[i] = frValue;
                else         mediaArr.splice(i, 1);
            }
            else {
                mediaArr.splice(i, 0, frValue);
            }
        }
        else if (type == "direction") {
            var i = 0;

            if (mediaArr[i] == "only") i++;
            if (mediaArr[i] == "screen" || mediaArr[i] == "print") i++;

            mediaArr.splice(i, mediaArr.length);

            if (frValue == "smaller" && sdValue) {
                mediaArr[i] = '(max-width: ' + (sdValue - 1) + 'px)';
            }
            else if (frValue == "larger" && sdValue) {
                mediaArr[i] = '(min-width: ' + sdValue + 'px)';
            }
            else if (frValue == "between" && sdValue) {
                sdValue = sdValue.split(',');
                var frBreakpoint = parseInt(sdValue[0]);
                var sdBreakpoint = parseInt(sdValue[1]);
                mediaArr[i] = '(min-width: ' + frBreakpoint + 'px) and (max-width: ' + (sdBreakpoint - 1) + 'px)';
            }
        }

        if (mediaArr[0] == "only") {
            if (mediaArr[1] == "screen" || mediaArr[1] == "print") {
                mediaArr[1] = "only " + mediaArr[1];
                mediaArr.splice(0, 1);
            }
            else {
                mediaArr[0] = "only screen";
            }
        }

        var newParams = mediaArr.join(' and ')
        updateMediaView(newParams);
        return newParams;
    }

    var createButton = function(from, to) {

    }

    var addBreakpointBtns = function (breakpoints) {
        if (!$container) return;
        var $tbody = $container.find('table > tbody');
        $tbody.html('');

        for (var i = 0; i < breakpoints.length; i++) {
            var currBreakpoint = parseInt(breakpoints[i], 10);

            var $rowContainer = $('<tr class="container-md"></tr>').appendTo($tbody);

            var iconIndex = i;
            if (i > mediaQueryBtn.length - 1) iconIndex = mediaQueryBtn.length - 1;
            $('<td><i class="icon ' + mediaQueryBtn[iconIndex] + '"></i></td>').appendTo($rowContainer);

            var $smallerMD = $('<td><a href="#" data-direction="smaller" data-number="' + currBreakpoint + '" class="btn pg-button add-btn"><i class="icon icon-131"></i> ' + currBreakpoint + ' px</a></td>').appendTo($rowContainer);
            var $largerMD  = $('<td><a href="#" data-direction="larger" data-number="' + currBreakpoint + '" class="btn pg-button add-btn">' + currBreakpoint + ' px <i class="icon icon-right-arrow"></i></a></td>').appendTo($rowContainer);

            if (i + 1 < breakpoints.length) {
                var nextBreakpoint = parseInt(breakpoints[i + 1], 10);
                var $betweenMD = $('<td><a href="#" data-direction="between" data-number="' + currBreakpoint + ',' + nextBreakpoint + '" class="btn pg-button add-btn">' + currBreakpoint + ' px <i class="icon icon-131"></i> ' + nextBreakpoint + ' px</a></td>').appendTo($rowContainer);
            }
        }

        $tbody.find('.btn').on('click', function (e) {
            var $btn = $(e.target).closest('.btn');

            if ($btn.hasClass('active')) {
                mediaParams = buildMediaParam(mediaParams, 'direction', $btn.data('direction'), '');

                $tbody.find('.btn').removeClass('active');
            }
            else {
                mediaParams = buildMediaParam(mediaParams, 'direction', $btn.data('direction'), $btn.data('number'));

                $tbody.find('.btn').removeClass('active');
                $btn.addClass('active');
            }

            mediaQuery.$field.find('input').val(mediaParams).trigger('change');
        });
    }

    c.onDefine = function() {
        this.registerInputField('media-query', mediaDef);
    }

    c.onShow = function() {
        $container = $('<div class="media-query-container"></div>');

        var $row = $('<div class="row media-query-row"></div>').appendTo($container);

        var $inputContainer = $('<div class="col-sm-9 input-container"></div>').appendTo($row);
        mediaQuery = this.showInputField($inputContainer, 'media-query', mediaDef);
        mediaQuery.$field.addClass('crsa-block-input');

        var $buttonContainer = $('<div class="col-sm-3 button-container"></div>').appendTo($row);
        var $button = $('<a href="#" class="btn pg-button add-btn">Select <i class="icon icon-down"></i></a>').appendTo($buttonContainer);

        var $querySelector = $('<div style="display: none;"><table class="query-selector-container"><tbody></tbody></table></div>').appendTo($container);
        var $table = $querySelector.find('> table');
        var $tbody = $table.find('> tbody');

        var $mediaTypeContainer = $('<div class="row media-type"></div>').appendTo($querySelector);
        var $selectBox = $('<div class="col-sm-5 select-container">\
                                        <select class="type-input">\
                                            <option value=""></option>\
                                            <option value="screen">Screen</option>\
                                            <option value="print">Print</option>\
                                        </select>\
                                    </div>').appendTo($mediaTypeContainer).find('> select');

        var $ignoreCheckbox = $('<div class="col-sm-7 checkbox-container">\
                                        <label><input type="checkbox" class="browsers-input"> Ignore in old browsers</label>\
                                    </div>').appendTo($mediaTypeContainer).find('input');

        var $manageBreakpointBtn = $('<div class="manage-breakpoints-container"><a href="#" class="btn btn-default add-btn">Manage Breakpoints</a></div>').appendTo($querySelector).find('.btn');

        $selectBox.on('change', function (e) {
            var $btn = $table.find('.btn.active');
            mediaParams = buildMediaParam(mediaParams, 'type', $selectBox.val());
            // mediaParams = buildMediaParam($btn.data('direction'), $btn.data('number'), $selectBox.val(), $ignoreCheckbox.is(':checked'));
            mediaQuery.$field.find('input').val(mediaParams).trigger('change');
        });

        $ignoreCheckbox.on('change', function (e) {
            var $btn = $table.find('.btn.active');
            mediaParams = buildMediaParam(mediaParams, 'browsers', $ignoreCheckbox.is(':checked'));
            // mediaParams = buildMediaParam($btn.data('direction'), $btn.data('number'), $selectBox.val(), $ignoreCheckbox.is(':checked'));
            mediaQuery.$field.find('input').val(mediaParams).trigger('change');
        });

        $button.on("click", function (e) {
            var open = $querySelector.hasClass('open');
            if (open) {
                $querySelector.slideUp();
                $querySelector.removeClass('open');
                $button.find('i').removeClass('icon-up').addClass('icon-down');
            }
            else {
                $querySelector.slideDown();
                $querySelector.addClass('open');
                $button.find('i').removeClass('icon-down').addClass('icon-up');
            }
        });

        $manageBreakpointBtn.on('click', function () {
            pinegrow.getSelectedPage().showManageBreakpoints();
        });

        return $container;
    }

    c.onSetValues = function() {
        mediaParams = this.values['media-query'];
        var page = pinegrow.getSelectedPage();
        if (page) {
            addBreakpointBtns(page.breakpoints);
            updateMediaView(mediaParams);
        }
    }

    $('body').on('crsa-breakpoints-changed', function (e, data) {
        var page = pinegrow.getSelectedPage();
        if (page) {
            addBreakpointBtns(page.breakpoints);
            updateMediaView(mediaParams);
        }
    });

    return c;
}