/*
- max-width on tabs to ...
--- dock at bottom of pages
--- hide splitter before col stack
- remember h in collapsed col stack
*/

var myLayout = null;

var testGoldenLayout = function() {

    var checkDropAreaFuncs = {
        pages: function(contentItem) {
            return contentItem.config.pages || false;
        },
        codeEditors: function(contentItem, a, b, c) {
            //console.log(a, b, c)
            if(a === 'header') return false;
            return true;
            return contentItem.config.codeEditors || false;
        },
        no_drop: function(contentItem, a, b, c) {
            if(a === 'header') return false;
            return true;
        }
    }

    var getNewStackDefForPages = function(stack, item) {
        var newStackDef = {
            isClosable: true,
            isFlexible: true, //will be resized by dockable actions,
            dontCollapseOnActiveTabClick: true,
            pages: true,
            addClass: 'pg-fullsize-item pg-page-area',
            notDraggable: true,
            validDropLocations: ".pg-page-area",
            checkDropArea: checkDropAreaFuncs.pages,
            getNewStackDef: getNewStackDefForPages,
            tabsNotDraggable: ui_not_draggable
        }
        if(item.config.componentName == 'pageview') {
            return newStackDef;
        } else {
            return {}
        }
    }

    var excludingPages = function(contentItem, a, b, c, d) {
//        console.log(contentItem, a)

        if(contentItem.config.noDropOthersInPositions && contentItem.config.noDropOthersInPositions.indexOf(a) >= 0) {
            console.log('cant drop')
            return false;
        }


        return !(contentItem.config.pages || contentItem.config.codeEditors || contentItem.config.dont_drop_stuff_here || false);
    }

    var ui_version = '2';

    var ui_not_draggable = pgf.kids || false;

    var defLib = {
        type:'component',
        componentName: 'lib_panel',
        componentState: { text: 'Component 1' },
        title: 'Library',
        isClosable: false,
        panel_key: 'library',
        panel_category: 'Essential',
        panel_description: 'Add elements and components to the page.',
        panel_icon: 'icon-import'
    }

    var defProject = {
        type:'component',
        componentName: 'project_panel',
        componentState: { text: 'Component 1' },
        title: 'Project',
        isClosable: false,
        panel_key: 'project',
        panel_category: 'Essential',
        panel_description: 'Manage project settings, files and folders.',
        panel_icon: 'icon-project'
    }

    var defVars = {
        type:'component',
        componentName: 'css_var_panel',
        componentState: { text: 'Component 1' },
        title: 'Vars',
        isClosable: false
    }

    var defHistory = {
        type:'component',
        componentName: 'history',
        componentState: { text: 'Component 1' },
        title: 'History',
        isClosable: false,
        panel_key: 'history',
        panel_category: 'Tools',
        panel_description: 'Move back and forward through the undo history.',
        panel_icon: 'icon-undo'
    }

    var defPages = {
        type: 'stack', // Stack
        isClosable: false,
        isFlexible: true, //will be resized by dockable actions,
        dontCollapseOnActiveTabClick: true,
        pages: true,
        addClass: 'pg-fullsize-item',
        notDraggable: true,
        content: [
        ],
        validDropLocations: ".pg-fullsize-item",
        checkDropAreaFunc: 'pages',
        //height: 10,
        getNewStackDef : getNewStackDefForPages
    }

    var defEditors = {
        type: 'stack',
        isClosable: false,
        notCollapsable: true,
        isHidden: true,
        dontCollapseOnActiveTabClick: true,
        height:50,
        width:20,
        codeEditors: true,
        checkDropAreaFunc: 'codeEditors',
        tabsNotDraggable : true,
        content: []
    }

    if(ui_not_draggable) {
        defPages.tabsNotDraggable = true;
        defEditors.tabsNotDraggable = true;
    }


    var defStatusBar = {
        type: 'stack', // Stack
        isClosable: false,
        dontCollapseOnActiveTabClick: true,
        noHeaders: true,
        fixedHeight: 32,
        noSplitter: true,
        noDropOthersInPositions: ['bottom', 'left', 'right'],
        //noDragDrop: true,
        addClass: 'pg-fullsize-item',
        content: [{
            type: 'component',
            componentName: 'status_bar',
            componentState: {text: 'Component 3'},
            title: 'Status bar',
            height: 100,
            noDragDrop: true
        }]
    }

    var defTree =  {
        type: 'component',
        componentName: 'tree',
        componentState: {text: 'Component 3'},
        title: 'Tree',
        isClosable: false,
        panel_key: 'tree',
        panel_category: 'Essential',
        panel_description: 'View and edit the structure of the HTML document.',
        panel_icon: 'icon-Pin11'
        //width: 15
    }

    var defCSSTree =  {
        type: 'component',
        componentName: 'css_tree',
        componentState: {text: 'Component 3'},
        title: 'CSS Tree',
        isClosable: false
        //width: 15
    }

    var defCSSTreeActive =  {
        type: 'component',
        componentName: 'css_tree_active',
        componentState: {text: 'Component 3'},
        title: 'CSS Tree Active',
        isClosable: false
        //width: 15
    }

    var defCSSVisual =  {
        type: 'component',
        componentName: 'css_visual',
        componentState: {text: 'Component 3'},
        title: 'CSS Visual Editor',
        isClosable: false
        //width: 15
    }

    //PG

    var defProp = {
        type: 'component',
        componentName: 'prop_panel',
        componentState: {text: 'Component 1'},
        title: pgf.kids ? 'Element attributes' : 'Element properties',
        isClosable: false,
        panel_key: 'prop',
        panel_category: 'Essential',
        panel_description: 'Edit element attributes and use framework visual controls.',
        panel_icon: 'icon-settings'
    }

    var defStyle = {
        type:'component',
        componentName: 'style',
        componentState: { text: 'Component 1' },
        title: 'Style',
        isClosable: false,
        panel_key: 'style',
        panel_category: 'Essential',
        panel_description: 'Use CSS to style elements on the page.',
        panel_icon: 'icon-Pin15'
    }
    var defElementCode = {
        type: 'component',
        componentName: 'element_code',
        componentState: {text: 'Component 1'},
        title: 'Element code',
        isClosable: false,
        panel_key: 'element_code_panel',
        panel_category: 'Tools',
        panel_description: 'Edit the code of the selected element.',
        panel_icon: 'icon-KODA'
    }

    //if(pgf.product !== 'PG') {

        var defInfo = {
            type: 'component',
            componentName: 'info',
            componentState: {text: 'Component 1'},
            title: pgf.kids ? 'Your Adventure' : 'Information',
            isClosable: false,
            panel_category: 'Tools',
            panel_icon: pgf.kids ? null : 'icon-274',
            panel_key: 'info',
            panel_description: 'Show information and instructions for the current project.',
        }
   // }

    if(pgf.product === 'PG' || pgf.product === 'ONLINE' || pgf.product === 'WPPLUGIN') {


        var defActions = {
            type: 'component',
            componentName: 'act_panel',
            componentState: {text: 'Component 1'},
            title: 'Actions',
            isClosable: false,
            panel_key: 'act',
            panel_category: 'Components',
            panel_description: 'Define and use components and master pages.',
            panel_icon: 'icon-actions'
        }

        var defCms = {
            type: 'component',
            componentName: 'cms_panel',
            componentState: {text: 'Component 1'},
            title: 'WordPress theme builder',
            isClosable: false,
            panel_key: 'cms',
            panel_category: 'WordPress',
            panel_description: 'Add WordPress template functions to HTML elements.',
            panel_icon: 'icon-WP'
        }

        var defClassStyles = {
            type: 'component',
            componentName: 'class_styles_panel',
            componentState: {text: 'Component 1'},
            title: 'Class Styles',
            isClosable: false,
            panel_key: 'classstyles',
            panel_category: 'Tailwind CSS',
            panel_description: 'Manage Tailwind CSS class styles.',
            panel_icon: 'icon-classes'
        }

        var defAnimations = {
            type: 'component',
            componentName: 'animations_panel',
            componentState: {text: 'Component 1'},
            title: 'Interactions',
            isClosable: false,
            panel_key: 'animations',
            panel_category: 'Interactions',
            panel_description: 'Manage interactions and scroll scenes.',
            panel_icon: 'icon-113'
        }


        var defAnimationTimeline = {
            type: 'stack',
            isClosable: false,
            notCollapsable: true,
            isHidden: true,
            dontCollapseOnActiveTabClick: true,
            tabsNotDraggable: true,
            dont_drop_stuff_here: true,
            noAlwaysShownButton: true,
            addClass: 'pg-force-min-panel-height',
            height: 25,
            content: [{
                type: 'component',
                componentName: 'animation_timeline',
                componentState: {text: 'Component 1'},
                title: 'Animation Timeline',
                isClosable: false,
                reorderEnabled: false,
                notDraggable: true,
                panel_category: 'Interactions',
                panel_description: 'Edit animation timeline.',
                panel_icon: 'icon-snap-timeline',
                panel_on_show: function() {
                    pinegrow.findFrameworkByKey('pg.ia').showTimelineEditor(true);
                },
                panel_on_hide: function() {
                    pinegrow.findFrameworkByKey('pg.ia').showTimelineEditor(false);
                },
                panel_on_is_visible: function() {
                    return pinegrow.findFrameworkByKey('pg.ia').isTimelineEditorShown();
                }
            }]
        }
    }


    //Disable animations if not active
    if(!pinegrow.hasActivatedProduct('IA') && !pgIsInTrial() && crsaIsEmailActivated()) {
        defAnimations = null;
        defAnimationTimeline = null;
    }

    //Disable animations if not active
    if(!pinegrow.hasActivatedProduct('TW') && !pgIsInTrial() && crsaIsEmailActivated()) {
        defClassStyles = null;
    }

    if(!pinegrow.hasActivatedProduct('WP') && !pgIsInTrial() && crsaIsEmailActivated()) {
        defCms = null;
    }

    var defProjectDB = {
        type:'component',
        componentName: 'db_tree',
        componentState: { text: 'Component 1' },
        title: 'Action mappings',
        isClosable: false
    }

    //SNAP
    var defSnap = {
        type:'component',
        componentName: 'snap',
        componentState: { text: 'Component 1' },
        title: 'HTML Snapshots',
        isClosable: false
    }

    // MAGIC
    var defDmDesign = {
        type:'component',
        componentName: 'dm_design_panel',
        componentState: { text: 'Component 1' },
        title: 'Design',
        isClosable: false,
        panel_key: 'pgdm',
        panel_category: 'Essential',
        panel_description: 'Manage the overall design (theme) of the current project.',
        panel_icon: 'icon-color'
    }

    var defDmStyle = {
        type:'component',
        componentName: 'dm_style_panel',
        componentState: { text: 'Component 1' },
        title: 'Style',
        isClosable: false
    }

    var defDmProp = {
        type:'component',
        componentName: 'dm_prop_panel',
        componentState: { text: 'Component 1' },
        title: 'Props',
        isClosable: false
    }

    var defDmStyles = {
        type:'component',
        componentName: 'dm_styles_panel',
        componentState: { text: 'Component 1' },
        title: 'Styles',
        isClosable: false
    }
    // END Magic

    var getFullConfig = function(config) {
        return {
            settings: {
                showPopoutIcon: false,
                showMaximiseIcon: false,
                showCloseIcon: true
            },
            content: [

                {
                    type: 'row',
                    content: config
                }
            ]
        }
    }

    var getModifiedDef = function(def, opts) {
        return $.extend(def, opts);
    }

    var getStackDef = function(size, content, docked) {
        return {
            type: 'stack', // Stack
            width:size || 18,
            isClosable: false,
            isDocked: docked || false,
            isAutoDocked: false,
            notDraggable: ui_not_draggable,
            tabsNotDraggable: ui_not_draggable,
            content: content.filter(function(i) {
                return i !== null;
            })
        }
    }

    var getHiddenStackDef = function(content) {
        return {
            type: 'stack', // Stack
            isClosable: false,
            notCollapsable: true,
            width:0,
            isHidden: true,
            hidden_stack: true,
            dontCollapseOnActiveTabClick: true,
            content: content.filter(function(i) {
                return i !== null;
            })
        }
    }

    var getColumnDef = function(content, floating) {
        return {
            type: 'column',
            isClosable: false,
            content: content.filter(function(i) {
                return i !== null;
            }),
            isFloating: floating
        }
    }

    var getRowDef = function(content) {
        return {
            type: 'row',
            isClosable: false,
            content: content.filter(function(i) {
                return i !== null;
            })
        }
    }

    var default_configs;

//    console.log('Product = ' + pgf.product)

    if(pgf.product === 'KIDS') {
        default_configs = [
            {
                name: 'Large screen (4 columns)', key: 'default',
                config: getFullConfig([
                    getStackDef(22, [/*defProject,*/ defInfo]),
                    getColumnDef([defPages, defEditors, defStatusBar]),
                    getStackDef(18, [defProp,  defStyle]),
                    getStackDef(18, [defTree])
                ])
            },
            {
                name: 'Small screen (3 columns)', key: 'small',
                config: getFullConfig([
                    getStackDef(27, [/*defProject,*/ defInfo]),
                    getColumnDef([defPages, defEditors, defStatusBar]),
                    getStackDef(20, [defTree, defProp,  defStyle])
                ])
            },
            ]

    } else if(pgf.product === 'SNAP') {
        default_configs = [
            {
                name: 'Default', key: 'default',
                config: getFullConfig([
                    getColumnDef([defPages]),
                    getStackDef(25, [defSnap])
                ])
            }
        ]
    } else if(pgf.product === 'PGTC') {
        default_configs = [
            {
                name: 'Large screen (4 columns)', key: 'default',
                config: getFullConfig([
                    getStackDef(18, [defProject, defHistory, defProjectDB], true),
                    getColumnDef([defPages, defEditors, defStatusBar]),
                    getStackDef(22, [defCms]),
                    getStackDef(22, [defTree])
                ])
            }
        ]
    } else if(pgf.product === 'ONLINE' || pgf.product === 'WPPLUGIN') {

        //defActions = null;
        //defClassStyles = null;
        if(!pinegrow.hasActivatedProduct('WP')) {
            defCms = null;
        }
        defLib = null;
        //defProject = null;
        //defActions = null;

        default_configs = [
            {
                name: 'Default (4 columns)', key: 'default',
                config: getFullConfig([
                    getStackDef(20, [/* defLib, defProject,*/ defInfo], false),
                    getColumnDef([defPages, defEditors, defAnimationTimeline, defStatusBar]),
                    getStackDef(20, [defDmDesign, defProp, defStyle, defAnimations /*, defActions */, defCms]),
                    getStackDef(18, [defTree, defProject]),
                    getHiddenStackDef([defElementCode, defHistory, defClassStyles, defActions])
                ])
            },
            {
                name: 'Minimal', key: 'minimal',
                config: getFullConfig([
                    getStackDef(20, [/* defLib, defProject,*/ defInfo], false),
                    getColumnDef([defPages, defEditors, defAnimationTimeline, defStatusBar]),
                    getStackDef(20, [defDmDesign, defTree, defProp,  defStyle, defAnimations, defCms /*, defActions */]),
                    getHiddenStackDef([defElementCode, defHistory, defClassStyles, defActions, defProject])
                ])
            },
            {
                name: 'Left - Right', key: 'left_right',
                config: getFullConfig([
                    getStackDef(20, [/* defLib, defProject,*/ defTree, defInfo, defProject], false),
                    getColumnDef([defPages, defEditors, defAnimationTimeline, defStatusBar]),
                    getStackDef(20, [defDmDesign, defProp, defStyle, defAnimations, defCms /*, defActions */]),
                    getHiddenStackDef([defElementCode, defHistory, defClassStyles, defActions, defProject])
                ])
            }
            ]
    } else {

        default_configs = [
            {
                name: 'Default (4 columns)', key: 'default',
                config: getFullConfig([
                    getStackDef(20, [defLib, defProject, defTree /*, defHistory*/], false),
                    getColumnDef([defPages, defEditors, defAnimationTimeline, defStatusBar]),
                    getStackDef(20, [defProp, defClassStyles, /* defCSSTreeActive, defCSSTree, defCSSVisual,*/ defStyle, defDmDesign, defAnimations, /* defElementCode,*/ defActions, defCms]),
                    getHiddenStackDef([defElementCode, defHistory, defInfo])
                ])
            },
            {
                name: 'Small screen (3 columns)', key: 'small',
                config: getFullConfig([
                    getStackDef(20, [defLib, defProject /*, defHistory*/], false),
                    getColumnDef([defPages, defEditors, defAnimationTimeline, defStatusBar]),
                    getStackDef(20, [defDmDesign, defProp, defClassStyles, /* defCSSTreeActive, defCSSTree, defCSSVisual,*/ defStyle, defAnimations, /* defElementCode,*/ defTree, defActions, defCms]),
                    getHiddenStackDef([defElementCode, defHistory, defInfo])
                ])
            },
            {
                name: 'All sides (Props and code below page view)', key: 'all_sides',
                config: getFullConfig([
                    getStackDef(18, [defLib, defProject, defHistory]),
                    getColumnDef([getModifiedDef(defPages, {height: 60}), defAnimationTimeline, defEditors,
                        getRowDef([
                            getStackDef(50, [defProp, defClassStyles]),
                            getStackDef(50, [defElementCode])
                        ]),
                        defStatusBar
                    ]),
                    getStackDef(18, [defTree]),
                    getStackDef(18, [/* defCSSTreeActive, defCSSTree, defCSSVisual,*/ defDmDesign, defStyle, defAnimations,/*defVars,*/ defActions, defCms]),
                    getHiddenStackDef([defInfo])
                ])
            },
            {
                name: 'Minimal (all panels collapsed)', key: 'minimal',
                config: getFullConfig([
                    getStackDef(18, [defLib, defProject, defHistory], true),
                    getColumnDef([defPages, defEditors, defAnimationTimeline, defStatusBar]),
                    getStackDef(18, [defTree], true),
                    getStackDef(18, [defDmDesign, defProp, defClassStyles, /* defCSSTreeActive, defCSSTree, defCSSVisual,*/ defStyle, defAnimations, /*defVars,*/ defElementCode, defActions, defCms], true),
                    getHiddenStackDef([defInfo])
                ])
            },
            {
                name: 'Two screens (Pages on one, tools on another)', key: '2screens',
                config: getFullConfig([
                    getColumnDef([defPages, defAnimationTimeline, defStatusBar]),
                    getColumnDef([
                        getRowDef([
                            getStackDef(20, [defLib, defProject, defHistory]),
                            getStackDef(20, [defDmDesign, defProp, defClassStyles, /* defCSSTreeActive, defCSSTree, defCSSVisual,*/ defStyle, defAnimations, /*defVars,*/ defElementCode, defActions, defCms]),
                            getStackDef(18, [defTree])
                        ]),
                        defEditors
                    ], true /* floating */),
                    getHiddenStackDef([defInfo])
                ])
            },
        ]
    }

    defLib && pinegrow.panelManager.registerPanel(defLib);
    defProp && pinegrow.panelManager.registerPanel(defProp);
    defStyle && pinegrow.panelManager.registerPanel(defStyle);
    defTree && pinegrow.panelManager.registerPanel(defTree);
    defProject && pinegrow.panelManager.registerPanel(defProject);
    defDmDesign && pinegrow.panelManager.registerPanel(defDmDesign);
    defActions && pinegrow.panelManager.registerPanel(defActions);
    if(defCms) {
        pinegrow.panelManager.registerPanel(defCms);
    }
    if(defAnimations) {
        pinegrow.panelManager.registerPanel(defAnimations);
        pinegrow.panelManager.registerPanel(defAnimationTimeline.content[0]);
    }
    if(defClassStyles) {
        pinegrow.panelManager.registerPanel(defClassStyles);
    }
    defHistory && pinegrow.panelManager.registerPanel(defHistory);
    defElementCode && pinegrow.panelManager.registerPanel(defElementCode);
    defInfo && pinegrow.panelManager.registerPanel(defInfo);

    if(pgIsMagic()) {
        default_configs = [];

        default_configs.push({name: 'Magic', key: 'magic',
            config:
                getFullConfig([
                    getStackDef(20, [defLib, defProject, defHistory], true),
                    getColumnDef([defPages, defEditors, defStatusBar]),
                    getStackDef(20,[defDmProp, defDmDesign, defDmStyle, defDmStyles, defActions /*, defProp, defStyle */]),
                    getStackDef(18, [defTree], true)
                ])
        });

        pinegrow.showQuickMessage('This is MAGIC!');
    }

    window.pgGetWorkspaces = function() {
        return default_configs;
    }

    var getNamedConfig = function(key) {
        for(var i = 0; i < default_configs.length; i++) {
            if(default_configs[i].key == key) return default_configs[i];
        }
        return null;
    }

    var getDefaultConfig = function() {
        if(pgIsMagic()) return getNamedConfig('magic').config;

        return getNamedConfig($('body').width() < 14/*00*/ ? 'default_small' : 'default').config;
    }

    var default_config = getDefaultConfig();

    var config = jQuery.extend(true, {}, default_config);

    var removePageViewsDo = function (node, remove_more) {

        var remove = ['pageview', 'code_editor', 'canvas'];
        if(remove_more) remove = remove.concat(remove_more);
        var r = [];
        for (var i = 0; i < node.content.length; i++) {
            if (node.content[i] && remove.indexOf(node.content[i].componentName || '') < 0) {

                if (node.content[i].content) {
                    removePageViewsDo(node.content[i], remove_more);
                }

                var skip = false;

                if (node.content[i].codeEditors) {

                    node.content[i].notCollapsable = true;
                    node.content[i].dontCollapseOnActiveTabClick = true;

                    if (node.content[i].isHidden || true) {
                        node.content[i].height = 50;
                        node.content[i].width = 20;
                    }
                    node.content[i].isHidden = true;
                    if (node.content[i]["undocked_width_px"]) {
                        delete node.content[i]["undocked_width_px"];
                    }
                    node.content[i].checkDropAreaFunc = 'codeEditors';
                    //node.content[i].validDropLocations = ".pg-none";
                    node.content[i].tabsNotDraggable = true;
                    //node.content[i]
                } else if (node.content[i].pages) {
                    node.content[i].getNewStackDef = getNewStackDefForPages;
                    node.content[i].addClass = 'pg-fullsize-item pg-page-area';

                    if (has_pages) {
                        skip = true; //only one pages stack
                    } else {
                        has_pages = true;
                    }
                } else if(node.content[i].type !== 'component' && (!node.content[i].content || node.content[i].content.length === 0)) {
                    skip = true;
                }

                if (!skip) {
                    r.push(node.content[i]);

                    if (node.content[i].checkDropAreaFunc) {
                        node.content[i].checkDropArea = checkDropAreaFuncs[node.content[i].checkDropAreaFunc];
                    }

                    if (node.content[i].config && node.content[i].config.checkDropAreaFunc) {
                        node.content[i].config.checkDropArea = checkDropAreaFuncs[node.content[i].config.checkDropAreaFunc];
                    }
                    if (node.content[i].config && node.content[i].config.newStackDef && node.content[i].config.newStackDef.checkDropAreaFunc) {
                        node.content[i].config.newStackDef.checkDropArea = checkDropAreaFuncs[node.content[i].config.newStackDef.checkDropAreaFunc];
                    }
                }

            } else {

            }
        }
        node.content = r;

        if (node.activeItemIndex >= node.content.length) {
            node.activeItemIndex = node.content.length - 1;
            if (node.activeItemIndex < 0) {
                delete node.activeItemIndex;
            }
        }
    }

    var removePageViews = function (node, remove_more) {
        has_pages = false;

        //add new panels
        var add_panels = [];

        if(defCms) {
            add_panels.push({
                panel: defCms,
                after: function(i) {
                    return i.componentName ? i.componentName === 'style' : false;
                }
            })
        }

        if(defClassStyles) {
            add_panels.push({
                panel: defClassStyles,
                after: function(i) {
                    return i.componentName ? i.componentName === 'style' : false;
                }
            })
        }

        if(defAnimations) {
            add_panels.push({
                panel: defAnimations,
                after: function(i) {
                    return i.componentName ? i.componentName === 'style' : false;
                }
            })
        }

        if(defAnimationTimeline) {
            add_panels.push({
                panel: defAnimationTimeline.content[0],
                after: function(i) {
                    return i.pages || false;
                }
            })
        }

        if(defDmDesign) {
            add_panels.push({
                panel: defDmDesign,
                after: function(i) {
                    return i.componentName ? i.componentName === 'style' : false;
                },
                before: true
            })
        }

        if(defInfo) {
            add_panels.push({
                panel: defInfo,
                after: function(i, parent) {
                    if(parent.hidden_stack) {
                        return true;
                    }
                    return false;
                },
            })
        }

        var panel_added = false;

        var findItem = function(item, name, add, before) {
            if(item.content) {
                for(var i = 0; i < item.content.length; i++) {
                    if(!item.content[i]) continue;

                    if(typeof name === 'function') {
                        if(name(item.content[i], item)) {
                            if (add) {
                                item.content.splice(before ? i : i + 1, 0, add);
                                panel_added = true;
                            }
                            return true;
                        } else {
                            if (findItem(item.content[i], name, add)) {
                                return true;
                            }
                        }
                    } else {
                        if(name === 'hidden_stack' && item.content[i].hidden_stack) {
                            return true;
                        } else if (item.content[i].type === 'component') {
                            if (item.content[i].componentName === name) {
                                return true;
                            }
                        } else {
                            if (findItem(item.content[i], name, add)) {
                                return true;
                            }
                        }
                    }
                }
                return false;
            }
        }

        if(!findItem(node, 'hidden_stack')) {
            node.content.push(hidden_stack_config);
        }

        add_panels.forEach(function(pair) {
            if(!findItem(node, typeof pair.panel === 'function' ? pair.panel : pair.panel.componentName)) {
                panel_added = false;
                findItem(node, pair.after, pair.panel, pair.before || false)
                if(!panel_added) {
                    console.warn(`Unable to add the panel ${pair.panel.componentName}`);
                }
            }
        })

        removePageViewsDo(node, remove_more);
    }

    var remove_more = pinegrow.isContributorMode() ? ['dm_design_panel', 'code_editor', 'element_code', 'style', 'css_var_panel', 'act_panel', 'cms_panel', 'animations_panel', 'animation_timeline', 'class_styles_panel'] : [];

    if(!defAnimations) {
        remove_more.push('animations_panel');
        remove_more.push('animation_timeline');
    }

    if(!defClassStyles) {
        remove_more.push('class_styles_panel');
    }

    if(!defCms) {
        remove_more.push('cms_panel');
    }

    if(!defActions) {
        remove_more.push('act_panel');
    }
    var layout_state_key = 'pg_layout_state';
    if(pgIsMagic()) layout_state_key = 'pg_layout_state_magic2'

    layout_state_key += pgf.layout_prefix;

    var layoutStorage = localStorage;
    if(pgf.settings_on_backend && pgwpdata && pgwpdata.user_settings) {
        layoutStorage = pgwpdata.user_settings;
    }

    if(layoutStorage[layout_state_key]) {
        var version = layoutStorage.pg_layout_state_version || '0';

        if(layoutStorage.pg_layout_state_ccmode == '1' && !pinegrow.isContributorMode()) {
            version = 'modechange';
        }

        if(ui_version == version) {

            var testconfig = null;

            config = JSON.parse(testconfig || layoutStorage[layout_state_key]);

            //remove pageviews
            var has_pages = false;

            removePageViews(config, remove_more);
            remove_more = null;
            //console.log(JSON.stringify(config));
        }
    } else {
        removePageViews(config, remove_more);
        remove_more = null;
    }


    if(remove_more) {
        removePageViews(config, remove_more);
    }

    myLayout = new GoldenLayout( config, $('<div id="layout-container"></div>').appendTo($('body')) );

    $('#layout-container').on('scroll', function(e) {
        //fix for weird page scroll
        $(this).scrollTop(0);
    })

    $(window).resize( myLayout._resizeFunction );

    var floatingColYDelta = 0;

    var win_floats = isApp();//true;//pgIsDev();

    var onColumnRowCreated = function(new_column) {

        if(!new_column.config.isFloating) return;

        //console.log('POPOUT stack/column ' + (new_column.config.pg_win_id || ' NO ID'))

        new_column.config.floatingPosY = ('floatingPosY' in new_column.config) ? new_column.config.floatingPosY : (100 + floatingColYDelta);

        floatingColYDelta += 20;

        if(floatingColYDelta >= 100) floatingColYDelta = 0;

        var def_h = Math.max(300, Math.floor(($('body').height() - new_column.config.floatingPosY) * 0.85));
        var w = new_column.config.floatingWidth ? (Math.max(300, new_column.config.floatingWidth)) : 300;

        var bw = $('body').width();

        var def_x = (new_column.config.prefloatingPosX || bw/2);
        if(def_x > bw/2) {
            def_x = def_x - w - floatingColYDelta;
        } else {
            def_x = def_x + floatingColYDelta;
        }

        new_column.config.floatingPosX = ('floatingPosX' in new_column.config) ? new_column.config.floatingPosX : def_x;

        new_column.isFloating = true;

        new_column.element.addClass('lm_floating');

        if(!win_floats) {
            new_column.element.css({
                left: new_column.config.floatingPosX + 'px',
                top: new_column.config.floatingPosY + 'px',
                height: new_column.config.floatingHeight ? (Math.max(300, new_column.config.floatingHeight) + 'px') : (def_h + 'px'),
                width: w + 'px'
            })


            var drag_resize_handle = $('<div class="lm_resize_handle pg-win-resizer"><i class="icon icon-drag-kotni"></i></div>');

            new_column.element.append(drag_resize_handle);

            new_column.dragMoverResizer = new PgMoverAndResizer(new_column.element, '.lm_drag_header', drag_resize_handle, '.lm_goldenlayout');
            new_column.dragMoverResizer.wholeVisible = false;

            new_column.dragMoverResizer.onResize = function (w, h) {
                new_column.config.floatingWidth = w;
                new_column.config.floatingHeight = h;
                new_column.callDownwards('setSize');
            }

            new_column.dragMoverResizer.onMove = function (pos_x, pos_y) {
                new_column.config.floatingPosX = pos_x;
                new_column.config.floatingPosY = pos_y;
                new_column.callDownwards('setSize'); //force state change
            }

            new_column.element.on('mousedown', function (e) {
                if (!new_column.element.hasClass('lm_floating_focused')) {
                    $('.lm_floating_focused').removeClass('lm_floating_focused');
                    new_column.element.addClass('lm_floating_focused')
                }
            })

            var setConfigAfterChange = function (change) {
                if (change) {
                    new_column.config.floatingWidth = change.w;
                    new_column.config.floatingHeight = change.h;
                    new_column.config.floatingPosX = change.x;
                    new_column.config.floatingPosY = change.y;

                    new_column.callDownwards('setSize');
                }
            }

            new_column.element.on('dblclick', '.lm_drag_header', function () {
                if (new_column.dragMoverResizer) {
                    setConfigAfterChange(new_column.dragMoverResizer.ensureVisible(true, true))
                }
            })

        } else {
            new_column.element.css({
                left: '',
                top: '',
                height: '',
                width: ''
            })

            if(!openPanelInExternalWindowStack) {
                //debugger;
                //openPanelInExternalWindowStack = new_column.contentItems.length > 0 ? new_column.contentItems[0] : null;
            }

            var win_options = {};
            pinegrow.dispatchEvent('on_panel_open_in_floating_window', null, openPanelInExternalWindowStack, new_column, win_options)
           // call event before openPanelInExternalWindow
            openPanelInExternalWindow(new_column.element, null, win_options, openPanelInExternalWindowStack || new_column);
        }

        var onWindowResized = function() {
            if(new_column.dragMoverResizer) {
                if(new_column.dragMoverResizer.ensureVisible(false, true)) {
                    new_column.callDownwards( 'setSize');
                }
            }
        }

        $(window).on('resize', onWindowResized)

        onWindowResized();

        new_column.on('itemDestroyed', function() {
            //debugger;
            $(window).off('resize', onWindowResized)
        })

        //new_column.element.prepend(drag_header);
    }

    myLayout.on( 'rowCreated', onColumnRowCreated)
    myLayout.on( 'columnCreated', onColumnRowCreated)

    myLayout.on( 'itemCreated', function( item ){
        //console.log(item)
        if(!item.config.checkDropArea) item.config.checkDropArea = excludingPages;

        if(!item.config.validDropLocations) item.config.validDropLocations = ":not(.pg-fullsize-item)";
    })

    myLayout.on( 'stackCreated', function( stack ){
        /*
         * Re-use the label
         */
        var label = stack.layoutManager.config.labels.popout;

        if(!stack.config.checkDropArea) stack.config.checkDropArea = excludingPages;

        if(!stack.config.validDropLocations) stack.config.validDropLocations = ":not(.pg-fullsize-item)";

        var drag_header = $('<div class="lm_drag_header"></div>');
        drag_header.insertAfter(stack.header.element.find('.lm_handle'));

        $('<div class="lm_drag_header lm_drag_header_left"></div>').appendTo(stack.element);
        $('<div class="lm_drag_header lm_drag_header_right"></div>').appendTo(stack.element);

        stack.toggleAllwaysShown = function() {
            stack.config.allwaysShown = !(stack.config.allwaysShown || false);
            if(stack.config.allwaysShown) {
                stack.allwaysShownButton.element.addClass('active');
            } else {
                stack.allwaysShownButton.element.removeClass('active');
            }
            saveUIState();
        }
        /*
         * Callback when the user clicks the popout button
         */
        stack.popout = function(event, force_dock, force_to_root) {

            if(myLayout.ignoreNextClick()) return;
            /*
             * The currently selected item - that's the one you'd want to pop out
             */
            var $floating = stack.element.closest('.floating-win');
            if(
                (win_floats && (force_dock || $floating.length && $floating.find('.lm_stack').length === 1)) /* ||
                (stack.parent && stack.parent.isFloating)*/) {

                //unfloat
                var panel = stack.parent;
                var new_window = stack.element.get(0).ownerDocument.defaultView;

                pgUIViewManager.forEachView(stack.element, function (view) {
                    view.onBeforeMovedToAnotherWindow && view.onBeforeMovedToAnotherWindow(new_window, stack.element);
                })

                var app_win = pgGetAppWindowForDOMWindow(panel.element.get(0).ownerDocument.defaultView);
                let pgEditorViewlenght;

                myLayout.withoutUpdateSize(function() {
                    stack.element.detach();

                    var col = stack.parent;

                    //stack.header.element.find('.lm_drag_header').remove();

                    stack.parent.removeChild(stack, true);

                    if(force_to_root || !stack.restoreAtRememberedPosition(col)) {
                        myLayout.root.contentItems[0].addChild(stack, undefined, null, true /* force main win */);
                    }

                    stack.config.width = stack.width_before_float || 18;

                    //stack.config.isFloating = false;

                    if(col.contentItems.length == 0 && col.dragMoverResizer) {
                        col.dragMoverResizer.destroy();
                    }

                    /*
                    try {
                        col.parent.removeChild(col);
                    } catch(err) {}*/
                });

                myLayout.updateSize();

                pgUIViewManager.forEachView(stack.element, function (view) {
                     view.onMovedToAnotherWindow && view.onMovedToAnotherWindow(new_window, stack.element);
                })

                pinegrow.selectedElements.reselect();
                pinegrow.dispatchEvent('on_panel_moved_in_another_window', app_win);

                return;
            }
            var item = stack.header.activeContentItem;

            item = stack;

            stack.rememberPosition();

            //openPanelInExternalWindow will be called from within this. We set the $el for the win name
            openPanelInExternalWindow$Element = stack.element;
            openPanelInExternalWindowStack = stack;

            var new_column = myLayout._$normalizeContentItem({
                title: 'KOLI',
                type: 'column',
                componentName: 'kolicol',
                componentState: { text: 'Ha' },
                width: 17,
                floatingWidth: stack.element.width(),
                isFloating: true,
                prefloatingPosX: item.element.offset().left
            });

            openPanelInExternalWindow$Element = null;
            openPanelInExternalWindowStack = null;

            myLayout.root.contentItems[ 0 ].addChild( new_column );

            stack.width_before_float = stack.config.width;

            //stack.config.isFloating = true;

            stack.element.detach();

            if(stack.parent) {
                stack.parent.removeChild( stack, true );
            }

            new_column.addChild(stack);



            /*
            if(win_floats) {

                openPanelInExternalWindow(new_column.element, function (win, $lc) {

                });
            }
            */
        };

        if(!stack.config.pages /* && !stack.config.codeEditors */) {

            if(!stack.config.codeEditors && pgf.hide_panels) {
                stack.allwaysShownButton = new GoldenLayout.__lm.controls.HeaderButton(stack.header, 'Show this panel even when all panels are hidden. ' + `Use ${pgShowKbd('TAB')} key to toggle all panels.`, 'lm_allways_shown', stack.toggleAllwaysShown);
                stack.allwaysShownButton.element.addClass('icon-custom');
                addTooltip(stack.allwaysShownButton.element);

                if (stack.config.allwaysShown) {
                    stack.allwaysShownButton.element.addClass('active');
                }
            }

            stack.headerButton = new GoldenLayout.__lm.controls.HeaderButton(stack.header, 'Toggle floating panel.', 'lm_popout', stack.popout);
            stack.headerButton.element.addClass('icon-custom');
            addTooltip(stack.headerButton.element);


        }
        /*
        stack.dockedButton = new GoldenLayout.__lm.controls.HeaderButton( stack.header, label, 'lm_popout', function() {
            stack.setDocked(!stack.isDocked);
        } );
        */

        if(stack.config.addClass) {
            stack.element.addClass(stack.config.addClass);
        }

        if(stack.config.isFloating) {
            //stack.popout();
        }
        if(stack.config.isDocked) {
            stack.hasVerticalTabs = true;
            setTimeout(function() {
                stack.setDocked(stack.config.isDocked);
            }, 100)
        }
        if(stack.config.isHidden) {
            stack.hideStack();
        }

        if(stack.config.pages) {
            stack.on('activeContentItemChanged', function(item) {
                if(item.pgPageTab) {
                    pinegrow.setSelectedPageTab(item.pgPageTab);
                }
            })

            //item that is already active was clicked
            stack.on('activeContentItemClicked', function(item) {
                if(item.pgPageTab) {
                    pinegrow.setSelectedPageTab(item.pgPageTab);
                }
            })
        }
    });

    var hidden_stack = null;

    var hidden_stack_config = {
        type: 'stack',
        isClosable: false,
        notCollapsable: true,
        width:0,
        isHidden: true,
        hidden_stack: true,
        dontCollapseOnActiveTabClick: true
    }

    myLayout.getHiddenStackForHiddenPanels = function() {
        if(!hidden_stack) {
            hidden_stack = myLayout.root.getItemsByFilter(function(item) {
                if (item.config.hidden_stack) return true;
            })[0];

            if(!hidden_stack) {
                hidden_stack = myLayout._$normalizeContentItem(hidden_stack_config);
                myLayout.root.contentItems[0].addChild(hidden_stack, undefined, null, true /* force main win */);
            }
        }
        return hidden_stack;
    }

    var in_ui_drag = false;

    myLayout.on('dragStart', function(dp) {
        $.fn.crsapages('showOverlays');

        if(dp._contentItem && dp._contentItem.config.validDropLocations) {
            $('.lm_stack').not(dp._contentItem.config.validDropLocations).addClass('show-invalid-drop-location');
        }

        in_ui_drag = true;
    });

    myLayout.on('dragStop', function(dp) {
        $.fn.crsapages('showOverlays', true);

        if(dp._contentItem && dp._contentItem.config.validDropLocations) {
            $('.lm_stack').not(dp._contentItem.config.validDropLocations).removeClass('show-invalid-drop-location');
        }

        in_ui_drag = false;

        saveUIState();

        pgUpdateAppWindowTitles();
    });

    myLayout.on('dragNotAllowed', function(dp) {
        if(!pgf.kids) pinegrow.showQuickMessage('Page area is not draggable.');
        $('body').removeClass( 'lm_dragging' );
    });

    myLayout.on('tabDragNotAllowed', function(dp) {
        if(!pgf.kids) pinegrow.showQuickMessage('Individual code tabs are not draggable. Move the whole panel instead.');
        $('body').removeClass( 'lm_dragging' );
    });

    myLayout.on('collapseNotAllowed', function(dp) {
        pinegrow.showQuickMessage('Collapsing the panel at this location is not supported. Move the panel outside of the page area first.', 6000);
    });

    myLayout.on('singleClickOnActiveTab', function(dp) {
        pinegrow.showQuickMessage('Double click on any tab to collapse the panel.');
    });


    /*
    var events = 'tabCreated columnCreated rowCreated componentCreated itemCreated'.split(' ').forEach(function(e) {
        myLayout.on( e, function( stack ){
            console.log(stack);
        });
    })
*/

    var created_panels = {};

    myLayout.registerComponent( 'custom', function( container, state ){
    });

    myLayout.registerComponent( 'pageview', function( container, state ){
    });

    myLayout.registerComponent( 'code_editor', function( container, state ){
    });

    myLayout.registerComponent( 'canvas', function( container, state ){
      var el = container.getElement().append($('.canvas'));
    });

    var compTree = null;

    myLayout.registerComponent( 'tree', function( container, state ){
        compTree = compTree || new PgTreeView();
        var el = container.getElement().append(compTree.view.get$Element());
        compTree.view.addedToLayout(container);
    });

    var compCSSTree = null;

    myLayout.registerComponent( 'css_tree', function( container, state ){
        compCSSTree = compCSSTree || new PgCSSTreeView(false);
        var el = container.getElement().append(compCSSTree.view.get$Element());
        compCSSTree.view.addedToLayout(container);
    });

    var compCSSTreeActive = null;

    myLayout.registerComponent( 'css_tree_active', function( container, state ){
        compCSSTreeActive = compCSSTreeActive || new PgCSSTreeView(true);//new PgCSSComposerView();//
        var el = container.getElement().append(compCSSTreeActive.view.get$Element());
        compCSSTreeActive.view.addedToLayout(container);
    });

    var compCSSVisual = null;

    myLayout.registerComponent( 'css_visual', function( container, state ){
        compCSSVisual = compCSSVisual || new PgCSSEditorView();
        var el = container.getElement().append(compCSSVisual.view.get$Element());
        compCSSVisual.view.addedToLayout(container);
    });

    var compLib = null;

    myLayout.registerComponent( 'lib_panel', function( container, state ){
      //var el = container.getElement().append($('#crsa-elements'));
        //compLib = compLib || new PgLibraryView();
        compLib = compLib || new PgPageLibsTabbedView();
        var el = container.getElement().append(compLib.view.get$Element());
        compLib.view.addedToLayout(container);
    });

    var compProp = null;

    myLayout.registerComponent( 'prop_panel', function( container, state ){
        compProp = compProp || new PgPropertiesView();
        var el = container.getElement().append(compProp.view.get$Element());
        compProp.view.addedToLayout(container);
    });

    var compHistory = null;

    myLayout.registerComponent( 'history', function( container, state ){
        compHistory = compHistory || new PgUndoView();
        var el = container.getElement().append(compHistory.view.get$Element());
        compHistory.view.addedToLayout(container);
    });

    var compCode = null;

    myLayout.registerComponent( 'element_code', function( container, state ){
        compCode = compCode || new PgCodeEditorsView({view_name: 'element_code_panel'});
        var el = container.getElement().append(compCode.view.get$Element());
        compCode.view.addedToLayout(container);

        pinegrow.codeEditorsView = compCode;
    });

    var compInfo = null;

    myLayout.registerComponent( 'info', function( container, state ){
        compInfo = compInfo || new PgInfoPanelView();
        var el = container.getElement().append(compInfo.view.get$Element());
        compInfo.view.addedToLayout(container);
        pinegrow.infoPanel = compInfo;
    });

    var compStyle = null;

    myLayout.registerComponent( 'style', function( container, state ){

        compStyle = compStyle || new PgCSSActiveRulesCombinedView();
        var el = container.getElement().append(compStyle.view.get$Element());
        compStyle.view.addedToLayout(container);
    });

    var compStatusBar = null;

    myLayout.registerComponent( 'status_bar', function( container, state ){
        compStatusBar = compStatusBar || new PgStatusBarView();
        pinegrow.statusBar = compStatusBar;
        var el = container.getElement().append(compStatusBar.view.get$Element());
        compStatusBar.view.addedToLayout(container);
    });

    var compVars = null;

    myLayout.registerComponent( 'css_var_panel', function( container, state ){
        compVars = compVars || new PgVarsView();
        var el = container.getElement().append(compVars.view.get$Element());
        compVars.view.addedToLayout(container);
    });

    var compActions = null;

    myLayout.registerComponent( 'act_panel', function( container, state ){
        compActions = compActions || new PgCombinedActionsView('ACT','icon-actions');
        var el = container.getElement().append(compActions.view.get$Element());
        compActions.view.addedToLayout(container);
    });

    var compCMS = null;

    if(defCms) {
        myLayout.registerComponent('cms_panel', function (container, state) {
            compCMS = compCMS || new PgCombinedActionsView('CMS', 'icon-WP');
            var el = container.getElement().append(compCMS.view.get$Element());
            compCMS.view.addedToLayout(container);
        });
    }

    var compAnimations = null;

    if(defAnimations) {

        myLayout.registerComponent('animations_panel', function (container, state) {
            compAnimations = compAnimations || new PgCombinedActionsView('ANIMATIONS', 'icon-113');
            var el = container.getElement().append(compAnimations.view.get$Element());
            compAnimations.view.addedToLayout(container);
            window.pgAnimationsPanel = compAnimations;
        });
    }

    var compAnimationTimeline = null;

    if(defAnimationTimeline) {
        myLayout.registerComponent('animation_timeline', function (container, state) {
            compAnimationTimeline = compAnimationTimeline || new PgAnimationEditorTimelineView('animations_timeline', 'icon-113');
            var el = container.getElement().append(compAnimationTimeline.view.get$Element());
            compAnimationTimeline.view.addedToLayout(container);

            setTimeout(function() {
                //console.log(container.tab.element);
                //Hide it instead of closing
                $(`<div class="lm_close_tab""></div>`).appendTo(container.tab.element).on('click', function(e) {
                    e.preventDefault();
                    pinegrow.findFrameworkByKey('pg.ia').showTimelineEditor(false);
                })
            }, 1000)
        });
    }

    var compProjectDB = null;

    myLayout.registerComponent( 'db_tree', function( container, state ){
        compProjectDB = compProjectDB || new PgProjectDBTreeView();
        var el = container.getElement().append(compProjectDB.view.get$Element());
        compProjectDB.view.addedToLayout(container);
    });

    var compProject = null;

    myLayout.registerComponent( 'project_panel', function( container, state ){
        compProject = compProject || new PgProjectView();
        var el = container.getElement().append(compProject.view.get$Element());
        compProject.view.addedToLayout(container);

        created_panels['project_panel'] = true;
    });

    var compClassStyles = null;

    myLayout.registerComponent( 'class_styles_panel', function( container, state ){
        compClassStyles = compClassStyles || new PgClassStylesView('CMS', 'icon-WP');
        var el = container.getElement().append(compClassStyles.view.get$Element());
        compClassStyles.view.addedToLayout(container);
    });

    var compDmDesign = null;

    myLayout.registerComponent( 'dm_design_panel', function( container, state ){
        compDmDesign = compDmDesign || new PgDmView();
        var el = container.getElement().append(compDmDesign.view.get$Element());
        compDmDesign.view.addedToLayout(container);
    });

    var compDmStyle = null;

    myLayout.registerComponent( 'dm_style_panel', function(container, state ){
        compDmStyle = compDmStyle || new PgDmStyleView();
        var el = container.getElement().append(compDmStyle.view.get$Element());
        compDmStyle.view.addedToLayout(container);
    });

    var compDmProps = null;

    myLayout.registerComponent( 'dm_prop_panel', function(container, state ){
        compDmProps = compDmProps || new PgDmPropertiesView();
        var el = container.getElement().append(compDmProps.view.get$Element());
        compDmProps.view.addedToLayout(container);
    });


    var compDmStyles = null;

    myLayout.registerComponent( 'dm_styles_panel', function( container, state ){
        compDmStyles = compDmStyles || new PgDmStyleListView();
        var el = container.getElement().append(compDmStyles.view.get$Element());
        compDmStyles.view.addedToLayout(container);
    });

    var compSnap = null;

    myLayout.registerComponent( 'snap', function( container, state ){
        compSnap = compSnap || new PgSnapView();
        var el = container.getElement().append(compSnap.view.get$Element());
        compSnap.view.addedToLayout(container);
    });

    myLayout.on( 'initialised', function(){
        pgUIViewManager.updateVisibility();
    });

    if(pgIsDev() && false) {
        myLayout.init();
        myLayout.updateSize();
    } else {
        try {
            myLayout.init();
            myLayout.updateSize();
        } catch (err) {
            console.error(err);
            delete layoutStorage[layout_state_key];
            pgf.settings_on_backend && pinegrow.setSetting(layout_state_key, '');
            pinegrow.showAlert('Invalid workspace layout. Please restart Pinegrow.', 'Invalid layout');
        }
    }

    myLayout.restoreWorkspace = function(key) {
        var c;
        var save = false;

        if(typeof key === 'object') {
            //custom saved layout
            c = JSON.parse(key.config);
            if(key.ccmode != pinegrow.isContributorMode()) {
                pinegrow.showAlert('This layout can only be used if <b>CMS mode</b> is <b>' + (key.ccmode ? 'ON' : 'OFF') + '</b>.', 'Can\'t use the layout in the current mode');
                return;
            }
            save = true;
        } else {
            c = key ? getNamedConfig(key).config : getDefaultConfig();
        }
        var row_def = jQuery.extend(true, {}, c.content[0]);
        removePageViews(row_def, remove_more);

        try {
            hidden_stack = null;
            pgPageCodeEditorsStack.beforeDestroy();

            myLayout.withoutUpdateSize(function () {
                var row = myLayout._$normalizeContentItem(row_def);
                var old_row = myLayout.root.contentItems[0];

                var pages = old_row._$getItemsByProperty('componentName', 'pageview');
                var page_stacks = row.getItemsByFilter(function (item) {
                    return item.config.pages || false;
                })

                pages.forEach(function (page) {
                    page.parent.removeChild(page, true);
                    //page.tab.header.removeTab(page, true);
                    page_stacks[0].addChild(page);
                })

                var code_editors = old_row._$getItemsByProperty('componentName', 'code_editor');
                var code_editors_stacks = row.getItemsByFilter(function (item) {
                    return item.config.codeEditors || false;
                })

                code_editors.forEach(function (page) {
                    page.parent.removeChild(page, true);
                    //page.tab.header.removeTab(page, true);
                    code_editors_stacks[0].addChild(page);
                })

                myLayout.root.replaceChild(old_row, row, true);
            })

            myLayout.updateSize();
            setTimeout(function() {

                myLayout.root.getItemsByFilter(function(item) {
                    if (item.updateSplittersVisibility) item.updateSplittersVisibility();
                    return false;
                })

                //myLayout.updateSplitters();
                myLayout.updateSize();
            }, 200)

            pgPageCodeEditorsStack.setStack(null);

            if(save) {
                saveUIState();
            }

            if(!pgf.kids) {
                pinegrow.showQuickMessage('Restart Pinegrow if you are experiencing issues after restoring workspace.', 5000);
            }
        } catch(err) {
            pinegrow.showAlert(`There was a problem with restoring workspace. Please restart ${pgf.product_name}.`, 'Restart is needed');
            delete layoutStorage[layout_state_key];
            pgf.settings_on_backend && pinegrow.setSetting(layout_state_key, '');
        }
    }

    $('#crsa-left-plane').detach();

    var current_json_config = '';

    var checkLayoutConfig = function(config) {

        var has = {
            //lib_panel: false,
            //project_panel: false,
            history: false,
            pages_stack: false,
            editors_stack: false,
            status_bar: false,
            tree: false,
            prop_panel: false,
            style: false,
            element_code: false,
            dm_design_panel: false,
        }

        if(defLib) {
            has.lib_panel = false;
        }

        if(defProject) {
            has.project_panel = false;
        }

        if(defAnimations) {
            has.animations_panel = false;
        }

        if(defAnimationTimeline) {
            has.animation_timeline = false;
        }

        if(defClassStyles) {
            has.class_styles_panel = false;
        }

        if(defCms) {
            has.cms_panel = false;
        }

        if(defActions) {
            has.act_panel = false;
        }

        if(pinegrow.isContributorMode()) {
            delete has.style;
            delete has.act_panel;
            delete has.cms_panel;
            delete has.element_code;
            delete has.animations_panel;
            delete has.animation_timeline;
            delete has.class_styles_panel;
            delete has.dm_design_panel;
        }

        if(pgf.product === 'PGTC') {
            has = {
                project_panel: false,
                history: false,
                pages_stack: false,
                status_bar: false,
                tree: false,
                cms_panel: false,
                db_tree: false
            }
        }

        if(pgf.product === 'MAGIC') {
            has = {
                project_panel: false,
                history: false,
                pages_stack: false,
                status_bar: false,
                tree: false,
                dm_design_panel: false,
                dm_style_panel: false,
                dm_styles_panel: false,
                dm_prop_panel: false,
                act_panel: false
            }
        }

        if(pgf.product === 'KIDS') {
            var has = {
                pages_stack: false,
                editors_stack: false,
                status_bar: false,
                tree: false,
                prop_panel: false,
                style: false,
                info: false
            }
        }

        if(pgf.product === 'SNAP') {
            has = {
                snap: false,
                pages_stack: false
                //status_bar: false
            }
        }

        var checkItem = function(item) {

            if(item.type === 'component') {
                has[item.componentName] = true;
            } else if(item.type === 'stack') {
                if(item.pages) {
                    has['pages_stack'] = true;
                } else if(item.codeEditors) {
                    has['editors_stack'] = true;
                }
            }

            /*
            if(item.pg_win_id) {
                console.log(`Has Win ID ${item.pg_win_id}`, item)
            }*/

            if(item.content) {
                for(var i = 0; i < item.content.length; i++) {
                    checkItem(item.content[i]);
                }
            }
        }

        checkItem(config || myLayout.config);

        var ok = true;

        $.each(has, function(key, val) {
            if(val === false) {
                console.log('layout error on ' + key)
                ok = false;
            }
        })
        return ok;
    }

    myLayout.withoutSaveState = function(func) {
        var orig = typeof pgDontSaveLayoutState !== 'undefined' && pgDontSaveLayoutState;
        pgDontSaveLayoutState = true;
        func();
        pgDontSaveLayoutState = orig;
    }

    window.saveUIState = function() {
        if(!in_ui_drag && (typeof pgDontSaveLayoutState == 'undefined' || !pgDontSaveLayoutState)) {

            var config = myLayout.toConfig();

            if(!checkLayoutConfig(config)) {
                //don't save invalid config
                pinegrow.showQuickError('Oops... Invalid workspace layout. Please restart Pinegrow.', true);
                return;
            }

            var cj = JSON.stringify(config);

            if(cj != current_json_config) {
                //console.log('CONFIG CHANGED');
            }

            //console.log(cj)

            layoutStorage[layout_state_key] = cj;
            current_json_config = cj;
            layoutStorage.pg_layout_state_version = ui_version;

            layoutStorage.pg_layout_state_ccmode = pinegrow.isContributorMode() ? "1" : "";

            pgf.settings_on_backend && pinegrow.setSetting(layout_state_key, cj);
        }
    }

    window.pgCustomWorkspaces = new PgCustomWorkspaces(myLayout);

    myLayout.on( 'stateChanged', function(){
        pgUIViewManager.updateVisibility();
        if(pinegrow.connectors) pinegrow.connectors.update();
        //console.log(myLayout.toConfig());
        saveUIState();

        myLayout.updateSplitters();

        pgPreview.hide();

        if(win_floats) {
            pgCloseEmptyUIWindows();
        }

        var problems = [];

        var win_i = 0;

        //check if valid layout
        pgGetAppWindows().forEach(function(win) {
            var $lc = $(win.window.document).find('#layout-container');
            $lc.find('.lm_drop_tab_placeholder').remove();

            /*

            $lc.find('.lm_row,.lm_column').each(function(i, e) {
                //check if any splitter without element following it
                var $e = $(e);
                $e.find('> .lm_splitter').each(function(i, split) {
                    var $split = $(split);
                    var $next = $split.next();
                    if($next.length === 0 || !$next.is('.lm_item')) {
                        problems.push('Splitter without item! in ' + win_i);
                    }
                })
            }) */
            win_i++;
        })

        var checkItem = function(item) {
            var has = false;

            if(item.parent && !$.contains(item.parent.element.get(0), item.element.get(0)) && !item.isFloating) {
                has = true;
                problems.push('Misplaced element ' + win_i);
            }
            item.contentItems.forEach(function(ci) {
                has = has || checkItem(ci);
            })
            return has;
        }

        if(checkItem(myLayout.root)) {

        }

        //check if all components are displayed


        if(problems.length) {
            console.log('PROBLEMS', problems)
        }
    });

    myLayout.on('stackCollapsedOnActiveTabClick', function() {
        //pinegrow.showNotice('<p>Clicking on the icon of the tab that is already active, collapses the panel.</p><p>Collapsed panels are vertical.</p><p>Clicking on any tab icon in the panel will expand the panel back to its original size.</p><p>Use this feature to hide un-needed panels and make more space for the panels you are actively using.</p><p>' + pinegrow.showHelpImage('collapsed.panel.jpg') + '</p>', 'The panel was collapsed', 'panel-collapse-first');
    })

    var pgToggleFloatingPanelsValue = true;

    window.pgArePanelsQuicklyHidden = function() {
        return !pgToggleFloatingPanelsValue;
    }

    window.pgToggleFloatingPanels = function(force, no_message) {
        if(!pgf.hide_panels) return;

        var $floating = $('.lm_floating');

        if($floating.length == 0 && false) {
            if(!no_message) {
                pinegrow.showQuickMessage('There are no floating panels. Use <i class="icon icon-window" style="margin:0 4px;"></i> icon to float a panel.');
            }
            pinegrow.hidePanelsButton.setActive(false);
            pgToggleFloatingPanelsValue = true;
        } else {
            pgToggleFloatingPanelsValue = force === undefined ? !pgToggleFloatingPanelsValue : force;

            if (pgToggleFloatingPanelsValue) {
                //show
                pg$Show($floating)
                myLayout.uncollapseAllStacks();
            } else {
                //hide
                $floating.each(function(i, f) {
                    if($(f).find('.lm_allways_shown.active').length == 0) {
                        pgHide(f);
                    }
                })
                //pg$Hide($floating)
                myLayout.collapseAllStacks();

                pinegrow.showNotice('<p>All docked panels are collapsed and floating panels are hidden.</p><p>Press ' + pgShowKbdCombo('TAB') + ' or click on the <i class="icon icon-hide"></i> icon in the top toolbar to quickly toggle panels visibility.</p>', 'Panels are hidden', 'hideFloatingPanels2');
            }
            pgUIViewManager.updateVisibilityInArea($floating);
            pinegrow.hidePanelsButton.setActive(!pgToggleFloatingPanelsValue);
        }
    }
/*
    pinegrow.addEventHandler('on_selected_elements_changed', function(page) {
        var pgel = pinegrow.selectedElements.getLastSelected();
        var $floating = $('.lm_floating');
        if(pgel) {
            pg$Show($floating)
            //var p = new PgPositionNextToPgel($floating, pgel, null, 0);
            //p.destroy();
        } else {
            pg$Hide($floating)
        }
        pgUIViewManager.updateVisibilityInArea($floating);
    })
*/

    $('body').on('pg-ui-add-ss-panel', function (event, obj) {
        var cs = obj.cs;

        var $csPanel = $('#pg-' + cs.getUniqueName() + '-panel');

        if ($csPanel.length == 0) {
            var newItemConfig = {
                type:'component',
                componentName: 'css_panel',
                componentState: { uniqueName: cs.getUniqueName() },
                title: cs.name,
                isClosable: true
            }

            var sheetsPanelArr = myLayout.root.getItemsByFilter(function (component) {
                if (component.type == "component" && component.componentName == "sheets_panel") {
                    return true;
                }
                return false;
            });

            if (sheetsPanelArr.length > 0) {
                sheetsPanelArr[0].parent.addChild( newItemConfig );
            }
        }
    })

}

var pgUIViewId = 0;

//refresh on show

var PgUIView = function($element, name, display_name) {

    this.onDestroy = null;
    this.onShow = null;
    this.onHide = null;
    this.onResize = null;
    this.onMovedToAnotherWindow = null;

    this.name = name;
    this.display_name = display_name;

    this.alwaysVisible = false;

    this.tabIcon = null;

    var id = pgUIViewId++;

    this.getId = function() {
        return id;
    }

    var _this = this;

    this.parent = null;

    var handlers = [];

    var gl_content_item_container = null; //if added to Golden layout item container

    var sizes = [250, 300]

    var _onResize = function() {
        var w = $element.width();
        var classes = $element.attr('class') || '';

        var size = 'lg';

        if(w <= 200) {
            size = 'xs';
        } else if(w <= 300) {
            size = 'sm';
        } else if(w <= 400) {
            size = 'md'
        }

        classes = classes.replace(/(^|\s)pg\-view\-width\-(xs|sm|md|lg)(\s|$)/, '');
        classes += ' pg-view-width-' + size;
        $element.attr('class', classes);

        if(_this.onResize) {
            _this.whenVisible(function() {
                _this.onResize();
            }, 'resize', 1)
        }
        positionNotificationBadge();
    }

    var _onTabClosed = function() {
        _this.destroy();
    }

    var _onBeforeTabClosed = function() {
        if(_this.onBeforeDestroy) _this.onBeforeDestroy();
    }

    this.getWindow = function() {
        var el = $element.get(0);
        return el.ownerDocument ? el.ownerDocument.defaultView : null;
    }

    this.getTab = function() {
        if(gl_content_item_container && gl_content_item_container.tab) {
            return gl_content_item_container.tab;
        }
        return null;
    }

    this.addedToLayout = function(c) {
        gl_content_item_container = c;
        gl_content_item_container.on('resize', _onResize);
        gl_content_item_container.on('tabClosed', _onTabClosed);
        gl_content_item_container.on('beforeTabClosed', _onBeforeTabClosed);

        if(this.classForContainer) {
            //console.log(gl_content_item_container)
            gl_content_item_container._element.addClass(this.classForContainer);
        }
        if(this.tabIcon) {
            c.on( 'tab', function() {
                var $i = $('<i class="tab-icon icon ' + _this.tabIcon + '"></i>').insertBefore(c.tab.element.find('.lm_title'));
                c.tab.element.addClass('pg-tab-with-icon');

                addTooltip(c.tab.element, '<b>' + c.parent.config.title + '.</b>' + (pgf.kids ? '' : 'Click to switch to the tab. Double click to collapse the panel.'));

            } );

        }
        if(this.onAddedToLayout) {
            this.onAddedToLayout(c);
        }
    }

    var $notificationBadge = null;

    var positionNotificationBadge = function() {
        if($notificationBadge && gl_content_item_container) {
            var docked = gl_content_item_container._element.closest('.lm_item').hasClass('lm_docked_closed');

            var pos = gl_content_item_container.tab.element.offset();
            $notificationBadge.css({
                top: (pos.top - 6) + 'px',
                left: (pos.left + gl_content_item_container.tab.element.width() - 6 + (docked ? -20 : 0)) + 'px'
            })
        }
    }

    this.setNotificationBadge = function(val, tooltip) {
        if(gl_content_item_container) {

            if($notificationBadge) {
                $notificationBadge.remove();
                $notificationBadge = null;
            }

            if(!$notificationBadge) {
                $notificationBadge = $(`<div class="pg-notification-badge"></div>`).appendTo(gl_content_item_container.tab.element.closest('body'))
            }
            if(val) {
                $notificationBadge.html(val);
                if(tooltip) {
                    addTooltip($notificationBadge, tooltip)
                }
                positionNotificationBadge();
            } else {
                $notificationBadge.remove();
                $notificationBadge = null;
            }
        }
    }

    var itemActiveBeforeShow = null;

    this.getLayoutItem = function() {
        return gl_content_item_container ? gl_content_item_container.parent : null;
    }

    this.showInUI = function(flash, if_not_collapsed, next_to_panel) {
        if(gl_content_item_container) {
            var item = gl_content_item_container.parent;

            var hidden_stack = myLayout.getHiddenStackForHiddenPanels();
            if(item.parent === hidden_stack || item.parent.config.hidden_stack) {
                //this is a panel hidden in the hidden stack
                //lets restore it back to the original position
                var done = false;
                if(next_to_panel) {
                    //try to display the panel in the same stack as the next_to_panel
                    if(next_to_panel === 'pages') {
                        //under pages
                        var pages_stack = myLayout.root.getItemsByFilter(function(item) {
                            if(item.config.pages) return true;
                        })[0];

                        if(pages_stack) {
                            var info_stack = myLayout._$normalizeContentItem({
                                type: 'stack',
                                isClosable: false,
                                notCollapsable: false,
                                width: 0,
                                height: item.config.parentStackHeight || 25,
                                addClass: 'pg-force-min-panel-height',
                                isHidden: false,
                                hidden_stack: false,
                                dontCollapseOnActiveTabClick: false,
                                hideStackIfSinglePanelHidden: true
                            });
                            //info_stack.config.hideStackIfSinglePanelHidden = true;

                            pages_stack.parent.addChild(info_stack, pages_stack.parent.contentItems.indexOf(pages_stack) + 1);

                            item.rememberedParent = info_stack;
                            item.rememberedIndex = 0;
                            done = true;
                        }
                    } else {
                        var next_to_view = pgUIViewManager.getView(next_to_panel);
                        if (next_to_view && !next_to_view.isHiddenInUI()) {
                            var next_item = next_to_view.getLayoutItem();
                            if (next_item) {
                                item.rememberedParent = next_item.parent;
                                item.rememberedIndex = 0;
                                done = true;
                            }
                        }
                    }
                }
                if(!done) {
                    item.rememberedIndex = item.config.rememberedPosition ? item.config.rememberedPosition.index : 0;
                    item.rememberedParent = item.config.rememberedPosition ? findStackByPositionObjectId(item.config.rememberedPosition.parent_id) : null;
                }
                myLayout.withoutSaveState(function() {
                    item.parent.removeChild(item, true);
                })

                if(!item.restoreAtRememberedPosition(item.parent, true)) {
                    myLayout.root.contentItems[0].addChild(item, undefined, null, true /* force main win */);
                }
                if(item.parent.config.isHidden) {
                    item.parent.showStack();
                }
            } else if(item.parent.config.isHidden) {
                item.parent.showStack();
            }

            var $f = item.element.closest('.lm_floating');
            if($f.length && !$f.is(':visible')) {
                pgToggleFloatingPanels(true);
            }

            if(item.parent.config.isHidden) {
                item.parent.showStack();
            }

            if(item.parent.isDockedClosed) {
                if(if_not_collapsed) return;

                item.parent.openDocked();
            }
            itemActiveBeforeShow = item.parent.getActiveContentItem();
            if(itemActiveBeforeShow == item) {
                itemActiveBeforeShow = null;
            }

            item.parent.setActiveContentItem(item);

            if(flash) {
                pg$Flash($element, typeof flash === 'string' ? flash : 'bck_flash');
            }
        }
    }

    var findStackByPositionObjectId = function(id) {
        return myLayout.root.getItemsByFilter(function(item) {
            if (item.config.position_object_id === id) return true;
        })[0];
    }

    this.hideInUI = function() {
        if(gl_content_item_container) {
            var item = gl_content_item_container.parent;

            if(item.parent?.config?.hideStackIfSinglePanelHidden) {
                if(item.parent.contentItems.length === 1) {
                    item.parent.hideStack();
                    return;
                }
            }

            item.rememberPosition();

            var parent_id = item.rememberedParent.config.position_object_id || 'pid' + Math.random();
            item.rememberedParent.config.position_object_id = parent_id;

            item.config.rememberedPosition = {
                index: item.rememberedIndex,
                parent_id: parent_id
            }
            item.config.parentStackHeight = item.parent.config.height;

            var hidden_stack = myLayout.getHiddenStackForHiddenPanels();
            var old_parent = item.parent;

            myLayout.withoutSaveState(function() {
                item.parent.removeChild(item, true);
            })
            hidden_stack.addChild(item);

            if(old_parent.contentItems.length === 0) {
                old_parent.hideStack();
            }
        }
    }

    this.isHiddenInUI = function() {
        if(gl_content_item_container) {
            var item = gl_content_item_container.parent;

            return item.parent.config.hidden_stack || item.parent.config.isHidden;
        }
    }

    this.undoShowInUI = function() {
        if(itemActiveBeforeShow) {
            var item = gl_content_item_container.parent;
            item.parent.setActiveContentItem(itemActiveBeforeShow);
            itemActiveBeforeShow = null;
        }
    }

    this.setAlwaysVisible = function(val) {
        this.alwaysVisible = val;
        this.updateVisibility();
    }


    //will be auto removed on destroy
    this.on = function(event, func) {
        handlers.push({event: event, func: func});
        $('body').on(event, func);
    }

    $element.addClass('pg-ui-view').data('pg-ui-view', this);

    this.get$Element = function() {
        return $element;
    }

    this.destroy = function() {
        when_visible_funcs = [];
        if(name) {
            pgUIViewManager.unregisterView(name);
        }

        $element.data('pg-ui-view', null);

        if(gl_content_item_container) {
            gl_content_item_container.off('resize', _onResize);
            gl_content_item_container.off('tabClosed', _onTabClosed);
            gl_content_item_container.off('beforeTabClosed', _onBeforeTabClosed);
        }

        handlers.forEach(function(h) {
            $('body').off(h.event, h.func);
        })

        if(this.onDestroy) {
            this.onDestroy();
        }

        if($notificationBadge) {
            $notificationBadge.remove();
            $notificationBadge = null;
        }

        $element.remove();
        this.parent = null;
    }

    var visible = $element.is(':visible') || this.alwaysVisible;

    this.isVisible = function() {
        return visible;
    }

    this.updateVisibility = function() {
        var v = this.alwaysVisible || $element.is(':visible');
        //console.log('updateVisibility: ' + (name || 'view') + ' = ' + v + ' (' + visible + ')');
        if(v != visible) {
            visible = v;
            if(v) {
                when_visible_funcs.forEach(function(d) {
                    d.func();
                })
                when_visible_funcs = [];

                if(this.onShow) {
                    this.onShow();
                }
            } else {
                if(this.onHide) this.onHide();
            }
        }
    }

    var when_visible_funcs = [];

    //func will be run immediatelly if view is visible, otherwise when it becomes visible
    this.whenVisible = function(func, task, order) {
        task = task || 'show';
        if(order === undefined) order = 0;

        if(!visible) {
            //make sure it is visible or not
            //visible = this.alwaysVisible || $element.is(':visible');
        }
        if(visible) {
            func();
        } else {
            clearWhenVisibleTask(task);
            var d = {func: func, task: task, order: order};
            var done = false;
            for(var i = 0; i < when_visible_funcs.length; i++) {
                if(when_visible_funcs[i].order >= order) {
                    when_visible_funcs.splice(i, 0, d);
                    done = true;
                    break;
                }
            }
            if(!done) when_visible_funcs.push(d);
        }
    }

    var clearWhenVisibleTask = function(task) {
        var idx = -1;
        for(var i = 0; i < when_visible_funcs.length; i++) {
            if(when_visible_funcs[i].task === task) {
                idx = i;
                break;
            }
        }
        if(idx >= 0) {
            when_visible_funcs.splice(idx, 1);
        }
    }

    this.clearWhenVisible = function(task) {
        if(task) {
            clearWhenVisibleTask(task);
        } else {
            when_visible_funcs = [];
        }
    }

    this.getFastdomTasks = function() {
        return pgGetFastdomTasks($element.get(0));
    }

    if(name) {
        pgUIViewManager.registerView(name, this);
    }
}

var pgGetFastdomTasks = function(el) {
    return pgFastdomTasks;

    if(!el) return pgFastdomTasks;
    var doc = el.ownerDocument;
    var win = (doc && doc.defaultView ) ? doc.defaultView : window;
    //console.log('Using fast dom of ' + win.pg_win_id)
    return win.pgFastdomTasks;
}


var PgUIViewManager = function() {

    var named_views = {};
    var _this = this;

    this.registerView = function(name, v) {
        named_views[name] = v;
    }

    this.unregisterView = function(name) {
        if(named_views[name]) {
            delete named_views[name];
        }
    }

    this.getView = function(name) {
        return named_views[name] || null;
    }

    var forEachView = function($area, func) {
        $area.add($area).find('.pg-ui-view').each(function(i, e) {
            var $e = $(e);
            var view = $e.data('pg-ui-view');
            if(view) {
                func(view);
            }
        })
    }

    this.forEachView = forEachView;

    this.destroyViewsInArea = function($area) {
        forEachView($area, function(view) {
            view.destroy();
        })
    }

    this.updateVisibility = function() {
        pgGetAppWindows().forEach(function(win) {
            _this.updateVisibilityInArea($(win.window.document.body));
        })
    }

    this.updateVisibilityInArea = function($area) {
        forEachView($area, function(view) {
            view.updateVisibility();
        })
    }

    this.getViewForElement = function($el, search_parents) {
        if(!$el.is('.pg-ui-view') && search_parents) {
            $el = $el.closest('.pg-ui-view');
        }
        return $el.data('pg-ui-view');
    }

    this.hideElement = function($el) {
        $el.hide();
        var view = this.getViewForElement($el);
        if(view) {
            view.updateVisibility();
        }
    }

    this.showElement = function($el) {
        $el.show();
        var view = this.getViewForElement($el);
        if(view) {
            view.updateVisibility();
        }
    }
}

var pgUIViewManager = new PgUIViewManager();


var PgToggleButtonMaker = function() {

    var _this = this;

    var getStyles = function(options) {
        if (!options) return '';
        var styles = options.styles;

        if (!styles) return '';
        var s = '';
        $.each(styles, function(f, k) {
            s += f + ':' + k + ' !important;';
        })
        return s;
    }

    var getAttrs = function (options) {
        if (!options) return '';
        if(options.title) {
            if(!options.attributes) {
                options.attributes = {};
            }
            options.attributes.title = options.title;
        }
        var attrs = options.attributes;

        if (!attrs) return '';
        var s = '';
        $.each(attrs, function(f, k) {
            s += f + '="' + k + '" ';
        });
        return s;
    }

    var getElement = function(options, text, classes, tag) {
        text = text || '';
        tag = tag || 'div';
        return '<' + tag + ' class="pg-tb-button' + (classes ? (' ' + classes) : '') + '" ' + getAttrs(options) + 'style="' + getStyles(options) + '">' + text + '</' + tag + '>';
    }

    this.makeColor = function(color, text, options) {
        options = options || {};
        var prop = 'background-color';
        if (options && options['use-background-image']) {
            prop = 'background-image';
        }
        var def = {
            styles: {
                'border-radius': '3px',
                'width': '18px',
                'height': options.height || '16px',
                [prop]: color || 'transparent'
            }
        }

        return getElement($.extend({}, def, options), text, 'pg-tb-button-color');
    }

    this.makeColorFromCSSVariable = function(variable, options, text) {
        return function() {
            var color = _this.getColorFromCSSVariable(variable, options.default || null);
            return _this.makeColor(color, text, options);
        }
    }

    this.getColorFromCSSVariable = function(v, def) {
        var c = def || 'rgba(0,0,0,0)';
        var page = pinegrow.getSelectedPage();
        if(page) {
            c = page.getCSSVariableValue(v) || def || 'rgba(0,0,0,0)';
        }
        return c;
    }

    this.makeColorTextFromCSSVariable = function(variable, options, text) {
        return function() {
            var color = _this.getColorFromCSSVariable(variable, options.default_color || null);
            return _this.makeColorText(color, options, text);
        }
    }

    this.makeColorText = function(color, options, text) {
        var opts = {
            styles: {
                color: color
            }
        }
        return getElement($.extend({}, opts, options), '', 'pg-tb-button-icon icon icon-ikone1-100-copy-63', 'i');
    }

    this.makeText = function(text, options) {
        return getElement(options, text, 'pg-tb-button-text');
    }

    this.makeIcon = function(icon, options) {
        return getElement(options, '', 'pg-tb-button-icon icon icon-' + icon, 'i');
    }

    this.makeImage = function(url, options) {
        return getElement(options, `<img src="${url}">`, 'pg-tb-button-image');
    }
}


var pgToggleButtonsCount = 1;

var PgToggleButtons = function($cont, options) {

    var def = {
        input_type: 'hidden',
        multiple: false,
        compact: false,
        compact_current_html: null,
        on_button_highlighted: null,
        on_enter: null,
        on_leave: null
    }

    this.id = 'pgToggleButton_' + pgToggleButtonsCount++;

    var update_task = null;
    var inherited_task = null;

    this.default_value = null;

    var settings = $.extend({}, def, options);

    if(settings.compact) {
        var $compact_container = $(`<div class="pg-tb-compact-container"><div class="pg-tb-compact-current"></div></div>`).appendTo($cont);
        $cont = $compact_container;
        var $compact_current = $compact_container.find('.pg-tb-compact-current');
    }

    var $list = $(`<div class="pg-tb${settings.compact ? ' pg-tb-compact' : ''}"></div>`).appendTo($cont);
    var $input = null;//$('<input type="hidden">').appendTo($list);

    var get$input = function() {
        if(!$input) {
            switch(settings.input_type) {
                case 'hidden':
                    $input = $('<input type="hidden">').appendTo($list);
                    break;
                case 'checkbox':
                    $input = $('<input type="checkbox" value="' + settings.checkbox_value + '" style="display:none;">').appendTo($list);
                    break;
            }
        }
    }

    var getInputValue = function() {
        switch(settings.input_type) {
            case 'hidden':
                return $input.val();
                break;
            case 'checkbox':
                return $input.is(':checked') ? settings.checkbox_value : null;
                break;
        }
    }

    var setInputValue = function(v) {
        if(!$input) return;

        switch(settings.input_type) {
            case 'hidden':
                $input.val(v);
                break;
            case 'checkbox':
                $input.prop("checked", v == settings.checkbox_value);
                break;
        }
    }


    this.options = [];

    var options = [];

    this.show_empty = false;

    var value = null;

    var _this = this;

    this.get$list = function () {
        return $list;
    }

    this.get$input = function() {
        get$input();
        return $input;
    }

    var shown = false;

    this.show = function() {
        if(typeof this.options == 'function') {
            options = this.options();
        } else {
            options = this.options;
        }
        get$input();
        addHandlers();
        update();
        shown = true;

        //Compatibility with PgInputField setValue
        $input.on('crsa-field-value-updated', function(e) {
            _this.setValue(getInputValue());
        })
    }

    var current_node = null;
    var current_inherited = null;

    this.setValue = function(val) {
        value = val;
        setInputValue(val);
        if(shown) {
            update();
        }
    }

    this.getValue = function() {
        return value;
    }

    this.setMultipleValues = function(has) {
        if(has && has instanceof Array) {
            $list.find('>div').each(function(i, div) {
                var def = options[i];
                if(has.indexOf(def.key) >= 0) {
                    $(div).addClass('active');
                }
            })
        }
    }

    var update = function() {

        if(update_task) {
            update_task.stop();
            update_task = null;
        }
        if(inherited_task) {
            inherited_task.stop();
            inherited_task = null;
        }

        if($input) $input.detach();

        _this.onBeforeUpdate && _this.onBeforeUpdate();

        //$list.empty();

        current_node = null;
        current_inherited = null;

        var s = '';

        var values;

        if(settings.multiple) {
            values = (value || '').split(',');
        } else {
            values = [];
            if(value !== null) values.push(value);
        }

        var current_html = '';

        for(var i = 0; i < options.length; i++) {
            var html;
            if(options[i].html) {
                html = typeof options[i].html === 'function' ? options[i].html() : options[i].html;
            } else if(options[i].icon) {
                // TODO: @add-icon check this
                html = '<i class="fa fa-' + options[i].icon + '"></i>';
            } else {
                html = options[i].name;
            }
            var is_active = (values.indexOf(options[i].key) >= 0 || (_this.default_value !== null && _this.default_value == options[i].key));

            if(i === 0 || is_active) {
                current_html = html;
            }
            if(settings.compact_current_html) {
                current_html = settings.compact_current_html;
            }
            s += '<div ' + (is_active ? 'class="active" ' : '') + 'data-item-id="' + i + '" data-item-key="' + options[i].key + '">' + html + '</div>';
        }

        $list.get(0).innerHTML = s;

        (value !== null) ? $list.addClass('has-value') : $list.removeClass('has-value');

        if($input) $input.appendTo($list);

        $compact_current && ($compact_current.get(0).innerHTML = current_html);

        _this.onAfterUpdate && _this.onAfterUpdate();
    }

    var updateFast = function() {
        var values;

        if(settings.multiple) {
            values = (value || '').split(',');
        } else {
            values = [];
            if(value !== null) values.push(value);
        }
        if(values.length === 0 && _this.default_value !== null) {
            values.push(_this.default_value);
        }

        if(update_task) {
            update_task.stop();
            update_task = null;
        }

        update_task = pgFastdomTasks.create(_this.id + '_update');

        update_task.mutate(function() {
            var list = $list.get(0);
            for(var i = 0; i < list.children.length; i++) {
                var node = list.children[i];
                if(node.tagName === 'DIV') {
                    var key = node.getAttribute('data-item-key');
                    if(values.indexOf(key) >= 0) {
                        if(!node.classList.contains('active')) {
                            node.classList.add('active');
                        }
                    } else {
                        if(node.classList.contains('active')) {
                            node.classList.remove('active');
                        }
                    }
                }
            }
        })
    }

    this.setInheritedValue = function(val, resp_label) {
        if(shown) {
            if(inherited_task) {
                inherited_task.stop();
                inherited_task = null;
            }

            inherited_task = pgFastdomTasks.create(_this.id + '_set_inherited');

            inherited_task.mutate(function() {
                if (current_inherited) {
                    current_inherited.classList.remove('inherited');
                }

                if (val) {
                    current_inherited = $list.get(0).querySelector(`[data-item-key="${val}"]`);
                    if(current_inherited) {
                        current_inherited.classList.add('inherited');
                        var label = current_inherited.querySelector('span.responsive-label');
                        if(!label) {
                            label = document.createElement("span");
                            label.classList.add('responsive-label');
                            current_inherited.prepend(label);
                        }
                        label.innerText = resp_label;
                    }
                } else {

                }
            })
        }
    }

    var addHandlers = function() {

        var $target;

        var getItem = function(event) {
            $target = $(event.target).closest('[data-item-id]');
            if($target.length) {
                var id = parseInt($target.attr('data-item-id'));
                return id < options.length ? options[id] : null;
            }
            return null;
        }

        if(settings.on_enter) {
            $list.on('mouseenter', function(e) {
                settings.on_enter($list);
            })
        }

        if(settings.on_leave) {
            $list.on('mouseleave', function(e) {
                settings.on_leave($list);
            })
        }

        if(settings.on_button_highlighted) {
            $list.on('mouseenter', '[data-item-id]', function(e) {
                var item = getItem(e);
                item && settings.on_button_highlighted(item);
            })

            $list.on('mouseleave', '[data-item-id]', function(e) {
                settings.on_button_highlighted(null);
            })
        }



        $list.get(0).addEventListener('click', function(e) {
            var item = getItem(e);
            if(item) {
                var has_active = $target.hasClass('active');

                if((_this.show_empty || settings.multiple) && has_active) {
                    $target.removeClass('active');

                    if(settings.multiple) {
                        var a = value ? value.split(',') : [];
                        var idx = a.indexOf(item.key);
                        if(idx >= 0) {
                            a.splice(idx, 1);
                        }
                        value = a.join(',');
                    } else {
                        $list.find('>.active').removeClass('active');
                        value = null;
                    }
                    setInputValue(value);

                    if($compact_current) {
                        $compact_current.get(0).innerHTML = settings.compact_current_html || $list.find('>div').get(0).innerHTML;
                    }
                } else {
                    if(!settings.multiple) {
                        $list.find('>div').removeClass('active');
                    }
                    $target.addClass('active');
                    //setInputValue(item.key);
                    if(settings.multiple) {
                        var a = value ? value.split(',') : [];
                        var idx = a.indexOf(item.key);
                        if(idx < 0) {
                            a.push(item.key);
                        }
                        value = a.join(',');
                    } else {
                        value = item.key;
                    }
                    setInputValue(value);

                    if($compact_current) {
                        $compact_current.get(0).innerHTML = settings.compact_current_html || $list.find('>.active').get(0).innerHTML;
                    }
                }
                if(settings.on_click) {
                    settings.on_click();
                }
                if($input) $input.trigger('change');
                if(_this.onChanged) _this.onChanged.call(_this, value);
            }
        }, true);

    }

    this.destroy = function() {
        if(update_task) {
            update_task.stop();
            update_task = null;
        }
        if(inherited_task) {
            inherited_task.stop();
            inherited_task = null;
        }
    }
}

var PgCheckbox = function($cont, label, value) {

    var pm = new PgToggleButtonMaker();

    PgToggleButtons.call(this, $cont, {
        input_type: 'checkbox',
        checkbox_value: value
    });

    this.show_empty = true;

    this.options = [{
        key: value,
        name: label,
        html: pm.makeText(label)
    }]
}

PgCheckbox.prototype = Object.create(PgToggleButtons.prototype);
PgCheckbox.prototype.constructor = PgCheckbox;

var PgPanelNotice = function(with_arrow, high_priority) {
    this.$element = $('<div class="alert alert-info alert-panel-notice"><content></content></div>').hide();

    var $content = this.$element.find('content');

    if(with_arrow) {
        this.$element.append(`<div class="alert-arrow"></div>`);
        this.$element.addClass('with-arrow');
    }

    if(high_priority) {
        this.$element.addClass('important')
    }

    this.isShown = function() {
        return this.$element.is(':visible');
    }

    this.show = function(msg) {
        if(msg) {
            $content.html(msg);
            this.$element.show();
        } else {
            $content.empty();
            this.$element.hide();
        }
    }
}


var PgCodePanelNotice = function() {

    var msg = null;
    var $element = $('<div class="panel-notice"></div>').hide();

    this.onShow = null;
    this.onHide = null;

    this.hideOnEmpty = false;

    this.get$Element = function() {
        return $element;
    }

    this.getMessage = function() {
        return msg;
    }

    this.setMessage = function(m, top) {
        if(m !== msg) {
            $element.html(m);
            msg = m;
            if(this.hideOnEmpty) {
                if (msg) {
                    if (!$element.is(':visible')) {
                        $element.show();
                        if (this.onShow) this.onShow();
                    }
                } else {
                    if ($element.is(':visible')) {
                        $element.hide();
                        if (this.onHide) this.onHide();
                    }
                }
            }
        }
        if(top !== undefined) {
            if (top) {
                $element.addClass('top');
            } else {
                $element.removeClass('top');
            }
        }
    }
}

var PgFastdomTask = function(fd, manager) {
    this.manager = manager || pgFastdomTasks;
    this.fastdom = fd || fastdom;
    this.ids = [];
    this.done_count = 0;
}

PgFastdomTask.prototype.measure = function(func) {
    var _this = this;
    this.ids.push(this.fastdom.measure(function() {
        func();
        _this.done_count++;
        _this.cleanupIfDone();
    }));
}

PgFastdomTask.prototype.mutate = function(func) {
    var _this = this;
    this.ids.push(this.fastdom.mutate(function() {
        func();
        _this.done_count++;
        _this.cleanupIfDone();
    }));
}

PgFastdomTask.prototype.stop = function(func) {
    //console.log('stopping task');
    var _this = this;
    this.ids.forEach(function(id) {
        _this.fastdom.clear(id);
    })
    this.ids = [];
    this.done_count = 0;
    this.cleanupIfDone();
}

PgFastdomTask.prototype.cleanupIfDone = function() {
    if(this.done_count === this.ids.length) {
        this.ids = [];
        this.manager.done(this);
    }
}

var PgFastdomTaskManager = function(fd) {
    fd = fd || fastdom;

    var list = [];

    var count = 0;

    this.getUniqueKey = function() {
        return 'task_' + count++;
    }

    this.create = function(key, data) {
        var task = this.find(key, data);

        if(task) {
            task.stop();
        }

        task = new PgFastdomTask(fd, this);
        list.push({
            key: key,
            data: data,
            task: task
        })
        return task;
    }

    this.createDummy = function() {
        return {
            measure: function(func) { func() },
            mutate: function(func) { func() }
        }
    }

    this.done = function(task) {
        for(var i = 0; i < list.length; i++) {
            if(list[i].task === task) {
                list.splice(i, 1);
                break;
            }
        }
    }

    this.find = function(key, data, all) {
        var r = [];
        for(var i = 0; i < list.length; i++) {
            if(list[i].key === key && (!data || list[i].data === data)) {
                if(all) {
                    r.push(list[i].task);
                } else {
                    return list[i].task;
                }
            }
        }
        return all ? r : null;
    }

    this.stopAll = function(key, data) {
        this.find(key, data, true).forEach(function(task) {
            task.stop();
        })
    }

    fd.catch = function(error) {

    }
}

window.pgFastdomTasks = window.pgFastdom = new PgFastdomTaskManager();

var PgCustomWorkspaces = function(myLayout) {
    var custom = [];

    var key = 'pg_custom_workspaces';

    var layoutStorage = localStorage;
    if(pgf.settings_on_backend && pgwpdata && pgwpdata.user_settings) {
        layoutStorage = pgwpdata.user_settings;
    }

    if(layoutStorage[key]) {
        try {
            custom = JSON.parse(layoutStorage[key]);
        } catch(err) {}
    }

    var findCustom = function(name) {
        for(var i = 0; i < custom.length; i++) {
            if(custom[i].name === name) return i;
        }
        return -1;
    }

    this.getList = function() {
        return custom;
    }

    this.save = function(name, config) {
        if(!config) {
            config = JSON.stringify(myLayout.toConfig());
        }
        var item = {
            name: name,
            config: config,
            ccmode: pinegrow.isContributorMode()
        }
        var idx = findCustom(name);
        if(idx < 0) {
            custom.push(item);
        } else {
            custom[idx] = item;
        }
        saveCustom();
    }

    this.remove = function(name) {
        var idx = findCustom(name);
        if(idx >= 0) {
            custom.splice(idx, 1);
        }
        saveCustom();
    }

    var saveCustom = function() {
        var c = JSON.stringify(custom);
        layoutStorage[key] = c;
        if(pgf.settings_on_backend) {
            pinegrow.setSetting(key, c);
            pinegrow.backend.savePendingUserSettings();
        }
    }
}

var pg_app_windows = [];
var pg_app_internal_windows = [];
var pg_active_window = null;
var pg_win_id_count = 0;
var pg_focus_list = [];
var pg_app_win_under_mouse = null;
var pg_app_win_dont_put_on_top = false;
var pg_app_win_ignore_focus_blur = false;
var pg_app_win_set = false;
var pg_app_win_main_on_top = is_mac;
var pg_app_win_is_main_on_top = false;
var pg_app_win_shown = false;
var pg_win_ids = [];

var pg_is_pg_win_active = true;

/*
var originalSetTimeout = setTimeout;
var originalClearTimeout = clearTimeout;

window.setTimeout = function(func, delay, a, b, c, d, e, f) {
    var st = (pg_active_window && pg_active_window !== pg_app_windows[0]) ? pg_active_window.window.setTimeout : originalSetTimeout;
    return st(func, delay, a, b, c, d, e, f);
}

window.clearTimeout = function(handle) {
    var st = (pg_active_window && pg_active_window !== pg_app_windows[0]) ? pg_active_window.window.clearTimeout : originalClearTimeout;
    return st(handle);
}
*/

var pgHasFloatingWindows = function() {
    return pg_app_windows.length > 1;
}

var pgAppWindowsStopIgnoringBlurDelayed = function() {
    pg_app_win_delayed_tasks.run('clearIgnore', function() {
        pg_app_win_ignore_focus_blur = false;
    }, 200)
}

var pgAppWindowIgnoreBlurForAWhile = function() {
    pg_app_win_ignore_focus_blur = true;
    pgAppWindowsStopIgnoringBlurDelayed();
}

var pgShowAppWindows = function() {
    for (var i = 0; i < pg_app_windows.length; i++) {
        if (pg_focus_list.indexOf(pg_app_windows[i]) < 0) {
            pg_focus_list.unshift(pg_app_windows[i]);
        }
    }

    for (var i = 0; i < pg_focus_list.length; i++) {
        if (pg_focus_list[i] !== pg_app_windows[0]) {
            //console.log('should set on top ' + i + '?')
            if(pgAppWindowHasVisibleContent(pg_focus_list[i])) {
                //pg_focus_list[i].show();
                //console.log('set on top ' + i)
                //pg_focus_list[i].setAlwaysOnTop(true);
                pgAppWindowSetOnTop(pg_focus_list[i], true);
                pg_focus_list[i].pg_is_shown = true;
                //$(pg_focus_list[i].window.document.documentElement).css('display','');
            }
        }
    }
    pg_app_win_shown = true;
}

var pgDebugAppWins = function() {
    return;
    console.log('----')
    pg_app_windows.forEach(function(win) {
        console.log(`Win ${win.pg_win_id} on top ${win.isAlwaysOnTop}`, win);
    })
    console.log('----')
    pg_focus_list.forEach(function(win) {
        console.log(`Focus order Win ${win.pg_win_id}`);
    })
}

var pgAppWindowSetOnTop = function(win, val) {

    //console.log(`Set on top Win ${win.window.pg_win_id} to ${val}`);
    if(win !== pg_app_windows[0]) {
        if(val !== win._pg_is_shown) {
            if(val) {
                if(pgAppWindowHasVisibleContent(win)) {
                    win.show();
                    win._pg_is_shown = val;
                }
            } else {
                win.hide();
                win._pg_is_shown = val;
            }
        }
    } else {
        return;
    }
    if(val) {
        //win.setAlwaysOnTop(false);
    }
    win.setAlwaysOnTop(val);
}

var pgAppWindowHasFocus = function(win) {
    if(!win) return;

    pinegrow.getClipboard().onWindowFocus();

    pg_app_win_ignore_focus_blur = true;

    pg_app_win_delayed_tasks.run('endIgnoreBlur', function () {
        pg_app_win_ignore_focus_blur = false;
    }, 100)

    var idx = pg_focus_list.indexOf(win);
    if (idx >= 0) {
        pg_focus_list.splice(idx, 1);
    }
    pg_focus_list.push(win);

    var main_focused = win === pg_app_windows[0];
    if (main_focused) {
        //main win is focused, we can switch off always on top for main
        //pg_app_windows[0].setAlwaysOnTop(false);
        pgAppWindowSetOnTop(pg_app_windows[0], false);
        //console.log('main not on top');
        pg_app_win_is_main_on_top = false;
    }

    if (!pg_is_pg_win_active || pg_active_window === pg_app_windows[0]) {

        if (!main_focused && pg_app_win_main_on_top && !pg_app_win_is_main_on_top) {

            //pg_app_windows[0].setAlwaysOnTop(true);

            pgAppWindowSetOnTop(pg_app_windows[0], true);
            pg_app_win_is_main_on_top = true;
            pg_app_win_set = false;
//            console.log('main ON top');
        }

        for (var i = 0; i < pg_app_windows.length; i++) {
            if (pg_focus_list.indexOf(pg_app_windows[i]) < 0) {
                pg_focus_list.unshift(pg_app_windows[i]);
            }
        }


        if(!pg_app_win_shown || (pg_app_win_is_main_on_top && !pg_app_win_set)) {
            pgShowAppWindows();
            pg_app_win_set = true;
        }
        //win.show(); was preventing minimize on win
        //win.focus();
    }

    pgDebugAppWins();

    pg_active_window = win;
    pg_is_pg_win_active = true;

}

var pgAppWindowLostFocus = function(win) {

    if(typeof pinegrow !== 'undefined') {
        pinegrow.getClipboard().onWindowBlur();
    }

    if(pg_app_win_ignore_focus_blur) return;

    pg_is_pg_win_active = false;

    if(pg_app_windows.length) {
        pg_active_window = pg_app_windows[0];
    }

    pg_app_win_delayed_tasks.run('hideIfPgNotFocused', function() {
        if(!pg_is_pg_win_active) {
            //another app is active
            if(pg_app_win_main_on_top) {
                //pg_app_windows[0].setAlwaysOnTop(false);
                pgAppWindowSetOnTop(pg_app_windows[0], false);
                pg_app_win_is_main_on_top = false;
                //console.log('main not on top');
            }

            for (var i = 1; i < pg_app_windows.length; i++) {
                //pg_app_windows[i].setAlwaysOnTop(false);
                pgAppWindowSetOnTop(pg_app_windows[i], false);
                //pg_app_windows[i].hide();
                //$(pg_app_windows[i].window.document.documentElement).css('display','none');
                pg_app_windows[i].pg_is_shown = false;
            }
            pg_app_win_shown = false;
            pg_app_win_set = false;
        }
        pgDebugAppWins();
    }, 100)

    pgDebugAppWins();
}

var pgAppWindowsHandleFullscreen = function(win) {
    pinegrow.showAlert(`<p>Full screen mode is not compatible with floating panels. You can maximize the window instead.</p>`, 'Full screen is not supported', 'Exit fullscreen', 'Maximize', function() {
        win.leaveFullscreen();
        win.focus();
    }, function() {
        win.leaveFullscreen();
        win.maximize();
        win.focus();
    })
}

var pgRegisterAppWindow = function(win, wid) {

    //var win_id = win.window.pg_win_id;
    var win_id = win.pg_win_id;

    if(pg_app_windows.indexOf(win) < 0) {
        pg_app_windows.push(win);
        pg_app_internal_windows.push(win.window);

        $(win.window)
            /*
            .on('mousemove', function(e) {
                //console.log(e);
                //is it over this window

                if(pg_active_window === null && win.window === window) {

                    if(typeof pinegrow === 'object') {


                        var dm = pinegrow.getDragMenu();
                        if (dm) {
                            pg_active_window = win;
                            //we're in drag drop and the mouse crossed into another window
                            //what to do?
                            //first, let's focus the window
                            //win.focus();
                            //debugger;
                        }
                    }
                }
            }) */
            .on('dragenter', function(e) {
                pgAutoScrollManager.stopAll();
                //console.log(`DRAG ENTER in ${win_id}`);
            })
            .on('dragover', function(e) {
                //console.log(`DRAG OVER in ${win_id}`);
            })
            .on('drag', function(e) {
                //console.log(`DRAG in ${win_id}`);
            })



        setTimeout(function() {

            win.on('minimize', function(e) {

                if(win.window === window) {
                    //pgAppWindowIgnoreBlurForAWhile();

                    for (var i = 1; i < pg_app_windows.length; i++) {
                        //pg_app_windows[i].setAlwaysOnTop(false);
                        pg_app_windows[i].hide();
                    }
                    pg_app_win_shown = false;
                    pg_app_win_set = false;
                }
            })

            win.on('maximize', function(e) {
                if(win.window === window) {
                    //pg_app_windows[0].setAlwaysOnTop(false);
                    pgAppWindowSetOnTop(pg_app_windows[0], false);
                }
            })

            win.on('enter-fullscreen', function(e) {
                if(pg_app_windows.length > 1) {
                    pgAppWindowsHandleFullscreen(win);
                }
            })

            win.on('restore', function(e) {

                if(win.window === window) {
                    for (var i = 1; i < pg_app_windows.length; i++) {
                        pg_app_windows[i].show();
                    }
                    pg_app_win_shown = true;
                }
            })

            win.on('blur', function(e) {
                //console.log('blur in ' + e.target.pg_win_id)

                pgAppWindowLostFocus(win);
            })

            win.on('focus', function(e) {
                //console.log('focus in ' + e.target.pg_win_id)
                pgAppWindowHasFocus(win);
                //console.log('focus end in ' + e.target.pg_win_id)
            })

            if(win.window !== window) {
                win.on('close', function () {
                    if (win === pg_active_window) {
                        pg_active_window = null;
                    }
                    while(true) {
                        try {
                            var $pop = $(win.window.document.body).find('.lm_popout').first();
                            if ($pop.length) {
                                var $stack = $pop.closest('.lm_stack');
                                var stack = myLayout.root.findItemWithDOMElement($stack.get(0));
                                if (stack) {
                                    stack.popout(null, true /* force dock */);
                                }
                                if ($(win.window.document.body).find('.lm_popout').index($pop) >= 0) {
                                    //still here! force restore back to main window
                                    stack.popout(null, true, true /* force to root */);
                                }
                                if ($(win.window.document.body).find('.lm_popout').index($pop) >= 0) {
                                    pinegrow.showQuickError('Oops... Can\'t undock panel. Please restore workspace.');
                                    break;
                                }
                            } else {
                                break;
                            }
                        } catch(err) {
                            break;
                        }
                    }
                    pgUnregisterAppWindow(win);

                    try {
                        var test_win = win.window;
                        pinegrow.dispatchEvent('on_window_before_close', null, win);
                    } catch(err) {

                    }
                    win.close(true);
                })
            }

            /*
            win.window.document.addEventListener('mouseenter', function(e) {
                pgAppWindowOnMouseEnter(e, wid);
            }, false);


            win.window.document.addEventListener('mouseover', function(e) {
                pgAppWindowOnMouseEnter(e, wid);
            }, false);
            */

            if(!pgIsDev() || true) {
                $(win.window.document.body).on('contextmenu', function (e) {
                    if($(e.target).closest('.navbar-brand, .pg-allow-right-click').length > 0) {
                        return;
                    }
                    pgCloseContextMenus();
                    return false;
                })
            }


            typeof pinegrow !== 'undefined' && pinegrow.dispatchEvent('on_new_window_registered', null, win);
       }, pg_app_windows.length === 1 ? 3000 : 100)
    }
}

var pg_app_win_delayed_tasks = new PgDelayedTasks();

var pgAppWindowOnMouseEnter = function(e, wid) {

    var win = pgGetAppWindowForDOMWindow(e.view) || pg_app_windows[0];
   // console.log(e.type + ' in ' + e.view.pg_win_id, e)
//return
    pg_app_win_under_mouse = win;

    pg_app_win_delayed_tasks.run('focusWin', function() {
        if(pg_is_pg_win_active && win === pg_app_windows[0] && pg_active_window !== win) {
            win.focus();
        }
    }, 200)
}

var pgUnregisterAppWindow = function(win) {
    var idx = pg_app_windows.indexOf(win);
    if(idx >= 0) {
        pg_app_windows.splice(idx, 1);
        pg_app_internal_windows.splice(idx, 1);
    }
    idx = pg_focus_list.indexOf(win);
    if(idx >= 0) {
        pg_focus_list.splice(idx, 1);
    }
    //idx = pg_win_ids.indexOf(win.window.pg_win_id);
    idx = pg_win_ids.indexOf(win.pg_win_id);
    if(idx >= 0) {
        pg_win_ids.splice(idx, 1);
    }
    pgDebugAppWins();
}

var pgGetAppWindowForDOMWindow = function(w) {
    for(var i = 0; i < pg_app_windows.length; i++) {
        if(pg_app_windows[i].window === w) return pg_app_windows[i];
    }
    return null;
}

var pgGetAppWindows = function() {
    return pg_app_windows;
}

var pgGetInternalWindows = function() {
    return pg_app_internal_windows;
}

var pgGetMainAppWindow = function() {
    return pg_app_windows[0];
}

var pgGetFocusedWindow = function() {
    return pg_active_window;
}

var pgCloseEmptyUIWindows = function() {
    var close = [];
    for(var i = 1; i < pg_app_windows.length; i++) {
        if(pgIsAppWindowEmpty(pg_app_windows[i])) {
            close.push(pg_app_windows[i]);
        } else {
            var $body = $(pg_app_windows[i].window.document.body);
            var $lc = $body.find('#layout-container');
            $lc.attr('data-stacks', $lc.find('.lm_stack').length);
        }
    }
    close.forEach(function(win) {
        pgUnregisterAppWindow(win);
        win.close(true);
    })
}

var pgCloseAllUIWindows = function() {
    var close = [];
    for(var i = 1; i < pg_app_windows.length; i++) {
        if($(pg_app_windows[i].window.document.body).find('.pg-quick-win-floating').length === 0) {
            close.push(pg_app_windows[i]);
        }
    }
    close.forEach(function(win) {
        var $body = $(win.window.document.body);
        var $lc = $body.find('#layout-container');
        $lc.detach();
        pgUnregisterAppWindow(win);
        win.close(true);
    })
}

var pgIsAppWindowEmpty = function(win) {
    return $(win.window.document.body).find('.lm_item:not(.lm_floating),.pg-quick-win-floating').length === 0;
}

var pgAppWindowHasVisibleContent = function(win) {
    var list = $(win.window.document.body).find('.lm_item:visible,.pg-quick-win-floating:visible').not('.lm_floating');
    //console.log(list)
    return list.length > 0;
}

var pgGetAppWindowForDOMElement = function(el) {
    return pgGetAppWindowForDOMWindow(el.ownerDocument.defaultView);
}

var pgGetAppWindowUnderMouse = function() {
    return pg_app_win_under_mouse || pg_app_windows[0];
}

var pgGetAppWindowTitle = function($el) {
    var names = [];
    pgUIViewManager.forEachView($el, function(view) {
        if(view.display_name) {
            if(names.length > 2) {
                if(names.length === 3) names.push('...');
            } else {
                names.push(view.display_name);
            }
        }
    })
    var name = (names.length ? (names.join(' | ') + ' - ') : '') + 'Pinegrow';
    return name;
}

var pgUpdateAppWindowTitle = function(win) {
    win.title = pgGetAppWindowTitle($(win.window.document.body));
}

var pgUpdateAppWindowTitles = function() {
    for(var i = 1; i < pg_app_windows.length; i++) {
        pgUpdateAppWindowTitle(pg_app_windows[i]);
    }
}

var pgAppWindowSetZoom = function(win, val) {
    val = parseFloat(val);

    if(val == -2) val = -2.224;

    win.zoomLevel = val;

    if(val < 0) {
        $(win.window.document.body).addClass('zoom');
    } else {
        $(win.window.document.body).removeClass('zoom');
    }
}

var pgAppWindowApplyCodeFontSize = function(only_win) {
    var size = pinegrow.getSetting('code-size', '12px');
    var font = pinegrow.getSetting('code-font', '');
    pgGetAppWindows().forEach(function(win) {
        if(!only_win || only_win === win) {
            pinegrow.codeEditor.setFontSize(size, font, win.window.document);
        }
    })
}

var gui = require('nw.gui');
//gui.Window.get().window.pg_win_id = "MainWindow";
gui.Window.get().pg_win_id = "MainWindow";

pgRegisterAppWindow(gui.Window.get());

var openPanelInExternalWindow$Element = null;
var openPanelInExternalWindowStack = null;


var openPanelInExternalWindow = function($el, done, options, ui_item) {

    var generateWinId = function() {
        var s = 'pgUIWin_';
        var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        var len = 6;
        for(var i = 0; i < len; i++) {
            s += possible.charAt(Math.floor(Math.random() * possible.length));
        }
        return s;
    }

    ui_item = openPanelInExternalWindowStack || ui_item;

    var docsWindow = null;

    var gui = require('nw.gui');

    if(gui.Window.get().isFullscreen) {
        pgAppWindowsHandleFullscreen(gui.Window.get());
    }

    var getName = function() {
        return pgGetAppWindowTitle(openPanelInExternalWindow$Element || $el);
    }

    var wid = null;//(openPanelInExternalWindow$Element || $el).data('pg-ui-win-id');

    var lookForWinId = function(item) {
        if(item.config.pg_win_id) return item.config.pg_win_id;
        if(item.contentItems) {
            for(var i = 0; i < item.contentItems.length; i++) {
                var ret = lookForWinId(item.contentItems[i]);
                if(ret) return ret;
            }
        }
        return null;
    }

    if(ui_item) {
        wid = lookForWinId(ui_item) || null;
        if(wid) {
            console.log('Found win id in config: ' + wid);
        }
    }

    if(wid) {
        if(pg_win_ids.indexOf(wid) >= 0) {
            console.log('another win is using the win id')
            wid = null;
        }
        /*
        for(var i = 1; i < pg_app_windows.length; i++) {
            if(pg_app_windows[i].window.pg_win_id === wid) {
                //another window is using this id already
                console.log('another win is using the win id')
                wid = null;
                break;
            }
        }*/
    }

    if(!wid) {
        wid = generateWinId();
        while(pg_win_ids.indexOf(wid) >= 0) {
            wid = generateWinId();
        }
        if(ui_item) {
            ui_item.config.pg_win_id = wid;
        }
    }

    pg_win_ids.push(wid);

    //console.log('WID ' + wid);

    pg_app_win_ignore_focus_blur = true;

    var opts = $.extend({
        focus: false,
        id: wid,
        always_on_top: true,
        title: 'Pinegrow',
        frame: false,
        min_width: 200,
        min_height: 200
    }, options || {})

    console.log('Open panel in new win ' + wid)

    gui.Window.open('empty.html', opts, function (win) {
        docsWindow = win;

        win.pg_is_shown = true;

        var first_load = true;

        pg_app_win_ignore_focus_blur = false;

        docsWindow.on('loaded', function () {
            if (first_load) {
                var new_window = docsWindow.window;

                docsWindow.window.pgFastdomTasks = new PgFastdomTaskManager(docsWindow.window.fastdom);

                pgUIViewManager.forEachView($el, function(view) {
                    view.onBeforeMovedToAnotherWindow && view.onBeforeMovedToAnotherWindow(new_window, $el);
                })

                pgAppWindowSetZoom(docsWindow, getUIZoom());

               // docsWindow.window.pg_win_id = wid;
                docsWindow.pg_win_id = wid;

                pgRegisterAppWindow(docsWindow);

                pgAppWindowApplyCodeFontSize(docsWindow);

                var $body = $(docsWindow.window.document.body);

                if(is_windows) {
                    $('body').addClass('win');
                } else if(is_mac) {
                    $('body').addClass('osx');
                }
                if(isApp()) {
                    $('body').addClass('app');
                }

                var $header = $('<div class="pg-app-win-header"><div class="pg-app-win-header-drag"><i class="drag icon icon-drag-vert-double-x225"></i></div><i class="icon close icon-close"></i></div>').appendTo($body);

                var $lc = $('<div id="layout-container" class="floating-win"></div>');
                $body.find('#win-content').append($lc);

                $(docsWindow.window).on('resize', function() {
                    $(window).trigger('resize');
                })

                $header.find('.close').on('click', function() {
                    docsWindow.close();
                })

                if($el) $lc.append($el);

                if(done) done(docsWindow.window, $lc, docsWindow);

                first_load = false;

                docsWindow.title = 'Loaded - Pinegrow';

                $(docsWindow.window.document).on('keydown.crsa', function(event) {
                    return $.fn.crsa('processKeydownEvent', event);
                });

                $(docsWindow.window.document).on('keyup.crsa', function(event) {
                    return $.fn.crsa('processKeyupEvent', event);
                });

                $(window).trigger('resize');

                docsWindow.title = getName();

                pinegrow.activateCurrentWorkspaceThemeInWindow(docsWindow);

                saveUIState();


                pgUIViewManager.forEachView($el, function (view) {
                    view.onMovedToAnotherWindow && view.onMovedToAnotherWindow(new_window, $el);
                })

                pinegrow.selectedElements.reselect();

                pinegrow.dispatchEvent('on_panel_moved_in_another_window', docsWindow);
            }
        })

        docsWindow.on('closed', function () {
            pgUnregisterAppWindow(docsWindow);
            docsWindow = null;
        });
    })
}

class PgPanelManager {
    constructor() {
        this.panels = [];
    }

    registerPanel(o) {
        this.panels.push({
            key: o.panel_key || o.componentName,
            name: o.title,
            description: o.panel_description || null,
            category: o.panel_category,
            on_show: o.panel_on_show || null,
            on_hide: o.panel_on_hide || null,
            on_is_visible: o.panel_on_is_visible || null,
            icon: o.panel_icon || null,
            kbd: o.panel_kbd || null
        })
    }

    forEachPanel(func) {
        var pmap = {
            'Essential': 1,
            'Components': 2,
            'WordPress': 3,
            'Interactions': 4,
            'Tailwind CSS': 5,
            'Tools': 6
        }
        this.panels.sort(function(a, b) {
            var ai = pmap[a.category] || 1000;
            var bi = pmap[b.category] || 1000;
            if(ai > bi) {
                return 1;
            } else if(ai < bi) {
                return -1;
            } else {
                return 0;
            }
        })
        this.panels.forEach(func);
    }
}
