var PgThumbnailMaker = function() {

    var _this = this;
    var stageWin = null;
    var line = [];
    var delay = 4000;

    var img_w = 180 * 2;//280; 360
    var img_h = 140 * 2;//220;

    var thumb_host = this.host = 'http://pinegrowthumbnails.com/';

    var width = img_w * 3;
    var height = img_h * 3;

    var scale = img_w / width;

    var setting_key = 'use-recent-thumbnails';
    var setting_default = '1';

    if(is_linux) {
        //setting_key += '-linux';
        setting_default = '0';
    }

    var show_window = !is_mac;

    this.enabled = pinegrow.getSetting(setting_key, setting_default) == "1";

    this.setEnabled = function(v) {
        this.enabled = v;
        pinegrow.setSetting(setting_key, v ? "1" : "0");
        if(v) {
            processLineItem();
        }
    }

    if(isApp()) {
        var path = require('path');
        var folder = path.join(nw.App.dataPath, 'pg_pageimg');

        crsaCreateDirs(folder);

        var gui = require('nw.gui');

        gui.Window.get().on('close', function () {
            if (stageWin) {
                stageWin.close(true);
                stageWin = null;
            }
        })
    }

    var makeFilename = function(url) {
        if(is_windows) url = url.toLowerCase();
        return 'pg_pageimg_' + md5(url) + '.png';
    }

    this.getStoredThumbnailUrl = function(url) {
        if(!isApp()) return null;

        var name = makeFilename(url);
        var file = path.join(folder, name);
        if(crsaIsFileExist(file)) {
            if(!pgf.use_server) return crsaMakeUrlFromFile(file);

            return pinegrow.getProxyUrl(thumb_host + name);
        } else {
            return null;
        }
    }

    this.getStoredThumbnailFilePath = function(thumb_url) {
        if(!pgf.use_server) {
            return crsaMakeFileFromUrl(thumb_url);
        }
        var name = thumb_url.replace(thumb_host, '');
        return path.join(folder, name);
    }

    this.setProjectThumbnail = function(project, file_name) {
        var name = makeFilename(project.getDir());
        var file = path.join(folder, name);
        crsaCopyFileSync(null, file_name, file);
    }


    var findInLine = function(url) {
        for(var i = 0; i < line.length; i++) {
            if(line[i].url == url) return i;
        }
        return -1;
    }

    this.makeThumbnail = function(url, project_url, force) {
        console.log('makeThumbnail - add to list ' + url);
        if(findInLine(url) < 0) {
            line.unshift({url:url, project_url: project_url, force: force});
        }
        if(!busy) {
            processLineItem();
        }
    }

    var busy = false;
    var first_load = true;
    var current_url = null;
    var current_project_url = null;

    var getWindow = function(done) {
        if(stageWin) {
            //if(show_window) stageWin.show();
            done(stageWin);
        } else {

            gui.Window.open('empty.html', {
                focus: false,
                always_on_top: false,
                title: 'Say Cheese! This window is used for taking page screenshots for the start screen. Disable if needed.',
                width: width,
                height: height,
                show: false
            }, function(win) {
                stageWin = win;
                win.on('loaded', function() {
                    console.log('Thumb win loaded')
                    if(first_load && current_url) {
                        first_load = false;

                        setTimeout(onPageLoaded, delay);
                    }
                })
                if(show_window) {
                    //win.moveTo(-width * 2, -height * 2);
                    //win.show();
                }
                done(stageWin);

                stageWin.on('closed', function () {
                    stageWin = null;
                });
            })
        }
    }

    var onPageLoaded = function() {
        //lets take a picture

        //console.log('thumb onPageLoaded')

        try {
            $(stageWin.window.document.body).css('overflow', 'hidden');
        } catch(err) {}

        setTimeout(function() {
            try {
                var p = new CrsaProfile(true, 'makeThumbnail [' + current_url + '] - ');

                //console.log('thumb taking picture...')

                var mw = pgGetMainAppWindow();
                stageWin.x = mw.x;
                stageWin.y = mw.y;
                stageWin.width = Math.min(width, mw.width);
                stageWin.height = Math.min(height, mw.height);

                var oa = mw.isAlwaysOnTop;
                mw.setAlwaysOnTop(true);
                stageWin.show();
                mw.setAlwaysOnTop(oa);



                stageWin.capturePage(function (datauri) {
                    p.show('capturePage');
                    //console.log('thumb got picture.')
                    //  try {
                    //var retina = stageWin.window.devicePixelRatio;
                    var canvas = document.createElement('canvas');

                    var t_w = Math.round(width);
                    var t_h = Math.round(height);

                    canvas.setAttribute('width', t_w);
                    canvas.setAttribute('height', t_h);
                    var ctx = canvas.getContext('2d');
                    var img = new window.Image();

                    img.addEventListener("load", function () {

                        try {
                            p.show('imageLoaded');

                            var retina = Math.round(img.width / (width * 1.0));

                            console.log('makeThumbnail Info: img_w: ' + img.width + ', win_w: ' + width + ', retina: ' + retina);

                            var newImg = img;
                            //ctx.drawImage(newImg, 0, 0, width * retina, height * retina, 0, 0, width, height);

                            //try this, should scale if larger
                            ctx.drawImage(newImg, 0, 0, t_w, t_h);

                            var smallCanvas = (scale < 1.0) ? downScaleCanvas(canvas, scale) : canvas;

                            var filename = makeFilename(current_url);
                            var filePath = path.join(folder, filename);

                            p.show('imageScale');

                            var onSaved = function() {
                                p.show('imageSaved');
                                pinegrow.dispatchEvent('on_thumbnail_generated', null, current_url);
                                busy = false;
                                processLineItem();
                            }

                            var image = smallCanvas.toDataURL('image/png');
                            image = image.replace('data:image/png;base64,', '');
                            var buffer = new Buffer(image, 'base64');
                            require('fs').writeFile(filePath, buffer, function(error) {
                                if(!error && current_project_url) {

                                    var prjfilename = makeFilename(current_project_url);
                                    var prjfilePath = path.join(folder, prjfilename);
                                    require('fs').writeFile(prjfilePath, buffer, function(error) {
                                        onSaved();
                                    });

                                } else {
                                    if(error) {
                                        console.log('Error saving thumbnail to ' + filePath, error);
                                        busy = false;
                                        processLineItem();
                                    } else {
                                        onSaved();
                                    }
                                }
                            });

                        } catch (err) {
                            console.log('Thumbnail error: ' + err);
                            busy = false;
                            processLineItem();
                        }

                    }, false);

                    img.src = datauri;

                }, {format: 'png', datatype: 'datauri'});
            } catch(err) {
                console.log('Thumbnail error: ' + err);
                busy = false;
                setTimeout(processLineItem, 1000);
            }
        },100);
    }

    var processLineItem = function() {
        if(stageWin) stageWin.hide();

        if(line.length == 0 || busy || !_this.enabled) {
            //nothing to do
            if(current_url && stageWin) {
                current_url = null;

                stageWin.window.location.href = pinegrow.httpServer.url + '/pginternal/thumbfactory';
            }
        } else {
            busy = true;

            var item = line.pop();

            //console.log('makeThumbnail - popped line item - ' + item.url);

            getWindow(function(win) {
                first_load = true;
                current_url = item.url;
                current_project_url = item.project_url;

                var url = current_url;

                var page = pinegrow.getCrsaPageByUrl(current_url);

                if(crsaIsRemoteUrl(current_url) && !page && !item.force) {
                    //remote page is no longer open in pg
                    //don't take the photo if we already have one
                    if(_this.getStoredThumbnailUrl(current_url)) {
                        busy = false;
                        setTimeout(processLineItem, 10);
                        return;
                    }
                }

                if(page || crsaIsFileUrl(current_url)) {
                    url = pinegrow.getProxyUrl(current_url);
                    delay = 2000;
                } else {
                    //remote url
                    delay = 4000;
                }

                win.window.location.href = url;
                console.log('makeThumbnail - loading ' + current_url);
            })
        }
    }

    var last_photo = {};

    pinegrow.addEventHandler('on_project_loaded', function(page) {
        last_photo = {}
    })

    pinegrow.addEventHandler('on_page_saved', function(page) {
        if(busy) return;

        var project_url = null;
        var project = pinegrow.getCurrentProject();
        if(project && project.isPageInProject(page)) {
            project_url = project.getDir(); //use folder for projects
        }
        //do a bit of delay to correctly handle the situation where the page is closed immediatelly after save
        if(pinegrow.getSelectedPage() === page) {
            //only do selected pages
            var last = last_photo[page.url] || 0;
            var time = (new Date().getTime());
            if(time - last > 5 * 60 * 1000) {
                last_photo[page.url] = time;

                if(page.activeView) {
                    //still open
                    var current_url = project_url || page.url;
                    var filename = makeFilename(current_url);
                    var filePath = path.join(folder, filename);

                    busy = true;

                    pinegrow.takePhotoOfPage(page, filePath, function() {
                        busy = false;
                        pinegrow.dispatchEvent('on_thumbnail_generated', null, current_url);
                    }, img_w)
                }

                /*
                setTimeout(function () {


                    _this.makeThumbnail(page.url, project_url);
                }, 100)
                */
            }
        }
    })

    if(false) {

        pinegrow.addEventHandler('on_page_loaded', function (page) {
            var project_url = null;
            var project = pinegrow.getCurrentProject();
            if (project && project.isPageInProject(page)) {
                project_url = project.getDir(); //use folder for projects
            }

            if (/*crsaIsRemoteUrl(page.url) && */!_this.getStoredThumbnailUrl(project_url || page.url)) {

                //take picture of loaded [remote] pages if they don't have a picture yet
                setTimeout(function () {
                    _this.makeThumbnail(page.url, project_url);
                }, 100)
            }
        })
    }

}