class PgTranslator {
    constructor() {
        this.map = {}
    }

    setString(key, val) {
        this.map[key] = val;
    }

    getString(key, def, data) {
        if(key in this.map) {
            var str = this.map[key];
            if(data) {
                str = str.replace(/%([^%]+)%/g, function(m, a) {
                    return data[a] || a;
                })
            }
            return str;
        } else {
            console.warn('TRANSLATOR: Missing key: ' + key);
            return def || 'Missing key: ' + key;
        }
    }

    addString(key, val) {
        this.map[key] = (this.map[key] || '') + val;
    }
}

window.pgTranslator = new PgTranslator();

window.__set = window.pgTranslator.setString.bind(pgTranslator);
window.__get = window.pgTranslator.getString.bind(pgTranslator);
window.__add = window.pgTranslator.addString.bind(pgTranslator);
