var PgControlMarginPadding = function(options) {

    var options = options || {};
    var setCssValueForShorthandable = options.setCssValueForShorthandable || function() {};
    var getCssValueForShorthandable = options.getCssValueForShorthandable || function() {};

    var highlightOnChanged = function() {};
    var getValuesFromObj = function() { return {} };

    var marginPaddingBtnActive = {
        margin: false,
        padding: false
    }

    var addCssShorthandableDef = function(name, placeholder, f, sf, control, base_on_equal) {
        return {
            'type' : 'slider',
            'name' : name,
            'placeholder': placeholder,
            'action' : 'custom',
            'without_text': true,
            'without_icon': true,
            'show_empty' : true,
            get_value: function(obj) {
                var value = getCssValueForShorthandable(obj, control.values, f, sf, base_on_equal);
                return value;
            },
            set_value: function(obj, value, values, oldValue, eventType) {
                var newValue = setCssValueForShorthandable(obj, f, sf, value, !marginPaddingBtnActive[f], base_on_equal);
                return newValue;
            },
            on_changed: highlightOnChanged
        }
    }

    return function () {

        var c = new PgCustomPropertyControl('css-margin-padding');
        var $container = null;

        var mBorder = {
            'margin-left': 10,
            'margin-right': 10,
            'margin-top': 20,
            'margin-bottom': 20,

            'padding-left': 13,
            'padding-right': -13,
            'padding-top': 30,
            'padding-bottom': 30
        }

        var mBorderLastValue = {
            'height': 80,
            'margin-left': 13,
            'margin-right': 13,
            'margin-top': 0,
            'margin-bottom': 0
        }

        var mIconLastValue = {
            'top': 23,
            'left': 50,
            'right': 50,
        }

        var fieldInputs = {
            'margin-top': null,
            'margin-bottom': null,
            'margin-right': null,
            'margin-left': null,

            'padding-top': null,
            'padding-bottom': null,
            'padding-right': null,
            'padding-left': null
        }

        var toggleIconActivation = function (e, type, control) {
            var $target = $(e.currentTarget);
            $target.toggleClass('active');
            marginPaddingBtnActive[type] = $target.hasClass('active');

            if (marginPaddingBtnActive[type]) {
                var obj = control.obj;
                var values = getValuesFromObj(obj);

                var directions = ['top', 'left', 'right', 'bottom'];
                for (var i = 0; i < directions.length; i++) {
                    var prop = type + '-' + directions[i];

                    if (values[prop]) {
                        var value = values[prop].value || values[prop];

                        updateMarginPaddingValue(obj, type, '', value);
                        break;
                    }
                }
            }
        }

        var updatePaddingAndMarginView = function ($field, type, direction, valueStr) {
            var oldValueStr = $container.data('old-' + type + '-' + direction + '-value');

            var value = parseInt(valueStr, 10);
            var oldValue = parseInt(oldValueStr, 10);

            if (valueStr == oldValueStr || value == oldValue) return;

            var $border = null,
                firstParam,
                secondParam,
                $icon = null,
                unit = 'px';
            var iconCurrValue = null;
            var iconDirection = direction;

            if (direction == "left" || direction == "right") unit = '%';

            if (type == "margin") {
                $border = $field.siblings('.margin-border');
                firstParam = 'padding-' + direction;
                secondParam = 'margin-' + direction;
            }
            else if (type == "padding") {
                $border = $field.siblings('.padding-border');
                firstParam = 'margin-' + direction;
                if (direction == 'top' || direction == 'bottom') {
                    secondParam = 'height';
                }
                else if (direction == 'left' || direction == 'right') {
                    secondParam = '';
                }
                if (direction == 'top' || direction == 'right' || direction == 'left') {
                    $icon = $border.find('.change-all-icon');
                    if (direction == "top") {
                        // iconCurrValue = parseInt($icon.css(direction), 10);
                        iconCurrValue = mIconLastValue[direction];
                    }
                    else if (direction == "left") {
                        iconCurrValue = mIconLastValue[direction];
                    }
                    else if (direction == "right") {
                        iconDirection = "left";
                        iconCurrValue = mIconLastValue[iconDirection];
                    }
                }
            }

            var currValue = mBorderLastValue[secondParam];
            if (currValue == undefined && secondParam) currValue = parseInt($border.css(secondParam), 10);

            var newValue = mBorder[type + '-' + direction];

            if (value != oldValue) {
                if (value == 0) {
                    $border.css(firstParam, 0);
                    if (secondParam) {
                        $border.css(secondParam, (currValue + newValue) + unit);
                        mBorderLastValue[secondParam] = currValue + newValue;
                    }
                    if ($icon) {
                        $icon.css(iconDirection, (iconCurrValue + newValue) + unit);
                        mIconLastValue[iconDirection] = iconCurrValue + newValue;
                    }
                }
                else if (parseInt($border.css(firstParam), 10) == 0) {
                    $border.css(firstParam, '');
                    if (secondParam) {
                        $border.css(secondParam, (currValue - newValue) + unit);
                        mBorderLastValue[secondParam] = currValue - newValue;
                    }
                    if ($icon) {
                        $icon.css(iconDirection, (iconCurrValue - newValue) + unit);
                        mIconLastValue[iconDirection] = iconCurrValue - newValue;
                    }
                }
            }
        }

        var updateMarginPaddingValue = function (obj, type, skipDirection, value) {
            if (marginPaddingBtnActive[type]) {
                var directionArr = ['top', 'bottom', 'right', 'left'];

                for (var i = 0; i < directionArr.length; i++) {
                    if (directionArr[i] != skipDirection) {
                        var field = type + '-' + directionArr[i];
                        fieldInputs[field].setValue(value);
                        setCssValueForShorthandable(obj, type, directionArr[i], value, !marginPaddingBtnActive[type]);
                        updatePaddingAndMarginView(marginPaddingObjs[field].$el, type, directionArr[i], value);
                        $container.data('old-' + field + '-value', value);
                    }
                }
            }
            highlightOnChanged(obj, null, null, null, {highlight: true})
        }

        var fieldChanged = function(obj, prop, value, oldValue, fdef, $field) {
            if(options.on_subfield_changed) {
                options.on_subfield_changed(obj, prop, value, oldValue, fdef, $field);
            }
        }

        marginPaddingObjs = {
            'margin-top': {
                fdef: $.extend({}, addCssShorthandableDef("Margin top", "Top", "margin", "top", this), {
                    on_changed: function (obj, prop, value, oldValue, fdef, $field) {
                        updatePaddingAndMarginView($field, 'margin', 'top', value, oldValue);
                        updateMarginPaddingValue(obj, 'margin', 'top', value, oldValue);
                        $container.data('old-' + prop + '-value', value);
                        fieldChanged(obj, prop, value, oldValue, fdef, $field);
                    }
                }),
                $el: null
            },
            'margin-left': {
                fdef: $.extend({}, addCssShorthandableDef("Margin left", "Left", "margin", "left", this), {
                    on_changed: function (obj, prop, value, oldValue, fdef, $field) {
                        updatePaddingAndMarginView($field, 'margin', 'left', value, oldValue);
                        updateMarginPaddingValue(obj, 'margin', 'left', value, oldValue);
                        $container.data('old-' + prop + '-value', value);
                        fieldChanged(obj, prop, value, oldValue, fdef, $field);
                    }
                }),
                $el: null
            },
            'padding-top': {
                fdef: $.extend({}, addCssShorthandableDef("Padding top", "Top", "padding", "top", this), {
                    on_changed: function (obj, prop, value, oldValue, fdef, $field) {
                        updatePaddingAndMarginView($field, 'padding', 'top', value, oldValue);
                        updateMarginPaddingValue(obj, 'padding', 'top', value, oldValue);
                        $container.data('old-' + prop + '-value', value);
                        fieldChanged(obj, prop, value, oldValue, fdef, $field);
                    }
                }),
                $el: null
            },
            'padding-left': {
                fdef: $.extend({}, addCssShorthandableDef("Padding left", "Left", "padding", "left", this), {
                    on_changed: function (obj, prop, value, oldValue, fdef, $field) {
                        updatePaddingAndMarginView($field, 'padding', 'left', value, oldValue);
                        updateMarginPaddingValue(obj, 'padding', 'left', value, oldValue);
                        $container.data('old-' + prop + '-value', value);
                        fieldChanged(obj, prop, value, oldValue, fdef, $field);
                    }
                }),
                $el: null
            },
            'padding-right': {
                fdef: $.extend({}, addCssShorthandableDef("Padding right", "Right", "padding", "right", this), {
                    on_changed: function (obj, prop, value, oldValue, fdef, $field) {
                        updatePaddingAndMarginView($field, 'padding', 'right', value, oldValue);
                        updateMarginPaddingValue(obj, 'padding', 'right', value, oldValue);
                        $container.data('old-' + prop + '-value', value);
                        fieldChanged(obj, prop, value, oldValue, fdef, $field);
                    }
                }),
                $el: null
            },
            'padding-bottom': {
                fdef: $.extend({}, addCssShorthandableDef("Padding bottom", "Bottom", "padding", "bottom", this), {
                    on_changed: function (obj, prop, value, oldValue, fdef, $field) {
                        updatePaddingAndMarginView($field, 'padding', 'bottom', value, oldValue);
                        updateMarginPaddingValue(obj, 'padding', 'bottom', value, oldValue);
                        $container.data('old-' + prop + '-value', value);
                        fieldChanged(obj, prop, value, oldValue, fdef, $field);
                    }
                }),
                $el: null
            },
            'margin-right': {
                fdef: $.extend({}, addCssShorthandableDef("Margin right", "Right", "margin", "right", this), {
                    on_changed: function (obj, prop, value, oldValue, fdef, $field) {
                        updatePaddingAndMarginView($field, 'margin', 'right', value, oldValue);
                        updateMarginPaddingValue(obj, 'margin', 'right', value, oldValue);
                        $container.data('old-' + prop + '-value', value);
                        fieldChanged(obj, prop, value, oldValue, fdef, $field);
                    }
                }),
                $el: null
            },
            'margin-bottom': {
                fdef: $.extend({}, addCssShorthandableDef("Margin bottom", "Bottom", "margin", "bottom", this), {
                    on_changed: function (obj, prop, value, oldValue, fdef, $field) {
                        updatePaddingAndMarginView($field, 'margin', 'bottom', value, oldValue);
                        updateMarginPaddingValue(obj, 'margin', 'bottom', value, oldValue);
                        $container.data('old-' + prop + '-value', value);
                        fieldChanged(obj, prop, value, oldValue, fdef, $field);
                    }
                }),
                $el: null
            }
        }

        for (var mp in marginPaddingObjs) {
            marginPaddingObjs[mp].fdef.subkey = mp;
        }

        var setValueFromControl = function (obj, values) {
            var propType = ['margin', 'padding'];
            var directions = ['top', 'bottom', 'left', 'right'];

            for (var i = 0; i < propType.length; i++) {
                for (var j = 0; j < directions.length; j++) {
                    var value = getCssValueForShorthandable(obj, values, propType[i], directions[j]);
                    marginPaddingObjs[propType[i] + '-' + directions[j]].value = value;
                    values[propType[i] + '-' + directions[j]] = value;
                }
            }
        }

        c.onDefine = function () {
            for (var mp in marginPaddingObjs) {
                marginPaddingObjs[mp].fdef.subkey = mp;
            }
        }

        c.onShow = function () {
            var _this = this;
            $container = $('<div class="margin-and-padding-container text-center"></div>');

            var values = getValuesFromObj(this.obj);
            setValueFromControl(this.obj, values);

            // Margin top
            var marginTop = this.showInputField($container, 'margin-top', marginPaddingObjs['margin-top'].fdef);
            marginPaddingObjs['margin-top'].$el = marginTop.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
            fieldInputs['margin-top'] = marginTop;

            // Margin left
            var marginLeft = this.showInputField($container, 'margin-left', marginPaddingObjs['margin-left'].fdef);
            marginPaddingObjs['margin-left'].$el = marginLeft.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
            fieldInputs['margin-left'] = marginLeft;

            var $marginBorder = $('<div class="margin-border"></div>').appendTo($container);

            var $marginIcon = $('<div class="change-all-margin-icon change-all-icon">\
                                                            <i class="icon-same"></i>\
                                                        </div>').appendTo($marginBorder);

            marginPaddingObjs['margin-$icon'] = $marginIcon;
            $marginIcon.on('click', function (e) {
                toggleIconActivation(e, 'margin', _this);
            });

            var $paddingContainer = $('<div class="padding-container"></div>').appendTo($marginBorder);

            // Padding top
            var paddingTop = this.showInputField($paddingContainer, 'padding-top', marginPaddingObjs['padding-top'].fdef);
            marginPaddingObjs['padding-top'].$el = paddingTop.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
            fieldInputs['padding-top'] = paddingTop;

            // Padding left
            var paddingLeft = this.showInputField($paddingContainer, 'padding-left', marginPaddingObjs['padding-left'].fdef);
            marginPaddingObjs['padding-left'].$el = paddingLeft.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
            fieldInputs['padding-left'] = paddingLeft;

            var $paddingIcon = $('<div class="padding-border">\
                                        <div class="change-all-padding-icon change-all-icon"><i class="icon-same"></i></div>\
                                    </div>').appendTo($paddingContainer).find('> .change-all-icon');

            marginPaddingObjs['padding-$icon'] = $paddingIcon;
            $paddingIcon.on('click', function (e) {
                toggleIconActivation(e, 'padding', _this);
            });

            // Padding right
            var paddingRight = this.showInputField($paddingContainer, 'padding-right', marginPaddingObjs['padding-right'].fdef);
            marginPaddingObjs['padding-right'].$el = paddingRight.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
            fieldInputs['padding-right'] = paddingRight;

            // Padding bottom
            var paddingBottom = this.showInputField($paddingContainer, 'padding-bottom', marginPaddingObjs['padding-bottom'].fdef);
            marginPaddingObjs['padding-bottom'].$el = paddingBottom.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
            fieldInputs['padding-bottom'] = paddingBottom;

            // Margin right
            var marginRight = this.showInputField($container, 'margin-right', marginPaddingObjs['margin-right'].fdef);
            marginPaddingObjs['margin-right'].$el = marginRight.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
            fieldInputs['margin-right'] = marginRight;

            // Margin bottom
            var marginBottom = this.showInputField($container, 'margin-bottom', marginPaddingObjs['margin-bottom'].fdef);
            marginPaddingObjs['margin-bottom'].$el = marginBottom.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
            fieldInputs['margin-bottom'] = marginBottom;

            return $container;
        }

        c.onSetValues = function () {
            var values = getValuesFromObj(this.obj);
            setValueFromControl(this.obj, values);

            for (var mp in marginPaddingObjs) {
                var value = null;
                if (values[mp]) {
                    value = values[mp].value || values[mp];
                }

                var arr = mp.split('-');
                var $el = marginPaddingObjs[mp].$el;
                if ($el) {
                    fieldInputs[mp].setValue(value);
                    updatePaddingAndMarginView($el, arr[0], arr[1], value, null);
                }
                if ($container) $container.data('old-' + mp + '-value', value);
            }

            var types = ['margin', 'padding'];

            for (var i = 0; i < types.length; i++) {
                var type = types[i];
                var top = marginPaddingObjs[type + '-top'].value;
                var left = marginPaddingObjs[type + '-left'].value;
                var right = marginPaddingObjs[type + '-right'].value;
                var bottom = marginPaddingObjs[type + '-bottom'].value;

                if (top && top == left && left == right && right == bottom) {
                    marginPaddingObjs[type + '-$icon'].addClass('active');
                    marginPaddingBtnActive[type] = true;
                }
                else {
                    marginPaddingObjs[type + '-$icon'].removeClass('active');
                    marginPaddingBtnActive[type] = false;
                }
            }
        }

        return c;
    }
}