



var PgInfoPanelView = function() {

    pinegrow.infoPanel = this;

    var $element = $('<div class="pg-info-viewer"><!--<div class="pg-info-viewer-toolbar"></div>--><div class="pg-info-viewer-content"></div></div>');


    /*
    var toolbar = new PgButtonToolbar();
    toolbar.addSection('index');

    var indexButton = new PgButtonToolbarItem('<span>Content</span>', 'Go back to "Power-up with Pinegrow" index.');
    toolbar.addItem('index', indexButton);
    indexButton.onClick = function () {
        pinegrow.showDocsTopic('docs.index')
    }

    $element.find('.pg-info-viewer-toolbar').append(toolbar.$element)
*/

    var $content = $element.find('.pg-info-viewer-content');

    var view = new PgUIView($element, 'info');
    this.view = view;

    if(!pgf.kids) {
        view.tabIcon = 'icon-274';
    }
    var _this = this;

    var current_topic_id = null;

    this.setContent = function(template, data, keep_scroll_position) {
        var info_editor = pinegrow.findFrameworkByKey('pg.info.editor');

        var html = `<h1>__title__</h1><div>__content__</div>`;
        $.each(data, function(key, val) {
            html = html.replace(`__${key}__`, val);
        })

        html = html.replace(/([A-Za-z\+0-9]+)\_KEY([^\w])/g, function(a, b, c) {
            return pgShowKbdCombo(b) + c;
        })

        html = pinegrow.tutorialsManager.addInteractiveElementsToHTML(html);

        $content.html(html);

        $content.find('[data-pginfo-tooltip]').each(function(i, el) {
            var $el = $(el);
            var key = $el.attr('data-pginfo-tooltip');
            var info = pgInfoPanelgetTooltipInfo(key);
            if(info) {
                $el.addClass('has-tooltip');
                $el.attr('title', info.text);
                $el.attr('data-tooltip-key', key);
                $el.attr('data-html', 'true');
                $el.attr('data-tooltip-action', '');
                if(info.icon) {
                    $el.prepend($(`<i class="icon ${info.icon}" style="margin-right:4px;"></i>`));
                }
            }
        })

        if(info_editor) {
            $content.find('[data-pginfo-selectui]').each(function (i, el) {
                var $el = $(el);
                var sel = info_editor.ieGetSelectorForShowField($el);
                if (sel) {
                    $el.addClass('has-tooltip');
                    $el.attr('title', 'Click to reveal on screen.');
                    $el.attr('data-tooltip-key', '');
                    $el.attr('data-tooltip-action', 'field');
                    $el.attr('data-tooltip-action-param', sel);
                }
            })
        }

        addTooltip($content.find('[title]'), 'title', {

        });

        addTooltip($content.find('[data-pginfo-select]:not([data-pginfo-animation])'), 'Click to select the element on the page.');
        addTooltip($content.find('[data-pginfo-animation]'), 'Click to open the interaction.');

        var $imgs = $content.find('img').not('.no-retina');

        var resizeImg = function(img) {
            if ($(img).closest('.gif_wrap,.full').length == 0) {
                img.style.width = (img.naturalWidth / 2) + 'px';
            }
        }

        $imgs.on('load', function() {
            resizeImg(this);
        })

        $imgs.each(function(i, img) {
            if (img.naturalWidth) {
                resizeImg(img);
            }
        });

        if(!keep_scroll_position) {
            $content.scrollTop(0);
        }

        crsaHandleExternalLinks($content);
    }

    this.get$Content = function() {
        return $content;
    }

    $element.on('click', 'ol li', function(e) {
        var $e = $(this);
        $e.closest('ol').find('> li.highlighted').removeClass('highlighted');
        $e.addClass('highlighted');
    })

    $element.on('click', '[data-tooltip-key]', function(e) {
        pinegrow.dispatchEvent('on_info_panel_tooltip_clicked', null, this, e);
    })

    var withVisiblePanel = function(panel, func) {
        var view = pgUIViewManager.getView(panel);

        pinegrow.showUIPanel(panel, false, false, false);
        setTimeout(function() {
            func(view);
        }, 50)
    }

    $element.on('click', '[data-pginfo-animation]', function(e) {
        e.preventDefault();

        var $el = $(this);
        var key = $el.attr('data-pginfo-animation');
        if(key) {

            //allow element to be selected and view updated with other actions first
            setTimeout(function() {
                var panel = 'animations';
                withVisiblePanel(panel, function(view) {
                    var $vel = view.get$Element().find('.pg-actions-assigned');
                    var $action = $vel.find(`[data-action="${key}"]`);
                    var idx = $el.attr('data-pginfo-animation-index');
                    if(idx) {
                        $action = $action.find(`[data-repeat-item="${idx}"]`);
                    }
                    if($action.length) {
                        pgScrollToItemInContainer($action, $action.closest('.pg-grid'), false, true, function () {
                            var edit = $el.attr('data-pginfo-animation-edit');
                            if(idx) {
                                switch(edit) {
                                    case 'edit':
                                        $action = $action.find('.pg-button.edit');
                                        break;
                                    case 'play':
                                        $action = $action.find('.pg-button.play');
                                        break;
                                    case 'options':
                                        $action = $action.find('.pg-action-section > h6');
                                        break;
                                    case 'enable_on':
                                        $action = $action.find(`.crsa-field-data-pg-md-${idx}`);
                                        break;
                                    case 'trigger':
                                        $action = $action.find(`.crsa-field-data-pg-tr-${idx}`);
                                        break;
                                }

                                //let the user click on the button
                                /*
                                setTimeout(function() {
                                    var pgia = pinegrow.findFrameworkByKey('pg.ia');
                                    if(pgia) {
                                        pgia.pgiaEditAnimation(pinegrow.selectedElements.getLastSelected(), key === 'animation-action', parseInt(idx) - 1);
                                    }
                                }, 100)

                                 */
                            }
                            pgRevealElement($action);
                        }, -50)
                    } else {
                        pinegrow.showQuickError('The action is not defined on the selected element');
                    }
                })
            }, 100)
        }
    })

    $element.on('click', '[data-pginfo-animation-timeline]', function(e) {
        e.preventDefault();

        var $el = $(this);
        var pgia = pinegrow.findFrameworkByKey('pg.ia');
        var key = $el.attr('data-pginfo-animation-timeline');
        if(key) {
            var param = $el.attr('data-pginfo-animation-timeline-param');
            var extra = $el.attr('data-pginfo-animation-timeline-extra');
            if(!pgia.isTimelineEditorShown()) {
                pinegrow.showQuickError('The Timeline editor is not open. Click on Edit animation to open it.')
            } else {
                var sel;
                var not_found_msg;
                switch(key) {
                    case 'track':
                        sel = `.pg-ae-tv-el-actors-list .pg-ae-tv-el-actor:nth-child(${param})`;
                        not_found_msg = 'The track is not displayed.'
                        break;
                    case 'transform':
                        sel = `.pg-ae-tv-el-timelines .pg-ae-el-tl:nth-child(${param}) .pg-ae-timeline-visual-kf:eq(${parseInt(extra) - 1})`;
                        not_found_msg = 'The transform is not displayed.'
                        break;
                    case 'edit_transform':
                        sel = `.pg-ae-t-view`;
                        not_found_msg = 'The Edit transform dialog is not displayed';
                        break;
                    case 'edit_transform_add':
                        sel = `.pg-ae-t-view .props > .pg-button`;
                        not_found_msg = 'The Edit transform dialog is not displayed';
                        break;
                }
                var $el = $(sel);
                if($el.length === 0) {
                    pinegrow.showQuickError(not_found_msg);
                } else {
                    pgRevealElement($el);
                }
            }
        }
    })

    $element.on('click', '[data-select],[data-pginfo-select]', function(e) {
        e.preventDefault();
        var sel = this.getAttribute('data-pginfo-select') || this.getAttribute('href');
        var page = this.getAttribute('data-pginfo-select-page') || this.getAttribute('data-page');
        var skip_reveal = this.getAttribute('data-pginfo-select-no-reveal') === 'true';

        var select = function() {
            !pinegrow.getShowDisplayHelpers() && pinegrow.setShowDisplayHelpers(true, false);

            var pgel;
            var p = pinegrow.getSelectedPage();
            var $pgel = p.activeView.get$Html().find(sel);
            if($pgel.length) {
                pgel = getElementPgNode($pgel, true)
            }
            if(!pgel) {
                pgel = p.sourceNode.findOne(sel);
            }
            if(pgel) {
                pgel.scrollTo();
                pinegrow.selectElement(pgel);
                if(!skip_reveal) {
                    setTimeout(function () {
                        pgRevealElement(p.$page.find('.pg-hl-select.crsa-hl-size-sel:visible'))
                    }, 50)
                }
            } else {
                pinegrow.showQuickError(`Can't find this element on the page.`);
            }
        }
        if(page) {
            pinegrow.openOrShowPage(pinegrow.getCurrentProject().getAbsoluteUrl(page), function() {
                select();
            }, true)
        } else {
            select();
        }
    })

    var dragMenu = null;
    var dragged_pic = null;

    var dragHelper = new PgDragHelper($content, '.pg-info-panel-lib-button-code,.pg-info-panel-draggable', null, true);

    dragHelper.on( 'dragStart', function(x, y, event) {
        $.fn.crsapages('showOverlays');

        var $button = dragHelper.dragTarget;
        var code = pgDecodeAttribute($button.attr('data-code'));

        var pgel = pgCreate(code);

        var def = null;
        var page = pinegrow.getSelectedPage();
        if(page) {
            def = page.getMainType(null, pgel);
        }

        dragMenu = new PgDragMenu(def, false, true);
        dragMenu.pgel = pgel;
        dragMenu.selectNew = true;

        dragMenu.handleMoveEvent(event, dragMenu);

        $element.trigger('pg-drag-start');
    }, this );

    dragHelper.on( 'drag', function(x, y, event) {

        dragMenu.handleMoveEvent(event, dragMenu);
    }, this );

    dragHelper.on( 'dragStop', function(x, y) {
        $.fn.crsapages('showOverlays', true);

        var inserted = dragMenu.insert();

        //check placement
        var target_sel = dragHelper.dragTarget.attr('data-target-selector');
        var place_error = dragHelper.dragTarget.attr('data-place-error');

        if(target_sel && inserted && dragMenu.inserted_elements.getLength()) {
            dragMenu.inserted_elements.forEachElement(function(pgel) {
                if(!pgel.is(target_sel)) {
                    place_error = place_error || 'The element was dropped in the wrong location.';
                    pinegrow.showAlert(`<p>${place_error}</p><p>To fix the issue rearrange elements in the <b>Structure panel</b> or use <b>Undo</b> and drag the element again.</p>`, 'Oops... The element is not in the right place!', null, 'Got it!');
                }
            })
        }

        dragMenu.destroy();
        dragMenu = null;

        crsaFuncs.showInsertionLine(null);
        pinegrow.highlightElement(null);

        $element.trigger('pg-drag-stop');

    }, this );


    view.onResize = function() {
    }

    view.onDestroy = function() {
    }
}