$(function() {

    $('body').one('pinegrow-ready', function(e, pinegrow) {
        var f = new PgFramework('bs3.4.1', 'Bootstrap 3');
        f.type = "bootstrap";
        f.allow_single_type = true;

        f.description = '<a href="http://getbootstrap.com/">Bootstrap</a> starting pages and components. Templates are based on Bootstrap 3.4.1.';
        f.author = 'Pinegrow';
        f.author_link = 'http://pinegrow.com';

        f.ignore_css_files = [/(^|\/)bootstrap\.(css|less)/i, /(^|\/)bootstrap\.min\.(css|less)/i, /(^|\/)font(\-|)awesome(\.min|)\.(css|less)/i];
        f.detect_async = function(crsaPage, done) {
            crsaPage.stylesheetsThatContain(/bootstrap\sv3/i, /(^|\/)bootstrap(\.min|)\.(css|less)/i, function(list) {
                done(list.length > 0)
            });
        }

        var prefix = 'bs3.';

        f.setScriptFileByScriptTagId('plugin-bootstrap-3-4-1'); //get url if script is included directly into edit.html

        pinegrow.addFramework(f, 3);

        var num_columns = parseInt(pinegrow.getSetting('bootstrap-col-num', '12')) || 12;

        var sizes = ["xs", "sm", "md", "lg"];
        var sizes_names = ["Extra Small", "Small", "Medium", "Large"];
        var sizes_breakpoints = [0, 768, 992, 1200];
        var sizes_view_sizes = [480, 768, 1024, 1280];
        var sizes_icons = ['icon-Xs', 'icon-IPAD', 'icon-tableta-lezeca', 'icon-ikone100--copy_laptop'];

        var size_for_all = '';

        var sizes_breakpoints_map = {};
        for(var i = 0; i < sizes.length; i++) {
            sizes_breakpoints_map[sizes[i]] = sizes_breakpoints[i];
        }

        var isColumn = function(pgel) {
            if(pgel.tagName == 'div') {
                if(pgel.parent && pgel.parent.isSelector('.row,.form-group') && !pgel.hasClass('row')) return true;
            }
            // if(pgel.tagName == 'label') return false; // why?
            var cls = pgel.getAttr('class');
            if(cls) {
                if(cls.match(/(\s|^)col\-/i)) return true;
            }
            return false;
        }

        var bs_options = {
            num_columns: num_columns,
            sizes: sizes,
            sizes_breakpoints: sizes_breakpoints,
            sizes_breakpoints_map: sizes_breakpoints_map,
            sizes_view_sizes: sizes_view_sizes,
            sizes_icons: sizes_icons,
            size_for_all: size_for_all,
            sizes_names: sizes_names,
            prefix: prefix,
            col_prefix_class: 'col',
            isColumn: isColumn,
            onClickOnColumnPoint: function() {
                var q = PgQuickProperties([col_def.sections['bs3.gridlayout']], this.menu.pgel, this.$element, 'Column size &amp; order', 300);
            },
            version_name: `Bootstrap 3.4`
        }

        var gh = new PgBootstrapHelpers(bs_options, f, 3);



        //f.default = true;

        var getPlaceholderImage = function() {
            return pinegrow.getPlaceholderImage();
        }

        var showJavascriptMessage = function() {
            //crsaQuickMessage('You might need to Save and Reload the page (Page -&gt; Reload / CMD + R) to activate this change.', 3000, true);
        }

        var bm = new PgToggleButtonMaker();

        var getBootstrapColor = function(type) {
            switch(type) {
                case 'default':
                    return '#fff';
                case 'primary':
                    return '#337ab7';
                case 'info':
                    return '#5bc0de';
                case 'success':
                    return '#5cb85c';
                case 'warning':
                    return '#f0ad4e';
                case 'danger':
                    return '#d9534f';
                case 'muted':
                    return '#777';
                default:
                    return '#fff';
            }
        }


        var bsDataTarget =  {
            type: 'text',
            name: 'Data target',
            type: 'text',
            live_update: true,
            action : 'custom',
            get_value: function(pgel) {
                return pgel.attr('data-target');
            },
            set_value: function(pgel, value, values, oldValue, eventType) {
                if(value) {
                    pgel.attr('data-target', value);
                } else {
                    pgel.removeAttr('data-target');
                }
                showJavascriptMessage();
                return value;
            }
        }


        var bsDataToggle = {
            type: 'select',
            name: 'Data toggle',
            live_update: false,
            show_empty: true,
            options : [
                {key : 'dropdown', name : 'Dropdown' },
                {key : 'modal', name : 'Modal' },
                {key : 'tab', name : 'Tab' },
                {key : 'pill', name : 'Pill' },
                {key : 'tooltip', name : 'Tooltip' },
                {key : 'popover', name : 'Popover' },
                {key : 'button', name : 'Button' },
                {key : 'buttons', name : 'Buttons' },
                {key : 'collapse', name : 'Collapse' },
                {key : 'popover', name : 'Popover' }
            ],
            action : 'custom',
            get_value: function(pgel) {
                return pgel.attr('data-toggle');
            },
            set_value: function(pgel, value, values, oldValue, eventType) {
                if(value) {
                    pgel.attr('data-toggle', value);
                } else {
                    pgel.removeAttr('data-toggle');
                }
                showJavascriptMessage();
                return value;
            }
        }


        var tooltipMsgShown = false,
            popoverMsgShown = false;

        var onTooltipsChanged = function(pgel) {
            gh.executeScriptInPageDelayed(pgel.getPage(), bsTooltipsSection._tooltipsCode);
        }

        var onTooltipsChangedRefresh = function(pgel) {
            pinegrow.showQuickMessage('Refresh the page to see the changes.', 2000, false, null, 5000);
        }

        var bsTooltipsSection = {
            name : 'Tooltip',
            _tooltipsCode: '$(function() {\n    $(\'[data-toggle="tooltip"]\').tooltip();\n})',
            _tooltipsMainCode: '$(\'[data-toggle="tooltip"]\').tooltip()',
            fields : {
                tooltip : {
                    'type' : 'checkbox',
                    'name' : 'Tooltip',
                    'value' : "1",
                    'action' : 'custom',
                    get_value: function(pgel) {
                        return pgel.attr('data-toggle') == 'tooltip';
                    },
                    set_value: function(pgel, value, values, oldValue, eventType) {
                        if(value) {
                            pgel.attr('data-toggle', 'tooltip');
                            pinegrow.askAboutAddingCodeToPage(pgel.getPage(), bsTooltipsSection._tooltipsCode, 'Enable Bootstrap tooltips', 'Bootstrap tooltips need to be enabled with the call to the .tooltip() function. The following code activates all tooltips on the page:', true, bsTooltipsSection._tooltipsMainCode);

                        } else {
                            if(pgel.attr('data-toggle') == 'tooltip') {
                                pgel.removeAttr('data-toggle');
                            }
                        }
                        onTooltipsChangedRefresh(pgel);
                        return value;
                    }
                },
                tooltptext : {
                    type: 'text',
                    name: 'Text',
                    live_update : true,
                    'action' : 'custom',
                    get_value: function(pgel) {
                        var t = pgel.attr('title');
                        if(!t || t.length == 0) {
                            t = pgel.attr('data-original-title');
                        }
                        return t;
                    },
                    set_value: function(pgel, value, values, oldValue, eventType) {
                        if(value) {
                            pgel.attr('title', value);
                            if(pgel.attr('data-original-title')) {
                                pgel.attr('data-original-title', value);
                            }
                        } else {
                            pgel.removeAttr('title');
                            pgel.removeAttr('data-original-title');
                        }
                        return value;
                    },
                    on_changed : function(pgel, prop, value, oldValue) {
                        if(!oldValue) {
                            onTooltipsChangedRefresh(pgel)
                        } else {
                            onTooltipsChanged(pgel)
                        }
                    }
                },
                tooltipos : {
                    type: 'select',
                    name: 'Placement',
                    action: 'element_attribute',
                    attribute : 'data-placement',
                    'show_empty' : true,
                    'options' : [
                        {'key' : 'top', 'name' : 'Top'},
                        {'key' : 'right', 'name' : 'Right'},
                        {'key' : 'bottom', 'name' : 'Bottom'},
                        {'key' : 'left', 'name' : 'Left'},
                        {'key' : 'auto top', 'name' : 'Auto top'},
                        {'key' : 'auto right', 'name' : 'Auto right'},
                        {'key' : 'auto bottom', 'name' : 'Auto bottom'},
                        {'key' : 'auto left', 'name' : 'Auto left'}
                    ],
                    on_changed : onTooltipsChangedRefresh
                },
                tooltiphtml : {
                    type: 'checkbox',
                    name: 'Html',
                    action: 'element_attribute',
                    attribute: 'data-html',
                    value: 'true',
                    negvalue: 'false',
                    live_update : false,
                    on_changed : onTooltipsChangedRefresh
                },
                tooltiptrigger : {
                    type: 'select',
                    name: 'Trigger',
                    action: 'element_attribute',
                    attribute : 'data-trigger',
                    'show_empty' : true,
                    'options' : [
                        {'key' : 'click', 'name' : 'Click'},
                        {'key' : 'hover', 'name' : 'Hover'},
                        {'key' : 'focus', 'name' : 'Focus'},
                        {'key' : 'manual', 'name' : 'Manual'}
                    ],
                    on_changed : onTooltipsChangedRefresh
                },
                tooltpdelay : {
                    type: 'text',
                    name: 'Delay in ms',
                    action: 'element_attribute',
                    attribute: 'data-delay',
                    live_update : true,
                    on_changed : onTooltipsChangedRefresh
                },
                tooltpcontainer : {
                    type: 'text',
                    name: 'Container',
                    action: 'element_attribute',
                    attribute: 'data-container',
                    live_update : false,
                    on_changed : onTooltipsChangedRefresh
                },
                tooltipcode : {
                    'type' : 'button',
                    'action': 'button',
                    'name' : 'Enable tooltips on the page',
                    'func' : function(pgel, $button) {
                        pinegrow.makeChanges(pgel, 'Add tooltips code', function() {
                            pinegrow.addScriptCodeToPageIfNeeded(pgel.getPage(), bsTooltipsSection._tooltipsCode, 'Tooltips code', true /* execute */, bsTooltipsSection._tooltipsMainCode);
                        })
                    }
                }
            }
        }

        var onPopoversChanged = function(pgel) {
            gh.executeScriptInPageDelayed(pgel.getPage(), bsPopoverSection._popoversCode);
        }

        var bsPopoverSection = {
            name : 'Popover',
            _popoversCode: '$(function() {\n    $(\'[data-toggle="popover"]\').popover();\n})',
            _popoversMainCode: '$(\'[data-toggle="popover"]\').popover()',
            fields : {
                popover : {
                    'type' : 'checkbox',
                    'name' : 'Popover',
                    'value' : "1",
                    'action' : 'custom',
                    get_value: function(pgel) {
                        return pgel.attr('data-toggle') == 'popover';
                    },
                    set_value: function(pgel, value, values, oldValue, eventType) {
                        if(value) {
                            pgel.attr('data-toggle', 'popover');
                            pinegrow.askAboutAddingCodeToPage(pgel.getPage(), bsPopoverSection._popoversCode, 'Enable Bootstrap popovers', 'Bootstrap popovers need to be enabled with the call to the .popover() function. The following code activates all popovers on the page:', true, bsPopoverSection._popoversMainCode);
                        } else {
                            if(pgel.attr('data-toggle') == 'popover') {
                                pgel.removeAttr('data-toggle');
                            }
                        }
                        onTooltipsChangedRefresh(pgel);
                        return value;
                    }
                },
                popovertext : {
                    type: 'text',
                    name: 'Title',
                    'action' : 'custom',
                    get_value: function(pgel) {
                        var t = pgel.attr('title');
                        if(!t || t.length == 0) {
                            t = pgel.attr('data-original-title');
                        }
                        return t;
                    },
                    set_value: function(pgel, value, values, oldValue, eventType) {
                        if(value) {
                            pgel.attr('title', value);
                            if(pgel.attr('data-original-title')) {
                                pgel.attr('data-original-title', value);
                            }
                        } else {
                            pgel.removeAttr('title');
                            pgel.removeAttr('data-original-title');
                        }
                        return value;
                    },
                    on_changed : function(pgel, prop, value, oldValue) {
                        if(!oldValue) {
                            onTooltipsChangedRefresh(pgel)
                        } else {
                            onPopoversChanged(pgel)
                        }
                    }
                },
                popovercontent : {
                    type: 'text',
                    name: 'Content',
                    action: 'element_attribute',
                    attribute: 'data-content',
                    on_changed : onPopoversChanged
                },
                popoverpos : {
                    type: 'select',
                    name: 'Placement',
                    action: 'element_attribute',
                    attribute : 'data-placement',
                    'show_empty' : true,
                    'options' : [
                        {'key' : 'top', 'name' : 'Top'},
                        {'key' : 'right', 'name' : 'Right'},
                        {'key' : 'bottom', 'name' : 'Bottom'},
                        {'key' : 'left', 'name' : 'Left'},
                        {'key' : 'auto top', 'name' : 'Auto top'},
                        {'key' : 'auto right', 'name' : 'Auto right'},
                        {'key' : 'auto bottom', 'name' : 'Auto bottom'},
                        {'key' : 'auto left', 'name' : 'Auto left'}
                    ],
                    on_changed : onTooltipsChangedRefresh
                },
                popoverhtml : {
                    type: 'checkbox',
                    name: 'Html',
                    action: 'element_attribute',
                    attribute: 'data-html',
                    value: 'true',
                    negvalue: 'false',
                    live_update : false,
                    on_changed : onTooltipsChangedRefresh
                },
                popovertrigger : {
                    type: 'select',
                    name: 'Trigger',
                    action: 'element_attribute',
                    attribute : 'data-trigger',
                    'show_empty' : true,
                    'options' : [
                        {'key' : 'click', 'name' : 'Click'},
                        {'key' : 'hover', 'name' : 'Hover'},
                        {'key' : 'focus', 'name' : 'Focus'},
                        {'key' : 'manual', 'name' : 'Manual'}
                    ],
                    on_changed : onTooltipsChangedRefresh
                },
                popoverdelay : {
                    type: 'text',
                    name: 'Delay in ms',
                    action: 'element_attribute',
                    attribute: 'data-delay',
                    live_update : false,
                    on_changed : onTooltipsChangedRefresh
                },
                popovercontainer : {
                    type: 'text',
                    name: 'Container',
                    action: 'element_attribute',
                    attribute: 'data-container',
                    live_update : false,
                    on_changed : onTooltipsChangedRefresh
                },
                popovercode : {
                    'type' : 'button',
                    'action': 'button',
                    'name' : 'Enable popovers on the page',
                    'func' : function(pgel, $button) {
                        pinegrow.makeChanges(pgel, 'Add popovers code', function() {
                            pinegrow.addScriptCodeToPageIfNeeded(pgel.getPage(), bsPopoverSection._popoversCode, 'Popovers code', true /* execute */, bsPopoverSection._popoversMainCode);
                        })
                    }
                }
            }
        }


        var crsaAddStandardSections = function(addTo) {
            var bsAlign = {
                'type' : 'select',
                'name' : 'Text align',
                'action' : 'apply_class',
                'show_empty' : true,
                toggle_buttons: true,
                'options' : [
                    {
                        'key' : 'text-left',
                        'name' : 'Left',
                        html: bm.makeIcon('align-left')
                    },
                    {
                        'key' : 'text-center',
                        'name' : 'Center',
                        html: bm.makeIcon('align-center')
                    },
                    {
                        'key' : 'text-right',
                        'name' : 'Right',
                        html: bm.makeIcon('align-right')
                    },
                    {
                        'key' : 'text-justify',
                        'name' : 'Justify',
                        html: bm.makeIcon('align-full')
                    }
                ]
            };

            var bsTextEmphasis = {
                'type' : 'select',
                'name' : 'Text context',
                'action' : 'apply_class',
                'show_empty' : true,
                toggle_buttons: true,
                'options' : [
                    {
                        'key' : 'text-muted',
                        'name' : 'Muted',
                        html: bm.makeColorText( getBootstrapColor('muted'), 'A')

                    },
                    {
                        'key' : 'text-primary',
                        'name' : 'Primary',
                        html: bm.makeColorText( getBootstrapColor('primary'), 'A')
                    },
                    {
                        'key' : 'text-success',
                        'name' : 'Success',
                        html: bm.makeColorText( getBootstrapColor('success'), 'A')
                    },
                    {
                        'key' : 'text-info',
                        'name' : 'Info',
                        html: bm.makeColorText( getBootstrapColor('info'), 'A')
                    },
                    {
                        'key' : 'text-warning',
                        'name' : 'Warning',
                        html: bm.makeColorText( getBootstrapColor('warning'), 'A')
                    },
                    {
                        'key' : 'text-danger',
                        'name' : 'Danger',
                        html: bm.makeColorText( getBootstrapColor('danger'), 'A')
                    }
                ]
            };


            var bsBckEmphasis = {
                'type' : 'select',
                'name' : 'Background context',
                'action' : 'apply_class',
                'show_empty' : true,
                toggle_buttons: true,
                'options' : [
                    {
                        'key' : 'bg-primary',
                        'name' : 'Primary',
                        html: bm.makeColor( getBootstrapColor('primary'))
                    },
                    {
                        'key' : 'bg-success',
                        'name' : 'Success',
                        html: bm.makeColor( getBootstrapColor('success'))
                    },
                    {
                        'key' : 'bg-info',
                        'name' : 'Info',
                        html: bm.makeColor( getBootstrapColor('info'))
                    },
                    {
                        'key' : 'bg-warning',
                        'name' : 'Warning',
                        html: bm.makeColor( getBootstrapColor('warning'))
                    },
                    {
                        'key' : 'bg-danger',
                        'name' : 'Danger',
                        html: bm.makeColor( getBootstrapColor('danger'))
                    }
                ]
            };

            var bsTransform = {
                'type' : 'select',
                'name' : 'Text transform',
                'action' : 'apply_class',
                'show_empty' : true,
                toggle_buttons: true,
                'options' : [
                    {
                        'key' : 'text-lowercase',
                        'name' : 'Lowercase',
                        html: bm.makeIcon('lowercase')
                    },
                    {
                        'key' : 'text-uppercase',
                        'name' : 'Uppercase',
                        html: bm.makeIcon('uppercase')
                    },
                    {
                        'key' : 'text-capitalize',
                        'name' : 'Capitalize',
                        html: bm.makeIcon('sentence-case')
                    }
                ]
            };

            var bsLead = {
                'type' : 'checkbox',
                'name' : 'Lead',
                'action' : 'apply_class',
                'value' : 'lead'
            };

            var bsNowrap = {
                'type' : 'checkbox',
                'name' : 'No wrap',
                'action' : 'apply_class',
                'value' : 'text-nowrap'
            };

            var rules_section = {
                name : 'CSS Rules',
                fields : {
                    'rules' : {
                        'type' : 'rules',
                        'name' : null,
                        'action' : 'rules'
                    }
                }
            };

            var s = {
                'bstext' : {
                    name: 'Text &amp; Context',
                    compact: true,
                    default_closed: false,
                    fields: {
                        bstextalign : bsAlign,
                        bsemphasis: bsTextEmphasis,
                        bsbckcontext: bsBckEmphasis,
                        bsTransform: bsTransform,
                        bslead: bsLead,
                        bsnowrap: bsNowrap
                    }
                },
                'bslayout' : {
                    name: 'Layout',
                    fields: {
                        bsfloat : {
                            'type' : 'select',
                            'name' : 'Pull',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'options' : [
                                {
                                    'key' : 'pull-left',
                                    'name' : 'Left'
                                },
                                {
                                    'key' : 'pull-right',
                                    'name' : 'Right'
                                }
                            ]
                        },
                        clearfix : {
                            'type' : 'checkbox',
                            'name' : 'Clear floats',
                            'action' : 'apply_class',
                            'value' : 'clearfix'
                        }
                        /*     bscenter : {
                         'type' : 'checkbox',
                         'name' : 'Center block',
                         'action' : 'apply_class',
                         'value' : 'center-block'
                         }*/
                    }
                },
                'bsvisible' : {
                    name: 'Visibility',
                    compact: true,
                    fields: {
                        bsvisibiity : {
                            'type' : 'select',
                            'name' : 'Visibility',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'options' : [
                                {
                                    'key' : 'show',
                                    'name' : 'Shown'
                                },
                                {
                                    'key' : 'hidden',
                                    'name' : 'Hidden'
                                },
                                {
                                    'key' : 'invisible',
                                    'name' : 'Invisible'
                                }
                            ]
                        },
                        bsprint : {
                            'type' : 'select',
                            'name' : 'Print',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'options' : [
                                {
                                    'key' : 'visible-print',
                                    'name' : 'Visible'
                                },
                                {
                                    'key' : 'hidden-print',
                                    'name' : 'Hidden'
                                }
                            ]
                        },
                        'sr-only' : {
                            'type' : 'checkbox',
                            'name' : 'Scr.rdr only',
                            'action' : 'apply_class',
                            'value' : 'sr-only'
                        },

                        bstexthide : {
                            'type' : 'checkbox',
                            'name' : 'Hide text',
                            'action' : 'apply_class',
                            'value' : 'text-hide'
                        }

                    }
                },
                'bsresponsive' : {
                    name: 'Responsiveness',
                    fields: {
                        responsive_control: {
                            type: 'custom',
                            name: 'layout_control',
                            action: 'none',
                            control: createResponsiveControl,
                            oldshow: function($dest, obj, fn, fdef, values, $scrollParent) {
                                var $table = $("<table/>", {class: 'grid-control resp-control four-col-grid'}).appendTo($dest);
                                var $row = $("<tr/>").html("<td><label>Xs</label></td><td><label>Sm</label></td><td><label>Md</label></td><td><label>Lg</label></td>").appendTo($table);

                                $row = $("<tr/>").appendTo($table);
                                for(var m = 0; m < sizes.length; m++) {
                                    $td = $("<td/>").appendTo($row);
                                    var field = 'responsive-' + sizes[m];
                                    $.fn.crsa("addInputField", $td, obj, field, createResponsiveSelect(sizes[m]), values, false, $scrollParent);
                                }
                            }
                        }
                    }
                },
                bsTooltips: bsTooltipsSection,
                bsPopovers: bsPopoverSection,
                'bsjavascript' : {
                    name: 'Javascript',
                    fields: {
                        bsdatatarget: bsDataTarget,
                        bsdatatoggle: bsDataToggle,
                        bsdataslideto: {
	                    	type: 'text',
	                    	name: 'Data slide to',
	                    	action: 'element_attribute',
	                    	attribute: 'data-slide-to'
                        },
                        affix : {
                            name : 'Affix',
                            'type': 'checkbox' ,
                            value: '1',
                            action: "custom",
                            get_value: function(pgel) {
                                if(pgel.attr('data-spy') == 'affix') {
                                    return '1';
                                }
                                return null;
                            },
                            set_value: function(pgel, value, values) {
                                if(value) {
                                    pgel.attr('data-spy', 'affix');
                                } else {
                                    pgel.removeAttr('data-spy');
                                }
                                showJavascriptMessage();
                                return value;
                            }
                        },
                        affixtop : {
                            name : 'Affix top',
                            'type': 'text' ,
                            action: "custom",
                            get_value: function(pgel) {
                                return pgel.attr('data-offset-top');
                            },
                            set_value: function(pgel, value, values) {
                                if(value) {
                                    pgel.attr('data-offset-top', value);
                                } else {
                                    pgel.removeAttr('data-offset-top');
                                }
                                showJavascriptMessage();
                                return value;
                            }
                        },
                        affixbottom : {
                            name : 'Affix bottom',
                            'type': 'text' ,
                            action: "custom",
                            get_value: function(pgel) {
                                return pgel.attr('data-offset-bottom');
                            },
                            set_value: function(pgel, value, values) {
                                if(value) {
                                    pgel.attr('data-offset-bottom', value);
                                } else {
                                    pgel.removeAttr('data-offset-bottom');
                                }
                                showJavascriptMessage();
                                return value;
                            }
                        }
                    }
                }
            };
/*
            var before = {
                rules : rules_section,
                'id' : {
                    name : 'Element',
                    fields : {
                        'element_id' : {
                            'type' : 'text',
                            'name' : 'Element Id',
                            'action' : 'element_id'
                        }
                    }
                }
            }
*/
            var before = {
                css : {
                    //inherit this from html framework
                    inherit: true
                }
            }

            var list = {};

            $.each(addTo, function(k,v) {
                list[k] = v;
            });

            $.each(before, function(k,v) {
                list[k] = v;
            });



            $.each(s, function(k,v) {
                list[k] = v;
            });
            return list;
        }




        var createResponsiveSelect = function(size) {
            var span_select = {
                'type' : 'select',
                'name' : null,
                'action' : 'apply_class',
                'show_empty' : true,
                'options' : [
                    {key: 'visible-' + size, name: 'Visible'},
                    {key: 'hidden-' + size, name: 'Hidden'},
                    {key: 'visible-' + size + '-block', name: 'Block'},
                    {key: 'visible-' + size + '-inline-block', name: 'Inline block'},
                    {key: 'visible-' + size + '-inline', name: 'Inline'}
                ]
            }
            return span_select;
        }

        function getGridPreview(t) {
            return '<div class="container preview-' + t + '">\
            <div class="row sel">\
                <div class="col-xs-4 sel"><div></div></div>\
                <div class="col-xs-4"><div></div></div>\
                <div class="col-xs-4"><div></div></div>\
            </div>\
            <div class="row">\
                <div class="col-xs-4"><div></div></div>\
                <div class="col-xs-4"><div></div></div>\
                <div class="col-xs-4"><div></div></div>\
            </div>\
            </div>';
        };

        //Container
        f.addComponentType({
            'type' : 'bs-container',
            'selector' : '.container,.container-fluid',
            tags: 'major',
            preview: getGridPreview('container'),
            'code' : '<div class="container"></div>',
            'name' : 'Container',
            empty_placeholder : true,
            action_menu: {
                add: ['bs-row']
            },
            'inline_edit' : true,
            'sections' : gh.addPrefixToSectionsAndFields({
                bscontaineropt : {
                    name : "Container options",
                    fields : {
                        fluid : {
                            name : 'Fluid',
                            'type': 'checkbox' ,
                            value: '1',
                            action: "custom",
                            get_value: function(pgel) {
                                return pgel.hasClass('container-fluid') ? '1' : null;
                            },
                            set_value: function(pgel, value, values, oldValue, eventType) {
                                if(value) {
                                    pgel.removeClass('container');
                                    pgel.addClass('container-fluid');
                                } else {
                                    pgel.addClass('container');
                                    pgel.removeClass('container-fluid');
                                }
                                return value;
                            }
                        }
                    }
                }
            })
        });

        //Row
        f.addComponentType({
            'type' : 'bs-row',
            'selector' : 'div.row',
            tags: 'major',
            preview: getGridPreview('row'),
            //'parent_selector' : '.container',
            invalid_drop_msg : "Row can only be dropped into a Container. Drop it to the tree if you want to put it somewhere else.",
            'code' : '<div class="row"></div>',
            empty_placeholder : true,
            'name' : 'Row',
            action_menu : {
                add: ['bs-column', 'thumbnail-img', 'thumbnail-content']
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                rowsettings: {
                    name: "Row",
                    fields: {
                        nogutters: {
                            type: 'checkbox',
                            name: 'No gutters',
                            action: 'apply_class',
                            value: 'row-no-gutters'
                        }
                    }
                }
            })
        });

        //Column clear
        f.addComponentType({
            'type' : 'bs-clear',
            'selector' : 'div.clear-columns',
            'code' : '<div class="clearfix clear-columns"></div>',
            'name' : 'Clear columns',
            'sections' : gh.addPrefixToSectionsAndFields({})
        });

        var columnPlaceMsg = 'Put <b>Column</b> in a <b>Row</b>. If you want to put it somewhere else, drop it on the tree.';


        //Define a function that will create the control
        var createResponsiveControl = function() {
            var c = new PgCustomPropertyControl('bs-responsive-control');

            c.onDefine = function() {
                for (var m = 0; m < sizes.length; m++) {
                    var field = 'responsive-' + sizes[m];
                    this.registerInputField(field, createResponsiveSelect(sizes[m]))
                }
            }

            //Show control. Return the control $el.
            c.onShow = function() {
                var $table = $("<table/>", {class: 'grid-control resp-control four-col-grid'});
                var $row = $("<tr/>").html("<td><label>Xs</label></td><td><label>Sm</label></td><td><label>Md</label></td><td><label>Lg</label></td>").appendTo($table);

                $row = $("<tr/>").appendTo($table);
                for(var m = 0; m < sizes.length; m++) {
                    $td = $("<td/>").appendTo($row);
                    var field = 'responsive-' + sizes[m];
                    this.showInputField($td, field, createResponsiveSelect(sizes[m]));
                }
                return $table;
            }

            //Called when control is recycled and new values are set
            c.onSetValues = function() {
                //Nothing to do in this case. PG will take care of updating sub fields with new values
            }

            //Helper functions and vars

            var createResponsiveSelect = function(size) {
                var span_select = {
                    'type' : 'select',
                    'name' : null,
                    'action' : 'apply_class',
                    'show_empty' : true,
                    'options' : [
                        {key: 'visible-' + size, name: 'Visible'},
                        {key: 'hidden-' + size, name: 'Hidden'},
                        {key: 'visible-' + size + '-block', name: 'Block'},
                        {key: 'visible-' + size + '-inline-block', name: 'Inline block'},
                        {key: 'visible-' + size + '-inline', name: 'Inline'}
                    ]
                }
                return span_select;
            }

            //Return the control
            return c;
        };


        //Define a function that will create the control
        var createGridControl = function() {
            //will keep helper functions and vars private

            //Create control, needs a unique id
            var c = new PgCustomPropertyControl('bs-col-grid');

            //Register subfields.
            c.onDefine = function() {

                //These fields will not be shown when just registered. This is neccessary to get values.
                for(var n = 0; n < fields.length; n++) {
                    for (var m = 0; m < sizes.length; m++) {
                        var field = field_keys[n] + sizes[m];
                        this.registerInputField(field, createColumnSpans(field_names[n], "col-" + sizes[m] + fields[n], true, fields[n] == '' ? 1 : 0))
                    }
                }
            }

            //Show control. Return the control $el.
            c.onShow = function() {
                var $table = $("<table/>", {class: 'grid-control columns-control five-col-grid'});
                var $row = $("<tr/>").html("<td></td><td><label>Xs</label></td><td><label>Sm</label></td><td><label>Md</label></td><td><label>Lg</label></td>").appendTo($table);

                for(var n = 0; n < fields.length; n++) {
                    $row = $("<tr/>").appendTo($table);
                    var $td = $("<td/>").html('<label>' + field_names[n] + '</label>').appendTo($row);
                    for(var m = 0; m < sizes.length; m++) {
                        $td = $("<td/>").appendTo($row);

                        var field = field_keys[n] + sizes[m];
                        this.showInputField($td, field, createColumnSpans(field_names[n], "col-" + sizes[m] + fields[n], true, fields[n] == '' ? 1 : 0));
                    }
                }
                return $table;
            }

            //Called when control is recycled and new values are set
            c.onSetValues = function() {
                //Nothing to do in this case. PG will take care of updating sub fields with new values
            }

            //Helper functions and vars
            var fields = ["", "-offset", "-push", "-pull"];
            var field_names = ["Span&nbsp;", "Offs&nbsp;", "Push&nbsp;", "Pull&nbsp;"];
            var field_keys = ["span_", "offset_", "push_", "pull_"];

            var createColumnSpans = function(name, base, empty, start) {
                if(typeof start == 'undefined') start = 1;
                var span_select = {
                    'type' : 'select',
                    'name' : null,
                    'action' : 'apply_class',
                    'show_empty' : empty,
                    'options' : []
                }
                for(var n = start; n <= num_columns; n++) {
                    span_select.options.push({key: base + '-' + n, name: n});
                }
                return span_select;
            }

            //Return the control
            return c;
        };



        var col_def = {
            'type' : 'bs-column',
            tags: 'major',
            'selector' : isColumn,
            preview: getGridPreview('column'),
            parent_selector: '.row',
            invalid_drop_msg : columnPlaceMsg,
            'code' : '<div class="col-md-4"><h3>Column title</h3>\
        <p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Donec id elit non mi porta gravida at eget metus. Nullam id dolor id nibh ultricies vehicula ut id elit.</p>\
        </div>',
            'empty_placeholder' : true,
            'name' : 'Column',
            'inline_edit' : true,
            'sections' : gh.addPrefixToSectionsAndFields({
                gridlayout : {
                    name : "Grid",
                    fields : {
                        gridlayout_control: {
                            type: 'custom',
                            name: 'layout_control',
                            action: 'none',
                            control: createGridControl
                        }
                    }
                }
            })
        }
        f.addComponentType(col_def);




        var bsPullRight = {
            'type' : 'checkbox',
            'name' : 'Pull right',
            'action' : 'apply_class',
            'value' : 'pull-right'
        };
        var hoptions = [
            {key: 'h1', name: 'Heading 1'},
            {key: 'h2', name: 'Heading 2'},
            {key: 'h3', name: 'Heading 3'},
            {key: 'h4', name: 'Heading 4'},
            {key: 'h5', name: 'Heading 5'},
            {key: 'h6', name: 'Heading 6'}
        ];

        var headings = ['h1', 'h2', 'h3', 'h4', 'h5', 'h6'];
        $.each(headings, function(i,h) {
            var hdef = {
                'type' : h,
                'selector' : h,
                'code' : '<' + h + '>Heading ' + (i+1) + '</' + h + '>',
                'name' : h,
                action_menu: {
                    add: ['small']
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                    'style' : {
                        name : 'Heading',
                        fields : {
                            description : {
                                'type' : 'select',
                                'name' : 'Level',
                                'action' : 'custom',
                                'show_empty' : false,
                                options: hoptions,
                                get_value: function(pgel) {
                                    for(var i = 0; i < hoptions.length; i++) {
                                        if(pgel.tagName == hoptions[i].key) {
                                            return hoptions[i].key;
                                        }
                                    }
                                    return null;
                                },
                                set_value: function(pgel, value, values, oldValue, eventType) {
                                    crsaWillChangeDom();
                                    var newpgel = pgel.replaceTag(value);
                                    //$.fn.crsa('setSelectElementOnUpdate', newpgel);todo30
                                    return value;
                                }
                            }
                        }
                    }
                })
            }
            f.addComponentType(hdef);
        });

        var secondaryText = {
            'type' : 'small',
            'selector' : 'small',
            'code' : '<small>Secondary text</small>',
            'preview' : '<h1><small>Secondary text</small></h1>',
            'name' : 'Secondary text',
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(secondaryText);

        var tag = {
            'type' : 'p',
            'selector' : 'p',
            'code' : '<p>Paragraph</p>',
            'name' : 'p',
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(tag);

        var abbreviation = {
            'type' : 'abbr',
            'selector' : 'abbr',
            'code' : '<abbr title="Description">term</abbr>',
            'name' : 'Abbreviation',
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Abbreviation',
                    fields : {
                        description : {
                            'type' : 'text',
                            'name' : 'Description',
                            'action' : 'element_attribute',
                            'attribute' : 'title'
                        },
                        initialism : {
                            'type' : 'checkbox',
                            'name' : 'All caps',
                            'action' : 'apply_class',
                            'value' : 'initialism'
                        }
                    }
                }
            })
        }
        f.addComponentType(abbreviation);


        var address = {
            'type' : 'address',
            'selector' : 'address',
            'code' : '<address>\
        <strong>Twitter, Inc.</strong><br/>\
795 Folsom Ave, Suite 600<br/>\
    San Francisco, CA 94107<br/>\
            <abbr title="Phone">P:</abbr> (123) 456-7890<br/>\
            <br/>\
            <strong>Full Name</strong><br>\
            <a href="mailto:#">first.last@example.com</a>\
        </address>',
            'name' : 'Address',
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(address);


        var blockQuoteCitationSetValue = function (pgel, value, values, oldValue) {
            crsaWillChangeDom();

            var source = values.source;
            var pgsmall = pgel.findOne('small');
            if (!value || value.length == 0) {
                //$small.remove();
                pgsmall.remove();
            } else {
                if (source && source.length > 0) {
                    source = '<cite title="' + source + '">' + source + '</cite>';
                } else {
                    source = '';
                }
                if ((!oldValue || oldValue.length == 0) && (source && source.length > 0)) value += " @SOURCE";
                var text = value.replace(/@source/i, source);
                if (!pgsmall) {
                    //$small = $("<small/>").appendTo($el);
                    pgsmall = pgCreateNodeFromHtml("<small></small>");
                    pgel.append(pgsmall);
                }
                pgsmall.html(text);
            }
            return value;
        };

        var blockquote = {
            'type' : 'blockquote',
            'selector' : 'blockquote',
            tags: 'major',
            'code' : '<blockquote>\
        <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.</p>\
    <small>Someone famous in <cite title="Source Title">Source Title</cite></small>\
</blockquote>',
            'name' : 'Blockquote',
            'sections' : gh.addPrefixToSectionsAndFields({
                'data' : {
                    name: "Info",
                    fields: {
                        citation: {
                            type: 'text',
                            name: 'Citation',
                            action: 'custom',
                            live_update: false,
                            get_value: function (pgel) {
                                var pgsmall = pgel.findOne('small');
                                if (!pgsmall) return null;
                                var s = pgsmall.html();
                                s = s.replace(/<cite.*<\/cite>/i, '@SOURCE');
                                return s;
                            },
                            set_value: blockQuoteCitationSetValue
                        },
                        source: {
                            type: 'text',
                            name: 'Source',
                            action: 'custom',
                            live_update: false,
                            get_value: function (pgel) {
                                var pgcite = pgel.findOne('cite');
                                if (!pgcite) return null;
                                return pgcite.text();
                            },
                            set_value: function (pgel, value, values) {
                                var citation = values.citation;
                                if (value && value.length > 0) {
                                    if (!citation) {
                                        citation = '@SOURCE';
                                    } else {
                                        if (!citation.match(/@source/i)) {
                                            citation += ' @SOURCE';
                                        }
                                    }
                                }
                                setTimeout(function() {
                                    //wait for source set_value cycle to complete and commit before updating
                                    $.fn.crsa('setSelectedElementProperty', 'citation', citation);
                                }, 100);

                                return value;
                            }
                        },
                        blockqoute_reverse : {
                            'type' : 'checkbox',
                            'name' : 'Reverse',
                            'action' : 'apply_class',
                            'value' : 'blockquote-reverse'
                        }
                    }
                }
            })
        }
        f.addComponentType(blockquote);

        //hr
        f.addComponentType({
            'type' : 'hr',
            'selector' : 'hr',
            'code' : '<hr/>',
            'name' : 'hr',
            'sections' : gh.addPrefixToSectionsAndFields({})
        });

        var glyphs = ['glyphicon-asterisk',  'glyphicon-plus',  'glyphicon-euro',  'glyphicon-minus',  'glyphicon-cloud',  'glyphicon-envelope',  'glyphicon-pencil',  'glyphicon-glass',  'glyphicon-music',  'glyphicon-search',  'glyphicon-heart',  'glyphicon-star',  'glyphicon-star-empty',  'glyphicon-user',  'glyphicon-film',  'glyphicon-th-large',  'glyphicon-th',  'glyphicon-th-list',  'glyphicon-ok',  'glyphicon-remove',  'glyphicon-zoom-in',  'glyphicon-zoom-out',  'glyphicon-off',  'glyphicon-signal',  'glyphicon-cog',  'glyphicon-trash',  'glyphicon-home',  'glyphicon-file',  'glyphicon-time',  'glyphicon-road',  'glyphicon-download-alt',  'glyphicon-download',  'glyphicon-upload',  'glyphicon-inbox',  'glyphicon-play-circle',  'glyphicon-repeat',  'glyphicon-refresh',  'glyphicon-list-alt',  'glyphicon-lock',  'glyphicon-flag',  'glyphicon-headphones',  'glyphicon-volume-off',  'glyphicon-volume-down',  'glyphicon-volume-up',  'glyphicon-qrcode',  'glyphicon-barcode',  'glyphicon-tag',  'glyphicon-tags',  'glyphicon-book',  'glyphicon-bookmark',  'glyphicon-print',  'glyphicon-camera',  'glyphicon-font',  'glyphicon-bold',  'glyphicon-italic',  'glyphicon-text-height',  'glyphicon-text-width',  'glyphicon-align-left',  'glyphicon-align-center',  'glyphicon-align-right',  'glyphicon-align-justify',  'glyphicon-list',  'glyphicon-indent-left',  'glyphicon-indent-right',  'glyphicon-facetime-video',  'glyphicon-picture',  'glyphicon-map-marker',  'glyphicon-adjust',  'glyphicon-tint',  'glyphicon-edit',  'glyphicon-share',  'glyphicon-check',  'glyphicon-move',  'glyphicon-step-backward',  'glyphicon-fast-backward',  'glyphicon-backward',  'glyphicon-play',  'glyphicon-pause',  'glyphicon-stop',  'glyphicon-forward',  'glyphicon-fast-forward',  'glyphicon-step-forward',  'glyphicon-eject',  'glyphicon-chevron-left',  'glyphicon-chevron-right',  'glyphicon-plus-sign',  'glyphicon-minus-sign',  'glyphicon-remove-sign',  'glyphicon-ok-sign',  'glyphicon-question-sign',  'glyphicon-info-sign',  'glyphicon-screenshot',  'glyphicon-remove-circle',  'glyphicon-ok-circle',  'glyphicon-ban-circle',  'glyphicon-arrow-left',  'glyphicon-arrow-right',  'glyphicon-arrow-up',  'glyphicon-arrow-down',  'glyphicon-share-alt',  'glyphicon-resize-full',  'glyphicon-resize-small',  'glyphicon-exclamation-sign',  'glyphicon-gift',  'glyphicon-leaf',  'glyphicon-fire',  'glyphicon-eye-open',  'glyphicon-eye-close',  'glyphicon-warning-sign',  'glyphicon-plane',  'glyphicon-calendar',  'glyphicon-random',  'glyphicon-comment',  'glyphicon-magnet',  'glyphicon-chevron-up',  'glyphicon-chevron-down',  'glyphicon-retweet',  'glyphicon-shopping-cart',  'glyphicon-folder-close',  'glyphicon-folder-open',  'glyphicon-resize-vertical',  'glyphicon-resize-horizontal',  'glyphicon-hdd',  'glyphicon-bullhorn',  'glyphicon-bell',  'glyphicon-certificate',  'glyphicon-thumbs-up',  'glyphicon-thumbs-down',  'glyphicon-hand-right',  'glyphicon-hand-left',  'glyphicon-hand-up',  'glyphicon-hand-down',  'glyphicon-circle-arrow-right',  'glyphicon-circle-arrow-left',  'glyphicon-circle-arrow-up',  'glyphicon-circle-arrow-down',  'glyphicon-globe',  'glyphicon-wrench',  'glyphicon-tasks',  'glyphicon-filter',  'glyphicon-briefcase',  'glyphicon-fullscreen',  'glyphicon-dashboard',  'glyphicon-paperclip',  'glyphicon-heart-empty',  'glyphicon-link',  'glyphicon-phone',  'glyphicon-pushpin',  'glyphicon-usd',  'glyphicon-gbp',  'glyphicon-sort',  'glyphicon-sort-by-alphabet',  'glyphicon-sort-by-alphabet-alt',  'glyphicon-sort-by-order',  'glyphicon-sort-by-order-alt',  'glyphicon-sort-by-attributes',  'glyphicon-sort-by-attributes-alt',  'glyphicon-unchecked',  'glyphicon-expand',  'glyphicon-collapse-down',  'glyphicon-collapse-up',  'glyphicon-log-in',  'glyphicon-flash',  'glyphicon-log-out',  'glyphicon-new-window',  'glyphicon-record',  'glyphicon-save',  'glyphicon-open',  'glyphicon-saved',  'glyphicon-import',  'glyphicon-export',  'glyphicon-send',  'glyphicon-floppy-disk',  'glyphicon-floppy-saved',  'glyphicon-floppy-remove',  'glyphicon-floppy-save',  'glyphicon-floppy-open',  'glyphicon-credit-card',  'glyphicon-transfer',  'glyphicon-cutlery',  'glyphicon-header',  'glyphicon-compressed',  'glyphicon-earphone',  'glyphicon-phone-alt',  'glyphicon-tower',  'glyphicon-stats',  'glyphicon-sd-video',  'glyphicon-hd-video',  'glyphicon-subtitles',  'glyphicon-sound-stereo',  'glyphicon-sound-dolby',  'glyphicon-sound-5-1',  'glyphicon-sound-6-1',  'glyphicon-sound-7-1',  'glyphicon-copyright-mark',  'glyphicon-registration-mark',  'glyphicon-cloud-download',  'glyphicon-cloud-upload',  'glyphicon-tree-conifer',  'glyphicon-tree-deciduous',  'glyphicon-cd',  'glyphicon-save-file',  'glyphicon-open-file',  'glyphicon-level-up',  'glyphicon-copy',  'glyphicon-paste',  'glyphicon-alert',  'glyphicon-equalizer',  'glyphicon-king',  'glyphicon-queen',  'glyphicon-pawn',  'glyphicon-bishop',  'glyphicon-knight',  'glyphicon-baby-formula',  'glyphicon-tent',  'glyphicon-blackboard',  'glyphicon-bed',  'glyphicon-apple',  'glyphicon-erase',  'glyphicon-hourglass',  'glyphicon-lamp',  'glyphicon-duplicate',  'glyphicon-piggy-bank',  'glyphicon-scissors',  'glyphicon-bitcoin',  'glyphicon-btc',  'glyphicon-xbt',  'glyphicon-yen',  'glyphicon-jpy',  'glyphicon-ruble',  'glyphicon-rub',  'glyphicon-scale',  'glyphicon-ice-lolly',  'glyphicon-ice-lolly-tasted',  'glyphicon-education',  'glyphicon-option-horizontal',  'glyphicon-option-vertical',  'glyphicon-menu-hamburger',  'glyphicon-modal-window',  'glyphicon-oil',  'glyphicon-grain',  'glyphicon-sunglasses',  'glyphicon-text-size',  'glyphicon-text-color',  'glyphicon-text-background',  'glyphicon-object-align-top',  'glyphicon-object-align-bottom',  'glyphicon-object-align-horizontal',  'glyphicon-object-align-left',  'glyphicon-object-align-vertical',  'glyphicon-object-align-right',  'glyphicon-triangle-right',  'glyphicon-triangle-left',  'glyphicon-triangle-bottom',  'glyphicon-triangle-top',  'glyphicon-console',  'glyphicon-superscript',  'glyphicon-subscript',  'glyphicon-menu-left',  'glyphicon-menu-right',  'glyphicon-menu-down',  'glyphicon-menu-up'];
        var glyphs_options = [];
        for(var i = 0; i < glyphs.length; i++) {
            var g = glyphs[i];
            glyphs_options.push({key: g, name: g.replace('glyphicon-',''), html: '<i class="glyphicon ' + g + '"></i>'});
        }

        var glyphs_def = {
            'type' : 'glyphicon',
            'selector' : 'span.glyphicon',
            'code' : '<span class="glyphicon glyphicon-star"></span>',
            'name' : 'Glyphicon',
            'sections' : gh.addPrefixToSectionsAndFields({
                'data' : {
                    name: "Icon",
                    fields: {
                        icon: {
                            type: 'select',
                            name: 'Icon',
                            options: glyphs_options,
                            rich: {
                                title: 'Select icon',
                                modal: true,
                                class: 'icons-grid'
                            },
                            action: 'custom',
                            get_value: function (pgel) {
                                var value = '';
                                var cls = pgel.getAttr('class');
                                var m = cls.match(/glyphicon-[a-z\-]*/i);
                                if (m) value = m[0]
                                return value;
                            },
                            set_value: function (pgel, value, values) {
                                var cls = pgel.getAttr('class');
                                var m = cls.match(/glyphicon-[a-z\-]*/i);
                                if (m) pgel.removeClass(m[0]);
                                pgel.addClass(value);
                                return value;
                            }
                        }
                    }
                }
            })
        }
        f.addComponentType(glyphs_def);




        var description = {
            'type' : 'description',
            'selector' : 'dl',
            'code' : '<dl>\
        <dt>Description lists</dt>\
    <dd>A description list is perfect for defining terms.</dd>\
    <dt>Euismod</dt>\
    <dd>Vestibulum id ligula porta felis euismod semper eget lacinia odio sem nec elit.</dd>\
</dl>',
            'name' : 'Description list',
            tags: 'major',
            action_menu: {
                add: ['description-term', 'description-def']
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        'horizontal' : {
                            'type' : 'checkbox',
                            'name' : 'Horizontal',
                            'action' : 'apply_class',
                            'value' : 'dl-horizontal'
                        }
                    }
                }
            })
        }
        f.addComponentType(description);


        var description_term = {
            'type' : 'description-term',
            'selector' : 'dt',
            parent_selector: 'dl',
            'code' : '<dt>Term</dt>',
            'name' : 'Description term',
            'sections' : gh.addPrefixToSectionsAndFields({})
        }
        f.addComponentType(description_term);

        var description_def = {
            'type' : 'description-def',
            'selector' : 'dd',
            parent_selector: 'dl',
            'code' : '<dd>Term definition.</dd>',
            'name' : 'Description definition',
            'sections' : gh.addPrefixToSectionsAndFields({})
        }
        f.addComponentType(description_def);



        var code = {
            'type' : 'code',
            'selector' : 'code',
            'code' : '<code>&lt;section&gt;</code>',
            'name' : 'Code',
            'sections' : gh.addPrefixToSectionsAndFields({})
        }
        f.addComponentType(code);

        var code_block = {
            'type' : 'code-block',
            'selector' : 'pre',
            'code' : '<pre>&lt;p&gt;Sample text here...&lt;/p&gt;</pre>',
            'name' : 'Code block',
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        'scroll' : {
                            'type' : 'checkbox',
                            'name' : 'Scrollable',
                            'action' : 'apply_class',
                            'value' : 'pre-scrollable'
                        }
                    }
                }
            })
        }
        f.addComponentType(code_block);

        var codekbd = {
            'type' : 'code-kbd',
            'selector' : 'kbd',
            'code' : '<kbd>ctrl</kbd>',
            'name' : 'Kbd',
            'sections' : gh.addPrefixToSectionsAndFields({})
        }
        f.addComponentType(codekbd);

        var codevar = {
            'type' : 'code-var',
            'selector' : 'var',
            'code' : '<var>variable</var>',
            'name' : 'Variable',
            'sections' : gh.addPrefixToSectionsAndFields({})
        }
        f.addComponentType(codevar);

        var codesample = {
            'type' : 'code-sample',
            'selector' : 'samp',
            'code' : '<samp>This text is meant to be treated as sample output from a computer program.</samp>',
            'name' : 'Sample',
            'sections' : gh.addPrefixToSectionsAndFields({})
        }
        f.addComponentType(codesample);


        //tables
        var isTableRowEmpty = function (pgtr) {
            var empty = true;
            var pgtd = pgtr.find(">td");

            for (var i = 0; i < pgtd.length; i++) {
                if ($.trim(pgtd[i].html()).length > 0) {
                    empty = false;
                    return false;
                }
            }

            return empty;
        }

        var countNonEmptyTableRows = function(pgtbody) {
            var c = 0;
            var pgrows = pgtbody.find(">tr");

            for (var i = 0; i < pgrows.length; i++) {
                if (isTableRowEmpty(pgrows[i])) c++;
            }
            return c;
        }

        var getTablePreviewCode = function(t) {
            return '<table class="table preview-' + t + '">\
        <thead>\
        <tr>\
            <th>#</th>\
            <th>First Name</th>\
            <th>Last Name</th>\
            <th>Username</th>\
        </tr>\
        </thead>\
    <tbody>\
        <tr class="sel">\
            <td>1</td>\
            <td class="sel">Mark</td>\
            <td>Otto</td>\
            <td>@mdo</td>\
        </tr>\
        <tr>\
            <td>2</td>\
            <td>Jacob</td>\
            <td>Thornton</td>\
            <td>@fat</td>\
        </tr>\
        <tr>\
            <td>3</td>\
            <td>Larry</td>\
            <td>the Bird</td>\
            <td>@twitter</td>\
        </tr>\
    </tbody>\
</table>';
        }

        var table = {
            'type' : 'table',
            'selector' : 'table',
            tags: 'major',
            'code' : '<table class="table">\
        <thead>\
        <tr>\
            <th>#</th>\
            <th>First Name</th>\
            <th>Last Name</th>\
            <th>Username</th>\
        </tr>\
        </thead>\
    <tbody>\
        <tr>\
            <td>1</td>\
            <td>Mark</td>\
            <td>Otto</td>\
            <td>@mdo</td>\
        </tr>\
        <tr>\
            <td>2</td>\
            <td>Jacob</td>\
            <td>Thornton</td>\
            <td>@fat</td>\
        </tr>\
        <tr>\
            <td>3</td>\
            <td>Larry</td>\
            <td>the Bird</td>\
            <td>@twitter</td>\
        </tr>\
    </tbody>\
</table>',
            preview: getTablePreviewCode('table'),
            'name' : 'Table',
            'sections' : gh.addPrefixToSectionsAndFields({
                'data' : {
                    name: "Table options",
                    fields: {
                        rows: {
                            type: 'slider',
                            name: 'Rows',
                            live_update: false,
                            action: 'custom',
                            slider_def_unit: '',
                            get_value: function (pgel) {
                                var pgtbody = pgel.findOne('>tbody');
                                var pgrows = pgtbody.find('>tr');
                                return pgrows.length;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {

                                crsaWillChangeDom();

                                value = parseInt(value) || 0;
                                var pgtbody = pgel.findOne('>tbody');
                                if (!pgtbody) {
                                    //$tbody = $('<tbody/>').appendTo($el);
                                    pgtbody = pgCreateNodeFromHtml('<tbody></tbody>');
                                    pgel.append(pgtbody);
                                    // $tbody = $(pgtbody.get(0).el);
                                }
                                var pgrows = pgtbody.find('>tr').reverse();

                                var cols = values.columns;
                                var change = false;
                                var empty_count = countNonEmptyTableRows(pgtbody);
                                var new_value = value;

                                if (pgrows.length < value) {
                                    for (var n = 0; n < value - pgrows.length; n++) {
                                        //var $tr = $('<tr/>').appendTo($tbody);
                                        var pgtr = pgCreateNodeFromHtml('<tr></tr>');
                                        pgtbody.append(pgtr);
                                        // var $tr = $(pgtr.get(0).el);
                                        for (var c = 0; c < cols; c++) {
                                            pgtr.append(pgCreateNodeFromHtml('<td></td>'));
                                            //$('<td/>').appendTo($tr);
                                        }
                                    }
                                    change = true;
                                } else if (pgrows.length > value) {
                                    var remove = pgrows.length - value;

                                    for (var i = 0; i < pgrows.length; i++) {
                                        var pgtr = pgrows[i];
                                        if (true || isTableRowEmpty(pgtr)) {
                                            pgtr.remove();
                                            remove--;
                                            if(remove == 0) break;
                                        }
                                    }

                                    new_value = value + remove;
                                }

                                if (eventType == "change") {
                                    // $.fn.crsa("setNeedsUpdate", false, $el);
                                    value = new_value;
                                }
                                if (value == 0) return null;
                                else            return value;
                            }
                        },
                        columns: {
                            type: 'slider',
                            name: 'Columns',
                            live_update: false,
                            action: 'custom',
                            slider_def_unit: '',
                            get_value: function (pgel) {
                                var pgtbody = pgel.findOne('>tbody');
                                var pgrows = pgtbody.find('>tr');
                                var max_c = 0;

                                for (var i = 0; i < pgrows.length; i++) {
                                    var c = pgrows[i].find('>td').length;
                                    if (c > max_c) max_c = c;
                                }

                                var pgheadrows = pgel.find('>thead >tr');

                                for (var i = 0; i < pgheadrows.length; i++) {
                                    var c = pgheadrows[i].find('>th').length;
                                    if (c > max_c) max_c = c;
                                }

                                return max_c;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {

                                crsaWillChangeDom();

                                value = parseInt(value) || 0;

                                var pgtbody = pgel.findOne('>tbody');
                                var pgthead = pgel.findOne('>thead');

                                var pgrows = [];
                                if (pgtbody) pgrows = pgrows.concat(pgtbody.find('>tr'));
                                if (pgthead) pgrows = pgrows.concat(pgthead.find('>tr'));

                                var new_value = value;
                                if (value) {
                                    var max_c = 0;

                                    for (var i = 0; i < pgrows.length; i++) {
                                        var pgcells = pgrows[i].find('>td,>th').reverse();

                                        if (pgcells.length > value) {
                                            var remove = pgcells.length - value;

                                            for (var n = 0; n < pgcells.length; n++) {
                                                var pgtd = pgcells[n];
                                                if (true || $.trim(pgtd.html()) == '') {
                                                    //$td.remove();
                                                    pgtd.remove();
                                                    remove--;
                                                    if (remove == 0) break;
                                                }
                                            }
                                        } else if (pgcells.length < value) {
                                            for(var n = pgcells.length; n < value; n++) {
                                                var tag = pgrows[i].parent.tagName == 'thead' ? 'th' : 'td';
                                                pgrows[i].append(pgCreateNodeFromHtml('<' + tag + '></' + tag + '>'));
                                                //$('<' + tag +'/>').appendTo($(tr));
                                            }
                                        }
                                        var c = pgrows[i].find('>td,>th').length;
                                        if (c > max_c) max_c = c;
                                    }

                                    new_value = max_c;
                                }
                                if (eventType == "change") {
                                    // $.fn.crsa("setNeedsUpdate", false, $el);
                                    value = new_value;
                                }

                                if (value == 0) return null;
                                else            return value;
                            }
                        }
                    }
                },
                'style' : {
                    name : 'Style',
                    fields : {
                        'striped' : {
                            'type' : 'checkbox',
                            'name' : 'Striped',
                            'action' : 'apply_class',
                            'value' : 'table-striped'
                        },
                        'bordered' : {
                            'type' : 'checkbox',
                            'name' : 'Bordered',
                            'action' : 'apply_class',
                            'value' : 'table-bordered'
                        },
                        'hover-rows' : {
                            'type' : 'checkbox',
                            'name' : 'Hover rows',
                            'action' : 'apply_class',
                            'value' : 'table-hover'
                        },
                        'condensed' : {
                            'type' : 'checkbox',
                            'name' : 'Condensed',
                            'action' : 'apply_class',
                            'value' : 'table-condensed'
                        },
                        'addInputFieldve' : {
                            'type' : 'checkbox',
                            'name' : 'Responsive',
                            'action' : 'custom',
                            'value' : '1',
                            get_value: function (pgel) {
                                if (pgel.parent.isSelector('div.table-responsive')) return '1';
                                return null;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                crsaWillChangeDom();
                                var pgp = pgel.parent;
                                if (value) {
                                    if (!pgp.isSelector('div.table-responsive')) {
                                        if (pgp.tagName == 'div' && false) {
                                            //pgp.
                                            pgp.addClass('table-responsive');
                                        } else {
                                            //var $div = $('<div/>', {'class' : 'table-responsive'});
                                            var pgdiv = pgCreateNodeFromHtml('<div class="table-responsive"></div>');
                                            pgel.replaceWith(pgdiv, true);
                                            pgdiv.append(pgel);
                                            //$el.replaceWith($div);
                                            //$div.append($el);
                                        }
                                    }
                                } else {
                                    if (pgp.isSelector('div.table-responsive')) {
                                        if (pgp.children.length > 1) {
                                            pgp.removeClass('table-responsive');
                                        } else {
                                            pgel.detach();
                                            pgp.replaceWith(pgel);
                                        }
                                    }
                                }
                                // $.fn.crsa("setNeedsUpdate", false, $el);
                            }
                        }
                    }
                }
            })
        }
        f.addComponentType(table);

        var table_head = {
            'type' : 'thead',
            'selector' : 'thead',
            parent_selector: 'table',
            'code' : '<thead><tr><td></td></tr></thead>',
            preview: getTablePreviewCode('thead'),
            'name' : 'Table heading',
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(table_head);

        var table_body = {
            'type' : 'tbody',
            'selector' : 'tbody',
            parent_selector: 'table',
            'code' : '<tbody><tr><td></td></tr></tbody>',
            preview: getTablePreviewCode('tbody'),
            'name' : 'Table body',
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(table_body);

        var tableContext = {
            'type' : 'select',
            'name' : 'Context',
            'action' : 'apply_class',
            show_empty: true,
            'options' : [
                {
                    'key' : 'info',
                    'name' : 'Info'
                },
                {
                    'key' : 'active',
                    'name' : 'Active'
                },
                {
                    'key' : 'success',
                    'name' : 'Success'
                },
                {
                    'key' : 'warning',
                    'name' : 'Warning'
                },
                {
                    'key' : 'danger',
                    'name' : 'Danger'
                }
            ]
        };

        var table_row = {
            'type' : 'tr',
            'selector' : 'tr',
            parent_selector: 'table,tbody,thead,tfooter',
            'code' : '<tr><td></td></tr>',
            preview: getTablePreviewCode('tr'),
            'name' : 'Table row',
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        'context' : tableContext
                    }
                }
            })
        }
        f.addComponentType(table_row);

        var table_cell = {
            'type' : 'td',
            'selector' : 'td',
            parent_selector: 'tr',
            'code' : '<td></td>',
            preview: getTablePreviewCode('td'),
            'name' : 'Table cell',
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        'context' : tableContext
                    }
                }
            })
        }
        f.addComponentType(table_cell);


        var restructureForm = function (pgel, values) {
            var horiz = pgel.isSelector('.form-horizontal');
            var pggroups = pgel.find('>div.form-group,>button,>div>button,>div.checkbox,fieldset>div,fieldset>button');
            var col1 = values[prefix + 'horizontal-col1'] || 2;
            var col2 = values[prefix + 'horizontal-col2'] || 10;

            var pglabel = pgel.find('label');
            for (var i = 0; i < pglabel.length; i++) {
                pglabel[i].addClass('control-label');
            }

            for (var i = 0; i < pggroups.length; i++) {
                var pggroup = pggroups[i];

                if (!pggroup.isSelector('.form-group') && !pggroup.closest('.form-group')) {
                    if (horiz) {
                        var pgdiv = pgCreateNodeFromHtml('<div class="form-group"></div>');
                        pggroup.replaceWith(pgdiv, true);
                        pgdiv.append(pggroup);
                        pggroup = pgdiv;
                        // $group = $(pgdiv.get(0).el);
                    }
                }
                var pgelms = pggroup.children;
                var pgch = [];
                for (var j = 0; j < pgelms.length; j++) {
                    var pgelm = pgelms[j];
                    if (pgelm.tagName != "text") pgch.push(pgelm);
                }
                if (pgch.length >= 2) {
                    var pglab = pgch[0];
                    var pgfield = pgch[1];

                    var cls = pglab.getAttr('class');
                    if (cls) pglab.setAttr('class', cls.replace(/col-[a-z][a-z]-[0-9]*/ig, ''));

                    cls = pgfield.getAttr('class');
                    var field_has_cols = cls && cls.match(/col-[a-z][a-z]-[0-9]*/ig) != null;
                    if (cls && field_has_cols) pgfield.setAttr('class', cls.replace(/col-[a-z][a-z]-[0-9]*/ig, ''));

                    if(horiz) {
                        pglab.addClass('col-sm-' + col1);
                        if (!pgfield.tagName == 'div' || !field_has_cols) {
                            /*var $div = $('<div/>');
                            field.replaceWith($div);
                            $div.append(field);
                            field = $div;
                            */
                            var pgdiv = pgCreateNodeFromHtml('<div></div>');
                            pgfield.replaceWith(pgdiv, true);
                            pgdiv.append(pgfield);
                            pgfield = pgdiv;
                            // field = $(pgfield.get(0).el);
                        }
                        pgfield.addClass('col-sm-' + col2);
                        if (pgch.length > 2) {
                            for (var n = 2; n < pgch.length; n++) {
                                //$($ch.get(n)).appendTo(field);
                                pgfield.append(pgch[n]);
                            }
                        }
                    }
                } else if (pgch.length == 1) {
                    var pgfield = pgch[0];

                    cls = pgfield.getAttr('class');
                    var field_has_cols = cls && cls.match(/col-[a-z][a-z]-[a-z\-0-9]*/ig) != null;
                    if (cls && field_has_cols) pgfield.setAttr('class', cls.replace(/col-[a-z][a-z]-[a-z\-0-9]*/ig, ''));

                    if(horiz) {
                        if (!pgfield.tagName == 'div' || !field_has_cols) {
                            /*var $div = $('<div/>');
                            field.replaceWith($div);
                            $div.append(field);
                            field = $div;*/

                            var pgdiv = pgCreateNodeFromHtml('<div></div>');
                            pgfield.replaceWith(pgdiv, true);
                            pgdiv.append(pgfield);
                            pgfield = pgdiv;
                            // field = $(pgfield.get(0).el);
                        }

                        pgfield.addClass('col-sm-offset-' + col1);
                        pgfield.addClass('col-sm-' + col2);
                    }
                }
            }

            if (pgel.isSelector('.form-inline, .navbar-form')) {
                var pglabel1 = pgel.find('label');
                for (var i = 0; i < pglabel1.length; i++) {
                    pglabel1[i].addClass('sr-only');
                }

                var pglabel2 = pgel.find('div.checkbox >label');
                for (var i = 0; i < pglabel2.length; i++) {
                    pglabel2[i].removeClass('sr-only');
                }
            } else {
                var pglabel = pgel.find('label');
                for (var i = 0; i < pglabel.length; i++) {
                    pglabel[i].removeClass('sr-only');
                }
            }

        }

        var spanOptions = [];
        for(var n = 1; n <= num_columns; n++) spanOptions.push({key: n, name: n});

        //forms
        var form = {
            'type' : 'form',
            tags: 'major',
            'selector' : 'form',
            'code' : '<form role="form">\
        <div class="form-group">\
    <label class="control-label" for="exampleInputEmail1">Email address</label>\
    <input type="email" class="form-control" id="exampleInputEmail1" placeholder="Enter email">\
    </div>\
        <div class="form-group">\
            <label class="control-label" for="exampleInputPassword1">Password</label>\
            <input type="password" class="form-control" id="exampleInputPassword1" placeholder="Password">\
            </div>\
            <div class="form-group">\
                <label class="control-label" for="exampleInputFile">File input</label>\
                <input type="file" id="exampleInputFile">\
                    <p class="help-block">Example block-level help text here.</p>\
                </div>\
                <div class="checkbox">\
                    <label class="control-label" >\
                        <input type="checkbox"> Check me out\
                        </label>\
                    </div>\
                    <button type="submit" class="btn">Submit</button>\
                </form>',
            'name' : 'Form',
            action_menu: {
                add: ['form-group', 'form-textarea-group', 'form-select-group', 'form-checkbox-group', 'form-radio-group', 'form-static-group', 'form-fieldset'],
                on_add : function (pgel, pgnew, newdef, prepend) {
                    var values = getValuesForObject(pgel);

                    if (prepend) {
                        pgel.prepend(pgnew);
                    } else {
                        pgel.append(pgnew);
                    }
                    restructureForm(pgel, values);
                }
            },
            on_child_inserted : function (pgp, pgel, cp) {
                var values = getValuesForObject(pgp);
                restructureForm(pgp, values);
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'layout' : {
                    name : 'Style',
                    fields : {
                        'layout' : {
                            'type' : 'select',
                            'name' : 'Layout',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'action' : 'custom',
                            'options' : [
                                {key: 'form-normal', name: 'Normal'},
                                {key: 'form-inline', name: 'Inline'},
                                {key: 'form-horizontal', name: 'Horizontal'},
                                {key: 'navbar-form', name: 'Navbar'}
                            ],
                            get_value: function (pgel) {
                                if (pgel.isSelector('.form-horizontal')) return 'form-horizontal';
                                if (pgel.isSelector('.form-inline')) return 'form-inline';
                                if (pgel.isSelector('.navbar-form')) return 'navbar-form';
                                if (pgel.isSelector('.form-normal')) return 'form-normal';
                                return '';
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                pgel.removeClass('form-horizontal');
                                pgel.removeClass('form-inline');
                                pgel.removeClass('form-normal');
                                pgel.removeClass('navbar-form');
                                pgel.addClass(value);

                                restructureForm(pgel, values);
                                return value;
                            }
                        }
                    }
                },
                'horizontal' : {
                    name : 'Horizontal',
                    fields : {
                        'horizontal-col1' : {
                            'type' : 'select',
                            'name' : 'Label span',
                            'options' : spanOptions,
                            'show_empty' : true,
                            'action' : 'custom',
                            get_value: function (pgel) {
                                if (!pgel.hasClass('form-horizontal')) return null;

                                var val = null;
                                var pglabel = pgel.find('label');

                                for (var i = 0; i < pglabel.length; i++) {
                                    var pge = pglabel[i]
                                    var cls = pge.getAttr('class');
                                    if (cls) {
                                        var m = cls.match(/col-[a-z][a-z]-([0-9]*)/i);
                                        if (m) {
                                            val = parseInt(m[1]);
                                            break;
                                            // return false;
                                        }
                                    }
                                }

                                if (val === null) {
                                    var pgdiv = pgel.find('div');

                                    for (var i = 0; i < pgdiv.length; i++) {
                                        var pge = pgdiv[i];
                                        var cls = pge.getAttr('class');
                                        if (cls) {
                                            var m = cls.match(/col-[a-z][a-z]-offset-([0-9]*)/i);
                                            if (m) {
                                                val = parseInt(m[1]);
                                                break;
                                                // return false;
                                            }
                                        }
                                    }
                                }

                                if (val === null) val = pgel.data['crsa-form-col1'];
                                return val;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                crsaWillChangeDom();

                                setTimeout(function() {
                                    restructureForm(pgel, values);
                                    // $.fn.crsa("setNeedsUpdate", true, $el);
                                }, 100);
                                pgel.data['crsa-form-col1'] = value;
                                return value;
                            }
                        },
                        'horizontal-col2' : {
                            'type' : 'select',
                            'name' : 'Field span',
                            'options' : spanOptions,
                            'show_empty' : true,
                            'action' : 'custom',
                            get_value: function (pgel) {
                                if (!pgel.hasClass('form-horizontal')) return null;

                                var val = null;
                                var pgin = pgel.find('input,textarea,div.checkbox,button');

                                for (var i = 0; i < pgin.length; i++) {
                                    var pge = pgin[i].parent;
                                    var cls = pge.getAttr('class');
                                    if (cls) {
                                        var m = cls.match(/col-[a-z][a-z]-([0-9]*)/i);
                                        if (m) {
                                            val = parseInt(m[1]);
                                            break;
                                            // return false;
                                        }
                                    }
                                }
                                if (val === null) val = pgel.data['crsa-form-col2'];
                                return val;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                crsaWillChangeDom();

                                setTimeout(function() {
                                    restructureForm(pgel, values);
                                    // $.fn.crsa("setNeedsUpdate", true, $el);
                                }, 100);

                                pgel.data['crsa-form-col2'] = value;
                                return value;
                            }
                        }
                    }
                }
            })
        }
        f.addComponentType(form);




        var form_group = {
            'type' : 'form-group',
            'selector' : 'div.form-group',
            parent_selector: 'form,fieldset',
            'code' : function(env) {
                var id = getUniqueId('formInput');
                return '<div class="form-group">\
        <label class="control-label" for="' + id + '">Field label</label>\
<input type="text" class="form-control" id="' + id + '" placeholder="Placeholder text">\
</div>'
            },
            'name' : 'Form group',
            action_menu: {
                add: ['form-static', 'form-input', 'textarea', 'form-checkbox','form-radio', 'label',  'form-help', 'form-select']
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'data' : {
                    name : 'Group options',
                    fields : {
                        'validation' : {
                            'type' : 'select',
                            'name' : 'Validation state',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'options' : [
                                {key: 'has-success', name: 'Success'},
                                {key: 'has-warning', name: 'Warning'},
                                {key: 'has-error', name: 'Error'}
                            ]
                        },
                        'feedback' : {
                            'type' : 'checkbox',
                            'name' : 'Feedback icon',
                            value : '1',
                            'action' : 'custom',
                            get_value: function (pgel) {
                                var val = (pgel.hasClass('has-feedback') && pgel.find('.form-control-feedback').length > 0) ? '1' : null;
                                return val;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                crsaWillChangeDom();
                                if (value) {
                                    pgel.addClass('has-feedback');
                                    var code = '<span class="glyphicon glyphicon-ok form-control-feedback"></span>';
                                    if (pgel.data['crsa-old-feedback']) {
                                        code = pgel.data['crsa-old-feedback'];
                                    }
                                    pgel.append(pgCreateNodeFromHtml(code));
                                } else {
                                    var pgold = pgel.findOne('.form-control-feedback');
                                    if (pgold) {
                                        pgel.data['crsa-old-feedback'] = pgold.getViewHtml();
                                        pgold.remove();
                                    }
                                    pgel.removeClass('has-feedback');
                                }
                                // pinegrow.setNeedsUpdate($el);
                                return value;
                            }
                        }
                    }
                }
            })
        }
        f.addComponentType(form_group);



        var form_ta_group = {
            'type' : 'form-textarea-group',
            'selector' : null,
            parent_selector: 'form,fieldset',
            'code' : function(env) {
                var id = getUniqueId('formInput');
                return '<div class="form-group">\
        <label class="control-label" for="' + id + '">Field label</label>\
        <textarea class="form-control" rows="3" id="' + id + '"></textarea>\
</div>'
            },
            'name' : 'Textarea group',
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(form_ta_group);


        var disabled = {
            type: 'checkbox',
            action: 'element_attribute',
            attribute: 'disabled',
            name: 'Disabled',
            value: 'disabled'
        };

        var readonly = {
            type: 'checkbox',
            action: 'element_attribute',
            attribute: 'readonly',
            name: 'ReadOnly',
            value: 'readonly'
        }

        var required = {
            type: 'checkbox',
            action: 'element_attribute',
            attribute: 'required',
            name: 'Required',
            value: 'required',
            empty_attribute: true
        };

        var control_sizing = {
            'type' : 'select',
            'name' : 'Size',
            'action' : 'apply_class',
            'show_empty' : true,
            'options' : [
                {key: 'input-sm', name: 'Small'},
                {key: '', name: 'Default'},
                {key: 'input-lg', name: 'Large'}
            ]
        };


        var form_input = {
            'type' : 'form-input',
            'selector' : function(pgel) {
                if(pgel.tagName == 'input' && pgel.getAttribute('type') != 'checkbox') return true;
                //if($el.is('div.form-group')) return true;
                return false;
            },
            'code' : '<input type="text" class="form-control" placeholder="Placeholder text">',
            'name' : 'Input',
            'sections' : gh.addPrefixToSectionsAndFields({
                'data' : {
                    name : 'Input options',
                    fields : {
                        'type' : {
                            'type' : 'select',
                            'name' : 'Type',
                            'action' : 'custom',
                            'options' : [
                                {key: 'text', name: 'Text'},
                                {key: 'password', name: 'Password'},
                                {key: 'number', name: 'Number'},
                                {key: 'email', name: 'Email'},
                                {key: 'file', name: 'File'},
                                {key: 'url', name: 'Url'},
                                {key: 'search', name: 'Search'},
                                {key: 'tel', name: 'Tel'},
                                {key: 'color', name: 'Color'},
                                {key: 'datetime', name: 'Datetime'},
                                {key: 'datetime-local', name: 'Datetime local'},
                                {key: 'date', name: 'Date'},
                                {key: 'month', name: 'Month'},
                                {key: 'time', name: 'Time'},
                                {key: 'week', name: 'Week'}
                            ],
                            get_value: function (pgel) {
                                return pgel.getAttr('type');
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                pgel.setAttr('type', value);
                                return value;
                            }
                        },
                        value: {
                            type: 'text',
                            name: 'Value',
                            action: 'custom',
                            attribute: 'value',
                            get_value: function (pgel) {
                                return pgel.getAttr('value');
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                pgel.setAttr('value', value);
                                return value;
                            }
                        },
                        placeholder: {
                            type: 'text',
                            name: 'Placeholder',
                            action: 'element_attribute',
                            attribute: 'placeholder'
                        },
                        'control-size' : control_sizing,
                        disabled: disabled,
                        readonly: readonly,
                        required: required
                    }
                }
            })
        }
        f.addComponentType(form_input);





        var form_textarea = {
            'type' : 'textarea',
            'selector' : 'textarea',
            'code' : '<textarea class="form-control" rows="3"></textarea>',
            'name' : 'Textarea',
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        'rows' : {
                            'type' : 'text',
                            'name' : 'Rows',
                            'action' : 'element_attribute',
                            'attribute' : 'rows'
                        },
                        'control-size' : control_sizing,
                        readonly: readonly,
                        disabled: disabled
                    }
                }
            })
        }
        f.addComponentType(form_textarea);


        var form_checkbox_group = {
            'type' : 'form-checkbox-group',
            selector: '.checkbox',
       /*     'selector' : function($el) {
                if($el.is('div.checkbox') || $el.children('label.checkbox').length > 0) return true;
                return false;
            },*/
            parent_selector: 'form,fieldset',
            'code' : '<div class="checkbox">\
        <label class="control-label">\
        <input type="checkbox" value="">\
        Option one is this and that&mdash;be sure to include why it\'s great\
        </label>\
        </div>',
            'name' : 'Checkbox group',
            action_menu: {
                add: ['form-checkbox','label', 'form-help']
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        'rows' : {
                            'type' : 'checkbox',
                            'name' : 'Inline',
                            'action' : 'custom',
                            'value' : '1',
                            get_value: function (pgel) {
                                var pglabel = pgel.findOne('>label');
                                return pglabel.hasClass('checkbox-inline') ? "1" : null;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pglabel = pgel.find('>label');

                                if (value) {
                                    pglabel.addClass('checkbox-inline');
                                    pgel.removeClass('checkbox');
                                } else {
                                    pglabel.removeClass('checkbox-inline');
                                    pgel.addClass('checkbox');
                                }
                                return value;
                            }
                        }
                    }
                }
            })
        }
        f.addComponentType(form_checkbox_group);

        var form_checkbox = {
            'type' : 'form-checkbox',
            'selector' : function(pgel) {
                if(pgel.tagName == 'label' && pgel.find('>input[type="checkbox"]').length > 0) return true;
                return false;
            },
            'code' : '<label>\
        <input class="control-label" type="checkbox" value="">\
        Checkbox label\
        </label>',
            'name' : 'Checkbox',
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        'disabled' : {
                            'type' : 'checkbox',
                            'name' : 'Disabled',
                            'action' : 'custom',
                            'value' : '1',
                            get_value: function (pgel) {
                                var pginput = pgel.findOne('input[type="checkbox"]');
                                return pginput.getAttr("disabled") ? "1" : null;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pginput = pgel.findOne('input[type="checkbox"]');
                                pginput.setAttr('disabled', value);
                                return value;
                            }
                        },
                        'inline': {
                            type: 'checkbox',
                            name: 'Inline',
                            action: 'apply_class',
                            value: 'checkbox-inline'
                        }
                    }
                }
            })
        }
        f.addComponentType(form_checkbox);


        var form_radio_group = {
            'type' : 'form-radio-group',
            selector: '.radio',
       /*     'selector' : function($el) {
                if($el.is('div.radio') || $el.children('label.radio').length > 0) return true;
                return false;
            },*/
            parent_selector: 'form,fieldset',
            'code' : '<div class="radio">\
        <label class="control-label">\
        <input type="radio" name="group" value="option1" checked>\
        Option one\
        </label>\
        </div>',
            'name' : 'Radio group',
            action_menu: {
                add: ['form-radio','label', 'form-help']
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        'group' : {
                            'type' : 'text',
                            'name' : 'name',
                            'action' : 'custom',
                            get_value: function (pgel) {
                                var pginput = pgel.findOne('input[type="radio"]');
                                return pginput.getAttr('name');
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pginput = pgel.findOne('input[type="radio"]');
                                pginput.setAttr('name', value);
                                return value;
                            }
                        },
                        'rows' : {
                            'type' : 'checkbox',
                            'name' : 'Inline',
                            'action' : 'custom',
                            'value' : '1',
                            get_value: function (pgel) {
                                var pginput = pgel.findOne('>label');
                                return pginput.hasClass('radio-inline') ? "1" : null;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pginput = pgel.findOne('>label');
                                if (value) {
                                    pginput.addClass('radio-inline');
                                    pgel.removeClass('radio');
                                } else {
                                    pginput.removeClass('radio-inline');
                                    pgel.addClass('radio');
                                }
                                return value;
                            }
                        }
                    }
                }
            })
        }
        f.addComponentType(form_radio_group);

        var form_radio = {
            'type' : 'form-radio',
            'selector' : function(pgel) {
                if(pgel.tagName == 'label' && pgel.find('>input[type="radio"]').length > 0) return true;
                return false;
            },
            'code' : '<label class="control-label">\
        <input type="radio" name="group" value="option1" checked>\
        Option one\
        </label>',
            'name' : 'Radio',
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        'disabled' : {
                            'type' : 'checkbox',
                            'name' : 'Disabled',
                            'action' : 'custom',
                            'value' : '1',
                            get_value: function (pgel) {
                                var pginput = pgel.findOne('input[type="radio"]');
                                return pginput.getAttr("disabled") ? "1" : null;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pginput = pgel.findOne('input[type="radio"]');
                                pginput.setAttr('disabled', value);
                                return value;
                            }
                        },
                        'inline': {
                            type: 'checkbox',
                            name: 'Inline',
                            action: 'apply_class',
                            value: 'radio-inline'
                        }
                    }
                }
            })
        }
        f.addComponentType(form_radio);




        var form_select_group = {
            'type' : 'form-select-group',
            'selector' : null,
            parent_selector: 'form,fieldset',
            'code' : function(env) {
                var id = getUniqueId('formInput');
                return '<div class="form-group">\
        <label class="control-label" for="' + id + '">Field label</label>\
        <select id="' + id + '" class="form-control">\
            <option>1</option>\
            <option>2</option>\
            <option>3</option>\
        </select>\
</div>'
            },
            'name' : 'Select group',
            action_menu: {
                add: ['form-select','label', 'form-help']
            },
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(form_select_group);


        var form_select = {
            'type' : 'form-select',
            'selector' : 'select',
            'code' : '<select class="form-control">\
            <option>1</option>\
            <option>2</option>\
            <option>3</option>\
        </select>',
            'name' : 'Select',
            action_menu: {
                add: ['form-option']
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        'multiple' : {
                            'type' : 'checkbox',
                            'name' : 'Multiple',
                            'action' : 'element_attribute',
                            'attribute' : 'multiple',
                            'value' : 'multiple',
                            'attribute_without_value' : true
                        },
                        'control-size' : control_sizing,
                        disabled: disabled
                    }
                }
            })
        }
        f.addComponentType(form_select);

        var form_option = {
            'type' : 'form-option',
            'selector' : 'option',
            'code' : '<option value="value">Name</option>',
            preview: 'none',
            'name' : 'Select option',
            'sections' : gh.addPrefixToSectionsAndFields({
                'data' : {
                    name : 'Data',
                    fields : {
                        'value' : {
                            'type' : 'text',
                            'name' : 'Value',
                            'action' : 'element_attribute',
                            'attribute' : 'value'
                        },
                        'name' : {
                            'type' : 'text',
                            'name' : 'Name',
                            'action' : 'element_html'
                        }
                    }
                }
            })
        }
        f.addComponentType(form_option);


        var form_static_group = {
            'type' : 'form-static-group',
            'selector' : null,
            parent_selector: 'form,fieldset',
            'code' : '<div class="form-group">\
        <label class="control-label">Email</label>\
        <p class="form-control-static">email@example.com</p>\
    </div>',
            'name' : 'Static group',
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(form_static_group);


        var form_static = {
            'type' : 'form-static',
            'selector' : 'p.form-control-static',
            'code' : '<p class="form-control-static">email@example.com</p>',
            'name' : 'Static field',
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(form_static);


        var form_label = {
            'type' : 'label',
            'selector' : 'label',
            'code' : '<label class="control-label">Email address</label>',
            'name' : 'Form label',
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Label options',
                    fields : {
                        'for_id' : {
                            'type' : 'text',
                            'name' : 'For field id',
                            'action' : 'element_attribute',
                            'attribute' : 'for'
                        }
                    }
                }
            })
        }
        f.addComponentType(form_label);



        var form_fieldset = {
            'type' : 'form-fieldset',
            'selector' : 'fieldset',
            parent_selector: 'form',
            'code' : '<fieldset></fieldset>',
            'name' : 'Fieldset',
            action_menu: {
                add: ['form-group', 'form-textarea-group', 'form-select-group', 'form-checkbox-group', 'form-radio-group', 'form-static-group']
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        disabled: disabled
                    }
                }
            })
        }
        f.addComponentType(form_fieldset);


        var form_help = {
            'type' : 'form-help',
            'selector' : 'span.help-block',
            'code' : '<span class="help-block">A block of help text.</span>',
            'name' : 'Help text',
            'sections' : gh.addPrefixToSectionsAndFields({

            })
        }
        f.addComponentType(form_help);

        var igspan = {
            'type' : 'input-group-span',
            'selector' : null,
            'code' : '<span>Text</span>',
            'name' : 'Input group addon',
            'sections' : gh.addPrefixToSectionsAndFields({})
        }
        f.addComponentType(igspan);

        var form_naked_checkbox = {
            'type' : 'form-checkbox-naked',
            'selector' : null,
            'code' : '<input type="checkbox">',
            'name' : 'Checkbox',
            'sections' : gh.addPrefixToSectionsAndFields({

            })
        }
        f.addComponentType(form_naked_checkbox);

        var form_naked_radio = {
            'type' : 'form-radio-naked',
            'selector' : null,
            'code' : '<input type="radio">',
            'name' : 'Radio',
            'sections' : gh.addPrefixToSectionsAndFields({

            })
        }
        f.addComponentType(form_naked_radio);


        var form_input_group = {
            'type' : 'form-input-group',
            'selector' : 'div.input-group',
            priority: 100,
            'code' : '<div class="input-group">\
        <span class="input-group-addon">@</span>\
    <input type="text" class="form-control" placeholder="Username">\
    </div>',
            'name' : 'Input group',
            action_menu : {
                'add' : ['input-group-span'],
                'on_add' : function(pgel, pgnew, newdef, prepend) {
                    var spanCls = 'input-group-addon';
                    if (['form-checkbox-naked', 'form-radio-naked'].indexOf(newdef.type) >= 0) {
                        //$new = $('<span/>').append($new);
                        pgnew = pgCreateNodeFromHtml('<span></span>').append(pgnew);
                    } else if (['button-dropdown'].indexOf(newdef.type) >= 0) {
                        pgnew.addClass('input-group-btn').removeClass('btn-group');
                    }
                    if (pgnew.tagName == 'span') {
                        pgnew.addClass(spanCls);
                    }
                    if (prepend) {
                        pgel.prepend(pgnew);
                    } else {
                        pgel.prepend(pgnew);
                    }
                }
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Input group',
                    fields : {
                        size: {
                            name: 'Size',
                            type: 'select',
                            action: 'apply_class',
                            show_empty : true,
                            options: [
                                {key: 'input-group-lg', name: 'Large'},
                                {key: 'input-group-sm', name: 'Small'}
                            ]
                        }
                    }
                }
            })
        }
        f.addComponentType(form_input_group);



        //button


        var getButtonTypeToggleButton = function(type) {
            if(type == 'link') {
                return bm.makeColor(null, 'T', {
                    'text-decoration': 'underline'
                });
            } else {
                var text_color = type == 'default' ? '#333' : '#fff';
                return bm.makeColor(getBootstrapColor(type), '', {
                    'color': text_color
                });
            }
        }

        var getButtonSizeToggleButton = function(size) {
            return bm.makeText(size);

            var fs = 14;
            switch(size) {
                case 'lg':
                    fs = 16;
                    break;
                case 'default':
                    fs = 14;
                    break;
                case 'sm':
                    fs = 12;
                    break;
                case 'xs':
                    fs = 10;
                    break;
            }
            return '<div style="color:#fff;font-weight:bold;font-size:' + fs + 'px;padding: 2px 16px;border-radius: 4px;background-color:#4D4D4D;">' + size + '</div>';
        }

        var button = {
            'type' : 'bs-button',
            'selector' : '.btn',
            'name' : 'Button',
            'code' : '<button type="button" class="btn btn-default">Label</button>',
            'content_selector' : null,
            'drag_code' : null, //same as panel code
            'allowed_in' : null, //everywhere
            'sections' : gh.addPrefixToSectionsAndFields({
                'button' : {
                    name : 'Button options',
                    default_closed: false,
                    fields : {
                        btlabel : {
                            type: 'text',
                            name: 'Label',
                            action: 'element_html',
                            update_tree: true
                        },
                        'bsbuttonhref' : {name : 'Href (if a)', type : 'text', action: 'element_attribute', attribute: 'href', file_picker: true, file_picker_no_proxy : true, show_if: 'bs_button_tag==a'},
                        'bsbuttontarget' : {name : 'Target (if a)', type : 'text', action: 'element_attribute', attribute: 'target', show_if: 'bs_button_tag==a'},
                        bs_button_tag : {
                            'type' : 'select',
                            'name' : 'Element',
                            'action' : 'custom',
                            toggle_buttons: true,
                            'options' : [
                                {
                                    'key' : 'a',
                                    'name' : 'Link - a tag',
                                    html: bm.makeText('&lt;a&gt;')
                                },
                                {
                                    'key' : 'button',
                                    'name' : 'Button - button tag',
                                    html: bm.makeText('&lt;button&gt;')
                                }
                            ],
                            show_empty: false,
                            get_value: function(pgel) {
                                return pgel.tagName == 'button' ? 'button' : 'a';
                            },
                            set_value: function(pgel, value, values, oldValue, eventType) {
                                var tag = value;
                                pgel = pgel.replaceTag(tag);

                                if(value == 'a') {
                                    pgel.removeAttr('type');
                                    pgel.attr('href', pgel.getData('remember-href') || '#');
                                } else {
                                    pgel.attr('type', 'button');
                                    pgel.setData('remember-href', pgel.attr('href'));
                                    pgel.removeAttr('href');
                                }
                                return value;
                            }
                        },
                        'button-type' : {
                            'type' : 'select',
                            'name' : 'Type',
                            'action' : 'apply_class',
                            show_empty: true,
                            toggle_buttons: true,
                            'options' : [
                                {
                                    'key' : 'btn-default',
                                    'name' : 'Default',
                                    html: getButtonTypeToggleButton('default')
                                },
                                {
                                    'key' : 'btn-primary',
                                    'name' : 'Primary',
                                    html: getButtonTypeToggleButton('primary')
                                },
                                {
                                    'key' : 'btn-info',
                                    'name' : 'Info',
                                    html: getButtonTypeToggleButton('info')
                                },
                                {
                                    'key' : 'btn-success',
                                    'name' : 'Success',
                                    html: getButtonTypeToggleButton('success')
                                },
                                {
                                    'key' : 'btn-warning',
                                    'name' : 'Warning',
                                    html: getButtonTypeToggleButton('warning')
                                },
                                {
                                    'key' : 'btn-danger',
                                    'name' : 'Danger',
                                    html: getButtonTypeToggleButton('danger')
                                },
                                /*     {
                                 'key' : 'btn-inverse',
                                 'name' : 'Inverse'
                                 },*/
                                {
                                    'key' : 'btn-link',
                                    'name' : 'Link',
                                    html: getButtonTypeToggleButton('link')
                                }
                            ]
                        },
                        bs_button_size : {
                            'type' : 'select',
                            'name' : 'Size',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            toggle_buttons: true,
                            'options' : [
                              /*  {
                                    'key' : '',
                                    'name' : 'Default',
                                    html: getButtonSizeToggleButton('default')
                                },*/
                                {
                                    'key' : 'btn-lg',
                                    'name' : 'Large',
                                    html: getButtonSizeToggleButton('lg')
                                },
                                {
                                    'key' : 'btn-sm',
                                    'name' : 'Small',
                                    html: getButtonSizeToggleButton('sm')
                                },
                                {
                                    'key' : 'btn-xs',
                                    'name' : 'Extra small',
                                    html: getButtonSizeToggleButton('xs')
                                }
                            ]
                        },
                        block : {
                            type: 'checkbox',
                            name: 'Block level',
                            action: 'apply_class',
                            value: 'btn-block'
                        },
                        active : {
                            type: 'checkbox',
                            name: 'Active',
                            action: 'apply_class',
                            value: 'active'
                        },
                        disabled: {
                            type: 'checkbox',
                            name: 'Disabled',
                            action: 'custom',
                            value: '1',
                            get_value: function(pgel) {
                                return (pgel.attr('disabled') != null || pgel.hasClass('disabled')) ? '1' : null;
                            },
                            set_value: function(pgel, value, values, oldValue, eventType) {
                                if(pgel.tagName == 'button') {
                                    if(value) {
                                        pgel.attr('disabled', 'disabled');
                                    } else {
                                        pgel.removeAttr('disabled');
                                    }
                                } else {
                                    if(value) {
                                        pgel.addClass('disabled');
                                    } else {
                                        pgel.removeClass('disabled');
                                    }
                                }
                                return value;
                            }
                        }
                    }
                },
                css : {
                    //inherit this from html framework
                    inherit: true
                },
                bstooltip : bsTooltipsSection,
                bspopover : bsPopoverSection
            })
        };

        f.addComponentType(button);


        var dropdown_menu = {
            'type' : 'dropdown-menu',
            'selector' : 'ul.dropdown-menu',
            'code' : '<ul class="dropdown-menu" role="menu">\
    <li><a href="#">Action</a></li>\
    <li><a href="#">Another action</a></li>\
    <li><a href="#">Something else here</a></li>\
<li class="divider"></li>\
    <li><a href="#">Separated link</a></li>\
</ul>',
            'name' : 'Dropdown menu',
            tags: 'major',
            'action_menu' : {
                'add' : ['button-dropdown-item']
            },
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(dropdown_menu);


        var button_dropdown = {
            'type' : 'button-dropdown',
            'selector' : function(pgel) {
                if(pgel.hasClass('btn-group') && pgel.find('>.dropdown-menu').length > 0) return true;
                return false;
            },
            'code' : '<div class="btn-group">\
        <button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown">\
    Action <span class="caret"></span>\
</button>\
    <ul class="dropdown-menu" role="menu">\
    <li><a href="#">Action</a></li>\
    <li><a href="#">Another action</a></li>\
    <li><a href="#">Something else here</a></li>\
<li class="divider"></li>\
    <li><a href="#">Separated link</a></li>\
</ul>\
    </div>',
            'name' : 'Button dropdown',
            tags: 'major',
            'action_menu' : {
                'add' : ['button-dropdown-item'],
                'on_add' : function(pgel, pgnew, newdef, prepend) {
                    var pgul = pgel.find('> ul.dropdown-menu');
                    if (pgul.length == 0) {
                        pgul = pgCreateNodeFromHtml('<ul class="dropdown-menu" role="menu"></ul>');
                        pgel.append(pgul);
                    }
                    else {
                        pgul = pgul[0];
                    }

                    if (prepend) {
                        pgul.prepend(pgnew);
                    } else {
                        pgul.append(pgnew);
                    }
                }
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'variation' : {
                    name : 'Variations',
                    fields : {
                        dropup : {
                            name : "Dropup",
                            type : "checkbox",
                            value: 'dropup',
                            action: 'apply_class'
                        }
                    }
                }
            })
        }
        f.addComponentType(button_dropdown);

        var dropdown_classes = [
            {key: 'dropdown-header', name: 'Header'},
            {key: 'divider', name: 'Divider'},
            {key: 'disabled', name: 'Disabled'}
        ];

        var button_dropdown_item = {
            'type' : 'button-dropdown-item',
            'selector' : function(pgel) {
                return pgel.tagName == 'li' && pgel.parent && pgel.parent.hasClass('dropdown-menu');
            },
            parent_selector: 'ul.dropdown-menu',
            'code' : '<li role="presentation"><a role="menuitem" tabindex="-1" href="#">Action</a></li>',
            'name' : 'Button dropdown item',
            'sections' : gh.addPrefixToSectionsAndFields({
                'variation' : {
                    name : 'Dropdown item',
                    fields : {
                        type : {
                            name : "Type",
                            type : "select",
                            options : dropdown_classes,
                            show_empty: true,
                            action: 'custom',
                            get_value: function (pgel) {
                                var val = null;
                                $.each(dropdown_classes, function(i, c) {
                                    if(pgel.hasClass(c.key)) {
                                        val = c.key;
                                        return false;
                                    }
                                });
                                return val;
                            },
                            set_value: function (pgel, value, values) {
                                var pga = pgel.find('> a');
                                var need_a = value != 'dropdown-header' && value != 'divider';
                                var text = pga.length == 0 ? pgel.html() : pga[0].html();
                                if (need_a) {
                                    if (!text) text = 'Action';
                                    if (pga.length == 0) {
                                        pgel.html('');
                                        pga = pgCreateNodeFromHtml('<a role="menuitem" tabindex="-1" href="#">Action</a>');
                                        pgel.append(pga);
                                        // $a = $(pga.get(0).el);
                                    }
                                    pga[0].html(text);
                                } else {
                                    pga[0].remove();
                                    pgel.html(text);
                                }

                                $.each(dropdown_classes, function(i,c) {
                                    if(pgel.hasClass(c.key)) {
                                        pgel.removeClass(c.key);
                                    }
                                });
                                pgel.addClass(value);
                                // $.fn.crsa('setNeedsUpdate', false, $el);
                                return value;
                            }
                        },
                        label : {
                            name : "Label",
                            type : "text",
                            action: 'custom',
                            get_value: function (pgel) {
                                var pga = pgel.find('>a');
                                if (pga.length > 0) pgel = pga[0];
                                return pgel.html();
                            },
                            set_value: function (pgel, value, values) {
                                var pga = pgel.find('>a');
                                // if (pga.length > 0) pgel = pga[0];

                                for (var i = 0; i < pga.length; i++) {
                                    pga[i].html(value);
                                }

                                return value;
                            }
                        }
                    }
                }
            })
        }
        f.addComponentType(button_dropdown_item);


        var button_group_size = {
            type: 'select',
            action: 'apply_class',
            show_empty: true,
            name: 'Size',
            options: [
                {key: 'btn-group-lg', name: "Large"},
                {key: 'btn-group-sm', name: "Small"},
                {key: 'btn-group-xs', name: "Extra small"}
            ]
        }



        var button_group = {
            'type' : 'button-group',
            'selector' : 'div.btn-group, div.btn-group-vertical',
            'code' : '<div class="btn-group">\
        <button type="button" class="btn btn-default">Left</button>\
    <button type="button" class="btn btn-default">Middle</button>\
<button type="button" class="btn btn-default">Right</button>\
</div>',
            'name' : 'Button group',
            tags: 'major',
            'sections' : gh.addPrefixToSectionsAndFields({
                'buttons' : {
                    name : 'Buttons',
                    fields : {
                        size : button_group_size,
                        orientation : {
                            name: "Orientation",
                            show_empty: false,
                            type: 'select',
                            action: 'apply_class',
                            options: [
                                {key: 'btn-group', name: "Horizontal"},
                                {key: 'btn-group-vertical', name: "Vertical"}
                            ]
                        },
                        justified : {
                            name : "Justified",
                            type : "checkbox",
                            value: 'btn-group-justified',
                            action: 'apply_class',
                            tip: "Requires link(a tag) buttons"
                        },
                        bstoggle : bsDataToggle
                    }
                }
            })
        }
        f.addComponentType(button_group);


        var button_toolbar = {
            'type' : 'button-toolbar',
            'selector' : 'div.btn-toolbar',
            'code' : '<div class="btn-toolbar" role="toolbar">\
        <div class="btn-group">\
    <button type="button" class="btn btn-default">1</button>\
    <button type="button" class="btn btn-default">2</button>\
</div>\
    <div class="btn-group">\
        <button type="button" class="btn btn-default">8</button>\
    </div>\
</div>',
            'name' : 'Button toolbar',
            'sections' : gh.addPrefixToSectionsAndFields({

            })
        }
        f.addComponentType(button_toolbar);


        var image = {
            'type' : 'img',
            'selector' : 'img',
            'code' : function() {
                return '<img src="' + getPlaceholderImage() + '" width="200"/>'
            },
            'name' : 'Image',
            'sections' : gh.addPrefixToSectionsAndFields({
               /* attributes : {
                    inherit:true
                },*/
                'image' : {
                    position: 0,
                    name : 'Image',
                    fields : {
                        bsshape : {
                            'type' : 'select',
                            'name' : 'Shape',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'options' : [
                                {
                                    'key' : 'img-rounded',
                                    'name' : 'Rounded'
                                },
                                {
                                    'key' : 'img-circle',
                                    'name' : 'Circle'
                                },
                                {
                                    'key' : 'img-thumbnail',
                                    'name' : 'Thumbnail'
                                }
                            ]
                        },
                        bsresponsive : {
                            type: 'checkbox',
                            name: 'Responsive',
                            action: 'apply_class',
                            value: 'img-responsive'
                        }
                    }
                }
            })
        }
        f.addComponentType(image);


        var close_button = {
            'type' : 'button-close',
            'selector' : 'button.close',
            'code' : '<button type="button" class="close" aria-hidden="true">&times;</button>',
            'name' : 'Close button',
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(close_button);


        var caret = {
            'type' : 'caret',
            'selector' : 'span.caret',
            'code' : '<span class="caret"></span>',
            'name' : 'Caret',
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        }
        f.addComponentType(caret);


        //tabs and pills
        (function() {

            var list_item = {
                'type' : 'nav-list-item',
                'selector' : function(pgel) {
                    return pgel.tagName == 'li' && pgel.parent && pgel.parent.isSelector('.nav,.breadcrumb,.pagination');
                },
                parent_selector: 'ul,ol',
                'code' : '<li><a href="#">Title</a></li>',
                'name' : 'Nav item',
                priority: 100,
                'sections' : gh.addPrefixToSectionsAndFields({
                    'list' : {
                        name : 'Nav item',
                        fields : {
                            stacked : {
                                type: 'select',
                                name: 'State',
                                action: 'apply_class',
                                'show_empty' : true,
                                'options' : [
                                    {'key' : 'active', 'name' : 'Active'},
                                    {'key' : 'disabled', 'name' : 'Disabled'}
                                ]
                            },
                            bsdropdown : {
                                'type' : 'checkbox',
                                'name' : 'Dropdown',
                                'value' : '1',
                                'action' : 'custom',
                                get_value: function (pgel) {
                                    return pgel.hasClass('dropdown') ? '1' : null;
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    var pga = pgel.find('>a,>button');
                                    if (value) {
                                        pgel.addClass('dropdown');
                                        for (var i = 0; i < pga.length; i++) {
                                            pga[i][i].setAttr('data-toggle', 'dropdown');
                                            if (pga[i].find('b.caret').length == 0) {
                                                pga[i].html(pga[i].html() + ' <b class="caret"></b>');
                                            }
                                        }

                                        var pgdm = pgel.find('>.dropdown-menu');
                                        if (pgdm.length == 0) {
                                            pgdm = pgCreateNodeFromHtml('<ul class="dropdown-menu" role="menu" aria-labelledby="dLabel"></ul>');
                                            pgel.append(pgdm);
                                        }
                                        showJavascriptMessage();
                                    } else {
                                        pgel.removeClass('dropdown');
                                        for (var i = 0; i < pga.length; i++) {
                                            pga[i].html(pga[i].html().replace(/\s*<b class="caret"><\/b>/i,''));
                                            pga[i].removeAttr('data-toggle');
                                        }
                                    }
                                    // $.fn.crsa('setNeedsUpdate', false, $el);
                                    // $.fn.crsa('setSelectElementOnUpdate', $el);
                                    return value;
                                }
                            },
                            bsdatatarget : bsDataTarget,
                            bsdatatoggle : bsDataToggle
                        }
                    }
                })
            }
            f.addComponentType(list_item);



            var findTabsContentPanes = function(pgtabs) {
                var next = pgtabs.next();
                if (next && next.isSelector('.tab-content')) {
                    return next;
                }
                var pga = pgtabs.find('a');
                if (pga.length > 0) {
                    pga = pga[0];

                    if (pga.getAttr('data-toggle') == 'tab') {
                        var pgp = findTabPane(pga);
                        if (pgp && pgp.length > 0) {
                            pgp = pgp[0];
                            var pgdiv = pgp.parent;
                            if (pgdiv.isSelector('.tab-content')) return pgdiv;
                        }
                    }
                }
                return null;
            }

            var findTabSel = function(pga) {
                var sel = pga.getAttr('data-target');
                if (!sel) sel = pga.getAttr('href');
                if (sel) sel = sel.replace('#','');
                if (sel && sel.length == 0) sel = null;
                return sel;
            }

            var findTabPane = function(pga) {
                var sel = findTabSel(pga);
                if (!sel) return null;
                try {
                    var pgp = pga.closest('body').find(sel);
                    return pgp;
                }
                catch(err) {}
                return null;
            }

            var tag = {
                'type' : 'tabs',
                'selector' : 'ul.nav-tabs,ul.nav-pills',
                'code' : '<ul class="nav nav-tabs">\
            <li class="active"><a href="#">Home</a></li>\
        <li><a href="#">Profile</a></li>\
        <li><a href="#">Messages</a></li>\
    </ul>',
                'name' : 'Tabs',
                'action_menu' : {
                    'add' : ['nav-list-item', 'navbar-dropdown', 'bs-tab-pane'],
                    'on_add' : function(pgel, pgnew, newdef, prepend) {
                        var pgpanes = findTabsContentPanes(pgel);
                        if (pgnew.isSelector('.tab-pane')) {
                            if (!$panes) {
                                //$panes = $('<div class="tab-content"></div>').insertAfter($el);
                                pgpanes = pgCreateNodeFromHtml('<div class="tab-content"></div>').insertAfter(pgel);
                            }

                            if (prepend) {
                                pgpanes.prepend(pgnew);
                            } else {
                                pgpanes.append(pgnew);
                            }
                        } else {
                            if (pgnew.tagName != 'li') {
                                pgnew = pgCreateNodeFromHtml('<li></li>').append(pgnew).addClass('dropdown');
                            }

                            if (prepend) {
                                pgel.prepend(pgnew);
                            } else {
                                pgel.append(pgnew);
                            }
                        }

                        if (pgpanes && pgnew.tagName == 'li') {
                            var pga = pgnew.find('> a');
                            var sel = findTabSel(pga);
                            var pgp = findTabPane(pga);

                            if (!pgp || pgp.length == 0) {
                                if (!sel) {
                                    sel = getUniqueId('tab', null, 0);
                                    for (var i = 0; i < pga.length; i++) {
                                        pga[i].setAttr('href', '#' + sel);
                                    }
                                }
                                for (var i = 0; i < pga.length; i++) {
                                    pga[i].setAttr('data-toggle', 'tab');
                                }

                                pgnew = pgCreateNodeFromHtml('<div class="tab-pane" id="' + sel + '"><p>Tab ' + sel + ' content goes here...</p></div>');
                                if (prepend) {
                                    pgpanes.prepend(pgnew);
                                } else {
                                    pgpanes.append(pgnew);
                                }
                            }
                        }
                    }
                },
                tags : 'major',
                'sections' : gh.addPrefixToSectionsAndFields({
                    'tabs' : {
                        name : 'Tabs and Pills',
                        fields : {
                            type : {
                                'type' : 'select',
                                'name' : 'Type',
                                'action' : 'apply_class',
                                'show_empty' : false,
                                'options' : [
                                    {'key' : 'nav-tabs', 'name' : 'Tabs'},
                                    {'key' : 'nav-pills', 'name' : 'Pills'}
                                ]
                            },
                            stacked : {
                                type: 'checkbox',
                                name: 'Stacked',
                                action: 'apply_class',
                                value: 'nav-stacked'
                            },
                            justified : {
                                type: 'checkbox',
                                name: 'Justified',
                                action: 'apply_class',
                                value: 'nav-justified'
                            },
                            'withpanes' : {
                                'type' : 'checkbox',
                                'name' : 'With panes',
                                'action' : 'custom',
                                'value' : '1',
                                get_value: function (pgel) {
                                    return findTabsContentPanes(pgel) ? '1' : null;
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    crsaWillChangeDom();
                                    var pgpanes = findTabsContentPanes(pgel);

                                    if (value) {
                                        var active = pgel.find('>li').indexOf(pgel.find('>li.active')[0]);
                                        if (active < 0) active = 0;

                                        if (!pgpanes) {
                                            var html = pgel.data['crsa-tab-panes'];
                                            if (html) {
                                                pgpanes = pgCreateNodeFromHtml(html);
                                            } else {
                                                pgpanes = pgCreateNodeFromHtml('<div class="tab-content"></div>');
                                                var pglilink = pgel.find('>li a');

                                                for (var i = 0; i < pglilink.length; i++) {
                                                    var pgtab = pglilink[i];

                                                    var sel = findTabSel(pgtab);
                                                    if (!sel) {
                                                        sel = getUniqueId('tab', null, 0);
                                                        pgtab.setAttr('data-target', '#' + sel);
                                                    }
                                                    pgtab.setAttr('data-toggle', 'tab');

                                                    var pgp = pgCreateNodeFromHtml('<div class="tab-pane" id="' + sel + '">Tab ' + sel + ' content goes here...</div>');
                                                    pgpanes.append(pgp);
                                                    if (i == active) {
                                                        pgp.addClass('active');
                                                    }
                                                }
                                            }
                                            pgpanes.insertAfter(pgel);
                                        }
                                        // $.fn.crsa("setNeedsUpdate", false, $el.parent().has($panes) ? $el.parent() : $el.closest('body'));
                                    } else {
                                        // var next = pgpanes && pgel.parent.hasChildren(pgpanes);
                                        if (pgpanes) {
                                            pgel.data['crsa-tab-panes'] = pgpanes.get$DOMElement();
                                            pgpanes.remove();
                                        }
                                        // $.fn.crsa("setNeedsUpdate", false, next ? $el.parent() : $el.closest('body'));
                                    }
                                    showJavascriptMessage();
                                }
                            }
                        }
                    }
                })
            }
            f.addComponentType(tag);

            f.addComponentType({
                'type' : 'bs-tab-pane',
                'selector' : '.tab-pane',
                parent_selector: '.tab-content',
                'code' : '<div class="tab-pane"><p>Tab content goes here...</p></div>',
                'name' : 'Tab pane',
                //priority: 100,
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            });

        })();

        //breadcrumbs
        (function() {

            var list_item = {
                'type' : 'nav-list-item-current',
                'selector' : null,
                parent_selector: 'ul,ol',
                'code' : '<li class="active">Data</li>',
                'name' : 'Active item',
                //priority: 100,
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            }
            f.addComponentType(list_item);

            var tag = {
                'type' : 'breadcrumb',
                tags: 'major',
                'selector' : 'ol.breadcrumb',
                'code' : '<ol class="breadcrumb">\
            <li><a href="#">Home</a></li>\
        <li><a href="#">Library</a></li>\
    <li class="active">Data</li>\
    </ol>',
                'name' : 'Breadcrumbs',
                'action_menu' : {
                    'add' : ['nav-list-item', 'nav-list-item-current']
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            }
            f.addComponentType(tag);

        })();


        //pagination
        (function() {

            f.addComponentType({
                'type' : 'pagination-item',
                'selector' : null,
                parent_selector: 'ul.pagination',
                'code' : '<li><a href="#">_NUM_</a></li>',
                'name' : 'Item'
            });

            f.addComponentType({
                'type' : 'pagination-current',
                'selector' : null,
                parent_selector: 'ul.pagination',
                'code' : '<li class="active"><a href="#">_NUM_ <span class="sr-only">(current)</span></a></li>',
                'name' : 'Active item'
            });

            f.addComponentType({
                'type' : 'pagination-previous',
                'selector' : null,
                parent_selector: 'ul.pagination',
                'code' : '<li><a href="#">&laquo;</a></li>',
                'name' : 'Previous'
            });

            f.addComponentType({
                'type' : 'pagination-next',
                'selector' : null,
                parent_selector: 'ul.pagination',
                'code' : '<li><a href="#">&raquo;</a></li>',
                'name' : 'Next'
            });

            var tag = {
                'type' : 'pagination',
                tags: 'major',
                'selector' : 'ul.pagination',
                'code' : '<ul class="pagination">\
            <li><a href="#">&laquo;</a></li>\
        <li class="active"><a href="#">1 <span class="sr-only">(current)</span></a></li>\
        <li><a href="#">2</a></li>\
        <li><a href="#">3</a></li>\
        <li><a href="#">&raquo;</a></li>\
    </ul>',
                'name' : 'Pagination',
                'action_menu' : {
                    'add' : ['pagination-item', 'pagination-current', 'pagination-previous', 'pagination-next'],
                    'on_add' : function(pgel, pgnew, newdef, prepend) {
                        if (newdef.type == 'pagination-previous') {
                            pgel.prepend(pgnew);
                        } else if (newdef.type == 'pagination-next') {
                            pgel.append(pgnew);
                        } else {
                            var max = 0;
                            var pglist = pgel.find('>li');

                            for (var i = 0; i < pglist.length; i++) {
                                var pgli = pglist[i]
                                var val = parseInt(pgli.text());
                                if (val && val > max) max = val;
                            }

                            max++;
                            pgnew.html(pgnew.html().replace('_NUM_', max));

                            if (pglist.length > 0) {
                                var pglast = pglist[pglist.length - 1];
                                //console.log(last.text());
                                var t = pglast.text();
                                if (t.match(/(&raquo;|»)/i)) {
                                    pgnew.insertBefore(pglast);
                                } else {
                                    pgel.append(pgnew);
                                }
                            } else {
                                pgel.append(pgnew);
                            }
                        }
                    }
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                    'list' : {
                        name : 'Pagination',
                        fields : {
                            stacked : {
                                type: 'select',
                                name: 'Size',
                                action: 'apply_class',
                                'show_empty' : true,
                                'options' : [
                                    {'key' : 'pagination-lg', 'name' : 'Large'},
                                    {'key' : 'pagination-sm', 'name' : 'Small'}
                                ]
                            }
                        }
                    }
                })
            }
            f.addComponentType(tag);

        })();


        //pager
        (function() {

            f.addComponentType({
                'type' : 'pager-item',
                'selector' : function(pgel) {
                    return pgel.tagName == 'li' && pgel.parent && pgel.parent.hasClass('pager');
                },
                parent_selector: '.pager',
                'code' : '<li><a href="#">Title</a></li>',
                'name' : 'Item',
                'sections' : gh.addPrefixToSectionsAndFields({
                    'list' : {
                        name : 'Pager item',
                        fields : {
                            stacked : {
                                type: 'select',
                                name: 'Type',
                                action: 'apply_class',
                                'show_empty' : true,
                                'options' : [
                                    {'key' : 'previous', 'name' : 'Previous'},
                                    {'key' : 'next', 'name' : 'Next'}
                                ]
                            },
                            disabled : disabled
                        }
                    }
                })
            });

            f.addComponentType({
                'type' : 'pager-prev',
                'selector' : null,
                parent_selector: '.pager',
                'code' : '<li class="previous"><a href="#">&larr; Older</a></li>',
                'name' : 'Previous'
            });

            f.addComponentType({
                'type' : 'pager-next',
                'selector' : null,
                parent_selector: '.pager',
                'code' : '<li class="next"><a href="#">Newer &rarr;</a></li>',
                'name' : 'Next'
            });




            var tag = {
                'type' : 'pager',
                'selector' : 'ul.pager',
                'code' : '<ul class="pager">\
            <li><a href="#">Previous</a></li>\
        <li><a href="#">Next</a></li>\
    </ul>',
                'name' : 'Pager',
                'action_menu' : {
                    'add' : ['pager-item', 'pager-prev', 'pager-next']
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            }
            f.addComponentType(tag);

        })();


        //navbar
        (function() {

            var findDiv = function (pgel, cls) {
                var pgdiv = pgel.find('div' + cls);
                if (pgdiv.length == 0) {
                    pgdiv = pgel.find('> div');
                }
                if (pgdiv.length == 0) {
                    pgdiv = pgel;
                }
                if (pgdiv.length != undefined) {
                    pgdiv = pgdiv[0];
                }
                return pgdiv;
            }

            var findUl = function(pgdiv) {
                return pgdiv.find('>ul.nav');
            }


            var navbar = {
                'type' : 'navbar',
                'selector' : '.navbar',
                'code' : '<nav class="navbar navbar-default" role="navigation">\
                <div class="container-fluid">\
                <div class="navbar-header">\
                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1">\
                        <span class="sr-only">Toggle navigation</span>\
                        <span class="icon-bar"></span>\
                        <span class="icon-bar"></span>\
                        <span class="icon-bar"></span>\
                    </button>\
                    <a class="navbar-brand" href="#">Brand</a>\
                </div>\
\
                <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">\
                    <ul class="nav navbar-nav">\
                        <li class="active"><a href="#">Link</a></li>\
                        <li><a href="#">Link</a></li>\
                        <li class="dropdown">\
                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">Dropdown <b class="caret"></b></a>\
                            <ul class="dropdown-menu">\
                                <li><a href="#">Action</a></li>\
                                <li><a href="#">Another action</a></li>\
                                <li><a href="#">Something else here</a></li>\
                                <li class="divider"></li>\
                                <li><a href="#">Separated link</a></li>\
                                <li class="divider"></li>\
                                <li><a href="#">One more separated link</a></li>\
                            </ul>\
                        </li>\
                    </ul>\
                    <form class="navbar-form navbar-left" role="search">\
                        <div class="form-group">\
                            <input type="text" class="form-control" placeholder="Search">\
                            </div>\
                            <button type="submit" class="btn btn-default">Submit</button>\
                        </form>\
                        <ul class="nav navbar-nav navbar-right">\
                            <li><a href="#">Link</a></li>\
                            <li class="dropdown">\
                                <a href="#" class="dropdown-toggle" data-toggle="dropdown">Dropdown <b class="caret"></b></a>\
                                <ul class="dropdown-menu">\
                                    <li><a href="#">Action</a></li>\
                                    <li><a href="#">Another action</a></li>\
                                    <li><a href="#">Something else here</a></li>\
                                    <li class="divider"></li>\
                                    <li><a href="#">Separated link</a></li>\
                                </ul>\
                            </li>\
                        </ul>\
                    </div>\
                </div>\
            </nav>',
                'name' : 'Navbar',
                tags: 'major',
                'action_menu' : {
                    'add' : ['link', 'navbar-brand', 'navbar-form', 'navbar-list', 'navbar-dropdown'],
                    'on_add' : function(pgel, pgnew, newdef, prepend) {
                        if (['link', 'navbar-dropdown'].indexOf(newdef.type) >= 0) {
                            var pgdiv = findDiv(pgel, '.navbar-collapse');
                            var pgul = findUl(pgdiv);
                            var pgli;
                            if (pgul.length > 0) {
                                var pgli = pgCreateNodeFromHtml('<li></li>');
                                pgul = pgul[0];
                                pgul.append(pgli);
                            }
                            else {
                                var pgul = pgCreateNodeFromHtml('<ul class="nav navbar-nav"><li></li></ul>');
                                pgdiv.append(pgul);
                                pgli = pgul.find('li');
                            }

                            if(prepend) {
                                for (var i = 0; i < pgli.length; i++) {
                                    pgli[i].prepend(pgnew);
                                }
                            } else {
                                for (var i = 0; i < pgli.length; i++) {
                                    pgli[i].append(pgnew);
                                }
                            }
                        } else if(['navbar-brand'].indexOf(newdef.type) >= 0) {
                            var pgdiv = findDiv(pgel, '.navbar-header');
                            if (prepend) {
                                pgdiv.prepend(pgnew);
                            } else {
                                pgdiv.append(pgnew);
                            }
                        } else if(['navbar-form' ,'navbar-list'].indexOf(newdef.type) >= 0) {
                            var pgdiv = findDiv(pgel, '.navbar-collapse');
                            if (prepend) {
                                pgdiv.prepend(pgnew);
                            } else {
                                pgdiv.append(pgnew);
                            }
                        }
                    }
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                    navbar : {
                        name : 'Navbar style',
                        fields : {
                            collapse : {
                                name : 'Collapsable',
                                'type': 'checkbox' ,
                                value: '1',
                                action: "custom",
                                get_value: function (pgel) {
                                    return pgel.find('.navbar-collapse').length > 0 ? '1' : null;
                                },
                                set_value: function (pgel, value, values) {
                                    crsaWillChangeDom();
                                    var pgcontainer = pgel.findOne('.container,.container-fluid');

                                    if (!pgcontainer) {
                                        pgcontainer = pgel;
                                    }

                                    if (value) {
                                        var pgheader = pgel.findOne('.navbar-header');

                                        if (!pgheader) {
                                            pgheader = pgCreateNodeFromHtml('<div class="navbar-header"></div>');
                                            pgcontainer.prepend(pgheader);
                                        }

                                        var pgbrand = pgel.findOne('.navbar-brand');

                                        if (pgbrand) {
                                            if (pgheader.hasChildren(pgbrand)) {
                                                pgheader.append(pgbrand);
                                            }
                                        }
                                        var pgcontent = pgel.findOne('.navbar-collapse');
                                        var cid = null;

                                        if (pgcontent) cid = pgcontent.getAttr('id');
                                        if (!cid) cid = getUniqueId("nav", null, 0);

                                        if (!pgcontent) {
                                            pgcontent = pgCreateNodeFromHtml('<div class="collapse navbar-collapse" id="' + cid + '"></div>');
                                            pgcontainer.append(pgcontent);
                                        } else {
                                            pgcontent.addClass('collapse').addClass('navbar-collapse');
                                        }

                                        var pgbutton = pgel.findOne('.navbar-toggle');
                                        if (!pgbutton) {
                                            var pgbutton = pgCreateNodeFromHtml('<button class="navbar-toggle" data-toggle="collapse" data-target="#' + cid + '"></button>');
                                            pgbutton.html('<span class="sr-only">Toggle navigation</span>\
                                                            <span class="icon-bar"></span>\
                                                            <span class="icon-bar"></span>\
                                                            <span class="icon-bar"></span>');
                                        }
                                        pgheader.prepend(pgbutton);

                                        for (var i = 0; i < pgcontainer.length; i++) {
                                            if (pgcontainer[i] != pgheader && pgcontainer[i] != pgcontent) {
                                                pgcontent.append(pgcontainer[i]);
                                            }
                                        }
                                    } else {
                                        var pgheader = pgel.findOne('.navbar-header');
                                        var pgbutton = pgel.findOne('.navbar-toggle').remove();
                                        var pgcontent = pgel.findOne('.navbar-collapse');

                                        var pgcontentchildren = pgcontent.children;
                                        for (var i = 0; i < pgcontentchildren.length; i++) {
                                            if (pgcontentchildren[i] != pgbutton) {
                                                pgcontainer.append(pgcontentchildren[i]);
                                            }
                                        }
                                        // $header.remove();
                                        pgbutton.remove();
                                        pgcontent.remove();
                                    }
                                    // $.fn.crsa('setNeedsUpdate', false, $el);
                                    return value;
                                }
                            },
                            navbartype : {
                                name : 'Type',
                                'type': 'select' ,
                                show_empty: true,
                                action: "apply_class",
                                options: [
                                    {key: "navbar-fixed-top", name: "Fixed - top", tip: "Add padding-top to body to prevent navbar overlapping the content."},
                                    {key: "navbar-fixed-bottom", name: "Fixed - bottom", tip: "Add padding-bottom to body to prevent navbar overlapping the content."},
                                    {key: "navbar-static-top", name: "Static - top"}
                                ]
                            },
                            inverse : {
                                name : 'Inverse',
                                'type': 'checkbox' ,
                                value: 'navbar-inverse',
                                action: "apply_class"
                            }
                        }
                    }
                })
            }
            f.addComponentType(navbar);

            var brand = {
                'type' : 'navbar-brand',
                'selector' : '.navbar-brand',
                'code' : '<a class="navbar-brand" href="#">Brand</a>',
                'name' : 'Brand',
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            }
            f.addComponentType(brand);

            var form = {
                'type' : 'navbar-form',
                'selector' : null,
                'code' : '<form class="navbar-form navbar-left" role="search">\
        <div class="form-group">\
            <input type="text" class="form-control" placeholder="Search">\
            </div>\
            <button type="submit" class="btn btn-default">Submit</button>\
        </form>',
                'name' : 'Navbar form',
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            }
            f.addComponentType(form);


            var section = {
                'type' : 'navbar-list',
                'selector' : 'ul.navbar-nav',
                'code' : '<ul class="nav navbar-nav"></ul>',
                'name' : 'Navbar section',
                tags: 'major',
                'action_menu' : {
                    'add' : ['link', 'navbar-dropdown'],
                    'on_add' : function (pgel, pgnew, newdef, prepend) {
                        // var pgli = new pgQuery().create('<li></li>');
                        var pgli = pgCreateNodeFromHtml('<li></li>');
                        pgel.append(pgli);

                        if (prepend) {
                            pgli.prepend(pgnew);
                        } else {
                            pgli.append(pgnew);
                        }
                    }
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                    layout : {
                        name : 'Navbar section',
                        fields : {
                            type : {
                                name : 'Position',
                                'type': 'select' ,
                                show_empty: true,
                                action: "apply_class",
                                options: [
                                    {key: "navbar-left", name: "Left" },
                                    {key: "navbar-right", name: "Right" }
                                ]
                            },
                            scrollspy : {
                                name : 'Scrollspy',
                                'type': 'checkbox' ,
                                value: '1',
                                action: "custom",
                                get_value: function (pgel) {
                                    var pgb = pgel.closest('body');
                                    var dt = pgb.getAttr('data-target');
                                    if (pgb.getAttr('data-spy') == 'scroll' && dt && pgel.parent.tagName == 'dt') {
                                        return '1';
                                    }
                                    return null;
                                },
                                set_value: function (pgel, value, values) {
                                    var pgb = pgel.closest('body');
                                    if (value) {
                                        var pgp = pgel.parent;
                                        var id = pgp.getAttr('id');
                                        if (!id) {
                                            id = getUniqueId('nav', null, 0);
                                            pgp.attr('id', id);
                                        }
                                        pgb.setAttr('data-spy', 'scroll');
                                        pgb.setAttr('data-target', '#' + id);
                                    } else {
                                        pgb.removeAttr('data-spy');
                                        pgb.removeAttr('data-target');
                                    }
                                    showJavascriptMessage();
                                    return value;
                                }
                            }
                        }
                    }
                })
            }
            f.addComponentType(section);



            var dropdown = {
                'type' : 'navbar-dropdown',
                'selector' : null,
                'code' : '<a href="#" class="dropdown-toggle" data-toggle="dropdown">Dropdown <b class="caret"></b></a>',
                'name' : 'Dropdown',
                on_inserted : function(pgel, page) {
                    var pgul = pgCreateNodeFromHtml('<ul class="dropdown-menu">\
                            <li><a href="#">Action</a></li>\
                            <li><a href="#">Another action</a></li>\
                            <li class="divider"></li>\
                            <li><a href="#">Separated link</a></li>\
                        </ul>');
                    pgul.insertAfter(pgel);
                },
                'sections' : gh.addPrefixToSectionsAndFields({

                })
            }
            f.addComponentType(dropdown);

        })();



        //lists

        var list = {
            'type' : 'list',
            tags: 'major',
            'selector' : 'ul,ol',
            'code' : '<ul>\
        <li>Lorem ipsum dolor sit amet</li>\
    <li>Consectetur adipiscing elit</li>\
    <li>Integer molestie lorem at massa</li>\
    <li>Nulla volutpat aliquam velit\
    <ul>\
    <li>Phasellus iaculis neque</li>\
    <li>Purus sodales ultricies</li>\
    </ul>\
    </li>\
</ul>',
            'name' : 'List',
            'action_menu' : {
                'add' : ['list_item']
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Style',
                    fields : {
                        'ordered' : {
                            'type' : 'checkbox',
                            'name' : 'Ordered',
                            'action' : 'custom',
                            'value' : '1',
                            get_value: function (pgel) {
                                return pgel.tagName == "ol" ? "1" : null;
                            },
                            set_value: function (pgel, value, values) {
                                crsaWillChangeDom();
                                var tag = value == "1" ? 'ol' : 'ul';
                                pgel = pgel.replaceTag(tag);

                                // $.fn.crsa("setNeedsUpdate", false, $el);
                                return value;
                            }
                        },
                        'unstyled' : {
                            'type' : 'checkbox',
                            'name' : 'Unstyled',
                            'action' : 'apply_class',
                            'value' : 'list-unstyled'
                        },
                        'inline' : {
                            'type' : 'checkbox',
                            'name' : 'Inline',
                            'action' : 'apply_class',
                            'value' : 'list-inline'
                        }
                    }
                }
            })
        }
        f.addComponentType(list);

        var list_item = {
            'type' : 'list_item',
            'selector' : 'li',
            parent_selector: 'ol,ul',
            'code' : '<li>List item</li>',
            'name' : 'List Item',
            'sections' : gh.addPrefixToSectionsAndFields({

            })
        }
        f.addComponentType(list_item);


        //labels, badges
        (function() {

            f.addComponentType({
                'type' : 'span-label',
                'selector' : 'span.label',
                'code' : '<span class="label label-default">New</span>',
                'name' : 'Label',
                'sections' : gh.addPrefixToSectionsAndFields({
                    'list' : {
                        name : 'Label',
                        fields : {
                            value : {
                                type: 'text',
                                name: 'Value',
                                action: 'element_html'
                            },
                            variation : {
                                type: 'select',
                                name: 'Type',
                                action: 'apply_class',
                                'show_empty' : true,
                                'options' : [
                                    {'key' : 'label-default', 'name' : 'Default'},
                                    {'key' : 'label-primary', 'name' : 'Primary'},
                                    {'key' : 'label-success', 'name' : 'Success'},
                                    {'key' : 'label-info', 'name' : 'Info'},
                                    {'key' : 'label-warning', 'name' : 'Warning'},
                                    {'key' : 'label-danger', 'name' : 'Danger'}
                                ]
                            }
                        }
                    }
                })
            });

            f.addComponentType({
                'type' : 'badge',
                'selector' : 'span.badge',
                'code' : '<span class="badge">42</span>',
                'name' : 'Badge',
                'sections' : gh.addPrefixToSectionsAndFields({
                    'badge' : {
                        name : 'Badge',
                        fields : {
                            value : {
                                type: 'text',
                                name: 'Value',
                                action: 'element_html'
                            }
                        }
                    }
                })
            });


            f.addComponentType({
                'type' : 'page-header',
                'selector' : 'div.page-header',
                'code' : '<div class="page-header">\
            <h1>Example page header <small>Subtext for header</small></h1>\
        </div>',
                'name' : 'Page header',
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            });

        })();


        //jumbotron
        (function() {

            f.addComponentType({
                'type' : 'jumbotron',
                tags: 'major',
                'selector' : 'div.jumbotron',
                'code' : '<div class="jumbotron">\
            <h1>Hello, world!</h1>\
            <p>This is a simple hero unit, a simple jumbotron-style component for calling extra attention to featured content or information.</p>\
            <p><a class="btn btn-primary btn-lg" role="button">Learn more</a></p>\
        </div>',
                'name' : 'Jumbotron',
                'action_menu' : {
                    'add' : ['jumbotron-h1', 'jumbotron-p', 'jumbotron-b'],
                    'on_add' : function (pgel, pgnew, newdef, prepend) {
                        var pgc = pgel.find('.container,.container-fluid');
                        if (pgc.length > 0) {
                            pgel = pgc[0];
                        }
                        if (newdef.type == 'jumbotron-b') {
                            var pgbtns = pgel.find('.btn');
                            var pgbs = pgbtns[pgbtns.length - 1];
                            if (pgbs) {
                                pgnew.insertAfter(pgbs);
                                // pgCreateNodeFromHtml('&nbsp;').insertBefore(pgnew.get(0).pgel);
                                pgCreateNodeFromHtml('&nbsp;').insertBefore(pgnew);
                                // pgnew.before('&nbsp;');
                            } else {
                                // $new = $('<p/>').append($new);
                                var p = pgCreateNodeFromHtml('<p></p>');
                                p.append(pgnew);

                                pgnew = p;

                                if (prepend) {
                                    pgel.prepend(pgnew);
                                } else {
                                    pgel.append(pgnew);
                                }
                            }
                        } else {
                            if (prepend) {
                                pgel.prepend(pgnew);
                            } else {
                                pgel.append(pgnew);
                            }
                        }
                    }
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                    'list' : {
                        name : 'Jumbotron',
                        fields : {
                            fullscreen : {
                                type: 'checkbox',
                                name: 'Full width',
                                action: 'custom',
                                value: "1",
                                get_value: function (pgel) {
                                    var pgc = pgel.closest('.container,.container-fluid');
                                    return !pgc ? '1' : null;
                                },
                                set_value: function (pgel, value, values) {
                                    crsaWillChangeDom();

                                    var putOutOfContainer = function() {
                                        var pgcon = pgel.closest('.container,.container-fluid');
                                        if (!pgcon) return;
                                        pgel.insertBefore(pgcon);
                                        if (pgcon.children.length == 0) {
                                            pgcon.remove();
                                        }
                                    }

                                    var putInContainer = function() {
                                        var pgcon = pgel.closest('.container,.container-fluid');
                                        if (pgcon) return;

                                        var pgc = pgCreateNodeFromHtml('<div class="container"></div>');

                                        var pgm = pgel.next();
                                        var fun = 'insertBefore';

                                        if (!pgm) {
                                            pgm = pgel.prev();
                                            fun = 'insertAfter';

                                            if (!pgm) {
                                                append = true;
                                                pgm = pgel.parent;
                                                fun = 'appendTo';
                                            }
                                        }

                                        pgc[fun](pgm);
                                        pgc.append(pgel);
                                    }

                                    if (value) {
                                        putOutOfContainer();
                                    } else {
                                        putInContainer();
                                    }
                                    // $.fn.crsa('setNeedsUpdate');
                                    return value;
                                }
                            }
                        }
                    }
                })
            });

            f.addComponentType({
                'type' : 'jumbotron-p',
                'selector' : null,
                parent_selector: '.jumbotron',
                'code' : '<p>This is a simple hero unit, a simple jumbotron-style component for calling extra attention to featured content or information.</p>',
                'name' : 'Text',
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType({
                'type' : 'jumbotron-h1',
                'selector' : null,
                parent_selector: '.jumbotron',
                'code' : '<h1>Hello, world!</h1>',
                'name' : 'Title',
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType({
                'type' : 'jumbotron-b',
                'selector' : null,
                parent_selector: '.jumbotron,.jumbotron p',
                'code' : '<a class="btn btn-primary btn-lg" role="button">Learn more</a>',
                'name' : 'Button',
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            });

        })();



        //thumbnails
        (function() {

            f.addComponentType({
                'type' : 'thumbnail-img',
                'selector' : null,
                tags: 'major',
                parent_selector: '.row',
                invalid_drop_msg : columnPlaceMsg,
                'code' : function() {
                    return '<div class="col-xs-6 col-md-3">\
        <a href="#" class="thumbnail">\
            <img src="' + getPlaceholderImage() + '" alt="">\
        </a>\
        </div>';
                },
                'preview' : function() {
                    return '<div class="col-xs-12">\
        <a href="#" class="thumbnail">\
            <img src="' + getPlaceholderImage() + '" alt="">\
        </a>\
        </div>';
                },
                'name' : 'Image thumbnail',
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            });


            f.addComponentType({
                'type' : 'thumbnail-content',
                'selector' : null,
                tags: 'major',
                parent_selector: '.row',
                invalid_drop_msg : columnPlaceMsg,
                'code' : '<div class="col-sm-6 col-md-4">\
            <div class="thumbnail">\
        <img src="' + getPlaceholderImage() + '" alt="">\
            <div class="caption">\
                <h3>Thumbnail label</h3>\
                <p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Donec id elit non mi porta gravida at eget metus. Nullam id dolor id nibh ultricies vehicula ut id elit.</p>\
                <p><a href="#" class="btn btn-primary" role="button">Button</a> <a href="#" class="btn btn-default" role="button">Button</a></p>\
            </div>\
        </div>\
        </div>',
                'preview' : '<div class="col-sm-12">\
            <div class="thumbnail">\
        <img src="' + getPlaceholderImage() + '" alt="">\
            <div class="caption">\
                <h3>Thumbnail label</h3>\
                <p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Donec id elit non mi porta gravida at eget metus. Nullam id dolor id nibh ultricies vehicula ut id elit.</p>\
                <p><a href="#" class="btn btn-primary" role="button">Button</a> <a href="#" class="btn btn-default" role="button">Button</a></p>\
            </div>\
        </div>\
        </div>',
                'name' : 'Content thumbnail',
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            });



        })();



        //alerts
        (function() {

            f.addComponentType({
                'type' : 'alert',
                'selector' : 'div.alert',
                'code' : '<div class="alert alert-success">\
            <strong>Well done!</strong> You successfully read this important alert message.\
        </div>',
                'name' : 'Alert',
                action_menu: {
                    actions : [
                        {label: "Style links", action: function($el) {
                            $el.find('a').addClass('alert-link');
                        }}
                    ]
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                    'style' : {
                        name : 'Alert',
                        fields : {
                            'type' : {
                                'type' : 'select',
                                'name' : 'Type',
                                'action' : 'apply_class',
                                show_empty: false,
                                'options' : [
                                    {key: 'alert-success', name: 'Success'},
                                    {key: 'alert-info', name: 'Info'},
                                    {key: 'alert-warning', name: 'Warning'},
                                    {key: 'alert-danger', name: 'Danger'}
                                ]
                            },
                            'close' : {
                                'type' : 'checkbox',
                                'name' : 'Dismissable',
                                'value' : "1",
                                'action' : 'custom',
                                get_value: function (pgel) {
                                    return pgel.find("button.close").length > 0 ? "1" : null;
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    crsaWillChangeDom();
                                    var pgb = pgel.findOne('button.close');

                                    if (value) {
                                        if (!pgb) {
                                            pgb = pgCreateNodeFromHtml('<button type="button" class="close" data-dismiss="alert" aria-hidden="true"></button>').html('&times;');
                                            pgel.prepend(pgb);
                                        }
                                    } else {
                                        pgb.remove();
                                    }
                                    // $.fn.crsa('setNeedsUpdate', false, $el);
                                    return value;
                                }
                            }
                        }
                    }
                })
            });

        })();

        //progress bar
        (function() {

            f.addComponentType({
                'type' : 'progress',
                'selector' : 'div.progress',
                'code' : '<div class="progress">\
            <div class="progress-bar" role="progressbar" aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="width: 60%;">\
        <span class="sr-only">60% Complete</span>\
        </div>\
    </div>',
                'preview' : '<div class="progress progress-striped active">\
            <div class="progress-bar" role="progressbar" aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="width: 60%;">\
        <span class="sr-only">60% Complete</span>\
        </div>\
        <div class="progress-bar progress-bar-success" role="progressbar" aria-valuenow="20" aria-valuemin="0" aria-valuemax="100" style="width: 20%;">\
        <span class="sr-only">20% Complete</span>\
        </div>\
    </div>',
                'name' : 'Progress bar',
                tags: 'major',
                action_menu : {
                    add: ['progress-bar']
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                    'style' : {
                        name : 'Progress bar',
                        fields : {
                            'striped' : {
                                'type' : 'checkbox',
                                'name' : 'Striped',
                                'value' : "progress-bar-striped",
                                'action' : 'apply_class'
                            },
                            'animated' : {
                                'type' : 'checkbox',
                                'name' : 'Animated',
                                'value' : "active",
                                'action' : 'apply_class'
                            }
                        }
                    }
                })
            });

            var options = [
                {key: 'progress-bar-success', name: 'Success'},
                {key: 'progress-bar-info', name: 'Info'},
                {key: 'progress-bar-warning', name: 'Warning'},
                {key: 'progress-bar-danger', name: 'Danger'}
            ];

            f.addComponentType({
                'type' : 'progress-bar',
                'selector' : 'div.progress-bar',
                parent_selector: 'div.progress',
                'code' : '<div class="progress-bar" role="progressbar" aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="width: 60%;">\
        <span class="sr-only">60% Complete</span>\
    </div>',
                'preview' : '<div class="progress">\
            <div class="progress-bar" role="progressbar" aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="width: 60%;">\
        <span class="sr-only">60% Complete</span>\
    </div>',
                'name' : 'Progress bar section',
                'sections' : gh.addPrefixToSectionsAndFields({
                    'style' : {
                        name : 'Progress bar section',
                        fields : {
                            'type' : {
                                'type' : 'select',
                                'name' : 'Type',
                                'action' : 'apply_class',
                                show_empty: true,
                                'options' : options
                            },
                            'percent' : {
                                'type' : 'text',
                                'name' : 'Completed %',
                                'action' : 'custom',
                                get_value: function (pgel) {
                                    var v = pgel.getAttr('aria-valuenow');
                                    if (v !== null) return v;

                                    var styles = styleToObject(pgel.getAttr('style'));

                                    var w = styles.width;
                                    w = w ? w.replace('%', '') : null;
                                    return w;
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    var v = value == null ? 50 : parseInt(value);
                                    if (v > 100) v = 100;
                                    value = v.toString()
                                    pgel.setAttr('aria-valuenow', value).setAttr('style', 'width:' + value + '%');
                                    var t = value + '% Complete';
                                    for (var n = 0; n < options.length; n++) {
                                        if (pgel.hasClass(options[n].key)) {
                                            t += ' (' + options[n].name + ')';
                                            break;
                                        }
                                    }

                                    pgel.findOne('span').html(t);
                                    return value;
                                }
                            },
                            'pblabel': {
                                'type' : 'text',
                                'name' : 'Label',
                                'action' : 'custom',
                                get_value: function (pgel) {
                                    var pgspan = pgel.findOne('> span');
                                    if (!pgspan) return '';

                                    return pgspan.text();
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    var pgspan = '';
                                    var pgpspan = pgel.findOne('> span');
                                    if (!pgpspan) {
                                        var pgpspan = pgCreateNodeFromHtml('<span></span>');
                                        pgel.html('').append(pgpspan);
                                    }
                                    pgpspan.html(value);
                                    return value;
                                }
                            },
                            'pbshowlabel': {
                                'type' : 'checkbox',
                                'name' : 'Show label',
                                'value' : '1',
                                'action' : 'custom',
                                get_value: function (pgel) {
                                    var pgspan = pgel.findOne('> span');
                                    return (pgspan && pgspan.hasClass('sr-only')) ? null : '1';
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    var pgspan = pgel.findOne('> span');

                                    if(pgspan) {
                                        if (value == 1) {
                                            pgspan.removeClass('sr-only');
                                        }
                                        else {
                                            pgspan.addClass('sr-only');
                                        }
                                    }
                                    return value;
                                }
                            },
                            'striped' : {
                                'type' : 'checkbox',
                                'name' : 'Striped',
                                'value' : "progress-bar-striped",
                                'action' : 'apply_class'
                            },
                            'animated' : {
                                'type' : 'checkbox',
                                'name' : 'Animated',
                                'value' : "active",
                                'action' : 'apply_class'
                            }
                        }
                    }
                })
            });


        })();


        //media
        (function() {

            /*
            f.addComponentType({
                'type' : 'media',
                tags: 'major',
                'selector' : 'div.media',
                'code' : function() {
                    return '<div class="media">\
            <a class="pull-left" href="#">\
        <img class="media-object" src="' + getPlaceholderImage() + '" width="100">\
        </a>\
        <div class="media-body">\
        <h4 class="media-heading">Media heading</h4>\
    Cras sit amet nibh libero, in gravida nulla. Nulla vel metus scelerisque ante sollicitudin commodo. Cras purus odio, vestibulum in vulputate at, tempus viverra turpis. Fusce condimentum nunc ac nisi vulputate fringilla. Donec lacinia congue felis in faucibus.\
    </div>\
    </div>';
                },
                'name' : 'Media',
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            });
            */

            f.addComponentType({
                'type' : 'media-list',
                'selector' : 'ul.media-list',
                'code' : function() {
                    return '<ul class="media-list">\
                    <li class="media">\
                            <a class="pull-left" href="#">\
                        <img class="media-object" src="' + getPlaceholderImage() + '" width="100">\
                        </a>\
                        <div class="media-body">\
                        <h4 class="media-heading">Media heading</h4>\
                    Cras sit amet nibh libero, in gravida nulla. Nulla vel metus scelerisque ante sollicitudin commodo. Cras purus odio, vestibulum in vulputate at, tempus viverra turpis. Fusce condimentum nunc ac nisi vulputate fringilla. Donec lacinia congue felis in faucibus.\
                    </div>\
                    </li>\
                    <li class="media">\
                        <a class="pull-left" href="#">\
                            <img class="media-object" src="' + getPlaceholderImage() + '" width="100">\
                            </a>\
                            <div class="media-body">\
                                <h4 class="media-heading">Media heading</h4>\
                            Cras sit amet nibh libero, in gravida nulla. Nulla vel metus scelerisque ante sollicitudin commodo. Cras purus odio, vestibulum in vulputate at, tempus viverra turpis. Fusce condimentum nunc ac nisi vulputate fringilla. Donec lacinia congue felis in faucibus.\
                            </div>\
                        </li>\
                    </ul>';
                },
                'name': 'Media list',
                priority: 100,
                //preview: 'none',
                'action_menu' : {
                    'add' : ['media-list-item']
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            });

            f.addComponentType({
                'type' : 'media-list-item',
                'priority' : 100,
                'selector' : 'li.media',
                'code' : function() {
                    return '<li class="media">\
                            <a class="pull-left" href="#">\
                        <img class="media-object" src="' + getPlaceholderImage() + '" width="100">\
                        </a>\
                        <div class="media-body">\
                        <h4 class="media-heading">Media heading</h4>\
                    Cras sit amet nibh libero, in gravida nulla. Nulla vel metus scelerisque ante sollicitudin commodo. Cras purus odio, vestibulum in vulputate at, tempus viverra turpis. Fusce condimentum nunc ac nisi vulputate fringilla. Donec lacinia congue felis in faucibus.\
                    </div>\
                    </li>';
                },
                'name': 'Media list item',
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            });

            /*

             f.addComponentType({
             'type' : 'progress-bar',
             'selector' : 'div.progress-bar',
             'code' : '',
             'name' : 'Progress bar section',
             'sections' : gh.addPrefixToSectionsAndFields({
             'style' : {
             name : 'Progress bar section',
             fields : {
             'type' : {
             'type' : 'select',
             'name' : 'Type',
             'action' : 'apply_class',
             show_empty: false,
             'options' : options
             },
             'percent' : {
             'type' : 'text',
             'name' : 'Completed %',
             'action' : 'custom',
             get_value: function(obj) {
             var $el = obj.data;
             var w = $el.get(0).style.width;
             w = w != null ? w.replace('%', '') : null;
             return w;
             },
             set_value: function(obj, value, values, oldValue, eventType) {
             var $el = obj.data;
             var v = value == null ? 50 : parseInt(value);
             if(v > 100) v = 100;
             $el.get(0).style.width = v + '%';
             $el.attr('aria-valuenow', v);
             var t = v + '% Complete';
             for(var n = 0; n < options.length; n++) {
             if($el.hasClass(options[n].key)) {
             t += ' (' + options[n].name + ')';
             break;
             }
             }
             var $s = $el.find('span').html(t);
             return value;
             }
             }
             }
             }
             })
             });
             */

        })();


        //list group
        (function() {

            f.addComponentType({
                'type' : 'list-group',
                'selector' : 'ul.list-group,div.list-group',
                priority: 100,
                'code' : '<ul class="list-group">\
            <li class="list-group-item">Cras justo odio</li>\
            <li class="list-group-item">Dapibus ac facilisis in</li>\
            <li class="list-group-item">Morbi leo risus</li>\
    </ul>',
                'name' : 'List group',
                'action_menu' : {
                    'add' : ['list-group-item']
                },
                tags: 'major',
                'sections' : gh.addPrefixToSectionsAndFields({
                    'style' : {
                        name : 'List group',
                        fields : {
                            'percent' : {
                                'type' : 'checkbox',
                                'name' : 'Linked',
                                'value' : '1',
                                'action' : 'custom',
                                get_value: function (pgel) {
                                    return pgel.tagName == 'div' ? '1' : null;
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    crsaWillChangeDom();
                                    var dmain = value == '1' ? 'div' : 'ul';
                                    var ditem = value == '1' ? 'a' : 'li';
                                    // var $newel;
                                    var pgnewel;
                                    if (pgel.tagName != dmain) {
                                        var items = pgel.children;
                                        for (var i = 0; i < items.length; i++) {
                                            items[i].detach();
                                        }

                                        //$newel = replaceTag($el, dmain);
                                        pgnewel = pgel.replaceTag(dmain);
                                        // obj.data = $(pgnewel.get(0).el);
                                        // $newel = obj.data;
                                    } else {
                                        // $newel = $el;
                                        pgnewel = pgel;
                                    }

                                    var newels = [];
                                    for (var i = 0; i < items.length; i++) {
                                        var pgitem = items[i];

                                        if (pgitem.tagName == ditem) {
                                            newels.push(pgitem);
                                        } else {
                                            var pgnew = pgitem.replaceTag(ditem);
                                            if (ditem == 'a') pgnew.setAttr('href', '#')
                                            newels.push(pgnew);
                                        }
                                    }

                                    for (var n = 0; n < newels.length; n++) {
                                        pgnewel.append(newels[n]);
                                    }
                                    // $.fn.crsa('setNeedsUpdate', false, $newel);
                                    return value;
                                }
                            }
                        }
                    }
                })
            });

            f.addComponentType({
                'type' : 'list-group-item',
                'selector' : 'li.list-group-item',
                priority: 100,
                parent_selector: 'ul,ol',
                'code' : '<li class="list-group-item">Cras justo odio</li>',
                'name' : 'List group item',
                'action_menu' : {
                    'add' : ['h4', 'p', 'img','badge']
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                })
            });

            f.addComponentType({
                'type' : 'list-group-item-link',
                'selector' : 'a.list-group-item',
                priority: 100,
                parent_selector: '.list-group',
                'code' : '<a class="list-group-item" href="#">Cras justo odio</a>',
                'name' : 'List group item',
                'action_menu' : {
                    'add' : ['h4', 'p', 'img','badge']
                },
                'sections' : gh.addPrefixToSectionsAndFields({
                    link : {
                        name : 'Link',
                        fields : {
                            'active' : {
                                'type' : 'checkbox',
                                'name' : 'Active',
                                'value' : 'active',
                                'action' : 'apply_class'
                            }
                        }
                    }
                })
            });

        })()


        //panels

        f.addComponentType({
            'type' : 'panel',
            tags: 'major',
            'selector' : 'div.panel',
            priority: 100,
            'code' : '<div class="panel">\
        <div class="panel-body">Basic panel example</div>\
    </div>',
            'name' : 'Panel',
            action_menu: {
                add: ['panel-heading', 'panel-footer', 'table', 'list-group'],
                on_add : function (pgel, pgnew, newdef) {
                    if (newdef.type == 'panel-heading') {
                        pgel.prepend(pgnew);
                        //$el.prepend($new);
                    } else if (newdef.type == 'panel-footer') {
                        pgel.append(pgnew);
                        //$el.append($new);
                    } else if (newdef.type == 'table' || newdef.type == 'list-group') {
                        var pgb = pgel.find('> .panel-body');
                        if (pgb.length == 0) {
                            pgel.append(pgnew);
                            //$el.append($new);
                        } else {
                            var pglastb = pgb[pgb.length - 1];
                            pgnew.insertAfter(pglastb);
                            //$new.insertAfter($b.last());
                        }
                    }
                }
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'panel' : {
                    name : 'Panel',
                    fields : {
                        variation : {
                            type: 'select',
                            name: 'Type',
                            action: 'apply_class',
                            'show_empty' : true,
                            'options' : [
                                {'key' : 'panel-primary', 'name' : 'Primary'},
                                {'key' : 'panel-success', 'name' : 'Success'},
                                {'key' : 'panel-info', 'name' : 'Info'},
                                {'key' : 'panel-warning', 'name' : 'Warning'},
                                {'key' : 'panel-danger', 'name' : 'Danger'}
                            ]
                        }
                    }
                }
            })
        });



        f.addComponentType({
            'type' : 'panel-heading',
            'selector' : 'div.panel-heading',
            parent_selector: '.panel',
            priority: 100,
            'code' : '<div class="panel-heading">Panel heading without title</div>',
            'name' : 'Panel heading',
            'sections' : gh.addPrefixToSectionsAndFields({
                'style' : {
                    name : 'Panel heading',
                    fields : {
                        'tag' : {
                            'type' : 'select',
                            'name' : 'Title tag',
                            'action' : 'custom',
                            show_empty: true,
                            'options' : hoptions,
                            get_value: function (pgel) {
                                for (var i = 0; i < hoptions.length; i++) {
                                    if (pgel.find(hoptions[i].key).length > 0) {
                                        return hoptions[i].key;
                                    }
                                }
                                return null;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var t = pgel.text();
                                if (value) {
                                    var pgh = pgCreateNodeFromHtml('<' + value + '></' + value + '>').html(t);
                                    pgel.html('').append(pgh);
                                } else {
                                    pgel.html(t);
                                }
                                return value;
                            }
                        }
                    }
                }
            })
        });

        f.addComponentType({
            'type' : 'panel-footer',
            'selector' : 'div.panel-footer',
            parent_selector: '.panel',
            'code' : '<div class="panel-footer">Panel footer</div>',
            'name' : 'Panel footer',
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        });



/*
        var getCssValueForShorthandable = function(values, f, sf, base_on_equal) {
            var ptoa = {
                left: [0, 1, 1, 3],
                right: [0, 1, 1, 1],
                top: [0, 0, 0, 0],
                bottom: [0, 0, 2, 2]
            };
            var v = null;
            $.each(values, function(fn, fv) {
                var vobj = null;
                if(fn == f + '-' + sf) {
                    v = fv.value;
                } else if(fn == f) {
                    if(base_on_equal) {
                        v = fv.value;
                    } else {
                        var a = splitCssValue(fv.value);
                        if(a.length == 0) return null;

                        var imp = null;
                        if(a[a.length-1].match(/!important/i)) {
                            imp = a.pop();
                        }
                        if(a.length > 0 && a.length <= 4) {
                            v = a[ptoa[sf][a.length-1]];
                        }
                        if(imp) v = v + " " + imp;
                    }
                }
            });
            return v;
        }
*/

        f.addComponentType({
            'type' : 'well',
            'selector' : 'div.well',
            'code' : '<div class="well">Look, I\'m in a well!</div>',
            'name' : 'Well',
            'sections' : gh.addPrefixToSectionsAndFields({
                'panel' : {
                    name : 'Well',
                    fields : {
                        variation : {
                            type: 'select',
                            name: 'Size',
                            action: 'apply_class',
                            'show_empty' : true,
                            'options' : [
                                {'key' : 'well-lg', 'name' : 'Large'},
                                {'key' : 'well-sm', 'name' : 'Small'}
                            ]
                        }
                    }
                }
            })
        });


        var link = {
            'type' : 'link',
            'selector' : 'a[href]',
            'code' : '<a href="http://">Link</a>',
            'name' : 'Link',
            'inline_edit' : true,
            'sections' : gh.addPrefixToSectionsAndFields({})
        }
        f.addComponentType(link);

        /*
        link = {
            'type' : 'anchor',
            'selector' : 'a[name]',
            'code' : '<a name="name"></a>',
            preview: 'none',
            'name' : 'Anchor',
            'inline_edit' : true,
            'sections' : gh.addPrefixToSectionsAndFields({
                link : {
                    name : 'Anchor',
                    fields : {
                        'name' : {name : 'Name', type : 'text', action: 'element_attribute', attribute: 'name'}
                    }
                }
            })
        }
        f.addComponentType(link);*/

        //Javascript
        var def_modal = {
            'type' : 'bs-modal',
            'selector' : '.modal',
            'code' : function() {
                var id = getUniqueId('modal', null, 0);
                return '<div class="modal fade pg-show-modal" id="' + id + '" tabindex="-1" role="dialog" aria-hidden="true">\
                <div class="modal-dialog">\
            <div class="modal-content">\
                <div class="modal-header">\
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>\
                    <h4 class="modal-title">Modal title</h4>\
                </div>\
                <div class="modal-body">\
                    <p>One fine body&hellip;</p>\
                </div>\
                <div class="modal-footer">\
                    <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>\
                    <button type="button" class="btn btn-primary">Save changes</button>\
                </div>\
            </div>\
            </div>\
            </div>'
            },
            preview: '<div class="modal open fade in" style="display:block;opacity:1;height:300px;width:500px;position:relative;">\
                <div class="modal-dialog modal-sm">\
            <div class="modal-content">\
                <div class="modal-header">\
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>\
                    <h4 class="modal-title">Modal title</h4>\
                </div>\
                <div class="modal-body">\
                    <p>One fine body&hellip;</p>\
                </div>\
                <div class="modal-footer">\
                    <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>\
                    <button type="button" class="btn btn-primary">Save changes</button>\
                </div>\
            </div>\
            </div>\
            </div>\
            ',
            'name' : 'Modal',
            _editModalTriggers: function(pgel, $clicked) {
                var q = new PgQuickSelectElement({
                    title: 'Edit triggers for showing the modal',
                    description: '<p>Select an element (usually a button or a link) that should open the modal.</p>',
                    reselect: true,
                    target: $clicked,
                    current_col: function() {
                        var mid = pgel.getAttribute('id');
                        if(mid) {
                            var col = new PgCollection();
                            col.setList(pgel.document.findWithMultipleAttrValues([
                                {
                                    name: 'data-toggle',
                                    value: 'modal'
                                },
                                {
                                    name: 'data-target',
                                    value: '#' + mid
                                }
                            ]))
                            return col;
                        } else {
                            return null;
                        }
                    },
                    remove: true,
                    func: function(col, remove_col) {
                        var mid = pgel.getAttribute('id');
                        if(!mid) {
                            mid = pgel.getUniqueIdAttribute('modal');
                            pgel.setAttribute('id', mid);
                        }
                        var api = new PgApi();
                        api.setAttribute(col, [
                            {
                                name: 'data-toggle',
                                value: 'modal'
                            },
                            {
                                name: 'data-target',
                                value: '#' + mid
                            }
                        ])
                        api.removeAttribute(remove_col, ['data-toggle', 'data-target']);
                        pinegrow.showQuickMessage('The modal triggers are set.')
                    }
                })
            },
            on_get_menu_commands: function(pgel, list, $el) {
                var _this = this;
                list.push({
                    icon: 'icon-267',
                    label: 'Edit modal triggers...',
                    header: 'Modal',
                    tooltip: 'Edit triggers for showing the modal.',
                    action: function(pgel, $clicked) {
                        _this._editModalTriggers(pgel, $clicked || $el)
                    }
                })
            },
            tags: 'major',
            on_inserted : function(pgel, page) {
                showJavascriptMessage();
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                bsmodal : {
                    name : 'Modal options',
                    fields : {
                        'bssize' : {
                            'type' : 'select',
                            'name' : 'Size',
                            'action' : 'custom',
                            'show_empty' : true,
                            'options' : [
                                {key: 'modal-sm', name: 'Small'},
                                {key: 'modal-lg', name: 'Large'}
                            ],
                            get_value: function (pgel) {
                                var pgm = pgel.findOne('.modal-dialog');

                                if (pgm && pgm.hasClass('modal-sm')) return 'modal-sm';
                                if (pgm && pgm.hasClass('modal-lg')) return 'modal-lg';
                                return null
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pgm = pgel.findOne('.modal-dialog');

                                if(pgm) {
                                    pgm.removeClass('modal-sm');
                                    pgm.removeClass('modal-lg');
                                    if (value) pgm.addClass(value);
                                }
                                return value;
                            }
                        },
                        bsbackdrop : {
                            'type' : 'select',
                            'name' : 'Backdrop',
                            'action' : 'element_attribute',
                            attribute : 'data-backdrop',
                            'show_empty' : true,
                            'options' : [
                                {key: 'true', name: 'Yes'},
                                {key: 'false', name: 'No'},
                                {key: 'static', name: 'Static'}
                            ]
                        },
                        bsescape : {
                            'type' : 'select',
                            'name' : 'Close on ESC',
                            'action' : 'element_attribute',
                            attribute : 'data-keyboard',
                            'show_empty' : true,
                            'options' : [
                                {key: 'true', name: 'Yes'},
                                {key: 'false', name: 'No'}
                            ]
                        },
                        bsremote : {
                            'type' : 'text',
                            'name' : 'Remote url',
                            'action' : 'element_attribute',
                            attribute : 'data-remote'
                        },
                        bseditshow : {
                            'type' : 'checkbox',
                            'name' : 'Show during editing',
                            'value' : 'pg-show-modal',
                            'action' : 'custom',
                            get_value: function (pgel) {
                                return pgel.hasClass('pg-show-modal') ? 'pg-show-modal' : null;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                if (value) {
                                    pgel.addClass(value);
                                } else {
                                    pgel.removeClass('pg-show-modal');
                                }
                                removeDisplayStyle(pgel);
                                return value;
                            }
                        },
                        bsmodaltriggers : {
                            'type' : 'button',
                            'action': 'button',
                            'name' : 'Modal triggers...',
                            'func' : function(pgel, $button) {
                                def_modal._editModalTriggers(pgel, $button);
                            }
                        },
                    }
                }
            })
        }
        f.addComponentType(def_modal)

        f.addComponentType({
            'type' : 'bs-dropdown',
            'selector' : '.dropdown',
            'code' : '<div class="dropdown">\
                <a data-toggle="dropdown" href="#">Dropdown trigger</a>\
    <ul class="dropdown-menu" role="menu">\
    <li><a href="#">Action</a></li>\
    <li><a href="#">Another action</a></li>\
    <li><a href="#">Something else here</a></li>\
<li class="divider"></li>\
    <li><a href="#">Separated link</a></li>\
</ul>\
    </div>',
            on_inserted : function() {
                showJavascriptMessage();
            },
            on_changed : function() {
               // showJavascriptMessage();
            },
            'name' : 'Dropdown',
            tags: 'major',
            'action_menu' : {
                'add' : ['button-dropdown-item'],
                'on_add' : function (pgel, pgnew, newdef, prepend) {
                    var pgul = pgel.find('> ul.dropdown-menu');
                    if (pgul.length == 0) {
                        pgul = pgCreateNodeFromHtml('<ul class="dropdown-menu" role="menu"></ul>');
                        pgel.append(pgul);
                    }
                    else {
                        pgul = pgul[0];
                    }

                    if (prepend) {
                        pgul.prepend(pgnew);
                    } else {
                        pgul.append(pgnew);
                    }
                }
            },
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        });



        f.addComponentType({
            'type' : 'bs-js-tabs',
            'selector' : null,
            'code' : function() {
                var id1 = getUniqueId('tab', null, 0);
                var id2 = getUniqueId('tab', null, id1);
                var id3 = getUniqueId('tab', null, id2);
                var id4 = getUniqueId('tab', null, id3);

                return '<ul class="nav nav-tabs">\
                    <li class="active"><a href="#' + id1 + '" data-toggle="tab">Home</a></li>\
                    <li><a href="#' + id2 + '" data-toggle="tab">Profile</a></li>\
                    <li><a href="#' + id3 + '" data-toggle="tab">Messages</a></li>\
                    <li><a href="#' + id4 + '" data-toggle="tab">Settings</a></li>\
                </ul>';
            },
            'name' : 'Tabs + Panes',
            tags: 'major',
            priority: 100,
            on_inserted : function(pgel) {
                var pgtc = pgCreateNodeFromHtml('<div class="tab-content"></div>').insertAfter(pgel);

                var pgelchildren = pgel.children;
                for (var i = 0; i < pgelchildren.length; i++) {
                    var pgt = pgelchildren[i]

                    var pgta = pgt.findOne('>a');
                    if(pgta) {
                        var id = pgta.getAttr('href');
                        if (id) id = id.replace('#', '');
                        var pgp = pgCreateNodeFromHtml('<div class="tab-pane"><p>Tab ' + (i + 1) + ' content goes here...</p></div>');
                        if (id) pgp.setAttr('id', id);
                        if (i == 0) pgp.addClass('active');
                        pgtc.append(pgp);
                    }
                }
                showJavascriptMessage();
            },
            on_changed : function() {
                //showJavascriptMessage();
            },
            'sections' : gh.addPrefixToSectionsAndFields({
            })
        });

        f.addComponentType({
            'type' : 'fd-tabs-item',
            'selector' : function(pgel) {
                return pgel.tagName == 'dd' && pgel.parent.hasClass('tabs');
            },
            'code' : function() {
                var id1 = getUniqueId('panel', null, 0);

                return '<dd><a href="#' + id1 + '">Tab</a></dd>';
            },
            'name' : 'Tabs item',
            tags: 'major',
            priority: 100,
            'sections' : gh.addPrefixToSectionsAndFields({
                'fdacc' : {
                    name: 'Item options',
                    fields: {
                        fddest : {
                            'type' : 'text',
                            'name' : 'Panel id',
                            'action' : 'custom',
                            live_update : false,
                            set_value : function (pgel, value, values, oldValue, eventType) {
                                var pga = pgel.findOne('> a');
                                pga.setAttr('href', '#' + value);

                                var pgtabs = pgel.parent.next();
                                if (pgtabs.find('#' + value).length == 0) {
                                    showAlert('Can not find tab content with this id.', 'No tab content');
                                } else {
                                    //showOrbitMessage();
                                }
                                return value;
                            },
                            get_value: function (pgel) {
                                var h = pgel.findOne('> a').getAttr('href');
                                return h ? h.replace('#', '') : null;
                            }
                        },
                        fdname : {
                            'type' : 'text',
                            'name' : 'Name',
                            'action' : 'custom',
                            live_update : true,
                            set_value : function (pgel, value, values, oldValue, eventType) {
                                var pga = pgel.findOne('> a');
                                pga.html(value);
                                return value;
                            },
                            get_value: function (pgel) {
                                return pgel.findOne('> a').html();
                            }
                        },
                        fdactive: {
                            type: 'checkbox',
                            name: 'Active',
                            action: 'custom',
                            value: '1',
                            set_value : function (pgel, value, values, oldValue, eventType) {
                                var pga = pgel.findOne('> a');
                                var h = pga.getAttr('href');
                                var pgtabs = pgel.parent.next();

                                if (h) {
                                    var pgtab = pgtabs.findOne(h);
                                    if (value) {
                                        pgtab.addClass('active');
                                    } else {
                                        pgtab.removeClass('active');
                                    }
                                }
                                return value;
                            },
                            get_value: function (pgel) {
                                return pgel.hasClass('active');
                            }
                        }
                    }
                }
            })
        });


        f.addComponentType({
            'type' : 'bs-accordion',
            'selector' : '.panel-group',
            'code' : function() {
                var pid = getUniqueId('panels', null, 0);
                var id1 = getUniqueId('collapse', null, 0);
                var id2 = getUniqueId('collapse', null, id1);
                var id3 = getUniqueId('collapse', null, id2);

                return '<div class="panel-group" id="' + pid + '">\
                    <div class="panel panel-default">\
                    <div class="panel-heading">\
                        <h4 class="panel-title">\
                            <a data-toggle="collapse" data-parent="#' + pid + '" href="#' + id1 + '">\
                            Collapsible Group Item #1\
                            </a>\
                        </h4>\
                    </div>\
                    <div id="' + id1 + '" class="panel-collapse collapse in">\
                    <div class="panel-body">\
                    Anim pariatur cliche reprehenderit, enim eiusmod high life accusamus terry richardson ad squid.\
                    </div>\
                    </div>\
                </div>\
                    <div class="panel panel-default">\
                        <div class="panel-heading">\
                            <h4 class="panel-title">\
                                <a class="collapsed" data-toggle="collapse" data-parent="#' + pid + '" href="#' + id2 + '">\
                                Collapsible Group Item #2\
                                </a>\
                            </h4>\
                        </div>\
                        <div id="' + id2 + '" class="panel-collapse collapse">\
                            <div class="panel-body">\
                            Anim pariatur cliche reprehenderit, enim eiusmod high life accusamus terry richardson ad squid.\
                            </div>\
                        </div>\
                    </div>\
                    <div class="panel panel-default">\
                        <div class="panel-heading">\
                            <h4 class="panel-title">\
                                <a class="collapsed" data-toggle="collapse" data-parent="#' + pid + '" href="#' + id3 + '">\
                                Collapsible Group Item #3\
                                </a>\
                            </h4>\
                        </div>\
                        <div id="' + id3 + '" class="panel-collapse collapse">\
                            <div class="panel-body">\
                            Anim pariatur cliche reprehenderit, enim eiusmod high life accusamus terry richardson ad squid.\
                            </div>\
                        </div>\
                    </div>\
                </div>';
            },
            'name' : 'Accordion',
            tags: 'major',
            priority: 100,
            action_menu: {
                add: ['bs-accordion-item'],
                on_add : function (pgel, pgnew, newdef, prepend) {
                    var id = pgel.getAttr('id');
                    if (id) {
                        var pga = pgnew.find('.panel-title >a');
                        if (pga.length > 0) {
                            pga = pga[0];
                            pga.setAttr('data-parent', '#' + id);
                        }
                    }

                    if (prepend) {
                        pgel.prepend(pgnew);
                    } else {
                        pgel.append(pgnew);
                    }
                }
            },
            on_inserted : function() {
                showJavascriptMessage();
            },
            on_changed : function() {
                //showJavascriptMessage();
            },
            'sections' : gh.addPrefixToSectionsAndFields({

            })
        });

        f.addComponentType({
            'type' : 'bs-accordion-item',
            'selector' : null,
            'code' : function() {
                var id1 = getUniqueId('collapse', null, 0);

                return '<div class="panel panel-default">\
                    <div class="panel-heading">\
                    <h4 class="panel-title">\
                    <a class="collapsed" data-toggle="collapse" data-parent="#accordion" href="#' + id1 + '">\
                    Collapsible Group Item\
                    </a>\
                    </h4>\
                </div>\
                    <div id="' + id1 + '" class="panel-collapse collapse">\
                        <div class="panel-body">\
                        Anim pariatur cliche reprehenderit, enim eiusmod high life accusamus terry richardson ad squid.\
                    </div>\
                    </div>\
                </div></div>';
            },
            'name' : 'Accordion item',
            tags: 'major',
            priority: 100,
            'sections' : gh.addPrefixToSectionsAndFields({

            })
        });

        var callSlider = function(pgel, func, msg) {
            var id = pgel.getId();
            var code = '$(\'[data-pg-id="' + id + '"]\').' + func + ';';

            pinegrow.setIgnoreClicks(true);
            pgel.executeScript(code);
            pinegrow.setIgnoreClicks(false);
            if(msg) {
                pinegrow.showQuickMessage(msg);
            }
        }

        var gotoSlide = function(pgel) {
            var slider = pgel.closest('.carousel');
            callSlider(slider, "carousel('pause')");
            var num = pgel.index();
            callSlider(slider, "carousel(" + (num) + ")", "Going to slide " + (num + 1) + "...");
        }

        f.addComponentType({
            'type' : 'bs-carousel',
            'selector' : '.carousel',
            'code' : function() {
                var pid = getUniqueId('carousel', null, 0);

                return '<div id="' + pid + '" class="carousel slide" data-ride="carousel">\
                    <!-- Indicators -->\
                    <ol class="carousel-indicators">\
                        <li data-target="#' + pid + '" data-slide-to="0" class="active"></li>\
                        <li data-target="#' + pid + '" data-slide-to="1"></li>\
                        <li data-target="#' + pid + '" data-slide-to="2"></li>\
                    </ol>\
                    <!-- Wrapper for slides -->\
                     <div class="carousel-inner">\
                         <div class="item active">\
                             <img src="' + getPlaceholderImage() + '" alt=""/>\
                             <div class="carousel-caption">\
                                 <h3>Slide 1 title</h3>\
                                 <p>Slide 1 description.</p>\
                             </div>\
                         </div>\
                         <div class="item">\
                             <img src="' + getPlaceholderImage() + '" alt=""/>\
                             <div class="carousel-caption">\
                                 <h3>Slide 2 title</h3>\
                                 <p>Slide 2 description.</p>\
                             </div>\
                         </div>\
                         <div class="item">\
                             <img src="' + getPlaceholderImage() + '" alt=""/>\
                             <div class="carousel-caption">\
                                 <h3>Slide 3 title</h3>\
                                 <p>Slide 3 description.</p>\
                             </div>\
                         </div>\
                     </div>\
                     <!-- Controls -->\
                     <a class="left carousel-control" href="#' + pid + '" data-slide="prev">\
                         <span class="glyphicon glyphicon-chevron-left"></span>\
                     </a>\
                     <a class="right carousel-control" href="#' + pid + '" data-slide="next">\
                         <span class="glyphicon glyphicon-chevron-right"></span>\
                     </a>\
                 </div>';
            },
            'name' : 'Carousel',
            tags: 'major',
            priority: 100,
            action_menu: {
                actions : [
                    {label: "Pause Carousel", action: function(pgel) {
                        callSlider(pgel, "carousel('pause')", "Carousel paused.");
                    }},
                    {label: "Resume Carousel", action: function(pgel) {
                        callSlider(pgel, "carousel('cycle')", "Carousel resumed.");
                    }},
                    {label: "Next Slide", action: function(pgel) {
                        callSlider(pgel, "carousel('next')");
                    }},
                    {label: "Previous Slide", action: function(pgel) {
                        callSlider(pgel, "carousel('prev')");
                    }}
                ],
                add: ['bs-carousel-item'],
                on_add : function (pgel, pgnew, newdef, prepend) {
                    var pgol = pgel.find('.carousel-indicators');
                    var max = 0;
                    var pginner = pgel.find('.carousel-inner');
                    pginner = pginner[0];

                    var i = 0;
                    if (pginner) {
                        i = pginner.children.length;
                    }

                    var id = pgel.getAttr('id');
                    if (!id) id = '';
                    var pgli = pgCreateNodeFromHtml('<li data-target="#' + id + '" data-slide-to="' + i + '"></li>');
                    if (prepend) {
                        if (pginner) pginner.prepend(pgnew);
                        if (pgol.length > 0) pgol[0].prepend(pgli);
                    } else {
                        if (pgol.length > 0) pgol[0].append(pgli);
                        if (pginner) pginner.append(pgnew);
                    }
                }
            },
            on_inserted : function() {
                showJavascriptMessage();
            },
            on_changed : function() {
                //showJavascriptMessage();
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                bscarousel : {
                    name : 'Carousel options',
                    fields : {
                        bsinterval : {
                            'type' : 'text',
                            'name' : 'Interval',
                            'action' : 'element_attribute',
                            attribute : 'data-interval'
                        },
                        bspause : {
                            'type' : 'select',
                            'name' : 'Pause on',
                            'action' : 'element_attribute',
                            attribute : 'data-pause',
                            'show_empty' : true,
                            'options' : [
                                {key: 'hover', name: 'Hover'}
                            ]
                        },
                        bswrap : {
                            'type' : 'select',
                            'name' : 'Wrap',
                            'action' : 'element_attribute',
                            attribute : 'data-wrap',
                            'show_empty' : true,
                            'options' : [
                                {key: 'true', name: 'Yes'},
                                {key: 'false', name: 'No'}
                            ]
                        }
                    }
                }
            })
        });


        f.addComponentType({
            'type' : 'bs-carousel-item',
            'selector' : function(pgel) {
                return pgel.hasClass('item') && pgel.parent.hasClass('carousel-inner');
            },
            'code' : function() {
                return '<div class="item">\
                             <img src="' + getPlaceholderImage() + '" alt=""/>\
                             <div class="carousel-caption">\
                                 <h3>Slide title</h3>\
                                 <p>Slide description.</p>\
                             </div>\
                         </div>';
            },
            'name' : 'Carousel slide',
            tags: 'major',
            priority: 100,
            on_selected: function(pgel) {
                gotoSlide(pgel);
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'carouselslide' : {
                    name : 'Slide',
                    fields : {
                        active : {
                            'type' : 'checkbox',
                            'name' : 'Active slide',
                            'action' : 'apply_class',
                            'value' : 'active'
                        }
                    }
                }
            })
        });

        f.addComponentType({
            'type' : 'bsmedia',
            'selector' : '.embed-responsive',
            'code' : '<div class="embed-responsive embed-responsive-16by9">\
                <iframe class="embed-responsive-item" src="http://www.youtube.com/embed/tbbKjDjMDok"></iframe>\
                </div>',
            'drag_helper' : '<div class="embed-responsive embed-responsive-16by9">\
                <div class="pg-empty-placeholder">Media</div>\
                </div>',
            'name' : 'Responsive media',
            tags: 'major',
            priority: 100,
            action_menu: {
                add: ['html-iframe', 'html-embed', 'html-object']
            },
            'sections' : gh.addPrefixToSectionsAndFields({
                'bsmedia' : {
                    name : 'Media options',
                    fields : {
                        active : {
                            'type' : 'select',
                            'name' : 'Aspect ratio',
                            'action' : 'apply_class',
                            'show_empty' : false,
                            'options' : [
                                {key: 'embed-responsive-4by3', name: '4 x 3'},
                                {key: 'embed-responsive-16by9', name: '16 x 9'}
                            ]
                        }
                    }
                }
            })
        });

        //Add BS common sections to all elements
        var tag = {
            'type' : 'tag',
            'selector' : function(pgel) { return true },
            'name' : 'Div',
            'display_name' : 'tag',
            'priority' : 2001,
            'sections' : gh.addPrefixToSectionsAndFields(crsaAddStandardSections({
                aaaaaattributes : {
                    inherit: true
                }
            }))
        }
        f.addComponentType(tag);



        var getTypes = function(list) {
            var r = [];
            for(var i = 0; i < list.length; i++) {
                if(typeof list[i] == 'string') {
                    var def = f.getComponentType(list[i]);
                    if(def) {
                        r.push(def);
                    }
                } else {
                    r.push(list[i]);
                }
            }
            return r;
        }

        var section = new PgFrameworkLibSection('bsgrid', 'Grid');
        section.setComponentTypes(getTypes(['bs-container','bs-row','bs-column','thumbnail-img', 'thumbnail-content', 'bs-clear']));
        f.addLibSection(section);

        section = new PgFrameworkLibSection('bsbuttons', 'Buttons');
        section.setComponentTypes( getTypes(['bs-button' , 'button-close', 'caret', 'button-toolbar', 'button-group', 'button-dropdown', 'dropdown-menu', 'button-dropdown-item']));
        f.addLibSection(section);

        section = new PgFrameworkLibSection('bstypo', 'Text &amp; Images');
        section.setComponentTypes( getTypes(['h1','h2','h3','h4','h5','h6','small', 'page-header', 'p', 'link', 'anchor', 'abbr','address','blockquote', 'glyphicon','img','hr']));
        f.addLibSection(section);

        section = new PgFrameworkLibSection('bsui', 'UI elements');
        section.setComponentTypes( getTypes(['span-label', 'badge', 'alert', 'progress', 'progress-bar', 'media-list', 'media-list-item', 'list-group', 'list-group-item', 'panel', 'panel-heading', 'panel-footer', 'well']));
        f.addLibSection(section);

        section = new PgFrameworkLibSection('bslists', 'Lists');
        section.setComponentTypes(getTypes(['list', 'list_item', 'description', 'description-term', 'description-def']));
        f.addLibSection(section);

        section = new PgFrameworkLibSection('bstable', 'Tables');
        section.setComponentTypes( getTypes(['table','thead', 'tbody', 'tr', 'td']));
        f.addLibSection(section);

        section = new PgFrameworkLibSection('bscode', 'Code');
        section.setComponentTypes( getTypes(['code', 'code-block', 'code-kbd', 'code-var', 'code-sample']));
        f.addLibSection(section);

        section = new PgFrameworkLibSection('bsform', 'Forms');
        section.setComponentTypes( getTypes(['form', 'form-group', 'form-textarea-group', 'form-select-group', 'form-select', 'form-option', 'form-checkbox-group', 'form-radio-group', 'form-static-group', 'form-static', 'form-input', 'textarea', 'form-checkbox','form-radio', 'label', 'form-fieldset', 'form-help', 'form-input-group']));
        f.addLibSection(section);

        section = new PgFrameworkLibSection('bsnavbar', 'Navigation');
        section.setComponentTypes( getTypes(['navbar','tabs', 'breadcrumb', 'pagination', 'pager', 'jumbotron']));
        f.addLibSection(section);

        section = new PgFrameworkLibSection('bsmedia', 'Media');
        section.setComponentTypes( getTypes(['bsmedia']));
        f.addLibSection(section);

        section = new PgFrameworkLibSection('bsjs', 'Javascript');
        section.setComponentTypes( getTypes(['bs-modal','bs-dropdown','button-dropdown-item', 'bs-js-tabs', 'alert', 'bs-accordion', 'bs-carousel']));
        f.addLibSection(section);

        f.on_set_inline_style = function(page, o) {
            o.css += gh.getViewCss();

            o.css += '\
            .pg-show-modal {\
            position: relative;\
            top: auto;\
            right: auto;\
            left: auto;\
            bottom: auto;\
            display: block;\
            opacity: 1;\
            }\
            .pg-show-modal.fade .modal-dialog {\
            -webkit-transform: translate(0, 0);\
            -moz-transform: translate(0, 0);\
            transform: translate(0, 0);\
            }';
        }

        var removeDisplayStyle = function(pgm) {
            var s = pgm.getAttr('style');
            if (s) {
                s = s.replace(/display\:\s*[a-z]*;/i,'');
                if (s.length > 0) {
                    pgm.setAttr('style', s);
                } else {
                    pgm.removeAttr('style');
                }
            }
        }

        f.aaaon_get_source = function(crsaPage, $html) {
            $html.find('.modal-backdrop').remove();
            $html.find('.modal').each(function(i,m) {
                var $m = $(m);
                removeDisplayStyle($m);
            });
            $html.find('body').removeClass('modal-open');
            $html.find('.tooltip').remove();
            $html.find('.popover').remove();

            $html.find('[data-original-title]').each(function(i,e) {
                var $e = $(e);
                $e.attr('title', $e.attr('data-original-title')).removeAttr('data-original-title');
            });
        }

        f.on_page_loaded = function(crsaPage) {
            return;
            $(function() {
                var $html = crsaPage.get$Html();
                $html.find('.carousel').each(function(i,c) {
                    var $c = $(c);
                    $c.carousel('pause');
                    crsaQuickMessage("Carousel was paused.", 2000, false);
                });
            });
        }

        f.on_build_actions_menu = function(page, menus, pgel, $el) {
            if (pgel.getClasses().indexOf("row") > -1) {
                menus.push(
                    {label: "Update column breaks", class: 'insert-col-breaks', kbd: null, manage_change: true, action: function($el) {
                        var selectedPage = pinegrow.getSelectedPage();
                        pinegrow.makeChanges(pgel, "Insert column breaks", function() {

                            var pgClearfixList = pgel.find('> .clearfix');
                            for (var i = 0; i < pgClearfixList.length; i++) {
                                if (pgClearfixList[i].html().length == 0) {
                                    pgClearfixList[i].remove();
                                }
                            }

                            var pgCols = pgel.children;
                            var sumSize = {};

                            var getAllSizes = function (currentSizes, offset) {
                                var resSizes = {}
                                var addedSizes = [];
                                var length;
                                for(var size in currentSizes) {
                                    for (var i = sizes.indexOf(size); i<sizes.length; i++) {
                                        if (addedSizes.indexOf(sizes[i]) > -1) break;

                                        if (currentSizes[sizes[i]] > -1)
                                            length = currentSizes[sizes[i]];

                                        if (!resSizes[sizes[i]]) resSizes[sizes[i]] = 0;
                                        resSizes[sizes[i]] = length;
                                        addedSizes.push(sizes[i]);
                                    }
                                }

                                if (!offset) {
                                    for (var i = 0; i<sizes.length; i++) {
                                        if (!resSizes[sizes[i]]) resSizes[sizes[i]] = num_columns;
                                    }
                                }
                                return resSizes;
                            }

                            for (var i = 0; i < pgCols.length; i++) {
                                var pgcol = pgCols[i];
                                if (pgcol.closingTag == 'text') continue;

                                // var col_node = getElementPgNode($col);
                                var clss = pgcol.getClasses();

                                var currentSizes = {};
                                var offsetSizes = {};
                                var currentAllSizes = {};
                                for (var j = 0; j < clss.length; j++) {
                                    var m = clss[j].match(/col\-(xs|sm|md|lg)-([0-9]+)/);
                                    var o = clss[j].match(/col\-(xs|sm|md|lg)-offset-([0-9]+)/);
                                    if (m) {
                                        currentSizes[m[1]] = parseInt(m[2]);
                                    }
                                    if (o) {
                                        offsetSizes[o[1]] = parseInt(o[2]);
                                    }
                                }

                                var currentAllSizes = getAllSizes(currentSizes);
                                var offsetAllSizes = getAllSizes(offsetSizes, true);
                                for (var size in currentAllSizes) {
                                    if (!sumSize[size]) sumSize[size] = 0;
                                    sumSize[size] += currentAllSizes[size] + (offsetAllSizes[size] || 0);
                                }

                                var visibleClearfix = "";
                                var insertAfter = "", insertBefore = "";
                                for(var size in sumSize) {
                                    if (sumSize[size] >= num_columns) {
                                        if (sumSize[size] == num_columns) {
                                            insertAfter += " visible-" + size + "-block";
                                            sumSize[size] = 0;
                                        }
                                        else {
                                            insertBefore += " visible-" + size + "-block";
                                            sumSize[size] = (currentAllSizes[size] == num_columns ? 0 : currentAllSizes[size]);
                                        }
                                    }
                                }
                                if (insertAfter.length) {
                                    var clrearfix = '<div class="clear-columns clearfix' + insertAfter + '"></div>';
                                    var pgClearfix = pgCreateNodeFromHtml(clrearfix).insertAfter(pgcol);
                                    i++;
                                }
                                if (insertBefore.length) {
                                    var clrearfix = '<div class="clear-columns clearfix' + insertBefore + '"></div>';
                                    var pgprev = pgcol.prev();
                                    if (pgprev.hasClass('clear-columns') && pgprev.hasClass('clearfix')) {
                                        pgprev.addClass(insertBefore.trim());
                                    }
                                    else {
                                        var pgClearfix = pgCreateNodeFromHtml(clrearfix).insertBefore(pgcol);
                                        i++;
                                    }
                                }
                            }

                            // $.fn.crsa('updateStructureAndWireAllElemets', selectedPage.$iframe);
                            pinegrow.showQuickMessage('Column breaks updated.');
                        });
                    }
                })

            }
        }

        f.on_get_menu_points = function(page, pgel, menu, points) {
            gh.getMenuPoints(page, pgel, menu, points);
        }

        f.on_page_view_resized = function(page, pv) {
            gh.onPageViewResized(page, pv);
        }

        f.on_get_device_sizes = function(page, list) {
            gh.getDeviceSizesForPageViewMenu(page, list);
        }

        f.on_page_shown_in_live_view = function(page, pv) {
            gh.show(pv);
        }

        f.on_page_changes_done = function(page, info, page_col) {
            gh.updateHelpersAfterChange(page, info, page_col);
        }

        f.on_inline_editing_done = function(page, pgel) {
            gh.updateHelpersAfterChange(page, null, new PgCollection(pgel));
        }

        f.on_get_page_libs = function(page, list) {
            gh.getPageLibs([
                {name: 'CSS', url: 'css.html'},
                {name: 'Comp.', url: 'components.html'},
                {name: 'JS', url: 'javascript.html'}
            ]).forEach(function(item) {
                list.push(item);
            })
        }

        var extension_added = false;

        f.on_plugin_activated = function(page, done) {

            gh.onFrameworkActivatedOnPage(page);

            //add editable area extension
            if(extension_added) {
                if(done) done(f);
                return;
            }

            if(typeof PgEditableAreaExtension !== 'undefined') {
                var ext = new PgEditableAreaExtension('bs', 'Bootstrap', f);

                ext.addFieldFromProp('button-type', 'Button type', button.sections['bs3.button'].fields['bs3.button-type'], '.btn');

                ext.addFieldFromProp('button-size', 'Button size', button.sections['bs3.button'].fields['bs3.bs_button_size'], '.btn');

                pinegrow.addEditableAreaExtension(ext);
            }
            extension_added = true;
            //end add extension

            if(done) done(f);
        }


        /*

        var res = new PgComponentTypeResource('https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css');
        res.type = 'text/css';
        f.resources.add(res);

        res = new PgComponentTypeResource('https://cdnjs.cloudflare.com/ajax/libs/jquery/3.1.0/jquery.min.js');
        res.type = 'application/javascript';
        res.detect = /jquery/;
        res.footer = true;
        f.resources.add(res);

        res = new PgComponentTypeResource('https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js');
        res.type = 'application/javascript';
        res.footer = true;
        f.resources.add(res);

        f.resources.description = "Include Bootstrap CSS and JS files from Bootstrap CDN. Updating resources will add the latest version of Bootstrap CSS and JS to the page. If you have older or local version of Bootstrap linked to the page, remove the old CSS and JS links from the page.";
*/

        var onReplaceBootstrapCSSCDN = function(page, pgel) {
            var current_url = pgel.getAttribute('href');
            var info = page.getProjectInfo();
            if(info.getSourceStylesheetForCSSStylesheet(current_url)) {
                //this stylesheet is compiled from sass/less source, don't replace it
                return false;
            }
            return true;
        }

        var onReplaceBootstrapCSS = function(page, pgel) {
            var current_url = pgel.getAttribute('href');
            var info = page.getProjectInfo();
            if(info.getSourceStylesheetForCSSStylesheet(current_url)) {
                //this stylesheet is compiled from sass/less source, don't replace it
                return false;
            }
            if(current_url === 'bootstrap/css/bootstrap.min.css' || current_url === 'bootstrap/css/bootstrap.css') {
                return false;
            }
            return true;
        }

        var onReplaceBootstrapJS = function(page, pgel) {
            var current_url = pgel.getAttribute('src');
            if(current_url === 'bootstrap/js/bootstrap.min.js' || current_url === 'bootstrap/js/bootstrap.js') {
                return false;
            }
            return true;
        }

        var res;

        res = gh.addResource('https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css', /bootstrap(\.min|)\.css/i);
        //determines if the current LINK href that matches detect re should be replaced
        res.replace = onReplaceBootstrapCSSCDN;

        gh.addResource('https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js', /jquery(\.min|)\.js/i);
        gh.addResource('https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js', /bootstrap(\.min|)\.js/i);

        gh.addResource('assets/js/jquery.min.js', /jquery(\.min|)\.js/i);
        gh.addResource('assets/js/ie10-viewport-bug-workaround.js', /ie10\-viewport\-bug\-workaround\.js/i);

        res = gh.addResource('bootstrap/js/bootstrap.min.js',  /bootstrap(\.min|)\.js/i);
        res.replace = onReplaceBootstrapJS;

        res = gh.addResource('bootstrap/js/bootstrap.js',  /bootstrap(\.min|)\.js/i);
        res.replace = onReplaceBootstrapJS;

        res = gh.addResource('bootstrap/css/bootstrap.min.css', /bootstrap(\.min|)\.css/i);
        res.replace = onReplaceBootstrapCSS;

        res = gh.addResource('bootstrap/css/bootstrap.css', /bootstrap(\.min|)\.css/i);
        res.replace = onReplaceBootstrapCSS;

        var notRequiredFiles = ["carousel.css", "cover.css", "dashboard.css", "grid.css", "jumbotron.css", "jumbotron-narrow.css", "justified-nav.css", "navbar.css", "new.css", "non-responsive.css", "offcanvas.css", "starter-template.css", "sticky-footer.css", "sticky-footer-navbar.css", "style.css", "theme.css", "offcanvas.js", "offcanvas.min.js"];
        var templatesOrder = ["index.html", "starter-template.html", "dashboard.html", "jumbotron.html", "jumbotron-narrow.html", "justified-nav.html", "navbar.html", "non-responsive.html", "offcanvas.html", "grid.html", "sticky-footer.html", "sticky-footer-navbar.html", "theme.html", "carousel.html", "cover.html"];

        //Register starting page template
        f.addTemplateProjectFromResourceFolder('template', null, 3, function (node) {
            var currentFilesName = notRequiredFiles.filter(function (fileName) {
                return node.name == fileName;
            });
            if (currentFilesName && currentFilesName.length > 0) {
                node.required = false;
            }

            var nodeIndex = templatesOrder.indexOf(node.name);
            if (nodeIndex >= 0) node.order = nodeIndex;
        });
    });
});