$(function() {

    $('body').one('pinegrow-ready', function(e, pinegrow) {

        window.PgSafeUnsplashImages = new PgSafeUnsplashImages();
        window.PgSafeUnsplashImages.load('images/kids/kids-images.json');

        var addAlien = function(name, classes, width, top, right) {
            classes = 'pg-kids-head-alien top-right-inverse ' + classes || '';
            var code = `<img src="images/kids/${name}.png">`;
            var h = `<img src="images/kids/${name}.png" class="${classes} pg-info-panel-draggable" data-code="${pgEncodeAttribute(code)}" style="`;
            if(width) {
                h += `width:${width};`
            }
            if(top) {
                h += `top:${top};`;
            }
            if(right) {
                h += `right:${right};`;
            }
            h += '">';
            return h;
        }

        var addAlienResources = function(p, max, what, ext) {
            ext = ext || 'png';
            what = what || 'alien';
            max = max || 15;
            for(var i = 1; i <= max; i++) {
                p.addResource(`${what}${i}.${ext}`, `images/kids/${what}${i}.${ext}`);
            }
        }

        var addAllResources = function(a) {
            addAlienResources(a, 5, 'background', 'jpg');
            addAlienResources(a, 7, 'rocket');
            addAlienResources(a, 15);
            addAlienResources(a, 10, 'landscape');
            addAlienResources(a, 15, 'food');
            addAlienResources(a, 6, 'picture', 'jpg');
            addAlienResources(a, 7, 'spacerides', 'jpg');
            addAlienResources(a, 6, 'planet', 'jpg');
        }

        pinegrow.addEventHandler('on_image_categories_loaded', function(pagenull, custom_cats) {

            var images = {
            };

            var id = 0;

            var add = function(cat, name, num, ext) {
                var catdata = {
                    key: cat,
                    images: {}
                }
                for(var i = 1; i <= num; i++) {
                    id++;
                    var key = 'htmlplanet-' + id;
                    catdata.images[key] = `images/kids/${name}${i}.${ext}`;
                }
                subcats[cat] = catdata;
            }

            var subcats = {};

            add('Aliens', 'alien', 15, 'png');
            add('Backgrounds','background', 5, 'jpg');
            add('Rockets','rocket', 7, 'png');
            add('Landscape','landscape', 10, 'png');
            add('Planets', 'planet', 6, 'jpg');
            add('Food', 'food', 15, 'png');
            add('Pictures','picture', 6, 'jpg');
            add('Space rides','spacerides', 7, 'jpg');

            custom_cats.push({
                key: 'HTML Planet',
                top: true,
                header: 'HTML Planet images',
                subcats: subcats,
                sizes: null
            })
        });

        pinegrow.kidsTutorial = tutorial;


        var base_css = `
    html {
        height:100%;
    }
    
    body {
        min-height:100%;
        margin:0;
        padding:0;
    }
    
    * {
        box-sizing: border-box;
    }
`


        //Intro lesson
        var intro_lesson = new PgTutorialLesson('intro_lesson', 'alien13', 'Are you ready for the HTML adventure?', 'l1');

        intro_lesson.demo = true;
        intro_lesson.name = `Take a space ride to HTML Planet`;
        intro_lesson.display_title = `Take a space ride to HTML Planet` + addAlien('alien13', 'second', null, '-40px') + addAlien('rocket2', null, null, '-40px');

        intro_lesson.description = makeDesc(
            '568004696',
            ``,
            `<p>Look around the editor and then take off with the rocket:</p>
            <ol>
            <li>Click on the <b>Watch the video</b> button.</li>
            <li>Click anywhere in this text to highlight this step.</li>
            <li>Click on the underlined text, for example ${select('the image of Zootata', 'img[src*=\'alien\']')} to see where things are located on the screen.</li>
            <li>Great, you are ready to go!</li>
</ol>
`,

        )

        var intro_lesson_css = `
body {
    padding: 40px;
    background-image: url('images/kids/background1.jpg');
    background-repeat: no-repeat;
    background-size: cover;
    overflow:hidden;
}

img[src*="rocket"]  {
position:absolute;bottom:0px;right:400px;
filter: drop-shadow(3px 7px 4px rgba(0,0,0,0.22));
transition: transform 5s cubic-bezier(0.86, 0.02, 1.00, 1.00);
}
h1 {
color:#ffffff;
width:320px;
max-width:80%;
text-align:left;
position:absolute;
bottom:300px;
right:40px;
font-size:40px;
}
img[src*="landscape"]  {
position:absolute;left:0;bottom:0;width:100%;
}
img[src*="alien"]  {
position:absolute;bottom:40px;right:70px;
filter: drop-shadow(3px 7px 4px rgba(0,0,0,0.22));
transition: transform 2s, opacity 0.25s;
}
.fly {
transform: translate(10vw, -130vh) rotate(26deg);
}
.jump {
transform: translate(-300px, -30px) scale(0.5);
}
.go-in {
   opacity:0;
}
`;

        intro_lesson.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <img src="rocket4.png" width="200px"/>
        <h1>Hi, I&apos;m Zootata!<br>Do you want to join me on a space ride?</h1>
        <img src="landscape5.png" />
        <img src="alien13.png" width="240px" />
    </body>
</html>`);

        intro_lesson.inject_css = intro_lesson_css;
        intro_lesson.addStylesheet('style.css', '');

        addAllResources(intro_lesson);


        intro_lesson.onCheck = function(page, status) {
            var zootata, rocket;
            page.sourceNode.find('img').forEach(function(pgel) {
                var src = (pgel.getAttribute('src') || '');
                if(src.indexOf('rocket') >= 0) {
                    rocket = pgel;
                } else if(src.indexOf('alien') >= 0) {
                    zootata = pgel;
                }
            })

            if(!zootata) {
                status.message = 'Oops... Zootata is missing! Did you delete the alien image? No problem, use the Undo to bring her back, or Restart the adventure.';
                status.result = 'error';
            } else {
                var h1 = page.sourceNode.findOne('h1');
                h1 && h1.html('Let\'s go 😀');

                status.result = 'ok';


                zootata.addClass('jump');
                setTimeout(function() {
                    zootata.addClass('go-in');
                    rocket && rocket.addClass('fly');
                }, 2500)

                status.delay = 4000;


            }


            status.decoration = addAlien('alien13', 'check-box');
        }

        tutorial.addLesson(intro_lesson);
        //End intro lesson



        var chapter_basic_elements = 'Headings, paragraphs, images and links';

        var h1 = new PgTutorialLesson('h1', 'alien1', chapter_basic_elements, 'l1');

        h1.demo = true;
        h1.name = `Meet the h1 element`;
        h1.display_title = `Meet the ${showElement('h1')} element` + addAlien('alien1');

        h1.description = makeDesc(
            '483417920',
            `<p>The ${showElement('h1')} (Heading 1) element is used for the main heading (title) of the page.</p>`,
            `<p>Add the heading to Blotomic's message:</p>
            <ol>
            <li><b>Drag the H1 element</b> to the top of the message:<br>${h1.getHtmlForLibButton(tag('h1', 'Change me!'), '<h1>Change me!</h1>', null, null, 'body > h1:first-child', 'Place the H1 at the top of the yellow box.')}</li>
            <li>Make sure that the ${select('H1 element', 'h1')} is selected on the page (selected element has a blue border and a menu). Click on the element to select it.</li>
            <li><b>Activate the text editor</b> by clicking on the ${tooltip('text editor', 'edit_text')} icon in the blue menu above the H1 element.</li>
            <li><b>Change the text</b> in the heading. For example, write <code>A special message</code>.</li>
            <li>Click on the <b>${tooltip('Done button', 'edit_text_done')}</b> in the blue Text edit menu above the element when you're done with changing the text.</li>
            <li><b>Open the ${tooltip('code editor', 'code_editor')}</b> to see how the H1 element looks in the code.</li>
            <!-- <li><b>Change the text</b> of the title using the code editor.</li> -->
</ol>
`,

        )
        h1.video = `https://youtube.com/bubi`;

        var h1_css = `
html {
    background-image: url('images/kids/alien1.png');
    background-repeat: no-repeat; 
    background-position: right bottom; 
    min-height: 100%; 
    background-size: 50%;
}

body {
    margin-left: 40px; 
    margin-top: 40px; 
    width: 50%; 
    max-width: 600px; 
    min-height: 10px;
    height: auto;
    font-size: 20px;
    padding-top: 20px;
    padding-left: 30px; 
    padding-right: 30px; 
    padding-bottom: 30px; 
    box-shadow: 5px 15px 37px rgba(0, 0, 0, 0.27); 
    background-color: rgba(255, 244, 185, 0.81);
}
`;

        h1.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><p>Hello! My name is Blotomic. Welcome to HTML Planet! Here you will get to learn HTML and CSS. We also have many fun adventures for you. With the help of HTML Planet you'll be able to make super cool websites in no time! Good luck, I hope you'll enjoy it!</p></body></html>`);

        h1.inject_css = h1_css;
        h1.addStylesheet('style.css', '');

        addAllResources(h1);

        h1.setLibrary({
            content: {
                h1: {
                    code: `<h1>I am the title</h1>`
                }
            }
        })
        h1.setStyle(false);

        var use_structure_to_fix = `<br><br>Use the ${tooltip('structure panel', 'structure')} to fix the problem.`;

        h1.onCheck = function(page, status) {
            var error = null;

            var h1s = page.sourceNode.find('h1');
            if(h1s.length === 0) {
                error = 'There is <b>no H1 element</b> on the page.';
            } else if(h1s.length > 1) {
                error = `There should be <b>only one H1</b> on the page. ${use_structure_to_fix}`
            } else {
                if(h1s[0].text().toLowerCase().indexOf('change me') >= 0) {
                    error = 'Use the Text edit tool to change the title of the message.';
                } else if(h1s[0].validateTree().length) {
                    error = 'The H1 element has <b>code errors</b>. Go to the code editor and check for missing &lt; and &gt; or incorrectly closed tags.'
                } else if(h1s[0].text().trim().length === 0) {
                    error = 'The H1 needs some text.';
                } else if(h1s[0].prev()) {
                    error = 'The H1 element should be <b>at the top of the yellow page</b>.'
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien1', 'check-box');
        }

        tutorial.addLesson(h1);



        //LESSON 2 - P
        var a2_p = new PgTutorialLesson('p', 'alien1', chapter_basic_elements, 'l2');

        a2_p.demo = true;
        a2_p.name = `The P paragraph`;
        a2_p.display_title = `The ${showElement('p')} paragraph` + addAlien('alien1');

        a2_p.description = makeDesc(
            '483913547',
            `<p>The ${showElement('p')} element represents a paragraph and is used for displaying text.</p>`,
            `<p>Blotomic's message is just one big chunk of text. Use the ${showElement('p')} element to divide it into more paragraphs.
</p>
            <ol>
            <li><b>Click on the message text</b> to select the ${select('p')} element.</li>
            <li><b>Activate the text editor</b> by clicking on the ${tooltip('text editor', 'edit_text')} icon in the blue menu above the element.</li>
            <li><b>Split the paragraph</b> into four paragraphs by pressing the ${pgShowKbd('ENTER')} key in the text.</li>
            <li>Press the <b>${tooltip('Done button', 'edit_text_done')}</b> in the text editor menu when you're done with changing the text.</li>
            <li><b>Open the ${tooltip('code editor', 'code_editor')}</b> to explore the code.</li>
            <li><b>PRO Tip:</b> You can select the ${select('whole message', 'body')} and activate the ${tooltip('text editor', 'edit_text')} there to easily edit all the text.</li>
</ol>
`,

        )
        a2_p.video = `https://youtube.com/bubi`;

        a2_p.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><h1>A special message</h1><p>Hello! My name is Blotomic. Welcome to HTML Planet! Here you will get to learn HTML and CSS. We also have many fun adventures for you. With the help of HTML Planet you will be able to make super cool websites in no time! Good luck, I hope you will enjoy it!</p></body></html>`);

        a2_p.inject_css = h1_css;
        a2_p.addStylesheet('style.css', '');

        a2_p.onCheck = function(page, status) {
            var error = null;

            var ps = page.sourceNode.find('p');
            if(ps.length < 3) {
                error = `<p>Split the paragraph P into at least three paragraphs (P elements).</p><p>Use the <b>Edit text</b> tool and press ${pgShowKbd('ENTER')} key to split the paragraph.</p>`;
            } else {
                for(var i = 0; i < ps.length; i++) {
                    if(ps[i].isEmpty()) {
                        error = `<p>The ${getNumberName(i + 1)} paragraph is empty. Each paragraph should contain a chunk of text.</p>`;
                        break;
                    }
                }
            }
            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien1', 'check-box');
        }

        addAllResources(a2_p);
        tutorial.addLesson(a2_p);

        //End Lesson 2



        // Lesson 3
        var a3_img = new PgTutorialLesson('img', 'alien1', chapter_basic_elements, 'l3');

        a3_img.demo = true;
        a3_img.name = `The amazing IMG`;
        a3_img.display_title = `The amazing ${showElement('img')}` + addAlien('alien1');

        a3_img.description = makeDesc(
            '483916801',
            `<p>The ${showElement('img')} element is used for displaying images.</p>`,
            `<p>Discover different aliens from HTML Planet:
</p>
            <ol>
            <li><b>Drag the image</b> of an alien to the page:<br>${h1.getHtmlForLibButton(tag('img', null, {src: 'alien1.png'}), '<img src="alien1.png">')}</li>
            <li>Go to the <b>${tooltip('attributes panel', 'attributes_panel')}</b>.</li>
            <li>Make sure the ${select('img')} element is selected.</li>
            <li><b>Change the source</b> attribute, from <code>alien1.png</code> up to <code>alien15.png</code>.</li>
            <li>Open the <b>${tooltip('code editor', 'code_editor')}</b> and explore the code.</li>
</ol>
`,

        )
        a3_img.video = `https://youtube.com/bubi`;

        a3_img.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body></body></html>`);

        a3_img.inject_css = `
    body {
        padding:40px;
    }
`;
        a3_img.addStylesheet('style.css', '');

        a3_img.onCheck = function(page, status) {
            var error = null;

            var img = page.sourceNode.find('img');
            if(img.length < 1) {
                error = `<p>Drag the alien image to the page!`;
            } else {
                var src = img[0].getAttribute('src');
                if(!src || !src.match(/^alien[1-9][1-5]?\.png$/)) {
                    error = `<p>Go to the <b>Attributes panel</b> and set the <b>Src</b> attribute to any value from <code>alien1.png</code> to <code>alien15.png</code>.</p>`;
                }
            }
            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien1', 'check-box');
        }

        addAllResources(a3_img);

        tutorial.addLesson(a3_img);



        // Lesson 4
        var a4_img = new PgTutorialLesson('img_size', 'alien3', chapter_basic_elements, 'l4');

        a4_img.demo = true;
        a4_img.name = `The IMG width &amp; height`;
        a4_img.display_title = `The ${showElement('img')} width &amp; height` + addAlien('alien3');

        a4_img.description = makeDesc(
            '483919149',
            `<p>The width and height attributes set the size of the ${showElement('img')}.</p>`,
            `<p>Make the alien Bloby fit into the box:
</p>
            <ol>
            <li><b>Click on the ${select('img')}</b> to select it.</li>
            <li>Go to the <b>${tooltip('attributes panel', 'attributes_panel')}</b>.</li>
            <li><b>Adjust the ${field('width', 'prop:width')} and ${field('height', 'prop:height')}</b> attributes to fit Bloby into the box. But he should not be too small.</li>
            <li>Open the <b>${tooltip('code editor', 'code_editor')}</b> and explore the code.</li>
</ol>
`,

        )
        a4_img.video = `https://youtube.com/bubi`;

        a4_img.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><img src="alien3.png" width="500"></body></html>`);

        a4_img.inject_css = `
    body {
        padding:40px;
    }
    
    body:before {
        content: '';
        width:300px;
        height:300px;
        max-width:90%;
        max-height:90vh;
        display:block;
        position:absolute;
        background:#f1f1f1;
        border:4px dashed #aaaaaa;
        top:10px;
        left:10px;
    }
    
    img {
        position:absolute;
        top:10px;
        left:10px;
    }
`;
        a4_img.addStylesheet('style.css', '');

        addAllResources(a4_img);

        a4_img.onCheck = function(page, status) {
            var error = null;

            var img = page.sourceNode.findOne('img');
            if(!img) {
                error = `<p>Where is Bloby? Use Undo or restart the adventure to get him back.</p>`;
            } else {
                var $el = img.get$DOMElement();
                var w = $el.width();
                var h = $el.height();
                if(w > 305 || h > 305) {
                    error = `<p>Bloby is too big!</p>`;
                } else if(w < 100 || h < 100) {
                    error = `<p>Bloby is too small!</p>`;
                }
            }
            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien3', 'check-box');
        }

        tutorial.addLesson(a4_img);




        var a51_page_structure = new PgTutorialLesson('page', 'alien4', chapter_basic_elements, 'l5');

        a51_page_structure.demo = true;
        a51_page_structure.name = `The page structure`;
        a51_page_structure.display_title = `The page structure` + addAlien('alien4');

        a51_page_structure.description = makeDesc(
            '483922455',
            `<p>The main element of the page is the ${showElement('html')} element.</p>`,
            `<p>Explore the page structure:
</p>
            <ol>
            <li>Note, there is nothing to edit in this adventure. Just explore the page structure.</li>
            <li>Open the <b>${tooltip('code editor', 'code_editor')}</b> and explore the structure of the page.</li>
            <li><b>${escapeHtmlCode('<!doctype html>')}</b> tells that HTML language is used to describe the page.</li>
            <li>The <b>${select('html')}</b> element represents the whole page.</li>
            <li>The <b>${select('head')}</b> element contains information about the page.</li>
            <li>The <b>${select('body')}</b> element is the visible part of the page with texts and images.</li>
            <li>Use the <b>${tooltip('structure panel', 'structure')}</b> to explore the structure of the page.</li>
</ol>
`,

        )
        a51_page_structure.video = `https://youtube.com/bubi`;

        a51_page_structure.addPage('index.html', `<!doctype html><html><head>
<link href="tailwind_theme/tailwind.css" rel="stylesheet">
<link href="style.css" rel="stylesheet">
</head><body><h1>Hello, there!</h1><p>The content of the Body element is displayed on the page.</p><img src="alien4.png" width="140"></body></html>`);

        a51_page_structure.inject_css =  `body {
        padding:40px;
    }`;

        a51_page_structure.addStylesheet('style.css','');


        a51_page_structure.onCheck = function(page, status) {
            var error = null;
            status.result = 'ok';
            status.decoration = addAlien('alien4', 'check-box');
        }

        addAllResources(a51_page_structure);

        tutorial.addLesson(a51_page_structure);






        // Lesson 5 - Restaurant
        var a5_rest = new PgTutorialLesson('restaurant', 'alien7', chapter_basic_elements, 'l6');

        a5_rest.demo = true;
        a5_rest.name = `Bloobeek's Restaurant`;
        a5_rest.display_title = `Bloobeek's Restaurant` + addAlien('alien7', null, '70px');

        var food_buttons = `<div class="pg-info-panel-img-grid">`;

        food_buttons += a5_rest.getHtmlForLibButton('H1', `<h1>Yummy Star Munch</h1>`, null, 'Restaurant name 1')
        food_buttons += a5_rest.getHtmlForLibButton('H1', `<h1>Savour’ita</h1>`, null, 'Restaurant name 2')
        food_buttons += a5_rest.getHtmlForLibButton('H1', `<h1>Bloobeek's Fancy Flavour</h1>`, null, 'Restaurant name 3')

        food_buttons += a5_rest.getHtmlForLibButton('P', `<p>Savor the great taste of alien-made food. Our delicious menu will boggle your brain. Our breathtaking choices include:</p>`, null, 'Welcome message')
        food_buttons += a5_rest.getHtmlForLibButton('P', `<p>Black matter donut with soothing space slime</p>`, null, 'Dish name 1')
        food_buttons += a5_rest.getHtmlForLibButton('P', `<p>Dragon brains with a hint of slimy bubbles</p>`, null, 'Dish name 2')
        food_buttons += a5_rest.getHtmlForLibButton('P', `<p>Moon rocks with a sprinkle of purple star powder</p>`, null, 'Dish name 3')

        food_buttons += a5_rest.getHtmlForLibButton(`<img src="images/kids/alien7.png">`, `<img src="alien7.png">`, 'image', 'Bloobeek')

        for(var i = 1; i <= 15; i++) {
            food_buttons += a5_rest.getHtmlForLibButton(`<img src="images/kids/food${i}.png">`, `<img src="food${i}.png">`, 'image', 'Food image ' + i)
        }
        food_buttons += '</div>';

        a5_rest.description = makeDesc(
            '483924832',
            `<p>Create the menu for Bloobeek's restaurant using ${showElement('h1')},  ${showElement('p')} and  ${showElement('img')} elements. Have fun!</p>
${food_buttons}
`,
            ``,

        )
        a5_rest.video = `https://youtube.com/bubi`;

        a5_rest.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body></body></html>`);

        a5_rest.inject_css = `
        @import url('https://fonts.googleapis.com/css2?family=Amatic+SC:wght@700&family=Cormorant+Garamond:wght@300&display=swap');
        
    body {
        padding:40px;
        text-align:center;
        font-family: 'Cormorant Garamond', serif;
        max-width:800px;
        margin:0 auto;
    }
    
    h1 {
        font-family: 'Amatic SC', cursive;
        font-size: 50px;
    }
    
    img {
    }
    
    p {
        font-size: 20px;
        margin: 20px 0;
    }
    
`;
        a5_rest.addStylesheet('style.css', '');

        addAllResources(a5_rest);

        a5_rest.onCheck = function(page, status) {
            var error = null;
            var img = page.sourceNode.findOne('img');
            var h1 = page.sourceNode.findOne('h1');
            var p = page.sourceNode.findOne('p');

            if(!img) {
                error = '<p>Add some images so that visitors can see the food.</p>';
            } else if(!h1) {
                error = '<p>The restaurant needs a name. Use H1 for the name.</p>';
            } else if(!p) {
                error = '<p>Add some text describing the food and the restaurant.</p>';
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien7', 'check-box');
        }

        tutorial.addLesson(a5_rest);

        // End lesson


        var chapter_links = chapter_basic_elements;

        // Lesson 4
        var a6_link = new PgTutorialLesson('link', 'alien4', chapter_links, 'l7');

        a6_link.demo = true;
        a6_link.name = `Link, the teleporter`;
        a6_link.display_title = `Link ${showElement('a')}, the teleporter` + addAlien('alien4');

        a6_link.description = makeDesc(
            '484308050',
            `<p>Anchor ${showElement('a')} is used to create hyperlinks which teleport you from one page to another when you click on them.</p>`,
            `<p>Help the two aliens visit each other:
</p>
            <ol>
            <li>On the page <b>${page('alien1')}</b>, select the ${select('Visit Alien 2 paragraph', 'p')}.</li>
            <li>Go to the ${tooltip('attributes panel', 'attributes_panel')} and click on <b>${field('Create link', 'prop:html-link-create button')}</b> button.</li>
            <li>Set the <b>${field('href', 'prop:html-link-href')}</b> attribute to <code>alien2.html</code>.</li>
            <li>Click on the ${tooltip('click icon', 'click_icon')} to test the link.</li>
            <li>On the page <b>${page('alien2')}</b>, create a link to <code>alien1.html</code>.</li>
</ol>
`,

        )
        a6_link.video = `https://youtube.com/bubi`;

        a6_link.addPage('alien1.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><h1>Hi! I'm Alien 1</h1><img src="alien4.png" height="200"><p>Visit Alien 2.</p></body></html>`);

        a6_link.addPage('alien2.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><h1>Hi! I'm Alien 2</h1><img src="alien5.png" height="200"><p>Visit Alien 1.</p></body></html>`);

        a6_link.inject_css = `
    body {
        padding:40px;
        text-align:center;
        font-size:24px;
    }
    
    img {
       
    }
`;
        a6_link.addStylesheet('style.css', '');

        addAllResources(a6_link);

        a6_link.onCheck = function(page, status, all_pages) {
            var error = null;

            var p1 = all_pages['alien1.html'];
            var p2 = all_pages['alien2.html'];

            var a = p1.sourceNode.findOne('a');
            var a2 = p2.sourceNode.findOne('a');

            if(!a) {
                error = `<p>On alien1.html, use Create link button to create a link around the Visit Alien 2 paragraph.</p>`;
            } else if(a.getAttr('href') !== 'alien2.html') {
                error = `<p>On alien1.html, set Link <b>Href</b> attribute to <code>alien2.html</code>.</p>`;
            } else if(!a2) {
                error = `<p>On alien2.html, use Create link button to create a link around the Visit Alien 1 paragraph.</p>`;
            } else if(a2.getAttr('href') !== 'alien1.html') {
                error = `<p>On alien2.html, set Link <b>Href</b> attribute to <code>alien1.html</code>.</p>`;
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien4', 'check-box');
        }

        tutorial.addLesson(a6_link);


        //Link in text
        var a7_link = new PgTutorialLesson('link_text', 'alien7', chapter_links, 'l8');

        a7_link.demo = true;
        a7_link.name = `Create a link with the text editor`;
        a7_link.display_title = `Create a link ${showElement('a')} with the text editor` + addAlien('alien7', null, '70px');

        a7_link.description = makeDesc(
            '484310688',
            `<p>Use the text edit tool to link just a part of a text.</p>`,
            `<p>Help Bloobeek show his favorite alien food:
</p>
            <ol>
            <li>On the page <b>${page('index')}</b>, select the heading ${select('h1')}.</li>
            <li>Activate the ${tooltip('edit text', 'edit_text')} tool.</li>
            <li>Highlight the word <b>&quot;here&quot;</b>.</li>
            <li>Click on the <b>${tooltip('Link button', 'edit_text_link')}</b> in the blue text edit menu above the element and set the Href to <code>food.html</code>. Click on the <b>Create</b> button.</li>
            <li>Click <b>${tooltip('Done', 'edit_text_done')}</b> button to exit text editing.</li>
            <li><b>Select the ${select('a')} link</b> and test it with the ${tooltip('click icon', 'click_icon')}.</li>
</ol>
`,

        )
        a7_link.video = `https://youtube.com/bubi`;

        a7_link.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><h1>Click here to see my favorite food!</h1><img src="alien7.png" height="200"></body></html>`);

        a7_link.addPage('food.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><h1>Space dust cookie with slimy croutons</h1><img src="food5.png" height="200"></body></html>`);

        a7_link.inject_css = `
    body {
        padding:40px;
        text-align:center;
        font-size:24px;
    }
    
    img {
       
    }
`;
        a7_link.addStylesheet('style.css', '');

        a7_link.onCheck = function(page, status, all_pages) {
            var error = null;

            var p1 = all_pages['index.html'];
            var p2 = all_pages['food.html'];

            var a = p1.sourceNode.findOne('a');
            var a2 = p2.sourceNode.findOne('a');

            if(!a || a.html().trim() !== 'here') {
                error = `<p>On index.html, select the paragraph, activate the Text editor, select the word <code>here</code> and click on the Link button.</p>`;
            } else if(a.getAttr('href') !== 'food.html') {
                error = `<p>On index.html, set Link <b>Href</b> attribute to <code>food.html</code>.</p>`;
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien7', 'check-box');
        }

        addAllResources(a7_link);

        tutorial.addLesson(a7_link);




        //Link in text
        var a8_img_link = new PgTutorialLesson('link_img', 'alien9', chapter_links, 'l9');

        a8_img_link.demo = true;
        a8_img_link.name = `Linking the image`;
        a8_img_link.display_title = `Linking the ${showElement('img')} image` + addAlien('alien9');

        a8_img_link.description = makeDesc(
            '484312027',
            `<p>Links can also be on images.</p>`,
            `<p>Toosasa has a surprise for you:
</p>
            <ol>
            <li>On the page ${page('index')}, <b>select the ${select('img')}</b> element.</li>
            <li>Go to the ${tooltip('attributes panel', 'attributes_panel')}.</li>
            <li>Click on the <b>${field('Create link', 'prop:html-link-create')}</b> button.</li>
            <li>Set ${field('href', 'prop:html-link-href')} to <code>surprise.html</code>.</li>
            <li>Use the <b>${tooltip('click icon', 'click_icon')}</b> to test the link.</li>
</ol>
`,

        )
        a8_img_link.video = `https://youtube.com/bubi`;

        a8_img_link.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><h1>Click on me and see what happens!</h1><img src="alien9.png" height="200"></body></html>`);

        a8_img_link.addPage('surprise.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><h1>I love to spin!</h1><img src="alien9.png" height="200" class="spin"></body></html>`);

        a8_img_link.inject_css = `
    body {
        padding:40px;
        text-align:center;
        font-size:24px;
    }
    
    img {
       
    }
    
    .spin {
       animation-name: spin;
       animation-duration: 5000ms;
       animation-iteration-count: infinite;
       animation-timing-function: linear; 
    }
    
    @keyframes spin {
        from {
            transform:rotate(0deg);
        }
        to {
            transform:rotate(360deg);
        }
    }
`;
        a8_img_link.addStylesheet('style.css', '');

        addAllResources(a8_img_link);

        a8_img_link.onCheck = function(page, status, all_pages) {
            var error = null;

            page = all_pages['index.html'];

            var img = page.sourceNode.findOne('img');
            var a = img.parent;

            if(a.tagName !== 'a') a = null;

            if(!a || !a.findOne('img')) {
                error = `<p>On index.html, select the image, and use Create link button to create a link.</p>`;
            } else if(a.getAttr('href') !== 'surprise.html') {
                error = `<p>On index.html, set Link <b>Href</b> attribute to <code>surprise.html</code>.</p>`;
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien9', 'check-box');
        }

        tutorial.addLesson(a8_img_link);


        /*

        //Image size %
        var a9_img_size_percent = new PgTutorialLesson('a9_img_size_percent');

        a9_img_size_percent.name = `Resizing the ${showElement('img')} with percents`;
        a9_img_size_percent.display_title = `Resizing the ${showElement('img')} image with percents` + addAlien('alien9');

        a9_img_size_percent.description = makeDesc(
            'AQ6Kyk7sa84',
            `<p>Links can also be on images.</p>`,
            `<p>Toosasa has a surprise for you:
</p>
            <ol>
            <li>On index.html, <b>select the image</b>.</li>
            <li>Go to the ${tooltip('attributes panel', 'attributes_panel')}.</li>
            <li>Click on the <b>Create link</b> button.</li>
            <li>Set href to <b>surprise.html</b>.</li>
            <li>Use the <b>${tooltip('click icon', 'click_icon')}</b> to test the link.</li>
</ol>
`,

        )
        a9_img_size_percent.video = `https://youtube.com/bubi`;

        a9_img_size_percent.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><img src="rocket3.png"><img src="rocket3.png"></body></html>`);


        var blank_css = `

    html {
        min-height:100%;
    }

    body {
        padding:0;
        margin:0;
        min-height:100%;
        text-align:left;
        //overflow:hidden;
    }

    img {
        display:inline-block;
    }

`;
        a9_img_size_percent.addStylesheet('style.css', blank_css);

        addAlienResources(a9_img_size_percent, 7, 'rocket');

        tutorial.addLesson(a9_img_size_percent);


        */


        var addAlienResourceLibButtons = function(a9_teleport) {
            var food_buttons = '';

            for(var i = 1; i <= 8; i++) {
                food_buttons += a9_teleport.getHtmlForLibButton(`<img src="images/kids/alien${i}.png">`, `<img src="alien${i}.png" class="alien">`, 'image', 'Alien ' + i)
            }

            for(var i = 1; i <= 5; i++) {
                if(i === 3) continue;
                food_buttons += a9_teleport.getHtmlForLibButton(`<img src="images/kids/background${i}.jpg">`, `<img src="background${i}.jpg" width="100%" height="100%" class="background">`, 'image', 'Background ' + i)
            }

            for(var i = 1; i <= 10; i++) {
                food_buttons += a9_teleport.getHtmlForLibButton(`<img src="images/kids/landscape${i}.png">`, `<img src="landscape${i}.png" width="100%" class="landscape">`, 'image', 'Landscape ' + i)
            }

            for(var i = 1; i <= 7; i++) {
                food_buttons += a9_teleport.getHtmlForLibButton(`<img src="images/kids/rocket${i}.png">`, `<img src="rocket${i}.png" class="rocket">`, 'image', 'Rocket ' + i)
            }

            for(var i = 1; i <= 15; i++) {
                food_buttons += a9_teleport.getHtmlForLibButton(`<img src="images/kids/food${i}.png">`, `<img src="food${i}.png">`, 'image', 'Food image ' + i)
            }

            return food_buttons;
        }


        // Lesson 5 - Space planets
        var a9_teleport = new PgTutorialLesson('a9_teleport', 'alien8', chapter_links);

        a9_teleport.name = `The link rocket adventure`;
        a9_teleport.display_title = `The link rocket adventure` + addAlien('alien8');

        var food_buttons = `<div class="pg-info-panel-img-grid">`;

        food_buttons += a9_teleport.getHtmlForLibButton('H1', `<h1>My Amazing Planet</h1>`, null, 'Planet name')

        food_buttons += addAlienResourceLibButtons(a9_teleport);

        food_buttons += '</div>';

        a9_teleport.description = makeDesc(
            'AQ6Kyk7sa84',
            `<p>Create planets and use rocket links to travel between them.</p>
${food_buttons}
`,
            ``,

        )
        a9_teleport.video = `https://youtube.com/bubi`;

        for(var i = 1; i <= 3; i++) {
            a9_teleport.addPage(`planet${i}.html`, `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body></body></html>`);
        }

        var blank_css = `
        @import url('https://fonts.googleapis.com/css2?family=Do+Hyeon&display=swap');
        
    html {
        height:100%;
    }
    
    body {
        padding:0;
        margin:0;
        font-family: 'Do Hyeon', sans-serif;
        height:100%;
        display: flex;
        flex-direction: row;
        justify-items: revert;
        align-items: flex-end;
        justify-content: center;
        overflow:hidden;
    }
    
    * {
        z-index:2;
        position:relative;
    }
    
    h1 {
        font-size: 50px;
        color:white;
        position:absolute;
        top: 6%;
        text-align: center;
        left: 0;
        right: 0;
        text-shadow:1px 1px 3px rgba(0,0,0,0.25);
        padding:0 40px;
    }
    
    img {
        margin:0 20px 10px 20px;
        filter: drop-shadow(3px 7px 4px rgba(0,0,0,0.22))
    }
    
    
    img.background {
        position:absolute;
        left:0;
        top:0;
        z-index:0;
        //width: 100%;
        //height: 100%;
        //object-fit: cover;
        filter:none;
        margin:0;
    }
    
    img.landscape {
        position:absolute;
        bottom:0;
        left:0;
        right:0;
        z-index:1;
        //width: 100%;       
        //object-fit: cover;
        filter: drop-shadow(0px 0px 10px rgba(0,0,0,0.2));
        margin:0;
    }
    
    img.rocket {
        margin-bottom:20px;
    }
    
    
    
    p {
        font-size: 20px;
        margin: 20px 0;
    }
    
`;
        a9_teleport.addStylesheet('style.css', blank_css);

        addAlienResources(a9_teleport, 8);
        addAlienResources(a9_teleport, 10, 'landscape');
        addAlienResources(a9_teleport, 5, 'background', 'jpg');
        addAlienResources(a9_teleport, 7, 'rocket');

        //tutorial.addLesson(a9_teleport);

        // End lesson



        var chapter_text_style = 'Styling the text';

        // Lesson 10 - Font size
        //LESSON 2 - P
        var a10_font_size = new PgTutorialLesson('font_size', 'alien5', chapter_text_style);

        a10_font_size.name = `How big is the text?`;
        a10_font_size.display_title = `How big is the text?` + addAlien('alien5', null, '50px');

        a10_font_size.description = makeDesc(
            '484316380',
            `<p>The size of letters is set with the <code>font-size</code> CSS property.</p>`,
            `<p>Help Rooky read the message:</p>
            <ol>
            <li><b>Click on the text</b> to select the ${select('p')} element.</li>
            <li>Go to the <b>${tooltip('style panel', 'style')}</b>.</li>
            <li>In the <b>Text section</b>, set the <b>${field('Size', 'style:font-size')}</b> property to at least <code>20px</code>. Don't forget the <code>px</code> unit!</li>
            <li><b>Open the ${tooltip('code editor', 'code_editor')}</b> to see the property in the code.</li>
</ol>
`,

        )
        a10_font_size.video = `https://youtube.com/bubi`;

        a10_font_size.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><img src="alien5.png"><p>Hi Rooky! Do you want to come to my home for lunch? I invented a new yummy dish called Burp Balls Stew but I’m afraid to eat it because it looks like it will explode. Come around noon, we’ll have lots of fun. Yours, Bloobeek.</p></body></html>`);

        a10_font_size.addStylesheet('style.css', ``);

        a10_font_size.inject_css = `
html {
    background-image: url('images/kids/background1.jpg');
    background-repeat: no-repeat; 
    background-position: right bottom; 
    min-height: 100%; 
    background-size: cover;
}

p {
    margin-left: 40px; 
    margin-top: 40px; 
    width: 50%; 
    max-width: 600px; 
    padding-top:30px;
    padding-left: 30px; 
    padding-right: 30px; 
    padding-bottom: 30px; 
    box-shadow: 5px 15px 37px rgba(0, 0, 0, 0.27); 
    background-color: rgba(255, 255, 255, 0.9);
    font-size:8px;
}

img {
    position:absolute;
    right:20px;
    bottom:20px;
}
`;

        addAllResources(a10_font_size);

        a10_font_size.onCheck = function(page, status) {
            var error = null;

            var p = page.sourceNode.findOne('p');
            if(!p) {
                error = `<p>Did you delete the text? No problem, use Undo or restart the lesson.</p>`;
            } else {
                var $el = p.get$DOMElement();
                if(parseFloat(($el.css('fontSize') || '').replace('px', '')) < 20) {
                    error = `<p>The font size should be at least <code>20px</code>.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien5', 'check-box');
        }

        tutorial.addLesson(a10_font_size);

        //End Lesson 10


        //LESSON 2 - P
        var a11_color = new PgTutorialLesson('color', 'alien7', chapter_text_style);

        a11_color.name = `Let's color the text!`;
        a11_color.display_title = `Let's color the text!` + addAlien('alien7', null, '70px');

        a11_color.description = makeDesc(
            '487103559',
            `<p>Use the CSS property <code>color</code> to set the text color.</p>`,
            `<p>Help Bloobeek advertise his restaurant on the night sky:</p>
            <ol>
            <li><b>Click on the text</b> to select the ${select('h1')} element.</li>
            <li>Go to the <b>${tooltip('style panel', 'style')}</b>.</li>
            <li>In the <b>Text section</b>, open the <b>${field('color picker', 'style:color .color-value-placeholder')}</b> in the <b>${field('Color', 'style:color')}</b> field.</li>
            <li>In the color picker, select a <b>bright color</b> and then click on the <b>Choose</b> button to close the color picker.</li>
</ol>
`,

        )
        a11_color.video = `https://youtube.com/bubi`;

        a11_color.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><img src="alien7.png" height="200"><h1>Today's Special: Get extra Super Slimy Space Jelly when you order a plate of Burp Balls Stew!</h1></body></html>`);

        a11_color.inject_css = `
html {
    background-image: url('images/kids/background1.jpg');
    background-repeat: no-repeat; 
    background-position: right bottom; 
    min-height: 100%; 
    background-size: cover;
}

h1 {
    margin-left: 4vh;
    margin-top: auto;
    margin-top: 4vh;
    max-width: 320px;
    padding-left: 50px;
    padding-right: 50px;
    text-align: center;
    border-radius: 50%;
    padding-top: 70px;
    padding-bottom: 70px;
    box-shadow: inset 9px 5px 20px 0px rgba(255,255,255,0.4);
}

img {
    position:absolute;
    right:20px;
    bottom:20px;
}
`;

        a11_color.addStylesheet('style.css', '');

        addAllResources(a11_color);

        a11_color.onCheck = function(page, status) {
            var error = null;

            var p = page.sourceNode.findOne('h1');
            if(!p) {
                error = `<p>Did you delete the text? No problem, use Undo or restart the lesson.</p>`;
            } else {
                var $el = p.get$DOMElement();
                var color = $el.css('color');

                if(chroma(color).luminance() < 0.35) {
                    error = '<p>The color is too dark. Many aliens won\'t be able to see the sign.</p>';
                } else if(chroma(color).alpha() < 0.4) {
                    error = `<p>The color is too transparent.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien7', 'check-box');
        }

        tutorial.addLesson(a11_color);

        //End Lesson 11



        //LESSON 12 - Span color
        var a12_span_color = new PgTutorialLesson('span_color', 'alien10', chapter_text_style);

        a12_span_color.name = `Color the words to launch!`;
        a12_span_color.display_title = `Color the words to launch!` + addAlien('alien10');

        a12_span_color.description = makeDesc(
            '487106373',
            `<p>Wrap a part of the text with a ${showElement('span')} element in order to style it.</p>`,
            `<p>Launch the rocket by coloring the color words:</p>
            <ol>
            <li><b>Click on the text</b> to select the ${select('h1')} element.</li>
            <li>Activate the <b>${tooltip('text editor', 'edit_text')}</b>.</li>
            <li>Highlight the word <b>red</b> and click on the <b>${tooltip('Span button', 'edit_text_span')}</b>.</li>
            <li>Click on <b>${tooltip('Done', 'edit_text_done')}</b> to finish editing the text.</li>
            <li><b>Select the ${select('span')} element</b> and change its <b>Text color</b> in the ${tooltip('style panel', 'style')}.</li>
            <li>Do the same for <b>orange</b> and <b>green</b>.</li>
</ol>
`,

        )
        a12_span_color.video = `https://youtube.com/bubi`;

        a12_span_color.addPage('index.html', `<!doctype html>
        <html>
        <head>
        <link href="style.css" rel="stylesheet">
            </head>
            <body>
            <img src="background5.jpg" width="100%" height="100%" class="background">
            <img src="rocket4.png">
            <h1>Launch sequence activated on red, orange green!</h1>
            </body>
            </html>`);

        a12_span_color.inject_css = `
        
    html {
        height:100%;
    }
    
    body {
        padding:0;
        margin:0;
        height:100%;
        display: flex;
        flex-direction: row;
        justify-items: revert;
        align-items: flex-end;
        justify-content: center;
        overflow:hidden;
    }
    
    
    h1 {
        font-size: 50px;
        color:white;
        position:absolute;
        top: 6%;
        text-align: center;
        left: 0;
        right: 0;
        text-shadow:1px 1px 3px rgba(0,0,0,0.25);
        padding:0 40px;
    }
    
    * {
        z-index:2;
    }
    
    img {
        transition: transform 5s cubic-bezier(0.86, 0.02, 1.00, 1.00);
    }
    
    
    
    img.background {
        position:absolute;
        left:0;
        top:0;
        z-index:0;
        //width: 100%;
        //height: 100%;
        //object-fit: cover;
        filter:none;
        margin:0;
    }
    
    img[src*="rocket"] {
        margin:0 20px 10px 20px;
        filter: drop-shadow(3px 7px 4px rgba(0,0,0,0.22))
        margin-bottom:20px;
        transform: rotate(0deg) translate(-99px, 125px);
    }
    
    img.fly {
        transform: translate(10vw, -130vh) rotate(26deg);
     }
    
`
        a12_span_color.addStylesheet('style.css', '');

        addAllResources(a12_span_color);

        a12_span_color.onCheck = function(page, status) {
            var error = null;

            var spans = page.sourceNode.find('span');
            var colors = ['red', 'orange', 'green'];
            for(var i = 0; i < colors.length; i++) {
                var c = colors[i];
                if(spans.length <= i) {
                    error = `<p>Use the Edit text tool to create a span around the word ${c}.</p>`;
                } else if(!spans[i].text().trim().toLowerCase().startsWith(c)) {
                    error = `<p>The span should be around the word ${c}.</p>`;
                } else {
                    var $el = spans[i].get$DOMElement();
                    var tc = $el.css('color');
                    if(chroma.distance(c, tc) > 70) {
                        error = `<p>The color of the word ${c} should be more ${c}.</p>`;
                    } else if(chroma(tc).alpha() < 0.7) {
                        error = `<p>The color of the word ${c} is too transparent.</p>`;
                    }
                }
                if(error) break;
            }

            if(!error) {
                var r = page.sourceNode.find('img').forEach(function (pgel) {
                    if (!pgel.hasClass('background')) {
                        pgel.addClass('fly');
                    }
                });
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.delay = 4000;
                status.result = 'ok';
            }

            status.decoration = addAlien('alien10', 'check-box');
        }

        tutorial.addLesson(a12_span_color);

        //End Lesson 12



        //LESSON 12 - Span color
        var a13_font_family = new PgTutorialLesson('font_family', 'alien13', chapter_text_style);

        a13_font_family.name = `Find the font!`;
        a13_font_family.display_title = `Find the font!` + addAlien('alien13', null, null, '-30px');

        a13_font_family.description = makeDesc(
            '487110709',
            `<p>Use the <code>font-family</code> CSS property to set the shape of the letters.</p>`,
            `<p>Help Zootata make the poster more interesting by choosing a suitable font:</p>
            <ol>
            <li><b>Click on the text</b> to select the ${select('h1')} element.</li>
            <li>Go to the <b>${tooltip('style panel', 'style')}</b>.</li>
            <li>Select the font combination in the <b>${field('Font family', 'style:font-family')}</b> field.</li>
            <li>Try out different fonts to see which one fits the best.</li>
</ol>
`,

        )

        a13_font_family.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <h1>Super fun space rides to Wobbly Jelly asteroid belt!</h1>
        <img src="background1.jpg" width="100%" height="100%" class="background">
        <img src="rocket2.png" class="rocket" width="203">
        <img src="landscape3.png" width="100%" class="landscape">
    </body>
</html>`);

        a13_font_family.inject_css = `
    html {
        height:100%;
    }
    
    body {
        padding:0;
        margin:0;
        height:100%;
        display: flex;
        flex-direction: row;
        justify-items: revert;
        align-items: flex-end;
        justify-content: center;
        overflow:hidden;
    }
    
    
    h1 {
        font-size: 50px;
        color:white;
        position:absolute;
        top: 6%;
        text-align: center;
        left: 0;
        right: 0;
        text-shadow:1px 1px 3px rgba(0,0,0,0.25);
        padding:0 40px;
    }
    
    * {
        z-index:2;
    }
    
     img.landscape {
        position:absolute;
        bottom:0;
        left:0;
        right:0;
        z-index:1;
        //width: 100%;       
        //object-fit: cover;
        filter: drop-shadow(0px 0px 10px rgba(0,0,0,0.2));
        margin:0;
    }
    
    img.background {
        position:absolute;
        left:0;
        top:0;
        z-index:0;
        //width: 100%;
        //height: 100%;
        //object-fit: cover;
        filter:none;
        margin:0;
    }
    
    img[src*="rocket"] {
        margin:0 20px 10px 20px;
        filter: drop-shadow(3px 7px 4px rgba(0,0,0,0.22))
        margin-bottom:20px;
    }
    
    @keyframes jello {
      11.1% {
        transform: none
      }
      22.2% {
        transform: skewX(-12.5deg) skewY(-12.5deg)
      }
      33.3% {
        transform: skewX(6.25deg) skewY(6.25deg)
      }
      44.4% {
        transform: skewX(-3.125deg) skewY(-3.125deg)
      }
      55.5% {
        transform: skewX(1.5625deg) skewY(1.5625deg)
      }
      66.6% {
        transform: skewX(-0.78125deg) skewY(-0.78125deg)
      }
      77.7% {
        transform: skewX(0.390625deg) skewY(0.390625deg)
      }
      88.8% {
        transform: skewX(-0.1953125deg) skewY(-0.1953125deg)
      }
      100% {
        transform: none
      }
    }

    .jello {
      animation: jello 2s infinite;
      transform-origin: center
    }
   
`;
        a13_font_family.addStylesheet('style.css', '');

        addAllResources(a13_font_family);

        a13_font_family.onCheck = function(page, status) {
            var error = null;

            var h1 = page.sourceNode.findOne('h1');

            if(!h1) {
                error = `<p>Did you delete the text? No problem, use Undo or restart the lesson.</p>`;
            } else {
                if(!h1.getInlineStylePropertyValue('font-family')) {
                    error = `<p>Set the Font family CSS property for the heading.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
                status.delay = 2000;

                var r = page.sourceNode.find('img,h1').forEach(function(pgel) {
                    if(!pgel.hasClass('background')) {
                        pgel.addClass('jello');
                    }
                });
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        tutorial.addLesson(a13_font_family);

        //End Lesson 13



        var a14_div = new PgTutorialLesson('a14_div', 'alien13');

        a14_div.name = `Super fun space rides`;
        a14_div.display_title = `Super fun space rides` +  addAlien('alien13', null, null, '-30px');

        var food_buttons = `<div class="pg-info-panel-img-grid">`;

        food_buttons += a14_div.getHtmlForLibButton('H1', `<h1>This is a cool heading</h1>`, null, 'Heading')
        food_buttons += a14_div.getHtmlForLibButton('P', `<p>A paragraph is a chunk of text about something very interesting.</p>`, null, 'Paragraph')

        food_buttons += addAlienResourceLibButtons(a14_div);

        food_buttons += '</div>';

        a14_div.description = makeDesc(
            'AQ6Kyk7sa84',
            `<p>Zootata hired you to create a website for her space adventure company.</p> ${food_buttons}`,
            null,

        )
        a14_div.video = `https://youtube.com/bubi`;

        a14_div.addPage('page1.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <h1>Super fun space rides!</h1>
        <p>Do you want to travel all around the Universe and visit cool places? Well, you’ve hit the jackpot!</p>
        <p>We are running fun space rides from HTML Planet to:</p>
        <p>Slimy Space balls - 20 Space Coins</p>
        <p>Bouncy balloon Planet - 25 Space Coins</p>
        <p>The bubble swamp - 10 Space Coins</p>
        <p>All rides include yummy snacks such as Sticky Boomballs, Smelly Rock Tenticles and Wigly Fuzzworms.</p>
        <p>See you soon!</p>
    </body>
</html>`);

        a14_div.addPage('page2.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
    </body>
</html>`);

        a14_div.addPage('page3.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
    </body>
</html>`);

        a14_div.addStylesheet('style.css', `
        
    html {
        height:100%;
    }
    
    body {
        padding: 20px 40px 140px;
        margin: 0;
        min-height: 100%;
        //display: flex;
        //flex-direction: column;
        box-sizing: border-box;
        position: relative;
        text-align: center;
    }
    
    div {
        position:absolute;
        top: 6%;
        text-align: center;
        left: 0;
        right: 0;
        padding:0 40px;
    }
    
    h1 {
        //font-size: 50px;
       // text-shadow:1px 1px 3px rgba(0,0,0,0.25);
    }
    
    h1, p {
        max-width:500px;
        z-index:10;
    }
    
    * {
        z-index:2;
        position:relative;
    }
    
     img.landscape {
        position:absolute;
        bottom:0;
        left:0;
        right:0;
        z-index:1;
        //width: 100%;       
        //object-fit: cover;
        filter: drop-shadow(0px 0px 10px rgba(0,0,0,0.2));
        margin:0;
    }
    
    img.background {
        position:absolute;
        left:0;
        top:0;
        z-index:0;
        //width: 100%;
        //height: 100%;
        //object-fit: cover;
        filter:none;
        margin:0;
    }
    
    aaimg.rocket {
        filter: drop-shadow(3px 7px 4px rgba(0,0,0,0.22))
        position:absolute;
        right:20px;
        bottom:10px;
    }
    
    aaimg.alien {
        margin:0 20px 10px 20px;
        filter: drop-shadow(3px 7px 4px rgba(0,0,0,0.22))
        margin-bottom:20px;
        position:absolute;
        right:20px;
        bottom:20px;
    }
   
`);

        addAlienResources(a14_div, 5, 'background', 'jpg');
        addAlienResources(a14_div, 7, 'rocket');
        addAlienResources(a14_div, 15);
        addAlienResources(a14_div, 10, 'landscape');
        addAlienResources(a14_div, 15, 'food');

        a14_div.onCheck = function(page, status) {
            var error = null;

            var r = page.sourceNode.find('img,h1').forEach(function(pgel) {
                if(!pgel.hasClass('background')) {
                    pgel.addClass('jello');
                }
            });

            status.result = 'ok';
            status.delay = 2000;

            status.decoration = addAlien('alien3', 'check-box');
        }

        //tutorial.addLesson(a14_div);

        //End Lesson 13


        //LESSON 2 - P
        var a15_line_height = new PgTutorialLesson('line_height', 'alien1', chapter_text_style);

        a15_line_height.name = `Line height to the rescue!`;
        a15_line_height.display_title = `Line height to the rescue!` + addAlien('alien1');

        a15_line_height.description = makeDesc(
            '487113294',
            `<p>Use the <code>line-height</code> CSS property to set the height of lines of text.</p>`,
            `<p>Unscramble the secret message:
</p>
            <ol>
            <li><b>Click on the text</b> to select the ${select('p')} element.</li>
            <li>Go to the <b>${tooltip('style panel', 'style')}</b>.</li>
            <li>Use the <b>${field('Height', 'style:line-height')}</b> field in the Text section to set the <code>line-height</code>.</li>
            <li>Try values with a unit (for example <code>32px</code>) and without a unit (for example <code>1.3</code>).</li>
</ol>
`,

        )
        a15_line_height.video = `https://youtube.com/bubi`;

        a15_line_height.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <img src="landscape10.png" width="100%" class="landscape">
        <img src="background1.jpg" width="100%" height="100%" class="background">
        <p>Far far away from HTML Planet, in deep space where nobody lives lies the super deep Black Hole. But do you know who lives in the super deep Black Hole? A super cute alien with super fluffy fur! To visit teleport to coordinates ABFE541-HW63. See you soon!
</p>
    </body>
</html>`);

        a15_line_height.addPage('example.html', `<!doctype html><html><head><link href="example.css" rel="stylesheet">
</head><body><p>One summer day on the HTML Planet Bloobeek decided to go for a walk. It was a huge undertaking – a long journey, including the trek of six to seven hours, and a massive trek to see an entire planet covered in sunny grassy fields. Lots of space sheeps came on board, and the whole thing was a spectacular sight. He returned late in the evening.</p></body></html>`);

        a15_line_height.inject_css = `
        
    html {
        height:100%;
    }
    
    body {
        padding:0;
        margin:0;
        height:100%;
        display: flex;
        flex-direction: row;
        justify-items: revert;
        align-items: flex-end;
        justify-content: center;
        overflow:hidden;
    }
    
    
    p {
        font-size: 28px;
        font-family: Impact, Charcoal, sans-serif;
        color:white;
        position:absolute;
        top: 6%;
        text-align: center;
        left: 40px;
        right:40px;
        //width: 50%; 
    //max-width: 600px; 
        text-shadow:1px 1px 3px rgba(0,0,0,0.25);
        padding:0 20px;
        //box-shadow: 5px 15px 37px rgba(0, 0, 0, 0.27); 
    //background-color: rgba(255, 244, 185, 0.81);
        line-height:1px;
    }
    
    * {
        z-index:2;
    }
    
     img.landscape {
        position:absolute;
        bottom:0;
        left:0;
        right:0;
        z-index:1;
        //width: 100%;       
        //object-fit: cover;
        filter: drop-shadow(0px 0px 10px rgba(0,0,0,0.2));
        margin:0;
    }
    
    img.background {
        position:absolute;
        left:0;
        top:0;
        z-index:0;
        //width: 100%;
        //height: 100%;
        //object-fit: cover;
        filter:none;
        margin:0;
    }
    
    
`;
        a15_line_height.addStylesheet('style.css', '');

        addAllResources(a15_line_height);

        a15_line_height.onCheck = function(page, status) {
            var error = null;

            var h1 = page.sourceNode.findOne('p');

            if(!h1) {
                error = `<p>Did you delete the text? No problem, use Undo or restart the lesson.</p>`;
            } else {
                var lh = h1.getInlineStylePropertyValue('line-height');
                if(!lh) {
                    error = `<p>Set the Line height CSS property for the paragraph.</p>`;
                } else if(lh.indexOf('px') >= 0) {
                    lh = parseFloat(lh.replace('px', ''));
                    if(lh < 28) {
                        error = `<p>The line height is too small.</p>`;
                    } else if(lh > 100) {
                        error = `<p>The line height is too large.</p>`;
                    }
                } else {
                    lh = parseFloat(lh);
                    if(lh < 1) {
                        error = `<p>The line height is too small.</p>`;
                    } else if(lh > 5) {
                        error = `<p>The line height is too large.</p>`;
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien1', 'check-box');
        }

        tutorial.addLesson(a15_line_height);

        //End Lesson 15



        //LESSON 16
        var a16_text_props = new PgTutorialLesson('text_style', 'alien11', chapter_text_style);

        a16_text_props.name = `Text styling riddles`;
        a16_text_props.display_title = `Text styling riddles` + addAlien('alien11');

        a16_text_props.description = makeDesc(
            '487115943',
            ``,
            `<p>Style each paragraph according to what it says:
</p>
            <ol>
            <li><b>Click on the text</b> to select a ${select('p')} element.</li>
            <li>Go to the <b>${tooltip('style panel', 'style')}</b>.</li>
            <li>Use one of the text styling properties on each paragraph: <code>${field('font-weight', 'style:font-weight')}</code>, <code>${field('letter-spacing', 'style:letter-spacing')}</code>, <code>${field('font-style', 'style:font-style')}</code>, <code>${field('font-variant', 'style:font-variant')}</code>, <code>${field('text-decoration','style:text-decoration')}</code>, <code>${field('text-transform', 'style:text-transform')}</code> and <code>${field('text-align', 'style:text-align')}</code>.</li>
</ol>
`,

        )
        a16_text_props.video = `https://youtube.com/bubi`;

        a16_text_props.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <img src="background4.jpg" width="100%" height="100%" class="background">
        <p>I am very brave and bold!</p>
        <p>My letters are verrrrrry far apart.</p>
        <p>The strong wind leaned me to the right side.</p>
        <p>My letters are all Big, but some are Bigger.</p>
        <p>I used to be a good idea, but now I am crossed out.</p>
        <p>All my letters are big, all are the same size.</p>
        <p>I am in the center of things!</p>
        <p>I am stuck to the right edge.</p>
        <p>I have multiple lines and nicely take up the space from the left edge to the right edge. My words flow like a calm surface of a mountain lake. Only my last line ends wherever it falls.</p>
    </body>
</html>`);

        a16_text_props.addPage('example.html', `<!doctype html><html><head><link href="example.css" rel="stylesheet">
</head><body><p>One summer day on HTML Planet, Bloobeek decided to go for a walk. It was a huge undertaking – a long journey, including the trek of six to seven hours, and a massive trek to see an entire planet covered in sunny grassy fields. Lots of space sheeps came on board, and the whole thing was a spectacular sight. He returned late in the evening.</p></body></html>`);

        a16_text_props.inject_css = `
        
    html {
        height:100%;
    }
    
    body {
        padding:40px;
        margin:0;
        min-height:100%;
        position:relative;
        box-sizing: border-box;
    }
    
    
    p {
        font-size: 20px;
        font-family: 'Palatino Linotype', 'Book Antiqua', Palatino, serif;;
        position: relative;
    }
    
    * {
        z-index:2;
        position:relative;
    }
    
     img.landscape {
        position:absolute;
        bottom:0;
        left:0;
        right:0;
        z-index:1;
        //width: 100%;       
        //object-fit: cover;
        filter: drop-shadow(0px 0px 10px rgba(0,0,0,0.2));
        margin:0;
        opacity:0.4;
    }
    
    img.background {
        position:absolute;
        left:0;
        top:0;
        z-index:0;
        //width: 100%;
        //height: 100%;
        //object-fit: cover;
        filter:none;
        margin:0;
    }
    
    
`;
        a16_text_props.addStylesheet('style.css', '');

        addAllResources(a16_text_props);


        a16_text_props.onCheck = function(page, status) {
            var error = null;
            var r = [
                {prop: 'font-weight', val: 'bold'},
                {prop: 'letter-spacing', val: ''},
                {prop: 'font-style', val: 'italic'},
                {prop: 'font-variant', val: 'small-caps'},
                {prop: 'text-decoration', val: 'line-through'},
                {prop: 'text-transform', val: 'uppercase'},
                {prop: 'text-align', val: 'center'},
                {prop: 'text-align', val: 'right'},
                {prop: 'text-align', val: 'justify'}
            ]
            var ps = page.sourceNode.find('p');

            for(var i = 0; i < r.length; i++) {
                if(ps.length <= i) {
                    error = `<p>Did you delete the text? No problem, use Undo or restart the lesson.</p>`;
                } else {
                    var v = ps[i].getInlineStylePropertyValue(r[i].prop);
                    if(!v) {
                        error = `<p>The paragraph ${i+1} should have the CSS property <b>${r[i].prop}</b>.</p>`;
                    } else if(r[i].val && r[i].val != v) {
                        error = `<p>The paragraph ${i+1} should have the CSS property <b>${r[i].prop}</b> set to <code>${r[i].val}</code>.</p>`;
                    }
                }
                if(error) break;
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien11', 'check-box');
        }

        tutorial.addLesson(a16_text_props);

        //End Lesson 16



        //LESSON 17
        var a17_parent_style = new PgTutorialLesson('parent_style', 'alien13', chapter_text_style);

        a17_parent_style.name = `Space drama with parent elements`;
        a17_parent_style.display_title = `Space drama with parent elements` + addAlien('alien13', 'second', null, '-40px') + addAlien('alien1');

        a17_parent_style.description = makeDesc(
            '487501174',
            `<p>Set style on the parent element to quickly style all elements inside it.</p>`,
            `<p>Help Blotomic learn his lines:
</p>
            <ol>
            <li>Click on the empty page area to <b>select the ${select('body')} element</b>.</li>
            <li>Go to the <b>${tooltip('style panel', 'style')}</b>.</li>
            <li>Set <b>${field('Font family', 'style:font-family')}</b> to <code>Courier New, Courier, monospace</code> (scroll to the end of the font selection box) and <b>Font size</b> to <code>18px</code>.</li>
            <li>Select <b>Blotomic's lines</b> one by one and make them <code>bold</code> using the <b>${field('Font weight', 'style:font-weight')}</b> CSS property.</li>
</ol>
`,

        )
        a17_parent_style.video = `https://youtube.com/bubi`;

        a17_parent_style.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <h1>The space trip to the center of the Wobbly Jelly Asteroid Belt</h1>

<p>- Scene 1 -</p>

<p>Zootata: Oh no! Our rocket engine is on fire!</p>

<p>Blotomic: Quick, spray it with anti-fire dust!</p>

<p>Zootata: Where is it? Did you pack the anti-fire dust?</p>

<p>Blotomic: What?! I thought you packed it.</p>

<p>(Zootata sighs and puts hands on her head.)</p>

<p>Zootata: What shall we do now?</p> 

<p>Blotomic: I will put on my space suit, go out and close the fuel valve.</p>

<p>Zootata: Be careful, it’s dangerous. We are flying almost at the speed of light.</p>

<p>(Blotomic puts on his space suit and leaves the rocket, switches on the radio.)</p>

<p>Blotomic: Zootata, can you hear me?</p>

<p>Zootata: Loud and clear.</p>

<p>Blotomic: I see the problem. A lump of space lava got stuck in the engine.</p>

<p>- End of scene 1 -</p>

    </body>
</html>`);


        addAllResources(a17_parent_style);

        a17_parent_style.inject_css = `
body {
padding:40px 80px;
}
`;

        a17_parent_style.addStylesheet('style.css', ``);

        a17_parent_style.onCheck = function(page, status) {
            var error = null;

            var b = page.sourceNode.findOne('body');

            if((b.getInlineStylePropertyValue('font-family') + '').indexOf('Courier') < 0) {
                error = `<p>Set the Font family CSS property of the <b>body</b> to <code>Courier New</code>.</p>`;
            } else if((b.getInlineStylePropertyValue('font-size') + '') != '18px') {
                error = `<p>Set the Font size CSS property of the <b>body</b> to <code>18px</code>.</p>`;
            } else {
                var ps =  page.sourceNode.find('p');
                for(var i = 0; i < ps.length; i++) {
                    if(ps[i].text().indexOf('Blotomic:') >= 0) {
                        if(ps[i].getInlineStylePropertyValue('font-weight') != 'bold') {
                            error = `<p>The sentance &quot;${ps[i].text()}&quot; should be bold.</p>`;
                            break;
                        }
                    } else {
                        if(ps[i].getInlineStylePropertyValue('font-weight') == 'bold') {
                            error = `<p>The sentance &quot;${ps[i].text()}&quot; should not be bold.</p>`;
                            break;
                        }
                    }
                }
            }
            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien1', 'check-box');
        }

        tutorial.addLesson(a17_parent_style);

        //End Lesson 17


        var chapter_background = 'Backgrounds';

        //LESSON 18
        var a18_bck_color = new PgTutorialLesson('background_color', 'alien13', chapter_background);

        a18_bck_color.name = `More space drama with background color`;
        a18_bck_color.display_title = `More space drama with background color` + addAlien('alien13', 'second', null, '-40px') + addAlien('alien1');

        a18_bck_color.description = makeDesc(
            '487503138',
            `<p>Use the <code>background-color</code> CSS property to color the background.</p>`,
            `<p>Help Zootata and Blotomic read the script by setting the background color:
</p>
            <ol>
            <li>Click on the empty page area to <b>select the ${select('body')} element</b>.</li>
            <li>Go to the <b>${tooltip('style panel', 'style')}</b>.</li>
            <li>In the <b>Background section</b> use the <b>${field('Color', 'style:background-color')}</b> field to set the <code>background-color</code>. Click on the ${field('color square', 'style:background-color .color-value-placeholder')} on the right side of the field to open the color picker.</li>
            <li>Select a background color on which both dark and light text is readable.</li>
</ol>
`,

        )
        a18_bck_color.video = `https://youtube.com/bubi`;

        a18_bck_color.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
<h1>The space trip to the center of the Wobbly Jelly Asteroid Belt</h1>
        <p style="text-align: center;">- Scene 2 -</p>
        <p>(Blotomic uses his gloves to try pulling the space lava out of the engine.)</p>
        <p>Blotomic: <span style="color: #ffffff; border-bottom: 1px dashed #979797;">It&rsquo;s too hot and sticky!</span> Can you come and help me?</p>
        <p>Zootata: I’m coming!</p>
        <p>Blotomic: Hurry up!</p>
        <p>(Zootata grabs her <span style="color: #ffffff; border-bottom: 1px dashed #979797;">slime puller</span>, puts on her space suit and leaves their rocket.)</p>
        <p>Zootata: Lets pull together! <span style="color: #ffffff; border-bottom: 1px dashed #979797;">Three, two, one, PULL!</span></p>
        <p>(They both pull and tug as strong as they can. <span style="color: #ffffff; border-bottom: 1px dashed #979797;">The chunk of lave flies out of the engine.</span>)</p>
        <p>Blotomic: Yes! We did it!</p>
        <p>(Zootata and Blotomic return to the rocket door but <span style="color: #ffffff; border-bottom: 1px dashed #979797;">the door is shut</span>.)</p>
        <p>Zootata: Oh no&hellip; <span style="color: #ffffff; border-bottom: 1px dashed #979797;">The door is locked!</span></p>
        <p>Blotomic: It must have happened <span style="color: #ffffff; border-bottom: 1px dashed #979797;">when we pulled on the lava and the rocket shook.</span></p>
        <p style="text-align: center;">- End of Scene 2 -</p>


    </body>
</html>`);

        a18_bck_color.addPage('example.html', `<!doctype html><html><head><link href="example.css" rel="stylesheet">
</head><body><p>One summer day on HTML Planet, Bloobeek decided to go for a walk.</p><p>It was a huge undertaking – a long journey, including the trek of six to seven hours, and a massive trek to see an entire planet covered in sunny grassy fields.</p><p>Lots of space sheeps came on board, and the whole thing was a spectacular sight. He returned late in the evening.</p></body></html>`);

        addAllResources(a18_bck_color);

        a18_bck_color.inject_css = `
body {
padding:40px 80px;
font-size:18px;
font-family: 'Courier New', Courier, monospace;
}
`
        a18_bck_color.addStylesheet('style.css', ``);



        a18_bck_color.onCheck = function(page, status) {
            var error = null;

            var b = page.sourceNode.findOne('body');

            if(!b.getInlineStylePropertyValue('background-color')) {
                error = `<p>Set the Background color CSS property of the <b>body</b> to a suitable color.</p>`;
            }
            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien1', 'check-box');
        }

        tutorial.addLesson(a18_bck_color);

        //End Lesson 18



        // Lesson 4
        var a19_bck_img = new PgTutorialLesson('background_image', 'alien3', chapter_background);

        a19_bck_img.name = `Background image for the perfect photo`;
        a19_bck_img.display_title = `Background image for the perfect photo` + addAlien('alien3');

        a19_bck_img.description = makeDesc(
            '487504382',
            `<p>Use the <code>background-image</code> CSS property to display an image in the background of an element.</p>`,
            `<p>Help Bloby choose the background for his photo:
</p>
            <ol>
            <li><b>Click on the ${select('body')} element</b> to select it.</li>
            <li>Go to the <b>${tooltip('style panel', 'style')}</b>.</li>
            <li>Enter <code>background1.jpg</code> into the <b>${field('Image', 'style:background-image')}</b> field in the <b>Background section</b>.</li>
            <li>Try also <code>background2.jpg</code>, <code>background3.jpg</code>, <code>background4.jpg</code> and <code>background5.jpg</code> and choose your favorite.</li>
            <li><b>Hint:</b> Open the ${field('image gallery', 'style:background-image .crsa-pick-file')} and select the image there.</li>
</ol>
`,

        )
        a19_bck_img.video = `https://youtube.com/bubi`;

        a19_bck_img.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><img src="alien3.png" width="340"></body></html>`);

        var blank_css = `
        html { height: 100%;}
    body {
        padding:40px;
        overflow:hidden;
        height:100%;
    }
    
    img {
        position:absolute;
        bottom:-80px;
        left:20%;
        filter: drop-shadow(3px 7px 4px rgba(0,0,0,0.22));
    }
`;

        a19_bck_img.inject_css = blank_css;

        a19_bck_img.addStylesheet('style.css', '');
        addAllResources(a19_bck_img);

        a19_bck_img.onCheck = function(page, status) {
            var error = null;

            var b = page.sourceNode.findOne('body');

            var img = b.getInlineStylePropertyValue('background-image') || '';

            if(!img.match(/^url\(\'background[1-5]\.jpg\'\)$/)) {
                error = `<p>Set the Background image CSS property of the <b>body</b> to one of the backgrounds: <code>background1.jpg</code> to <code>background5.jpg</code>.</p>`;
            }
            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien3', 'check-box');
        }

        tutorial.addLesson(a19_bck_img);


        var checkBackground = function(b, name) {
            var img = b.getInlineStylePropertyValue('background-image') || '';
            if(!img.match(/^url\(\'background[1-5]\.jpg\'\)$/)) {
                return `<p>Set the Background image CSS property of the <b>${name}</b> to one of the backgrounds: <code>background1.jpg</code> to <code>background5.jpg</code>.</p>`;
            }
            return null;
        }

        var checkAlien = function(b, name) {
            var img = b.getInlineStylePropertyValue('background-image') || '';
            if(!img.match(/^url\(\'alien([1-9]|1[0-5])\.png\'\)$/)) {
                return `<p>Set the Background image CSS property of the <b>${name}</b> to one of the alien: <code>alien1.png</code> to <code>alien15.png</code>.</p>`;
            }
            return null;
        }

        // Lesson 4
        var a20_bck_repeat = new PgTutorialLesson('background_repeat', 'alien5', chapter_background);

        a20_bck_repeat.name = `Multiplying planet backgrounds`;
        a20_bck_repeat.display_title = `Multiplying planet backgrounds` + addAlien('alien5', null, '60px');

        a20_bck_repeat.description = makeDesc(
            '487506612',
            `<p>Use the <code>background-repeat</code> CSS property to control how the background image is repeated.</p>`,
            `<p>Play around with the Planet multiplying machine:
</p>
            <ol>
            <li><b>Select the ${select('body')}</b> element.</li>
            <li>Go to the <b>${tooltip('style panel', 'style')}</b>.</li>
            <li>Enter <code>planet1.jpg</code> into the <b>${field('Image', 'style:background-image')}</b> field in the <b>Background section</b>.</li>
            <li>Try different values of <b>${field('Repeat', 'style:background-repeat')}</b> property and see what happens.</li>
            <li>You can also multiply planets <code>planet2.jpg</code>, <code>planet3.jpg</code>, <code>planet4.jpg</code>, <code>planet5.jpg</code> and <code>planet6.jpg</code>.</li>
</ol>
`,

        )
        a20_bck_repeat.video = `https://youtube.com/bubi`;

        a20_bck_repeat.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body></body></html>`);

        var blank_css = `
        html { height: 100%;}
    body {
        padding:40px;
        overflow:hidden;
        height:100%;
    }
    
    img {
        position:absolute;
        bottom:-80px;
        left:20%;
        filter: drop-shadow(3px 7px 4px rgba(0,0,0,0.22));
    }
`;
        a20_bck_repeat.inject_css = blank_css;

        a20_bck_repeat.addStylesheet('style.css', ``);

        addAllResources(a20_bck_repeat);

        a20_bck_repeat.onCheck = function(page, status) {
            var error = null;

            var b = page.sourceNode.findOne('body');

            var img = b.getInlineStylePropertyValue('background-image') || '';

            if(!img.match(/^url\(\'planet[1-6]\.jpg\'\)$/)) {
                error = `<p>Set the Background image CSS property of the <b>body</b> to one of the planets: <code>planet1.jpg</code> to <code>planet6.jpg</code>.</p>`;
            } else if(!b.getInlineStylePropertyValue('background-repeat')) {
                error = `<p>Set the Background repeat CSS property of the <b>body</b> element.</p>`;
            }
            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien5', 'check-box');
        }

        tutorial.addLesson(a20_bck_repeat);




        var a21_bck_pos = new PgTutorialLesson('background_position', 'alien15', chapter_background);

        a21_bck_pos.name = `Use the background position to save the planet`;
        a21_bck_pos.display_title = `Use the background position to save the planet` + addAlien('alien15');

        a21_bck_pos.description = makeDesc(
            '487507710',
            `<p>Use the <code>background-position</code> CSS property to position the background image.</p>`,
            `<p>Move the planet into the <b>right bottom</b> corner to save it from the asteroid:
</p>
            <ol>
            <li><b>Click on the ${select('body')}</b> element to select it.</li>
            <li>Go to the <b>${tooltip('style panel', 'style')}</b>.</li>
            <li>Try different values of the <b>Background position</b> property to see what happens.</li>
            <li>Set the <b>Background position</b> property to <code>right bottom</code> in order to move the planet to the safe corner.</li>
</ol>
`,

        )
        a21_bck_pos.video = `https://youtube.com/bubi`;

        a21_bck_pos.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body style="background-image: url('planet1.jpg'); background-repeat: no-repeat;><h1>Asteroid<br>hit zone!</h1></body></html>`);

        var blank_css = `
        html { height: 100%;}
    body {
        padding:30px;
        overflow:hidden;
        height:100%;
    }
    
    h1 {
        background-color: rgba(255, 0, 0, 0.62); width: 300px; height: 300px; text-align: center; display: flex; flex-direction: column; justify-content: center; border-radius: 150px; color: rgba(0, 0, 0, 0.81); font-size: 47px; font-family: Impact, Charcoal, sans-serif; margin-top: 0; margin-bottom: 0;
        pointer-events:none;
    }
`;
        a21_bck_pos.inject_css = blank_css;
        a21_bck_pos.addStylesheet('style.css', ``);

        addAllResources(a21_bck_pos, 6, 'planet', 'jpg');

        a21_bck_pos.onCheck = function(page, status) {
            var error = null;

            var b = page.sourceNode.findOne('body');

            if(b.getInlineStylePropertyValue('background-position') != 'right bottom') {
                error = `<p>Set the Background position CSS property of the <b>body</b> to <code>right bottom</code>.</p>`;
            }
            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien15', 'check-box');
        }

        tutorial.addLesson(a21_bck_pos);



        var a22_bck_size = new PgTutorialLesson('background_size', 'alien3', chapter_background);

        a22_bck_size.name = `Background size for Bloby's photo`;
        a22_bck_size.display_title = `Background size for Bloby's photo` + addAlien('alien3', null, null, '-30px');

        a22_bck_size.description = makeDesc(
            '487508987',
            `<p>Use the <code>background-size</code> CSS property to control the size of the background image.</p>`,
            `<p>Help Bloby take a photo in front of his house:
</p>
            <ol>
            <li><b>Click on the ${select('body')}</b> element to select it.</li>
            <li>Go to the <b>${tooltip('style panel', 'style')}</b>.</li>
            <li>Set <b>${field('Background Size', 'style:background-size')}</b> to <code>cover</code> or <code>contain</code>.</li>
            <li>Combine the size with background <b>${field('Repeat', 'style:background-repeat')}</b>, <b>${field('Position', 'style:background-position')}</b> and <b>${field('Color', 'style:background-color')}</b> to create the perfect background.</li>
</ol>
`,

        )
        a22_bck_size.video = `https://youtube.com/bubi`;

        a22_bck_size.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body style="background-image:url('background3.jpg');><img src="alien3.png" width="340"></body></html>`);

        var blank_css = `
        html { height: 100%;}
    body {
        padding:40px;
        overflow:hidden;
        height:100%;
        box-sizing: border-box;
    }
    
    img {
        position:absolute;
        bottom:-80px;
        left:20%;
        filter: drop-shadow(3px 7px 4px rgba(0,0,0,0.22));
    }
`;
        a22_bck_size.inject_css = blank_css;

        a22_bck_size.addStylesheet('style.css', ``);
        addAllResources(a22_bck_size);

        a22_bck_size.onCheck = function(page, status) {
            var error = null;

            var b = page.sourceNode.findOne('body');

            var img = b.getInlineStylePropertyValue('background-size');

            if(!img) {
                error = `<p>Set the Background size CSS property of the <b>body</b> element.</p>`;
            }
            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien3', 'check-box');
        }

        tutorial.addLesson(a22_bck_size);




        var a23_fun_grid = new PgTutorialLesson('a23_fun_grid', 'alien3');

        a23_fun_grid.name = `Background image for the perfect photo`;
        a23_fun_grid.display_title = `Background image for the perfect photo` + addAlien('alien3');

        var food_buttons = `<div class="pg-info-panel-img-grid">`;

        food_buttons += a23_fun_grid.getHtmlForLibButton('H1', `<h1>This is a cool heading</h1>`, null, 'Heading')
        food_buttons += a23_fun_grid.getHtmlForLibButton('P', `<p>A paragraph is a chunk of text about something very interesting.</p>`, null, 'Paragraph')

        food_buttons += addAlienResourceLibButtons(a23_fun_grid);

        food_buttons += '</div>';

        a23_fun_grid.description = makeDesc(
            'AQ6Kyk7sa84',
            `<p>Use <code>background-image</code> CSS property to display an image in the background of an element.</p> ${food_buttons}`,
            null,

        )
        a23_fun_grid.video = `https://youtube.com/bubi`;

        a23_fun_grid.addPage('index.html', `<!doctype html><html><head><link href="style.css" rel="stylesheet">
</head><body><div></div><div></div></body></html>`);

        //<div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div>

        var blank_css = `
        html { height: 100%;}
    body {
        padding:40px;
        box-sizing: border-box;
        min-height:calc(100%);
        //display:grid;
        //grid-template-columns:1fr 1fr 1fr;
        //grid-template-rows:1fr 1fr 1fr;
        //grid-gap:20px;
        font-size:18px;
    }
    
    aadiv {
        //box-shadow:2px 2px 8px rgba(0,0,0,0.2);
        //overflow:hidden;
        //text-align:center;
        position: absolute;
        left:0;
        top:0;
        bottom:0;
        right:0;
    }
    
    h1 {
    margin:10px;
    }
    
    p {
    margin:10px;
    }
`;
        a23_fun_grid.addStylesheet('style.css', blank_css);

        addAlienResources(a23_fun_grid, 5, 'background', 'jpg');
        addAlienResources(a23_fun_grid, 7, 'rocket');
        addAlienResources(a23_fun_grid, 15);
        addAlienResources(a23_fun_grid, 10, 'landscape');
        addAlienResources(a23_fun_grid, 15, 'food');

        //tutorial.addLesson(a23_fun_grid);





        var chapter_rookys_card = `Fun project - Rooky's card`;

        var a24_card_div = new PgTutorialLesson('card_div', 'alien5', chapter_rookys_card);

        a24_card_div.name = `Rooky's card - Div, the handy box`;
        a24_card_div.display_title = `Rooky's card - Div, the handy box` +  addAlien('alien5', null, '60px');

        a24_card_div.description = makeDesc(
            '487510599',
            `<p>The ${showElement('div')} element is used for grouping and styling other HTML elements.</p>`,
            `<p>Start creating a business card for Rooky:</p>
<ol>
            <li>Select the <b>${select('body element', 'body')}</b>, go to the ${tooltip('style panel', 'style')} and set its <b>${field('Background image', 'style:background-image')}</b> to <code>background1.jpg</code>.</li>
            <li><b>Drag the Div element</b> to the page:<br>${a24_card_div.getHtmlForLibButton(tag('div', ''), '<div data-empty-placeholder></div>')}</li>
            <li><b>${select('Select the Div', 'div')}</b> and set its <b>${field('Background color', 'style:background-color')}</b> to <code>white</code>.</li>
</ol>
`,

        )

        a24_card_div.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
    </body>
</html>`);

        var rooky_card_css = `
       
        * {
        box-sizing: border-box;
        }
        
    html {
        height:100%;
    }
    
    body {
        padding: 0;
        margin: 0;
        min-height: 100%;
    }
`;

        a24_card_div.inject_css = rooky_card_css;

        a24_card_div.addStylesheet('style.css', ``);

        a24_card_div.onCheck = function(page, status) {
            var error = null;

            var b = page.sourceNode.findOne('body');

            var bgi = b.getInlineStylePropertyValue('background-image') || '';
            var bgc = b.getInlineStylePropertyValue('background-color') || '';

            if(!bgi && !bgc) {
                error = `<p>Set the Background image CSS property of the <b>body</b> to <code>background1.jpg</code>.</p>`;
            } else if(bgi && !bgi.match(/^url\(\'background[1-5]\.jpg\'\)$/)) {
                error = `<p>Set the Background image CSS property of the <b>body</b> to one of the backgrounds: <code>background1.jpg</code> to <code>background5.jpg</code>.</p>`;
            } else {
                var divs = page.sourceNode.find('div');
                if(divs.length == 0) {
                    error = `<p>Drag the DIV element to the page.</p>`;
                } else if(divs.length > 1) {
                    error = `<p>There should be only one DIV element on the page. ${use_structure_to_fix}</p>`;
                } else if(!divs[0].getInlineStylePropertyValue('background-color')) {
                    error = `<p>Set the Background image CSS property of the <b>DIV</b> to <code>white</code>.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien5', 'check-box');
        }

        addAllResources(a24_card_div);

        tutorial.addLesson(a24_card_div);






        var a25_card_margin = new PgTutorialLesson('card_margin', 'alien5', chapter_rookys_card);

        a25_card_margin.name = `Rooky's card - Outer space margins`;
        a25_card_margin.main_lesson = a24_card_div;

        a25_card_margin.display_title = `Rooky's card - Outer space margins` +  addAlien('alien5', null, '60px');

        a25_card_margin.description = makeDesc(
            '487721552',
            `<p>Use <code>margin</code> CSS property to set the space around the element.</p>`,
            `<p>Continue creating a business card for Rooky:</p>
<ol>
            <li><b>${select('Select the Div', 'div')}</b> element and go to the ${tooltip('style panel', 'style')}.</li>
            <li>Set the <b>Margin</b> on all four sides to <code>40px</code>. Remember to put the <code>px</code> unit after the number.</li>
</ol>
`,

        )

        a25_card_margin.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body style="background-image: url('background1.jpg');">
        <div style="background-color: #ffffff;" data-empty-placeholder></div>
    </body>
</html>`);

        a25_card_margin.inject_css = rooky_card_css;
        a25_card_margin.addStylesheet('style.css', ``);

        var getCssPropValue = function($el, prop) {
            var v = $el.css(prop);
            if(v === '' || v === null) return null;
            v = (v + '').replace('px', '');
            return isNaN(v) ? v : parseFloat(v);
        }

        var getInlineCSSValue = function(pgel, prop) {
            if(prop instanceof RegExp) {
                var v = pgel.getAttr('style') || '';
                var a = v.split(';');
                for(var i = 0; i < a.length; i++) {
                    if(a[i].trim().match(prop)) return true;
                }
                return false;
            }
            var v = pgel.getInlineStylePropertyValue(prop);
            if(v === '' || v === null) return null;
            v = (v + '').replace('px', '');
            return isNaN(v) ? v : parseFloat(v);
        }

        a25_card_margin.onCheck = function(page, status) {
            var error = null;

            var div = page.sourceNode.findOne('div');

            if(!div) {
                error = `<p>Did you delete the DIV? No problem, use Undo or restart the lesson.</p>`;
            } else {
                var $el = div.get$DOMElement();
                var props = ['margin-left', 'margin-top', 'margin-right'];
                for(var i = 0; i < props.length; i++) {
                    var v = getCssPropValue($el, props[i]);
                    if(v === null || v < 20) {
                        error = `<p>The <b>${props[i]}</b> on the DIV element should be <code>40px</code>.</p><p>Make sure that you have the <code>px</code> unit after the number, without spaces.</p>`;
                        break;
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien5', 'check-box');
        }

        addAllResources(a25_card_margin);

        tutorial.addLesson(a25_card_margin);





        var a26_card_br = new PgTutorialLesson('card_br', 'alien5', chapter_rookys_card);

        a26_card_br.name = `Rooky's card - BReak the line`;
        a26_card_br.display_title = `Rooky's card - BReak the line` +  addAlien('alien5', null, '50px');

        a26_card_br.main_lesson = a24_card_div;

        a26_card_br.description = makeDesc(
            '487723919',
            `<p>The ${showElement('br')} element is used to create line breaks in text.</p>`,
            `<p>Add the text to Rooky's business card:</p>
<ol>
            <li><b>Drag the H1</b> for the name and drop it <b>inside the Div</b>, then use the <b>${tooltip('edit text', 'edit_text')}</b> tool to change the text to <code>Rooky Blub</code>:<br>${a26_card_br.getHtmlForLibButton(tag('h1', 'My Name'), '<h1>My Name</h1>', null, null, 'div > h1', 'Drag the H1 into the Div element.')}</li>
            <li><b>Drag the P</b> for the job title and place it <b>below the H1</b>, then change the text to <code>Hotel Manager</code>:<br>${a26_card_br.getHtmlForLibButton(tag('p', 'My Job'), '<p>My Job</p>', null, null, 'div > p', 'Drag the P into the Div element.')}</li>
            <li><b>Drag the P</b> for the contact information and place it <b>below the job title</b>:<br>${a26_card_br.getHtmlForLibButton(tag('p', 'Phone:...'), '<p>Phone: +1234 685 5643 E-mail: rooky.blub@spacehotel.com SpaceTalk: @RookyBlub</p>', null, null, 'div > p', 'Drag the P into the Div element.')}</li>
            <li>Activate the <b>${tooltip('edit text', 'edit_text')}</b> tool and use the ${pgShowKbdCombo('SHIFT+ENTER')} key to break the contact information into three lines.</li>
</ol>
`,

        )
        a26_card_br.video = `https://youtube.com/bubi`;

        a26_card_br.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body style="background-image: url('background1.jpg');">
        <div style="background-color: #ffffff; margin: 40px;" data-empty-placeholder></div>
    </body>
</html>`);

        a26_card_br.inject_css = rooky_card_css;
        a26_card_br.addStylesheet('style.css', ``);

        addAllResources(a26_card_br);

        a26_card_br.onCheck = function(page, status) {
            var error = null;

            var div = page.sourceNode.findOne('div');

            if(!div) {
                error = `<p>Did you delete the DIV? No problem, use Undo or restart the lesson.</p>`;
            } else {
                var els = page.sourceNode.find('h1,p');
                for(var i = 0; i < els.length; i++) {
                    if(els[i].parent !== div) {
                        error = `<p>The <b>${els[i].tagName}</b> should be directly in the DIV element, not in the ${els[i].parent.tagName} element. Use the Structure panel to move it.</p>`;
                        break;
                    }
                    if(els[i].text().trim() === '') {
                        error = `<p>The <b>${els[i].tagName}</b> should have the text. Use the Edit Text tool to edit its content.</p>`;
                        break;
                    }
                }
                if(!error) {
                    var h1 = page.sourceNode.findOne('h1');
                    var p = page.sourceNode.findOne('p');

                    if(!h1) {
                        error = `<p>Drag the H1 element into the DIV.</p>`;
                    } else if(page.sourceNode.find('p').length < 2) {
                        error = `<p>Drag the P element into the DIV.</p>`;
                    } else if(page.sourceNode.find('p br').length < 2) {
                        error = `<p>Break the text into at least three lines. Use Edit Text tool and press SHIFT + Enter to insert a break.</p>`;
                    } else if(h1.text() === 'My Name') {
                        error = `<p>Use the Edit Text tool to write Rooky Blub into the H1.</p>`;
                    } else if(p && p.text() === 'My Job') {
                        error = `<p>Use the Edit Text tool to write Hotel Manager into the first P.</p>`;
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien5', 'check-box');
        }


        tutorial.addLesson(a26_card_br);



        var a27_card_padding = new PgTutorialLesson('card_padding', 'alien5', chapter_rookys_card);

        a27_card_padding.name = `Rooky's card - Pad the inner space`;
        a27_card_padding.display_title = `Rooky's card - Pad the inner space` +  addAlien('alien5', null, '50px');

        a27_card_padding.main_lesson = a24_card_div;

        a27_card_padding.description = makeDesc(
            '487725903',
            `<p>Use the <code>padding</code> CSS property to set the inner space of the element.</p>`,
            `<p>Add spacing around the text:</p>
<ol>
    <li><b>${select('Select the Div', 'div')}</b> element and go to the ${tooltip('style panel', 'style')}.</li>
    <li>Set the <b>Padding left</b> and <b>Padding right</b> to <code>20px</code>.</li>
    <li>Set the <b>Padding top</b> to <code>10px</code>.</li>
    <li>Set the <b>Padding bottom</b> to <code>20px</code>.</li>
</ol>
`,

        )
        a27_card_padding.video = `https://youtube.com/bubi`;

        a27_card_padding.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body style="background-image: url('background1.jpg');">
        <div style="background-color: #ffffff; margin: 40px;">
            <h1>Rooky Blub</h1>
            <p>Hotel manager</p>
            <p>Phone: +1234 685 5643<br>E-mail: rooky.blub@spacehotel.com<br>SpaceTalk: @RookyBlub</p>
        </div>
    </body>
</html>`);

        a27_card_padding.inject_css = rooky_card_css;
        a27_card_padding.addStylesheet('style.css', ``);

        a27_card_padding.onCheck = function(page, status) {
            var error = null;

            var div = page.sourceNode.findOne('div');

            if(!div) {
                error = `<p>Did you delete the DIV? No problem, use Undo or restart the lesson.</p>`;
            } else {
                var $el = div.get$DOMElement();
                var props = ['padding-left', 'padding-top', 'padding-right', 'padding-bottom'];
                for(var i = 0; i < props.length; i++) {
                    var v = getCssPropValue($el, props[i]);
                    if(v === null || v < 10) {
                        error = `<p>The <b>${props[i]}</b> on the DIV element should be at least <code>10px</code>.</p>`;
                        break;
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien5', 'check-box');
        }

        addAllResources(a27_card_padding);

        tutorial.addLesson(a27_card_padding);




        var a28_card_bck = new PgTutorialLesson('card_background', 'alien5', chapter_rookys_card);

        a28_card_bck.name = `Rooky's card - Adding the image`;
        a28_card_bck.display_title = `Rooky's card - Adding the image` +  addAlien('alien5', null, '50px');

        a28_card_bck.main_lesson = a24_card_div;

        a28_card_bck.description = makeDesc(
            '487726795',
            `<p>Use the <code>background-image</code> to add the image to the background of the element.</p>`,
            `<p>Add the image of Rooky to the card:</p>
<ol>
    <li><b>${select('Select the Div', 'div')}</b> element and go to the ${tooltip('style panel', 'style')}.</li>
    <li>Set the <b>Background image</b> to <code>alien5.png</code>.</li>
    <li>Set the <b>Padding left</b> to <code>160px</code>.</li>
    <li>Set the <b>Background repeat</b> to <code>no-repeat</code>.</li>
    <li>Set the <b>Background size</b> to <code>50px</code>.</li>
    <li>Set the <b>Background position</b> to <code>50px center</code>.</li>
</ol>
`,

        )
        a28_card_bck.video = `https://youtube.com/bubi`;

        a28_card_bck.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body style="background-image: url('background1.jpg');">
        <div style="background-color: #ffffff; margin: 40px; padding: 10px 20px 20px;">
            <h1>Rooky Blub</h1>
            <p>Hotel manager</p>
            <p>Phone: +1234 685 5643<br>E-mail: rooky.blub@spacehotel.com<br>SpaceTalk: @RookyBlub</p>
        </div>
    </body>
</html>`);

        a28_card_bck.inject_css = rooky_card_css;
        a28_card_bck.addStylesheet('style.css', ``);

        addAllResources(a28_card_bck);

        a28_card_bck.onCheck = function(page, status) {
            var error = null;

            var div = page.sourceNode.findOne('div');

            if(!div) {
                error = `<p>Did you delete the DIV? No problem, use Undo or restart the lesson.</p>`;
            } else {
                var $el = div.get$DOMElement();
                var pl = getCssPropValue($el, 'padding-left');
                var img = div.getInlineStylePropertyValue('background-image') || '';
                if(!img.match(/^url\(\'alien[1]?[0-9]\.png\'\)$/)) {
                    error = `<p>Set the Background image CSS property of the <b>DIV</b> to <code>alien5.png</code>.</p>`;
                } else if(!pl || pl < 100) {
                    error = `<p>Set the Padding left CSS property of the <b>DIV</b> to <code>160px</code>.</p>`;
                } else if(div.getInlineStylePropertyValue('background-repeat') !== 'no-repeat') {
                    error = `<p>Set the Background repeat CSS property of the <b>DIV</b> to <code>no-repeat</code>.</p>`;
                } else if(!div.getInlineStylePropertyValue('background-size')) {
                    error = `<p>Set the Background size CSS property of the <b>DIV</b> to <code>60px</code>.</p>`;
                } else if(!div.getInlineStylePropertyValue('background-position')) {
                    error = `<p>Set the Background size CSS property of the <b>DIV</b> to <code>50px center</code>.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien5', 'check-box');
        }

        tutorial.addLesson(a28_card_bck);


        var a29_card_dim = new PgTutorialLesson('card_dimensions', 'alien5', chapter_rookys_card);

        a29_card_dim.name = `Rooky's card - Making the card fit`;
        a29_card_dim.display_title = `Rooky's card - Making the card fit` +  addAlien('alien5', null, '50px');

        a29_card_dim.main_lesson = a24_card_div;

        a29_card_dim.description = makeDesc(
            '487728336',
            `<p>Use the <code>width</code> CSS property to set the width of the element.</p>`,
            `<p>Set the size for Rooky's card:</p>
<ol>
    <li><b>${select('Select the Div', 'div')}</b> element and go to the ${tooltip('style panel', 'style')}.</li>
    <li>Scroll down to the <b>Dimensions section</b>.</li>
    <li>Set the <b>Width</b> to <code>450px</code>.</li>
</ol>
`,

        )
        a29_card_dim.video = `https://youtube.com/bubi`;

        a29_card_dim.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body style="background-image: url('background1.jpg');">
        <div style="background-color: #ffffff; margin: 40px; padding: 10px 20px 20px 160px; background-image: url('alien5.png'); background-repeat: no-repeat; background-size: 60px; background-position: 50px center;">
            <h1>Rooky Blub</h1>
            <p>Hotel manager</p>
            <p>Phone: +1234 685 5643<br>E-mail: rooky.blub@spacehotel.com<br>SpaceTalk: @RookyBlub</p>
        </div>
    </body>
</html>`);

        a29_card_dim.inject_css = rooky_card_css;
        a29_card_dim.addStylesheet('style.css', ``);

        a29_card_dim.onCheck = function(page, status) {
            var error = null;

            var div = page.sourceNode.findOne('div');

            if(!div) {
                error = `<p>Did you delete the DIV? No problem, use Undo or restart the lesson.</p>`;
            } else {
                var w = getInlineCSSValue(div, 'width');
                if(!w || w < 400) {
                    error = `<p><b>Width</b> on the DIV element should be at least <code>400px</code>.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien5', 'check-box');
        }

        addAllResources(a29_card_dim);

        tutorial.addLesson(a29_card_dim);


        var a30_card_border = new PgTutorialLesson('card_border', 'alien5', chapter_rookys_card);

        a30_card_border.name = `Rooky's card - Adding border for a final touch`;
        a30_card_border.display_title = `Rooky's card - Adding border for a final touch` +  addAlien('alien5', null, '50px');

        a30_card_border.main_lesson = a24_card_div;

        a30_card_border.description = makeDesc(
            '487729234',
            `<p>Use the <code>border</code> and <code>border-radius</code> CSS properties to style the edges of the element.</p>`,
            `<p>Make Rooky's card even more special:</p>
<ol>
    <li><b>${select('Select the Div', 'div')}</b> element and go to the ${tooltip('style panel', 'style')}.</li>
    <li>Scroll down to the <b>Border</b> section.</li>
    <li>Play around with different border designs. Select the <b>Border style</b> to show the border and set its <b>Border width</b> and <b>Border color</b>. Use the <b>Equal borders</b> button to make the border same on all four sides.</li>
    <li>Set <b>Border radius</b> to round the corners. Use the <b>Equal radius</b> button to make all corners the same.</li>
    <li>Use all your styling skills to design a truly unique card.</li>
    <li>${tooltip('Turn off the menus', 'menu_toggle')} to better see the selected element.</li>
</ol>
`,

        )
        a30_card_border.video = `https://youtube.com/bubi`;

        a30_card_border.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body style="background-image: url('background1.jpg');">
        <div style="background-color: #ffffff; margin: 40px; padding: 10px 20px 20px 160px; background-image: url('alien5.png'); background-repeat: no-repeat; background-size: 60px; background-position: 50px center; width: 450px;">
            <h1>Rooky Blub</h1>
            <p>Hotel manager</p>
            <p>Phone: +1234 685 5643<br>E-mail: rooky.blub@spacehotel.com<br>SpaceTalk: @RookyBlub</p>
        </div>
    </body>
</html>`);

        a30_card_border.inject_css = rooky_card_css;
        a30_card_border.addStylesheet('style.css', rooky_card_css);

        a30_card_border.onCheck = function(page, status) {
            var error = null;

            var div = page.sourceNode.findOne('div');

            if(!div) {
                error = `<p>Did you delete the DIV? No problem, use Undo or restart the lesson.</p>`;
            } else {
                var $el = div.get$DOMElement();
                if($el.css('border-top-style') == 'none') {
                    error = `<p>Set the border style of the DIV element.</p>`;
                } else if($el.css('border-top-style') == 'none' || !getCssPropValue($el, 'border-top-width')) {
                    error = `<p>Set the border width of the DIV element.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien5', 'check-box');
        }

        addAllResources(a30_card_border);

        tutorial.addLesson(a30_card_border);


        var chapter_position = 'Positioning elements';

        var a31_bubbles = new PgTutorialLesson('bubbles_create', 'alien9', chapter_position);

        a31_bubbles.name = `Absolutely fun bubbles - Creating a bubble`;
        a31_bubbles.display_title = `Absolutely fun bubbles - Creating a bubble` +  addAlien('alien9', null, null, '-40px');

        a31_bubbles.description = makeDesc(
            '487967032',
            `<p>Use the <code>%</code> unit to create easily resizable designs.</p>`,
            `<p>Create a space bubble for Toosasa:</p>
<ol>
    <li>Select the ${select('body')} element.</li>
    <li>Set the <b>Background image</b> of the <b>Body</b> to <code>background4.jpg</code>.</li>
    <li><b>Drag the Div element</b> to the page:<br>${a31_bubbles.getHtmlForLibButton(tag('div', ''), '<div data-empty-placeholder></div>', null, null, 'body > div', 'Drag the Div into the Body element, not into another Div.')}</li>
    <li>Set the <b>Background color</b>  of the <b>Div</b> to a transparent white color.</li>
    <li>Set the <b>Width</b> and <b>Height</b> to <code>300px</code>.</li>
    <li>Turn off the ${tooltip('empty placeholder', 'empty_placeholder')}.</li>
    <li>Set the <b>Border radius</b> of all corners to <code>50<b>%</b></code>. Remember to use the <code>%</code> unit.</li>
    <li>Add <code>alien9.png</code> as the <b>Background image</b>, set <b>Background repeat</b> to <code>No repeat</code> and <b>Background position</b> to <code>center center</code>.</li>
    <li>Set the <b>Background size</b> to <code>60%</code>.</li>
</ol>
`,

        )
        a31_bubbles.video = `https://youtube.com/bubi`;

        a31_bubbles.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
    </body>
</html>`);

        a31_bubbles.inject_css = base_css;
        a31_bubbles.addStylesheet('style.css', ``);

        a31_bubbles.onCheck = function(page, status) {
            var error = null;

            var body = page.sourceNode.findOne('body');

            error = checkBackground(body, 'Body');

            if(!error) {
                var div = page.sourceNode.findOne('div');
                if(!div) {
                    error = `<p>Drag the DIV element to the page.</p>`;
                } else {
                    var $div = div.get$DOMElement();
                    if(!div.getInlineStylePropertyValue('background-color')) {
                        error = `<p>Set the background color of the DIV to a transparent white color.</p>`;
                    } else {
                        var w = getCssPropValue($div, 'width');
                        var h = getCssPropValue($div, 'height');
                        if(w !== h) {
                            error = `<p>Set Width and Height of the DIV to <code>300px</code>.</p>`;
                        } else if(div.hasAttribute('data-empty-placeholder')) {
                            error = `<p>Switch off the empty placeholder on the DIV so that you can see the real dimensions of the DIV.</p>`;
                        } else if(div.getInlineStylePropertyValue('border-radius') != '50%') {
                            error = `<p>Set Border radius of all four corners of the DIV element to <code>50<b>%</b></code>. Remember to use the <code>%</code> unit.`;
                        } else {
                            error = checkAlien(div, 'DIV');
                            if(!error) {
                                if(div.getInlineStylePropertyValue('background-repeat') != 'no-repeat') {
                                    error = `<p>Set Background repeat of the DIV to <code>no-repeat</code>.</p>`;
                                } else if(div.getInlineStylePropertyValue('background-position') != 'center center') {
                                    error = `<p>Set Background position of the DIV to <code>center center</code>.</p>`;
                                } else if(!(div.getInlineStylePropertyValue('background-size') || '').match(/^[2-8][0-9]\%$/)) {
                                    error = `<p>Set Background size of the DIV to <code>60%</code>.</p>`;
                                }
                            }
                        }

                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien9', 'check-box');
        }


        addAllResources(a31_bubbles);
        tutorial.addLesson(a31_bubbles);


        var a32_bubbles_absolute = new PgTutorialLesson('bubbles_absolute', 'alien9', chapter_position);

        a32_bubbles_absolute.name = `Absolutely fun bubbles - Let's move the bubble`;
        a32_bubbles_absolute.display_title = `Absolutely fun bubbles - Let's move the bubble` +  addAlien('alien9', null, null, '-40px') +  addAlien('alien10', null, '90px', '-54px', '70px') +  addAlien('alien11', null, '80px', '-50px', '170px');

        a32_bubbles_absolute.main_lesson = a31_bubbles;

        a32_bubbles_absolute.description = makeDesc(
            '487972999',
            `<p>Use <code>position:absolute;</code> and CSS properties <code>left</code>, <code>top</code>, <code>right</code> and <code>bottom</code> to position elements anywhere on the screen.</p>`,
            `<p>Move the bubble around:</p>
<ol>
    <li><b>${select('Select the bubble Div', 'div')}</b> and go to the <b>Position section</b> of the ${tooltip('style panel', 'style')}.</li>
    <li>Set <b>Position</b> to <code>absolute</code>.</li>
    <li>Move the bubble by setting its distance from the <b>Left</b>, <b>Top</b>, <b>Right</b> or <b>Bottom</b> edge.<br><br>
    Remember to delete the Left value if you set the Right, and the other way around. The same for Top and Bottom.</li>
    <li>${tooltip('Duplicate', 'duplicate')} the bubble to <b>create more bubbles</b>. Use the ${tooltip('Structure panel', 'structure')} to see and select overlapping bubbles.</li>
        <li>Use <b>Background image</b> to add other aliens (for example <code>alien1.png</code> and so on) and use <b>Position fields</b> to put them in different positions around the page. For extra fun, resize the bubbles.</li>
</ol>
`,

        )
        a32_bubbles_absolute.video = `https://youtube.com/bubi`;

        a32_bubbles_absolute.addPage('index.html', `<!doctype html>
        <html>
        <head>
        <link href="style.css" rel="stylesheet">
            </head>
            <body style="background-image: url('background4.jpg'); background-repeat: no-repeat; background-size: cover;">
            <div style="background-color: rgba(255, 255, 255, 0.53); width: 300px; height: 300px; border-radius: 50%; background-image: url('alien9.png'); background-repeat: no-repeat; background-position: center center; background-size: 60%;"></div>
            </body>
            </html>`);

        a32_bubbles_absolute.inject_css = base_css;
        a32_bubbles_absolute.addStylesheet('style.css', ``);

        a32_bubbles_absolute.onCheck = function(page, status) {
            var error = null;

            var div = page.sourceNode.findOne('div');
            if(!div) {
                error = `<p>Did you delete the bubble? No problem, use Undo or restart the adventure.</p>`;
            } else {
                if(div.getInlineStylePropertyValue('position') != 'absolute') {
                    error = `<p>Set the Position of the DIV to <code>absolute</code>.</p>`;
                } else if(!div.getInlineStylePropertyValue('top')
                    && !div.getInlineStylePropertyValue('bottom')
                    && !div.getInlineStylePropertyValue('left')
                    && !div.getInlineStylePropertyValue('right')
                ) {
                    error = `<p>Set Top, Left, Bottom or Right properties to move the bubble.</p>`;
                } else if(page.sourceNode.find('div') < 3) {
                    error = `<p>Make two more bubbles by duplicating the first bubble and moving them to different positions.</p>`;
                }
            }


            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien9', 'check-box');
        }

        addAllResources(a32_bubbles_absolute);
        tutorial.addLesson(a32_bubbles_absolute);


        var a33_bubbles_zindex = new PgTutorialLesson('bubbles_zindex', 'alien9', chapter_position);

        a33_bubbles_zindex.name = `Absolutely fun bubbles - Who's at the top?`;
        a33_bubbles_zindex.display_title = `Absolutely fun bubbles - Who's at the top?` +  addAlien('alien9', null, null, '-40px') +  addAlien('alien10', null, '90px', '-54px', '70px') +  addAlien('alien11', null, '80px', '-50px', '170px');

        a33_bubbles_zindex.main_lesson = a31_bubbles;

        a33_bubbles_zindex.description = makeDesc(
            '487977424',
            `<p>Use the <code>z-index</code> CSS property to set which element is at the top.</p>`,
            `<p>Arrange bubbles from top to bottom:</p>
<ol>
    <li><b>Make the bubbles overlap</b> by setting their absolute positions.</li>
    <li>You can change the color of bubbles to better see how they overlap (select a bubble and change its <b>Background color</b>).</li>
    <li>Play around with the <b>Z-Index</b> property to stack them in different ways.</li>
    <li>Use numeric values without units, such as <code>1</code>, <code>2</code>, <code>3</code>... The larger the number, the higher the element is.</li>
</ol>
`,

        )
        a33_bubbles_zindex.video = `https://youtube.com/bubi`;

        a33_bubbles_zindex.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body style="background-image: url('background4.jpg'); background-repeat: no-repeat; background-size: cover;">
        <div style="background-color: rgba(255, 221, 44, 0.53); width: 300px; height: 300px; border-radius: 50%; background-image: url('alien11.png'); background-repeat: no-repeat; background-position: center center; background-size: 55%; position: absolute; left: 276px; top: 51px;"></div>
        <div style="background-color: rgba(192, 157, 255, 0.53); width: 300px; height: 300px; border-radius: 50%; background-image: url('alien9.png'); background-repeat: no-repeat; background-position: center center; background-size: 60%; position: absolute; right: 100px; bottom: 41px;"></div>
        <div style="background-color: rgba(44, 255, 187, 0.53); width: 300px; height: 300px; border-radius: 50%; background-image: url('alien10.png'); background-repeat: no-repeat; background-position: center center; background-size: 55%; position: absolute; left: 40px; top: 120px;"></div>
    </body>
</html>`);

        a33_bubbles_zindex.inject_css = base_css;
        a33_bubbles_zindex.addStylesheet('style.css', base_css);

        a33_bubbles_zindex.onCheck = function(page, status) {
            var error = null;

            var divs = page.sourceNode.find('div');
            if(divs.length < 2) {
                error = `<p>Did you delete one or more bubbles? No problem, use Undo or restart the adventure.</p>`;
            } else {
                for(var i = 0; i < divs.length; i++) {
                    var has = false;
                    if(divs[i].getInlineStylePropertyValue('z-index')) {
                        has = true;
                        break;
                    }
                }
                if(!has) {
                    error = `<p>Set Z Index of bubble DIVs to arrange their stacking order.</p>`;
                }
            }


            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien9', 'check-box');
        }

        addAllResources(a33_bubbles_zindex);
        tutorial.addLesson(a33_bubbles_zindex);



        var a34_relative_key = new PgTutorialLesson('relative_key', 'alien13', chapter_position);

        a34_relative_key.name = `Unlocking the door with the relative position`;
        a34_relative_key.display_title = `Unlocking the door with the relative position` + addAlien('alien13', 'second', null, '-40px') + addAlien('alien1');

        a34_relative_key.description = makeDesc(
            '488386850',
            `<p>Use the <code>position:relative</code> CSS statement to move elements from their original position.</p>`,
            `<p>Help Zootata and Blotomic unlock the space ship door:</p>
<ol>
    <li>Select ${select('a green floating part Div', 'div.key')}.</li>
    <li>Set its <b>Position</b> to <code>relative</code>.</li>
    <li>Use the <b>Top</b> or <b>Bottom</b> properties to move the part down to the base.</li>
    <li>Do the same for all the floating parts.</li>
</ol>
`,

        )
        a34_relative_key.video = `https://youtube.com/bubi`;

        a34_relative_key.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body style="background-image: url('background1.jpg'); background-repeat: no-repeat; background-size: cover; padding: 30px; display: flex; flex-direction: column; align-items: center; justify-content: center;">
        <div style="width: 100%; min-width:300px; max-width:600px;">
            <div style="display: flex; flex-direction: row; align-items: flex-start; justify-content: space-evenly;">
                <div class="key" style="height: 100px;"></div>
                <div class="key" style="height: 80px;"></div>
                <div class="key" style="height: 60px;"></div>
                <div class="key" style="height: 120px;"></div>
            </div>
            <div class="base" style="margin-top: 20px;">
                <span style="text-transform: uppercase; font-size: 20px; font-family: 'Arial Black', Gadget, sans-serif;">Emergency key</span> 
                <br>Slide the floating parts down to open
            </div>
        </div>
    </body>
</html>`);

        a34_relative_key.addStylesheet('style.css', '');
        a34_relative_key.inject_css = base_css + `
.base {
    background-color: #f98c41; 
    height: 82px; 
    border-bottom-left-radius: 20px; 
    border-bottom-right-radius: 20px; 
    text-align: center; 
    padding-top: 18px; 
    font-family: Arial, Helvetica, sans-serif; 
    border-top: 4px solid #ffffff;    
}

.key {
background-color: #25ae4e;
height: 100px; 
border-top: 16px solid #fff400; 
border-top-left-radius: 10px; 
border-top-right-radius: 10px;
margin-right:20px;
display:inline-block;
flex-grow:1;
flex-shrink:1;
min-width:50px;
}
.key:last-child {
    margin-right:0;
}

`;

        a34_relative_key.onCheck = function(page, status) {
            var error = null;

            var keys = page.sourceNode.find('div.key');

            if(keys.length < 4) {
                error = `<p>There should be four keys in the lock. Use Undo or restart the lesson if you deleted some.</p>`;
            } else {
                var tops = [40, 60, 80, 20];
                for (var i = 0; i < keys.length; i++) {
                    if(keys[i].getInlineStylePropertyValue('position') != 'relative') {
                        error = `<p>The key ${i+1} should have Position set to <code>relative</code>.</p>`;
                        break;
                    } else if((Math.abs((getInlineCSSValue(keys[i], 'top') || 0) - tops[i]) >= 2)
                        && (Math.abs((getInlineCSSValue(keys[i], 'bottom') || 0) + tops[i]) >= 2)) {
                        error = `<p>The key ${i+1} should have Top set to <code>${tops[i]}px</code>.</p>`;
                        break;
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }


        addAllResources(a34_relative_key);
        tutorial.addLesson(a34_relative_key);


        var chapter_css_rules = 'CSS rules &amp; classes';

        var a35_rules_shop = new PgTutorialLesson('shop_rules', 'alien2', chapter_css_rules);

        a35_rules_shop.name = `CSS rules in the picture shop`;
        a35_rules_shop.display_title = `CSS rules in the picture shop` + addAlien('alien2', null, null, '-40px');

        a35_rules_shop.description = makeDesc(
            '488390762',
            `<p>CSS rules let us style a group of elements, for example all images.</p>`,
            `<p>Help Mooteetee create frames for her pictures:</p>
<ol>
    <li><b>${select('Select an image', 'img')}</b> and go to the ${tooltip('style panel', 'style')}.</li>
    <li>Click on the <b>Create new CSS rule</b> button.</li>
    <li>Enter <code>img</code> as the selector. This rule will style all images (${showElement('img')} elements) on the page.</li>
    <li>Click on the <b>Create button</b>. Keep the new rule selected and set the style with <b>Border style</b>, <b>Border width</b>, <b>Border color</b>, <b>Border radius</b>, <b>Margin</b> and other CSS properties.</li>
</ol>
`,

        )
        a35_rules_shop.video = `https://youtube.com/bubi`;

        a35_rules_shop.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body style="background-color: #ebe6df; padding: 20px; text-align: center;">
        <img src="picture1.jpg" height="200px">
        <img src="picture2.jpg" height="200px"> 
        <img src="picture3.jpg" height="200px"> 
        <img src="picture4.jpg" height="200px"> 
        <img src="picture5.jpg" height="200px"> 
        <img src="picture6.jpg" height="200px"> 
    </body>
</html>`);

        a35_rules_shop.addStylesheet('style.css',  '');

        a35_rules_shop.inject_css = base_css;
        a35_rules_shop.open_all_files_in_code = true;

        var getStyleCS = function() {
            var has = null;
            pinegrow.getStylesheets().forEach(function(cs) {
                if(cs.url && cs.url.indexOf('/style.css') >= 0) {
                    has = cs;
                }
            })
            return has;
        }

        var getCSSRules = function(sel) {
            var rules = [];

            pinegrow.getStylesheets().forEach(function(cs) {
                if(cs.rootNode) {
                    for(var i = 0; i < cs.rootNode.nodes.length; i++) {
                        var n = cs.rootNode.nodes[i];
                        if(n.type === 'rule') {
                            var s = pgcssh.getSelectorWithoutPgId(n.selector);
                            if(s.trim() === sel) {
                                rules.push(n);
                            }
                        }
                    }
                }
            })
            return rules;
        }

        var cssRulesHaveProperty = function(rules, prop, val) {
            for(var i = 0; i < rules.length; i++) {
                for(var j = 0; j < rules[i].nodes.length; j++) {
                    if(rules[i].nodes[j].type === 'decl') {
                        if(typeof prop === 'string') {
                            if(rules[i].nodes[j].prop === prop && (!val || val === rules[i].nodes[j].value)) return true;
                        } else {
                            if(rules[i].nodes[j].prop.match(prop)) return true;
                        }
                    }
                }
            }
            return false;
        }

        a35_rules_shop.onCheck = function(page, status) {
            var error = null;

            var rules = getCSSRules('img');

            if(rules.length === 0) {
                error = `<p>Create a new CSS rule with the selector <code>img</code>.</p>`;
            } else if(!cssRulesHaveProperty(rules, /^border/)) {
                error = `<p>Select the <code>img</code> rule in the Style panel and set the border.</p>`;
            } else if(!cssRulesHaveProperty(rules, /^margin/)) {
                error = `<p>Select the <code>img</code> rule in the Style panel and set margins.</p>`;
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien2', 'check-box');
        }

        addAllResources(a35_rules_shop);
        tutorial.addLesson(a35_rules_shop);



        var a36_rule_location = new PgTutorialLesson('shop_location', 'alien2', chapter_css_rules);

        a36_rule_location.name = `Where is the CSS rule?`;
        a36_rule_location.display_title = `Where is the CSS rule?` + addAlien('alien2', null, null, '-40px');

        a36_rule_location.main_lesson = a35_rules_shop;

        a36_rule_location.description = makeDesc(
            '488395679',
            `<p>CSS rules are stored in stylesheet files. The ${showElement('link')} element is used to connect stylesheets with the page.</p>`,
            `<p>Explore the code and try changing the CSS rule:</p>
<ol>
    <li>Open the <b>${tooltip('code editor', 'code_editor')}</b>.</li>
    <li>In the code editor, go to <b>${codeEditor('style.css')}</b> tab.</li>
    <li><b>${select('Select an image', 'img')}</b> on the page.</li>
    <li>Make sure the ${rule('img')} is selected in the ${tooltip('style panel', 'style')}.</li>
    <li>Use the ${tooltip('style panel', 'style')} to change the design of the ${rule('img')} and notice how the CSS code is changing (when using color picker, click on Choose in the picker to see the change in the code).</li>
</ol>
`,

        )
        a36_rule_location.video = `https://youtube.com/bubi`;

        a36_rule_location.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body style="background-color: #ebe6df; padding: 20px; text-align: center;">
        <img src="picture1.jpg" height="200px">
        <img src="picture2.jpg" height="200px"> 
        <img src="picture3.jpg" height="200px"> 
        <img src="picture4.jpg" height="200px"> 
        <img src="picture5.jpg" height="200px"> 
        <img src="picture6.jpg" height="200px"> 
    </body>
</html>`);

        a36_rule_location.addStylesheet('style.css',  `img {
    margin-right: 20px;
    margin-bottom: 20px;
    border: 10px ridge #ffffff;
}
`);

        a36_rule_location.inject_css = base_css;
        a36_rule_location.open_all_files_in_code = true;

        a36_rule_location.onCheck = function(page, status) {
            var error = null;
            var cs = getStyleCS();
            if(cs && !cs.changed) {
                error = `<p>Go ahead, try changing a CSS rule and observe the change in the style.css code editor.`;
            }
            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien2', 'check-box');
        }


        addAllResources(a36_rule_location);
        tutorial.addLesson(a36_rule_location);


        var a37_rule_style = new PgTutorialLesson('shop_style', 'alien2', chapter_css_rules);

        a37_rule_style.name = `CSS rules and the Style attribute`;
        a37_rule_style.display_title = `CSS rules and the Style attribute` + addAlien('alien2', null, null, '-40px');

        a37_rule_style.main_lesson = a35_rules_shop;

        a37_rule_style.description = makeDesc(
            '488396963',
            `<p>CSS rules and Style attribute can work together.</p>`,
            `<p>Make one of the frames special by changing the element style:</p>
<ol>
    <li>Select the <b>${select('second image','img:nth-child(2)')}</b>.</li>
    <li>In the ${tooltip('style panel', 'style')}, select the <b>Style attribute</b> to edit the <code>style</code> attribute of the Rocket ${select('img', 'img:nth-child(2)')} element.</li>
    <li>Change the <b>Border color</b> or other CSS properties of the Style attribute.</li>
    <li>Select the ${rule('img')} and see what happens if you change it.</li>
    <li>Notice that the Style attribute properties override the properties of the <code>img</code> CSS rule.</li>
</ol>
`,

        )
        a37_rule_style.video = `https://youtube.com/bubi`;

        a37_rule_style.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body style="background-color: #ebe6df; padding: 20px; text-align: center;">
        <img src="picture1.jpg" height="200px">
        <img src="picture2.jpg" height="200px"> 
        <img src="picture3.jpg" height="200px"> 
        <img src="picture4.jpg" height="200px"> 
        <img src="picture5.jpg" height="200px"> 
        <img src="picture6.jpg" height="200px"> 
    </body>
</html>`);

        a37_rule_style.addStylesheet('style.css',  `img {
    margin-right: 20px;
    margin-bottom: 20px;
    border: 10px ridge #ffffff;
}
`);

        a37_rule_style.inject_css = base_css;
        a37_rule_style.open_all_files_in_code = true;

        a37_rule_style.onCheck = function(page, status) {
            var error = null;

            var img = page.sourceNode.findOne('img[src="picture2.jpg"]');

            if(!img) {
                error = `<p>Did you delete the rocket picture? No problem, use Undo or restart the lesson.</p>`;
            } else {
                var s = img.getAttr('style') || '';

                if(!s.match(/border/)) {
                    error = `<p>Select the rocket image, select the Style attribute and set the border.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien2', 'check-box');
        }

        addAllResources(a37_rule_style);
        tutorial.addLesson(a37_rule_style);


        var chapter_classes = 'CSS rules &amp; classes';

        var a38_class_buttons = new PgTutorialLesson('class_buttons', 'alien15', chapter_classes);

        a38_class_buttons.name = `Spaceship button classes - Creating the layout`;
        a38_class_buttons.display_title = `Spaceship button classes - Creating the layout` + addAlien('alien15', null, null, '-40px');

        a38_class_buttons.description = makeDesc(
            '488399088',
            `<p>Use ${showElement('button')} elements is create clickable buttons.</p>`,
            `<p>Add buttons and edit their labels:</p>
<ol>
     <li>Drag <code>six</code> <b>${showElement('button')} elements</b> to the page:<br>${a38_class_buttons.getHtmlForLibButton(tag('button', 'Press me'), '<button>Press me</button>')}</li>
    <li>Select each ${select('button')} one by one and use the <b>${tooltip('text edit', 'edit_text')}</b> tool to set button names such as <code>On</code>, <code>Off</code>, <code>Speed up</code>, <code>Slow down</code>, <code>Space horn</code> and <code>Eject</code>.</li>
    <li>Note, pressing the ${pgShowKbd('ENTER')} key while editing the text will create new button elements. Select and delete such unwanted elements.</li>
</ol>
`,

        )
        a38_class_buttons.video = `https://youtube.com/bubi`;

        a38_class_buttons.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
    </body>
</html>`);

        a38_class_buttons.addStylesheet('style.css',  `
`);

        var base_class_with_padding = base_css + `
body {
padding:20px;
}`

        a38_class_buttons.inject_css = base_class_with_padding;
        a38_class_buttons.open_all_files_in_code = true;

        a38_class_buttons.onCheck = function(page, status) {
            var error = null;

            var buttons = page.sourceNode.find('button');

            if(buttons.length < 6) {
                error = `<p>Drag more buttons to the page. There should be at least six.</p>`;
            } else {
                for(var i = 0; i < buttons.length; i++) {
                    if(buttons[i].text() === 'Press me') {
                        error = `<p>Use the Edit text tool to change the label of the button ${i+1}.</p>`;
                        break;
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien15', 'check-box');
        }

        addAllResources(a38_class_buttons);
        tutorial.addLesson(a38_class_buttons);




        var a39_class_buttons_rule = new PgTutorialLesson('class_buttons_rule', 'alien15', chapter_classes);

        a39_class_buttons_rule.name = `Spaceship button classes - The dot space button rule`;
        a39_class_buttons_rule.display_title = `Spaceship button classes - The dot space button rule` + addAlien('alien15', null, null, '-40px');

        a39_class_buttons_rule.main_lesson = a38_class_buttons;

        a39_class_buttons_rule.description = makeDesc(
            '488402079',
            `<p>Selectors of CSS rules for classes have a <code>.</code> in front of the class name.</p>`,
            `<p>Create a CSS rule for the class <code>space-button</code>:</p>
<ol>
     <li><b>Select the first ${select('button')}</b> and go to the ${tooltip('style panel', 'style')}.</li>
     <li>Click on the <b>Create new CSS rule</b> button.</li>
     <li>Enter <code>.space-button</code> in the selector field (don't forget the dot <code>.</code>) and click on <b>Create</b>.</li>
     <li>Keep the new rule <code>.space-button</code> selected and set the <b>Background color</b>.</li>
     <li><b>Open the ${tooltip('code editor', 'code_editor')}</b> to check out the HTML and CSS code. Notice the <code>class</code> attribute on the first ${showElement('button')} element.</li>
</ol>
`,

        )
        a39_class_buttons_rule.video = `https://youtube.com/bubi`;

        a39_class_buttons_rule.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <button>On</button>
        <button>Off</button>
        <button>Speed up</button>
        <button>Slow down</button>
        <button>Space horn</button>
        <button>Eject</button>        
    </body>
</html>`);

        a39_class_buttons_rule.addStylesheet('style.css',  `
`);

        a39_class_buttons_rule.inject_css = base_class_with_padding;
        a39_class_buttons_rule.open_all_files_in_code = true;

        a39_class_buttons_rule.onCheck = function(page, status) {
            var error = null;

            var rules = getCSSRules('.space-button');

            if(rules.length === 0) {
                error = `<p>Create a new CSS rule with the selector <code>.space-button</code>.</p>`;
            } else if(page.sourceNode.find('button.space-button').length === 0) {
                error = `<p>Add the <code>space-button</code> class to the first button by keeping the Add class checked when you create the CSS rule.</p>`;
            } else if(!cssRulesHaveProperty(rules, 'background-color')) {
                error = `<p>Select the <code>.space-button</code> rule in the Style panel and set its Background color.</p>`;
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien15', 'check-box');
        }

        addAllResources(a39_class_buttons_rule);
        tutorial.addLesson(a39_class_buttons_rule);






        var a40_class_buttons_styling_real = new PgTutorialLesson('class_buttons_style', 'alien15', chapter_classes);

        a40_class_buttons_styling_real.name = `Spaceship button classes - Designing the buttons`;
        a40_class_buttons_styling_real.display_title = `Spaceship button classes - Designing the buttons` + addAlien('alien15', null, null, '-40px');

        a40_class_buttons_styling_real.main_lesson = a38_class_buttons;

        a40_class_buttons_styling_real.description = makeDesc(
            '488806481',
            `<p>Use the Style panel to style the selected CSS rule.</p>`,
            `<p>Style the <code>.space-button</code> CSS rule to design the buttons:</p>
<ol>
     <li>Select the first <b>${select('button')} element</b> and go to the ${tooltip('style panel', 'style')}.</li>
     <li>Make sure the ${rule('.space-button')} is selected.</li>
     <li>Set the <b>Width</b> to <code>150px</code> and the <b>Height</b> to <code>80px</code>.</li>
     <li>Set the <b>Margin top</b>, <b>Margin left</b> and <b>Margin right</b> to <code>10px</code>.</li>
     <li>Set the <b>Font family</b> to <code>Arial</code>, <b>Font size</b> to <code>16px</code>, <b>Text transform</b> and <code>uppercase</code>.</li>
     <li>Set the <b>Padding left</b> and <b>Padding right</b> to <code>10px</code> to add inner space.</li>
     <li>Set the <b>Border style</b> to <code>solid</code> (the first choice), <b>Border width</b> to <code>10px</code>, <b>Border color</b> to a shade of gray and <b>Border radius</b> to <code>20px</code>.</li>
    <li>These values are just examples. Feel free to create your own design.</li>
</ol>
`,

        )
        a40_class_buttons_styling_real.video = `https://youtube.com/bubi`;

        a40_class_buttons_styling_real.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <button class="space-button">On</button>
        <button>Off</button>
        <button>Speed up</button>
        <button>Slow down</button>
        <button>Space horn</button>
        <button>Eject</button>          
    </body>
</html>`);

        a40_class_buttons_styling_real.addStylesheet('style.css',  `
.space-button {
}
`);

        a40_class_buttons_styling_real.inject_css = base_class_with_padding;
        a40_class_buttons_styling_real.open_all_files_in_code = true;

        a40_class_buttons_styling_real.onCheck = function(page, status) {
            var error = null;

            var rules = getCSSRules('.space-button');

            if(rules.length === 0) {
                error = `<p>Create a new CSS rule with the selector <code>.space-button</code>.</p>`;
            } else if(!cssRulesHaveProperty(rules, 'width')) {
                error = `<p>Select the <code>.space-button</code> rule in the Style panel and set its <b>Width</b> to <code>150px</code>.</p>`;
            } else if(!cssRulesHaveProperty(rules, 'height')) {
                error = `<p>Select the <code>.space-button</code> rule in the Style panel and set its <b>Height</b> to <code>80px</code>.</p>`;
            } else if(!cssRulesHaveProperty(rules, /^margin/)) {
                error = `<p>Select the <code>.space-button</code> rule in the Style panel and set its <b>Margins</b>.</p>`;
            } else if(!cssRulesHaveProperty(rules, /^padding/)) {
                error = `<p>Select the <code>.space-button</code> rule in the Style panel and set its <b>Padding</b>.</p>`;

            } else if(!cssRulesHaveProperty(rules, 'font-family')) {
                error = `<p>Select the <code>.space-button</code> rule in the Style panel and set its <b>Font family</b>.</p>`;
            } else if(!cssRulesHaveProperty(rules, 'font-size')) {
                error = `<p>Select the <code>.space-button</code> rule in the Style panel and set its <b>Font size</b>.</p>`;
            } else if(!cssRulesHaveProperty(rules, 'text-transform')) {
                error = `<p>Select the <code>.space-button</code> rule in the Style panel and set its <b>Text transform</b> to <code>uppercase</code>.</p>`;
            } else if(!cssRulesHaveProperty(rules, /^border/)) {
                error = `<p>Select the <code>.space-button</code> rule in the Style panel and set its <b>Border</b>.</p>`;

            }


            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien15', 'check-box');
        }

        addAllResources(a40_class_buttons_styling_real);
        tutorial.addLesson(a40_class_buttons_styling_real);



        var a41_class_buttons_adding_classes = new PgTutorialLesson('class_buttons_adding_classes', 'alien15', chapter_classes);

        a41_class_buttons_adding_classes.name = `Spaceship button classes - Adding the class to all buttons`;
        a41_class_buttons_adding_classes.display_title = `Spaceship button classes - Adding the class to all buttons` + addAlien('alien15', null, null, '-40px');

        a41_class_buttons_adding_classes.main_lesson = a38_class_buttons;

        a41_class_buttons_adding_classes.description = makeDesc(
            '488809154',
            `<p>Use the <b>Classes</b> section in the <b>Attributes panel</b> to add existing classes to elements.</p>`,
            `<p>Add the class <code>space-button</code> to the rest of the buttons:</p>
<ol>
     <li>Select the <b>${select('second button', 'button:nth-child(2)')}</b> and go to the <b>${tooltip('attributes panel', 'attributes_panel')}</b>.</li>
    <li>In the <b>Classes</b> section click on the <code>space-button</code> class to add it to the selected element.</li>
    <li>Do the same for the rest of the ${showElement('button')} elements.</li>
</ol>
`,

        )
        a41_class_buttons_adding_classes.video = `https://youtube.com/bubi`;

        a41_class_buttons_adding_classes.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <button class="space-button">On</button>
        <button>Off</button>
        <button>Speed up</button>
        <button>Slow down</button>
        <button>Space horn</button>
        <button>Eject</button>              
    </body>
</html>`);

        a41_class_buttons_adding_classes.addStylesheet('style.css',  `
.space-button {
    width: 150px;
    height: 80px;
    margin-left: 10px;
    margin-right: 10px;
    margin-top: 10px;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 16px;
    text-transform: uppercase;
    padding-left: 10px;
    padding-right: 10px;
    border: 10px solid #5a5a5a;
    border-radius: 20px;
}
`);

        a41_class_buttons_adding_classes.inject_css = base_class_with_padding;
        a41_class_buttons_adding_classes.open_all_files_in_code = true;

        a41_class_buttons_adding_classes.onCheck = function(page, status) {
            var error = null;

            var buttons = page.sourceNode.find('button');

            for(var i = 0; i < buttons.length; i++) {
                if(!buttons[i].hasClass('space-button')) {
                    error = `<p>The button ${i+1} doesn't have the class <code>space-button</code>.</p>`;
                    break;
                }
            }

            if(!error) {
                buttons = page.sourceNode.find('.space-button');

                for(var i = 0; i < buttons.length; i++) {
                    if(buttons[i].tagName !== 'button') {
                        error = `<p>The ${buttons[i].tagName} element should not have the class <code>space-button</code>.</p>`;
                        break;
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien15', 'check-box');
        }

        addAllResources(a41_class_buttons_adding_classes);
        tutorial.addLesson(a41_class_buttons_adding_classes);



        var a42_class_buttons_subclasses = new PgTutorialLesson('class_buttons_subclasses', 'alien15', chapter_classes);

        a42_class_buttons_subclasses.name = `Spaceship button classes - A smart way to color the buttons`;
        a42_class_buttons_subclasses.display_title = `Spaceship button classes - A smart way to color the buttons` + addAlien('alien15', null, null, '-40px');

        a42_class_buttons_subclasses.main_lesson = a38_class_buttons;

        a42_class_buttons_subclasses.description = makeDesc(
            '488810750',
            `<p>HTML elements can have more than one class. Properties of their CSS rules are combined.</p>`,
            `<p>Create classes for green buttons:</p>
<ol>
     <li>Select the <b>${select('ON button', 'button')}</b> and go to the ${tooltip('style panel', 'style')}.</li>
     <li>Click on the <b>Create new CSS rule</b> button and enter the selector <code>.green-space-button</code>. Click on Create.</li>
     <li>Set the <b>Background color</b> to green and the <b>Border color</b> to darker shade of green. Use the <b>Equal borders</b> button to make all borders the same.</li>
     <li>Select the <b>${select('Speed up', 'button:nth-child(3)')}</b> button. Go to the <b>${tooltip('attributes panel', 'attributes_panel')}</b> and in <b>Classes</b> section add the <code>green-space-button</code> class.</li>
     <li>Try changing the ${rule('.space-button')} and see what happens.</li>
</ol>
`,

        )
        a42_class_buttons_subclasses.video = `https://youtube.com/bubi`;

        a42_class_buttons_subclasses.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <button class="space-button">On</button>
        <button class="space-button">Off</button>
        <button class="space-button">Speed up</button>
        <button class="space-button">Slow down</button>
        <button class="space-button">Space horn</button>
        <button class="space-button">Eject</button>       
    </body>
</html>`);

        a42_class_buttons_subclasses.addStylesheet('style.css',  `
.space-button {
    width: 150px;
    height: 80px;
    margin-left: 10px;
    margin-right: 10px;
    margin-top: 10px;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 16px;
    text-transform: uppercase;
    padding-left: 10px;
    padding-right: 10px;
    border: 10px solid #5a5a5a;
    border-radius: 20px;
}

`);

        a42_class_buttons_subclasses.inject_css = base_class_with_padding;
        a42_class_buttons_subclasses.open_all_files_in_code = true;

        a42_class_buttons_subclasses.onCheck = function(page, status) {
            var error = null;

            var rules = getCSSRules('.green-space-button');

            if(rules.length === 0) {
                error = `<p>Create a new CSS rule with the selector <code>.green-space-button</code>.</p>`;
            } else if(page.sourceNode.find('button.green-space-button').length === 0) {
                error = `<p>Add the <code>green-space-button</code> class to the first button by keeping the Add class checked when you create the CSS rule.</p>`;
            } else if(!cssRulesHaveProperty(rules, 'background-color')) {
                error = `<p>Select the <code>.green-space-button</code> rule in the Style panel and set its Background color to a shade of green.</p>`;
            } else if(!cssRulesHaveProperty(rules, /^border/)) {
                error = `<p>Select the <code>.green-space-button</code> rule in the Style panel and set its Border color to a shade of green.</p>`;
            } else if(page.sourceNode.find('button.green-space-button').length < 2) {
                error = `<p>Add the class <code>green-space-button</code> to at least one other button. Use the Attributes panel to do that.</p>`;
            }


            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien15', 'check-box');
        }

        addAllResources(a42_class_buttons_subclasses);
        tutorial.addLesson(a42_class_buttons_subclasses);



        var a43_class_buttons_red = new PgTutorialLesson('class_buttons_red', 'alien15', chapter_classes);

        a43_class_buttons_red.name = `Spaceship button classes - The red button`;
        a43_class_buttons_red.display_title = `Spaceship button classes - The red button` + addAlien('alien15', null, null, '-40px');

        a43_class_buttons_red.main_lesson = a38_class_buttons;

        a43_class_buttons_red.description = makeDesc(
            '488813037',
            `<p>The order of CSS rules in the code is important.</p>`,
            `<p>Create the CSS rule for the red button:</p>
<ol>
     <li>Select the <b>${select('Eject button', 'button:nth-child(6)')}</b> and go to the ${tooltip('style panel', 'style')}.</li>
     <li>Click on the <b>Create new CSS rule</b> button and enter the selector <code>.red-space-button</code>. Then click on Create.</li>
     <li>Set the <b>Background color</b> to red and the <b>Border color</b> to a darker shade of red. Use the equal button to make all borders the same.</li>
     <li>Open the ${tooltip('code editor', 'code_editor')} and take a look at the ${codeEditor('style.css code', 'style.css')}. The rule that comes later in the code is more important.</li>
     <li>The style panel displays the rules from the most important down to the least important.</li>
</ol>
`,

        )
        a43_class_buttons_red.video = `https://youtube.com/bubi`;

        a43_class_buttons_red.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <button class="green-space-button space-button">On</button>
        <button class="space-button">Off</button>
        <button class="green-space-button space-button">Speed up</button>
        <button class="space-button">Slow down</button>
        <button class="space-button">Space horn</button>
        <button class="space-button">Eject</button>     
    </body>
</html>`);

        a43_class_buttons_red.addStylesheet('style.css',  `
.space-button {
    width: 150px;
    height: 80px;
    margin-left: 10px;
    margin-right: 10px;
    margin-top: 10px;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 16px;
    text-transform: uppercase;
    padding-left: 10px;
    padding-right: 10px;
    border: 10px solid #5a5a5a;
    border-radius: 50px;
}

.green-space-button {
    background-color: #00dd0d;
    border-color: #068f00;
}

`);

        a43_class_buttons_red.inject_css = base_class_with_padding;
        a43_class_buttons_red.open_all_files_in_code = true;

        a43_class_buttons_red.onCheck = function(page, status) {
            var error = null;

            var rules = getCSSRules('.red-space-button');

            if(rules.length === 0) {
                error = `<p>Create a new CSS rule with the selector <code>.red-space-button</code>.</p>`;
            } else if(page.sourceNode.find('button.red-space-button').length === 0) {
                error = `<p>Add the <code>red-space-button</code> class to a button by keeping the Add class checked when you create the CSS rule.</p>`;
            } else if(!cssRulesHaveProperty(rules, 'background-color')) {
                error = `<p>Select the <code>.red-space-button</code> rule in the Style panel and set its Background color to a shade of red.</p>`;
            } else if(!cssRulesHaveProperty(rules, /^border/)) {
                error = `<p>Select the <code>.red-space-button</code> rule in the Style panel and set its Border color to a shade of red.</p>`;
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien15', 'check-box');
        }

        addAllResources(a43_class_buttons_red);
        tutorial.addLesson(a43_class_buttons_red);


        var a44_class_buttons_hover = new PgTutorialLesson('class_buttons_hover', 'alien15', chapter_classes);

        a44_class_buttons_hover.name = `Spaceship button classes - Hover and active`;
        a44_class_buttons_hover.display_title = `Spaceship button classes - Hover and active` + addAlien('alien15', null, null, '-40px');

        a44_class_buttons_hover.main_lesson = a38_class_buttons;

        a44_class_buttons_hover.description = makeDesc(
            '488814213',
            `<p>Use CSS rules with <code>:hover</code> and <code>:active</code> to style elements when the mouse pointer is over them and when they are clicked.</p>`,
            `<p>Create CSS rules for hover (mouse over) and active (click) states:</p>
<ol>
     <li><b>${select('Select a button', 'button')}</b> and go to the ${tooltip('style panel', 'style')}.</li>
     <li>Click on the <b>Create new CSS rule</b> button and enter the selector <code>.space-button:hover</code>. Then click on Create.</li>
     <li>Change the <b>Border width</b> to a different value, for example <code>5px</code>. Use the <b>Equal borders</b> button to set the width on all fours sides. <b>Move the mouse over the buttons</b> to see the effect.</li>
     <li><b>Create new CSS rule</b> for <code>.space-button:active</code>. Set <b>Position</b> to <code>relative</code> and <b>Top</b> to <code>5px</code>. In the <b>Border</b> section set the <b>Outline</b> to <code>none</code>.</li>
     <li>Try clicking on buttons.</li>
</ol>
`,

        )
        a44_class_buttons_hover.video = `https://youtube.com/bubi`;

        a44_class_buttons_hover.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <button class="green-space-button space-button">On</button>
        <button class="space-button">Off</button>
        <button class="green-space-button space-button">Speed up</button>
        <button class="space-button">Slow down</button>
        <button class="space-button">Space horn</button>
        <button class="red-space-button space-button">Eject</button>    
    </body>
</html>`);

        a44_class_buttons_hover.addStylesheet('style.css',  `
.space-button {
    width: 150px;
    height: 80px;
    margin-left: 10px;
    margin-right: 10px;
    margin-top: 10px;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 16px;
    text-transform: uppercase;
    padding-left: 10px;
    padding-right: 10px;
    border: 10px solid #5a5a5a;
    border-radius: 50px;
}

.green-space-button {
    background-color: #00dd0d;
    border-color: #068f00;
}

.red-space-button {
    background-color: #ff5d5d;
    border-color: #d30000;
}
`);

        a44_class_buttons_hover.inject_css = base_class_with_padding;
        a44_class_buttons_hover.open_all_files_in_code = true;

        a44_class_buttons_hover.onCheck = function(page, status) {
            var error = null;

            var rules = getCSSRules('.space-button:hover');

            if(rules.length === 0) {
                error = `<p>Create a new CSS rule with the selector <code>.space-button:hover</code>.</p>`;
            } else if(!cssRulesHaveProperty(rules, /^border/)) {
                error = `<p>Select the <code>.space-button:hover</code> rule in the Style panel and set its Border.</p>`;
            } else {

                var rules = getCSSRules('.space-button:active');

                if (rules.length === 0) {
                    error = `<p>Create a new CSS rule with the selector <code>.space-button:active</code>.</p>`;
                } else if (!cssRulesHaveProperty(rules, 'position')) {
                    error = `<p>Select the <code>.space-button:active</code> rule in the Style panel and set its Position to <code>relative</code>.</p>`;
                } else if (!cssRulesHaveProperty(rules, 'top')) {
                    error = `<p>Select the <code>.space-button:active</code> rule in the Style panel and set its Top to <code>5px</code>.</p>`;
                } else if (!cssRulesHaveProperty(rules, 'outline')) {
                    error = `<p>Select the <code>.space-button:active</code> rule in the Style panel and set its Outline to <code>none</code>.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien15', 'check-box');
        }

        addAllResources(a44_class_buttons_hover);
        tutorial.addLesson(a44_class_buttons_hover);


        var chapter_space_rides = 'Fun project - Create a Super Space Rides website';

        var a45_website_1_structure = new PgTutorialLesson('zootata_website_structure', 'alien13', chapter_space_rides);

        a45_website_1_structure.name = `Super Space Rides - The structure`;
        a45_website_1_structure.display_title = `Super Space Rides - The structure` + addAlien('alien13', null, null, '-30px');

        a45_website_1_structure.description = makeDesc(
            '489265274',
            `<p>Use <b>${showElement('header')}</b>, <b>${showElement('section')}</b> and <b>${showElement('footer')}</b> HTML elements to organize the website content.</p>`,
            `<p>Create the structure for the website:</p>
<ol>
     <li><b>Drag the Header element</b> to the top of the page. We will use it for the main heading and the company introduction.<br>${a45_website_1_structure.getHtmlForLibButton(tag('header', ''), '<header data-empty-placeholder></header>', null, null, 'body > header', 'The Header should be the first element in the Body.')}</li>
     <li><b>Add four Section elements</b> for Space rides, Video, Quotes and Contact us sections:<br>${a45_website_1_structure.getHtmlForLibButton(tag('section', ''), '<section data-empty-placeholder></section>', null, null, 'body > section', 'The Section should be in the Body element, not in Header or in another Section.')}</li>
      <li><b>Place the Footer element</b> at the bottom of the page. The footer will contain the company address.<br>${a45_website_1_structure.getHtmlForLibButton(tag('footer', ''), '<footer data-empty-placeholder></footer>', null, null, 'body > footer', 'The Footer should be the last element in the Body.')}</li>
     <li>Use the <b>Structure panel</b> to check that the order of the elements is correct:
     <pre>
Body
    <b>header</b>
    <b>section</b>
    <b>section</b>
    <b>section</b>
    <b>section</b>
    <b>footer</b></pre>
     </li>
</ol>
`,

        )
        a45_website_1_structure.video = `https://youtube.com/bubi`;

        a45_website_1_structure.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
    </body>
</html>`);

        a45_website_1_structure.addStylesheet('style.css',  `
`);

        a45_website_1_structure.inject_css = base_css;
        a45_website_1_structure.open_all_files_in_code = true;

        var getNumberName = function(i) {
            switch(i) {
                case 1: return 'first';
                case 2: return 'second';
                case 3: return 'third';
                default: return i + 'th';
            }
        }

        a45_website_1_structure.onCheck = function(page, status) {
            var error = null;

            var s = ['header', 'section', 'section', 'section', 'section', 'footer'];

            var all = page.sourceNode.find('header,section,footer');

            for(var i = 0; i < s.length; i++) {
                if(all.length <= i || all[i].tagName !== s[i]) {
                    error = `<p>The ${getNumberName(i+1)} element in the Body should be a <b>${s[i]}</b>.</p>`;
                } else if(all[i].parent.tagName !== 'body') {
                    error = `<p>The ${all[i].tagName} should be in the Body element.</p>`;
                }
                if(error) break;
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a45_website_1_structure);
        tutorial.addLesson(a45_website_1_structure);





        var a45_website_1_ids = new PgTutorialLesson('zootata_website_ids', 'alien13', chapter_space_rides);

        a45_website_1_ids.name = `Super Space Rides - Give names to elements`;
        a45_website_1_ids.display_title = `Super Space Rides - Give names to elements` + addAlien('alien13', null, null, '-30px');

        a45_website_1_ids.main_lesson = a45_website_1_structure;

        a45_website_1_ids.description = makeDesc(
            '489270095',
            `<p>Use the <b>id</b> attribute to give names to important HTML elements.</p>`,
            `<p>Give names to all section elements:</p>
<ol>
    <li><b>Select the first ${select('section')}</b> element.</li>
    <li>Go to the <b>${tooltip('attributes panel', 'attributes_panel')}</b>.</li>
    <li>Set <b>Id</b> to <code>rides</code>.</li>
    <li>Set the ids of the other three sections to <code>video</code>, <code>quotes</code> and <code>contact</code>.</li>
     <li>Use the <b>${tooltip('structure panel', 'structure')}</b> to check that the order and ids of the elements are correct:
     <pre>
Body
    header
    section#<b>rides</b>
    section#<b>video</b>
    section#<b>quotes</b>
    section#<b>contact</b>
    footer</pre>
     </li>
</ol>
`,

        )
        a45_website_1_ids.video = `https://youtube.com/bubi`;

        a45_website_1_ids.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header data-empty-placeholder></header>
        <section data-empty-placeholder></section>
        <section data-empty-placeholder></section>
        <section data-empty-placeholder></section>
        <section data-empty-placeholder></section>
        <footer data-empty-placeholder></footer>
    </body>
</html>`);

        a45_website_1_ids.addStylesheet('style.css',  `
`);

        a45_website_1_ids.inject_css = base_css;
        a45_website_1_ids.open_all_files_in_code = true;

        a45_website_1_ids.onCheck = function(page, status) {
            var error = null;

            var s = ['rides', 'video', 'quotes', 'contact'];

            var all = page.sourceNode.find('section');

            if(all.length !== 4) {
                error = `<p>There should be four Section elements on the page. ${use_structure_to_fix}</p>`;
            } else {
                for (var i = 0; i < all.length; i++) {
                    if(all[i].getAttr('id') !== s[i]) {
                        error = `<p>The id of the ${getNumberName(i + 1)} section should be <b>${s[i]}</b>.</p>`;
                        break;
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a45_website_1_ids);
        tutorial.addLesson(a45_website_1_ids);





        var a45_website_2_header = new PgTutorialLesson('zootata_website_header', 'alien13', chapter_space_rides);

        a45_website_2_header.name = `Super Space Rides - The header`;
        a45_website_2_header.display_title = `Super Space Rides - The header` + addAlien('alien13', null, null, '-30px');

        a45_website_2_header.main_lesson = a45_website_1_structure;

        a45_website_2_header.description = makeDesc(
            '489276444',
            `<p>The header is the most important part of a website.</p>`,
            `<p>Let's create the header:</p>
<ol>
     <li><b>Drag the Heading 1</b> to into the ${select('header')}.<br>${a45_website_2_header.getHtmlForLibButton(tag('h1', 'Super Space Rides'), '<h1>Super Space Rides</h1>', null, null, 'header > h1', 'Drag the H1 into the Header element.')}</li>
     <li><b>Place the Paragraph</b> with the description below the heading.<br>${a45_website_2_header.getHtmlForLibButton(tag('p', 'Join Zootata...'), '<p>Join Zootata on amazing rides around the universe!</p>', null, null, 'header > p', 'Drag the P into the Header element.')}</li>
     <li><b>${select('Select the Header', 'header')}</b> and set <b>Padding left</b>, <b>Padding top</b> and <b>Padding right</b> to <code>40px</code>. Set <b>Padding bottom</b> to <code>180px</code>.</li>
      <li>Keep the Header selected and set <b>Background image</b> to <code>spacerides1.jpg</code>, <b>Background repeat</b> to <code>no repeat</code>, <b>Background size</b> to <code>cover</code> and <b>Background position</b> to <code>right bottom</code>.</li>
      <li>Set the <b>Text color</b> of the Header to <code>white</code>.</li>
      <li><b>Save the style</b> in a new CSS rule with the selector <code>header</code>.</li>
</ol>
`,

        )
        a45_website_2_header.video = `https://youtube.com/bubi`;

        a45_website_2_header.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header data-empty-placeholder></header>
        <section data-empty-placeholder id="rides"></section>
        <section data-empty-placeholder id="video"></section>
        <section data-empty-placeholder id="quotes"></section>
        <section data-empty-placeholder id="contact"></section>
        <footer data-empty-placeholder></footer>
    </body>
</html>`);

        a45_website_2_header.addStylesheet('style.css',  `
`);

        a45_website_2_header.inject_css = base_css;
        a45_website_2_header.open_all_files_in_code = true;

        a45_website_2_header.onCheck = function(page, status) {
            var error = null;

            var header = page.sourceNode.find('header');

            if(header.length === 0) {
                error = `<p>Where did the Header element go? Use Undo or restart the adventure.</p>`;
            } else {
                var h1 = header[0].find('> h1');
                if(h1.length !== 1) {
                    error = `<p>The header should contain one H1 element.</p>`;
                } else {
                    var p = header[0].find('> p');
                    if(p.length !== 1) {
                        error = `<p>The header should contain one P element.</p>`;
                    } else if(p[0].prev() !== h1[0]) {
                        error = `<p>H1 should come before the P element.</p>`;
                    } else {
                        var rules = getCSSRules('header');
                        if(rules.length === 0) {
                            error = `<p>Create a new CSS rule with the selector <code>header</code>.</p>`;
                        } else if(!cssRulesHaveProperty(rules, /^padding/)) {
                            error = `<p>Set Padding for the <code>header</code> CSS rule.</p>`;
                        } else if(!cssRulesHaveProperty(rules, 'background-image', 'url(\'spacerides1.jpg\')')) {
                            error = `<p>Set Background image for the <code>header</code> CSS rule to <code>spacerides1.jpg</code>.</p>`;
                        } else if(!cssRulesHaveProperty(rules, 'background-repeat', 'no-repeat')) {
                            error = `<p>Set Background repeat for the <code>header</code> CSS rule to <code>no-repeat</code>.</p>`;
                        } else if(!cssRulesHaveProperty(rules, 'background-size', 'cover')) {
                            error = `<p>Set Background size for the <code>header</code> CSS rule to <code>cover</code>.</p>`;
                        } else if(!cssRulesHaveProperty(rules, 'background-position', 'right bottom')) {
                            error = `<p>Set Background position for the <code>header</code> CSS rule to <code>right bottom</code>.</p>`;
                        } else if(!cssRulesHaveProperty(rules, 'color')) {
                            error = `<p>Set Text color for the <code>header</code> CSS rule to <code>white</code>.</p>`;
                        }
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a45_website_2_header);
        tutorial.addLesson(a45_website_2_header);



        var a46_website_3_rides = new PgTutorialLesson('zootata_website_rides_1', 'alien13', chapter_space_rides);

        a46_website_3_rides.name = `Super Space Rides - Our Rides - Content`;
        a46_website_3_rides.display_title = `Super Space Rides - Our Rides - Content` + addAlien('alien13', null, null, '-30px');

        a46_website_3_rides.main_lesson = a45_website_1_structure;

        a46_website_3_rides.description = makeDesc(
            '489279335',
            `<p>Use <b>headings ${showElement('h2')}</b> and <b>${showElement('h3')}</b> for sub-headings and sub-sub-headings.</p>`,
            `<p>Let's create the Our Rides section:</p>
<ol>
     <li><b>Drag the content</b> into the Section#rides.<br>
     ${a46_website_3_rides.getHtmlForLibButton(tag('h2', 'Our Rides'), '<h2>Our Rides</h2>', null, null, '#rides > h2', 'Drag the H2 into the Section#rides element.')}
     ${a46_website_3_rides.getHtmlForLibButton(tag('p', 'Introduction...'), '<p>We have many different space rides. Find the one that is perfect for you!</p>', null, null, '#rides > p', 'Drag the P into the Section#rides element.')}
     ${a46_website_3_rides.getHtmlForLibButton(tag('p', 'Ride 1...'), '<p>Wobbly Jelly Asteroid Belt - Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>', null, null, '#rides > p', 'Drag the P into the Section#rides element.')}
     ${a46_website_3_rides.getHtmlForLibButton(tag('p', 'Ride 2...'), '<p>Underground Space Cave - Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>', null, null, '#rides > p', 'Drag the P into the Section#rides element.')}
     ${a46_website_3_rides.getHtmlForLibButton(tag('p', 'Ride 3...'), '<p>Black Hole Retreat - Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>', null, null, '#rides > p', 'Drag the P into the Section#rides element.')}
     </li>
      <li>Select the <b>${showElement('p')} describing the first ride</b> and activate the ${tooltip('text editor', 'edit_text')}. Place the cursor after the ride name, delete spaces and the hyphen and then press the ${pgShowKbd('ENTER')} key to split it into two paragraphs.</li>
      <li>Click on the <b>${tooltip('Done button', 'edit_text_done')}</b> to stop editing the text.</li>
      <li>Select the <b>${select('<p> with the ride name', '#rides > p:nth-of-type(2)')}</b>, click on the ${tooltip('more actions', 'more_actions')} icon in the selected element menu and select <b>Change to ${showElement('h3')}</b></li>
      <li>Do the same for the other two rides: split their paragraph in two and change the ride name to H3.</li>
      <li><b>${select('Select the Section', 'section#rides')}</b> and set <b>Padding</b> to <code>40px</code> on all sides. <b>Save the style</b> as a new CSS rule with the selector <code>section</code>.</li>
</ol>
`,

        )
        a46_website_3_rides.video = `https://youtube.com/bubi`;

        a46_website_3_rides.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section data-empty-placeholder id="rides"></section>
        <section data-empty-placeholder id="video"></section>
        <section data-empty-placeholder id="quotes"></section>
        <section data-empty-placeholder id="contact"></section>
        <footer data-empty-placeholder></footer>
    </body>
</html>`);

        a46_website_3_rides.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}
`);

        a46_website_3_rides.inject_css = base_css;
        a46_website_3_rides.open_all_files_in_code = true;

        a46_website_3_rides.onCheck = function(page, status) {
            var error = null;

            var rides = page.sourceNode.findOne('#rides');

            if(!rides) {
                error = `<p>Where did the Section#rides go? Use Undo or restart the adventure.</p>`;
            } else {
                var h2 = rides.findOne('> h2');
                if(!h2) {
                    error = `<p>The rides section should have a Heading 2 for the title.</p>`;
                } else {
                    if(!h2.next() || h2.next().tagName !== 'p') {
                        error = `<p>A paragraph with the section description should come after the H2 element.</p>`;
                    } else {
                        var h3s = rides.find('> h3');
                        if (h3s.length !== 3) {
                            error = `<p>The Rides section should have three H3 elements - one for each ride.</p>`;
                        } else {
                            for (var i = 0; i < h3s.length; i++) {
                                if (!h3s[i].next() || h3s[i].next().tagName !== 'p') {
                                    error = `<p>A paragraph with the ride description should come after the ${getNumberName(i + 1)} ride heading.</p>`;
                                }
                            }
                            if(!error) {
                                var rules = getCSSRules('section');
                                if(rules.length === 0) {
                                    error = `<p>Create a CSS rule with the selector <code>section</code>.`;
                                } else if(!cssRulesHaveProperty(rules, /padding/)) {
                                    error = `<p>Set the padding on the CSS rule <code>section</code>.`
                                }
                            }
                        }
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a46_website_3_rides);
        tutorial.addLesson(a46_website_3_rides);



        var a46_website_3_rides_2 = new PgTutorialLesson('zootata_website_rides_2', 'alien13', chapter_space_rides);

        a46_website_3_rides_2.name = `Super Space Rides - Our Rides - Floating images`;
        a46_website_3_rides_2.display_title = `Super Space Rides - Our Rides - Floating images` + addAlien('alien13', null, null, '-30px');

        a46_website_3_rides_2.main_lesson = a45_website_1_structure;

        a46_website_3_rides_2.description = makeDesc(
            '489283547',
            `<p>Use the <b>float</b> CSS property to make the elements float on the <code>left</code> or <code>right</code> side of the content.</p>`,
            `<p>Let's add images to Our Rides section:</p>
<ol>
     <li><b>Drag the image</b> and place it after the H3 heading of the first ride (Wobbly Asteroid Field):<br>
     ${a46_website_3_rides_2.getHtmlForLibButton(`<img src="images/kids/spacerides2.jpg">`, `<img src="spacerides2.jpg">`, 'image', null, '#rides > img', 'Drag the IMG into the Section#rides element.')}
     </li>
       <li><b>In the ${tooltip('Style panel', 'style')}</b> go to the Dimensions and set the <b>Width</b> to <code>280px</code>.</li>
       <li>In <b>Display section</b> set the <b>Float</b> to <code>left</code>.</li>
       <li>Set <b>Margin right</b> to <code>20px</code> and <b>Margin bottom</b> to <code>40px</code>.</li>
       <li><b>${select('Select the next H3', 'section#rides h3:nth-of-type(2)')}</b> with the name of the second ride and set <b>Clear</b> property to <code>both</code>.</li>
       
</ol>
`,

        )
        a46_website_3_rides_2.video = `https://youtube.com/bubi`;

        a46_website_3_rides_2.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
        </section>
        <section data-empty-placeholder id="video"></section>
        <section data-empty-placeholder id="quotes"></section>
        <section data-empty-placeholder id="contact"></section>
        <footer data-empty-placeholder></footer>
    </body>
</html>`);

        a46_website_3_rides_2.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
}

`);

        a46_website_3_rides_2.inject_css = base_css;
        a46_website_3_rides_2.open_all_files_in_code = true;

        a46_website_3_rides_2.onCheck = function(page, status) {
            var error = null;

            var rides = page.sourceNode.findOne('#rides');

            if(!rides) {
                error = `<p>Where did the Section#rides go? Use Undo or restart the adventure.</p>`;
            } else {
                var h3 = rides.findOne('> h3');
                if(!h3) {
                    error = `<p>The rides section should have a Heading 3 for each ride.</p>`;
                } else {
                    if(!h3.next() || h3.next().tagName !== 'img') {
                        error = `<p>The ride image should come directly after the first ride H3 heading.</p>`;
                    } else {
                        var img = h3.next();
                        if(!getInlineCSSValue(img, 'width')) {
                            error = `<p>Set the Width of the IMG Style attribute to <code>280px</code>.</p>`;
                        } else if(getInlineCSSValue(img, 'float') !== 'left') {
                            error = `<p>Set the Float of the IMG Style attribute to <code>left</code>.</p>`;
                        } else if(!getInlineCSSValue(img, 'margin-right')) {
                            error = `<p>Set the Margin right of the IMG Style attribute to <code>20px</code>.</p>`;
                        } else if(!getInlineCSSValue(img, 'margin-bottom')) {
                            error = `<p>Set the Margin right of the IMG Style attribute to <code>40px</code>.</p>`;
                        }
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a46_website_3_rides_2);
        tutorial.addLesson(a46_website_3_rides_2);




        var a46_website_3_rides_3 = new PgTutorialLesson('zootata_website_rides_3', 'alien13', chapter_space_rides);

        a46_website_3_rides_3.name = `Super Space Rides - Our Rides - More images &amp; CSS Rules`;
        a46_website_3_rides_3.display_title = `Super Space Rides - Our Rides - More images &amp; CSS Rules` + addAlien('alien13', null, null, '-30px');

        a46_website_3_rides_3.main_lesson = a45_website_1_structure;

        a46_website_3_rides_3.description = makeDesc(
            '489288292',
            `<p>Use the <b>float</b> CSS property to make the elements float on the <code>left</code> or <code>right</code> side of the content.</p>`,
            `<p>Let's add images to Our Rides section:</p>
<ol>
    <li><b>${select('Select the image', '#rides img')}</b> of the first ride in the Our Rides section.</li>
    <li>In the ${tooltip('Style panel', 'style')} click on the <b>Save the style</b> as a CSS rule icon on the Style attribute and create a new CSS rule with the selector <code>.image-left</code>.</li>
    <li>Select the <b>${select('heading of the second ride', 'section#rides h3:nth-of-type(2)')}</b> (the one that has <code>clear: both</code>) and <b>Save the style</b> as a CSS rule with the selector <code>h3</code>.</li>
     <li><b>Drag the image</b> and place it after the H3 with the name of the second ride:<br>
     ${a46_website_3_rides_3.getHtmlForLibButton(`<img src="images/kids/spacerides3.jpg">`, `<img src="spacerides3.jpg">`, 'image', null, '#rides > img', 'Drag the IMG into the Section#rides element.')}
     </li>
     <li>Set <b>Width</b> to <code>280px</code> and <b>Float</b> to <code>right</code>. Set <b>Margin left</b> to <code>20px</code> and <b>Margin bottom</b> to <code>40px</code>. <b>Save the style</b> as a new CSS rule with the selector <code>.image-right</code>.</li>
       <li><b>Drag the image</b> and place it after the heading of the third ride:<br>
     ${a46_website_3_rides_3.getHtmlForLibButton(`<img src="images/kids/spacerides4.jpg">`, `<img src="spacerides4.jpg">`, 'image', null, '#rides > img', 'Drag the IMG into the Section#rides element.')}
     </li>
       <li>In the <b>${tooltip('attributes panel', 'attributes_panel')}</b> add the class <code>image-left</code> class to the image.</li>
</ol>
`,

        )
        a46_website_3_rides_3.video = `https://youtube.com/bubi`;

        a46_website_3_rides_3.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" style="width: 280px; float: left; margin-right: 20px; margin-bottom: 40px;">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3 style="clear: both;">Underground Space Cave</h3>
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
        </section>
        <section data-empty-placeholder id="video"></section>
        <section data-empty-placeholder id="quotes"></section>
        <section data-empty-placeholder id="contact"></section>
        <footer data-empty-placeholder></footer>
    </body>
</html>`);

        a46_website_3_rides_3.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
}

`);

        a46_website_3_rides_3.inject_css = base_css;
        a46_website_3_rides_3.open_all_files_in_code = true;

        a46_website_3_rides_3.onCheck = function(page, status) {
            var error = null;

            var img = page.sourceNode.findOne('#rides img');
            if(!img) {
                error = `<p>Where did the ride image go? Use Undo or restart the adventure.</p>`;
            } else {
                var rules = getCSSRules('.image-left');
                if (rules.length < 1 || img.getAttr('style')) {
                    error = `<p>Select the first image and save its Style attribute as a new CSS rule <code>.image-left</code>.</p>`;
                } else {
                    var rules = getCSSRules('.image-right');
                    if (rules.length < 1 || !page.sourceNode.findOne('#rides img.image-right')) {
                        error = `<p>Select the second image and save its Style attribute as a new CSS rule <code>.image-right</code>.</p>`;
                    } else if(!cssRulesHaveProperty(rules, 'float', 'right')) {
                        error = `<p>Set Float to <code>right</code> for the CSS rule <code>.image-right</code>.</p>`;
                    } else if(!cssRulesHaveProperty(rules, 'margin-left')) {
                        error = `<p>Set Margin left to <code>20px</code> for the CSS rule <code>.image-right</code>.</p>`;
                    } else if(!cssRulesHaveProperty(rules, 'margin-bottom')) {
                        error = `<p>Set Margin bottom to <code>40px</code> for the CSS rule <code>.image-right</code>.</p>`;
                    } else if(!cssRulesHaveProperty(rules, 'width')) {
                        error = `<p>Set Width to <code>280px</code> for the CSS rule <code>.image-right</code>.</p>`;
                    } else if(page.sourceNode.find('#rides img.image-left').length !== 2) {
                        error = `<p>The first and the last ride image should have the class <code>image-left</code>.</p>`;
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a46_website_3_rides_3);
        tutorial.addLesson(a46_website_3_rides_3);





        var a46_website_4_video = new PgTutorialLesson('zootata_website_video', 'alien13', chapter_space_rides);

        a46_website_4_video.name = `Super Space Rides - Adding a YouTube video`;
        a46_website_4_video.display_title = `Super Space Rides - Adding a YouTube video` + addAlien('alien13', null, null, '-30px');

        a46_website_4_video.main_lesson = a45_website_1_structure;

        a46_website_4_video.description = makeDesc(
            '489710625',
            `<p>The ${showElement('iframe')} HTML element is used to include the content from other websites.</p>`,
            `<p>Let's do the Video section:</p>
<ol>
    <li><b>Drag the ${showElement('h2')} heading</b> and the <b>introduction ${showElement('p')} paragraph</b> to the #video section:<br>
    ${a46_website_4_video.getHtmlForLibButton(tag('h2', 'Experience the...'), '<h2>Experience the Space Ride</h2>', null, null, '#video > h2', 'Drag the H2 into the Section#video element.')}
     ${a46_website_4_video.getHtmlForLibButton(tag('p', 'Watch the video...'), '<p>Watch the video and experience the magic moments of Zootata\'s space rides:</p>', null, null, '#video > p', 'Drag the P into the Section#video element.')}
    </li>
    <li>Open the video on YouTube, click on <b>Share</b> and select <b>Embed</b>. Copy the code:<br>
    <a style="margin-top:10px;display:inline-block;" href="https://youtu.be/1ZcU27hgwHE" target="_blank" class="pg-button pg-button-primary">Open on YouTube</a>
    </li>
    <li><b>Add the ${showElement('iframe')} element</b> to the Video section and <b>paste the YouTube code</b> into the Iframe code box when asked:<br>
    ${a46_website_4_video.getHtmlForLibButton(tag('iframe', ''), '<iframe></iframe>', null, null, '#video > iframe', 'Drag the IFRAME into the Section#video element.')}
    </li>
    <li>Keep the ${select('iframe')} selected and in the ${tooltip('Style panel', 'style')} set its <b>Width</b> to <code>100%</code>.</li>
    <li><b>Save the style</b> as a CSS rule with the selector <code>iframe</code>.</li>
    <li>If you need to select an ${select('iframe')} use the ${tooltip('Structure panel', 'structure')}.</li>
    <li>Enjoy watching the video!</li>
</ol>
`,

        )
        a46_website_4_video.video = `https://youtube.com/bubi`;

        a46_website_4_video.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" class="image-left">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <img src="spacerides3.jpg" class="image-right">
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <img src="spacerides4.jpg" class="image-left">
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
        </section>
        <section data-empty-placeholder id="video"></section>
        <section data-empty-placeholder id="quotes"></section>
        <section data-empty-placeholder id="contact"></section>
        <footer data-empty-placeholder></footer>
    </body>
</html>`);

        a46_website_4_video.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
}

.image-left {
    width: 280px;
    float: left;
    margin-right: 20px;
    margin-bottom: 40px;
}

h3 {
    clear: both;
}

.image-right {
    width: 280px;
    float: right;
    margin-left: 20px;
    margin-bottom: 40px;
}
`);

        a46_website_4_video.inject_css = base_css;
        a46_website_4_video.open_all_files_in_code = true;

        a46_website_4_video.onCheck = function(page, status) {
            var error = null;

            var h2 = page.sourceNode.findOne('#video h2');
            if(!h2) {
                error = `<p>Section#video should have a H2 heading.</p>`;
            } else {
                var p = page.sourceNode.findOne('#video p');
                if(!p) {
                    error = `<p>Section#video should have a P with the description.</p>`;
                } else if(h2.next() !== p) {
                    error = `<p>The P should come after the H2.</p>`;
                } else {
                    var iframe = page.sourceNode.findOne('#video iframe');
                    if(!iframe) {
                        error = `<p>Section#video should have an IFRAME element.</p>`;
                    } else if(p.next() !== iframe) {
                        error = `<p>The IFRAME should come after the P element.</p>`;
                    } else if((iframe.getAttr('src') || '').indexOf('youtube.com') < 0) {
                        error = `<p>Paste the whole IFRAME element code from YouTube. If you made a mistake, delete the IFRAME and add a new one.</p>`;
                    } else {
                        var rules = getCSSRules('iframe');
                        if (rules.length < 1 || iframe.getAttr('style')) {
                            error = `<p>Select the IFRAME and save its Style attribute as a new CSS rule <code>iframe</code>.</p>`;
                        } else if(!cssRulesHaveProperty(rules, 'width', '100%')) {
                            error = `<p>Set Width to <code>100%</code> for the CSS rule <code>iframe</code>.</p>`;
                        }
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a46_website_4_video);
        tutorial.addLesson(a46_website_4_video);






        var a46_website_5_quotes = new PgTutorialLesson('zootata_website_quotes_1', 'alien13', chapter_space_rides);

        a46_website_5_quotes.name = `Super Space Rides - Happy quotes - Part 1`;
        a46_website_5_quotes.display_title = `Super Space Rides - Happy quotes - Part 1` + addAlien('alien13', null, null, '-30px');

        a46_website_5_quotes.main_lesson = a45_website_1_structure;

        a46_website_5_quotes.description = makeDesc(
            '489713614',
            `<p>Use the ${showElement('div')} HTML element to group elements together.</p>`,
            `<p>Create the Quotes section:</p>
<ol>
    <li><b>Drag the ${showElement('h2')} heading</b> and the <b>introduction ${showElement('p')} paragraph</b> to the ${select('#quotes section', 'section#quotes')}:<br>
    ${a46_website_5_quotes.getHtmlForLibButton(tag('h2', 'Our Happy...'), '<h2>Our Happy Customers</h2>', null, null, '#quotes > h2', 'Drag the H2 into the Section#quotes element.')}
     ${a46_website_5_quotes.getHtmlForLibButton(tag('p', 'Listen to...'), '<p>Listen to our fans explain how much fun they had on our space rides:</p>', null, null, '#quotes > p', 'Drag the P into the Section#quotes element.')}
    </li>
    <li><b>Add the ${showElement('div')} element</b> for the first quote to the Quotes section:<br>
    ${a46_website_5_quotes.getHtmlForLibButton(tag('div', ''), '<div data-empty-placeholder></div>', null, null, '#quotes > div', 'Drag the DIV into the Section#quotes element.')}
    </li>
    <li>Add the image, quote and signature <b>into the ${select('div', 'section#quotes div')}</b>:<br>
    ${a46_website_5_quotes.getHtmlForLibButton('<img src="images/kids/spacerides5.jpg">', '<img src="spacerides5.jpg">', 'image', null, '#quotes > div > img', 'Drag the IMG into the DIV element inside the Section#quotes element.')}
    ${a46_website_5_quotes.getHtmlForLibButton(tag('p', 'Wow! The Black Hole...'), '<p>Wow! The Black Hole was amazing. I got super stretchy, so I looked like a rope.</p>', null, null, '#quotes > div > p', 'Drag the P into the DIV element inside the Section#quotes element.')}
    ${a46_website_5_quotes.getHtmlForLibButton(tag('p', 'Bloobeek'), '<p>Bloobeek</p>', null, null, '#quotes > div > p', 'Drag the P into the DIV element inside the Section#quotes element.')}
    </li>
    <li><b>${select('Select the image', '#quotes img')}</b> and set its <b>Width</b> to <code>150px</code> and make it round by setting <b>Border radius</b> to <code>50%</code>.</li>
    <li><b>Select the ${select('div', '#quotes div')}</b> and set <b>Text align</b> to <code>center</code> and <b>Padding left</b>, <b>Padding top</b> and <b>Padding right</b> to <code>20px</code>. Set <b>Padding bottom</b> to <code>1px</code>.</li>
    <li>Set <b>Border style</b> to <code>solid</code> (the first choice), <b>Border width</b> to <code>1px</code> and <b>Border color</b> to <code>gray</code>. Use the <b>Equal borders</b> button to apply the border to all four sides.</li>
    <li><b>${select('Select the <p> with the quote', 'section#quotes div p')}</b> and activate the ${tooltip('Edit text', 'edit_text')} tool. Insert an opening quote <b>&ldquo;</b> at the start and a closing quote <b>&rdquo;</b> at the end.</li>
</ol>
`,

        )
        a46_website_5_quotes.video = `https://youtube.com/bubi`;

        a46_website_5_quotes.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" class="image-left">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <img src="spacerides3.jpg" class="image-right">
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <img src="spacerides4.jpg" class="image-left">
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
        </section>
        <section id="video">
            <h2>Experience the Space Ride</h2>
            <p>Watch the video and experience the magic moments of Zootata's space rides:</p>
            <iframe width="560" height="315" src="https://www.youtube.com/embed/1ZcU27hgwHE" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
        </section>
        <section data-empty-placeholder id="quotes"></section>
        <section data-empty-placeholder id="contact"></section>
        <footer data-empty-placeholder></footer>
    </body>
</html>`);

        a46_website_5_quotes.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
}

.image-left {
    width: 280px;
    float: left;
    margin-right: 20px;
    margin-bottom: 40px;
}

h3 {
    clear: both;
}

.image-right {
    width: 280px;
    float: right;
    margin-left: 20px;
    margin-bottom: 40px;
}

iframe {
    width: 100%;
}
`);

        a46_website_5_quotes.inject_css = base_css;
        a46_website_5_quotes.open_all_files_in_code = true;

        a46_website_5_quotes.onCheck = function(page, status) {
            var error = null;

            var h2 = page.sourceNode.findOne('#quotes h2');
            if(!h2) {
                error = `<p>Section#quotes should have a H2 heading.</p>`;
            } else {
                var p = page.sourceNode.findOne('#quotes p');
                if(!p) {
                    error = `<p>Section#quotes should have a P with the description.</p>`;
                } else if(h2.next() !== p) {
                    error = `<p>The P should come after the H2.</p>`;
                } else {
                    var div = page.sourceNode.findOne('#quotes div');
                    if(!div) {
                        error = `<p>Section#quotes should contain a DIV element.</p>`;
                    } else if(p.next() !== div) {
                        error = `<p>The DIV should come after the P element.</p>`;
                    } else {
                        var img = div.findOne('img');
                        if(!img) {
                            error = `<p>The DIV element should contain an image.</p>`;
                        } else if(!getInlineCSSValue(img, 'width')) {
                            error = `<p>Set the Width CSS property of the image to <code>150px</code>.</p>`;
                        } else if(img.getInlineStylePropertyValue('border-radius') !== '50%') {
                            error = `<p>Set the Border radius of the image to <code>50%</code> in all four corners. Note the <code>%</code> unit.</p>`;
                        } else if(getInlineCSSValue(div, 'text-align') !== 'center') {
                            error = `<p>Set the Text align of the DIV to <code>center</code>.</p>`;
                        } else if(!getInlineCSSValue(div, 'padding')) {
                            error = `<p>Set the Padding of the DIV element.</p>`;
                        } else if(!getInlineCSSValue(div, 'border')) {
                            error = `<p>Set the Border of the DIV element.</p>`;
                        } else {
                            var ps = div.find('p');
                            if(ps.length !== 2) {
                                error = `<p>The DIV should have two P elements: the quote and the signature.</p>`;
                            } else if(false && ps[0].text().indexOf('&') < 0 && ps[0].text().indexOf('"') < 0) {
                                error = `<p>Enclose the quote with double quotes.</p>`;
                            }
                        }
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a46_website_5_quotes);
        tutorial.addLesson(a46_website_5_quotes);





        var a47_website_5_quotes_2 = new PgTutorialLesson('zootata_website_quotes_2', 'alien13', chapter_space_rides);

        a47_website_5_quotes_2.name = `Super Space Rides - Happy quotes - Part 2`;
        a47_website_5_quotes_2.display_title = `Super Space Rides - Happy quotes - Part 2` + addAlien('alien13', null, null, '-30px');

        a47_website_5_quotes_2.main_lesson = a45_website_1_structure;

        a47_website_5_quotes_2.description = makeDesc(
            '490072603',
            `<p>Use the Duplicate feature to create copies of elements.</p>`,
            `<p>Create two more quotes:</p>
<ol>
    <li><b>Select the quote ${select('<div>', '#quotes div')}</b> and <b>Save the style</b> as a CSS rule with the selector <code>.quote</code>.</li>
    <li><b>${select('Select the <img>', '#quotes div img')}</b> and <b>Save the style</b> as a new CSS rule with the selector <code>.quote-image</code>.</li>
    <li><b>${select('Select the quote <div>', '#quotes div')}</b> and <b>${tooltip('Duplicate the element', 'duplicate')}</b>.</li>
    <li><b>${select('Select the <img>', '#quotes div:nth-of-type(2) img')} in the copy</b>, go to the ${tooltip('Attributes panel', 'attributes_panel')} and set the <b>Src</b> attribute to <code>spacerides6.jpg</code>.</li>
    <li><b>${select('Select the quote <p>', '#quotes div:nth-of-type(2) p')}</b> and use the ${tooltip('Edit text', 'edit_text')} tool to change the text between the quotes to <code style="white-space: normal;">I'm a big fan. I skated faster than the speed of light!</code>.
    <li><b>${select('Select the signature <p>', '#quotes div:nth-of-type(2) p:nth-of-type(2)')}</b> and change the text to <code>Rooky</code>.
    <li><b>${select('Select the second quote <div>', '#quotes div:nth-of-type(2)')}</b> and use <b>${tooltip('duplicate', 'duplicate')}</b> to create the third quote with the image <code>spacerides7.jpg</code>, quote <code style="white-space: normal;">The glow worms were 5 space bounces long. We were so deep under ground! I can't believe that Zootata was able to organize that!</code> and signature <code>Mooteetee</code>.</li>
    <li><b>${select('Select one of the quotes <div>', '#quotes div')}</b>, make sure the <code>.quote</code> CSS rule is selected and set <b>Margin top</b> and <b>Margin bottom</b> to <code>30px</code>.</li>
</ol>
`

        )
        a47_website_5_quotes_2.video = `https://youtube.com/bubi`;

        a47_website_5_quotes_2.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" class="image-left">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <img src="spacerides3.jpg" class="image-right">
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <img src="spacerides4.jpg" class="image-left">
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
        </section>
        <section id="video" style="background-color: #efefef;">
            <h2>Experience the Space Ride</h2>
            <p>Watch the video and experience the magic moments of Zootata's space rides:</p>
            <iframe width="560" height="315" src="https://www.youtube.com/embed/1ZcU27hgwHE" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
        </section>
        <section id="quotes">
            <h2>Our Happy Customers</h2>
            <p>Listen to our fans explain how much fun they had on our space rides:</p>
            <div style="text-align: center; border: 1px solid #b4b4b4; padding: 20px 20px 0px; background-color: #ffffff;">
                <img src="spacerides5.jpg" style="width: 150px; border-radius: 50%;"/>
                <p>&ldquo;Wow! The Black Hole was amazing. I got super stretchy, so I looked like a rope.&rdquo;</p>
                <p>Bloobeek</p>
            </div>
        </section>
        <section data-empty-placeholder id="contact"></section>
        <footer data-empty-placeholder></footer>
    </body>
</html>`);

        a47_website_5_quotes_2.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
}

.image-left {
    width: 280px;
    float: left;
    margin-right: 20px;
    margin-bottom: 40px;
}

h3 {
    clear: both;
}

.image-right {
    width: 280px;
    float: right;
    margin-left: 20px;
    margin-bottom: 40px;
}

iframe {
    width: 100%;
}
`);

        a47_website_5_quotes_2.inject_css = base_css;
        a47_website_5_quotes_2.open_all_files_in_code = true;

        a47_website_5_quotes_2.onCheck = function(page, status) {
            var error = null;

            var rules = getCSSRules('.quote');
            if(rules.length === 0) {
                error = `<p>Save the Style attribute on DIV as a new CSS rule with the selector <code>.quote</code>.</p>`;
            } else {
                var qs = page.sourceNode.find('.quote');
                if(qs.length !== 3) {
                    error = `<p>There should be three DIVs with the class <code>quote</code> on the page. ${use_structure_to_fix}</p>`;
                } else if(!cssRulesHaveProperty(rules, /^margin/)) {
                    error = `<p>Select the CSS rule <code>.quote</code> and set Margin top and bottom to <code>30px</code>.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a47_website_5_quotes_2);
        tutorial.addLesson(a47_website_5_quotes_2);






        var a47_website_6_contact = new PgTutorialLesson('zootata_website_contact_1', 'alien13', chapter_space_rides);

        a47_website_6_contact.name = `Super Space Rides - Contact us - Part 1`;
        a47_website_6_contact.display_title = `Super Space Rides - Contact us - Part 1` + addAlien('alien13', null, null, '-30px');

        a47_website_6_contact.main_lesson = a45_website_1_structure;

        a47_website_6_contact.description = makeDesc(
            '490073972',
            `<p>Use the <b>display</b> CSS property to set if the element is displayed inline or as a block.</p>`,
            `<p>Create the Contact Us section:</p>
<ol>
    <li><b>Drag the content</b> - the heading and the anchor - into the ${select('section#contact', 'section#contact')}.<br>
     ${a47_website_6_contact.getHtmlForLibButton(tag('h2', 'Want to join...'), '<h2>Want to join us on a space ride?</h2>', null, null, '#contact > h2', 'Drag the H2 into the Section#contact element.')}
     ${a47_website_6_contact.getHtmlForLibButton(tag('a', 'Link', {href: '...'}), '<a href="">Link</a>', null, null, '#contact > a', 'Drag the A into the Section#contact element.')}
    <li>${select('Change the <a>', '#contact a')} text to <code>Get in touch!</code></li>
    <li><b>Select the ${select('contact section', '#contact')}</b> and set <b>Background image</b> to <code>background1.jpg</code>, <b>Background repeat</b> to <code>no-repeat</code> and <b>Background size</b> to <code>cover</code>. Set <b>Text align</b> to <code>center</code> and <b>Text color</b> to <code>white</code>.</li>
   
    <li><b>Select the ${select('a', '#contact a')}</b> and set the <b>Font size</b> to <code>25px</code>, <b>Text color</b> to <code>white</code>, <b>Padding top / bottom</b> to <code>10px</code> and <b>Padding left / right</b> to <code>30px</code>.</li>
    <li>Set <b>Background color</b> to <code>orange</code> and <b>Text decoration</b> to <code>none</code>. Use <b>Border radius</b> to round the corners.</li>
    <li>In the Style panel, go to <b>Display section</b> and set <b>Display</b> to <code>inline-block</code>. Set <b>Margin top</b> to <code>10px</code> and <b>Margin bottom</b> to <code>20px</code>.</li>
</ol>
`,

        )
        a47_website_6_contact.video = `https://youtube.com/bubi`;

        a47_website_6_contact.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" class="image-left">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <img src="spacerides3.jpg" class="image-right">
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <img src="spacerides4.jpg" class="image-left">
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
        </section>
        <section id="video" style="background-color: #efefef;">
            <h2>Experience the Space Ride</h2>
            <p>Watch the video and experience the magic moments of Zootata's space rides:</p>
            <iframe width="560" height="315" src="https://www.youtube.com/embed/1ZcU27hgwHE" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
        </section>
        <section id="quotes">
            <h2>Our Happy Customers</h2>
            <p>Listen to our fans explain how much fun they had on our space rides:</p>
            <div class="quote">
                <img src="spacerides5.jpg" class="quote-image"/>
                <p>&ldquo;Wow! The Black Hole was amazing. I got super stretchy, so I looked like a rope.&rdquo;</p>
                <p>Bloobeek</p>
            </div>
            <div class="quote">
                <img src="spacerides6.jpg" class="quote-image"/>
                <p>&ldquo;I'm a big fan. I skated faster than the speed of light!&rdquo;</p>
                <p>Rooky</p>
            </div>
            <div class="quote">
                <img src="spacerides7.jpg" class="quote-image"/>
                <p>&ldquo;The glow worms were 5 space bounces long. We were so deep under ground! I can't believe that Zootata was able to organize that!&rdquo;</p>
                <p>Mooteetee</p>
            </div>
        </section>
        <section data-empty-placeholder id="contact"></section>
        <footer data-empty-placeholder></footer>
    </body>
</html>`);

        a47_website_6_contact.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
}

.image-left {
    width: 280px;
    float: left;
    margin-right: 20px;
    margin-bottom: 40px;
}

h3 {
    clear: both;
}

.image-right {
    width: 280px;
    float: right;
    margin-left: 20px;
    margin-bottom: 40px;
}

iframe {
    width: 100%;
}

.quote {
    text-align: center;
    border: 1px solid #b4b4b4;
    padding: 20px 20px 0px;
    background-color: #ffffff;
    margin-top: 30px;
    margin-bottom: 30px;
}

.quote-image {
    width: 150px;
    border-radius: 50%;
}
`);

        a47_website_6_contact.inject_css = base_css;
        a47_website_6_contact.open_all_files_in_code = true;

        a47_website_6_contact.onCheck = function(page, status) {
            var error = null;

            var h2 = page.sourceNode.findOne('#contact h2');
            if(!h2) {
                error = `<p>Section#contact should have a H2 heading.</p>`;
            } else {
                var a = page.sourceNode.findOne('#contact a');
                if(!a) {
                    error = `<p>Section#contact should have an A (anchor) element.</p>`;
                } else if(!a.text().startsWith('Get')) {
                    error = `<p>Edit the text of the A element.</p>`;
                } else {
                    var section = page.sourceNode.findOne('#contact');
                    var ch = checkBackground(section, 'Section');
                    if(ch) {
                        error = ch;
                    } else if(getInlineCSSValue(section, 'background-repeat') !== 'no-repeat') {
                        error = `<p>Set the Background repeat of the Contact section to <code>no-repeat</code>.</p>`;
                    } else if(getInlineCSSValue(section, 'background-size') !== 'cover') {
                        error = `<p>Set the Background size of the Contact section to <code>cover</code>.</p>`;
                    } else if(getInlineCSSValue(section, 'text-align') !== 'center') {
                        error = `<p>Set the Text align of the Contact section to <code>center</code>.</p>`;
                    } else if(!getInlineCSSValue(section, 'color')) {
                        error = `<p>Set the Text color of the Contact section to <code>white</code>.</p>`;
                    } else if(!getInlineCSSValue(a, 'font-size')) {
                        error = `<p>Set the Font size of the A element to <code>25px</code>.</p>`;
                    } else if(!getInlineCSSValue(a, 'color')) {
                        error = `<p>Set the Text color of the A element to <code>white</code>.</p>`;
                    } else if(!getInlineCSSValue(a, /^padding/)) {
                        error = `<p>Set the Padding of the A element.</p>`;
                    } else if(!getInlineCSSValue(a, 'background-color')) {
                        error = `<p>Set the Background color of the A element to <code>orange</code>.</p>`;
                    } else if(getInlineCSSValue(a, 'text-decoration') !== 'none') {
                        error = `<p>Set the Text decoration of the A element to <code>none</code>.</p>`;
                    } else if(!getInlineCSSValue(a, /^border\-radius/)) {
                        error = `<p>Set the Border radius of the A element to round the button.</p>`;
                    } else if(getInlineCSSValue(a, 'display') !== 'inline-block') {
                        error = `<p>Set the Display of the A element to <code>inline-block</code>.</p>`;
                    } else if(!getInlineCSSValue(a, /^margin/)) {
                        error = `<p>Set the Margins of the A element.</p>`;
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a47_website_6_contact);
        tutorial.addLesson(a47_website_6_contact);





        var a47_website_6_contact_2 = new PgTutorialLesson('zootata_website_contact_2', 'alien13', chapter_space_rides);

        a47_website_6_contact_2.name = `Super Space Rides - Contact Us - Part 2`;
        a47_website_6_contact_2.display_title = `Super Space Rides - Contact us - Part 2` + addAlien('alien13', null, null, '-30px');

        a47_website_6_contact_2.main_lesson = a45_website_1_structure;

        a47_website_6_contact_2.description = makeDesc(
            '490076494',
            `<p>Use <code>mailto:</code> anchor links to send emails.</p>`,
            `<p>Let's finish the Contact section:</p>
<ol>
    <li><b>${select('Select the contact section', '#contact')}</b> and <b>Save the style</b> as a new CSS rule with the selector <code>#contact</code>.</li>
    <li><b>${select('Select the button <a>', '#contact a')}</b> and <b>Save the style</b> as a CSS rule with the selector <code>.big-button</code>.</li>
    <li>Keep the button selected and <b>Create new CSS rule</b> with the selector <code>.big-button:hover</code></li>
    <li>Set <b>Text decoration</b> to <code>underline</code>.</li>
    <li>Go to the ${tooltip('Attributes panel', 'attributes_panel')} and set the <b>Href</b> attribute to <code>mailto:zootata@example.com</code>.</li>
    <li>Keep the ${select('button', '#contact a')} selected and use the ${tooltip('click icon', 'click_icon')} to test the link.</li>
</ol>
`,

        )
        a47_website_6_contact_2.video = `https://youtube.com/bubi`;

        a47_website_6_contact_2.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" class="image-left">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <img src="spacerides3.jpg" class="image-right">
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <img src="spacerides4.jpg" class="image-left">
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
        </section>
        <section id="video" style="background-color: #efefef;">
            <h2>Experience the Space Ride</h2>
            <p>Watch the video and experience the magic moments of Zootata's space rides:</p>
            <iframe width="560" height="315" src="https://www.youtube.com/embed/1ZcU27hgwHE" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
        </section>
        <section id="quotes">
            <h2>Our Happy Customers</h2>
            <p>Listen to our fans explain how much fun they had on our space rides:</p>
            <div class="quote">
                <img src="spacerides5.jpg" class="quote-image"/>
                <p>&ldquo;Wow! The Black Hole was amazing. I got super stretchy, so I looked like a rope.&rdquo;</p>
                <p>Bloobeek</p>
            </div>
            <div class="quote">
                <img src="spacerides6.jpg" class="quote-image"/>
                <p>&ldquo;I'm a big fan. I skated faster than the speed of light!&rdquo;</p>
                <p>Rooky</p>
            </div>
            <div class="quote">
                <img src="spacerides7.jpg" class="quote-image"/>
                <p>&ldquo;The glow worms were 5 space bounces long. We were so deep under ground! I can't believe that Zootata was able to organize that!&rdquo;</p>
                <p>Mooteetee</p>
            </div>
        </section>
        <section id="contact" style="background-image: url('background1.jpg'); background-repeat: no-repeat; background-size: cover; color: #ffffff; text-align: center;">
            <h2>Want to join us on a space ride?</h2>
            <a href="" style="font-size: 25px; padding: 10px 30px; background-color: #ff9400; color: #ffffff; text-decoration: none; border-radius: 25px; display: inline-block; margin-top: 10px; margin-bottom: 20px;">Get in touch!</a>
        </section>
        <footer data-empty-placeholder></footer>
    </body>
</html>`);

        a47_website_6_contact_2.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
}

.image-left {
    width: 280px;
    float: left;
    margin-right: 20px;
    margin-bottom: 40px;
}

h3 {
    clear: both;
}

.image-right {
    width: 280px;
    float: right;
    margin-left: 20px;
    margin-bottom: 40px;
}

iframe {
    width: 100%;
}

.quote {
    text-align: center;
    border: 1px solid #b4b4b4;
    padding: 20px 20px 0px;
    background-color: #ffffff;
    margin-top: 30px;
    margin-bottom: 30px;
}

.quote-image {
    width: 150px;
    border-radius: 50%;
}
`);

        a47_website_6_contact_2.inject_css = base_css;
        a47_website_6_contact_2.open_all_files_in_code = true;

        a47_website_6_contact_2.onCheck = function(page, status) {
            var error = null;

            var rules = getCSSRules('#contact');
            if(rules.length === 0) {
                error = `<p>Save the Style attribute of the Section#contact as the new CSS rule with the selector <code>#contact</code>.</p>`;
            } else {
                rules = getCSSRules('.big-button');
                if(rules.length === 0) {
                    error = `<p>Save the Style attribute of the A element in the Section#contact as the new CSS rule with the selector <code>.big-button</code>.</p>`;
                } else {
                    rules = getCSSRules('.big-button:hover');
                    if(rules.length === 0) {
                        error = `<p>Create a new CSS rule with the selector <code>.big-button:hover</code>.</p>`;
                    } else if(!cssRulesHaveProperty(rules, 'text-decoration', 'underline')) {
                        error = `<p>Select the CSS rule <code>.big-button:hover</code> and set Text decoration to <code>underline</code>.</p>`;
                    } else {
                        var a = page.sourceNode.findOne('#contact a');
                        if(!a || !(a.getAttr('href') || '').startsWith('mailto:')) {
                            error = `<p>Set the Href attribute of the A element to <code>mailto:zootata@example.com</code>.</p>`;
                        }
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a47_website_6_contact_2);
        tutorial.addLesson(a47_website_6_contact_2);






        var a47_website_7_footer = new PgTutorialLesson('zootata_website_footer', 'alien13', chapter_space_rides);

        a47_website_7_footer.name = `Super Space Rides - The Footer`;
        a47_website_7_footer.display_title = `Super Space Rides - The Footer` + addAlien('alien13', null, null, '-30px');

        a47_website_7_footer.main_lesson = a45_website_1_structure;

        a47_website_7_footer.description = makeDesc(
            '490078918',
            ``,
            `<p>Create the page footer:</p>
<ol>
    <li><b>Drag the ${showElement('p')}</b> into the <b>${select('footer')}</b>.<br>
     ${a47_website_7_footer.getHtmlForLibButton(tag('p', 'Zootata\'s Super...'), '<p>Zootata\'s Super Space Rides. Created by [your name].</p>', null, null, 'footer > p', 'Drag the P into the Footer element.')}
    <li>${tooltip('Edit the text', 'edit_text')} and use the ${tooltip('insert character', 'insert_char')} menu to insert a Symbol -&gt; copyright <code style="font-size:18px;">&copy;</code> character at the start.</li>
    <li><b>Select the ${select('footer')}</b> and set a dark <b>Background color</b>. Set the <b>Text color</b> to transparent white and <b>Text align</b> to <code>center</code>.</li> 
    <li>Set <b>Padding top / bottom</b> to <code>20px</code> and <b>Padding left / right</b> to <code>40px</code>.</li>
    <!--<li>Set <b>Margin top</b> to <code>0</code>.</li> -->
    <li><b>Save the style</b> as a CSS rule with the selector <code>footer</code>.</li>
    <li><b>${select('Select the contact section')}</b> and select the ${rule('#contact')}. Set <b>Padding bottom</b> to <code>120px</code>.</li>
    <li><b>Sign your made-up name</b> in the footer text.</li>
</ol>
`,

        )
        a47_website_7_footer.video = `https://youtube.com/bubi`;

        a47_website_7_footer.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" class="image-left">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <img src="spacerides3.jpg" class="image-right">
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <img src="spacerides4.jpg" class="image-left">
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
        </section>
        <section id="video" style="background-color: #efefef;">
            <h2>Experience the Space Ride</h2>
            <p>Watch the video and experience the magic moments of Zootata's space rides:</p>
            <iframe width="560" height="315" src="https://www.youtube.com/embed/1ZcU27hgwHE" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
        </section>
        <section id="quotes">
            <h2>Our Happy Customers</h2>
            <p>Listen to our fans explain how much fun they had on our space rides:</p>
            <div class="quote">
                <img src="spacerides5.jpg" class="quote-image"/>
                <p>&ldquo;Wow! The Black Hole was amazing. I got super stretchy, so I looked like a rope.&rdquo;</p>
                <p>Bloobeek</p>
            </div>
            <div class="quote">
                <img src="spacerides6.jpg" class="quote-image"/>
                <p>&ldquo;I'm a big fan. I skated faster than the speed of light!&rdquo;</p>
                <p>Rooky</p>
            </div>
            <div class="quote">
                <img src="spacerides7.jpg" class="quote-image"/>
                <p>&ldquo;The glow worms were 5 space bounces long. We were so deep under ground! I can't believe that Zootata was able to organize that!&rdquo;</p>
                <p>Mooteetee</p>
            </div>
        </section>
        <section id="contact">
            <h2>Want to join us on a space ride?</h2>
            <a href="mailto:zootata@example.com" class="big-button">Get in touch!</a>
        </section>
        <footer data-empty-placeholder></footer>
    </body>
</html>`);

        a47_website_7_footer.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
}

.image-left {
    width: 280px;
    float: left;
    margin-right: 20px;
    margin-bottom: 40px;
}

h3 {
    clear: both;
}

.image-right {
    width: 280px;
    float: right;
    margin-left: 20px;
    margin-bottom: 40px;
}

iframe {
    width: 100%;
}

.quote {
    text-align: center;
    border: 1px solid #b4b4b4;
    padding: 20px 20px 0px;
    background-color: #ffffff;
    margin-top: 30px;
    margin-bottom: 30px;
}

.quote-image {
    width: 150px;
    border-radius: 50%;
}

#contact {
    background-image: url('background1.jpg');
    background-repeat: no-repeat;
    background-size: cover;
    color: #ffffff;
    text-align: center;
}

.big-button {
    font-size: 25px;
    padding: 10px 30px;
    background-color: #ff9400;
    color: #ffffff;
    text-decoration: none;
    border-radius: 25px;
    display: inline-block;
    margin-top: 10px;
    margin-bottom: 20px;
}

.big-button:hover {
    text-decoration: underline;
}
`);

        a47_website_7_footer.inject_css = base_css;
        a47_website_7_footer.open_all_files_in_code = true;

        a47_website_7_footer.onCheck = function(page, status) {
            var error = null;

            var p = page.sourceNode.findOne('footer p');
            if(!p) {
                error = `<p>The footer element should contain a P element with the website information.</p>`;
            } else if(p.text().indexOf('&copy;') < 0) {
                error = `<p>Use the Edit text tool to insert a &copy; symbol into the footer text.</p>`;
            } else {
                var f = page.sourceNode.findOne('footer');
                var rules = getCSSRules('footer');

                if(rules.length === 0) {
                    error = `<p>Save the Style attribute of the footer element as the new CSS rule with the selector <code>footer</code>.</p>`;
                } else if(!cssRulesHaveProperty(rules, 'background-color')) {
                    error = `<p>Set the Background color of the <code>footer</code> CSS rule to a dark color.</p>`;
                } else if(!cssRulesHaveProperty(rules, 'color')) {
                    error = `<p>Set the Text color of the <code>footer</code> CSS rule to a white transparent color.</p>`;
                } else if(!cssRulesHaveProperty(rules, 'text-align', 'center')) {
                    error = `<p>Set the Text align of the <code>footer</code> CSS rule to <code>center</code>.</p>`;
                } else if(!cssRulesHaveProperty(rules, /^padding/)) {
                    error = `<p>Set the Padding of the <code>footer</code> CSS rule.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a47_website_7_footer);
        tutorial.addLesson(a47_website_7_footer);




        var a47_website_8_pageinfo = new PgTutorialLesson('zootata_website_pageinfo', 'alien13', chapter_space_rides);

        a47_website_8_pageinfo.name = `Super Space Rides - Page information`;
        a47_website_8_pageinfo.display_title = `Super Space Rides - Page information` + addAlien('alien13', null, null, '-30px');

        a47_website_8_pageinfo.main_lesson = a45_website_1_structure;

        a47_website_8_pageinfo.description = makeDesc(
            '490080503',
            `<p>Use the ${showElement('title')} and ${showElement('meta')} elements to set the information about the page.</p>`,
            `<p>Describe what this webpage is about and who made it:</p>
<ol>
    <li><b>Select the ${select('html')}</b> element and go to the ${tooltip('attributes panel', 'attributes_panel')}.</li>
    <li>Set <b>Title</b> to <code style="white-space: normal;">Super Space Rides</code>.</li>
    <li>Set <b>Description</b> to <code style="white-space: normal;">Join Zootata on amazing rides around the universe!</code>.</li>
    <li>Set <b>Keywords</b> to <code style="white-space: normal;">Space, Adventure, Space exploration, Travel</code>.</li>
    <li>Enter your nickname in the <b>Author</b> field.</li>
    <li>Open the <b>${tooltip('code editor', 'code_editor')}</b> and explore the code of the ${showElement('head')} element.</li>
</ol>
`,

        )
        a47_website_8_pageinfo.video = `https://youtube.com/bubi`;

        a47_website_8_pageinfo.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" class="image-left">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <img src="spacerides3.jpg" class="image-right">
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <img src="spacerides4.jpg" class="image-left">
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
        </section>
        <section id="video" style="background-color: #efefef;">
            <h2>Experience the Space Ride</h2>
            <p>Watch the video and experience the magic moments of Zootata's space rides:</p>
            <iframe width="560" height="315" src="https://www.youtube.com/embed/1ZcU27hgwHE" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
        </section>
        <section id="quotes">
            <h2>Our Happy Customers</h2>
            <p>Listen to our fans explain how much fun they had on our space rides:</p>
            <div class="quote">
                <img src="spacerides5.jpg" class="quote-image"/>
                <p>&ldquo;Wow! The Black Hole was amazing. I got super stretchy, so I looked like a rope.&rdquo;</p>
                <p>Bloobeek</p>
            </div>
            <div class="quote">
                <img src="spacerides6.jpg" class="quote-image"/>
                <p>&ldquo;I'm a big fan. I skated faster than the speed of light!&rdquo;</p>
                <p>Rooky</p>
            </div>
            <div class="quote">
                <img src="spacerides7.jpg" class="quote-image"/>
                <p>&ldquo;The glow worms were 5 space bounces long. We were so deep under ground! I can't believe that Zootata was able to organize that!&rdquo;</p>
                <p>Mooteetee</p>
            </div>
        </section>
        <section id="contact">
            <h2>Want to join us on a space ride?</h2>
            <a href="mailto:zootata@example.com" class="big-button">Get in touch!</a>
        </section>
        <footer>
            <p>&copy; Zootata&apos;s Super Space Rides. Created by [your name].</p>
        </footer>
    </body>
</html>`);

        a47_website_8_pageinfo.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
}

.image-left {
    width: 280px;
    float: left;
    margin-right: 20px;
    margin-bottom: 40px;
}

h3 {
    clear: both;
}

.image-right {
    width: 280px;
    float: right;
    margin-left: 20px;
    margin-bottom: 40px;
}

iframe {
    width: 100%;
}

.quote {
    text-align: center;
    border: 1px solid #b4b4b4;
    padding: 20px 20px 0px;
    background-color: #ffffff;
    margin-top: 30px;
    margin-bottom: 30px;
}

.quote-image {
    width: 150px;
    border-radius: 50%;
}

#contact {
    background-image: url('background1.jpg');
    background-repeat: no-repeat;
    background-size: cover;
    color: #ffffff;
    text-align: center;
    padding-bottom: 120px;
}

.big-button {
    font-size: 25px;
    padding: 10px 30px;
    background-color: #ff9400;
    color: #ffffff;
    text-decoration: none;
    border-radius: 25px;
    display: inline-block;
    margin-top: 10px;
    margin-bottom: 20px;
}

.big-button:hover {
    text-decoration: underline;
}

footer {
    text-align: center;
    background-color: #060025;
    padding: 20px 40px;
    color: rgba(255, 255, 255, 0.72);
}

`);

        a47_website_8_pageinfo.inject_css = base_css;
        a47_website_8_pageinfo.open_all_files_in_code = true;

        a47_website_8_pageinfo.onCheck = function(page, status) {
            var error = null;

            var title = page.sourceNode.findOne('title');
            if(!title) {
                error = `<p>Select the top HTML element and set the Title in the Attributes panel.</p>`;
            } else {
                if(!page.sourceNode.findOne('meta[name="description"]')) {
                    error = `<p>Select the top HTML element and set the Description in the Attributes panel.</p>`;
                } else if(!page.sourceNode.findOne('meta[name="keywords"]')) {
                    error = `<p>Select the top HTML element and set the Keywords in the Attributes panel.</p>`;
                } else if(!page.sourceNode.findOne('meta[name="author"]')) {
                    error = `<p>Select the top HTML element and set the Author in the Attributes panel.</p>`;
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a47_website_8_pageinfo);
        tutorial.addLesson(a47_website_8_pageinfo);









        var a47_website_8_design = new PgTutorialLesson('zootata_website_design_1', 'alien13', chapter_space_rides);

        a47_website_8_design.name = `Super Space Rides - Improving the layout`;
        a47_website_8_design.display_title = `Super Space Rides - Improving the layout` + addAlien('alien13', null, null, '-30px');

        a47_website_8_design.main_lesson = a45_website_1_structure;

        a47_website_8_design.description = makeDesc(
            '490081753',
            `<p>Set <b>Margin left / right</b> to <code>auto</code> to center the element.</p>`,
            `<p>Make sure that the page looks good on different screens:</p>
<ol>
    <li>Resize the page by dragging its right edge. If you need more space double-click on the panel tabs to collapse them.</li>
    <li><b>Select ${select('body')}</b> and set <b>Max width</b> to <code>800px</code>.</li>
    <li>Set <b>Min width</b> to <code>500px</code>.</li>
    <li>Set <b>Margin left / right</b> to <code>auto</code> to center the page.</li>
    <li>Set <b>Background image</b> to <code>background5.jpg</code>, <b>Background repeat</b> to <code>no-repeat</code>, <b>Background size</b> to <code>cover</code> and <b>Background attachment</b> to <code>fixed</code>.</li>
    <li><b>Select one of the ${select('<section> elements', 'section')}</b>, make sure the ${rule('section')} is selected and set its <b>Background color</b> to <code>white</code>.</li>
</ol>
`,

        )
        a47_website_8_design.video = `https://youtube.com/bubi`;

        a47_website_8_design.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
        <title>Super Space Rides</title>
        <meta name="description" content="Join Zootata on amazing rides around the universe!">
        <meta name="keywords" content="Space, Adventure, Space exploration, Travel">
        <meta name="author" content="My Name">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" class="image-left">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <img src="spacerides3.jpg" class="image-right">
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <img src="spacerides4.jpg" class="image-left">
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
        </section>
        <section id="video" style="background-color: #efefef;">
            <h2>Experience the Space Ride</h2>
            <p>Watch the video and experience the magic moments of Zootata's space rides:</p>
            <iframe width="560" height="315" src="https://www.youtube.com/embed/1ZcU27hgwHE" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
        </section>
        <section id="quotes">
            <h2>Our Happy Customers</h2>
            <p>Listen to our fans explain how much fun they had on our space rides:</p>
            <div class="quote">
                <img src="spacerides5.jpg" class="quote-image"/>
                <p>&ldquo;Wow! The Black Hole was amazing. I got super stretchy, so I looked like a rope.&rdquo;</p>
                <p>Bloobeek</p>
            </div>
            <div class="quote">
                <img src="spacerides6.jpg" class="quote-image"/>
                <p>&ldquo;I'm a big fan. I skated faster than the speed of light!&rdquo;</p>
                <p>Rooky</p>
            </div>
            <div class="quote">
                <img src="spacerides7.jpg" class="quote-image"/>
                <p>&ldquo;The glow worms were 5 space bounces long. We were so deep under ground! I can't believe that Zootata was able to organize that!&rdquo;</p>
                <p>Mooteetee</p>
            </div>
        </section>
        <section id="contact">
            <h2>Want to join us on a space ride?</h2>
            <a href="mailto:zootata@example.com" class="big-button">Get in touch!</a>
        </section>
        <footer>
            <p>&copy; Zootata&apos;s Super Space Rides. Created by [your name].</p>
        </footer>
    </body>
</html>`);

        a47_website_8_design.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
}

.image-left {
    width: 280px;
    float: left;
    margin-right: 20px;
    margin-bottom: 40px;
}

h3 {
    clear: both;
}

.image-right {
    width: 280px;
    float: right;
    margin-left: 20px;
    margin-bottom: 40px;
}

iframe {
    width: 100%;
}

.quote {
    text-align: center;
    border: 1px solid #b4b4b4;
    padding: 20px 20px 0px;
    background-color: #ffffff;
    margin-top: 30px;
    margin-bottom: 30px;
}

.quote-image {
    width: 150px;
    border-radius: 50%;
}

#contact {
    background-image: url('background1.jpg');
    background-repeat: no-repeat;
    background-size: cover;
    color: #ffffff;
    text-align: center;
    padding-bottom: 120px;
}

.big-button {
    font-size: 25px;
    padding: 10px 30px;
    background-color: #ff9400;
    color: #ffffff;
    text-decoration: none;
    border-radius: 25px;
    display: inline-block;
    margin-top: 10px;
    margin-bottom: 20px;
}

.big-button:hover {
    text-decoration: underline;
}

footer {
    text-align: center;
    background-color: #060025;
    padding: 20px 40px;
    color: rgba(255, 255, 255, 0.72);
}

`);

        a47_website_8_design.inject_css = base_css;
        a47_website_8_design.open_all_files_in_code = true;

        a47_website_8_design.onCheck = function(page, status) {
            var error = null;

            var body = page.sourceNode.findOne('body');
            if(!getInlineCSSValue(body, 'max-width')) {
                error = `<p>Select the BODY element and set the Max width CSS property to <code>800px</code>.</p>`;
            } else if(!getInlineCSSValue(body, 'min-width')) {
                error = `<p>Select the BODY element and set the Min width CSS property to <code>500px</code>.</p>`;
            } else if(getInlineCSSValue(body, 'margin-left') !== 'auto') {
                error = `<p>Select the BODY element and set the Margin left CSS property to <code>auto</code>.</p>`;
            } else if(getInlineCSSValue(body, 'margin-right') !== 'auto') {
                error = `<p>Select the BODY element and set the Margin right CSS property to <code>auto</code>.</p>`;
            } else {
                var ch = checkBackground(body, "BODY");
                if(ch) {
                    error = ch;
                } else if(getInlineCSSValue(body, 'background-repeat') !== 'no-repeat') {
                    error = `<p>Select the BODY element and set the Background repeat to <code>no-repeat</code>.</p>`;
                } else if(getInlineCSSValue(body, 'background-size') !== 'cover') {
                    error = `<p>Select the BODY element and set the Background size to <code>cover</code>.</p>`;
                } else if(getInlineCSSValue(body, 'background-attachment') !== 'fixed') {
                    error = `<p>Select the BODY element and set the Background attachment to <code>fixed</code>.</p>`;
                } else {
                    var rules = getCSSRules('section');
                    if(!cssRulesHaveProperty(rules, 'background-color')) {
                        error = `<p>Select a Section element and set the Background color of the <code>section</code> CSS rule to <code>white</code>.</p>`;
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a47_website_8_design);
        tutorial.addLesson(a47_website_8_design);





        var a47_website_8_design_2 = new PgTutorialLesson('zootata_website_design_2', 'alien13', chapter_space_rides);

        a47_website_8_design_2.name = `Super Space Rides - Fonts &amp; the header`;
        a47_website_8_design_2.display_title = `Super Space Rides - Fonts &amp; the header` + addAlien('alien13', null, null, '-30px');

        a47_website_8_design_2.main_lesson = a45_website_1_structure;

        a47_website_8_design_2.description = makeDesc(
            '490320047',
            `<p>Use negative margins for fun effects.</p>`,
            `<p>Improve the fonts and the header:</p>
<ol>
    <li>Use the <b>${tooltip('+ Insert', 'insert_menu')}</b> menu to drag a <b>${showElement('div')}</b> to the end of the <b>${select('Our rides section', '#rides')}</b>. Place the ${showElement('div')} <b>inside</b> the section, not after the section.</li>
    <li>Set <b>Clear</b> CSS property to <code>both</code> and <b>Save the style</b> as a CSS rule with the selector <code>.clear-floats</code>.</li>
    <li>Turn off the ${tooltip('empty placeholder', 'empty_placeholder')} on the selected Div.</li>
    <li><b>Select the ${select('body')}</b>, set <b>Font family</b> to <code>Arial, Helvetica, sans-serif</code> and <b>Font size</b> to <code>18px</code>.</li>
    <li><b>Save the style</b> as a CSS rule with the selector <code>body</code>.</li>
    <li><b>Select the ${select('h1', 'header h1')}</b> in the Header. Set <b>Font family</b> to <code>Impact, Charcoal, sans-serif</code> and <b>Font size</b> to <code>70px</code>.</li>
    <li><b>Save the style</b> as a CSS rule with the selector <code>h1</code>.</li>
    <li><b>Select the ${select('p', 'header p')} subheading</b> in the Header. Set <b>Font size</b> to <code>28px</code> and <b>Width</b> to <code>420px</code>. Set <b>Background color</b> to purple, <b>Padding left / right</b> to <code>20px</code> and <b>Padding top / bottom</b> to <code>10px</code>.</li>
    <li>Set <b>Margin left</b> to <code>-40px</code> and increase <b>Padding left</b> to <code>40px</code>. Round the <b>right corners</b> by <code>10px</code>.</li>
    <li>${tooltip('Turn off blue element menus', 'menu_toggle')} to better see the rounded corners.</li>
    <li><b>Save the style</b> as a CSS rule with the selector <code>.subheading</code>.</li>
</ol>
`,

        )
        a47_website_8_design_2.video = `https://youtube.com/bubi`;

        a47_website_8_design_2.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
        <title>Super Space Rides</title>
        <meta name="description" content="Join Zootata on amazing rides around the universe!">
        <meta name="keywords" content="Space, Adventure, Space exploration, Travel">
        <meta name="author" content="My Name">
    </head>
    <body style="min-width: 500px; max-width: 800px; margin-left: auto; margin-right: auto; background-image: url('background5.jpg'); background-repeat: no-repeat; background-size: cover; background-attachment: fixed;">
        <header>
            <h1>Super Space Rides</h1>
            <p>Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" class="image-left">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <img src="spacerides3.jpg" class="image-right">
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <img src="spacerides4.jpg" class="image-left">
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
        </section>
        <section id="video" style="background-color: #efefef;">
            <h2>Experience the Space Ride</h2>
            <p>Watch the video and experience the magic moments of Zootata's space rides:</p>
            <iframe width="560" height="315" src="https://www.youtube.com/embed/1ZcU27hgwHE" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
        </section>
        <section id="quotes">
            <h2>Our Happy Customers</h2>
            <p>Listen to our fans explain how much fun they had on our space rides:</p>
            <div class="quote">
                <img src="spacerides5.jpg" class="quote-image"/>
                <p>&ldquo;Wow! The Black Hole was amazing. I got super stretchy, so I looked like a rope.&rdquo;</p>
                <p>Bloobeek</p>
            </div>
            <div class="quote">
                <img src="spacerides6.jpg" class="quote-image"/>
                <p>&ldquo;I'm a big fan. I skated faster than the speed of light!&rdquo;</p>
                <p>Rooky</p>
            </div>
            <div class="quote">
                <img src="spacerides7.jpg" class="quote-image"/>
                <p>&ldquo;The glow worms were 5 space bounces long. We were so deep under ground! I can't believe that Zootata was able to organize that!&rdquo;</p>
                <p>Mooteetee</p>
            </div>
        </section>
        <section id="contact">
            <h2>Want to join us on a space ride?</h2>
            <a href="mailto:zootata@example.com" class="big-button">Get in touch!</a>
        </section>
        <footer>
            <p>&copy; Zootata&apos;s Super Space Rides. Created by [your name].</p>
        </footer>
    </body>
</html>`);

        a47_website_8_design_2.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
    background-color: #ffffff;
}

.image-left {
    width: 280px;
    float: left;
    margin-right: 20px;
    margin-bottom: 40px;
}

h3 {
    clear: both;
}

.image-right {
    width: 280px;
    float: right;
    margin-left: 20px;
    margin-bottom: 40px;
}

iframe {
    width: 100%;
}

.quote {
    text-align: center;
    border: 1px solid #b4b4b4;
    padding: 20px 20px 0px;
    background-color: #ffffff;
    margin-top: 30px;
    margin-bottom: 30px;
}

.quote-image {
    width: 150px;
    border-radius: 50%;
}

#contact {
    background-image: url('background1.jpg');
    background-repeat: no-repeat;
    background-size: cover;
    color: #ffffff;
    text-align: center;
    padding-bottom: 120px;
}

.big-button {
    font-size: 25px;
    padding: 10px 30px;
    background-color: #ff9400;
    color: #ffffff;
    text-decoration: none;
    border-radius: 25px;
    display: inline-block;
    margin-top: 10px;
    margin-bottom: 20px;
}

.big-button:hover {
    text-decoration: underline;
}

footer {
    text-align: center;
    background-color: #060025;
    padding: 20px 40px;
    color: rgba(255, 255, 255, 0.72);
}

`);

        a47_website_8_design_2.inject_css = base_css;
        a47_website_8_design_2.open_all_files_in_code = true;

        a47_website_8_design_2.onCheck = function(page, status) {
            var error = null;

            var div = page.sourceNode.findOne('#rides div.clear-floats');

            if(!div) {
                error = `<p>Place an empty DIV element at the end of the #rides section and create a new class CSS rule <code>.clear-floats</code> with <b>Clear</b> set to <code>both</code>.</p>`;
            } else if(div.next()) {
                error = `<p>The DIV with <code>.clear-floats</code> should be positioned at the very end of the #rides section. Use the Structure tree to move it around.</p>`;
            } else {
                var rules = getCSSRules('.clear-floats');
                if(rules.length === 0) {
                    error = `<p>Select the DIV and create a new class CSS rule <code>.clear-floats</code> and set <b>Clear</b> to <code>both</code>.</p>`;
                } else if(!cssRulesHaveProperty(rules, 'clear', 'both')) {
                    error = `<p>Select the CSS rule <code>.clear-floats</code> and set <b>Clear</b> to <code>both</code>.</p>`;
                } else if(div.hasAttribute('data-empty-placeholder')) {
                    error = `<p>Select the DIV with <code>.clear-floats</code> and switch off the empty placeholder helper.</p>`;
                } else {
                    var rules = getCSSRules('body');
                    if(rules.length === 0) {
                        error = `<p>Select the BODY and create a new class CSS rule <code>body</code>.</p>`;
                    } else if(!cssRulesHaveProperty(rules, 'font-family')) {
                        error = `<p>Select the CSS rule <code>body</code> and set the Font family.</p>`;
                    } else if(!cssRulesHaveProperty(rules, 'font-size')) {
                        error = `<p>Select the CSS rule <code>body</code> and set the Font size to <code>18px</code>.</p>`;
                    } else {
                        var rules = getCSSRules('h1');
                        if(rules.length === 0) {
                            error = `<p>Select the H1 in the Header and create a new class CSS rule <code>h1</code>.</p>`;
                        } else if(!cssRulesHaveProperty(rules, 'font-size')) {
                            error = `<p>Select the CSS rule <code>h1</code> and set the Font size to <code>70px</code>.</p>`;
                        } else {
                            var rules = getCSSRules('.subheading');
                            if(rules.length === 0) {
                                error = `<p>Select the P in the Header and create a new class CSS rule <code>.subheading</code>.</p>`;
                            } else if(!cssRulesHaveProperty(rules, 'font-size')) {
                                error = `<p>Select the CSS rule <code>.subheading</code> and set the Font size to <code>28px</code>.</p>`;
                            } else if(!cssRulesHaveProperty(rules, 'width')) {
                                error = `<p>Select the CSS rule <code>.subheading</code> and set the Width to <code>420px</code>.</p>`;
                            } else if(!cssRulesHaveProperty(rules, 'background-color')) {
                                error = `<p>Select the CSS rule <code>.subheading</code> and set its Background color.</p>`;
                            } else if(!cssRulesHaveProperty(rules, /^padding/)) {
                                error = `<p>Select the CSS rule <code>.subheading</code> and set its Padding.</p>`;
                            } else if(!cssRulesHaveProperty(rules, /^margin/)) {
                                error = `<p>Select the CSS rule <code>.subheading</code> and set its Margins.</p>`;
                            } else if(!cssRulesHaveProperty(rules, /^border/)) {
                                error = `<p>Select the CSS rule <code>.subheading</code> and set its Border radius.</p>`;
                            }
                        }
                    }
                }
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a47_website_8_design_2);
        tutorial.addLesson(a47_website_8_design_2);





        var a47_website_8_design_3 = new PgTutorialLesson('zootata_website_design_3', 'alien13', chapter_space_rides);

        a47_website_8_design_3.name = `Super Space Rides - Spice up the design`;
        a47_website_8_design_3.display_title = `Super Space Rides - Spice up the design` + addAlien('alien13', null, null, '-30px');

        a47_website_8_design_3.main_lesson = a45_website_1_structure;

        a47_website_8_design_3.description = makeDesc(
            '490323101',
            `<p>Use <code>box-shadow</code> CSS property to create cool 3D effects.</p>`,
            `<p>Add shadows to the page:</p>
<ol>
    <li><b>Select any ${select('img', '#rides img')}</b> element and make sure that <b>Style attribute</b> is selected in the Style panel.</li>
    <li>Go to the <b>Box shadow</b> section and <b>add a shadow</b> with <b>Distance</b> <code>4px</code>, <b>Angle</b> around <code>315</code> degrees, <b>Blur</b> <code>8px</code> and <code>transparent black</code> <b>Shadow color</b>.</li>
     <li><b>Save the style</b> as a new CSS rule with the selector <code>img</code>.</li>
     <li><b>Select the ${select('body')}</b> and make sure that ${rule('body')} is selected in the Style panel.</li>
    <li>Add a <b>Box shadow</b> with <b>Distance</b> <code>8px</code>, <b>Angle</b> around <code>315</code> degrees, <b>Blur</b> <code>12px</code> and <code>transparent black</code> <b>Shadow color</b>.</li>
    <li>Set the <b>Margin top</b> to <code>70px</code>.</li>
    <li>Well done! You created a real website!</li>
    <li><b>${tooltip('Preview the page', 'preview')}</b> in the browser.</li>
</ol>
`,

        )
        a47_website_8_design_3.video = `https://youtube.com/bubi`;

        a47_website_8_design_3.addPage('index.html', `<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
        <title>Super Space Rides</title>
        <meta name="description" content="Join Zootata on amazing rides around the universe!">
        <meta name="keywords" content="Space, Adventure, Space exploration, Travel">
        <meta name="author" content="My Name">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p class="subheading">Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" class="image-left">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <img src="spacerides3.jpg" class="image-right">
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <img src="spacerides4.jpg" class="image-left">
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
            <div class="clear-floats"></div>
        </section>
        <section id="video" style="background-color: #efefef;">
            <h2>Experience the Space Ride</h2>
            <p>Watch the video and experience the magic moments of Zootata's space rides:</p>
            <iframe width="560" height="315" src="https://www.youtube.com/embed/1ZcU27hgwHE" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
        </section>
        <section id="quotes">
            <h2>Our Happy Customers</h2>
            <p>Listen to our fans explain how much fun they had on our space rides:</p>
            <div class="quote">
                <img src="spacerides5.jpg" class="quote-image"/>
                <p>&ldquo;Wow! The Black Hole was amazing. I got super stretchy, so I looked like a rope.&rdquo;</p>
                <p>Bloobeek</p>
            </div>
            <div class="quote">
                <img src="spacerides6.jpg" class="quote-image"/>
                <p>&ldquo;I'm a big fan. I skated faster than the speed of light!&rdquo;</p>
                <p>Rooky</p>
            </div>
            <div class="quote">
                <img src="spacerides7.jpg" class="quote-image"/>
                <p>&ldquo;The glow worms were 5 space bounces long. We were so deep under ground! I can't believe that Zootata was able to organize that!&rdquo;</p>
                <p>Mooteetee</p>
            </div>
        </section>
        <section id="contact">
            <h2>Want to join us on a space ride?</h2>
            <a href="mailto:zootata@example.com" class="big-button">Get in touch!</a>
        </section>
        <footer>
            <p>&copy; Zootata&apos;s Super Space Rides. Created by [your name].</p>
        </footer>
    </body>
</html>`);

        a47_website_8_design_3.addStylesheet('style.css',  `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
    background-color: #ffffff;
}

.image-left {
    width: 280px;
    float: left;
    margin-right: 20px;
    margin-bottom: 40px;
}

h3 {
    clear: both;
}

.image-right {
    width: 280px;
    float: right;
    margin-left: 20px;
    margin-bottom: 40px;
}

iframe {
    width: 100%;
}

.quote {
    text-align: center;
    border: 1px solid #b4b4b4;
    padding: 20px 20px 0px;
    background-color: #ffffff;
    margin-top: 30px;
    margin-bottom: 30px;
}

.quote-image {
    width: 150px;
    border-radius: 50%;
}

#contact {
    background-image: url('background1.jpg');
    background-repeat: no-repeat;
    background-size: cover;
    color: #ffffff;
    text-align: center;
    padding-bottom: 120px;
}

.big-button {
    font-size: 25px;
    padding: 10px 30px;
    background-color: #ff9400;
    color: #ffffff;
    text-decoration: none;
    border-radius: 25px;
    display: inline-block;
    margin-top: 10px;
    margin-bottom: 20px;
}

.big-button:hover {
    text-decoration: underline;
}

footer {
    text-align: center;
    background-color: #060025;
    padding: 20px 40px;
    color: rgba(255, 255, 255, 0.72);
}

.clear-floats {
    clear: both;
}

body {
    min-width: 500px;
    max-width: 800px;
    margin-left: auto;
    margin-right: auto;
    background-image: url('background5.jpg');
    background-repeat: no-repeat;
    background-size: cover;
    background-attachment: fixed;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 18px;
}

h1 {
    font-family: Impact, Charcoal, sans-serif;
    font-size: 70px;
}

.subheading {
    font-size: 28px;
    width: 420px;
    background-color: #b700c4;
    padding: 10px 20px 10px 40px;
    margin-left: -40px;
    border-top-right-radius: 10px;
    border-bottom-right-radius: 10px;
}
`);

        a47_website_8_design_3.inject_css = base_css;
        a47_website_8_design_3.open_all_files_in_code = true;

        a47_website_8_design_3.onCheck = function(page, status) {
            var error = null;

            var rules = getCSSRules('img');
            if(rules.length === 0) {
                error = `<p>Select an IMG and create a new class CSS rule <code>img</code>.</p>`;
            } else if(!cssRulesHaveProperty(rules, 'box-shadow')) {
                error = `<p>Select the CSS rule <code>img</code> and set its Box shadow.</p>`;
            }

            var rules = getCSSRules('body');
            if(rules.length === 0) {
                error = `<p>Where did the BODY CSS rule go? No problem, use Undo or restart the lesson.</p>`;
            } else if(!cssRulesHaveProperty(rules, 'box-shadow')) {
                error = `<p>Select the CSS rule <code>body</code> and set its Box shadow.</p>`;
            } else if(!cssRulesHaveProperty(rules, /^margin/)) {
                error = `<p>Select the CSS rule <code>body</code> and set its Margin top and bottom to <code>70px</code>.</p>`;
            }

            if(error) {
                status.result = 'error';
                status.message = error;
            } else {
                status.result = 'ok';
            }
            status.decoration = addAlien('alien13', 'check-box');
        }

        addAllResources(a47_website_8_design_3);
        tutorial.addLesson(a47_website_8_design_3);



        var zootata_complete_html = `
<!doctype html>
<html>
    <head>
        <link href="style.css" rel="stylesheet">
        <title>Super Space Rides</title>
        <meta name="description" content="Join Zootata on amazing rides around the universe!">
        <meta name="keywords" content="Space, Adventure, Space exploration, Travel">
        <meta name="author" content="My Name">
    </head>
    <body>
        <header>
            <h1>Super Space Rides</h1>
            <p class="subheading">Join Zootata on amazing rides around the universe!</p>
        </header>
        <section id="rides">
            <h2>Our Rides</h2>
            <p>We have many different space rides. Find the one that is perfect for you!</p>
            <h3>Wobbly Jelly Asteroid Belt</h3>
            <img src="spacerides2.jpg" class="image-left">
            <p>Travel with the speed of light to the far edge of our galaxy. Land on the jelly asteroid and get wobbly! When you get dizzy come back to the spaceship and enjoy your delicious lunch. Price: 500 Space coins.</p>
            <h3>Underground Space Cave</h3>
            <img src="spacerides3.jpg" class="image-right">
            <p>Descend  20,000 Space kilometers down into the lava planet and explore the rarest glow worms in the universe. Glow worm nest is super radioactive. You will get a special protective suit that will keep your brain safe from melting. Price: 650 Space coins.</p>
            <h3>Black Hole Retreat</h3>
            <img src="spacerides4.jpg" class="image-left">
            <p>Travel through the black matter clouds all the way to the nearest black hole. There you will enjoy special stretching exercises with our trained professionals. Some of the best acrobats have learned their skills there. Price: 1,000 Space coins.</p>
            <div class="clear-floats"></div>
        </section>
        <section id="video" style="background-color: #efefef;">
            <h2>Experience the Space Ride</h2>
            <p>Watch the video and experience the magic moments of Zootata's space rides:</p>
            <iframe width="560" height="315" src="https://www.youtube.com/embed/1ZcU27hgwHE" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
        </section>
        <section id="quotes">
            <h2>Our Happy Customers</h2>
            <p>Listen to our fans explain how much fun they had on our space rides:</p>
            <div class="quote">
                <img src="spacerides5.jpg" class="quote-image"/>
                <p>&ldquo;Wow! The Black Hole was amazing. I got super stretchy, so I looked like a rope.&rdquo;</p>
                <p>Bloobeek</p>
            </div>
            <div class="quote">
                <img src="spacerides6.jpg" class="quote-image"/>
                <p>&ldquo;I'm a big fan. I skated faster than the speed of light!&rdquo;</p>
                <p>Rooky</p>
            </div>
            <div class="quote">
                <img src="spacerides7.jpg" class="quote-image"/>
                <p>&ldquo;The glow worms were 5 space bounces long. We were so deep under ground! I can't believe that Zootata was able to organize that!&rdquo;</p>
                <p>Mooteetee</p>
            </div>
        </section>
        <section id="contact">
            <h2>Want to join us on a space ride?</h2>
            <a href="mailto:zootata@example.com" class="big-button">Get in touch!</a>
        </section>
        <footer>
            <p>&copy; Zootata&apos;s Super Space Rides. Created by [your name].</p>
        </footer>
    </body>
</html>
`;

        var zootata_complete_css = `
header {
    padding: 40px 40px 180px;
    background-image: url('spacerides1.jpg');
    color: #ffffff;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: right bottom;
}

section {
    padding: 40px;
    background-color: #ffffff;
}

.image-left {
    width: 280px;
    float: left;
    margin-right: 20px;
    margin-bottom: 40px;
}

h3 {
    clear: both;
}

.image-right {
    width: 280px;
    float: right;
    margin-left: 20px;
    margin-bottom: 40px;
}

iframe {
    width: 100%;
}

.quote {
    text-align: center;
    border: 1px solid #b4b4b4;
    padding: 20px 20px 0px;
    background-color: #ffffff;
    margin-top: 30px;
    margin-bottom: 30px;
}

.quote-image {
    width: 150px;
    border-radius: 50%;
}

#contact {
    background-image: url('background1.jpg');
    background-repeat: no-repeat;
    background-size: cover;
    color: #ffffff;
    text-align: center;
    padding-bottom: 120px;
}

.big-button {
    font-size: 25px;
    padding: 10px 30px;
    background-color: #ff9400;
    color: #ffffff;
    text-decoration: none;
    border-radius: 25px;
    display: inline-block;
    margin-top: 10px;
    margin-bottom: 20px;
}

.big-button:hover {
    text-decoration: underline;
}

footer {
    text-align: center;
    background-color: #060025;
    padding: 20px 40px;
    color: rgba(255, 255, 255, 0.72);
}

.clear-floats {
    clear: both;
}

body {
    min-width: 500px;
    max-width: 800px;
    background-image: url('background5.jpg');
    background-repeat: no-repeat;
    background-size: cover;
    background-attachment: fixed;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 18px;
    box-shadow: 6px 6px 12px rgba(0, 0, 0, 0.22);
    margin: 70px auto 0;
}

h1 {
    font-family: Impact, Charcoal, sans-serif;
    font-size: 70px;
}

.subheading {
    font-size: 28px;
    width: 420px;
    background-color: #b700c4;
    padding: 10px 20px 10px 40px;
    margin-left: -40px;
    border-top-right-radius: 10px;
    border-bottom-right-radius: 10px;
}

img {
    box-shadow: 3px 3px 8px rgba(0, 0, 0, 0.24);
}
`;



        pinegrow.addEventHandler('on_get_new_project_templates', function(pagenull, template_list) {
            var list = [
                {
                    name: 'Blank page',
                    pid: 'admin/blank-page',
                    thumb: 'blank.jpg',
                    desc: 'Create from scratch',
                    vid: '572915874',
                    subid: 'template.blank'
                },
                {
                    name: 'Mobile phone',
                    pid: 'admin/mobile-phone',
                    thumb: 'mobile-phone.jpg',
                    desc: 'Create a space phone',
                    vid: '572915971',
                    subid: 'template.mobile'
                },
                {
                    name: 'Slideshow',
                    pid: 'admin/slideshow',
                    thumb: 'slideshow.jpg',
                    desc: 'A multi-page slideshow',
                    vid: '572916702',
                    subid: 'template.slideshow'
                },
                {
                    name: 'Simple website',
                    pid: 'admin/simple-website',
                    thumb: 'simple-website.jpg',
                    desc: 'One-page website',
                    vid: '572916313',
                    subid: 'template.simplewebsite'
                },
                {
                    name: 'Absolute playground',
                    pid: 'admin/absolute-playground',
                    thumb: 'absolute-playground.jpg',
                    desc: 'Absolutely positioned art',
                    vid: '572915179',
                    subid: 'template.playground'
                },
            ]

            if(location.hostname === 'localhost') {
                list.forEach(function(i) {
                    i.pid = i.pid.replace('admin/', 'mol6/');
                })
            }

            list.forEach(function(t) {
                t.thumb = `images/kids/project_templates/${t.thumb}`;
                template_list.push(t);
            })
        })


        pinegrow.addEventHandler('on_get_actions_for_start_menu', function(pagenull, start_actions) {

            var actions = [];

            var community_action = {
                icon: `<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chat" viewBox="0 0 16 16">
  <path d="M2.678 11.894a1 1 0 0 1 .287.801 10.97 10.97 0 0 1-.398 2c1.395-.323 2.247-.697 2.634-.893a1 1 0 0 1 .71-.074A8.06 8.06 0 0 0 8 14c3.996 0 7-2.807 7-6 0-3.192-3.004-6-7-6S1 4.808 1 8c0 1.468.617 2.83 1.678 3.894zm-.493 3.905a21.682 21.682 0 0 1-.713.129c-.2.032-.352-.176-.273-.362a9.68 9.68 0 0 0 .244-.637l.003-.01c.248-.72.45-1.548.524-2.319C.743 11.37 0 9.76 0 8c0-3.866 3.582-7 8-7s8 3.134 8 7-3.582 7-8 7a9.06 9.06 0 0 1-2.347-.306c-.52.263-1.639.742-3.468 1.105z"/>
</svg>`,
                label: 'Join the community',
                desc: 'Interact with parents and teachers on HTML Planet (adults only).',
                action: function() {
                    var html = `<p>Join our community on Discord to interact with parents and teachers who use HTML Planet to teach their children and students about web development and design.</p>
<p>Note that the community is <code>open only to adults</code>, in order to protect safety and privacy of kids on HTML Planet.</p>
<p><a href="https://discord.gg/3YKw6RDpNw" class="btn pg-button pg-button-primary" target="_blank">Join the community</a></p>`;

                    pinegrow.showAlert(html, 'Join the community', 'Close', null);
                }
            }


            var parent_guide_action = {
                icon: `<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-map" viewBox="0 0 16 16">
  <path fill-rule="evenodd" d="M15.817.113A.5.5 0 0 1 16 .5v14a.5.5 0 0 1-.402.49l-5 1a.502.502 0 0 1-.196 0L5.5 15.01l-4.902.98A.5.5 0 0 1 0 15.5v-14a.5.5 0 0 1 .402-.49l5-1a.5.5 0 0 1 .196 0L10.5.99l4.902-.98a.5.5 0 0 1 .415.103zM10 1.91l-4-.8v12.98l4 .8V1.91zm1 12.98 4-.8V1.11l-4 .8v12.98zm-6-.8V1.11l-4 .8v12.98l4-.8z"/>
</svg>`,
                label: 'Parent &amp; teacher guide',
                desc: 'Learn how to get started and get the most out of HTML Planet.',
                url: 'https://htmlplanetforkids.com/guide.html'
            }

            var video_action = {
                icon: `<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-camera-reels" viewBox="0 0 16 16">
<path d="M6 3a3 3 0 1 1-6 0 3 3 0 0 1 6 0zM1 3a2 2 0 1 0 4 0 2 2 0 0 0-4 0z"/>
<path d="M9 6h.5a2 2 0 0 1 1.983 1.738l3.11-1.382A1 1 0 0 1 16 7.269v7.462a1 1 0 0 1-1.406.913l-3.111-1.382A2 2 0 0 1 9.5 16H2a2 2 0 0 1-2-2V8a2 2 0 0 1 2-2h7zm6 8.73V7.27l-3.5 1.555v4.35l3.5 1.556zM1 8v6a1 1 0 0 0 1 1h7.5a1 1 0 0 0 1-1V8a1 1 0 0 0-1-1H2a1 1 0 0 0-1 1z"/>
<path d="M9 6a3 3 0 1 0 0-6 3 3 0 0 0 0 6zM7 3a2 2 0 1 1 4 0 2 2 0 0 1-4 0z"/>
</svg>`,
                label: 'Watch the intro video',
                desc: 'First time here? Learn everything you need to get started.',
                class: 'pg-lessons-intro-video',
                action: function () {
                    var video_player = new PgTutorialVideo('569606233', pgTutorialSubtitles.get('intro.video.kids'));
                    pinegrow.backend.setLessonStatus({
                        key: 'intro.video.kids'
                    }, 'done');
                }
            }

            if (!pinegrow.currentUser.isLoggedIn()) {
                actions.push(video_action);

                actions.push({
                    icon: `<i class="icon icon-276"></i>`,
                    label: 'Take it for a spin',
                    desc: 'Do the first ten adventures and create up to three projects.',
                    action: function () {
                        $('#start-tab-learn').trigger('click');

                        pinegrow.currentUser.registerForTrial();
                        return;

                        var explainer = new PgUIElementExplainer($('.lessons').first(), 'Start by doing the first ten adventures.', {
                            show_delay: 0,
                            close_delay: 50000,
                            focus: true,
                            position: 'up',
                            scroll_container: $('.pg-start-screen'),
                            button: 'Got it!'
                        });
                    }
                });

                actions.push({
                    icon: `<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-box-arrow-in-right" viewBox="0 0 16 16">
  <path fill-rule="evenodd" d="M6 3.5a.5.5 0 0 1 .5-.5h8a.5.5 0 0 1 .5.5v9a.5.5 0 0 1-.5.5h-8a.5.5 0 0 1-.5-.5v-2a.5.5 0 0 0-1 0v2A1.5 1.5 0 0 0 6.5 14h8a1.5 1.5 0 0 0 1.5-1.5v-9A1.5 1.5 0 0 0 14.5 2h-8A1.5 1.5 0 0 0 5 3.5v2a.5.5 0 0 0 1 0v-2z"/>
  <path fill-rule="evenodd" d="M11.854 8.354a.5.5 0 0 0 0-.708l-3-3a.5.5 0 1 0-.708.708L10.293 7.5H1.5a.5.5 0 0 0 0 1h8.793l-2.147 2.146a.5.5 0 0 0 .708.708l3-3z"/>
</svg>`,
                    label: 'Login',
                    desc: 'Sign into your account and continue your adventures.',
                    action: function () {
                        pinegrow.currentUser.showLoginForm();
                    }
                });
            }
            if (!pinegrow.currentUser.isLoggedInAndActive()) {
                actions.push({
                    icon: `<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-gift" viewBox="0 0 16 16">
<path d="M3 2.5a2.5 2.5 0 0 1 5 0 2.5 2.5 0 0 1 5 0v.006c0 .07 0 .27-.038.494H15a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1v7.5a1.5 1.5 0 0 1-1.5 1.5h-11A1.5 1.5 0 0 1 1 14.5V7a1 1 0 0 1-1-1V4a1 1 0 0 1 1-1h2.038A2.968 2.968 0 0 1 3 2.506V2.5zm1.068.5H7v-.5a1.5 1.5 0 1 0-3 0c0 .085.002.274.045.43a.522.522 0 0 0 .023.07zM9 3h2.932a.56.56 0 0 0 .023-.07c.043-.156.045-.345.045-.43a1.5 1.5 0 0 0-3 0V3zM1 4v2h6V4H1zm8 0v2h6V4H9zm5 3H9v8h4.5a.5.5 0 0 0 .5-.5V7zm-7 8V7H2v7.5a.5.5 0 0 0 .5.5H7z"/>
</svg>`,
                    label: 'Subscribe',
                    desc: 'Subscribe and get all HTML Planet features.',
                    action: function () {
                        if (pinegrow.currentUser.isLoggedIn()) {
                            pinegrow.currentUser.editProfile();
                        } else {
                            pinegrow.currentUser.showRegistrationForm();
                        }
                    },
                    url: 'https://htmlplanetforkids.com/#buy'
                });
            } else {
                //is logged in and active

                if (pinegrow.currentUser.isParent()) {
                    actions.push(parent_guide_action);

                    actions.push(video_action);

                    actions.push({
                        icon: `<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-person-lines-fill" viewBox="0 0 16 16">
<path d="M6 8a3 3 0 1 0 0-6 3 3 0 0 0 0 6zm-5 6s-1 0-1-1 1-4 6-4 6 3 6 4-1 1-1 1H1zM11 3.5a.5.5 0 0 1 .5-.5h4a.5.5 0 0 1 0 1h-4a.5.5 0 0 1-.5-.5zm.5 2.5a.5.5 0 0 0 0 1h4a.5.5 0 0 0 0-1h-4zm2 3a.5.5 0 0 0 0 1h2a.5.5 0 0 0 0-1h-2zm0 3a.5.5 0 0 0 0 1h2a.5.5 0 0 0 0-1h-2z"/>
</svg>`,
                        label: 'Edit your account',
                        desc: 'Manage profile and edit child accounts.',
                        action: function () {
                            pinegrow.currentUser.editProfile();
                        }
                    });

                    //actions.push(community_action);
                } else {
                    actions.push(video_action);
                }
            }

            actions.forEach(function(a) {
                start_actions.push(a);
            })
        })

        pinegrow.addEventHandler('on_page_changes_done', function(page) {
            //restore empty placeholders
            var p = pinegrow.getCurrentProject();
            var changed = false;
            page.sourceNode.walk(function(pgel) {
                if(pgel.isElement && pgel.placeholderWasAutoRemoved && pgel.isEmpty() && !pgel.hasAttribute(pgf.empty_ph_attribute)) {
                    pgel.setAttribute(pgf.empty_ph_attribute);
                    changed = true;
                }
                return true;
            })
            if(changed) {
                pinegrow.selectedElements.reselect();
            }
        })


        pinegrow.addEventHandler('on_set_inline_style', function(page, o) {

            var reset_css = `/*! normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css */html{line-height:1.15;-webkit-text-size-adjust:100%}body{margin:0}main{display:block}h1{font-size:2em;margin:.67em 0}hr{box-sizing:content-box;height:0;overflow:visible}pre{font-family:monospace,monospace;font-size:1em}a{background-color:transparent}abbr[title]{border-bottom:none;text-decoration:underline;text-decoration:underline dotted}b,strong{font-weight:bolder}code,kbd,samp{font-family:monospace,monospace;font-size:1em}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-.25em}sup{top:-.5em}img{border-style:none}button,input,optgroup,select,textarea{font-family:inherit;font-size:100%;line-height:1.15;margin:0}button,input{overflow:visible}button,select{text-transform:none}[type=button],[type=reset],[type=submit],button{-webkit-appearance:button}[type=button]::-moz-focus-inner,[type=reset]::-moz-focus-inner,[type=submit]::-moz-focus-inner,button::-moz-focus-inner{border-style:none;padding:0}[type=button]:-moz-focusring,[type=reset]:-moz-focusring,[type=submit]:-moz-focusring,button:-moz-focusring{outline:1px dotted ButtonText}fieldset{padding:.35em .75em .625em}legend{box-sizing:border-box;color:inherit;display:table;max-width:100%;padding:0;white-space:normal}progress{vertical-align:baseline}textarea{overflow:auto}[type=checkbox],[type=radio]{box-sizing:border-box;padding:0}[type=number]::-webkit-inner-spin-button,[type=number]::-webkit-outer-spin-button{height:auto}[type=search]{-webkit-appearance:textfield;outline-offset:-2px}[type=search]::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}details{display:block}summary{display:list-item}template{display:none}[hidden]{display:none}`;

            o.css += reset_css + `
*, *:after, *:before {
    box-sizing: border-box;
}
        
html, body {
    min-height:100vh;
}

`;
        })


    })
})