var pgRedrawTaskId = null;

jQuery.fn.redraw = function () {
    /*
    No longer needed for new NWJS

    if(pgRedrawTaskId) {
        clearTimeout(pgRedrawTaskId);
    }
    pgRedrawTaskId = setTimeout(function() {
        var $n = $(document.body);
        $n.hide(0, function() {
            $n.show();
        });
        return

        fastdom.mutate(function() {
            var n = document.body;
            pgHide(n);
            pgShow(n);
        })
        pgRedrawTaskId = null;
    }, 100);
    */
};

var PgQuickWindow = function(title, view, key, def_w, def_h, pinned, floatable, static_win) {

    var _this = this;

    this.view = view;
    this.hideOnClose = false;
    this.isClosable = true;
    this.visible = false;

    this.pinned = pinned || false;

    this.wasMoved = false;
    this.wasResized = false;

    var floating = floatable && (pinegrow.getSetting(key + '-float', '0') === '1');
    this.app_win = null;

    this.$element = $('<div class="pg-quick-win"><div class="pg-quick-win-header lm_handle"><span class="pg-quick-win-header-title">' + title + '</span><div class="pg-quick-win-header-icons"><span class="pg-close pg-quick-win-header-icon">' /* + (pinned ? '' : (pgShowKbd('ESC') + '&nbsp;&nbsp; '))*/  + '<i class="icon icon-close"></i></span></div></div><div class="pg-quick-win-content"></div><div class="pg-win-resizer"><i class="icon icon-drag-kotni"</div></div>');

    static_win && this.$element.addClass('pg-quick-win-static');

    var $content = this.$element.find('.pg-quick-win-content');
    var $title = this.$element.find('.pg-quick-win-header-title');

    this.$element.on('keydown', function(e) {
        switch(e.key) {
            case 'Enter':
                if(_this.onEnter) return _this.onEnter();
                break;
        }
    });

    this.autoSize = function(add) {
        if(add === undefined) add = 50;
        var b = $content.css('bottom');
        $content.css('bottom', 'auto');
        var h = $content.height();
        $content.css('bottom', b);
        var h = h + add;
        var pos = this.$element.offset();
        var sh = this.$element.closest('body').height();

        if(h > 100) {
            if(pos.top + h > sh) {
                h = sh - pos.top;
            }
        }
        this.$element.css({height: h + 'px'});
    }

    this.noRightEdge = function() {
        $content.addClass('no-right-edge');
    }


    this.$element.find('.pg-close').on('click', function(e) {
        e.preventDefault();
        if(_this.hideOnClose) {
            _this.hide();
        } else {
            _this.destroy();
        }
    })

    var size = pgQuickWindowManager.getSize(key, def_w || 300, def_h || 300);

    this.$element.css({
        width: size.w + 'px',
        height: size.h + 'px'
    })

    $content.append(view.view.get$Element());

    view.view.alwaysVisible = true;
    view.view.updateVisibility();

    this.addIconToHeader = function(icon, tooltip, func) {
        var $i = $('<span class="pg-quick-win-header-icon"><i class="icon ' + icon + '"></i></span>').prependTo(this.$element.find('.pg-quick-win-header-icons'));
        $i.on('click', function(e) {
            e.preventDefault();
            func($i);
        })
        if(tooltip) addTooltip($i, tooltip);
        return $i;
    }

    if(floatable) {
        this.addIconToHeader('icon-window', 'Toggle floating window', function() {
            if(_this.app_win) {
                _this.$element.removeClass('pg-quick-win-floating');
                pinegrow.setSetting(key + '-float', '0');
                floating = false;
                _this.showFor$El($('body'));

                //we need this here as well
                pgUIViewManager.forEachView(_this.$element, function (view) {
                    view.onMovedToAnotherWindow && view.onMovedToAnotherWindow(window, _this.$element);
                })

                pinegrow.selectedElements.reselect();

                _this.app_win.close();
                _this.app_win = null;
            } else {
                _this.$element.detach();
                pinegrow.setSetting(key + '-float', '1');
                floating = true;
                handleFloating();
            }
        })
    }

    this.setTitle = function(t) {
        $title.html(t);
    }

    var position;

    var get$Body = function($target, pgel) {
        var $b = null;
        if(pgel) {
            $target = pgel.get$DOMElement();
        } else {
            if($target) $b = $target.closest('body');
        }
        if($b && $b.length) {
            return $b;
        }
        return $('body');
    }

    var handleFloating = function() {
        _this.$element.addClass('pg-quick-win-floating');
        _this.isClosable = false;

        var after = function() {
            $(_this.app_win.window.document.body).find('.pg-app-win-header .close').hide();

            if (_this.onFloatingChanged) {
                _this.onFloatingChanged();
            }

            $(_this.app_win.window).off('.qw').on('resize.qw', function () {
                if (view.view.onResize) view.view.onResize();
            })

            if (view.view.onResize) view.view.onResize();
        }

        if(!_this.app_win) {
            openPanelInExternalWindow(_this.$element, function (win, $lc, app_window) {
                _this.app_win = app_window;

                after()
            }, {}, {
                config: {
                    pg_win_id: key
                }
            })
        } else {
            //replace win content
            _this.app_win.show(); //in case it was hidden before
            $(_this.app_win.window.document.body).find('.pg-quick-win-floating').detach();
            $(_this.app_win.window.document.body).find('#layout-container').append(_this.$element);
            after();
        }
    }

    if(floating) {
        var current_win = pgQuickWindowManager.getWindow(key);
        if(current_win && current_win.app_win) {
            //will replace
            this.app_win = current_win.app_win;
            current_win.app_win = null;
        }
    }

    this.showForPgel = function(pgel) {
        this.visible = true;
        if(floating) {
            handleFloating();
            return;
        }
        var $body = get$Body(null, pgel);
        if(!this.$element.parent().is($body)) {
            this.$element.appendTo($body);
        }
        if(position) {
            position.destroy();
        }
        position = new PgPositionNextToPgel(this.$element, pgel, view);
        pgUIViewManager.updateVisibilityInArea($content);
        if(view.view.onResize) view.view.onResize();
    }

    this.showFor$El = function($el, previous_position, distance, top) {
        this.visible = true;

        if(floating) {
            handleFloating();
            return;
        }

        var pv = getPageViewOfElement($el);

        var $body = pv ? pv.getPageParent$Body() : get$Body($el);
        if(!this.$element.parent().is($body)) {
            this.$element.appendTo($body);
        }

        if(position) {
            position.destroy();
        }

        var pos = pgQuickWindowManager.getPosition(key);

        if(previous_position && pos) {
            this.showAtPosition(pos.x, pos.y, size.w, false);
        } else {

            if(pv) {
                position = new PgPositionNextToPage$El(pv, this.$element, $el, view, distance);
            } else {
                position = new PgPositionNextTo$El(this.$element, $el, view, distance, top);
            }
        }
        pgUIViewManager.updateVisibilityInArea($content);
        if(view.view.onResize) view.view.onResize();
    }

    this.showCover = function(side) {
        this.visible = true;

        var $body = get$Body();
        if(!this.$element.parent().is($body)) {
            this.$element.appendTo($body);
        }
        position = new PgPositionNextTo$El(this.$element, $body, view, 0, side || 'cover_right');
        pgUIViewManager.updateVisibilityInArea($content);
        if(view.view.onResize) view.view.onResize();
    }


    this.showAtRandomPosition = function() {
        this.visible = true;

        var pos = pgQuickWindowManager.getPosition(key);
        if(!pos) {
            pos = {};
            pos.x = 100 + parseInt(Math.random() * ($('body').width() / 4));
            pos.y = 100 + parseInt(Math.random() * ($('body').height() / 4));
        }
        this.showAtPosition(pos.x, pos.y, size.w, false);
    }

    this.showAtPosition = function(x, y, width, whole) {
        this.visible = true;

        if(whole === undefined) whole = true;
        this.$element.appendTo(get$Body());
        if(!width) width = this.$element.width();
        this.$element.css({left: x + 'px', top: y + 'px', margin: 'auto', width: width + 'px'});
        pgUIViewManager.updateVisibilityInArea($content);
        if(view.view.onResize) view.view.onResize();
        this.dragMoverResizer.ensureVisible(whole, true);
    }

    var onWindowResized = function() {
        _this.dragMoverResizer && _this.dragMoverResizer.ensureVisible(false, false);
    }

    $(window).on('resize', onWindowResized);

    this.close = this.destroy = function() {
        if(this.onDestroy) this.onDestroy(this);

        if(position) {
            position.destroy();
        }

        view.view.destroy();

        this.$element.get(0).removeEventListener('click', onClicked, true);
        this.$element.remove();

        if(this.app_win) {
            this.app_win.close();
        }

        $(window).off('resize', onWindowResized);

        this.visible = false;

        pgQuickWindowManager.deregister(key);
    }

    this.show = function(whole) {
        this.visible = true;

        if(this.app_win) {
            this.app_win.show();
        }

        pg$Show(this.$element);
        var resized = false;
        this.dragMoverResizer && this.dragMoverResizer.ensureVisible(whole, true, function(changed, changed_size) {
            resized = changed_size;
        });
        pgUIViewManager.updateVisibilityInArea($content);
        if(resized) {
            if(view.view.onResize) view.view.onResize();
            if(this.onResize) this.onResize();
        }

        this.onShow && this.onShow();
    }

    this.hide = function(close_all) {
        this.visible = false;

        if(this.app_win) {
            this.app_win.hide();
        }
        pg$Hide(this.$element);
        pgUIViewManager.updateVisibilityInArea($content);

        this.onHide && this.onHide(close_all);
    }

    var $header = this.$element.find('.pg-quick-win-header');

    $header.on('dblclick', function(e) {
        _this.show(true);
    })

    //if(!static_win) {

        this.dragMoverResizer = new PgMoverAndResizer(this.$element, static_win ? 'dummy' : $header, this.$element.find('.pg-win-resizer'), 'body');

        this.dragMoverResizer.onResize = function (w, h) {
            if (this.app_win) return;

            if (view.view.onResize) view.view.onResize();
            pgQuickWindowManager.rememberSize(key, w, h);
            if (_this.onResize) _this.onResize();
            _this.wasResized = true;
        }

        this.dragMoverResizer.onMove = function (x, y) {
            if (this.app_win) return;

            if (_this.onMove) _this.onMove();
            pgQuickWindowManager.rememberPosition(key, x, y);
            if (position) {
                position.destroy();
                position = null;
            }
            _this.wasMoved = true;
        }

        this.dragMoverResizer.onMoveDrag = function (x, y) {
            if (_this.onMoveDrag) _this.onMoveDrag();
        }
  //  }

    this.setFocused = function(f) {
        if(this.pinned) return;

        if(f) {
            this.$element.addClass('focused');
        } else {
            this.$element.removeClass('focused');
        }
    }

    var onClicked = function() {
        if(_this.pinned) return;
        pgQuickWindowManager.focus(_this);
    }

    this.$element.get(0).addEventListener('click', onClicked, true);

    pgQuickWindowManager.register(key, this);
}


var PgQuickWindowManager = function() {
    var current = {};
    var _this = this;

    var remember_in_settings_map = {}

    var sizes = {};
    var positions = {};

    var focus_list = [];

    this.setRememberInSettings = function(key) {
        remember_in_settings_map[key] = true;
    }

    this.rememberSize = function(key, w, h) {
        sizes[key] = {w: w, h: h};
    }

    this.getSize = function(key, def_w, def_h) {
        return sizes[key] || {w: def_w, h: def_h};
    }

    this.rememberPosition = function(key, x, y) {
        positions[key] = {x: x, y: y};
        if(remember_in_settings_map[key]) {
            pinegrow.setSetting('qwin_pos_' + key, JSON.stringify(positions[key]))
        }
    }

    this.getPosition = function(key) {
        if(remember_in_settings_map[key]) {
            var p = pinegrow.getSetting('qwin_pos_' + key);
            if(p) {
                try {
                    positions[key] = JSON.parse(p);
                } catch(err) {}
            }
        }
        return positions[key] || null;
    }

    this.register = function(key, win) {
        if(current[key]) {
            current[key].destroy();
        }
        current[key] = win;
        if(!win.pinned) {
            this.focus(win);
        }
    }

    var focusLast = function() {
        var idx = focus_list.length - 1;
        while(idx >= 0) {
            if(focus_list[idx].$element.is(':visible')) {
                focus_list[idx].setFocused(true);
                return;
            }
            idx--;
        }
    }

    this.deregister = function(key) {
        var win = current[key] || null;
        if(win) {
            current[key] = null;
            var idx = focus_list.indexOf(win);
            if (idx >= 0) {
                focus_list.splice(idx, 1);
            }
            focusLast();
        }
    }

    var closeWin = function(win, close_all) {
        if(win.hideOnClose) {
            win.hide(close_all);
        } else {
            win.destroy();
        }
    }

    this.isOpen = function(key) {
        return current[key] ? true : false;
    }

    this.getWindow = function(key) {
        return current[key] || null;
    }

    this.close = function(key, close_all) {
        if(current[key]) {
            closeWin(current[key], close_all);
        }
    }

    this.focus = function(win, no_add) {
        var idx = focus_list.indexOf(win);
        if (idx >= 0) {
            focus_list.splice(idx, 1);
        }
        if(focus_list.length) {
            focus_list[focus_list.length - 1].setFocused(false);
        }
        focus_list.push(win);
        win.setFocused(true);
    }

    this.closeLast = function() {
        var w = this.hasClosableWindows();
        if(w) {
            closeWin(w);
        }
    }

    this.hasWindows = function() {
        return focus_list.length > 0;
    }

    this.hasClosableWindows = function() {
        for(var i = focus_list.length - 1; i >= 0; i--) {
            if(focus_list[i].isClosable && focus_list[i].visible) return focus_list[i];
        }
        return null;
    }

    this.closeAll = function() {
        var l = [];
        $.each(current, function(key, win) {
            l.push(key);
        })
        l.forEach(function(key) {
            _this.close(key, true);
        })
    }
}

var pgQuickWindowManager = new PgQuickWindowManager();





//Modals
function makeDialog(title, cancel, ok, body) {
    if (typeof body == 'undefined') body = '';
    var bstr = typeof body == 'string' ? body : '';

    var html = '<div class="modal-content">\
                <div class="modal-header">\
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>\
                    <h4 class="modal-title">' + title + '</h4>\
                </div>\
                <div class="modal-body">' + bstr + '\
                </div>\
                <div class="modal-footer"><p class="pull-left"></p>';
    if (cancel) {
        html += '<button type="button" class="btn btn-default btn-sm cancel">' + cancel + '</button>';
    }
    if (ok) {
        html += '<button type="button" class="btn btn-primary btn-sm ok">' + ok + '</button>';
    }
    html += '</div>\
            </div>';

    var $d = $('<div/>', {class: "modal-dialog crsa-dialog-nonmodal"}).html(html);
    if (typeof body == 'object') {
        $d.find('.modal-body').append(body);
    }
    return $d;
}

function makeAndShowDialog(title, cancel, ok, body, onCancel, onOk, validate, show_in_center) {
    var $dialog = makeDialog(title, cancel, ok, body);
    $('body').append($dialog);
    var x = 100;//$body.width() - $dialog.width() - 100;
    var y = 100;//$body.height() - $dialog.height() - 100;
    if (show_in_center) {
        x = ($('body').width() / 2) - ($('.modal-dialog').width() / 2 )
        y = 10;
    }
    $dialog.css('top', y + 'px').css('left', x + 'px');
    $dialog.draggable({handle: '.modal-header'})
        .on('dragstart', function (e, ui) {
            $.fn.crsapages('showOverlays');
        })
        .on('dragstop', function () {
            $.fn.crsapages('showOverlays', true);
        });

    $dialog.find('button.close,button.cancel').click(function () {
        if (onCancel) onCancel();
        $dialog.remove();
    });
    $dialog.find('button.ok').click(function () {
        if (!validate || validate()) {
            if (onOk) onOk();
            $dialog.remove();
        }
    });
    $dialog.on('hidden.bs.modal', function () {
        $dialog.remove();
    });
    return $dialog;
}

function setDialogNotice($d, text, cls) {
    var $p = $d.find('.modal-footer > p');
    $p.html(text).attr('class', 'pull-left ' + cls);
}

function makeModalDialog(title, cancel, ok, body, onCancel, onOk, onBeforeShow) {
    if (typeof body == 'function') body = body();
    var $d = makeDialog(title, cancel, ok, body);
    $d.removeClass('crsa-dialog-nonmodal');

    var $o = $('<div/>', {class: 'modal aafade', tabIndex: "-1", role: "dialog"}).append($d);
    $o.find('button.close,button.cancel').click(function (e) {
        if (onCancel) onCancel(e);
        onCancel = null;
        $o.modal('hide');
    });
    $o.find('button.ok').click(function (e) {
        if (onOk) {
            if(onOk(e) === false) return;
        }
        onCancel = null;
        $o.modal('hide');
    });
    $o.on('hidden.bs.modal', function () {
        if (onCancel) onCancel();
        $o.remove();
    })
    if (onBeforeShow) onBeforeShow($o);
    $o.modal({backdrop: 'static'});

    var win = pgGetFocusedWindow();
    if(win && win.window !== window) {
        pg_app_windows[0].focus();
        /*
        var $body = $(win.window.document.body);
        $('.modal-backdrop').appendTo($body);
        $body.append($o);*/
    }
    return $o;
}

function makeModalDialogWhole(body) {
    if (typeof body == 'function') body = body();
    var $d = $(body);
    var $o = $('<div/>', {class: 'modal aafade', tabIndex: "-1", role: "dialog"}).append($d);
    $o.modal({backdrop: 'static', keyboard: false});
    return $o;
}


function showAlert(body, title, cancel, ok, onCancel, onOk, extraButton, onExtra) {
    if (!title) title = "Notice";
    if (!ok && !cancel) ok = "OK";
    var $d = makeModalDialog(title, cancel, ok, body, onCancel, onOk);

    if(extraButton) {
        $('<a href="#" class="btn btn-primary">' + extraButton + '</a>').appendTo($d.find('.modal-footer')).on('click', function(e) {
            e.preventDefault();
            if(onExtra) onExtra(e);
            $d.modal('hide');
        });
    }
    crsaHandleExternalLinks($d);

    return $d;
}


function crsaHandleExternalLinks($d, func) {
    if (isApp()) {
        $d.on('click', 'a.external', function (e) {
            e.preventDefault();
            var url = $(this).attr('href');

            if(url.startsWith('help://')) {
                $('body').trigger('click');
                pinegrow.showDocsTopic(url.replace('help://', ''));
            } else {
                var gui = require('nw.gui');
                gui.Shell.openExternal(url);

                if (func) func(url);
            }

            return false;
        });
    }
}

function showNotice(message, title, key, done, only_once, force, not_checked_by_default, with_cancel, extraButton, onExtra, options) {
    options = $.extend({}, {
        cancel_label: 'Cancel',
        ok_label: 'Ok',
        got_it_label: 'Got it'
    }, options || {});

    var key = 'notice_hide_' + key;
    if (!force) {
        if (key in localStorage && localStorage[key] == '1') {
            if (done) done(false);
            return;
        }
        if (only_once && key in localStorage) {
            if (done) done(false);
            return;
        }
    }
    var $chk = $('<label class="pull-left control-label"><input type="checkbox" ' + (not_checked_by_default ? '' : 'checked="checked"') + '> Don\'t show this notice again</label>');

    var onClose = function () {
        if (done) done(true);
        if ($chk.find('input').is(':checked')) {
            localStorage[key] = '1';
        } else {
            localStorage[key] = '0';
        }
    }

    var onCancel = function() {
        if(with_cancel) {

        } else {
            onClose();
        }
    }

    var $d = showAlert(message, title, with_cancel ? options.cancel_label : null, with_cancel ? options.ok_label : options.got_it_label, onCancel, onClose, extraButton, onExtra);
    if (!only_once) {
        $d.find('.modal-footer').prepend($chk);
    }
    return $d;
}

function showPrompt(notice, title, value, placeholder, onCancel, onOk, cancelLabel, okLabel, recent_values, validate) {
    var $b = $('<form role="form" autocomplete="off">\
        <div class="form-group">\
        <label for="dlgInput">' + notice + '</label>\
        <input type="text" class="form-control" id="dlgInput" placeholder="' + placeholder + '"  spellcheck="false">\
        <p class="help-block"></p>\
        </div>\
        </form>');

    var $group = $b.find('.form-group');
    var $help = $b.find('.help-block');

    pg$Hide($help);

    if(recent_values && recent_values.length) {
        var $r = $(`<div><p>Select a recent value:</p><ul></ul></div>`).appendTo($b);
        var $rul = $r.find('ul');
        recent_values.forEach(function(val) {
            $li = $(`<li><a href="#" style="word-break: break-all;">${val}</a></li>`);
            $rul.append($li);
            $li.find('a').on('click', function(e) {
                e.preventDefault();
                onOk(val);
                $modal.modal('hide');
            })
        })
    }

    var $input = $b.find('input');
    var $form = $b;
    $form.on('submit', function (e) {
        e.preventDefault();

        if(has_error) {
            pinegrow.showQuickError('The value is not correct. ' + has_error);
            return;
        }
        var close = true;
        if (onOk) {
            var r = onOk($input.val());
            if(r === false) {
                close = r;
            }
        }
        if(close) {
            $modal.modal('hide');
        }
    });
    if (value) $input.val(value);

    var has_error = false;

    var validateValue = function(val) {
        if(!validate) return true;
        var error = validate(val);
        has_error = error;
        if(error) {
            $help.html(error);
            pg$Show($help);
            $group.addClass('has-error');
            return false;
        } else {
            pg$Hide($help);
            $group.removeClass('has-error');
            return true;
        }
    }

    if(validate) {
        $input.on('input', function(e) {
            var val = e.target.value;
            validateValue(val);
        })
    }
    var $modal = showAlert($b, title, cancelLabel || "Cancel", okLabel || "Ok", onCancel, function () {
        var val = $input.val();
        if (onOk) {
            if(!validateValue(val)) {
                pinegrow.showQuickError('The value is not correct.');
                return false;
            }
            return onOk(val);
        }
    });
    $modal.on('shown.bs.modal', function () {
        $input.focus();
    })
    $input.focus();
    return $modal;
}

var CrsaCollapsibleSections = function ($list) {
    this.show = function (getSectionDef, updateUsage) {
        $list.find('li.section > div').on('click', function (e) {
            var $section = $(e.delegateTarget).parent();
            var sec_def = getSectionDef($section);
            var $ul = $section.find('>ul');

            if ($section.hasClass('section-closed')) {
                slideToggle($ul, function () {
                    $section.removeClass('section-closed');
                    if (sec_def) {
                        sec_def.closed = false;
                        var k = 'sec_open_' + sec_def.key;
                        localStorage[k] = '1'; //open
                    }
                })
            } else {
                slideToggle($ul, function () {
                    $section.addClass('section-closed');
                    if (sec_def) {
                        sec_def.closed = true;
                        var k = 'sec_open_' + sec_def.key;
                        localStorage[k] = '0'; //closed
                    }
                });
            }
            if (updateUsage) updateUsage($section);
        });

        if (pinegrow.getSelectedElement() && updateUsage) {
            updateUsage();
        }
    }
}

var CrsaActionsPanel = function (tabName) {

    var currnetTabName = tabName || "ACT";
    var currentFactoryLibSections = null;
    var selectedPgel = null;
    var selected$el = null;
    var selectedElement = null;
    var $container;

    this.showAssignedActions = true;
    var _this = this;

    var hasAction = function (pgel, def) {
        if (def.has_action) {
            return def.has_action(pgel);
        }
        return def.attribute && pgel.hasAttr(def.attribute);
    }

    this.show = function ($lib) {
        $container = $lib;
        var filter = null;
        var $header = $lib.find('>.header');
        var $input = $('<input/>', {class: 'form-control filter-form', placeholder: 'search', spellcheck: "false"}).appendTo($header);
        crsaAddCancelSearch($input, 'top: 16px;right: 47px;');

        var $tags = $('<div/>', {class: 'form-tags'});//.appendTo($header);

        /* var $cancel = $('<a/>', {class: 'btn btn-link', href: '#'}).html('&times;').appendTo($lib).on('click', function(e) {
         e.preventDefault();
         $input.val('').trigger('input');
         })*/
        var $manage = $('<a href="#" class="icon-action"><i class="fa fa-cog"></i></a>').appendTo($header);
        $manage
            .on('click', function (e) {
                var selectedCrsaPage = pinegrow.getSelectedPage();
                if (selectedCrsaPage || true) {
                    $.fn.crsacss('showFrameworkManager', selectedCrsaPage);
                    e.preventDefault();
                } else {
                    showAlert("Open a page first!");
                }
            })

        addTooltip($manage, 'Manage libraries and plugins for the selected page.');


        var $content = $lib;//.find('>.content');

        var $obj_desc = $('<ul/>', {class: 'props-desc-obj'}).appendTo($content);

        $('<ul class="selected-insert"><li class="section"><div><h2></h2></div><ul></ul><div class="insert-help">Right click for options.</div></li></ul>').appendTo($content).hide();

        var $list = $('<ul/>').appendTo($content);

        var $showhelp = $('<label class="css-opt-label actions-show-help-label"><input class="control-label" type="checkbox" value="1">&nbsp;<span>Show help texts</span></label>').appendTo($header);
        $showhelp.find('input').on('change', function (e) {
            var $ch = $(e.delegateTarget);
            if ($ch.is(':checked')) {
                $list.addClass('show-help-text');
                pinegrow.setSetting('actions-show-help-text', '1');
            } else {
                $list.removeClass('show-help-text');
                pinegrow.setSetting('actions-show-help-text', '0');
            }
        });

        if (pinegrow.getSetting('actions-show-help-text', '1') == '1') {
            $list.addClass('show-help-text');
            $showhelp.find('input').attr("checked", "checked");
        }

        var preview = null;

        var currentPage = null;

        var pageChanged = function (crsaPage) {
            var sections = null;
            var changed = false;
            selected$el = null;
            selectedPgel = null;

            currentPage = crsaPage;

            if (!crsaPage) {
                changed = true;
                //$manage.hide();
            } else {
                sections = crsaPage.getActionsSections();
                if (currentFactoryLibSections == null || sections == null) {
                    changed = true;
                } else {
                    if (currentFactoryLibSections.length != sections.length) {
                        changed = true;
                    } else {
                        for (var i = 0; i < sections.length; i++) {
                            if (sections[i] != currentFactoryLibSections[i]) {
                                changed = true;
                                break;
                            }
                        }
                    }
                }
            }
            if (changed) {
                updateList(sections);
            } else {
                updateUsage();
            }
        }

        $('body').on('crsa-page-selected', function (e, crsaPage) {
            pageChanged(crsaPage);
        });

        $('body').on('crsa-element-selected', function (e, pgel) {
            var selectedCrsaPage = pinegrow.getSelectedPage();
            selectedElement = pgel;
            var was_empty = false;
            if (selectedElement) {
                was_empty = selectedPgel == null;
                selected$el = selectedElement.get$DOMElement();//todo30 - pgel
                selectedPgel = selectedElement;
            } else {
                selected$el = null;
                selectedPgel = null;
            }
            if (currentPage != selectedCrsaPage) {
                pageChanged(selectedCrsaPage);
            } else {
                if (was_empty || !selectedElement) {
                    updateList();
                } else {
                    //updateList();
                    updateAssignedActions();
                    updateUsage();
                }
                //updateUsage();
                //updateList();
            }
            $.fn.crsa('showElementDescription', $obj_desc, selectedElement);
        });

        $('body').on('crsa-frameworks-changed', function (e) {
            updateList();
        });

        var matchTags = function (tags, selected_tags) {
            if (!selected_tags || selected_tags.length == 0) return true;
            if (!tags || tags.length == 0) return false;
            for (var i = 0; i < selected_tags.length; i++) {
                var found = false;
                for (var j = 0; j < selected_tags[i].length; j++) {
                    if (tags.indexOf(selected_tags[i][j]) >= 0) {
                        found = true;
                        break;
                    }
                }
                if (!found) return false;
            }
            return true;
        }

        var selected_tags = [];

        var updateTags = function () {
            var tags = [
                {
                    cat: 'change',
                    text: 'changes',
                    values: [
                        {value: 'element', text: 'Replaces element.'},
                        {value: 'content', text: 'Replaces content.'},
                        {value: 'href', text: 'Replaces href attribute.'}
                    ]
                },
                {
                    cat: 'returns',
                    text: 'returns',
                    values: [
                        {value: 'string', text: 'Returns string.'},
                        {value: 'html', text: 'Returns html.'},
                        {value: 'url', text: 'Returns url.'}
                    ]
                }
            ]
            var html = '';

            for (var i = 0; i < tags.length; i++) {
                html += '<div><b>' + tags[i].text + '</b>';
                for (var j = 0; j < tags[i].values.length; j++) {
                    html += '<a href="' + tags[i].cat + ':' + tags[i].values[j].value + '">' + tags[i].values[j].value + '</a>';
                }
                html += '</div>';
            }
            $tags.html(html);

        }

        // updateTags();
        var assigned_actions_section = {
            name: 'Assigned actions',
            framework: {
                name: 'Shortcuts',
                show_in_action_tab: currnetTabName
            },
            getComponentTypes: function () {
                return [];
            }
        }

        function showFields(selectedElement, def, $item, $scrollParent) {
            var sections = def.sections ? Object.values(def.sections) : [];

            if (def.on_before_show_fields) {
                def.on_before_show_fields(currentPage, sections, selectedElement, def);
            }

            var values = {};

            try {
                values = selectedElement ? getValuesForObject(selectedElement, sections) : {};
            }
            catch (err) {
                console.log(err);
            }

            var $props = $('<div/>', {class: 'action-fields'});

            var count = sections.length;

            var on_fields_created = [];

            $.each(sections, function (i, s) {
                if ((s.hasOwnProperty("show") && !s.show) || !s.name) return true;

                if (i > 0) {
                    $('<div class="crsa-field crsa-field-label"><label>' + s.name + '</label></div>').appendTo($props);
                    //$('<h3/>').html(s.name).appendTo($props);
                }

                var $c = $('<div/>').appendTo($props);

                var createFields = function (fields) {
                    $.each(fields, function (fn, fdef) {
                        var $field;
                        if (fdef.type == 'custom') {
                            $field = fdef.show($c, selectedElement, fn, fdef, values);
                        } else {
                            $field = $.fn.crsa('addInputField', $c, selectedElement, fn, fdef, values, false, $scrollParent);
                        }
                        if (fdef.on_fields_created) {
                            on_fields_created.push({
                                func: fdef.on_fields_created,
                                obj: selectedElement,
                                field: $field,
                                def: fdef,
                                name: fn,
                                default_value: fdef.default_value || null
                            });
                        }
                        pinegrow.validateField(selectedElement, fn, values.hasOwnProperty(fn) ? values[fn] : null, fdef, $field, values);//check30
                    });
                }

                createFields(s.fields);

                var dynamic_fields = {};
                currentPage.callFrameworkHandler("on_show_action_fields", dynamic_fields, def, selectedElement);//todo30 sel is pgel

                createFields(dynamic_fields);

                // Use selectize
                // UseSelectize();
                // Use select2
                //useSelete2();
            });

            for (var i = 0; i < on_fields_created.length; i++) {
                var val = values.hasOwnProperty(on_fields_created[i].name) ? values[on_fields_created[i].name] : null;
                if (val === null && on_fields_created[i].default_value) val = on_fields_created[i].default_value;
                on_fields_created[i].func(
                    on_fields_created[i].obj,
                    on_fields_created[i].name,
                    val,
                    on_fields_created[i].def,
                    on_fields_created[i].field,
                    values);
            }
            on_fields_created = null;

            $props.insertAfter($item.find('>name'));
            //$item.append($props);
            return $props;
        }

        var removeFields = function ($item) {
            $item.find('>.action-fields').remove();
        }


        var sections_map = [];
        var actions_map = [];

        var getSectionDef = function ($li) {
            return sections_map[parseInt($li.attr('data-section-index'))];
        }

        var getActionDef = function ($li) {
            return actions_map[parseInt($li.attr('data-action-index'))];
        }

        var getHTMLForAction = function (def, cat_match) {
            var html = '';
            var extraname = '';
            var helptext = '';
            var tags = '';
            var tags_array = null;
            var icons = '';

            icons = '<icons>';

            if (def.framework && def.framework.get_preview_for_action) {
                icons += '<i class="icon icon-wand action-magic only-active"></i>&nbsp;<i class="fa fa-code show-code"></i>';
            }
            icons += '<i title="Remove action from the element" class="fa fa-times remove-action only-active"></i>&nbsp;</icons>';

            if (def.meta) {
                extraname = def.meta.extra_name ? '<small> / ' + def.meta.extra_name + '</small>' : '';
                helptext = def.meta.helptext ? def.meta.helptext : '';
                if (def.meta.helplink) {
                    helptext += '<a href="' + def.meta.helplink + '" class="external"><i class="fa fa-question-circle"></i></a>';
                }
                if (def.meta.tags && def.meta.tags.length) {
                    tags = def.meta.tags.join(' ');
                    tags_array = tags;
                }
            }

            if (filterRegEx) {
                if (!cat_match && !def.name.match(filterRegEx) && !extraname.match(filterRegEx) && !tags.match(filterRegEx)) {
                    return '';
                }
            }
            if (!matchTags(tags_array, selected_tags)) return '';

            //var $item = $('<li/>', { 'class' : 'crsa-action crsa-action-on'}).html('<name>' + def.name + extraname + icons + '</name>');

            //$item.data('crsa-factory-def', def); //!!!!!

            actions_map.push(def);

            html += '<li data-action-index="' + (actions_map.length - 1) + '" class="crsa-action crsa-action-on"><name>' + def.name + extraname + icons + '</name>';

            var has_this_action = false;

            if (selectedPgel) {
                if (hasAction(selectedPgel, def)) {
                    has_this_action = true;
                }
            }

            if (tags.length) {
                //html += '<div class="action-tags">' + tags + '</div>';
            }
            if (helptext.length) {
                html += '<p class="help-text">' + helptext + '</p>';
            }

            html += '</li>';
            //$item.appendTo($dest);
            return html;
        }

        var filterRegEx;

        var updateAssignedActions = function () {
            if (!_this.showAssignedActions) return;

            var selectedCrsaPage = pinegrow.getSelectedPage();
            if (!selectedCrsaPage || !selectedPgel) return;
            var used_actions = selectedCrsaPage.getAllActionTypes(selectedPgel);
            var html = '';
            var $as = $list.find('> .assigned-actions');
            if (used_actions.length) {
                for (var i = 0; i < used_actions.length; i++) {
                    if (used_actions[i].framework.show_in_action_tab == currnetTabName) {
                        html += getHTMLForAction(used_actions[i], false);
                    }
                }
                $as.show();
            } else {
                $as.hide();
            }
            pgRemoveMultiselects($as);
            $as.find('>ul').html(html);
            crsaHandleExternalLinks($as);
        }

        var updateList = function (sections) {
            var selectedCrsaPage = pinegrow.getSelectedPage();

            pgRemoveMultiselects($list);
            $list.html('');
            //return;
            filter = $input.val();
            filterRegEx = filter && filter.length > 0 ? new RegExp(escapeRegExp(filter), 'i') : null;

            var selected_tags = null;//[['t:post', 'comment'], ['settings']];

            /*   if(filterRegEx) {
             $cancel.show();
             } else {
             $cancel.hide();
             }*/

            if (!selectedCrsaPage) {
                currentFactoryLibSections = null;
                return;
            }
            sections_map = [];
            actions_map = [];

            if (!sections) sections = selectedCrsaPage.getActionsSections();
            currentFactoryLibSections = sections;

            var selectedElement = pinegrow.getSelectedElement();

            if (!selectedElement) {
                $list.html('<div class="alert alert-info">Click on any element on the page to edit its actions or to add new HTML elements to the page.</div>');
                return;
            }


            var displayed_sections = sections;

            if (selectedPgel) {
                /*var used_actions = selectedCrsaPage.getAllActionTypes(selected$el, selectedPgel);
                 if(used_actions.length) {
                 assigned_actions_section.getComponentTypes = function() {
                 return [];
                 }

                 }*/

            }
            if (_this.showAssignedActions) {
                displayed_sections = [assigned_actions_section].concat(sections);
            }

            var html = '';

            $.each(displayed_sections, function (i, sec_def) {
                if (sec_def.framework.show_in_action_tab != currnetTabName) return;
                var cat_match = true;
                if (filterRegEx) cat_match = sec_def.name.match(filterRegEx);

                var section_icons = '<i class="fa fa-caret-right closed"></i><i class="fa fa-caret-down opened"></i>';

                if (sec_def != assigned_actions_section) {
                    crsaPopulateSectionClosedStatus(sec_def);
                }


                var $tit;
                //$tit = $('<li/>', {class: 'section' + (sec_def.closed ? ' section-closed' : '')}).html('<div><h2>' + sec_def.name + '<small> / ' + sec_def.framework.name + '</small>' + section_icons + '</h2></div>').appendTo($list);

                sections_map.push(sec_def);

                var inner_html = '';
                $.each(sec_def.getComponentTypes(), function (i, eltype) {

                    var def = eltype;
                    if (def) {
                        inner_html += getHTMLForAction(def, cat_match);
                    }

                });
                if (inner_html.length || true) {

                    html += '<li data-section-index="' + (sections_map.length - 1) + '" class="' + 'section' + (sec_def.closed ? ' section-closed' : '') + (sec_def == assigned_actions_section ? ' assigned-actions' : '') + '"><div><h2>' + sec_def.name + '<small> / ' + sec_def.framework.name + '</small>' + section_icons + '</h2></div>';

                    //$tit.data('section-def', sec_def); //!!!!

                    //var $dest = $('<ul/>', {class:  ''}).appendTo($tit);

                    html += '<ul>';

                    html += inner_html;

                    html += '</ul></li>';
                }
            });

            $list.get(0).innerHTML = html;

            var dbl_timer = null;
            var tooltip_active = false;

            var last_previewed_def = null;

            updateAssignedActions();
            // updateUsage();

            crsaHandleExternalLinks($list);

            var collapsibleSections = new CrsaCollapsibleSections($list);
            collapsibleSections.show(getSectionDef, updateUsage);
        }

        var updateUsage = function ($div) {
            if (!$div) $div = $container;
            //$container.
            var $crsaPanel = $div;
            if (!$div.hasClass('crsa-panel')) {
                $crsaPanel = $div.closest('.crsa-panel');
            }
            $div.find('li.has-data').removeClass('has-data');
            $div.find('li.crsa-action').each(function (i, a) {
                var $li = $(a);
                pgRemoveMultiselects($li);
                $li.find('.action-fields').remove();
                var def = getActionDef($li);//$li.data('crsa-factory-def');
                if (selectedPgel) {
                    if (hasAction(selectedPgel, def)) {
                        $li.addClass('crsa-action-on');
                        showFields(selectedElement, def, $li, $crsaPanel.children('.content'));
                        $li.closest('.section').addClass('has-data');
                    } else {
                        $li.removeClass('crsa-action-on');
                        removeFields($li);
                    }
                } else {
                    $li.removeClass('crsa-action-on');
                }
            });
            $div.find('.section').each(function (i, sec) {
                var $sec = $(sec);
                var $ul = $sec.find('>ul');
                if ($ul.get(0).childNodes.length) {
                    $sec.show();
                } else {
                    $sec.hide();
                }
            });
        }

        var addEventsToList = function () {
            var list = $list.get(0);
            list.addEventListener('mouseenter', function (event) {
                var $target = $(event.target);
                if ($target.is('i.show-code')) {
                    if (selectedPgel) {
                        var $li = $target.closest('li');
                        var def = getActionDef($li); //$li.data('crsa-factory-def');
                        var code = def.framework.get_preview_for_action(selectedPgel, def);
                        //var $c = $('<pre>' + code + '</pre>');

                        var $el = crsaFuncs.createPreviewElementFromDefinition(def);
                        if (!$el) {
                            pinegrow.showPreview($li, $('<pre>' + escapeHtmlCode(code) + '</pre>'), 'cm-preview actions-preview', 300);
                        } else {
                            pinegrow.showPreview($li, $el, 'actions-preview', 300, code);
                        }
                    }
                }
            }, true);

            list.addEventListener('mouseleave', function (event) {
                var $target = $(event.target);
                if ($target.is('i.show-code')) {
                    pinegrow.hidePreview();
                }
            }, true);

            list.addEventListener('contextmenu', function (e) {
                var $target = $(e.target);
                if ($target.is('name') || $target.parent().is('name')) {
                    e.stopPropagation();
                    e.preventDefault();

                    var $li = $target.closest('li');
                    var def = getActionDef($li);

                    var $menu = new CrsaContextMenu(null, $li);

                    var name = getElementName(selected$el);
                    var action_name = '<b>' + def.name + '</b>';

                    if (selected$el && selectedPgel) {

                        if (hasAction(selectedPgel, def)) {
                            $menu.add("Remove action from selected element", null, null, 'header');
                            $menu.add("Remove " + action_name + " from <b>" + name + "</b>", null, function () {
                                //$target.closest('name').click();
                                addAndRemoveAction($target);
                            });
                        } else {
                            $menu.add("Add action to selected element", null, null, 'header');
                            $menu.add("Add " + action_name + " to <b>" + name + "</b>", null, function () {
                                $target.closest('name').click();
                            });
                            if (def.not_placeable && pgf.edit_html) {

                                $menu.add("", null, null, 'divider');
                                $menu.add("Can\'t create new HTML element: " + def.not_placeable, null, null, 'header');

                            }
                        }
                        if (def.not_placeable || !def.code || !pgf.edit_html) {

                        } else {
                            var am = crsaFuncs.findActionMenuForInsertingDefIntoEl(def, selectedPgel);

                            $menu.add("", null, null, 'divider');
                            $menu.add("Create new HTML element with this action", null, null, 'header');

                            $menu.add("Prepend to <b>" + name + "</b>", null, function () {
                                crsaFuncs.insertThroughActionMenu(am, selected$el, def, false, true);
                            });
                            $menu.add("Append to <b>" + name + "</b>", null, function () {
                                crsaFuncs.insertThroughActionMenu(am, selected$el, def, false, false);
                            });
                            $menu.add("Insert before <b>" + name + "</b>", null, function () {
                                crsaFuncs.insertBeforeOrAfter(selected$el, def, false, false);
                            });
                            $menu.add("Insert after <b>" + name + "</b>", null, function () {
                                crsaFuncs.insertBeforeOrAfter(selected$el, def, false, true);
                            });
                            $menu.add("Replace <b>" + name + "</b>", null, function () {
                                crsaFuncs.replaceElement(selected$el, def);
                            });
                        }

                    } else {
                        if(pgf.edit_html) {
                            $menu.add('First select an existing element on the page and then use the right click to place the new element.', null, function () {
                            }, 'header');
                        }
                    }

                    $menu.showAt(e.pageX, e.pageY);
                    return false;
                }

            }, true);

            var addAndRemoveAction = function ($target, only_add) {
                var $li = $target.closest('li');
                var def = getActionDef($li);//$li.data('crsa-factory-def');
                var pos_top = $li.position().top;

                //event.preventDefault();
                //event.stopImmediatePropagation();
                var collection = pinegrow.getCollection();

                var msg;
                var opname;

                collection.forEachElement(function (selectedPgel, i, total) {

                    if (selectedPgel) {
                        var elname = selectedPgel.getName();
                        var problems = new pgParserSourceProblem(selectedPgel, null, def.ignore_lock ? true : false);
                        var selectedCrsaPage = selectedPgel.getPage();

                        if (!selectedPgel) {
                            problems.add('element', elname, 'change');
                        }
                        if (!problems.ok()) {
                            showAlert(problems.toString(), "Can't edit this element");
                            return;
                        }

                        if (!hasAction(selectedPgel, def)) {
                            var can_add = true;
                            if (def.on_can_add_action) {
                                if (!def.on_can_add_action(selectedPgel, selectedCrsaPage, def)) {//todo30 - check handlers, last $el arg removed
                                    can_add = false;
                                }
                            }
                            if (can_add) {
                                if (!canMakeChange(selectedPgel, 'add_action', def)) return;

                                willMakeChange(selectedCrsaPage, "Add action / " + elname);

                                opname = "Add action / " + def.name;

                                if (!msg) {
                                    msg = 'Action <b>' + def.name + '</b> was added to <b>' + collection.getName() + '</b>';
                                }

                                var modified_pgel = $.fn.crsa('addActionToElement', selectedPgel, def, selectedCrsaPage);

                                if (modified_pgel == selectedPgel || true) {
                                    showFields(selectedElement, def, $li, $li.closest('.content'));
                                    $li.addClass('crsa-action-on');
                                }

                                pinegrow.stats.using('action.' + (def.type) || 'unknown');
                            }
                        } else {
                            if (only_add) {
                                if (i == 0) {
                                    pinegrow.showQuickMessage('Use <i class="fa fa-times"></i> icon to remove the action from the element.', 4000, false, 'error');
                                }
                                return;
                            }

                            if (!canMakeChange(selectedPgel, 'remove_action', def)) return;

                            willMakeChange(selectedCrsaPage, "Remove action / " + def.name);

                            opname = "Remove action / " + elname;

                            var modified_pgel = $.fn.crsa('removeActionFromElement', selectedPgel, def, selectedCrsaPage);
                            if (!msg) {
                                msg = 'Action <b>' + def.name + '</b> was removed from <b>' + collection.getName() + '</b>';
                            }

                            if (modified_pgel == selectedPgel || true) {
                                removeFields($li);
                                $li.removeClass('crsa-action-on');
                            }
                        }
                    }
                })
                if ($li.closest('.assigned-actions').length) {
                    //clicked on assigned actions, update list
                    updateUsage();
                } else {
                    //click on list, update assigned
                    updateAssignedActions();
                    updateUsage($list.find('.assigned-actions'));
                }
                var new_top = $li.position().top;
                var $content = $li.closest('.content');
                var st = $content.scrollTop();
                st = st - (pos_top - new_top);
                $content.scrollTop(st);

                pinegrow.changeManager.didChange(collection, opname);

                pinegrow.showQuickMessage(msg);
            }

            list.addEventListener('click', function (event) {
                var $target = $(event.target);

                if ($target.is('i.show-code')) {
                    if (selectedPgel) {
                        var selectedCrsaPage = pinegrow.getSelectedPage();
                        var $li = $target.closest('li');
                        var def = getActionDef($li);//$li.data('crsa-factory-def');
                        pinegrow.hidePreview();
                        event.preventDefault();
                        event.stopImmediatePropagation();
                        selectedCrsaPage.callFrameworkHandler('on_action_show_code_clicked', selectedPgel, def, $li);
                    }
                } else if ($target.is('i.remove-action')) {
                    addAndRemoveAction($target);
                    event.preventDefault();
                    event.stopImmediatePropagation();
                } else if ($target.is('i.action-magic')) {
                    if (selectedPgel) {
                        var selectedCrsaPage = pinegrow.getSelectedPage();
                        var $li = $target.closest('li');
                        var def = getActionDef($li);//$li.data('crsa-factory-def');
                        event.preventDefault();
                        event.stopImmediatePropagation();
                        if (selectedPgel && hasAction(selectedPgel, def)) {
                            selectedCrsaPage.callFrameworkHandler('on_action_magic_clicked', selectedPgel, def, $li);
                        } else {
                            var code = selectedCrsaPage.callFrameworkHandler('on_action_magic_preview_clicked', selectedPgel, def, function (code) {
                                if (code) {
                                    pinegrow.showPreview($li, code, 'actions-preview', 300);
                                }
                            });
                        }
                    }
                } else if ($target.is('name') || $target.parent().is('name')) {
                    event.preventDefault();
                    event.stopImmediatePropagation();
                    addAndRemoveAction($target, true);
                }
            }, true);

            /*
             $list.find('li.crsa-action name')
             .on('contextmenu', function(e) {


             var $li = $(e.delegateTarget);
             var def = $li.data('crsa-factory-def');
             var fm = def.framework;

             e.stopPropagation();
             e.preventDefault();
             methods.hidePreview();

             var $menu = new CrsaContextMenu();

             var selectedElement = pinegrow.getSelectedElement();

             if(selectedElement && selectedElement.type == 'element') {
             var am = findActionMenuForInsertingDefIntoEl(def, selectedElement.data);

             var name = getElementName(selectedElement.data);

             $menu.add("Insert after <b>" + name + "</b>", null, function() {
             insertBeforeOrAfter(selectedElement.data, def, false, true);
             last_previewed_def = def;
             });
             }
             $menu.showAt(e.pageX, e.pageY);

             });*/
        }


        var def = null;

        var active_$el = null;

        addEventsToList();

        updateList();

        $input.on('input', function () {
            updateList();
        });

    }

}

var pgWindowManager = function (win, name, no_prefs_func) {

    var _this = this;
    this.win = win;
    this.name = name;

    if(win.width == 640 && win.height == 480 && no_prefs_func) {
        no_prefs_func(win);
    }

    //Let NWJS handle window state save & restore
    return;

    var getKey = function (key) {
        return 'win_' + _this.name + '_' + screen.width + 'x' + screen.height + '_' + key;
    }

    var x = localStorage[getKey('x')] || null;
    var y = localStorage[getKey('y')] || null;
    var w = localStorage[getKey('w')] || null;
    var h = localStorage[getKey('h')] || null;

    //if(no_prefs_func) no_prefs_func(win);

    //console.log('RESTORE WIN: ' + x + ', ' + y + ', ' + w + ', ' + h);

    try {
        var move = true;
        if (x === null && y === null && w === null && h === null) {
            if (no_prefs_func) no_prefs_func(win);
        } else {
            if (x !== null && y !== null) {
                x = parseInt(x);
                y = parseInt(y);
                if (x < 0) x = 0;
                if (y < 0) y = 0;
                move = true;
                //win.moveTo(x, y);
            }
            if (w !== null && h !== null) {
                w = parseInt(w);
                h = parseInt(h);
                if (w < 400) w = 400;
                if (h < 300) h = 300;

                if (x + 100 > screen.width) {
                    x = 0;
                    w = screen.width - x;
                    move = false;
                }
                if (y + 100 > screen.height) {
                    y = 80;
                    h = screen.height - y;
                    move = false;
                }
                if (move) {
                    win.moveTo(x, y);
                    win.resizeTo(w, h);
                } else {
                    if (no_prefs_func) no_prefs_func(win);
                }


            }
        }
    } catch (err) {
    }

    var save = function () {
        //debugger;
        if (_this.win.height > 100 && _this.win.x > -1000 && _this.win.y >= -20) {
            localStorage[getKey('x')] = _this.win.x;
            localStorage[getKey('y')] = _this.win.y;
            localStorage[getKey('w')] = _this.win.width;
            localStorage[getKey('h')] = _this.win.height;
        }
    }

    win.on('move', function (x, y) {
        save();
    })

    win.on('resize', function (w, h) {
        save();
    })

    win.on('closed', function () {
        win = null;
        _this.win = null;
    })
}


var pgPageTabs = function ($dest) {

    var _this = this;
    var list = [];

    var $me = $('<div class="file-tabs"><ul></ul></div>');
    var $me_ul = $me.find('ul');
    var $lis;
    var visible = false;

    var show_tooltips = true;

    $me.prependTo($dest).hide();

    this.addPage = function (crsaPage) {
        //debugger;
        list.push(crsaPage);
        updateDisplay();
    }

    this.removePage = function (crsaPage) {
        var idx = list.indexOf(crsaPage);
        list.splice(idx, 1);
        var vis = null;
        for (var n = 0; n < list.length; n++) {
            if (list[n].visible) {
                vis = true;
                break;
            }
        }
        if (!vis && list.length) {
            showPage(list[0], 0);
        }
        updateDisplay();
    }

    this.updateDisplay = function () {
        updateDisplay();
    }

    this.getHeight = function () {
        return visible ? 39 : 0;
    }

    this.updateHasChangesStatus = function (cp) {
        var has = cp.hasChanges() ? ' *' : '';
        var $li = $me_ul.find('li[data-url="' + cp.url + '"]').each(function (i, li) {
            $(li).find('>span').html(has);
        })
    }

    var updateDisplay = function () {
        $me_ul.html('');
        for (var n = 0; n < list.length; n++) {
            var cp = list[n];
            var $li = $('<li data-url="' + cp.url + '">' + cp.tab_name + '<span>' + (cp.hasChanges() ? ' *' : '') + '</span></li>').appendTo($me_ul).data('page-index', n);
            if (cp.visible) {
                $li.addClass('active');
            }
            if (cp.live_update) {
                $li.addClass('view');
            }
        }
        $lis = $me_ul.find('li');

        $lis.on('click', function (e) {
            e.preventDefault();
            var $li = $(e.delegateTarget);
            var cp = list[$li.data('page-index')];

            var multi = true;
            if (!e.ctrlKey && !e.metaKey) {
                multi = false;
                hideAll(cp);

                if (show_tooltips) {
                    crsaQuickMessage('CMD/CTRL + Click to show multiple pages', 3000);
                    show_tooltips = false;
                }
            }
            if (multi && cp.visible) {
                hidePage(cp);
            } else {
                showPage(cp);
            }
            if (!cp.rememberWidth) $.fn.crsapages('refresh');
        })
        var old_visible = visible;
        if (list.length > 1) {
            $me.show();
            visible = true;
        } else {
            $me.hide();
            visible = false;
        }
        if (old_visible != visible) {
            $.fn.crsapages('refresh');
        }
    }

    var showPage = function (crsaPage, idx) {
        if (typeof idx == 'undefined') idx = list.indexOf(crsaPage);
        if (!$lis) return;
        var $li = $($lis.get(idx));
        $li.addClass('active');
        crsaPage.show();
        //debugger;
        var $selected_el = null;
        if (crsaPage.selected_element_pgid) {
            $selected_el = crsaPage.getElementWithPgId(crsaPage.selected_element_pgid);
        }
        pinegrow.selectElement($selected_el);
        //crsaPage.treeRepaintOnShow = crsaPage.treeRepaintOnShow;
        pinegrow.setSelectedPage(crsaPage);
    }

    var hidePage = function (crsaPage, idx) {
        if (typeof idx == 'undefined') idx = list.indexOf(crsaPage);
        if (!$lis) return;
        var $li = $($lis.get(idx));
        $li.removeClass('active');
        crsaPage.hide();
    }

    var hideAll = function (except) {
        for (var n = 0; n < list.length; n++) {
            var cp = list[n];
            if (cp != except) {
                hidePage(cp, n);
            }
        }
    }

    this.showPage = function (crsaPage, hide_others) {
        if (hide_others) {
            hideAll(crsaPage);
        }
        showPage(crsaPage);
        $.fn.crsapages('refresh');
    }

    this.hidePage = function (crsaPage) {
        hidePage(crsaPage);
        $.fn.crsapages('refresh');
    }

    this.hideAll = function () {
        hideAll();
        $.fn.crsapages('refresh');
    }
}

var PgEditException = function (msg, reason, on_display) {
    this.msg = msg;
    this.reason = reason;
    this.on_display = on_display;

    this.toString = function () {
        return this.msg;
    }
}


var PgBoxWithButton = function (icon, title, content, tooltip) {

    var button = new PgButtonToolbarItem(icon, tooltip);
    var $button = button.$element;

    var $box = $('<div class="news-box"><h3>' + title + '<i class="icon-close close"></i></h3></div>');

    var view;
    var has_content = false;

    var $popover = null;
    var is_open = false;
    var _this = this;

    crsaHandleExternalLinks($box);

    var close = function () {
        $box.animate({opacity: 0.0}, 200, function () {
            $box.detach();
            is_open = false;

            if(view) {
                view.destroy();
            }
        });
    }

    button.onClick = function () {

        if (is_open) {
            close();
        } else {
            if(!has_content) {
                var c = typeof content == 'function' ? content() : content;

                if (c instanceof PgUIView) {
                    view = c;
                    view.get$Element().appendTo($box);
                    view.alwaysVisible = true;
                    view.updateVisibility();
                } else {
                    $box.append(c);
                }
                has_content = true;
            }

            $button.closest('body').append($box);
            $box.css('left', ($button.offset().left + $button.outerWidth() - $box.width()) + 'px').css('right', 'auto');
            $box.css('opacity', 0).animate({opacity: 1.0}, 200);
            is_open = true;
            _this.opened();

            if(view && view.onResize) {
                view.onResize();
            }
        }
    }

    $box.find('.close').on('click', function (e) {
        e.preventDefault();
        close();
        _this.closed();
    })

    this.getButton = function () {
        return button;
    }

    this.get$Box = function () {
        return $box;
    }

    this.opened = function () {

    }

    this.closed = function () {

    }
}


var PgNewsBox = function () {

    var pgbox = new PgBoxWithButton('icon-cup', 'Articles &amp; News', '<div class="list"></div><div class="news-box-item"><a href="https://pinegrow.com/articles/" class="external" style="font-size: 12px;">More articles »</a></div><div class="news-box-item"  style="font-size: 12px;"><a href="https://www.getdrip.com/forms/8855293/submissions/new" class="external">Get new articles in your inbox »</a></div>', 'Read news and articles');

    var $box = pgbox.get$Box();

    this.button = pgbox.getButton();

    var $button = this.button.$element.addClass('hide');

    crsaHandleExternalLinks($box, function () {
        pinegrow.stats.using('news.click');
    });

    var $box_list;

    pgbox.opened = function () {
        $box_list = $box.find('div.list');
        updateBox(news_data.list);
        localStorage.last_news_version = news_data.news_version;
        $button.removeClass('has-news');
        pinegrow.stats.using('news.show');
    }

    var updateBox = function (list) {
        $box_list.html('');
        for (var i = 0; i < list.length; i++) {
            var $li = $('<div class="news-box-item"><a class="external" href="' + list[i].url + '">' + list[i].name + '<small>' + list[i].tag + '</small></a></div>');
            $box_list.append($li);
        }
    }

    var news_data = {list:[]};

    this.setData = function (data) {
        news_data = data;

        //updateBox(news_data.list);

        if (news_data.news_version != (localStorage.last_news_version || 0)) {
            $button.addClass('has-news');
        }

        $button.removeClass('hide').css('opacity', 0).animate({opacity: 1.0}, 1000);
    }
}

var pgGetOpenPartialInContainerInfo = function (partial_file) {
    var project = pinegrow.getCurrentProject();

    if (project) {
        return project.getProjectInfo().getSettingForFile(partial_file, 'open_partial_wrapper');
    }
    return null;
}

var pgOpenPartialInContainer = function (partial_url, done, force_interactive) {

    var $dialog;
    var $url;
    var $selector;
    var $remember;
    var url;
    var selector;
    var auto_open = false;

    var cp = pinegrow.getCrsaPageByUrl(partial_url);

    if (cp) {
        pinegrow.showQuickMessage('Page is already open.');
        cp.show(true);
        //pinegrow.pageTabs.showPage(cp, true);
        return;
    }

    var partial_file = crsaMakeFileFromUrl(partial_url);

    var info = pgGetOpenPartialInContainerInfo(partial_file);
    if (info) {
        url = info.url || '';
        selector = info.selector || '';
        auto_open = info.auto_open || false;
    }

    var showError = function ($field, msg) {
        var $p = $field.closest('.form-group').find('.error');
        if (msg) {
            $p.html(msg).removeClass('hide');
        } else {
            $p.html('').addClass('hide');
        }
    }

    var getAbsoluteUrl = function () {
        var curl = $url ? $url.val() : url;
        if (!curl) return null;
        var urllib = require('url');
        return urllib.resolve(partial_url, curl);
    }

    var onElementSelected = function () {

    }

    var onClose = function () {
        $('body').off('crsa-element-selected.openpartial');
    }

    var onOpen = function () {
        var opts = {
            wrapper_url: getAbsoluteUrl(),
            wrapper_selector: selector
        }
        pinegrow.openOrShowPage(partial_url, done, true, null, opts);
    }

    if (!force_interactive && auto_open) {
        if (url && selector) {
            pinegrow.showQuickMessage('Opening as a partial file in a container. Use Right-click -&gt; Open as partial... to override.', 4000);
            onOpen();
            return;
        }
    }

    pinegrow.getComponent('open-partial', function (pc) {
        var html = pc.html;

        $dialog = makeAndShowDialog("Open partial in container", "Cancel", "Open", html, function () {
            onClose();
        }, function () {
            //open
            var project = pinegrow.getCurrentProject();

            if (project) {
                var project_info = project.getProjectInfo();
                project_info.setSettingForFile(partial_file, 'open_partial_wrapper', {
                    url: url,
                    selector: selector,
                    auto_open: $remember.is(':checked')
                });
                project_info.save();
            }

            onOpen();

            onClose();

        }, function () {
            //validate
            var ok = true;
            url = $.trim($url.val());
            selector = $.trim($selector.val());

            showError($url, null);
            showError($selector, null);

            if (!url) {
                showError($url, 'File url or remote url is required.');
                ok = false;
            }
            if (!selector) {
                showError($selector, 'Selector is required. Use <b>body</b> if you have no other idea.');
                ok = false;
            }
            return ok;
        })

        $url = $dialog.find('.input-url').val(url);
        $selector = $dialog.find('.input-selector').val(selector);
        $remember = $dialog.find('.auto-open');

        if (auto_open) $remember.prop('checked', 'checked');

        showError($url, null);
        showError($selector, null);

        $url.closest('.form-group').find('a').on('click', function (e) {
            e.preventDefault();
            crsaChooseFile(function (url, file) {
                url = crsaMakeLinkRelativeTo(url, partial_url);
                $url.val(url);
            }, null, null, null, false);
        });

        $selector.closest('.form-group').find('a').on('click', function (e) {
            e.preventDefault();
            var page_url = getAbsoluteUrl();
            if (!page_url) {
                pinegrow.showQuickMessage('Set the url first!', 3000, false, 'error');
            } else {
                //pinegrow.showQuickMessage(page_url);
                pinegrow.openOrShowPage(page_url);

                $('body').off('crsa-element-selected.openpartial').on('crsa-element-selected.openpartial', function (e, pgel) {
                    if (pgel) {
                        var $el = pgel.get$DOMElement();
                        var s = pgFindUniqueSelectorForElement(pgel, pgel.document);
                        if (s) {
                            $selector.val(s);
                        } else {
                            pinegrow.showQuickMessage('Sorry, can\'t guess a unique selector.');
                        }

                    }
                })
            }
        });

    });


}

var PgUILayoutControl = function ($dest) {

    var code = '<ul class="ui-lc"></ul>';
    var $c = $(code).appendTo($dest);

    var layout = pinegrow.getSetting('ui-panel-layout', "L,P,C,T").split(',');

    var content = {L: 'Lib', P: 'Page', /* C: 'Code', */ T: 'Tree'};

    layout.forEach(function (i) {
        if (i && i != 'C') {
            $c.append($('<li data-panel="' + i + '">' + content[i] + '</li>'));
        }
    })

    $c.sortable().on("sortupdate", function (event, ui) {
        var r = [];
        $c.children().each(function (i, el) {
            var p = $(el).attr('data-panel');
            if (p) r.push(p);
        })
        var new_layout = r.join(',');

        pinegrow.setSetting('ui-panel-layout', new_layout);
        $(window).trigger('resize');
    });

}

var PgUILayoutControlBox = function ($button_dest, onSettings) {

    var pgbox = new PgBoxWithButton($button_dest, 'th-large', 'Drag panels to rearrange them:', '<div class="control"></div>', 'Rearrange UI panels');

    //<div class="news-box-item"><a href="#" class="settings" style="font-size: 12px;">More settings »</a></div>

    var $box = pgbox.get$Box().addClass('ui-lc-box');
    var $button = pgbox.get$Button().addClass('ui-lc-button');//.css('padding', '5px 5px 3px');

    var $box_content = $box.find('div.control');

    var control = null;

    pgbox.opened = function () {
        if (!control) control = new PgUILayoutControl($box_content);
    }

    $box.find('a.settings').on('click', function (e) {
        e.preventDefault();
        onSettings();
    })
}

var PgTrialUpgradeBox = function ($button_dest) {

    var msg = "<p>Whether you’re a beginner or an advanced web developer / designer, Pinegrow will help you save time, expand your skills and make your workflow more efficient.</p><p>Get a copy of Pinegrow for yourself, risk-free, with our 30 days money-back guarantee.</p><p><a class=\"external btn btn-primary\" href=\"https://pinegrow.com#buy\">Buy Pinegrow</a></p>";

    var pgbox = new PgBoxWithButton('icon-276', 'Power-up with Pinegrow', msg, 'Power-up with Pinegrow');

    this.button = pgbox.getButton();

    var $button = this.button.$element.addClass('gift-button');
    pgbox.get$Box().addClass('powerup-pg');

    pgbox.opened = function () {
        pinegrow.stats.using('app.gift');
    }
}

var addTooltip = function ($e, title, options) {

    var $body = $e.closest('body');

    var opts = {
        container: $body.length ? $body : 'body',
        placement: 'auto',
        html: true,
        title: title,
        use_title_attr: false,
        trigger: 'hover',
        delay: {"show": 800, "hide": 100},
        close_delay: null
    };
    if(options) opts = $.extend(opts, options);

    if(typeof title === 'function') {
        opts.get_title_func = title;
        opts.title = 'dummy';
    }

    if(opts.class) {
        opts.template = `<div class="tooltip ${opts.class}"><div class="tooltip-arrow"></div><div class="tooltip-inner"></div></div>`;
    }

    $e.tooltip(opts);
    $e.attr('data-has-tooltip', true);

    $e.on('mousedown', function (e) {
        $e.tooltip('hide');
    })

    var closeTimeout = null;

    var delay = (opts.close_delay === null) ? (opts.trigger === 'manual' ? 5000 : 10000) : opts.close_delay;

    $e.on('show.bs.tooltip', function() {
        //debugger;
        var $cont = $e.closest('body');
        var t = $e.data('bs.tooltip');
        t.options.container = $cont.length ? $cont : 'body';
        if(t.options.use_title_attr) {
            t.options.title = $e.attr(typeof t.options.use_title_attr === 'string' ? t.options.use_title_attr : 'title');
        }
        if(t.options.get_title_func) {
            t.options.title = t.options.get_title_func()
        }

        if(!$e.is(':visible')) {
            t.options.container = $('#tooltip-garbagebin');
        }
        /*
        if(opts.class) {
            t.options.template = t.options.template.replace(`"tooltip"`, `"tooltip ${opts.class}"`);
            console.log(t.options.template)
        }*/

        if(delay) {
            closeTimeout = setTimeout(function () {
                $e.tooltip('hide');
                closeTimeout = null;
            }, delay)
        }

        closeAllTooltips();
    })


    $e.on('hide.bs.tooltip', function() {
        if(closeTimeout) {
            clearTimeout(closeTimeout);
            closeTimeout = null;
        }
    })

    if(opts.trigger == 'manual') {
        closeAllTooltips();
        $e.tooltip('show');
    }

    return $e;
}

var closeAllTooltipsTimer = null;

var closeAllTooltips = function(delay) {
    if(closeAllTooltipsTimer) {
        clearTimeout(closeAllTooltipsTimer);
    }
    closeAllTooltipsTimer = setTimeout(function() {
        pgGetAppWindows().forEach(function(win) {
            $(win.window.document.body).find('[data-has-tooltip]').tooltip('hide');
        })
        setTimeout(function() {
            pgGetAppWindows().forEach(function(win) {
                $(win.window.document.body).find('.tooltip').remove();
            })
        }, 1000)
        closeAllTooltipsTimer = null;
    }, delay || 30000)
}



var PgCodeEditors = function () {
    var list = [];

    this.register = function (cm) {
        if (cm && list.indexOf(cm) < 0) list.push(cm);
    }

    this.unregister = function (cm) {
        if (!cm) return;
        var idx = list.indexOf(cm);
        if (idx >= 0) {
            list.splice(idx, 1);
        }
    }

    this.forEachEditor = function (func) {
        list.forEach(func);
    }
}

var setLightDarkClassForEditor = function ($editor, theme) {
    var dark = ['ambiance', 'blackboard', 'mbo', 'midnight', 'monokai'];
    $editor.removeClass('dark-theme');
    if (dark.indexOf(theme) >= 0) {
        $editor.addClass('dark-theme');
    }
}

var PgPositionElement = function ($el, position_x, position_y, $parent) {

    if (!$parent) $parent = $el.parent();

    var position = function () {
        var $p = $parent;
        var pw = $p.outerWidth();
        var ph = $p.outerHeight();

        var ew = $el.outerWidth();
        var eh = $el.outerHeight();

        var x, y;
        var spacer = 4;

        switch (position_x) {
            case 'left':
                x = spacer;
                break;
            case 'right':
                x = pw - ew - spacer;
                break;
            case 'center':
                x = (pw - ew) / 2;
                break;
        }
        switch (position_y) {
            case 'top':
                y = spacer;
                break;
            case 'bottom':
                y = ph - eh - spacer;
                break;
            case 'center':
                y = (ph - eh) / 2;
                break;
        }
        $el.css({left: x + 'px', top: y + 'px', margin: 'auto'});
    }

    position();

    $el.addClass('reposition-on-resize');

    $el.on('reposition', function () {
        position();
    })
}



var PgPositionNextToRect = function ($el, getrect, view, distance, top, use_fastdom) {

    var $parent = $el.parent();
    var current_rect = null;

    var domtask_id = pgGetFastdomTasks($el.get(0)).getUniqueKey();

    var position = function () {

        var task = use_fastdom ? pgGetFastdomTasks($el.get(0)).create(domtask_id) : {
            measure: function(func) { func() },
            mutate: function(func) { func() }
        };

        task.measure(function() {
            var rect = typeof getrect == 'function' ? getrect() : getrect;

            if(!rect) rect = current_rect;

            current_rect = rect;

            var $p = $parent;
            var pw = $p.outerWidth();
            var ph = $p.outerHeight();

            var ew = $el.outerWidth();
            var eh = $el.outerHeight();

            var ww = window.innerWidth;
            var wh = window.innerHeight;

            var x = 200, y = 200;
            var spacer = 4;
            if(distance !== undefined && distance !== null) spacer = distance;
            var min_w = 300;
            var new_w = ew;
            var new_h = eh;

            var top_space = 36;
            var bottom_space = 32;

            task.mutate(function() {

                if(rect) {
                    if(top == 'cover_right') {
                        new_w = Math.round(pw * 0.33);
                        new_h = ph - top_space - bottom_space;
                        x = pw - new_w;
                        y = top_space;
                    } else if(top == 'cover_left') {
                        new_w = Math.round(pw * 0.25);
                        if(new_w < 320) new_w = 320;

                        new_h = ph - top_space - bottom_space;
                        x = 0;
                        y = top_space;
                    } else if(top == 'cover_bottom') {
                        new_h = Math.round(ph * 0.5);
                        new_w = pw;
                        x = 0;
                        y = ph - new_h;
                    } else if(top == 'down') {
                        y = rect.bottom + spacer;
                        x = rect.left;
                        if(x + ew > pw) {
                            x = rect.right - ew;
                        }
                        if(x < 0) {
                            x = 0;
                        }
                        if(y + eh > ph) {
                            new_h = ph - y - 20;
                        }
                    } else if(top == 'down_top_left') {
                        y = rect.bottom + spacer;
                        x = rect.left;
                        if(x < 0) {
                            x = 0;
                        }
                        if (y + eh > wh) {
                            y = y - (eh + rect.height);
                        }
                    } else if(top == 'down_no_resize') {
                        y = rect.bottom + spacer;
                        x = rect.left;
                        if(x + ew > pw) {
                            x = rect.right - ew;
                        }
                        if(x < 0) {
                            x = 0;
                        }
                        if(y + eh > ph) {
                            y = ph - eh;
                        }
                    } else if(top) {
                        //show on top
                        x = rect.left;
                        if(x + ew > pw) {
                            x = pw - ew;
                        }
                        y = rect.top - spacer - eh;
                        if(y < 43) {
                            y = 43;
                            $el.addClass('sticky-top');
                        } else {
                            $el.removeClass('sticky-top');
                        }
                    } else {
                        //sides
                        //is right space enough
                        var right_space = pw - (rect.left + rect.width + spacer);
                        var left_space = rect.left - spacer;

                        if (right_space > ew) {
                            x = rect.left + rect.width + spacer;
                        } else {
                            if (right_space > left_space) {
                                x = rect.left + rect.width + spacer;
                                new_w = Math.max(min_w, right_space);
                            } else {
                                if (left_space > ew) {
                                    x = rect.left - ew - spacer;
                                } else {
                                    x = spacer;
                                    //new_w = Math.max(min_w, left_space - spacer);
                                }
                            }
                        }

                        y = rect.top;
                        if (rect.top + eh > ph) {
                            y = ph - eh;
                            if (y < 0) {
                                y = 0;
                                new_h = ph;
                            }
                        }

                        if(x < 0) x = 0;
                        if(x + new_w > pw) x = pw - new_w;
                    }
                }
                if(y < top_space) y = top_space;
                x = Math.round(x);
                y = Math.round(y);

                $el.css({left: x + 'px', top: y + 'px', margin: 'auto', width: new_w + 'px', height: new_h + 'px'});

            })
        })
    }

    position();

    $el.addClass('reposition-on-resize');

    var onReposition = function () {
        if($el.hasClass('reposition-on-resize')) {
            position();
        }
        if(view && view.onResized) view.onResized();
    }

    $el.on('reposition', onReposition)

    this.reposition = function() {
        onReposition();
    }

    this.destroy = function() {
        $el.off('reposition', onReposition)
        $el.removeClass('reposition-on-resize');
        if(use_fastdom) pgGetFastdomTasks($el.get(0)).stopAll(domtask_id);
    }
}

var PgPositionNextToPgel = function ($el, pgel, view, distance, top, use_fastdom) {

    var pos = new PgPositionNextToRect($el, function() {
        return pinegrow.selectedElements.getElementRect(pgel);
    }, view, distance, top, use_fastdom)

    this.destroy = function() {
        pos.destroy();
    }

    this.reposition = function() {
        pos.reposition();
    }
}

var PgPositionNextTo$El = function ($el, $target, view, distance, top, use_fastdom) {

    var pos = new PgPositionNextToRect($el, function() {
        if ($target && $target.length > 0) {
            return $target.get(0).getBoundingClientRect();
        }
        else {
            return null;
        }
    }, view, distance, top, use_fastdom)

    this.destroy = function() {
        pos.destroy();
    }

    this.reposition = function() {
        pos.reposition();
    }
}

var PgPositionNextToPage$El = function(pv, $el, $target, view, distance, top, use_fastdom) {

    var pos = new PgPositionNextToRect($el, function() {
        return pv.get$ElGlobalRect($target);
    }, view, distance, top, use_fastdom)

    this.destroy = function() {
        pos.destroy();
    }

    this.reposition = function() {
        pos.reposition();
    }
}



var PgPositionManager = function () {

    var t = null;

    $(window).on('resize', function () {
        if (t != null) clearTimeout(t);
        t = setTimeout(function () {
            pgGetAppWindows().forEach(function(win) {
                $(win.window.document).find('.reposition-on-resize').trigger('reposition');
            })
        }, 250);
    })
}

var pgPositionManagerInstance = new PgPositionManager();

var PgAskAboutElements = function (pgels, msg, title, buttons) {

    var $dialog = null;

    this.show = function () {
        $dialog = makeAndShowDialog(title, null, null, msg);
        var $footer_buttons = $dialog.find('.modal-footer');

        buttons.forEach(function (button) {
            var $b = $('<button class="btn btn-' + (button.primary ? 'primary' : 'default') + ' btn-sm" type="button">' + button.label + '</button>').on('click', function (e) {
                e.preventDefault();
                if (button.func) button.func(button.action);
                $dialog.remove();
            }).appendTo($footer_buttons);

            if (button.tooltip) {
                addTooltip($b, button.tooltip);
            }
        })

        var pos = new PgPositionElement($dialog, 'center', 'bottom', $('body'));

        var selectElement = function (pgel) {
            var page = pinegrow.getCrsaPageOfPgParserNode(pgel);

            if (pinegrow.getSelectedPage() != page) {
                pinegrow.showPage(page, true);
            }

            var $el = pgel.get$DOMElement();
            if (!$el) {
                page.refresh(function () {
                    pinegrow.selectElement(pgel);
                });
            } else {
                pinegrow.selectElement($el);
            }
        }

        selectElement(pgels[0]);

        var $list = $dialog.find('a[data-pg-select-element]');

        $list.on('click', function (e) {
            e.preventDefault();
            var pgel = pgParserNodeCatalogueInstance.get($(e.delegateTarget).attr('data-pg-select-element'));
            if (pgel) {
                selectElement(pgel);
                pinegrow.showQuickMessage('The element was selected in page view.');
            } else {
                pinegrow.showQuickMessage('Sorry, can\'t find this element in page view.');
            }

        })

        addTooltip($list, 'Click to select the element in page view.');

    }
}

var PgChooseFile = function (done, options) {
    options = options || {parent_url: null, save_as: null, folder: null, no_proxy: true, no_url: false, no_copy_to_folder: false};

    options.no_proxy = true;

    crsaChooseFile(function (url, file) {
        var setUrl = function () {
            if (fdef.file_picker_quotes && url) url = '"' + url + '"';

            if (fdef.file_picker_no_url) url = file;

            $input.val(url).trigger('change');
        }

        var parent_url = options.parent_url || null;
        if (parent_url) {
            if (crsaIsFileUrl(parent_url)) {
                var project = pinegrow.getCurrentProject();
                var outside_of_project = project && project.isUrlInProject(parent_url) && !project.isFileInProject(file);

                if(options.must_be_in_base_to_be_relative) {
                    if(url.startsWith(options.must_be_in_base_to_be_relative)) {
                        url = crsaMakeLinkRelativeTo(url, parent_url);
                    }
                } else {
                    url = crsaMakeLinkRelativeTo(url, parent_url);
                }
                //url = crsaMakeLinkRelativeTo(url, parent_url);

                if (!options.no_proxy) url = pinegrow.getProxyUrl(url);

                if ((crsaIsAbsoluteUrl(url) || outside_of_project) && !options.no_url && !options.no_copy_to_folder) {
                    pinegrow.showAlert("<p>Location of the file doesn't let us use a relative url. This can cause url to break when you upload the page to a server or if you open the page in a browser while Pinegrow is not running.</p><p>Would you like to copy the file in the same folder (or subfolder of folder) where your HTML page is located? Then Pinegrow can create relative urls that will work from wherever you open the page.</p>", "The file is not located in the project folder", 'No, use absolute link', 'Yes, copy the file', function () {
                        //use as is
                        done(url, file);
                    }, function () {
                        //copy
                        //debugger;

                        var folder = crsaMakeFileFromUrl(crsaGetBaseForUrl(parent_url));
                        var project_info;
                        if (project) {
                            project_info = project.getProjectInfo();
                            folder = project_info.getSetting('file-picker-copy-folder') || folder;
                        }
                        crsaChooseFile(function (new_url, new_file) {
                            if (new_file != file) {
                                try {
                                    crsaCopyFileSync(null, file, new_file);
                                    file = new_file;

                                    if(options.must_be_in_base_to_be_relative) {
                                        if(new_url.startsWith(options.must_be_in_base_to_be_relative)) {
                                            url = crsaMakeLinkRelativeTo(new_url, parent_url);
                                        }
                                    } else {
                                        url = crsaMakeLinkRelativeTo(new_url, parent_url);
                                    }
                                    if (crsaIsAbsoluteUrl(url)) {
                                        if (!options.no_proxy) url = pinegrow.getProxyUrl(url);
                                    }
                                    done(url, file);

                                    if (project_info) {
                                        project_info.setSetting('file-picker-copy-folder', require('path').dirname(new_file));
                                        project_info.save();
                                    }
                                } catch (err) {
                                    pinegrow.showAlert('Could not copy file: ' + err, 'Error');
                                }
                            }
                        }, require('path').basename(file) /* crsaGetNameFromUrl(url)*/, null, /* folder */ folder);
                    });
                } else {
                    done(url, file);
                }
            } else {
                if (!options.no_proxy) url = pinegrow.getProxyUrl(url);
                done(url, file);
            }
        } else {
            done(url, file);
        }
    }, /* save as */ options.save_as || null, null, null, options.folder || false);
}

var PgOverlayMessage = function (msg, auto_hide, tooltip) {

    var delay = 1000;

    var _this = this;

    this.onClick = null;

    var $el = $('<div class="overlay-message"></div>');

    $el.on('click', function(e) {
        e.preventDefault();
        _this.onClick && _this.onClick();
    })

    if(tooltip) {
        addTooltip($el, tooltip)
    }

    $el.html(msg);

    if (msg) {
        $el.appendTo($('body'));

        PgPositionElement($el, 'center', 'center');
    }

    this.destroy = function () {
        $el.remove();
    }

    var delayed_timeout = null;

    var clearDelayedHide = function () {
        if (delayed_timeout) {
            clearTimeout(delayed_timeout);
            delayed_timeout = null;
        }
    }

    this.hide = function (delayed) {
        //return;
        clearDelayedHide();

        if (delayed) {
            delayed_timeout = setTimeout(function () {
                _this.hide();
            }, typeof delayed == "number" ? delayed : 1000);
        } else {
            var a = {opacity: 0};
            if(this.$hideTowards) {
                var pos = this.$hideTowards.get(0).getBoundingClientRect();
                a.top = pos.top + pos.height/2 - $el.height()/2;
                a.left = pos.left + pos.width/2 - $el.width()/2;
            }
            $el.animate(a, 250, function () {
                $el.detach();
            })
        }
    }

    this.show = function () {
        clearDelayedHide();

        $el.appendTo($('body'));
        PgPositionElement($el, 'center', 'center');
        $el.css('opacity', 0);
        $el.animate({opacity: 1}, 150, function () {
        })
    }

    this.clearDelayedHide = function () {
        clearDelayedHide();
    }

    this.showIfHidden = function () {
        if (!$el.is(':visible')) this.show();
    }

    this.hideIfShown = function () {
        if ($el.is(':visible')) this.hide();
    }

    this.setMessage = function (msg) {
        $el.html(msg);
    }

    if (auto_hide) {
        setTimeout(function () {
            $el.animate({opacity: 0}, 250, function () {
                _this.destroy();
            })
        }, delay);
    }
}

var pgGetDragMenu = function() {
    return $.fn.crsa('getDragMenu');
}

var PgDragMenu = function (def, allow_clone, show, parent_selector, pgel, options) {

    options = $.extend({
        disableClone: pgf.kids || false,
        disableGrid: false,
        disableRepeater: false,
        disableDisableParentSelector: false,
        disableText: false,
        dragType: 'html'
    }, options || {})


    this.dragType = options.dragType;

    $.fn.crsa('setDraggedMenu', this);

    pinegrow.selectedElements.temporaryHideMenus();

    pinegrow.getAllPageViews().forEach(function(pv) {
        pv.addHtmlClass('crsa-in-drag');
    })

    var name = (def.display_name && pgel) ? pgel.tagName : def.name;

    var $del = $('<div class="factory-drag-helper"><div class="factory-drag-helper-inner"><div class="factory-drag-helper-inner-arrow"></div><i class="icon icon-import"></i><span>' + name + '</span> <span class="count" style="text-transform: none;">' + pinegrow.repeater.showLiveRepeatCount() + '</span><div class="help"><p class="clone">Hold ' + pgShowKbd('ALT') + ' to clone.</p><p class="parent_selector">Trying to insert into <b>' + (parent_selector || '') + '</b>. Hold ' + pgShowKbd('SHIFT') + ' to insert anywhere.</p><p class="grid-drop">Hold ' + pgShowKbd('CMD') + ' to target grid cells.</p><p class="drop-inside hl">Hold ' + pgShowKbd('SHIFT') + ' to drop inside collapsed.</p><p class="text-drop">Hold over text to insert into text.</p><p class="repeater">Type ' + pgShowKbd('1') + ' - ' + pgShowKbd('9') + ' to insert multiple copies.</p><!-- <p>' + pgShowKbd('ESC') + ' to cancel.</p>--></div></div></div>').data('crsa-factory-def', def);

    var $parent_selector = $del.find('.parent_selector');


    if(!parent_selector) {
        pg$Hide($parent_selector);
    } else {
        if(!options.disableDisableParentSelector) {
            pinegrow.showQuickMessage('Trying to insert into <b>' + (parent_selector || '') + '</b>. Press ' + pgShowKbd('SHIFT') + ' or use the tree to insert anywhere.', 3000);
        } else {
            pg$Hide($parent_selector);
        }
    }

    var $collapsed = $del.find('.drop-inside');
    pg$Hide($collapsed);

    var collapsed_shown = false;

    this.setDropInside = function(v) {
        if(v !== collapsed_shown) {
            v ? pg$Show($collapsed) : pg$Hide($collapsed);
            collapsed_shown = v;
        }
    }

    if(options.disableGrid || true) {
        pg$Hide($del.find('.grid-drop'));
    }
    if(options.disableRepeater || true) { //repeater not available during dragging
        pg$Hide($del.find('.repeater'));
    }
    if(options.disableText || !document.caretRangeFromPoint) {
        pg$Hide($del.find('.text-drop'));
    }
    if(options.disableClone) {
        pg$Hide($del.find('.clone'));
    }

    if(pgf.kids) {
        $del.find('.text-drop').text('Drag me to the page or to the Structure panel.');
    }

    if (show) {
        $('body').append($del);
    }

    var $icon = $del.find('i.icon');

    this.addElement = function ($el) {
        $del.append($el);
    }

    var current_over = null;
    var inserted_over = null;

    this.getOver = function() {
        return current_over;
    }

    this.setOver = function (over) {
        if (current_over != over) {
            if(over == 'none' && current_over == 'tree') return;
            $del.removeClass('over-lib over-page over-tree over-none');
            $del.addClass('over-' + over);
            current_over = over;
        }
    }

    if (!allow_clone) {
        $del.find('.clone').remove();
    } else {
        $icon.removeClass('icon-import').addClass('icon-moveitem');
    }

    this.element = null;
    this.position = null;
    this.positionElement = null;
    this.gridPosition = null;
    this.overInvalidParent = false;
    this.elementDefinition = def;
    this.movedElement = null;
    this.parentSelectorDisabled = false;

    this.pgel;
    this.positionPgel;
    this.movedPgel;
    this.insertInText = false;
    this.selectNew = 'auto';
    this.forcePositionLabel = null;

    this.formatHtml = false;

    this.clone = false;

    this.getCount = function () {
        return pinegrow.repeater.getCount();
    }

    this.window = window;

    this.getWindow = function() {
        return this.window;
    }

    this.setWindow = function(win) {
        this.window = win;
    }

    //precalculate stuff at the start of drag
    beforeElementMovedWithMouse();

    var is_over_grid = false;
    var current_grid_el = null;
    var current_grid_control = null;
    var first_grid = true;

    this.getGridOverlayControl = function() {
        return current_grid_control;
    }

    this.setOverGrid = function(v, $grid) {
        if(options.disableGrid) return;

        if(is_over_grid != v) {
            var $g = $del.find('.grid-drop');
            if(v) {
                $g.addClass('hl');
                pg$Show($g);
                if(!current_grid_control || current_grid_el !== $grid.get(0)) {
                    if(current_grid_control) {
                        current_grid_control.destroy();
                    }
                    current_grid_control = new PgCSSGridOverlayControl();
                    current_grid_control.show($grid)
                    current_grid_el = $grid.get(0);

                    if(first_grid) {
                        pinegrow.showQuickMessage(`Hold ${pgShowKbd('CMD')} to target a grid cell.`)
                        first_grid = false;
                    }
                }
            } else {
                if(current_grid_control) {
                    current_grid_control.destroy();
                }
                current_grid_el = null;
                $g.removeClass('hl');
                pg$Hide($g);
            }
            is_over_grid = v;
        }
    }

    var _this = this;

    this.get$Element = function () {
        return $del;
    }

    var msg = null;

    pinegrow.showUIPanel('tree', false, true /* if not collapsed */);

    var updateClone = function (page, state) {
        if (allow_clone) {
            if (state.alt) {
                $icon.removeClass('icon-moveitem').addClass('icon-duplicate');
                _this.clone = true;
            } else {
                $icon.addClass('icon-moveitem').removeClass('icon-duplicate');
                _this.clone = false;
            }
        }
        if(parent_selector) {
            if(state.shift) {
                pg$Hide($parent_selector);
                _this.parentSelectorDisabled = true;
            } else {
                pg$Show($parent_selector);
                _this.parentSelectorDisabled = false;
            }
        }
        if(current_grid_control) {
            current_grid_control.setHighlight(state.cmdCtrl);
        }
    }

    pinegrow.addEventHandler('on_key_state_changed', updateClone);

    var setCursor = function (c) {
        pgGetAppWindows().forEach(function(win) {
            var b = win.window.document.body;
            if (c) {
                $(b).css('cursor', (allow_clone ? 'move' : 'grab'));
            } else {
                $(b).css('cursor', '');
            }
        })
    }

    setCursor(true);

    this.move = function (x, y, win, target) {
        if(this.window !== win) {
            var $el = $(target);
            var pv = getPageViewOfElement($el);
            if (pv) {
                var pos = pv.pageRectToGlobalRect({left: x, top: y});

                x = pos.left;
                y = pos.top;
            }
            else {
                this.window = win;
                $(this.window.document.body).append($del);
            }
        }
        fastdom.mutate(function() {
            $del && pg$PositionAt($del, Math.round(x), Math.round(y));
        })

        //$del.css({left: Math.round(x) + 'px', top: Math.round(y) + 'px'});
    }

    this.destroy = function () {
        //return;

        if(current_grid_control) {
            current_grid_control.destroy();
        }
        current_grid_el = null;

        pinegrow.dispatchEvent('on_drag_drop_operation_done', null, this);

        $del.remove();

        pgGetAppWindows().forEach(function(win) {
            $(win.window.document.body).find('.factory-drag-helper').remove();
        })
        //this.element = null;
        this.position = null;
        //this.positionElement = null;
        this.overInvalidParent = false;
        //this.movedElement = null;

        pinegrow.removeEventHandler('on_key_state_changed', updateClone);


        this.pgel = null;
        this.positionPgel = null;
        this.movedPgel = null;

        setCursor(false);

        $.fn.crsa('setDraggedMenu', null);

        pinegrow.selectedElements.restoreShowMenus();

        pinegrow.getAllPageViews().forEach(function(pv) {
            pv.removeHtmlClass('crsa-in-drag');
        })

        pgAutoScrollManager.stopAll();

        if(inserted_over != 'tree') {
            pinegrow.undoShowUIPanel('tree');
        }
    }

    //get the element into which things will be inserted
    this.get$Target = function () {
        if (this.positionElement.nodeType && this.positionElement.nodeType == 3) {
            //text mode
            return $(this.positionElement.parentNode);
        } else {
            return this.positionElement;
        }
    }

    var isTextInsert = function () {
        return _this.insertInText;
        //return _this.positionElement.nodeType && _this.positionElement.nodeType == 3;
    }

    var is_app = isApp();

    this.handleMoveEvent = function (event) {
        if (show) {
            this.move(event.pageX, event.pageY, event.view, event.target);
        }
        crsaFuncs.elementMovedWithMouse(event, this);
    }

    this.insert = function () {

        var orig_def;
        var remove = false;

        var draggedPlaceholderElement = this.element;
        var draggedOverInvalidParent = this.overInvalidParent;
        var draggedPositionElement = this.positionElement;
        var draggedPosition = this.position;
        var draggedMenu = this;

        var inserted = false;
        var select_new = (this.selectNew === 'auto') ? (!this.movedPgel || (this.clone && pinegrow.selectedElements.isSelectedElement(this.pgel))) : this.selectNew;

        if(current_over == 'none') return false;

        if (!this.positionPgel) return false;

        if(this.onInsert) {
            if(this.onInsert.call(this)) return;
        }

      //  try {

            if (this.pgel) {

                //replace image?
                if(this.positionPgel.tagName === 'img' && this.pgel.tagName === 'img') {
                    if(draggedPosition === 'inside-top' || draggedPosition === 'inside-bottom') {
                        var col;
                        var url = this.pgel.getAttribute('src');
                        var srcset = this.pgel.getAttribute('srcset');

                        if(url) {
                            if (pinegrow.selectedElements.isSelectedElement(this.positionPgel)) {
                                col = pinegrow.selectedElements.getCollection();
                            } else {
                                col = new PgCollection(this.positionPgel);
                            }
                            pinegrow.makeChanges(col, 'Replace image', function () {
                                col.forEachElement(function (pgel) {
                                    var curl = pgel.getPage().makeRelativeUrl(url);
                                    pgel.setAttribute('src', curl);
                                    if(srcset) {
                                        pgel.setAttribute('srcset', srcset);
                                    } else if(pgel.hasAttribute('srcset')) {
                                        pgel.removeAttribute('srcset');
                                    }
                                })
                            })
                        }
                        return col;
                    }
                }

                var isSelected = pinegrow.selectedElements.isSelectedElement(this.pgel);

                var cloneIfNeeded = function (pgel, position_pgel, force) {
                    if(force === undefined) dorce = false;
                    var pgel_page = pgel.getPage();
                    if (!position_pgel) position_pgel = _this.positionPgel;

                    return (force || _this.clone || (_this.movedPgel && pgel_page && pgel_page != position_pgel.getPage())) ? pgel.clone() : pgel;
                }


                var pgEl = this.pgel;

                var page = pgEl.getPage();
                if (page) def = page.getMainType(null, pgEl);

                orig_def = def;
//            draggedPlaceholderElement.data('crsa-def', null);

                /*
                 //todo30 - invalid drop locations
                 if(draggedOverInvalidParent && !getIframeOfElement(draggedPlaceholderElement)) {
                 if(def.invalid_drop_msg) {
                 showAlert(def.invalid_drop_msg, "Can't put it here");
                 } else if(def.parent_selector && typeof def.parent_selector == 'string') {
                 showAlert('The element can only be placed in containers of type <b>' + def.parent_selector + '</b>. Drag it to the tree if you want to place it elsewhere.', "Can't put it here");
                 }
                 } else {
                 */

                var inserted_elements = new PgCollection();
                var moved_elements = this.clone ? inserted_elements : new PgCollection();

                var target_pgel = this.positionPgel;

                var move_ok = true;
                var bad_move_msg = null;

                if (this.movedPgel) {
                    var all_moved = [this.movedPgel];

                    if (isSelected) {
                        all_moved = pinegrow.selectedElements.getCollection().getList();
                    }

                    for(var i = 0; i < all_moved.length; i++) {
                        if(!this.clone) {
                            if (target_pgel.isDescendantOf(all_moved[i]) || ((this.position == 'inside-top' || this.position == 'inside-bottom' || isTextInsert()) && all_moved[i] == target_pgel)) {
                                move_ok = false;
                                bad_move_msg = 'Can\'t move element into itself.';
                                break;
                            }
                        }

                        if(['html', 'body', 'head'].indexOf(all_moved[i].tagName) >= 0) {
                            move_ok = false;
                            bad_move_msg = "Can't move " + all_moved[i].tagName + ' element.';
                            break;
                        }
                    }
                }

                if(target_pgel && target_pgel.tagName == 'html' && ['top', 'bottom', 'left', 'right'].indexOf(this.position) >= 0) {
                    move_ok = false;
                    bad_move_msg = 'Can\'t place elements outside of the page.';
                }

                if(!move_ok) {
                    pinegrow.showQuickMessage(bad_move_msg, 4000, false, 'error');
                }

                if(move_ok) {

                    if (!remove && this.pgel.parent) {
                        // TODO: check this
                        if (!canMakeChange(this.pgel.parent, 'insert_element', {inserted: pgEl})) {
                            remove = true;
                        }
                    }

                    var update_pgel = null;

                    if (isTextInsert()) {
                        //text mode
                        update_pgel = this.positionPgel;
                    } else {
                        update_pgel = this.positionPgel;
                        switch (draggedPosition) {
                            case 'top':
                            case 'left':
                            case 'bottom':
                            case 'right':
                                update_pgel = update_pgel.parent;
                                break;
                        }
                    }

                    var cp = update_pgel.getPage();

                    if (canMakeChange(update_pgel, 'insert_element', {inserted: pgEl})) {
                        willMakeChange(cp, "Add to page / " + this.pgel.getName());

                        var draggedCount = draggedMenu.getCount();

                        var doMorePgels = function () {
                            if (_this.morePgels) {
                                _this.morePgels.forEach(function (pgel) {
                                    pgel = pgel.clone();
                                    pgel.insertAfter(last_pgel);
                                    inserted_elements.add(pgel);
                                    last_pgel = pgel;
                                })
                            }
                        }

                        if (isTextInsert()) {
                            //text mode

                            var insertIntoText = function () {

                                //var $pel_inner = $(draggedPositionElement.parentNode);
                                var pgel_inner = _this.positionPgel;

                                var pgtext = getPgNodeForTextNode(_this.positionTextNode);
                                if (pgtext) {
                                    //console.log(pgtext.content, textNode.textContent);

                                    var content_a = crsaSplitCharsInArray(pgtext.content);

                                    var oldHtml = pgel_inner.html(null, true /* with ids */);

                                    pgEl = cloneIfNeeded(pgEl, pgtext, _this.movedPgel !== null /* force clone for moved elements */);

                                    var last_pgel = pgEl;

                                    pgEl.withoutEvents(function () {

                                        if (content_a.length <= draggedPosition) {
                                            pgEl.insertAfter(pgtext);
                                        } else {
                                            var new_text_pgel = pgCreateNodeFromHtml(crsaGetCharArraySubstring(content_a, draggedPosition, content_a.length));
                                            pgtext.content = crsaGetCharArraySubstring(content_a, 0, draggedPosition);
                                            pgEl.insertAfter(pgtext);
                                            new_text_pgel.insertAfter(pgEl);
                                            if (pgtext.content.length == 0) pgtext.remove();
                                        }
                                    })
                                    if (!_this.clone) pgEl.removeFromDOM();
                                    pgel_inner.updateInner(oldHtml); //will trigger DOM update of this element

                                    moved_elements.add(pgEl);
                                    doMorePgels();

                                    if (draggedCount > 1) {
                                        for (var i = 2; i <= draggedCount; i++) {
                                            var cloned_el = pgEl.clone();
                                            cloned_el.insertAfter(last_pgel);
                                            inserted_elements.add(cloned_el);
                                            last_pgel = cloned_el;
                                            doMorePgels();
                                        }
                                    }


                                    if (isSelected) {
                                        pinegrow.selectedElements.forEachSubsequentElementOrderedByDocumentPosition(_this.pgel, function (nextPgEl) {
                                            var alreadyMoved = false;
                                            moved_elements.forEachElement(function (mpgel) {
                                                if (nextPgEl.isDescendantOf(mpgel)) {
                                                    alreadyMoved = true;
                                                }
                                            })
                                            if (!alreadyMoved) {
                                                nextPgEl = cloneIfNeeded(nextPgEl, last_pgel);
                                                nextPgEl.insertAfter(last_pgel);
                                                last_pgel = nextPgEl;
                                                moved_elements.add(nextPgEl);

                                                for (var i = 2; i <= draggedCount; i++) {
                                                    var cloned_el = nextPgEl.clone();
                                                    cloned_el.insertAfter(last_pgel);
                                                    inserted_elements.add(cloned_el);
                                                    last_pgel = cloned_el;
                                                }
                                            }

                                        })
                                    }


                                    //this.pgel = pgEl.get$DOMElement(cp.get$Html());
                                    update_pgel = _this.positionPgel;
                                }

                                if (pinegrow.selectedElements.isInSelectedElement(pgel_inner) || pinegrow.selectedElements.isSelectedElement(pgel_inner)) {
                                    pinegrow.showQuickMessage('Inserting into text of multiple selected elements is not supported.', 5000);
                                }

                                inserted = true;
                            }

                            insertIntoText();

                        } else {
                            /////
                            var pgPosEl = this.positionPgel;

                            if (!remove && (!pgEl || !pgPosEl)) {
                                remove = true;
                                showAlert("The element can't be placed here because the destination is a dynamic element, created by Javascript code.", "Can't put it here");
                            }

                            if (pgPosEl.tagName == 'body' && draggedPosition == 'inside-bottom' && pgEl.tagName != 'script') {
                                //if appending to body, insert before any script elements
                                var firstScript = null;
                                for (var i = pgPosEl.children.length - 1; i >= 0; i--) {
                                    if (pgPosEl.children[i].isElement) {
                                        if (pgPosEl.children[i].tagName == 'script') {
                                            firstScript = pgPosEl.children[i];
                                        } else {
                                            break;
                                        }
                                    }
                                }
                                if (firstScript) {
                                    pgPosEl = firstScript;
                                    draggedPosition = 'top'; //insert before first end script
                                }
                            }

                            var insertAtPosition = function (pgEl, pgPosEl, draggedPosition) {
                                var update_pgel = _this.positionPgel;

                                switch (draggedPosition) {
                                    case 'top':
                                    case 'left':
                                        pgEl.insertBefore(pgPosEl);
                                        update_pgel = update_pgel.parent;
                                        break;
                                    case 'bottom':
                                    case 'right':
                                        pgEl.insertAfter(pgPosEl);
                                        update_pgel = update_pgel.parent;
                                        break;
                                    case 'inside-top':
                                        pgPosEl.prepend(pgEl);
                                        break;
                                    case 'inside-bottom':
                                        pgPosEl.append(pgEl);
                                        break;
                                }
                                return update_pgel;
                            }
                            //get info in case multi insert
                            var find_sel = pgPosEl.tagName;
                            var find_idx;
                            var moved_find_idx = -1;
                            var moved_find_sel;
                            var selected = pinegrow.selectedElements.isInSelectedElement(pgPosEl);

                            if (selected) {
                                find_idx = selected.findIncludingSelf(find_sel).indexOf(pgPosEl);
                                if (this.movedPgel) {
                                    moved_find_sel = this.movedPgel.tagName;
                                    moved_find_idx = selected.findIncludingSelf(moved_find_sel).indexOf(this.movedPgel);
                                }
                            }

                            if (!selected && pinegrow.selectedElements.isSelectedElement(pgPosEl)) {
                                selected = pgPosEl;
                                find_sel = '*';
                                find_idx = 0;
                            }

                            pgEl = cloneIfNeeded(pgEl, pgPosEl);
                            var update_pgel = insertAtPosition(pgEl, pgPosEl, draggedPosition);

                            if (pgEl === this.movedPgel) {
                                moved_elements.add(pgEl);
                            } else {
                                inserted_elements.add(pgEl);
                            }

                            var last_pgel = pgEl;

                            doMorePgels();

                            var repeatDraggedCountInsert = function (pgEl) {

                                if (draggedCount > 1) {
                                    for (var i = 2; i <= draggedCount; i++) {
                                        var cloned_el = pgEl.clone();
                                        cloned_el.insertAfter(last_pgel);
                                        last_pgel = cloned_el;
                                        inserted_elements.add(pgEl);

                                        doMorePgels();
                                    }
                                }
                            }

                            repeatDraggedCountInsert(pgEl);

                            if (selected) {

                                if (find_idx >= 0) {
                                    pinegrow.selectedElements.forEachSubsequentElement(selected, function (selected_pgel) {
                                        var list = find_sel == '*' ? [selected_pgel] : selected_pgel.findIncludingSelf(find_sel);
                                        if (find_idx < list.length) {
                                            var cp = selected_pgel.getPage();
                                            var target_pgel = list[find_idx];
                                            var move_pgel = null;
                                            var insert_pgel;

                                            if (moved_find_idx >= 0) {
                                                var moved_list = selected_pgel.findIncludingSelf(moved_find_sel);
                                                if (moved_list.length > moved_find_idx) {
                                                    move_pgel = moved_list[moved_find_idx];
                                                }
                                            }
                                            if (move_pgel) {
                                                insert_pgel = move_pgel;
                                                moved_elements.add(move_pgel);
                                            } else {
                                                insert_pgel = pgEl.clone();
                                                inserted_elements.add(insert_pgel);
                                            }
                                            insertAtPosition(insert_pgel, target_pgel, draggedPosition);
                                            last_pgel = insert_pgel;
                                            repeatDraggedCountInsert(insert_pgel);

                                            select_new = false;

                                        }

                                    })
                                }

                            }
                            if (isSelected) {
                                pinegrow.selectedElements.forEachSubsequentElementOrderedByDocumentPosition(this.pgel, function (nextPgEl) {
                                    var alreadyMoved = false;
                                    moved_elements.forEachElement(function (mpgel) {
                                        if (nextPgEl.isDescendantOf(mpgel)) {
                                            alreadyMoved = true;
                                        }
                                    })
                                    if (!alreadyMoved) {
                                        nextPgEl = cloneIfNeeded(nextPgEl, last_pgel);
                                        nextPgEl.insertAfter(last_pgel);
                                        last_pgel = nextPgEl;
                                        moved_elements.add(nextPgEl);

                                        repeatDraggedCountInsert(nextPgEl);
                                    }
                                })
                            }

                            inserted = true;

                        }

                        if (inserted) {
                            this.inserted_elements = inserted_elements;
                            this.moved_elements = moved_elements;

                            pinegrow.dispatchEvent('on_inserted_with_dragdrop', null, this);
                            pinegrow.changeManager.batchChanges(function () {

                                if(_this.onInsertedElements) {
                                    _this.onInsertedElements.call(_this, inserted_elements);
                                }
                                if(_this.onMovedElements) {
                                    _this.onMovedElements.call(_this, moved_elements);
                                }

                                if (inserted_elements.getLength()) {
                                    pinegrow.changeManager.didInsert(inserted_elements, _this.elementDefinition, _this.formatHtml);
                                }
                                if (moved_elements.getLength() && moved_elements != inserted_elements) {
                                    pinegrow.changeManager.didMove(moved_elements, cp, cp);
                                }
                            }, 'Drag and drop');
                        }
                    }

                    if (select_new) {
                        var select_pgel = this.pgel;

                        //dont select if in inline text mode and new element is not editable
                        if (crsaIsInEdit() && !canMakeChange(select_pgel, 'edit_content', null, true /* silent */)) {
                            //do nothing
                        } else {
                            setTimeout(function () {
                                pinegrow.selectElement(select_pgel);
                                select_pgel.scrollTo();
                            }, 10);
                        }
                    } else {
                        pinegrow.selectedElements.reselect();
                    }
                }
            }

            if (draggedPlaceholderElement) {
                if (remove) {
                    this.pgel.remove();
                } else {

                }
            }

    //    } catch(err) {
    //        console.log('Insert error', err);
    //    }

        draggedOverInvalidParent = false;
        elementUnderMouse = null;

        if (inserted) {
            pinegrow.repeater.repeatDone();
            inserted_over = current_over;
        }

        return inserted;
    }
}

var PgRepeater = function (msg) {

    var _this = this;

    var delay = 1500;

    var count = 1;

    var lastSetTime = 0;

    var browser = true;// !isApp();

    this.getCount = function () {
        return count || 1;
    }

    var msg = new PgOverlayMessage(null, false, 'Repeat the next insert action &times; times. Click here to clear the repeater.');

    msg.onClick = function() {
        _this.done();
    }

    this.$element = $('<div class="pg-repeater"></div>');

    !browser && (msg.$hideTowards = this.$element);

    var updateLiveCounts = function () {
        $('.repeater-count').each(function(i, el) {
            el.innerHTML = (count > 1 ? ('&times; ' + count) : '');
        })
    }

    var updateCount = function (force_show) {
        updateLiveCounts();

        msg.setMessage('&times; ' + count);
        _this.$element.html('&times; ' + _this.getCount());

        if (force_show) {
            msg.showIfHidden();
        }

        if (count <= 1) {
            !browser && msg.hide(delay);
            _this.$element.parent().removeClass('active');
        } else {
            msg.clearDelayedHide();
            _this.$element.parent().addClass('active');
        }
    }

    var delayTimer = null;
    var inTyping = false;

    this.keyPressed = function (e) {

        if(!pgf.edit_html || pgf.kids) return false;

        if(e.ctrlKey /*|| e.shiftKey*/ || e.metaKey || e.altKey) {
            //console.log(`repeater mod key pressed ${e.ctrlKey} ${e.shiftKey} ${e.metaKey} ${e.altKey}`, )
            return false;
        }

        var getNumber = function(e) {
            if(e.key.length == 1) {
                var code = e.key.charCodeAt(0) - 48;
                //console.log(`repeater code ${code}`)
                if(code >= 0 && code <= 9) {
                    return code;
                }
            }
            return -1;
        }

        var del = inTyping && (e.key == 'Backspace' || e.key == 'Delete');

        var num = getNumber(e);

        if (del || (num >= 0)) {
            inTyping = true;
            if(del) {
                count = Math.floor(count / 10);
            } else {
                var t = new Date().getTime();
                if (t - lastSetTime < delay) {
                    count = count * 10 + num;
                } else {
                    count = num;
                }
            }

            lastSetTime = t;
            if (count > 100) {
                count = 100;
                pinegrow.showQuickMessage('That would take too long! 100 is max.', 3000, true);
            }
            if(count < 1) {
                count = 1;
            }
            updateCount(true);

            if(delayTimer) {
                clearTimeout(delayTimer);
            }
            delayTimer = setTimeout(function() {
                !browser && msg.hide();
                delayTimer = null;
                inTyping = false;
            }, delay);

            return true;
        }
        return false; //not handled
    }

    this.repeat = function (first, other) {
        other = other || first;
        for (var i = 0; i < count; i++) {
            if (!first && i == 0) continue;
            var cont = (i == 0 ? first : other)(i, count);
            if (cont === false) break;
        }
        //this.repeatDone();
    }

    this.repeatDone = this.done = function () {
        count = 1;
        updateCount();
        //updateLiveCounts();
        msg.hide();

        inTyping = false;

        if(delayTimer) {
            clearTimeout(delayTimer);
            delayTimer = null;
        }
    }

    this.repeatOthers = function (func) {
        this.repeat(null, func);
    }

    this.showLiveRepeatCount = function () {
        return '<span class="repeater-count">' + (count > 1 ? ('x ' + count) : '') + '</span>';
    }

    this.addToToolbar = function(tb) {
        var def = tb.addSection('repeater');

        def.$element.append(this.$element);

        updateCount();

        addTooltip(def.$element, 'Repeat action &times; times. Type a number anywhere in the app to set. Type ' + pgShowKbd('1') + ' or ' + pgShowKbd('0') + ' to reset.');

        def.$element.on('click', function(e) {
            e.preventDefault();
            if(_this.getCount() === 1) {
                pinegrow.showQuickMessage('Type a number to set the repeater.');
            } else {
                _this.done();
            }
        })
    }


}


var PgKeyState = function(os) {

    this.shift = false;
    this.alt = false;
    this.cmdCtrl = false;
    this.ctrl = false;
    this.double_key = false;

    var last_changed_at = 0;
    var last_key = null;

    this.keyChanged = function(e) {
        var cmdCtrl = os == 'mac' ? e.metaKey : e.ctrlKey;
        var ctrl = e.ctrlKey;
        if(os == 'win' && e.altKey) {
            ctrl = false; //chrome bug
        }
        var orige = e;
        if(e.originalEvent) {
            orige = e.originalEvent;
        }
        var time = (new Date()).getTime();
        if(last_key === e.key && time - last_changed_at < 500 && orige.repeat !== true) {
            this.double_key = e.key;
        } else {
            this.double_key = false;
        }
        last_changed_at = time;
        last_key = e.key;
        this.update(e.shiftKey, e.altKey, cmdCtrl, ctrl);
    }

    this.update = function(shift, alt, cmdCtrl, ctrl) {
        if(this.shift != shift || this.alt != alt || this.cmdCtrl != cmdCtrl || this.ctrl != ctrl) {
            this.shift = shift;
            this.alt = alt;
            this.cmdCtrl = cmdCtrl;
            this.ctrl = ctrl;
            pinegrow.dispatchEvent('on_key_state_changed', null, this);
        }
    }
}


var PgSearchBox = function(options) {

    var defs = {
        input_type: 'text',
        placeholder: 'find text or selector',
        placeholder_active: pgf.kids ? null : 'find text or selector ($... to force sel)',
        toolbar_on: false,
        delay: false,
        delay_time: 500,
        search_on_input: true
    }
    var options = $.extend(defs, options || {});

    var term = '';

    var _this = this;

    this.onSearch = function(term) {};

    this.$element = $('<div></div>', {class: 'pg-search-box'});

    var input = new PgInputField('search', {
        type: options.input_type || 'text',
        show_empty: false,
        name: 'Search',
        without_text: true,
        slider_def_unit: '',
        placeholder: options.placeholder,
        get_menu_options: options.input_get_menu_options || null,
        menu_no_not_set_option: options.input_menu_no_not_set_option || null
    });

    var change_event = options.input_type == 'text' ? 'input' : 'change';

    input.appendTo(this.$element);

    var $icon = $('<i class="icon field-icon-infield icon-search"></i>');

    if(!options.no_search_icon) {
        $icon.appendTo(input.$field);
    }

    var $close_icon = $('<i class="icon field-icon-infield icon-close"></i>').appendTo(input.$field);
    pg$Hide($close_icon);

    $close_icon.on('click', function(e) {
        e.preventDefault();
        _this.setValue('');
    })

    var delayTimer = null;

    var onInput = function() {
        term = input.getValue();
        if(_this.onSearch) _this.onSearch(term);
        if(toolbar && !options.toolbar_on) {
            if(term.length) {
                toolbar.show();
            } else {
                toolbar.hide();
            }
        }
        if(term.length) {
            pg$Show($close_icon);
            pg$Hide($icon);
        } else {
            pg$Hide($close_icon);
        }
        delayTimer = null;
    }

    input.on(change_event, function(e) {
        if(options.search_on_input) {
            if (delayTimer) {
                clearTimeout(delayTimer);
                delayTimer = null;
            }
            if (options.delay) {
                delayTimer = setTimeout(onInput, options.delay_time);
            } else {
                onInput();
            }
        }
    })

    input.on('keydown', function(e) {
        if(e.which == 13) {
            onInput();
        }
    })

    input.on('focus', function () {
        input.$input.attr('placeholder', options.placeholder_active || options.placeholder);
        pg$Hide($icon);
    });

    input.on('blur', function () {
        input.$input.attr('placeholder', options.placeholder);
        if(term.length === 0) pg$Show($icon);
    });

    var $icons;
    var toolbar;
    var icons = [];

    this.getToolbar = function() {
        if(!toolbar) {
            toolbar = new PgButtonToolbar();
            toolbar.$element.appendTo(this.$element);
            if(!options.toolbar_on) toolbar.hide();
        }
        return toolbar;
    }

    this.addIcon = function(def) {

        this.getToolbar();
        if(def) {
            var item = new PgButtonToolbarItem(def.icon, def.label, def);
            toolbar.addItem('icons', item);
            item.onClick = function () {
                def.func(item);
            }
            return item;
        }
    }

    this.focus = function() {
        input.$input.get(0).focus();
    }

    this.setValue = function(val) {
        term = val;
        input.$input.val(val).trigger(change_event);
        if(!val) {
            pg$Show($icon);
        }
    }

    this.getValue = function() {
        return input.$input.val();
    }

    this.getInput = function() {
        return input;
    }

    this.destroy = function() {
        if(delayTimer) {
            clearTimeout(delayTimer);
            delayTimer = null;
        }
    }

    /*
    input.$input.tooltip({
        container: 'body',
        placement: 'left',
        title: 'Tree Drag & Drop is disabled when filter is set.',
        trigger: 'manual'
    });
    crsaAddCancelSearch($filter, 'top: 11px;right:18px;');
    */
}

var PgSearchBoxSpacer = function() {
    this.$element = $('<div></div>', {class: 'pg-search-box-spacer'});
}


var PgButtonToolbar = function(small) {

    var sections = [];
    var sections_map = {};

    var count = 0;

    this.$element = $('<div class="pg-button-toolbar"></div>');

    if(small) {
        this.$element.addClass('pg-button-toolbar-small');
    }

    this.getSection = function(section) {
        return sections_map[section] || null;
    }

    this.addSection = function(section, align_right) {
        var $element = $('<div class="pg-button-toolbar-section ' + section + '"></div').appendTo(this.$element);

        if(align_right) {
            $element.css('flex-direction', 'row-reverse');
        }
        var def = {key: section, items: [], $element: $element};
        sections.push(def);
        sections_map[section] = def;
        return def;
    }

    this.addItem = function(section, item) {
        var sec = this.getSection(section) || this.addSection(section);
        sec.items.push(item);
        sec.$element.append(item.$element);
        item.section = section;
        count++;
        this.updateCount();
        //if(item.onShown) item.onShown();
    }

    this.removeItem = function(item) {
        var sec = this.getSection(item.section);
        var idx = sec.items.indexOf(item);
        if(idx >= 0) sec.items.splice(idx, 1);
        item.$element.remove();
        count--;
        this.updateCount();
    }

    this.showSection = function(s) {
        var sec = this.getSection(s);
        pg$Show(sec.$element, 'inline-flex');
    }

    this.hideSection = function(s) {
        var sec = this.getSection(s);
        pg$Hide(sec.$element);
    }

    this.show = function() {
        this.$element.show();
    }

    this.hide = function() {
        this.$element.hide();
    }

    this.updateCount = function() {
        this.$element.attr('data-items', count);
    }

    this.destroy = function() {
        sections.forEach(function(s) {
            s.destroy();
        })
        this.$element.remove();
    }
}

var PgButtonToolbarItem = function(icon, label, data, carret) {

    var _this = this;
    var active = false;

    this.dontHandleClicks = false;
    this.data = data;

    if(typeof icon === 'string') {
        var code = icon.startsWith('<') ? icon : '<i class="icon ' + icon + '"></i>';
        this.$element = $('<div class="pg-button-toolbar-item">' + code + '</div>');
    } else {
        this.$element = $('<div class="pg-button-toolbar-item"></div>').append(icon);
    }

    if(!code || code.indexOf('<span') >= 0) {
        this.$element.addClass('has-text');
    }

    if(label) {
        setTimeout(function() {
            addTooltip(_this.$element, label);
        },1)
    }
    this.onClick = function() {};
    this.onContextClick = function() {};
    this.onCarretClick = function() {};

    if(carret) {
        var $carret = $('<i class="icon icon-down carret"></i>').appendTo(this.$element);
        $carret.on('click', function(e) {
            e.preventDefault();
            e.stopPropagation();
            //pgCloseContextMenus();

            _this.onCarretClick.call(_this);
        })
        this.$element.addClass('with-carret');
    }

    this.$element.on('click', function(e) {
        if(_this.dontHandleClicks) return;

        e.preventDefault();
        e.stopPropagation();

        if(!$(this).data('pg-menu')) {
            pgCloseContextMenus();
        }

        _this.onClick.call(_this);
        return false;
    })

    this.$element.on('contextmenu', function(e) {
        e.preventDefault();
        e.stopPropagation();
        //pgCloseContextMenus();

        _this.onContextClick.call(_this);
        return false;
    })

    this.setActive = function(a) {
        active = a;
        if(a) {
            this.$element.addClass('active-item');
        } else {
            this.$element.removeClass('active-item');
        }
        this.$element.addClass('active-toggle');
    }

    this.getActive = function() {
        return active;
    }

    this.show = function() {
        pg$Show(this.$element, 'inline-block');
    }

    this.hide = function() {
        pg$Hide(this.$element);
    }

    this.setLabel = function(label) {
        this.$element.find('span').html(label);
    }

    this.setTooltip = function(label) {
        addTooltip(_this.$element, label);
    }
}

var PgToolbarTabButtons = function(toolbar, section) {

    var _this = this;

    toolbar.addSection(section);

    var tabs = [];
    var active_tab = null;

    var setActive = function(tab) {
        if(active_tab) {
            active_tab.setActive(false);
        }
        tab && tab.setActive(true);
        active_tab = tab;
    }

    this.setActive = setActive;

    var onClick = function() {
        setActive(this);
        if(_this.onTabSelected) _this.onTabSelected(this);
    }

    this.findTabWithData = function(data) {
        for(var i = 0; i < tabs.length; i++) {
            if(tabs[i].data == data) return tabs[i];
        }
        return null;
    }

    this.findTabWithFilter = function(filter) {
        for(var i = 0; i < tabs.length; i++) {
            if(filter(tabs[i])) return tabs[i];
        }
        return null;
    }

    this.addTab = function(label, tooltip, data, active) {
        var tab = new PgButtonToolbarItem('<span>' + label + '</span><i class="icon icon-close"></i>', tooltip, data);

        toolbar.addItem(section, tab);

        tab.onClick = onClick;

        tab.$element.find('i.icon-close').on('click', function(e) {
            _this.removeTab(tab);
            return false;
        })

        tabs.push(tab);

        if(active) {
            onClick.call(tab);
        }

        tab.setClosable = function(v) {
            if(!v) {
                tab.$element.find('.icon-close').remove();
                tab.$element.addClass('without-close');
            }
            return tab;
        }

        return tab;
    }

    this.selectTab = function(tab) {
        onClick.call(tab);
    }

    this.removeTab = function(tab) {
        if(this.onTabClosed) {
            this.onTabClosed(tab);
        }
        toolbar.removeItem(tab);
        var idx = tabs.indexOf(tab);
        if(idx >= 0) {
            tabs.splice(idx, 1);
        }
        if(tab == active_tab) {
            tab = tabs[Math.min(tabs.length-1, idx)];
            var all_checked = false;
            while(tab.tabHidden) {
                idx--;
                if(idx < 0) {
                    if(all_checked) {
                        tab = tabs[0];
                        break;
                    };
                    idx = tabs.length - 1;
                    all_checked = true;
                }
                tab = tabs[Math.min(tabs.length-1, idx)];
            }
            setActive(tab);
            _this.onTabSelected(active_tab);
        }
    }

    this.getTabs = function() {
        return tabs;
    }

    this.hideTab = function(tab) {
        tab.tabHidden = true;
        pg$Hide(tab.$element);
    }

    this.showTab = function(tab) {
        tab.tabHidden = false;
        pg$Show(tab.$element);
    }

    this.isTabVisible = function(tab) {
        return tab.$element.is(':visible');
    }

    this.getActiveTab = function() {
        return active_tab;
    }
}

var PgButtonToolbarItemWithDropdown = function(icon, label, data, carret) {

    var actions = [];

    var _this = this;

    this.addAction = function(name, func, check, show_filter) {
        var def = typeof name == 'object' ? name : {label: name, action: func, check: check, show_filter: show_filter};
        actions.push(def);
    }

    this.clearActions = function() {
        actions = [];
    }

    this.onBeforeShow = function() {};

    this.toolbarItem = new PgButtonToolbarItem(icon, label, data, carret);

    var open = function() {
        var menu = new CrsaContextMenu(null, _this.toolbarItem.$element);

        _this.onBeforeShow.call(_this, menu);

        actions.forEach(function(a) {
            //{label: label, kbd: kbd, action: func, type: type, data: data, check: check, onShow: onShow}
            menu.add(a);
        })
        menu.showForElement(_this.toolbarItem.$element, null, 8);
    }

    this.toolbarItem.onClick = function() {
        if(!carret) {
            open();
        }
    }

    this.toolbarItem.onContextClick = function() {
        open();
    }

    this.toolbarItem.onCarretClick = function() {
        open();
    }
}

var PgButtonToolbarItemWithDropdownView = function(icon, label, data) {

    var _this = this;
    var view = null;
    this.$element = null;
    var $parent;
    var position;
    this.closeButton = true;

    var $close;

    this.onGetView = function() {}
    this.onShown = function() {}

    this.toolbarItem = new PgButtonToolbarItem(icon, label, data);

    this.toolbarItem.onClick = function() {
        if(!view) {
            $parent = _this.toolbarItem.$element.closest('body');

            _this.$element = $('<div class="pg-quick-dropdown"></div>').appendTo($parent);

            if(_this.closeButton) {
                $close = $('<i class="icon icon-close"></i>').appendTo(_this.$element);
                $close.on('click', function(e) {
                    e.preventDefault();
                    _this.close();
                })
            }

            view = _this.onGetView(_this);
            view.view.quickWin = _this;
            _this.$element.append(view.view.get$Element());
            view.view.alwaysVisible = true;
            view.view.updateVisibility();

            if(_this.onShown) _this.onShown(_this);

            position = new PgPositionNextTo$El(_this.$element, _this.toolbarItem.$element, null, 0, 'down');

            if(view.onResized) view.onResized();
        } else {
            _this.close();
        }
    }

    this.autoResize = function(min_h) {
        var h = view.view.get$Element().height();
        if(min_h && h < min_h) h = min_h;
        this.$element.css({
            height: (h + 36) + 'px'
        })
    }


    this.close = function() {
        if(view) {
            position.destroy();
            view.view.destroy();
            _this.$element.remove();
            view = null;
        }
    }


}


var PgZoomControl = function() {

    var _this = this;

    var zoom = 'fit';

    //zoom = 100;

    zoom = pinegrow.getSetting('view-zoom', zoom);

    var zoom_field = new PgInputField('zoom', {
        type: 'select',
        show_empty: false,
        name: 'Zoom',
        without_text: true,
        slider_def_unit: '',
        can_add_items: true,
        append_new_to_list: false,
        //system_field: true,
        options: function() {
            var r = [{key: 'fit', name: 'Fit'}];
            for(var i = 10; i > 0; i--) {
                r.push({key: i * 10, name: (i * 10) + '%'});
            }
            return r;
        }
    });

    zoom_field.setValue(zoom);

    //zoom_field.appendTo($header);
    zoom_field.setWidth(30);

    var onZoomChanged = function(z) {
        zoom = z ? z : zoom_field.getValue();
        if(_this.onSetSize) _this.onSetSize(zoom);

        pinegrow.getAllPages().forEach(function(page) {
            page.view.updateSize();
        })
        pinegrow.setSetting('view-zoom', zoom);
    }

    zoom_field.on('change', function() { onZoomChanged() })

    var decButton = new PgButtonToolbarItem('icon-minus-circle', 'Zoom out ' + pgShowKbdCombo('CMD+-') + '<br>Press ' + pgShowKbdCombo('CMD+0') + ' to reset.');
    var incButton = new PgButtonToolbarItem('icon-plus-circle', 'Zoom in ' + pgShowKbdCombo('CMD+PLUS') + '<br>Press ' + pgShowKbdCombo('CMD+0') + ' to reset.');

    var incDecValue = function(f) {
        var z = getCurrentZoom();
        z += f;
        z = z % 10 == 0 ? z : Math.floor(z/10) * 10;
        if(z <= 10) z = 10;
        zoom_field.setValue(z + '%');
        onZoomChanged(z);
    }

    incButton.onClick = function() {
        incDecValue(10);
    }

    decButton.onClick = function() {
        incDecValue(-10);
    }

    this.addToToolbar = function(tb) {
        tb.addSection('zoom');
        tb.addItem('zoom', decButton);
        tb.addItem('zoom', incButton);

        decButton.$element.addClass('zoom-out');
        incButton.$element.addClass('zoom-in');

        zoom_field.$field.insertAfter(decButton.$element);
    }

    this.zoomOut = function() {
        incDecValue(-10);
    }

    this.zoomIn = function() {
        incDecValue(10);
    }

    this.zoomReset = function() {
        zoom_field.setValue('100%');
        onZoomChanged(100);
    }

    this.getZoom = function() {
        if(zoom == 'fit') return zoom;
        var v = parseInt(zoom);
        if(v <= 0) v = 1;
        if(v > 1000) v = 1000;
        return v;
    }

    var getCurrentZoom = function() {
        if(zoom == 'fit') {
            var page = pinegrow.getSelectedPage();
            if(page) {
                return page.view.currentZoom * 100;
            } else {
                return 100;
            }
        } else {
            return parseInt(zoom);
        }
    }

}

var pgCurrentContextMenu = null;

var pgCloseContextMenus = function() {
    var has = false;
    if(pgCurrentContextMenu) {
        pgCurrentContextMenu.close();
        has = true;
    }
    pgCurrentContextMenu = null;
    return has;
}

var pgMakeParentContextMenusTransparent = function(val) {
    if(val) {
        $('body').addClass('pg-transparent-context-menus');
    } else {
        $('body').removeClass('pg-transparent-context-menus');
    }
}

var CrsaContextMenu = function (pActions, $element, parent_menu) {

    var _this = this;

    if(!parent_menu) {
        if ($element && $element.data('pg-menu')) {
            //menu will handle it
        } else {
            pgCloseContextMenus();
        }
    } else {

    }

    this.open_submenu = null;
    this.submenu_open_on_left = false;

    this.actions = pActions || [];
    this.$target;
    this.targetPgel;
    this.$clicked = $element;
    this.$element = $element;
    this.closeOnMouseOut = false;
    this.keepOpenOnClick = false;
    this.allowRightClick = false;

    var mouse_is_over = false;

    this.onClosed = null;

    this.add = function (label, kbd, func, type, data, check, onShow) {
        if(typeof label == 'object') {
            this.actions.push(label);
        } else {
            if (!type) type = 'link';
            this.actions.push({label: label, kbd: kbd, action: func, type: type, data: data, check: check, onShow: onShow});
        }
        return this.actions[this.actions.length-1]
    }

    this.addMany = function(list) {
        list.forEach(function(a) {
            _this.actions.push(a);
        })
    }

    var $body = $('body');
    var mydoc = document;
    var win = window;

    if($element && getIframeOfElement($element) === null) {
        $body = $element.closest('body');
        mydoc = $element.get(0).ownerDocument;
        win = mydoc.defaultView;
    }

    this.set$Body = function($b) {
        $body = $b;
    }

    this.setDocument = function(doc) {
        mydoc = doc;
    }

    var $menu_ul;
    var $backdrop;
    var $scroll_parent;
    var start_scroll_top;
    var start_y;
    var scroll_offset;
    var menu_h;
    var menu_w;

    var closeTimeout = null;

    this.closed = false;

    this.close = function (close_parents) {
        if(closeTimeout) {
            clearTimeout(closeTimeout);
            closeTimeout = null;
        }
        _this.closed = true;
        if (_this.$clicked) _this.$clicked.removeClass('has-menu');

        if ($menu_ul) {
            pgRemoveMultiselects($menu_ul);
            $menu_ul.remove();
        }
        $menu_ul = null;

        if(this.positioner) {
            this.positioner.destroy();
            this.positioner = null;
        }

        if(!parent_menu) {
            $(mydoc).off('.crsamenu');
        }

        if ($scroll_parent) {
            $scroll_parent.off('.crsamenu');
        }
        if ($backdrop) {
            $backdrop.remove();
            $backdrop = null;
        }
        if(_this.$element) _this.$element.data('pg-menu', 0);

        if(_this.onClosed) _this.onClosed();

        if(parent_menu) {
            parent_menu.open_submenu = null;

            if($element) {
                $element.removeClass('hovered');
            }

            if(close_parents) {
                parent_menu.close(true);
            }

            parent_menu.$menu_ul.removeClass('has-open-submenu')

            if(_this.parent_action.on_submenu_close) {
                _this.parent_action.on_submenu_close();
            }
        }

        if(_this.open_submenu) {
            _this.open_submenu.close();
        }

        if(pgCurrentContextMenu == _this) {
            pgCurrentContextMenu = null;
        }

        pgPreview.hide(); //make it simple, put this here
        crsaFuncs.showInsertionLine(null);
        pgMakeParentContextMenusTransparent(false);
    }

    this.closeSubmenus = function() {
        if(_this.open_submenu) {
            _this.open_submenu.close();
        }
    }

    this.isMouseOverOrSubmenuOpen = function() {
        return mouse_is_over || this.open_submenu;
    }

    this.showForElement = function($el, $scroll, dist, distX, func) {
        dist = dist || 0;
        distX = distX || 0;
        var menu = $el.data('pg-menu');
        if(menu) {
            menu.close();
        } else {
            this.$element = $el;
            $body = $el.closest('body');
            mydoc = $el.get(0).ownerDocument;
            $el.data('pg-menu', this);
            var pos = $el.offset();
            var h = $el.height();
            this.showAtInternal(pos.left + distX, pos.top + h + dist, $scroll, func);
            this.updatePosition();
        }
    }

    this.showAt = function (x, y, $scroll) {
        if($element && $element.data('pg-menu')) {
            $element.data('pg-menu').close();
        } else {
            if($element) {
                $element.data('pg-menu', this);
            }
            this.showAtInternal(x, y, $scroll);
        }
    }

    this.showAtPgel = function(pgel) {
        this.showAt(0, 0);
        this.positioner = new PgPositionNextToPgel($menu_ul, pgel, null);
        this.updatePosition()
    }

    this.showAtInternal = function (x, y, $scroll, func) {

        if (this.actions.length === 0) return;

        if(parent_menu) {
            parent_menu.open_submenu = this;
        }

        if (_this.$clicked) _this.$clicked.addClass('has-menu');

        if(!parent_menu) {
            $(mydoc).trigger('click');
        }

        $menu_ul = $('<ul class="dropdown-menu context-menu" role="menu"></ul>');
        $.fn.crsa('buildActionsDropDownMenu', this.actions, this.targetPgel, $menu_ul, this.close, this);

        if(this.allowRightClick) {
            $menu_ul.addClass('pg-allow-right-click');
        }

        this.$menu_ul = $menu_ul;

        if(this.onBeforeMenuShown) {
            this.onBeforeMenuShown();
        }

        $body.append($menu_ul);

        if(this.inModal) {
            $menu_ul.css('z-index', 2000);
        }

        if(func) {
            var pos = func($menu_ul, x, y);
            if(pos) {
                x = pos.x;
                y = pos.y;
            }
        }

        if(this.in_dialog) {
            $menu_ul.css('zIndex', 2000);
        }

        $menu_ul.css('top', y + 'px').css('left', x + 'px');

        var start_y = y;
        var start_x = x;

        if ('ontouchstart' in mydoc.documentElement) {
            $backdrop = $('<div class="dropdown-backdrop"/>').insertBefore($menu_ul).on('click', this.close);
        }

        $menu_ul
            .on('click', function(e) {
                if($(e.target).closest('.crsa-field')) {
                    return;
                }
                e.preventDefault();
                _this.close();
            })
            .on('contextmenu', function(e) {
                if(_this.allowRightClick) return;
                _this.close();
                return false;
            })

        if(parent_menu) {
            $menu_ul.on('mouseleave', function() {
                if(!_this.open_submenu) {
                    _this.close();
                }
                mouse_is_over = false;
            })
        }

        $menu_ul.on('mouseleave', function() {
            if(_this.closeOnMouseOut && !_this.open_submenu) {
                _this.close();
            }
            mouse_is_over = false;
        })

        $menu_ul.on('mouseenter', function() {
            mouse_is_over = true;
        })

        if(!parent_menu) {
            $(mydoc)
                .off('.crsamenu')
                .on('click.crsamenu', function (e) {
                    if (!$.contains($menu_ul.get(0), e.target)) {
                        _this.close();
                    }
                });

        }

        if ($scroll) {
            $scroll
                .off('.crsamenu')
                .on('scroll.crsamenu', function (event) {
                    var ny = (start_y + (start_scroll_top - $scroll.scrollTop()));
                    $menu_ul.css('top', ny + 'px');
                    var cy = 0;
                    if (ny < scroll_offset) {
                        cy = scroll_offset - ny - 2;
                        if (cy < 0) cy = 0;
                    }
                    $menu_ul.css('clip', 'rect(' + cy + 'px, ' + menu_w + 'px, ' + menu_h + 'px, 0px)');
                });
            start_scroll_top = $scroll.scrollTop();
            scroll_offset = $scroll.offset().top;
        }
        $scroll_parent = $scroll;

        $menu_ul.data('menu', this);
        $menu_ul.show();

        menu_h = $menu_ul.outerHeight();
        menu_w = $menu_ul.outerWidth();

        var winh = $(win).height();

        if ($scroll || true) {
            if (start_y + menu_h > winh) {
                start_y = winh - menu_h;//start_y - menu_h;
                if (start_y < 0) {
                    start_y = 0;
                    $menu_ul.css({
                        top: start_y + 'px',
                        height: (winh) + 'px',
                        overflowY: 'auto'
                    })
                } else {
                    $menu_ul.css('top', start_y + 'px')
                }
            }
            var ww = $(win).width()
            if (start_x + menu_w > ww - 4) {
                start_x = ww - menu_w - 4;
                if(start_x < 4) {
                    start_x = 4;
                    $menu_ul.css('max-width', '98%');
                }
                $menu_ul.css('left', start_x + 'px')
            }
        }

        this.resetCloseTimer();

        if(!parent_menu) {
            pgCurrentContextMenu = this;
        }

        this.actions.forEach(function(a) {
            a.on_menu_shown && a.on_menu_shown(a)
        })

        return $menu_ul;
    }

    this.resetCloseTimer = function() {
        if(closeTimeout) {
            clearTimeout(closeTimeout);
        }
        closeTimeout = setTimeout(function() {
            _this.close();
        }, pgIsDev() ? 1000000 : 30000)

        if(parent_menu) {
            parent_menu.resetCloseTimer();
        }
    }

    this.updatePosition = function (insidePage) {
        if(!$menu_ul) return;

        if(this.positioner) {
            this.positioner.reposition();
            return;
        }

        var $parent, topOffset = 0, leftOffset = 0;
        if (insidePage) {
            $parent = $menu_ul.parent();
            topOffset = $parent.offset().top;
            leftOffset = $parent.offset().left;
        }
        else {
            $parent = $(win);
        }

        var menu_offset = $menu_ul.offset();
        var menu_h = $menu_ul.height();
        var parent_h = $parent.height();

        if (menu_h + menu_offset.top > parent_h + topOffset) {
            //can we show on top?
            if(menu_offset.top - menu_h > 0) {
                $menu_ul.css({
                    top: (menu_offset.top - menu_h) + 'px'
                })
            } else {
                var offset = (menu_offset.top + menu_h) - (topOffset + parent_h);
                var newTop = menu_offset.top;//parseInt($menu_ul.css('top'), 10) - offset;
                var new_h = parent_h - 10 + topOffset - menu_offset.top;

                //if(new_h > parent_h - )

                $menu_ul.css({
                    'height': new_h,
                    'overflow-y': 'auto'
                    // 'top': '0'
                });
            }
        }
        var mulw = $menu_ul.width();
        var pw = $parent.width();

        if (mulw + menu_offset.left > pw + leftOffset) {

            var right_space = pw - menu_offset.left - mulw;
            var left_space = menu_offset.left;

            if(right_space > left_space || true) {
                //more space on right?
                var offset = (menu_offset.left + mulw) - (leftOffset + $parent.width());
                var newLeft = parseInt($menu_ul.css('left'), 10) - offset;
            } else {
                //on left
                newLeft = 0;
            }
            $menu_ul.css('left', newLeft);
        }
    }
}


var PgDropdownButton = function(label, onClick) {

    var _this = this;

    this.$element = $('<a href="#" class="actions button">' + (label ? '<span>' + label + '</span> ' : '') + '<i class="icon icon-down"></i></a>')
        .on('click', function(e) {
            onClick(e, _this);
            return false;
        })

    this.setTooltip = function(tip) {
        addTooltip(this.$element, tip);
    }

}

var PgDropdownMenu = function($target) {

    var _this = this;

    this.onGetActions = null;

    $target.on('click', function(e) {
        e.preventDefault();

        $target.addClass('open');

        var menu = new CrsaContextMenu(null, $target);
        _this.onGetActions(menu);

        menu.onClosed = function() {
            $target.removeClass('open');
        }

        menu.showForElement($target, $target.closest('body'));

        return false;
    })

    this.show = function($target) {
        var menu = new CrsaContextMenu(null, $target);
        _this.onGetActions(menu);

        menu.onClosed = function() {
            $target.removeClass('open');
        }

        menu.showForElement($target, $target.closest('body'), 8);
    }
}


var pgShowKbd = function(str) {
    return '<kbd>' + crsaGetKbdDisplay(str, true) + '</kbd>';
}

var pgShowKbdCombo = function(str) {
    var a = str.split('+');
    for(var i = 0; i < a.length; i++) {
        a[i] = a[i].replace(/^PLUS$/,'+');
        a[i] = pgShowKbd(a[i]);
    }
    return a.join(' + ');
}

var PgPreview = function() {

    var _this = this;

    var previewView = $('<div/>', {id: "crsa-preview", class: 'preview'}).html('<div class="content clearfix"></div><div class="description"></div><div class="pre-holder"><pre></pre></div>').appendTo($('body'));

    previewView.on('mouseover mousemove', function(e) {
        _this.hide();
    })

    this.isVisible = function() {
        return previewView.is(':visible');
    }

    var $c = previewView.find('>.content');
    var $desc = previewView.find('>.description');

    pg$Hide(previewView);

    var shown = false;

    this.setContentSize = function(w, h) {
        $c.css({
            width: w + 'px',
            height: h + 'px'
        })
        if(w > 0) {
            previewView.css({
                width: (w + 16) + 'px'
            })
        }
    }

    this.setDescription = function(html) {
        $desc.html(html);
        pgShow($desc.get(0));
    }

    var $current_target = null;

    this.show = function($target, $content, cls, code, description) {

        var $el = $content;

        $current_target = $target;

        var task = pgGetFastdomTasks($target.get(0)).create('showPreview');

        var win = $target.get(0).ownerDocument.defaultView;
        if(win !== previewView.get(0).ownerDocument.defaultView) {
            previewView.appendTo(win.document.body);
        }

        task.mutate(function() {

            if(!$el) {
                $el = $('<div style="display:none;"></div>');
                pgHide($c.get(0));
            } else {
                pgShow($c.get(0));
            }
            if(description) {
                $desc.html(description);
                pgShow($desc.get(0));
            } else {
                $desc.html('');
                pgHide($desc.get(0));
            }
            if($el) {
                $c.html('');

                if(_this.onShowFirstMutate) {
                    _this.onShowFirstMutate(win);
                    _this.onShowFirstMutate = null;
                } else {
                    $c.append($el);
                }

                if(cls) {
                    previewView.addClass(cls).data('custom-class', cls);
                }

                $c.css({
                    width: '',
                    height: ''
                })
                previewView.css({
                    width: ''
                })

                var $pre = previewView.find('>div.pre-holder pre');
                if(code) {
                    code = pinegrow.formatHtml(code);
                    $pre.html(escapeHtmlCode(code));
                    pgShow($pre.parent().get(0));
                } else {
                    pgHide($pre.parent().get(0));
                }

                task.measure(function() {
                    var o = $target.offset();
                    var wh = $(win).height();
                    var ww = $(win).width();
                    var ph = previewView.height();
                    var y = o.top - ph/2;
                    if(y + ph > wh) y = wh - ph;

                    var pvw = previewView.width();
                    var $container = $target.closest('.pg-grid-col');
                    if ($container.length == 0) $container = $target;

                    var pos_info = {};

                    var x = getPreviewPosition(pvw, $container, pos_info, win);

                    var fixed = false;

                    if(x + pvw > ww) {
                        x = 0;
                        if(y < wh / 2) {
                            //y = wh - ph - 48;
                            y = y + 80;
                        } else {
                            y = 0;
                        }
                        fixed = true;
                    }

                    pos_info.x = x;
                    pos_info.y = y;

                    //console.log('p show measure');

                    if(_this.onShowSecondMeasure) {
                        _this.onShowSecondMeasure();
                        _this.onShowSecondMeasure = null;
                    }

                    task.mutate(function() {
                        pgShow(previewView.get(0));
//console.log('p show');
                        if(_this.onShowThirdMutate) {
                            var newpos = _this.onShowThirdMutate(x, y, pos_info, fixed);
                            if(newpos) {
                                x = newpos.x;
                                y = newpos.y;
                            }
                            _this.onShowThirdMutate = null;
                        }

                        previewView.css({left: x + 'px', top: y + 'px'});

                        shown = true;
                    })

                })
            }
        })
    }

    this.hide = function() {
        //return;

        if(!shown) return;

        var task = pgGetFastdomTasks($current_target ? $current_target.get(0) : null).create('showPreview');

        if(_this.onHide) {
            _this.onHide();
            _this.onHide = null;
        }

        task.mutate(function() {
            shown = false;
            $c.empty();
            pg$Hide(previewView);
            //console.log('p hide');
            var cls = previewView.data('custom-class');
            if(cls) previewView.removeClass(cls).data('custom-class', null);
        })
    }

    var getPreviewPosition = function(preview_w, p, info, win) {
        info = info || {};
        win = win || window;
        var o = p.offset();
        var w = $(window).width();

        info.win_w = w;
        info.target_pos = o;
        info.container_w = p.width();

        info.win_h = $(win).height();

        var x = 0;

        if(o.left > w - o.left - info.container_w) {
            //more space on left
            info.pos = 'left';
            x = o.left - preview_w - 20;
            if(x < 0) x = 0;
        } else {
            info.pos = 'right';
            x = o.left + info.container_w + 0;
            if(x + preview_w > w) {
                x = w - preview_w;
            }
        }
        return x;
    }
}

var pgPreview = new PgPreview();

var pgOpenViewInFloatingPanel = function(name, key, view) {


    var stack = myLayout._$normalizeContentItem({
        type: 'stack', // Stack
        width: 15,
        isClosable: false,
        isFloating: true,
        isAutoDocked: false,
        content: [
            {
                type: 'component',
                componentName: 'custom',
                title: name,
                isClosable: false
            }
        ]
    });

    //myLayout.root.contentItems[ 0 ].addChild( stack );

    stack.contentItems[0].container.getElement().append(view.get$Element());

    view.addedToLayout(stack.contentItems[0].container);

    return stack;
}

var PgMoverAndResizer = function($el, $dragHandle, $resizeHandle, parentSelector) {

    var _this = this;
    var drag = typeof $dragHandle == 'string' ? new PgDragHelper($el, $dragHandle) : new PgDragHelper($dragHandle);

    this.dragListener = drag;

    this.wholeVisible = false;

    var original_x = 0;
    var page_offset_y = 0;
    var el_offset_x = 0;
    var el_offset_y = 0;

    var pos_x = 0;
    var pos_y = 0;

    drag.on( 'dragStart', function(x, y) {
        var $gl = $el.closest(parentSelector);
        var gl_pos = $gl.offset();
        page_offset_y = gl_pos.top;

        var el_pos = $el.offset();
        el_offset_x = x - el_pos.left;
        el_offset_y = y - el_pos.top;

        $.fn.crsapages('showOverlays');
    }, this );

    drag.on( 'drag', function(x, y, event) {
        x = event.pageX;
        y = event.pageY;

        pos_x = (x - el_offset_x);
        pos_y = (y - page_offset_y - el_offset_y);

        $el.css({
            left: pos_x + 'px',
            top: pos_y + 'px'
        })

        if(_this.onMoveDrag) _this.onMoveDrag();
    }, this );

    drag.on( 'dragStop', function(x, y) {
        $.fn.crsapages('showOverlays', true);

        ensureFloatingPanelIsVisible($el, function() {
            if(_this.onMove) _this.onMove(pos_x, pos_y);
        }, _this.wholeVisible);
    }, this );

    var drag_resize = new GoldenLayout.__lm.utils.DragListener($resizeHandle, null, false);

    this.dragResizer = drag_resize;

    var resize_original_x = 0;
    var resize_page_offset_y = 0;
    var resize_el_offset_x = 0;
    var resize_el_offset_y = 0;
    var resize_original_w = 0;
    var resize_original_h = 0;

    var resize_max_w;
    var resize_max_h;

    drag_resize.on( 'dragStart', function(x, y) {
        var $gl = $el.closest(parentSelector);
        var el_pos = $el.position();

        resize_original_w = $el.width();
        resize_original_h = $el.height();

        resize_max_w = $gl.width() - el_pos.left;
        resize_max_h = $gl.height() - el_pos.top;

        $.fn.crsapages('showOverlays');
    }, this );

    drag_resize.on( 'drag', function(x, y, event) {

        var w = Math.max(200, Math.min(resize_original_w + x, resize_max_w));
        var h = Math.max(200, Math.min(resize_original_h + y, resize_max_h));

        $el.css({
            width: w + 'px',
            height: h + 'px'
        })

        if(_this.onResize) _this.onResize(w, h);
    }, this );

    drag_resize.on( 'dragStop', function(x, y) {
        $.fn.crsapages('showOverlays', true);
        ensureFloatingPanelIsVisible($el, null, _this.wholeVisible);
    }, this );

    this.destroy = function() {
        drag.destroy();
        drag_resize.destroy();
    }

    this.ensureVisible = function(whole, no_animation, done) {
        return ensureFloatingPanelIsVisible($el, done, whole, no_animation);
    }

    var ensureFloatingPanelIsVisible = function(element, done, whole, no_animation) {
        var win_w = window.innerWidth;
        var win_h = window.innerHeight;
        var el_pos = element.offset();
        var el_w = element.width();
        var el_h = element.height();

        var uitop = 38;

        var $gl = element.closest(parentSelector);

        if(parentSelector == '.lm_goldenlayout') {
            uitop = 0;
            win_h = $gl.height();
        }

        if($gl.length == 0) {
            if(done) done();
            return;
        }

        var gl_pos = $gl.offset();

        el_pos.top -= gl_pos.top;

        var changed = false;
        var changed_size = false;

        if(el_pos.top < uitop /*-gl_pos.top*/) {
            el_pos.top = uitop /*gl_pos.top*/;
            changed = true;
        }

        var atleast_y = 40;

        var whole_x = false;
        var whole_y = false;

        if(whole) {
            if(whole === 'width') {
                whole_x = true;
            } else if(whole === 'height') {
                whole_y = true;
            } else {
                whole_x = whole_y = true;
            }
        }

        if(whole_y) atleast_y = el_h;

        if(win_h - el_pos.top  - gl_pos.top < atleast_y) {
            el_pos.top = win_h - atleast_y - gl_pos.top;
            changed = true;
        }

        var atleast_x = 40;

        if(whole_x) atleast_x = el_w;

        if(el_pos.left + el_w< atleast_x) {
            el_pos.left = -el_w + atleast_x;
            changed = true;
        }

        if(el_pos.left > win_w - atleast_x) {
            el_pos.left = win_w - atleast_x;
            changed = true;
        }

        if(whole_y && el_pos.top < uitop) {
            el_pos.top = uitop;
            if(el_pos.top + el_h > win_h) {
                el_h = win_h - uitop;
                changed = changed_size = true;
            }
        }
        if(whole_y && el_pos.top + el_h > win_h) {
            el_pos.top = win_h - el_h;
            if(el_pos.top < 0) {
                el_h = win_h - uitop;
                el_pos.top = uitop;
                changed = changed_size = true;
            }
        }

        if(whole_x && el_pos.left < 0) {
            el_pos.left = 0;
            if(el_pos.left + el_w > win_w) {
                el_w = win_w;
                changed = changed_size = true;
            }
        }
        if(whole_x && el_pos.left + el_w > win_w) {
            el_pos.left = win_w - el_w;
            if(el_pos.left < 0) {
                el_w = win_w;
                changed = changed_size = true;
            }
        }

        if(changed) {
            if(!no_animation) element.addClass('lm_floating_animate');
            element.css({
                left: el_pos.left + 'px',
                top: el_pos.top + 'px'
            })
            if(changed_size) {
                element.css({
                    width: el_w + 'px',
                    height: el_h + 'px'
                })
            }
            if(!no_animation) {
                setTimeout(function () {
                    element.removeClass('lm_floating_animate');
                    if (done) done(changed, changed_size);
                }, 500)
            } else {
                if(done) done(changed, changed_size);
            }
        } else {
            if(done) done();
        }

        if(changed || changed_size) {
            return {
                x: el_pos.left,
                y: el_pos.top,
                w: el_w,
                h: el_h
            }
        }
    }

}

var pgDoElementsIntersect = function(ela, elb) {
    var a = ela.getBoundingClientRect();
    var b = elb.getBoundingClientRect();
    return !(a.left+a.width<b.left || a.left > b.left + b.width || a.top+a.height<b.top || a.top > b.top + b.height);
    }

var pgConnectorId = 0;

var PgConnector = function() {
    this.fromRect = null;
    this.toRect = null;
    this.$from = null;
    this.$to = null;
    this.parent;
    this.color = 'orange';
    this.fromOffset = 0;
    this.toOffset = 0;

    var colors = {
        orange: '#ffa14d',
        blue: '#0098cc'
    }

    this.create = function() {
        pgConnectorId++;
        var id = 'connector_' + pgConnectorId;

        //<line stroke-width="4" stroke="' + colors[this.color] + '" x1="100" y1="100" x2="500" y2="300" id="' + id + '"/>

        var svg = $('<svg><path fill="none" stroke-width="4" stroke="' + colors[this.color] + '" d="M149,106 C251,110 285,276 398,284" id="' + id + '" /><circle id="' + id + '_c1" r="4" fill="' + colors[this.color] + '"/><circle id="' + id + '_c2" r="4" fill="' + colors[this.color] + '"/></svg>');

        this.$element = svg.find('#' + id);
        this.$circle1 = svg.find('#' + id + '_c1');
        this.$circle2 = svg.find('#' + id + '_c2');
    }

    this.updatePosition = function() {
        var visible = true;
        if(this.$from) {
            var $from = this.$from.closest(':visible');
            if($from.length) {
                this.fromRect = $from.get(0).getBoundingClientRect();
            } else {
                visible = false;
            }
        }
        if(this.$to) {
            var $to = this.$to.closest(':visible');
            if($to.length) {
                this.toRect = $to.get(0).getBoundingClientRect();
            } else {
                visible = false;
            }
        }

        if(this.$from.get(0).ownerDocument !== this.$to.get(0).ownerDocument) {
            visible = false;
        }

        var a = this.fromRect;
        var b = this.toRect;

        var intersects = !visible || !(a.left+a.width<b.left || b.left+b.width<a.left || a.top+a.height<b.top || b.top+b.height<a.top);

        var color;
        if(intersects) {
            color = 'none';
        } else {
            color = colors[this.color];
        }
        this.$element.attr('stroke', color);
        this.$circle1.attr('fill', color);
        this.$circle2.attr('fill', color);

        if(intersects) return;

        var points = getClosestPoint(this.fromRect, this.toRect, this.fromOffset, this.toOffset);

      /*  this.$element.attr('x1', points.a[0]);
        this.$element.attr('y1', points.a[1]);
        this.$element.attr('x2', points.b[0]);
        this.$element.attr('y2', points.b[1]);*/

        var cx1, cy1, cx2, cy2;

        if(points.a[2] == 'H') {
            cx1 = (points.a[0] + points.b[0])/2;
            cy1 = points.a[1];
        } else {
            cy1 = (points.a[1] + points.b[1])/2;
            cx1 = points.a[0];
        }
        if(points.b[2] == 'H') {
            cx2 = (points.b[0] + points.a[0])/2;
            cy2 = points.b[1];
        } else {
            cy2 = (points.b[1] + points.a[1])/2;
            cx2 = points.b[0];
        }

        var d = 'M' + points.a[0].toString() + ',' + points.a[1].toString() + ' C' + cx1.toString() + ',' + cy1.toString() + ' ' + cx2.toString() + ',' + cy2.toString() + ' ' + points.b[0].toString() + ',' + points.b[1].toString();

        this.$element.attr('d', d);

        this.$circle1.attr('cx', points.a[0]);
        this.$circle1.attr('cy', points.a[1]);
        this.$circle2.attr('cx', points.b[0]);
        this.$circle2.attr('cy', points.b[1]);
    }

    this.show = function() {
        this.updatePosition();
    }

    var makePoints = function(a, offset) {
        return [
            [a.left + a.width/2, a.top + offset, 'V'],
            [a.left + a.width - offset, a.top + a.height/2, 'H'],
            [a.left + a.width/2, a.top + a.height - offset, 'V'],
            [a.left + offset, a.top + a.height/2, 'H']
        ]
    }

    var getClosestPoint = function(a, b, ao, bo) {
        var points_a = makePoints(a, ao);
        var points_b = makePoints(b, bo);

        var min_d = 9999999999999;
        var min_p = null;

        points_a.forEach(function(pa) {
            points_b.forEach(function(pb) {
                var d = (pa[0] - pb[0])*(pa[0] - pb[0]) + (pa[1] - pb[1])*(pa[1] - pb[1]);
                if(d < min_d) {
                    min_d = d;
                    min_p = {a: pa, b: pb};
                }
            })
        })
        return min_p;
    }

    this.destroy = function() {
        if(this.$element) {
            this.$element.remove();
            this.$circle1.remove();
            this.$circle2.remove();
            this.parent.remove(this);
        }
    }
}

var PgConnectors = function() {

    var list = [];

    var $svg = $('<svg class="pg-connectors" width="100%" height="100%"></svg>').appendTo($('body'));
    pg$Hide($svg);

    this.add = function(c) {
        var idx = list.indexOf(c);
        if(idx >= 0) list.splice(idx, 1);
        list.push(c);

        pg$Show($svg);

        c.create();
        $svg.append(c.$element);
        $svg.append(c.$circle1);
        $svg.append(c.$circle2);
        c.parent = this;
        c.show();

    }

    this.remove = function(c) {
        var idx = list.indexOf(c);
        if(idx >= 0) list.splice(idx, 1);

        if(list.length === 0) {
            pg$Hide($svg);
        }
    }

    this.update = function() {
        list.forEach(function(c) {
            c.updatePosition();
        })
    }

}



var PgPageViewHelper = function(label, key, classname, $toggle, css, default_value, framework, select_color, default_color, dont_add_to_helpers_menu) {

    var colors = {
        lightblue: '#00BFFF',
        blue: '#6875ff',
        green: '#00d021',
        yellow: '#fdff00',
        orange: '#ffba00',
        darkorange: '#ff7f00',
        red: '#ff5858',
        purple: '#e100ff',
        gray: '#848484'
    }

    var selected_color = default_color || 'blue';

    var _this = this;

    if(!$toggle) $toggle = $('<div></div>');

    if(default_value === undefined) default_value = "1";

    var current_value = true;
    var in_ui = false;
    var not = false;

    this.onChange = function() {};
    this.onExtraCmd = function() {};
    this.onGetCurrentValue = null;

    if(classname.startsWith('UI:')) {
        in_ui = true;
        classname = classname.replace('UI:', '');
    }

    if(classname.startsWith('!')) {
        not = true;
        classname = classname.replace('!', '');
    }

    var set_mark_areas = function(value) {
        var on = dont_add_to_helpers_menu ? true : pinegrow.getShowDisplayHelpers();

        var show_value = value && on;

        if(not) {
            show_value = !value || !on;
        }

        if(in_ui) {
            if(show_value) {
                $('body').addClass(classname);
            } else {
                $('body').removeClass(classname);
            }
        } else {
            $.each(pinegrow.getAllPages(), function (i, cp) {
                cp.getPageViews().forEach(function (pv) {
                    var $html = pv.get$Html();
                    if ($html) {
                        if (show_value) {
                            $html.addClass(classname);
                        } else {
                            $html.removeClass(classname);
                        }
                    }
                })
            })
        }
        var $mark_areas_checkbox = $toggle.find('i');
        if(value) {
            $mark_areas_checkbox.show();
        } else {
            $mark_areas_checkbox.hide();
        }
        if(current_value != value) {
            _this.onChange(value);
        }
        current_value = value;
    }

    set_mark_areas(pinegrow.getSetting(key, default_value) === '1');
    if(select_color) {
        selected_color = pinegrow.getSetting(key + '-color', selected_color)
    }

    var toggle = function($li, force) {
        var value = (!current_value) || force;
        set_mark_areas(value);
        pinegrow.setSetting(key, value ? '1' : '0');

        if($li) {
            var $i = $li.find('i');
            if(value) {
                pg$Show($i);
            } else {
                pg$Hide($i);
            }
        }
    }

    this.setValue = function(val) {
        current_value = !val;
        toggle();
    }

    $toggle
        .on('click', function(e) {
            e.preventDefault();
            toggle();
        });

    var onPageLoadReload = function() {
        set_mark_areas(pinegrow.getSetting(key, default_value) == '1');
    }

    pinegrow.addEventHandler('on_page_loaded', onPageLoadReload);
    pinegrow.addEventHandler('on_page_refreshed', onPageLoadReload);

    if(!dont_add_to_helpers_menu) {
        pinegrow.addEventHandler('on_show_display_helpers_changed', function (pagenull, value) {
            onPageLoadReload();
        });
    }

    var getSelectedColorValue = function() {
        return colors[selected_color] || colors[default_color] || 'red';
    }

    if(css) {
        pinegrow.addEventHandler('on_set_inline_style', function(page, o) {
            o.css += css.replace(/\#COLOR\#/g, getSelectedColorValue());
        })
    }

    var getCurrentValue = this.getCurrentValue = function() {
        return _this.onGetCurrentValue ? _this.onGetCurrentValue() : current_value;
    }

    var a = {
        label: label,
        action: function(none, e, $li) {
            toggle($li);
            pinegrow.selectedElements.reselect();
        },
        check: function() {
            return getCurrentValue()
        },
        show_filter: function() {
            //show filter
            if(framework) {
                var page = pinegrow.getSelectedPage();
                if(!page || !page.hasFramework(framework)) return false;
            }
            return true;
        },
        extra_action: function() {
            _this.onExtraCmd();
        }
    }

    var getColorSubmenu = function() {
        var submenu = []
        var buttons = [];

        $.each(colors, function(col, val) {
            buttons.push({
                label: `<span class="pg-menu-color-swatch" style="background:${val};"></span>`,
                //check: col === selected_color,
                action: function() {
                    selected_color = col;
                    pinegrow.setSetting(key + '-color', selected_color);
                    pinegrow.getAllPages().forEach(function(page) {
                        page.addCrsaStyles()
                    })
                    toggle(null, true)
                }
            })
        })
        submenu.push({
            buttons: buttons
        })
        submenu.push({
            type: 'divider'
        })
        submenu.push({
            label: 'None',
            action: function() {
                toggle(null, false)
            }
        })
        return submenu;
    }

    if(select_color) {
        a.submenu = getColorSubmenu;
        a.submenu_class = 'pg-menu-fixed-size-md';
        a.label += `<span class="pg-menu-color-swatch pg-menu-color-swatch-right" style="background:${getSelectedColorValue()};"></span>`;
        a.on_painted = function($li) {
            $li.find('.pg-menu-color-swatch').css('background', getSelectedColorValue())
        }
    }

    if(!dont_add_to_helpers_menu) {
        pinegrow.helpersToolbarItem.addAction(a);
    }
}


var PgArrowsMover = function($input, $container, sel, section_sel) {

    var _this = this;

    var $item = null;

    this.flat = true;
    this.select_first = false;

    $input.on('focus.mover', function(e) {
            select(_this.get$Item());
        });

    $input.on('blur.mover', function(e) {
            select(null);
        });

    $input.on('keydown.mover', function(e) {
            var $i;
            switch(e.key) {
                case 'ArrowDown':
                    if($item) {
                        $i = $item.next();
                    } else {
                        $i = $container.find(sel).first();
                    }
                    select($i);
                    return false;
                    break;
                case 'ArrowUp':
                    if($item) {
                        $i = $item.prev();
                    } else {
                        $i = $container.find(sel).last();
                    }
                    select($i);
                    return false;
                    break;
                case 'Enter':
                    _this.onEnter($item);
                    return false;
                    break;
            }
        })


    /*
    var getNextSection = function($item) {
        if($item) {
            var $c = $item.closest(section_sel).next(section_sel);

        }
    }

    var getNext = function($item) {
        var $n = $item.next(sel);
        if($n.length) return $n;

        if(section_sel) {
            if($item) {
                var $s = $item.closest(section_sel);
                if($s)
            }
        }

        var $all = $
        while(true) {
            var $i = $p.find(sel).first();
            if($i.length) return $i;
        }
    }*/

    this.onEnter = function() {};

    this.get$Item = function() {
        if(!$item && this.select_first) {
            $item = $container.find(sel).first();
        }
        return $item;
    }

    this.set$Item = function($i) {
        select($i);
    }

    var select = function($i) {
        if($i && $i.length === 0) $i = null;
        if($item) {
            $item.removeClass('arrow-selected');
        }
        if($i) {
            $i.addClass('arrow-selected');
            pgScrollToItemInContainer($i, $container);
        }
        $item = $i;
        _this.onSelected && _this.onSelected($item)
    }

    this.update = function(attr, func) {
        var $selectedItem = this.get$Item();
        var selected_id = null;
        if($selectedItem) selected_id = $selectedItem.attr(attr);

        func && func();

        if(selected_id) {
            $selectedItem = $container.find('[' + attr + '="' + selected_id + '"]');
            if($selectedItem.length == 0) {
                $selectedItem = $container.find(sel + ':first');
            }
            this.set$Item($selectedItem);
        }
    }

    this.destroy = function() {
        $input.off('.mover');
    }
}

var PgDelayedTasks = function() {

    var timers = {}
    var funcs = {}

    this.cancel = function(key) {
        if(timers[key]) {
            clearTimeout(timers[key]);
            delete timers[key];
            delete funcs[key];
        }
    }

    this.run = function(key, func, delay) {
        this.cancel(key);

        timers[key] = setTimeout(function() {
            func();
            delete timers[key];
            delete funcs[key];
        }, delay)

        funcs[key] = func;
    }

    this.runAllNow = function() {
        $.each(timers, function(key, timer) {
            clearTimeout(timer);
            funcs[key]();
        })
        timers = {}
        funcs = {}
    }

    this.clearAll = function() {
        $.each(timers, function(key, t) {
            clearTimeout(t);
        })
        timers = {}
        funcs = {}
    }

    this.destroy = function() {
        this.clearAll();
    }
}



var PgQuickDialog = function(title, html, options) {

    options = $.extend(defs, options || {})

    var v = new PgQuickDialogView(html);

    var defs = {
        key: 'quickDialog' + v.view.getId(),
        width: 400,
        target: null,
        auto_size_padding: 80,
        on_close: null
    }

    options = $.extend(defs, options || {})

    var win = this.win = new PgQuickWindow(title, v, options.key , options.width, 250);

    if(options.target) {
        win.showFor$El(options.target);
    } else {
        win.showAtRandomPosition();
    }

    win.autoSize(options.auto_size_padding);

    win.onDestroy = function() {
        if(options.on_close) options.on_close();
    }
}

var PgQuickDialogView = function(html) {

    var _this = this;

    var $element = $('<div class="pg-quick-dialog"></div>');

    var view = this.view = new PgUIView($element);

    var $el = typeof html == 'string' ? html : html($element);

    $element.append($el);

    //pinegrow.addEventHandler('on_selected_elements_changed', onSelected);

    view.onDestroy = function() {
        //pinegrow.removeEventHandler('on_selected_elements_changed', onSelected);
    }
}


var PgWorkflowMode = function(key, name) {

    this.activate = function() {

    }

    this.deactivate = function() {

    }
}



var PgFocusBarMode = function() {

    this.mode = null;
    this.pgel = null;
    this.name = null;
    this.onlyTopLevel = false;
    this.insert = [];
    this.isActiveForPgel = function(pgel) { return false; };
    this.getName = function(pgel) {
        if(pgel) {
            return this.name + ' - ' + pgel.getName({short: true});
        } else {
            return this.name;
        }
    }
    this.getPgelForPage = function(page, done) { done(null); };
    this.onActivated = function(pgel) {};
}

var PgFocusBar = function() {

    var _this = this;
    var modes = [];

    var body_mode = new PgFocusBarMode();
    body_mode.mode = 'body';
    body_mode.name = 'Page Layout';
    body_mode.onlyTopLevel = true;
    body_mode.isActiveForPgel = function(pgel) {
        return pgel.tagName === 'body';
    }
    body_mode.getPgelForPage = function(page, done) {
        done(page.sourceNode.findOne('body'));
    }
    body_mode.onActivated = function(pgel) {
        pinegrow.showUIPanel('tree', false, true /* if not collapsed */);
    }

    modes.push(body_mode);

    ///

    var page_mode = new PgFocusBarMode();
    page_mode.mode = 'html';
    page_mode.name = 'Page Settings';
    page_mode.isActiveForPgel = function(pgel) {
        return pgel.tagName === 'html';
    }
    page_mode.getPgelForPage = function(page, done) {
        done(page.sourceNode.findOne('html'));
    }
    page_mode.onActivated = function(pgel) {
        pinegrow.selectElement(pgel.getPage().sourceNode.findOne('html'));
        pinegrow.showUIPanel('prop', false);
    }

   // modes.push(page_mode);

    ///

    var current_mode = null;
    var current_pgel = null;

    this.$element = $(`<div class="pg-focus-bar"><i class="pg-focus-bar-decoration icon icon-focus"></i>
<div class="pg-focus-bar-title">Focusing on&nbsp;<span class="pg-focus-bar-title-object"></span><i class="icon icon-close"></i></div>
<div class="pg-focus-bar-insert"><label>Insert:</label> <ul></ul></div>
</div>`);

    var $title = this.$element.find('.pg-focus-bar-title');
    var $title_object = this.$element.find('.pg-focus-bar-title-object');
    var $title_close = $title.find('.icon-close');

    var $insert = this.$element.find('.pg-focus-bar-insert');
    var $insert_list = $insert.find('ul');

    $insert_list.on('click', 'li', function(e) {
        e.preventDefault();

        var $el = $(this);
        var am = $el.data('action-menu');
        var def = $el.data('crsa-factory-def');

        crsaFuncs.insertThroughActionMenu(am, current_pgel, def, true);
    })

    $title_close.on('click', function(e) {
        e.preventDefault();
        pinegrow.isolateElement(null);
    })

    $title_object.on('click', function(e) {
        e.preventDefault();
        _this.showMenu($title_object);
        return false;
    })

    var show = function() {
        if(pgf.focus_in_tree) return;

        $('#layout-container').addClass('with-focus-bar');
        pg$Show(_this.$element, 'flex');
        $(window).trigger('resize');
    }

    var hide = function() {
        if(pgf.focus_in_tree) return;

        $('#layout-container').removeClass('with-focus-bar');
        pg$Hide(_this.$element);
        _this.focusButton.setActive(false);
        $(window).trigger('resize');
    }

    var createInsertButton = function(def) {
        var $item;
        var r = pinegrow.repeater.showLiveRepeatCount();
        var oc = ' <i class="icon icon-right-arrow"></i>';
        $item = $('<li/>', { 'class' : 'crsa-factory-element crsa-factory-element-text crsa-factory-element-type-' + def.type }).html('<name>' + def.name + r  + '</name>').data('crsa-factory-def', def);
        return $item;
    }

    var update = function(pgel) {
        current_mode = null;
        current_pgel = pgel;

        for(var i = 0; i < modes.length; i++) {
            if(modes[i].isActiveForPgel(pgel)) {
                current_mode = modes[i];
                break;
            }
        }
        if(current_mode) {
            $title_object.html(current_mode.getName(pgel));
            current_mode.onActivated(pgel);
        } else {
            $title_object.html(pgel.getName({short: true}));
        }
        _this.focusButton.setActive(true);

        //Insert
        var has_insert = false;
        $insert_list.empty();

        var currentPage = pgel.getPage();
        var defs = currentPage.getAllTypes(null, pgel);
        var add = [];
        $.each(defs, function(i, def) {
            if(def.action_menu && def.action_menu.add) {
                add.push(def.action_menu);
            }
        });

        $.each(add, function (i, action_menu) {
            $.each(action_menu.add, function (j, type) {
                var def = currentPage.getTypeDefinition(type);
                if (def) {
                    var $item = createInsertButton(def);
                    $item.data('action-menu', action_menu);
                    $item.addClass('crsa-factory-element-link')
                    $item.appendTo($insert_list);
                    has_insert = true;
                }
            });
        });

        if(has_insert) {
            pg$Show($insert, 'flex');
        } else {
            pg$Hide($insert);
        }
    }


    this.showMenu = function($el) {
        var menu = new CrsaContextMenu(null, $el);

        var pgel = pinegrow.selectedElements.getLastSelected();

        menu.add({
            type: 'header',
            label: 'Focus on:'
        });
        /*
        menu.add({
            type: 'divider'
        });
        */

        modes.forEach(function(mode) {
            menu.add({
                label: mode.getName(),
                action: function() {
                    var page = pinegrow.getSelectedPage();
                    if(page) {
                        mode.getPgelForPage(page, function (pgel) {
                            if (pgel) {
                                pinegrow.isolateElement(pgel, {
                                    drag_drop_only_top_level: mode.onlyTopLevel
                                });
                            }
                        })
                    } else {
                        pinegrow.showQuickError('Please open a page first.');
                    }
                }
            })
        })

        menu.add({
            label: pgel ? 'Selected element: ' + pgel.getName({short: true}) : 'Selected element',
            action: function() {
                var pgel = pinegrow.selectedElements.getLastSelected();
                if(pgel) {
                    pinegrow.isolateElement(pgel);
                } else {
                    pinegrow.showQuickError('Select an element first.');
                }
            },
            kbd: 'CMD+F'
        })

        menu.add({
            type: 'divider'
        });

        menu.add({
            label: 'Clear',
            action: function() {
                pinegrow.isolateElement(null);
            }
        })

        menu.showForElement($el, null, 8);
    }

    pinegrow.addEventHandler('on_element_isolated', function(page, pgel) {
        if(pgel) {
            show();
            update(pgel);
        } else {
            current_mode = null;
            current_pgel = null;
            hide();
        }
    })

    pinegrow.addEventHandler('on_page_selected', function(page) {
        if(page && current_pgel) {
            if(current_pgel.getPage() !== page) {
                if(current_mode) {
                    current_mode.getPgelForPage(page, function(pgel) {
                        if(pgel) {
                            pinegrow.isolateElement(pgel);
                        } else {
                            hide();
                        }
                    });
                } else {
                    hide();
                }
            } else {
                show();
            }
        }
    });

    this.$element.insertAfter($('#crsa-topbar'));
}


var PgDeviceSizesControl = function(pseudo, sync_pv, settings) {

    var _this = this;
    var hidden = false;

    if(sync_pv === undefined) {
        sync_pv = pinegrow.getSyncCurrentDeviceSizeWithPageView();
    }
    if(pseudo === undefined) {
        pseudo = true;
    }
    if(settings === undefined) {
        settings = true;
    }

    this.$element = $('<div class="pg-dm-sizes-control"></div>');

    var tabsToolbar = null;
    var deviceTabs = null;
    var tabs_map = {}
    var states_control = null;
    var all_device_sizes = null;
    var current_size_def = null;
    var current_size = null;
    var $notice;
    var state_control_opts = {};
    var current_tabs_hash = null;

    this.setStatesOptions = function(opts) {
        state_control_opts = opts;
    }

    this.show = function(show_def) {
        var page = pinegrow.getSelectedPage();
        if(!page) return;

        if(hidden) {
            pg$Show(this.$element, 'flex');
            hidden = false;
        }

        var pgel = pinegrow.selectedElements.getLastSelected();

        var info = {};

        all_device_sizes = page.activeView.getDeviceSizes(info);// pgDmStore.design.getDeviceSizes();

        var pv = page.activeView;

        var style = null;//pgDmStore.getCurrentStyle();
        current_size_def = show_def || pinegrow.getCurrentDeviceSize();//pgDmStore.design.getDeviceSizeDef(current_size);
        current_size = current_size_def.size || 'all';//pgDmStore.getCurrentSize();

        this.$element.empty();

        var $d = this.$element;

        tabsToolbar = new PgButtonToolbar();
        $d.prepend(tabsToolbar.$element.addClass('pg-tabs-toolbar'));

        $notice = $(`<div class="pg-dm-sizes-control-notice"></div>`);
        //this.$element.append($notice);

        deviceTabs = new PgToolbarTabButtons(tabsToolbar, 'tabs');

        tabs_map = {}

        current_tabs_hash = '';

        for(var i = 0; i < all_device_sizes.length; i++) {
            var def = all_device_sizes[i];
            var has = false;

            if(style) {
                var items = style.getItemsForSize(def.size);
                for(var j = 0; j < items.length; j++) {
                    if(items[j].isSet()) {
                        has = true;
                        break;
                    }
                }
            }

            var current = current_size === def.size;//pv.isDeviceSize(def);

            var tab = deviceTabs.addTab(/*`<i class="icon ${def.icon}"></i> ` +*/ (def.name_short || def.name) + '<i class="icon icon-hide"></i>', null, def, current).setClosable(false);

            tabs_map[def.size] = tab;

            if(has) {
                tab.$element.append('<i class="icon icon-check"></i>')
            }

            tab.$element.attr('data-size', def.size);

            current_tabs_hash += '_' + def.name;

            addTooltip(tab.$element, `<code>${def.w_range[0]}px</code> and up.<br>Click to select. Right-click to resize the page.`);

            (function(def, tab) {
                tab.$element.on('contextmenu', function (e) {
                    var pgel = pinegrow.selectedElements.getLastSelected();
                    pgel && pgel.setData('selectedCssRule', null);

                    var orig_sync_pv = sync_pv;
                    sync_pv = true;
                    /*
                    NO IDEA why this works and not doing this directly as below
                    if(!sync_pv) {
                        var pv = page.view.setActiveViewSizeWithDef(def);
                        page.view.setActiveView(pv);
                    }

                     */
                    deviceTabs.setActive(tab);
                    deviceTabs.onTabSelected(tab);

                    sync_pv = orig_sync_pv;
                })
            })(def, tab);
        }

        addTooltip(tabsToolbar.$element.find('i.icon-hide'), 'This size is not visible in the active page view.');

        updateIsTabSizeVisible(page)

        deviceTabs.onTabSelected = function(tab) {
            var def = tab.data;

            current_size = def.size || 'all';
            current_size_def = def;

            var page = pinegrow.getSelectedPage();

            if(sync_pv) {
                var pv = page.view.setActiveViewSizeWithDef(def);
                page.view.setActiveView(pv);
            }

            pinegrow.setCurrentDeviceSize(def, page, page.activeView, true /* force */);

            if(_this.onDeviceSizeChanged) {
                _this.onDeviceSizeChanged(page, def);
            }

            if(page) {
                //page.view.setActiveViewSizeWithDef(def);
                updateIsTabSizeVisible(page)
            }
        }

        states_control = new PgPseudoStatesControl(info.states);
        var statesButton = new PgButtonToolbarItem(states_control.$element);

        $.each(state_control_opts, function(key, val) {
            states_control[key] = val;
        })

        states_control.$addClassTo = statesButton.$element.addClass('pg-pseudo-dropdown-container');
        states_control.show();

        states_control.onStateChanged = function(states) {
            var page = pinegrow.getSelectedPage();
            pinegrow.setCurrentDeviceSize(pinegrow.getCurrentDeviceSize(), page, page.activeView, true /* force */);
        }

       // tabsToolbar.addSection('states', true /* right align */);
        if(pseudo) {
            tabsToolbar.addSection('pseudo').$element.css('height', '28px');
            tabsToolbar.addItem('pseudo', statesButton);
        }

        if(settings) {
            tabsToolbar.addSection('settings', true /* right align */).$element.css('height', '28px');

            var toolsButton = new PgButtonToolbarItem('icon-tools', 'Settings &amp; Tools.');
            tabsToolbar.addItem('settings', toolsButton);
            toolsButton.onClick = function() {
                var a = []

                a.push({
                    label: 'Sync with page view',
                    check: sync_pv,
                    action: function() {
                        sync_pv = !sync_pv;

                        if(sync_pv && page.view.getPage() /* check if page is in the middle of being loaded/destroyed */) {
                            var pv = page.view.setActiveViewSizeWithDef(current_size_def);
                            page.view.setActiveView(pv);
                        }
                        pinegrow.setSyncCurrentDeviceSizeWithPageView(sync_pv);
                        //pinegrow.setSetting('prop-device-size-sync', sync_pv ? '1' : '0');
                        pinegrow.showMode('Sync with the page view', sync_pv);
                    }
                })

                pinegrow.dispatchEvent('on_device_size_selector_settings', pinegrow.getSelectedPage(), a, _this);

                var menu = new CrsaContextMenu(a, this.$element);
                menu.showForElement(this.$element);
            }
        }

        var syncButton = new PgButtonToolbarItem('icon-Transform_X', 'Sync with page view display.');
        //tabsToolbar.addItem('settings', syncButton);



        syncButton.onClick = function() {
            sync_pv = !this.getActive();
            this.setActive(sync_pv);

            if(sync_pv && page.view.getPage() /* check if page is in the middle of being loaded/destroyed */) {
                var pv = page.view.setActiveViewSizeWithDef(current_size_def);
                page.view.setActiveView(pv);
            }
            pinegrow.setSetting('prop-device-size-sync', sync_pv ? '1' : '0');
            pinegrow.showMode('Sync with page view', sync_pv);
        }

        syncButton.setActive(sync_pv);
    }

    var updateIsTabSizeVisible = function(page) {
        var shown = false;

        page.getPageViews().forEach(function(pv) {
            if(!shown && pv.isDeviceSizeVisible(current_size_def)) {
                shown = true;
            }
        })

        if(!shown) {
            tabs_map[current_size] && tabs_map[current_size].$element.addClass('not-visible');
            //$notice.get(0).innerHTML = `${current_size_def.name_short || current_size_def.name} is not visible in the page view.`;
            //pg$Show($notice);
        } else {
            tabs_map[current_size] && tabs_map[current_size].$element.removeClass('not-visible');
            //pg$Hide($notice);
        }
        //pg$Hide($notice);
    }

    var areSizesTheSame = function() {
        if(current_tabs_hash === null) return false;
        var hash = '';
        var page = pinegrow.getSelectedPage();
        if(page) {
            var info = {};
            var sizes = page.activeView.getDeviceSizes(info);

            for (var i = 0; i < sizes.length; i++) {
                var def = sizes[i];
                hash += '_' + def.name;
            }
        }
        return current_tabs_hash === hash;
    }

    this.updateOrShow = function(show_def) {
        if(areSizesTheSame()) {
            this.update(show_def)
        } else {
            this.show(show_def)
        }
    }

    this.update = function(show_def) {
        var page = pinegrow.getSelectedPage();
        if(!page) return;

        if(hidden) {
            pg$Show(this.$element, 'flex');
            hidden = false;
        }

        var pv = page.activeView;

        var new_current_size_def = show_def || pinegrow.getCurrentDeviceSize();
        var new_current_size = new_current_size_def.size || 'all';

        if(new_current_size !== current_size) {
            if(current_size) {
                //tabs_map[current_size] && tabs_map[current_size].setActive(false);
            }
            if(new_current_size) {
                //tabs_map[new_current_size] && tabs_map[new_current_size].setActive(true);

                deviceTabs.setActive(tabs_map[new_current_size] && tabs_map[new_current_size]);
            } else {
                deviceTabs.setActive(null);
            }
        }

        current_size = new_current_size;
        current_size_def = new_current_size_def;

        var pgel = pinegrow.selectedElements.getLastSelected();
        pgel && states_control.update(pgel);

        updateIsTabSizeVisible(page)
    }

    this.hide = function() {
        pg$Hide(this.$element);
        hidden = true;
    }
}


var PgPseudoStatesControl = function(cssStates) {

    var _this = this;

    var current_states = {
    };

    var getAllStates = function() {
        var page = pinegrow.getSelectedPage();
        if(page) {
            var list = [];
            page.callFrameworkHandler('on_get_pseudo_states_for_pseudo_control', list);
            return list;
        }
        return cssStates;
    }

    var dom_states = ['active', 'hover', 'focus', 'visited', 'focus-within'];

    var $pseudoContainer = this.$element = $('<div class="pg-pseudo-dropdown"><span></span><i class="icon icon-down"></i></div>');

    this.$addClassTo = $pseudoContainer;

    var $span = $pseudoContainer.find('span');
    var selected_state = '';

    var updateStateClasses = function(pgel) {

        pgel.get$DOMElements().forEach(function($el) {
            getAllStates().forEach(function(state) {
                //if(dom_states.indexOf(state) >= 0) {
                    var cls = `pg-state-${state}`;
                    if (current_states[state]) {
                        $el.addClass(cls);
                        $el.attr('data-' + cls, '');
                    } else {
                        $el.removeClass(cls);
                        $el.removeAttr('data-' + cls)
                    }
                //}
            })
        })
    }

    this.show = function() {

        addTooltip($pseudoContainer, 'Select pseudo state.', {
            use_title_attr: true
        });

        $pseudoContainer.on('click', function(e) {

            var setState = function(state) {

                var cssStates = getAllStates();

                selected_state = state;
                cssStates.forEach(function(s) {
                    current_states[s] = s === selected_state;
                })

                var states = cssStates;//[];

                var valid_css_states = [];

                cssStates.forEach(function (state) {
                    if (current_states[state] && dom_states.indexOf(state) >= 0) {
                        valid_css_states.push(state);
                    }
                })

                var col = pinegrow.getCollection();

                col.forEachElementAsync(function (pgel, ondone) {
                    updateStateClasses(pgel);
                    pinegrow.devTools.forcePseudoStates(pgel, valid_css_states, ondone);
                }, function (results) {
                    pinegrow.dispatchEvent('on_current_pseudo_state_changed', pinegrow.getSelectedPage(), states);
                    _this.onStateChanged && _this.onStateChanged(states);
                })
            }

            var actions = [
                {
                    type: 'header',
                    label: 'Select a pseudo class:'
                },
                {
                    label: 'None',
                    check: selected_state === '',
                    action: function() {
                        setState('');
                    }
                },
                {
                    type: 'divider'
                }
            ]

            cssStates.forEach(function(state) {
                actions.push({
                    label: state,
                    check: selected_state === state,
                    action: function() {
                        setState(state);
                    }
                })
            })

            _this.onShowMenu && _this.onShowMenu(actions);

            var menu = new CrsaContextMenu(actions, $span);
            menu.showForElement($span);
            return false;
        })

        var pgel = pinegrow.selectedElements.getLastSelected();
        this.update(pgel);
    }

    this.update = function(pgel) {
        if(pgel) {
            var $pgel = pgel.get$DOMElement();
        }

        var states = [];

        selected_state = '';

        var cssStates = getAllStates();

        for (var i = 0; i < cssStates.length; i++) {
            var cssState = cssStates[i];

            if($pgel) {
                current_states[cssState] = $pgel.hasClass(`pg-state-${cssState}`) || $pgel.get(0).hasAttribute('data-pg-state-' + cssState);
                if(current_states[cssState]) {
                    selected_state = cssState;
                    states.push(cssState);
                    break;
                }
            }
        }

        var txt = selected_state;
        this.onUpdateDisplay && (txt = this.onUpdateDisplay(txt))

        $span.text(txt || 'Pseudo class');

        if(txt) {
            this.$addClassTo.addClass('has-state');
        } else {
            this.$addClassTo.removeClass('has-state');
        }

        $pseudoContainer.attr('title', selected_state ? 'Edit the <b>:' + selected_state + '</b> state. Click to change.' : 'Click to select a pseudo state...');

        pinegrow.dispatchEvent('on_current_pseudo_state_changed', pinegrow.getSelectedPage(), states);
    }
}

var PgColorPicker = function($input, colors, text, getObj, settings) {

    settings = settings || {};

    /*
    [
        [
            {color: 'red', value: 'color-red'}
        ]
    ]

     */
    var $element = null;
    var position;

    var _this = this;

    this.close_on_mouseleave = false;
    this.keepOpenOnClick = false;

    var $field = $('<div class="pg-color-picker-field"></div>').insertAfter($input);

    var view = new PgUIView($field);

    var current_value = null;
    var current_color_value = null;

    var getColorForValue = function(val) {
        var list = typeof colors === 'function' ? colors(getObj()) : colors;
        for(var i = 0; i < list.length; i++) {
            for(var n = 0; n < list[i].length; n++) {
                if(list[i][n].key === val) {
                    return list[i][n].color;
                }
            }
        }
        return null;
    }

    var show = this.show = function() {
        $element = $('<div class="pg-color-picker"><i class="close icon icon-close"></i></div>').appendTo($('body'));
        var $grid = $('<div class="pg-color-picker-grid"></div>').appendTo($element);

        $element.find('.close').on('click', function(e) {
            e.preventDefault();
            close();
        })

        var html = '';

        var list = typeof colors === 'function' ? colors(getObj && getObj()) : colors;

        //var pal = typeof palette == 'function' ? palette() : palette;

        var current_value = $input.val();

        list.forEach(function (crow) {
            
            html += '<div class="pg-color-picker-row">';

            crow.forEach(function(c) {
                var bck = c.color;
                //var val = '$' + c.name + '-' + desc[i.toString()];

                var val = c.key;

                html += `<div class="pg-color-picker-c ${current_value === val ? 'selected' : ''}" title="${c.name || ''}" data-val="${val}" data-color="${bck}"><div style="background-color:${bck};"></div></div>`;
            })

            html += '</div>';
        })

        html += '<button class="pg-button">No color</button>';

        $grid.html(html);

        $grid.on('click', 'button', function(e) {
            current_value = null;
            settings.on_value_set && settings.on_value_set('');
            setValue('');
            $input.val('');
            if(!_this.keepOpenOnClick) {
                close();
            } else {
                $element.find('.pg-color-picker-c.selected').removeClass('selected');
            }
            $input.trigger('change');
        })

        $grid.on('click', '.pg-color-picker-c', function(e) {
            var $c = $(this);
            var val = $c.attr('data-val');

            settings.on_value_set && settings.on_value_set(val);

            $input.val(val);
            setValue($c.attr('data-color'), val);

            if(!_this.keepOpenOnClick) {
                close();
            } else {
                $element.find('.pg-color-picker-c.selected').removeClass('selected');
                $c.addClass('selected');
            }

            $input.trigger('change');

            /*
            current_value = {
                base: $c.attr('data-base'),
                variable: $c.attr('data-val'),
                color: $c.attr('data-color'),
                shade: $c.attr('data-shade')
            }
            */


        })

        if(settings.on_color_highlighted) {
            $grid.on('mouseenter', '.pg-color-picker-c', function(e) {
                var $c = $(this);
                var val = $c.attr('data-val');
                settings.on_color_highlighted && settings.on_color_highlighted(val);
            })

            $grid.on('mouseleave', '.pg-color-picker-c', function(e) {
                settings.on_color_highlighted && settings.on_color_highlighted(null);
            })
        }

        $element.on('mouseleave', onMouseLeave);
        $element.on('mouseenter', onMouseEnter);

        settings.on_show && settings.on_show();
    }

    var setValue = function(color, val) {
        $field.text(val);
        if(color) {
            var cc = chroma(color);
            if (cc.alpha() == 0) {
                cc = cc.alpha(1);
                color = cc.css();
            }
            current_color_value = color;
        } else {
            current_color_value = null;
        }
        if(!text) {
            $field.css({
                'background-color': color,
                color: cc ? (chroma.contrast('#ffffff', cc) < 4.5 ? 'rgba(0,0,0,0.7)' : 'rgba(255, 255, 255, 0.7)') : ''
            });
        } else {

            $field.css({
                'color': color,
                'background-color': cc ? (chroma.contrast('#ffffff', cc) < 4.5 ? 'rgba(0,0,0,1)' : 'rgba(255, 255, 255, 1)') : ''
            });
        }
    }

    this.getColorValue = function() {
        return current_color_value;
    }

    this.isOpen = function() {
        return $element !== null;
    }

    var close = this.close = function() {
        if($element) {
            position && position.destroy();
            position = null;

            $element.off('mouseenter', onMouseEnter);
            $element.off('mouseleave', onMouseLeave);

            $element.remove();
            $element = null;
        }
        settings.on_hide && settings.on_hide();
    }

    var onInputValueChanged = function(e) {
        var val = $input.get(0).value;
        setValue(getColorForValue(val) || '', val);
    }

    $input.on('pg-on-value-updated', onInputValueChanged)

    this.get$Input = function() {
        return $input;
    }

    this.showWithPosition = function($target) {
        show();
        position = new PgPositionNextTo$El($element, $target || $input, null, 0, 'down_no_resize');
    }

    $field.on('click', function(e) {
        if($element) {
            close();
        } else {
            _this.showWithPosition($input);
            //show();
            //position = new PgPositionNextTo$El($element, $input, null, 0, 'down_no_resize');
        }
    })

    /*
    var onColorChanged = function(pagenull, name, color) {
        if(current_value) {
            if(current_value.base == name) {
                setValue(pgDmStore.design.getColorShade(chroma(color), current_value.shade).css());
            }
        }
    }

    pinegrow.addEventHandler('on_dm_color_changed', onColorChanged);

    */

    var onMouseDown = function(e) {
        if($element) {
            if($(e.target).closest($element).length) return;
            if($(e.target).closest($field).length) return;
            //debugger;
            close();
        }
    }

    document.addEventListener('mousedown', onMouseDown, true);

    var mouse_over = false;

    var onMouseEnter = function(e) {
        mouse_over = true;
    }

    var onMouseLeave = function(e) {
        mouse_over = false;
        if(_this.close_on_mouseleave) {
            _this.close();
        }
    }

    this.isMouseOver = function() {
        return mouse_over;
    }

    view.onDestroy = function() {
        document.removeEventListener('mousedown', onMouseDown);
        $input.off('pg-on-value-updated', onInputValueChanged)
        _this.close();
        //pinegrow.removeEventHandler('on_dm_color_changed', onColorChanged);
    }
}

var PgElementClassesControlTEST = function() {
    this.$element = $('<div class="pg-el-classes-control clearable-area"></div>');

    var pgsec = new PgUISection('ElementClassesControl', '', {
        collapse_tooltip: 'Click to expand / collapse the class list.'
    });

    this.$element.append(pgsec.$element);

    var $content = pgsec.$content;

    var tree = new PgClassTree();

    this.show = function(pgel) {
        pg$Show(this.$element);
        $content.trigger('crsa-will-clear-area');
        $content.empty();

        if(pgel) {

        }
    }

    this.hide = function() {
        this.show(null);
        pg$Hide(this.$element);
    }

    this.destroy = function() {
        this.show(null);
    }
}

var PgElementClassesControl = function() {
    this.ignore_update = false;

    this.$element = $('<div class="pg-el-classes-control clearable-area"></div>');

    var pgsec = new PgUISection('ElementClassesControl', '', {
        collapse_tooltip: 'Click to expand / collapse the class list.'
    });

    this.$element.append(pgsec.$element);

    var $content = pgsec.$content;

    this.show = function(pgel) {
        if(this.ignore_update) return;

        pg$Show(this.$element);
        $content.trigger('crsa-will-clear-area');
        $content.empty();

        if(pgel) {
            crsaFuncs.updateRulesList($content, pgel, null, null, true, this);
        }
    }

    this.hide = function() {
        this.show(null);
        pg$Hide(this.$element);
    }

    this.destroy = function() {
        this.show(null);
    }
}

var PgSectionNavigator = function() {

    var toolbar;

    var $filter = $('<div class="pg-css-gui-filter"></div>');
    this.$element = $filter;

    var grid = null;

    this.setGrid = function(g) {
        grid = g;
    }

    this.addSection = function(d) {
        filter_sections.push(d);
    }

    var prev_filter_sections = [];

    var areSectionsSame = function(ns) {
        if(prev_filter_sections.length !== ns.length) return false;
        for(var i = 0; i < ns.length; i++) {
            if(prev_filter_sections[i].name !== ns[i].name) return false;
        }
        return true;
    }

    var hasData = function(sf) {
        if(sf.sub_sections) {
            for(var i = 0; i < sf.sub_sections.length; i++) {
                if(hasData(sf.sub_sections[i])) return true;
            }
        } else {
            for (var i = 0; i < sf.sections.length; i++) {
                if (grid.hasData(sf.sections[i])) return true;
            }
        }
        return false;
    }

    var shown = true;

    this.show = function(filter_sections) {

        if(areSectionsSame(filter_sections)) {
            this.update(filter_sections);
        } else {
            toolbar && toolbar.destroy();

            toolbar = new PgButtonToolbar(true /* small */);
            toolbar.$element.appendTo($filter);

            toolbar.addSection('sections');

            filter_sections.forEach(function (sf) {
                var item = new PgButtonToolbarItem(sf.icon, sf.name, sf);

                sf.active = false;
                item.setActive(hasData(sf));
                toolbar.addItem('sections', item);

                sf.toolbarItem = item;

                item.onClick = function() {
                    if (sf.sub_sections) {
                        var a = sf.sub_sections.map(function (d) {
                            return {
                                label: d.name,
                                check: hasData(d),
                                action: function () {
                                    grid.scrollTo(d.sections);
                                }
                            }
                        })
                        var menu = new CrsaContextMenu(a, item.$element);
                        menu.showForElement(item.$element);
                    } else {
                        grid.scrollTo(sf.sections);
                    }
                }
            })
        }
        prev_filter_sections = filter_sections;

        if(!shown) {
            pg$Show(this.$element);
            shown = true;
        }
    }

    this.hide = function() {
        if(shown) {
            pg$Hide(this.$element);
            shown = false;
        }
    }

    this.update = function(filter_sections) {
        filter_sections.forEach(function(sf) {
            var has = false;

            if(sf.sub_sections) {
                //sub sections
                sf.sub_sections.forEach(function(subf) {
                    has = has || hasData(subf)
                })
            } else {
                has = hasData(sf);
            }
            sf.toolbarItem.setActive(has);
        })
    }

    this.updateHasData = function() {
        this.update(prev_filter_sections);
    }

}


var PgDraggableReorder = function($element, selector, on_ordered, drop_effect) {

    var dragHelper = new PgDragHelper($element, selector, null, true);

    if(drop_effect) {
        dragHelper.onGetDropEffect = function(drag_target) {
            return typeof drop_effect === 'function' ? drop_effect(drag_target) : drop_effect;
        }
    }

    var $drop = $(`<div class="${selector.replace('.','')} drop-target" draggable="true"></div>`);

    var over_element = null;
    var replace = true;
    var dragged_element = null;
    var mode = 'move';

    var onDragOver = function(e) {
        e.preventDefault();
        var $e = $(this);
        if(replace) {
            if(this !== dragged_element && over_element !== this) {
                over_element && over_element.classList.remove('drop-target');

                over_element = this;
                if(!over_element.classList.contains('drop-target')) {
                    over_element.classList.add('drop-target')
                }
            }
        } else {
            if (!$e.hasClass('drop-target')) {
                $drop.insertBefore($e);
            }
        }
    }

    dragHelper.on( 'dragStart', function(x, y, event) {
        $.fn.crsapages('showOverlays');

        dragged_element = dragHelper.dragTarget.get(0);
        over_element = null;

        $element.on('dragover', selector, onDragOver);
        $element.on('dragenter', selector, onDragOver);
        //$element.on('drop', selector, onDragOver);

    }, this );

    dragHelper.on( 'drag', function(x, y, event) {

        //dragMenu.handleMoveEvent(event, dragMenu);
        mode = event.originalEvent.dataTransfer.dropEffect || 'move';
    }, this );

    dragHelper.on( 'dragStop', function(event, x, y) {
        $.fn.crsapages('showOverlays', true);

        $element.off('dragover', selector, onDragOver);
        $element.off('dragenter', selector, onDragOver);

        over_element && over_element.classList.remove('drop-target');

        /*
        if($drop.parent().length && $drop.parent().get(0) === dragHelper.dragTarget.parent().get(0)) {
            dragHelper.dragTarget.insertBefore($drop);
        }
        $drop.detach();

         */

        on_ordered && on_ordered(dragged_element, over_element, event.originalEvent.dataTransfer.dropEffect);
    }, this );
}


class PgCSSFieldExtension {

    constructor(field_name, fdef, $fc, $input) {
        this.fdef = fdef;
        this.$container = $fc;
        this.$input = $input;

        var _this = this;

        this.css_property = field_name;

        if(fdef.css_property) {
            this.css_property = fdef.css_property;
        }

        this.$container.on('contextmenu', function(e) {
            e.preventDefault();
            _this.showMenu();
            return false;
        })

        fdef.on_get_value_from_field = this.onGetValue.bind(this);
        fdef.on_set_field_value = this.onSetValue.bind(this);

        this.add_default_unit = 'px';
        if('add_default_unit' in fdef) {
            this.add_default_unit = fdef.add_default_unit;
        } else if(fdef.type === 'select') {
            this.add_default_unit = '';
        }

        this.info = pgParseCSSValue(this.$input.val());

        if(fdef.type !== 'select' || true) {
            this.$element = $(pgE('div', {
                'class': 'pg-css-field-pill'
            }));
            this.$container.get(0).appendChild(this.$element.get(0));

            $fc.addClass('pg-field-with-css-ext');
            $fc.closest('.crsa-field').addClass('pg-field-with-css-ext-on-crsa-field');

            this.$element.on('click', function(e) {
                e.preventDefault();
                _this.showMenu();
                return false;
            })

            this.$input.on('blur', this.onBlur.bind(this));

            this.updatePill();
        }
    }

    onBlur(e) {
        this.updatePill();
        var val = this.$input.val();
        var info = pgParseCSSValue(val);

        if(val === null || val === '' || val === '0' || val === 0 || !this.add_default_unit) return;

        if(info.type === 'value') {
            var new_val = pgGetCSSValueFromParsedInfo(info);
            (val !== new_val) && this.$input.val(new_val);
        }
    }

    //called when getting the value from the field
    onGetValue(val, event) {
        if(val === null || val === '' || val === '0' || val === 0 || !this.add_default_unit) {
            //but what about important? on bck color, for example
            if(this.info.important) {
                var info = pgParseCSSValue(val);
                if(!info.important) {
                    //important is set on the field, but val doesnt have it
                    val = val + ' !important';
                }
            }
            return val;
        }

        if(this.fdef.skip_adding_units_on_input && event.type === 'input') return val;

        var info = pgParseCSSValue(val);

        if(info.type === 'value') {
            this.info.value = info.val;
            if(!info.unit) {
                info.unit = this.info.unit || 'px';
            }
        }
        if(!info.important) {
            info.important = this.info.important;
        }

        this.info = info;

        return pgGetCSSValueFromParsedInfo(this.info);
    }

    //called when setting the value into the field
    onSetValue(val) {
        this.info = pgParseCSSValue(val);

        if(this.info.important) {
            val = this.info.original_without_important;
        }
        this.updatePill();
/*
        if(this.info.unit) {
            this.updatePill();
            val = this.info.value.toString();
        }*/
        return val;
    }

    destroy() {

    }

    updatePill() {
        var el = this.$element.get(0);
        var cls = '';
        if(this.info.important) {
            el.innerHTML = '!';
        } else {
            el.innerHTML = '!'; //'<i class="icon icon-down"></i>';
        }
        el.setAttribute('data-important', this.info.important ? "true" : "false");
    }

    showMenu() {
        const _this = this;
        var actions = [];

        var pgel = pinegrow.selectedElements.getLastSelected();
        var page = pinegrow.getSelectedPage();

        if(pgel) {
            var $selected_element = pgel.get$DOMElement();
        }

        var text_field = _this.fdef.type !== 'select' && _this.fdef.type !== 'color' && _this.fdef.type !== 'custom';

        if(text_field) {

            actions.push({
                type: 'header',
                label: 'Convert unit'
            })

            var units = ['px', '%', 'em', 'rem', 'pt', 'vw', 'vh'];

            var convert = function (unit) {
                var value = _this.$input.val();
                var info = pgParseCSSValue(value);
                if (info.value !== null) {
                    var converted_value = pgConvertCSSUnit(info.value, info.unit, unit, $selected_element, _this.css_property);
                    _this.info.unit = unit;
                    _this.$input.val(converted_value + unit);
                    _this.updatePill();
                    _this.$input.change();
                }
            }

            units.forEach(function (unit) {
                actions.push({
                    label: unit,
                    check: unit === _this.info.unit,
                    action: function () {
                        convert(unit)
                    }
                })
            })

            var more_units = ['cm', 'mm', 'Q', 'in', 'pc', 'ex', 'ch', 'lh', 'vmin', 'vmax'];

            actions.push({
                label: 'More units',
                submenu: more_units.map(function (unit) {
                    return {
                        label: unit,
                        check: unit === _this.info.unit,
                        action: function () {
                            convert(unit)
                        }
                    }
                })
            })

            actions.push({
                type: 'divider'
            })

        }

        actions.push({
            label: '!important',
            action: function () {
                var value = _this.$input.val();
                var info = pgParseCSSValue(value);
                if(info.important) {
                    _this.info.important = true;
                }
                _this.info.important = info.important = !_this.info.important;
                _this.updatePill();
                _this.$input.val(info.original_without_important);
                _this.$input.change();
            },
            check: _this.info.important
        })

        var vars_field = _this.fdef.type !== 'select' && _this.fdef.type !== 'custom';

        if($selected_element && vars_field) {
            var display_values = new PgGetCSSValueHTML();

            var css_variables = pinegrow.insight.getCSSVarsForPage(page);

            var style = page.activeView.getWindow().getComputedStyle($selected_element.get(0));

            var css_vars_actions = [];

            css_variables.forEach(function(d) {
                var val = style.getPropertyValue('--' + d.key);

                if(val !== null && val !== '') {
                    css_vars_actions.push({
                        label: d.key + ' / ' + display_values.getHTML((val + '').trim()),
                        action: function () {
                            _this.$input.val(`var(--${d.key})`);
                            //_this.$input.val(`--${d.key}`);
                            _this.$input.change();
                            _this.updatePill();
                        }
                    })
                }
            })

            if(css_vars_actions.length) {
                actions.push({
                    type: 'divider'
                })

                actions.push({
                    label: 'CSS variables',
                    submenu: css_vars_actions
                })
            }
        }

        if(text_field) {
            actions.push({
                type: 'divider'
            })

            actions.push({
                label: 'Calculate',
                action: function () {
                    var value = _this.$input.val();
                    var info = pgParseCSSValue(value);
                    if (!info.calc) {
                        //add var() if needed
                        if (info.value !== null) {
                            value = `calc(${info.original_without_important} + 0px)`;
                        } else {
                            //error in safari
                            if(isApp()) {
                                //value = info.original_without_important.replace(/(?<!var\()(\-\-[a-z0-9\-]+)/g, `var($1)`);
                            }
                            if (value === '') value = '0';
                            value = `calc(${value} + 0px)`;
                        }
                        if (info.important) _this.info.important = true;

                        _this.$input.val(value);
                        _this.$input.change();
                        _this.updatePill();
                    }
                }
            })
        }

        const menu = new CrsaContextMenu(actions, this.$element || this.$container);
        menu.showForElement(this.$element || this.$container);
    }
}

class PgMousePosition {
    constructor() {

        this.pos = {
            top: 0,
            left: 0,
            target: null
        }

        this.prev_pos = {
            top: 0,
            left: 0
        }

        this.prev_time = 0;
        this.last_time = 0;

        var _this = this;

        $('body').on('mousemove', function(e) {
            _this.updateData(e);
        })
    }

    updateData(e, target) {
        var time = performance.now();
        if(time - this.prev_time > 100) {
            this.prev_pos.top = this.pos.top;
            this.prev_pos.left = this.pos.left;
            this.prev_time = this.last_time;
            this.last_time = time;
        }

        this.pos.top = e.pageY;
        this.pos.left = e.pageX;
        this.pos.target = target;
    }

    registerPositionInIframe(e) {
        this.updateData(e, e.target);
    }

    getVelocity() {
        var time = performance.now();
        if(time - this.last_time > 100) return 0;

        if(time - this.last_time === 0) return 0;
        var dy = Math.abs(this.pos.top - this.prev_pos.top);
        var dx = Math.abs(this.pos.left - this.prev_pos.left);
        return Math.sqrt(dy * dy + dx * dx) / (time - this.last_time) * 1000;
    }

    getYVelocity() {
        var time = performance.now();
        if(time - this.last_time > 100) return 0;

        if(time - this.last_time === 0) return 0;
        var dy = Math.abs(this.pos.top - this.prev_pos.top);
        return dy / (time - this.last_time) * 1000;
    }

    getPosition() {
        if(this.pos.target) {
            //convert to global
            var pv = getPageViewOfElement($(this.pos.target));
            if(pv) {
                var pos = pv.pageRectToGlobalRect({
                    left: this.pos.left,
                    top: this.pos.top,
                    width: 0,
                    height: 0
                })

                this.pos.left = pos.left;
                this.pos.top = pos.top;
                this.pos.target = null;
            }
        }
        return this.pos;
    }
}



var PgFocusRect = function() {

    var _this = this;

    var $overlay = $('<div class="pg-focus-rect"><div class="pg-focus-rect-top"></div><div class="pg-focus-rect-bottom"></div><div class="pg-focus-rect-left"></div><div class="pg-focus-rect-right"></div></div>');

    var $top = $overlay.find('.pg-focus-rect-top');
    var $bottom = $overlay.find('.pg-focus-rect-bottom');
    var $left = $overlay.find('.pg-focus-rect-left');
    var $right = $overlay.find('.pg-focus-rect-right');

    var shown = false;

    this.onHide = null;
    this.onHideByClick = null;

    $overlay.on('click', function(e) {
        e.preventDefault();
        pinegrow.dispatchEvent('on_focus_rect_closed', null);
        _this.hide();
        _this.onHideByClick && _this.onHideByClick();
    })

    var showRect = function(rect, $body) {
        var body_rect = $body.get(0).getBoundingClientRect();

        $top.css({height: rect.top});
        $bottom.css({height: body_rect.height - rect.top - rect.height});
        $left.css({top: rect.top, width: rect.left, height: rect.height});
        $right.css({top: rect.top, width: body_rect.width - rect.left - rect.width, height: rect.height});

        $overlay.appendTo($body);

        shown = true;

        pinegrow.selectedElements.onRepositionMenus = _this.update;
    }

    var updateFunc = null;

    this.hide = function() {
        $overlay.detach();
        shown = false;
        updateFunc = null;
        pinegrow.selectedElements.onRepositionMenus = null;
        this.onHide && this.onHide();
    }

    this.showFor$El = function($el, on_closed_by_click) {
        this.onHideByClick = on_closed_by_click;
        updateFunc = function() {
            showRect($el.get(0).getBoundingClientRect(), $el.closest('body'));
        }
        updateFunc();
    }

    this.showForPage$El = function($el) {
        updateFunc = function() {
            var pv = getPageViewOfElement($el);
            var rect = pv.get$ElGlobalRect($el);
            showRect(rect, pv.getPageParent$Body());
        }
        updateFunc();
    }

    this.coverAll = function() {
        updateFunc = function() {
            var rect = {x:0, left:0, top:0, y:0, width: 0, height: 0, right:0, bottom: 0};
            showRect(rect, $('body'));
        }
        updateFunc();
    }

    this.update = function() {
        updateFunc && updateFunc();
    }

    this.destroy = function() {
        this.hide();
        $overlay.remove();
    }

    /*
        pinegrow.addEventHandler('on_selected_elements_changed', function() {
            return;
            var pgel = pinegrow.selectedElements.getLastSelected();
            if(pgel) {
                var $el = pgel.get$DOMElement();
                if($el) {
                    _this.showForPage$El($el);
                }
            } else {
                _this.hide();
            }
        });*/
}

var PgUIElementExplainer = function($el, html, opts) {

    var options = $.extend({}, {
        show_delay: 100,
        close_delay: 3000,
        focus: false,
        position: 'down',
        scroll_container: null,
        button: null,
        next_step: null,
        on_button_clicked: null,
        on_close: null
    }, opts)

    if(options.button) {
        html += `<p><button class="btn pg-button">${options.button}</button></p>`;
    }
    this.$element = $(`<div class="pg-ui-element-explainer" style="visibility:hidden;opacity:0;" data-position="${options.position}">${html}<i class="icon icon-close"></i></div>`).appendTo($el.closest('body'));

    this.$element.find('button').on('click', function(e) {
        e.preventDefault();
        options.on_button_clicked && options.on_button_clicked();
        close();
    });

    (options.scroll_container || $('body')).one('scroll', function(e) {
        close();
    });

    var position;
    var _this = this;
    var timer;
    var focus = null;

    this.$element.find('i.icon-close').on('click', function(e) {
        e.preventDefault();
        close();
    })

    var show = function() {

        var animations = {
            down: {
                show: 'fadeInUp',
            },
            up: {
                show: 'fadeInDown'
            }
        }

        var data = {"l":[{"name":"Show","trg":"no","a":animations[options.position].show,"po":"true"},{"name":"Hide","trg":"no","a":{"l":[{"t":"","l":[{"t":"set","p":0,"d":0,"l":{"autoAlpha":1,"y":0},"e":"Power1.easeOut"},{"t":"tween","p":0,"d":0.5,"l":{"autoAlpha":0,"y":"-0%"},"e":"Power1.easeOut"},{"t":"tween","p":0.5,"d":0.5,"l":{"pgDom":{"remove":1}}}]}]},"po":"true"}]};

        var doShow = function() {
            position = new PgPositionNextTo$El(_this.$element, $el, null, 4, options.position);
            pgia.play(_this.$element.get(0), 'Show', data);

            if(options.focus) {
                focus = new PgFocusRect();
                focus.showFor$El($el);
                focus.onHide = function() {
                    close();
                }
            }

            timer = setTimeout(function () {
                close();
            }, options.close_delay);
        }

        if(options.scroll_container) {
            pgScrollToItemInContainer($el, options.scroll_container, false, true, doShow, -100)
        } else {
            doShow();
        }

    }

    var close = function() {
        clearTimeout(timer);
        timer = null;
        show_timer && clearTimeout(show_timer);
        show_timer = null;
        pgia.play(_this.$element.get(0), 'Hide');
        position && position.destroy();
        position = null;

        if(focus) {
            focus.onHide = null;
            focus.destroy();
        }

        if(options.next_step) {
            options.next_step();
        }
        options.on_close && options.on_close();
    }

    var show_timer = setTimeout(show, options.show_delay);

    this.close = close;
}